(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source | 
  Boogie/Spec# benchmarks.
  This benchmark was translated by Michal Moskal.
|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun InRange (Int Int) Bool)
(declare-fun this () Int)
(declare-fun int_18446744073709551615 () Int)
(declare-fun Smt.false () Int)
(declare-fun ThenCheck_correct () Int)
(declare-fun then_correct () Int)
(declare-fun z_0 () Int)
(declare-fun z_1 () Int)
(declare-fun z_2 () Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun z () Int)
(declare-fun select1 (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun then_2_join_correct () Int)
(declare-fun CONCVARSYM (Int) Int)
(declare-fun FIELD () Int)
(declare-fun y_0 () Int)
(declare-fun y_1 () Int)
(declare-fun divides (Int Int) Int)
(declare-fun y_2 () Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun ThenCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun subtypes (Int Int) Bool)
(declare-fun store1 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun StartCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun join_2_GeneratedUnifiedExit_correct () Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun int_2147483647 () Int)
(declare-fun x_0 () Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun ReallyLastGeneratedExit_correct () Int)
(declare-fun int_m9223372036854775808 () Int)
(declare-fun Smt.true () Int)
(declare-fun Heap () Int)
(declare-fun int_4294967295 () Int)
(declare-fun start_correct () Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun StartCheck_correct () Int)
(declare-fun boolNot (Int) Int)
(declare-fun GeneratedUnifiedExit_correct () Int)
(declare-fun ElseCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun intLess (Int Int) Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun is (Int Int) Int)
(declare-fun join_correct () Int)
(declare-fun int_m2147483648 () Int)
(declare-fun ElseCheck_correct () Int)
(declare-fun else_correct () Int)
(declare-fun modulo (Int Int) Int)
(declare-fun else_2_join_correct () Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun int_9223372036854775807 () Int)
(assert true)
(assert true)
(assert (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v)))
(assert (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v)))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolIff ?x ?y) Smt.true) (= (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolImplies ?x ?y) Smt.true) (=> (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolAnd ?x ?y) Smt.true) (and (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolOr ?x ?y) Smt.true) (or (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int)) (! (= (= (boolNot ?x) Smt.true) (not (= ?x Smt.true))) :pattern ((boolNot ?x)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (anyEqual ?x ?y) Smt.true) (= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (! (= (= (anyNeq ?x ?y) Smt.true) (not (= ?x ?y))) :pattern ((anyNeq ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (intLess ?x ?y) Smt.true) (< ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtMost ?x ?y) Smt.true) (<= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtLeast ?x ?y) Smt.true) (>= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intGreater ?x ?y) Smt.true) (> ?x ?y))))
(assert (distinct Smt.false Smt.true))
(assert (forall ((?t Int)) (! (subtypes ?t ?t) :pattern ((subtypes ?t ?t)) )))
(assert (forall ((?t Int) (?u Int) (?v Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?v)) (subtypes ?t ?v)) :pattern ((subtypes ?t ?u) (subtypes ?u ?v)) )))
(assert (forall ((?t Int) (?u Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?t)) (= ?t ?u)) :pattern ((subtypes ?t ?u) (subtypes ?u ?t)) )))
(assert (let ((?v_0 (select2 Heap this FIELD))) (let ((?v_1 (= x_0 ?v_0)) (?v_2 (= y_0 ?v_0)) (?v_5 (= x_0 y_0))) (let ((?v_8 (and ?v_1 ?v_5)) (?v_16 (= start_correct Smt.true)) (?v_3 (= y_0 x_0))) (let ((?v_10 (and ?v_2 ?v_3)) (?v_6 (= y_0 z_0)) (?v_17 (= else_correct Smt.true)) (?v_18 (= else_2_join_correct Smt.true)) (?v_15 (= z_1 x_0)) (?v_4 (= x_0 z_1)) (?v_19 (= join_correct Smt.true)) (?v_20 (= join_2_GeneratedUnifiedExit_correct Smt.true)) (?v_21 (= ElseCheck_correct Smt.true)) (?v_9 (= y_2 y_0)) (?v_22 (= ElseCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_7 (=> true true)) (?v_23 (= GeneratedUnifiedExit_correct Smt.true)) (?v_24 (= ReallyLastGeneratedExit_correct Smt.true)) (?v_25 (= StartCheck_correct Smt.true)) (?v_26 (= StartCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_11 (= 3 3)) (?v_12 (= x_0 x_0))) (let ((?v_13 (and ?v_11 ?v_12 ?v_1))) (let ((?v_14 (=> ?v_13 true)) (?v_27 (= then_correct Smt.true)) (?v_28 (= ThenCheck_correct Smt.true)) (?v_29 (= ThenCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_30 (= then_2_join_correct Smt.true))) (not (=> (and (=> (=> true (=> true (=> ?v_1 (=> ?v_2 (=> ?v_8 true))))) ?v_16) (=> (=> true (=> ?v_10 (=> (= z_0 ?v_0) (=> (and ?v_2 ?v_6 ?v_3) true)))) ?v_17) (=> (=> true (=> (= y_1 y_0) (=> (= z_1 z_0) true))) ?v_18) (=> (=> true (=> (and ?v_15 (= z_1 ?v_0)) (=> (and ?v_4 ?v_1) (=> (and ?v_1 ?v_4) true)))) ?v_19) (=> (=> true (=> (= y_2 y_1) (=> (= z_2 z_1) true))) ?v_20) (=> (=> true (=> (and ?v_1 ?v_5 (= x_0 z_0)) (and ?v_5 ?v_6 ?v_1 (=> (and ?v_5 ?v_6 ?v_1) (=> (and ?v_3 ?v_6 ?v_2) true))))) ?v_21) (=> (=> true (=> ?v_9 (=> (= z_2 z_0) true))) ?v_22) (=> ?v_7 ?v_23) (=> ?v_7 ?v_24) (=> (=> true (=> ?v_8 (and ?v_5 ?v_1 (=> (and ?v_5 ?v_1) (=> (and ?v_3 ?v_2) true))))) ?v_25) (=> (=> true (=> ?v_9 (=> (= z_2 z) true))) ?v_26) (=> (=> true (=> ?v_10 ?v_14)) ?v_27) (=> (=> true (=> (and ?v_11 ?v_1 ?v_12) (and ?v_11 ?v_12 ?v_1 (=> ?v_13 ?v_14)))) ?v_28) (=> (=> true (=> (= y_2 3) (=> (= z_2 x_0) true))) ?v_29) (=> (=> true (=> (= y_1 3) (=> ?v_15 true))) ?v_30)) (and ?v_16 ?v_17 ?v_18 ?v_19 ?v_20 ?v_21 ?v_22 ?v_23 ?v_24 ?v_25 ?v_26 ?v_27 ?v_28 ?v_29 ?v_30))))))))))
(check-sat)
(exit)
