(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/contains.spl:47:3-4:An invariant might not be maintained by a loop in procedure contains
  tests/spl/sl_sorted_set/contains.spl:37:14:Related location: This is the loop invariant that might not be maintained
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_21$0 () Bool)
(declare-fun Axiom_22$0 () Bool)
(declare-fun Axiom_23$0 () Bool)
(declare-fun Axiom_24$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_2$0 () SetLoc)
(declare-fun c1_4$0 () SetInt)
(declare-fun c1_5$0 () SetInt)
(declare-fun c1_init$0 () SetInt)
(declare-fun c2_4$0 () SetInt)
(declare-fun c2_5$0 () SetInt)
(declare-fun c2_init$0 () SetInt)
(declare-fun content_2$0 () SetInt)
(declare-fun content_init$0 () SetInt)
(declare-fun curr_4$0 () Loc)
(declare-fun curr_5$0 () Loc)
(declare-fun curr_init$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst_2$0 () Loc)
(declare-fun lst_init$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev_4$0 () Loc)
(declare-fun prev_5$0 () Loc)
(declare-fun prev_init$0 () Loc)
(declare-fun sk_?X_90$0 () SetLoc)
(declare-fun sk_?X_91$0 () SetLoc)
(declare-fun sk_?X_92$0 () SetLoc)
(declare-fun sk_?X_93$0 () SetLoc)
(declare-fun sk_?X_94$0 () SetLoc)
(declare-fun sk_?X_95$0 () SetLoc)
(declare-fun sk_?X_96$0 () SetLoc)
(declare-fun sk_?X_97$0 () SetLoc)
(declare-fun sk_?X_98$0 () SetLoc)
(declare-fun sk_?X_99$0 () SetLoc)
(declare-fun sk_?X_100$0 () SetLoc)
(declare-fun sk_?X_101$0 () SetLoc)
(declare-fun sk_?X_102$0 () SetLoc)
(declare-fun sk_?X_103$0 () SetLoc)
(declare-fun sk_?X_104$0 () SetLoc)
(declare-fun sk_?X_105$0 () SetLoc)
(declare-fun sk_?e_4$0 () Int)
(declare-fun sk_?e_5$0 () Int)
(declare-fun sk_FP_2$0 () SetLoc)
(declare-fun sk_FP_3$0 () SetLoc)
(declare-fun sk_l1_4$0 () Loc)
(declare-fun sk_l1_5$0 () Loc)
(declare-fun sk_l2_4$0 () Loc)
(declare-fun sk_l2_5$0 () Loc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_398$0 () Int)
(declare-fun t_399$0 () Int)
(declare-fun t_400$0 () Int)
(declare-fun t_401$0 () Int)
(declare-fun t_402$0 () Int)
(declare-fun t_403$0 () Int)
(declare-fun t_404$0 () Int)
(declare-fun t_405$0 () Int)
(declare-fun t_406$0 () Int)
(declare-fun t_407$0 () Int)
(declare-fun t_408$0 () Int)
(declare-fun t_409$0 () Int)
(declare-fun t_410$0 () Int)
(declare-fun t_411$0 () Int)
(declare-fun t_412$0 () Int)
(declare-fun t_413$0 () Int)
(declare-fun t_414$0 () Int)
(declare-fun t_415$0 () Int)
(declare-fun t_416$0 () Int)
(declare-fun t_417$0 () Int)
(declare-fun t_418$0 () Int)
(declare-fun t_419$0 () Int)
(declare-fun t_420$0 () Int)
(declare-fun t_421$0 () Int)
(declare-fun t_422$0 () Int)
(declare-fun t_423$0 () Int)
(declare-fun t_424$0 () Int)
(declare-fun t_425$0 () Int)
(declare-fun t_426$0 () Int)
(declare-fun t_427$0 () Int)
(declare-fun t_428$0 () Int)
(declare-fun t_429$0 () Int)
(declare-fun t_430$0 () Int)
(declare-fun t_431$0 () Int)
(declare-fun t_432$0 () Int)
(declare-fun t_433$0 () Int)
(declare-fun t_434$0 () Int)
(declare-fun t_435$0 () Int)
(declare-fun t_436$0 () Int)
(declare-fun t_437$0 () Int)
(declare-fun t_438$0 () Int)
(declare-fun t_439$0 () Int)
(declare-fun t_440$0 () Int)
(declare-fun t_441$0 () Int)
(declare-fun t_442$0 () Int)
(declare-fun t_443$0 () Int)
(declare-fun t_444$0 () Int)
(declare-fun t_445$0 () Int)
(declare-fun t_446$0 () Int)
(declare-fun t_447$0 () Int)
(declare-fun t_448$0 () Int)
(declare-fun t_449$0 () Int)
(declare-fun t_450$0 () Loc)
(declare-fun t_451$0 () Loc)
(declare-fun t_452$0 () Loc)
(declare-fun t_453$0 () Loc)
(declare-fun t_454$0 () Loc)
(declare-fun t_455$0 () Loc)
(declare-fun t_456$0 () Loc)
(declare-fun t_457$0 () Loc)
(declare-fun t_458$0 () Loc)
(declare-fun t_459$0 () Loc)
(declare-fun t_460$0 () Loc)
(declare-fun t_461$0 () Loc)
(declare-fun t_462$0 () Loc)
(declare-fun t_463$0 () Loc)
(declare-fun t_464$0 () Loc)
(declare-fun t_465$0 () Loc)
(declare-fun t_466$0 () Loc)
(declare-fun t_467$0 () Loc)
(declare-fun t_468$0 () Loc)
(declare-fun t_469$0 () Loc)
(declare-fun t_470$0 () Loc)
(declare-fun t_471$0 () Loc)
(declare-fun t_472$0 () Loc)
(declare-fun t_473$0 () Loc)
(declare-fun t_474$0 () Loc)
(declare-fun t_475$0 () Loc)
(declare-fun t_476$0 () Loc)
(declare-fun t_477$0 () Loc)
(declare-fun t_478$0 () Loc)
(declare-fun t_479$0 () Loc)
(declare-fun t_480$0 () Loc)
(declare-fun t_481$0 () Loc)
(declare-fun t_482$0 () Loc)
(declare-fun t_483$0 () Loc)
(declare-fun t_484$0 () Loc)
(declare-fun t_485$0 () Loc)
(declare-fun t_486$0 () Loc)
(declare-fun t_487$0 () Loc)
(declare-fun t_488$0 () Loc)
(declare-fun t_489$0 () Loc)
(declare-fun t_490$0 () Loc)
(declare-fun t_491$0 () Loc)
(declare-fun t_492$0 () Loc)
(declare-fun t_493$0 () Loc)
(declare-fun t_494$0 () Loc)
(declare-fun t_495$0 () Loc)
(declare-fun t_496$0 () Loc)
(declare-fun t_497$0 () Loc)
(declare-fun t_498$0 () Loc)
(declare-fun t_499$0 () Loc)
(declare-fun t_500$0 () Loc)
(declare-fun t_501$0 () Loc)
(declare-fun val_2$0 () Int)
(declare-fun val_init$0 () Int)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_501$0))

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_500$0))

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_499$0))

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_498$0))

(assert (=
  (witness$0 data$0 val_2$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_497$0))

(assert (= (witness$0 data$0 val_2$0 (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_496$0))

(assert (=
  (witness$0 data$0 val_2$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_495$0))

(assert (= (witness$0 data$0 val_2$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_494$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_493$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_492$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_491$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_490$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_489$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_488$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_487$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_486$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_485$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_484$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_483$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_482$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_481$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_480$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_479$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_478$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_477$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_476$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_475$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_474$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_473$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_472$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_471$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_470$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_469$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_468$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_467$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_466$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_465$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_464$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_463$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_462$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_461$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_460$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_459$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_458$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_457$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_456$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_455$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_454$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_453$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
  t_452$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_451$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_4$0)
    (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
  t_450$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_449$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_448$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_447$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_446$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_445$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_444$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_443$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_442$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_441$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_440$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_439$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_438$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_437$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_436$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_435$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_434$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_433$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_432$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_431$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_430$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_429$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_428$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_427$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_4$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_426$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_425$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_424$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_423$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_422$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_421$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_420$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_419$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_4$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_418$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_417$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_416$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_415$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_414$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_413$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_412$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_411$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_410$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_409$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_408$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_407$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_406$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_405$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_404$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_403$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_402$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_401$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
  t_400$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_399$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_4$0)
      (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
  t_398$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (not Axiom_21$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_103$0)) (not (in$1 l2 sk_?X_103$0))))))

(assert (or (and (Btwn$0 next$0 curr_init$0 null$0 null$0) Axiom_22$0)
    (not
         (sorted_set_struct$0 sk_?X_95$0 data$0 next$0 curr_init$0 null$0
           c1_init$0))))

(assert (or (not Axiom_23$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_5$0))
                (not (in$1 l1 sk_?X_105$0)) (not (in$1 l2 sk_?X_105$0))))))

(assert (or (and (Btwn$0 next$0 lst_init$0 curr_init$0 curr_init$0) Axiom_24$0)
    (not
         (sorted_set_struct$0 sk_?X_97$0 data$0 next$0 lst_init$0 curr_init$0
           c2_init$0))))

(assert (= c1_4$0 c1_init$0))

(assert (= c2_4$0 c2_init$0))

(assert (= content_2$0 content_init$0))

(assert (= curr_5$0 (read$0 next$0 curr_4$0)))

(assert (= prev_4$0 prev_init$0))

(assert (= val_2$0 val_init$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_91$0 sk_?X_93$0))

(assert (= sk_?X_93$0 (union$1 sk_?X_96$0 sk_?X_94$0)))

(assert (= sk_?X_95$0 (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0)))

(assert (= sk_?X_97$0 (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0)))

(assert (or
    (and (= (read$0 next$0 prev_init$0) curr_init$0)
         (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_96$0 sk_?X_94$0))
         (= c1_init$0 (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
         (= c2_init$0 (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
         (= content_init$0 (union$0 c1_init$0 c2_init$0)) (= sk_?X_91$0 FP$0)
         (> val_init$0 (read$1 data$0 prev_init$0))
         (Btwn$0 next$0 lst_init$0 prev_init$0 curr_init$0)
         (sorted_set_struct$0 sk_?X_95$0 data$0 next$0 curr_init$0 null$0
           c1_init$0)
         (sorted_set_struct$0 sk_?X_97$0 data$0 next$0 lst_init$0 curr_init$0
           c2_init$0)
         (or (= curr_init$0 null$0) (= prev_init$0 null$0)
             (< (read$1 data$0 prev_init$0) (read$1 data$0 curr_init$0)))
         (not (= prev_init$0 curr_init$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_init$0 (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
         (= c2_init$0 emptyset$0)
         (= content_init$0 (union$0 c1_init$0 c2_init$0))
         (= curr_init$0 lst_init$0) (= prev_init$0 null$0)
         (= sk_?X_90$0 FP$0)
         (sorted_set_struct$0 sk_?X_95$0 data$0 next$0 curr_init$0 null$0
           c1_init$0)
         (or (= curr_init$0 null$0) (= prev_init$0 null$0)
             (< (read$1 data$0 prev_init$0) (read$1 data$0 curr_init$0))))))

(assert (= sk_?X_99$0 sk_?X_101$0))

(assert (= sk_?X_101$0 (union$1 sk_?X_104$0 sk_?X_102$0)))

(assert (= sk_?X_103$0 (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0)))

(assert (= sk_?X_105$0 (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0)))

(assert (= sk_FP_3$0 sk_?X_98$0))

(assert (or (in$0 sk_?e_5$0 c2_5$0)
    (and (in$0 sk_?e_5$0 (union$0 c1_5$0 c2_5$0))
         (not (in$0 sk_?e_5$0 content_2$0)))
    (and (in$0 sk_?e_5$0 c1_5$0)
         (not
              (in$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))
    (and (in$0 sk_?e_5$0 content_2$0)
         (not (in$0 sk_?e_5$0 (union$0 c1_5$0 c2_5$0))))
    (and (in$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
         (not (in$0 sk_?e_5$0 c1_5$0)))
    (and (in$1 sk_l2_5$0 sk_FP_3$0) (not (in$1 sk_l2_5$0 FP$0)))
    (and (not (= curr_5$0 null$0)) (not (= prev_5$0 null$0))
         (not (< (read$1 data$0 prev_5$0) (read$1 data$0 curr_5$0))))
    (not (= curr_5$0 lst_2$0)) (not (= prev_5$0 null$0))
    (not (Btwn$0 next$0 curr_5$0 null$0 null$0))
    (and (Btwn$0 next$0 sk_l1_5$0 sk_l2_5$0 null$0)
         (in$1 sk_l1_5$0 sk_?X_103$0) (in$1 sk_l2_5$0 sk_?X_103$0)
         (not (= sk_l1_5$0 sk_l2_5$0))
         (not (< (read$1 data$0 sk_l1_5$0) (read$1 data$0 sk_l2_5$0))))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_init$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 curr_init$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_init$0
                          null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 curr_init$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))
                 (not (= l1 curr_init$0)))
            (and
                 (or (= l1 curr_init$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 curr_init$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_init$0
                          curr_init$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
              (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (and (Btwn$0 next$0 curr_5$0 null$0 null$0) Axiom_21$0)
    (not
         (sorted_set_struct$0 sk_?X_103$0 data$0 next$0 curr_5$0 null$0
           c1_5$0))))

(assert (or (not Axiom_22$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_95$0))
                (not (in$1 l2 sk_?X_95$0))))))

(assert (or (and (Btwn$0 next$0 lst_2$0 curr_5$0 curr_5$0) Axiom_23$0)
    (not
         (sorted_set_struct$0 sk_?X_105$0 data$0 next$0 lst_2$0 curr_5$0
           c2_5$0))))

(assert (or (not Axiom_24$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_init$0))
                (not (in$1 l1 sk_?X_97$0)) (not (in$1 l2 sk_?X_97$0))))))

(assert (= FP_Caller_2$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c1_5$0 (setminus$0 c1_4$0 (setenum$0 (read$1 data$0 curr_4$0)))))

(assert (= c2_5$0 (union$0 c2_4$0 (setenum$0 (read$1 data$0 curr_4$0)))))

(assert (= curr_4$0 curr_init$0))

(assert (= lst_2$0 lst_init$0))

(assert (= prev_5$0 curr_4$0))

(assert (< (read$1 data$0 curr_4$0) val_2$0))

(assert (= sk_?X_90$0 sk_?X_92$0))

(assert (= sk_?X_92$0 sk_?X_94$0))

(assert (= sk_?X_94$0 sk_?X_95$0))

(assert (= sk_?X_96$0 sk_?X_97$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (= sk_?X_98$0 sk_?X_100$0))

(assert (= sk_?X_100$0 sk_?X_102$0))

(assert (= sk_?X_102$0 sk_?X_103$0))

(assert (= sk_?X_104$0 sk_?X_105$0))

(assert (= sk_FP_2$0 sk_?X_99$0))

(assert (or (= prev_5$0 curr_5$0)
    (in$1 sk_l1_4$0 (intersection$1 sk_?X_104$0 sk_?X_102$0))
    (and (in$0 sk_?e_4$0 (union$0 c1_5$0 c2_5$0))
         (not (in$0 sk_?e_4$0 content_2$0)))
    (and (in$0 sk_?e_4$0 c1_5$0)
         (not
              (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))
    (and (in$0 sk_?e_4$0 c2_5$0)
         (not
              (in$0 sk_?e_4$0
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))
    (and (in$0 sk_?e_4$0 content_2$0)
         (not (in$0 sk_?e_4$0 (union$0 c1_5$0 c2_5$0))))
    (and (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
         (not (in$0 sk_?e_4$0 c1_5$0)))
    (and (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
         (not (in$0 sk_?e_4$0 c2_5$0)))
    (and (in$1 sk_l1_4$0 sk_FP_2$0) (not (in$1 sk_l1_4$0 FP$0)))
    (and (not (= curr_5$0 null$0)) (not (= prev_5$0 null$0))
         (not (< (read$1 data$0 prev_5$0) (read$1 data$0 curr_5$0))))
    (not (= (read$0 next$0 prev_5$0) curr_5$0))
    (not (> val_2$0 (read$1 data$0 prev_5$0)))
    (not (Btwn$0 next$0 curr_5$0 null$0 null$0))
    (not (Btwn$0 next$0 lst_2$0 curr_5$0 curr_5$0))
    (not (Btwn$0 next$0 lst_2$0 prev_5$0 curr_5$0))
    (and (Btwn$0 next$0 sk_l1_4$0 sk_l2_4$0 null$0)
         (in$1 sk_l1_4$0 sk_?X_103$0) (in$1 sk_l2_4$0 sk_?X_103$0)
         (not (= sk_l1_4$0 sk_l2_4$0))
         (not (< (read$1 data$0 sk_l1_4$0) (read$1 data$0 sk_l2_4$0))))
    (and (Btwn$0 next$0 sk_l1_4$0 sk_l2_4$0 curr_5$0)
         (in$1 sk_l1_4$0 sk_?X_105$0) (in$1 sk_l2_4$0 sk_?X_105$0)
         (not (= sk_l1_4$0 sk_l2_4$0))
         (not (< (read$1 data$0 sk_l1_4$0) (read$1 data$0 sk_l2_4$0))))))

(assert (not (= curr_4$0 null$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_5$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_5$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_2$0 l1 curr_5$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))
                 (not (= l1 curr_5$0)))
            (and
                 (or (= l1 curr_5$0)
                     (not (Btwn$0 next$0 lst_2$0 l1 curr_5$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_5$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_5$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_5$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))
              (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_5$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_5$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
