(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sls/sls_copy.spl:52:4-15:A postcondition of procedure copy might not hold at this return point
  tests/spl/sls/sls_copy.spl:24:10-47:Related location: This is the postcondition that might not hold
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldInt Loc) Int)
(declare-fun read$1 (FldLoc Loc) Loc)
(declare-fun write$0 (FldInt Loc Int) FldInt)
(declare-fun write$1 (FldLoc Loc Loc) FldLoc)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetLoc)
(declare-fun setenum$0 (Loc) SetLoc)
(declare-fun union$0 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun in$0 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Alloc_1$0 () SetLoc)
(declare-fun Alloc_2$0 () SetLoc)
(declare-fun Axiom_12$0 () Bool)
(declare-fun Axiom_13$0 () Bool)
(declare-fun Axiom_14$0 () Bool)
(declare-fun Axiom_15$0 () Bool)
(declare-fun Axiom_16$0 () Bool)
(declare-fun Axiom_17$0 () Bool)
(declare-fun Axiom_18$0 () Bool)
(declare-fun Axiom_19$0 () Bool)
(declare-fun Axiom_20$0 () Bool)
(declare-fun Axiom_21$0 () Bool)
(declare-fun Axiom_22$0 () Bool)
(declare-fun Axiom_23$0 () Bool)
(declare-fun Axiom_24$0 () Bool)
(declare-fun Axiom_25$0 () Bool)
(declare-fun Axiom_26$0 () Bool)
(declare-fun Axiom_27$0 () Bool)
(declare-fun Axiom_28$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_1$0 () SetLoc)
(declare-fun FP_2$0 () SetLoc)
(declare-fun FP_3$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun FP_Caller_final_1$0 () SetLoc)
(declare-fun cp_2$0 () Loc)
(declare-fun cp_3$0 () Loc)
(declare-fun curr_2$0 () Loc)
(declare-fun curr_3$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun data_1$0 () FldInt)
(declare-fun data_2$0 () FldInt)
(declare-fun lslseg_domain$0 (FldInt FldLoc Loc Loc Int) SetLoc)
(declare-fun lslseg_struct$0 (SetLoc FldInt FldLoc Loc Loc Int) Bool)
(declare-fun lst$0 () Loc)
(declare-fun lst_1$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun next_1$0 () FldLoc)
(declare-fun next_2$0 () FldLoc)
(declare-fun res_1$0 () Loc)
(declare-fun res_2$0 () Loc)
(declare-fun res_3$0 () Loc)
(declare-fun sk_?X_18$0 () SetLoc)
(declare-fun sk_?X_19$0 () SetLoc)
(declare-fun sk_?X_20$0 () SetLoc)
(declare-fun sk_?X_21$0 () SetLoc)
(declare-fun sk_?X_22$0 () SetLoc)
(declare-fun sk_?X_23$0 () SetLoc)
(declare-fun sk_?X_24$0 () SetLoc)
(declare-fun sk_?X_25$0 () SetLoc)
(declare-fun sk_?X_26$0 () SetLoc)
(declare-fun sk_?X_27$0 () SetLoc)
(declare-fun sk_?X_28$0 () SetLoc)
(declare-fun sk_?X_29$0 () SetLoc)
(declare-fun sk_?X_30$0 () SetLoc)
(declare-fun sk_?X_31$0 () SetLoc)
(declare-fun sk_?X_32$0 () SetLoc)
(declare-fun sk_?X_33$0 () SetLoc)
(declare-fun sk_?X_34$0 () SetLoc)
(declare-fun sk_?X_35$0 () SetLoc)
(declare-fun sk_?X_36$0 () SetLoc)
(declare-fun sk_?X_37$0 () SetLoc)
(declare-fun sk_?X_38$0 () SetLoc)
(declare-fun sk_?X_39$0 () SetLoc)
(declare-fun sk_?X_40$0 () SetLoc)
(declare-fun sk_?X_41$0 () SetLoc)
(declare-fun sk_l1_2$0 () Loc)
(declare-fun sk_l2_2$0 () Loc)
(declare-fun slseg_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun slseg_struct$0 (SetLoc FldInt FldLoc Loc Loc) Bool)
(declare-fun t_12$0 () Int)
(declare-fun t_13$0 () Int)
(declare-fun t_14$0 () Int)
(declare-fun t_15$0 () Int)
(declare-fun t_16$0 () Int)
(declare-fun t_17$0 () Int)
(declare-fun t_18$0 () Loc)
(declare-fun t_19$0 () Loc)
(declare-fun t_20$0 () Loc)
(declare-fun t_21$0 () Int)
(declare-fun t_22$0 () Int)
(declare-fun t_23$0 () Int)
(declare-fun t_24$0 () Int)
(declare-fun t_25$0 () Int)
(declare-fun t_26$0 () Int)
(declare-fun t_27$0 () Int)
(declare-fun t_28$0 () Int)
(declare-fun t_29$0 () Int)
(declare-fun t_30$0 () Int)
(declare-fun t_31$0 () Int)
(declare-fun t_32$0 () Loc)
(declare-fun t_33$0 () Loc)
(declare-fun t_34$0 () Loc)
(declare-fun t_35$0 () Loc)
(declare-fun t_36$0 () Loc)
(declare-fun t_37$0 () Loc)
(declare-fun t_38$0 () Loc)
(declare-fun t_39$0 () Loc)
(declare-fun t_40$0 () Loc)
(declare-fun t_41$0 () Loc)
(declare-fun t_42$0 () Loc)
(declare-fun t_43$0 () Loc)
(declare-fun t_44$0 () Loc)
(declare-fun t_45$0 () Loc)
(declare-fun t_46$0 () Loc)
(declare-fun t_47$0 () Loc)
(declare-fun t_48$0 () Loc)
(declare-fun tmp_2$0 () Loc)

(assert (= (ep$0 next_1$0 FP_2$0 tmp_2$0) t_48$0))

(assert (= (ep$0 next_1$0 FP_2$0 sk_l2_2$0) t_47$0))

(assert (= (ep$0 next_1$0 FP_2$0 sk_l1_2$0) t_46$0))

(assert (= (ep$0 next_1$0 FP_2$0 res_3$0) t_45$0))

(assert (= (ep$0 next_1$0 FP_2$0 res_2$0) t_44$0))

(assert (= (ep$0 next_1$0 FP_2$0 res_1$0) t_43$0))

(assert (= (ep$0 next_1$0 FP_2$0 lst_1$0) t_42$0))

(assert (= (ep$0 next_1$0 FP_2$0 lst$0) t_41$0))

(assert (= (ep$0 next_1$0 FP_2$0 curr_3$0) t_40$0))

(assert (= (ep$0 next_1$0 FP_2$0 curr_2$0) t_39$0))

(assert (= (ep$0 next_1$0 FP_2$0 null$0) t_38$0))

(assert (= (read$1 next_2$0 cp_2$0) t_37$0))

(assert (= (read$1 next_1$0 curr_3$0) t_36$0))

(assert (= (read$1 next_1$0 cp_3$0) t_35$0))

(assert (= (read$1 next$0 curr_3$0) t_34$0))

(assert (= (read$1 next$0 cp_3$0) t_33$0))

(assert (= (read$1 next$0 cp_2$0) t_32$0))

(assert (= (read$0 data_2$0 curr_2$0) t_31$0))

(assert (= (read$0 data_2$0 cp_2$0) t_30$0))

(assert (= (read$0 data_1$0 sk_l2_2$0) t_29$0))

(assert (= (read$0 data_1$0 sk_l1_2$0) t_28$0))

(assert (= (read$0 data_1$0 curr_3$0) t_27$0))

(assert (= (read$0 data_1$0 cp_3$0) t_26$0))

(assert (= (read$0 data$0 sk_l2_2$0) t_25$0))

(assert (= (read$0 data$0 sk_l1_2$0) t_24$0))

(assert (= (read$0 data$0 curr_3$0) t_23$0))

(assert (= (read$0 data$0 cp_3$0) t_22$0))

(assert (= (read$0 data$0 cp_2$0) t_21$0))

(assert (= (read$1 (write$1 next$0 cp_2$0 null$0) curr_3$0) t_20$0))

(assert (= (read$1 (write$1 next$0 cp_2$0 null$0) cp_3$0) t_19$0))

(assert (= (read$1 (write$1 next$0 cp_2$0 null$0) cp_2$0) t_18$0))

(assert (= (read$0 (write$0 data$0 cp_2$0 (read$0 data$0 curr_2$0)) sk_l2_2$0)
  t_17$0))

(assert (= (read$0 (write$0 data$0 cp_2$0 (read$0 data$0 curr_2$0)) sk_l1_2$0)
  t_16$0))

(assert (= (read$0 (write$0 data$0 cp_2$0 (read$0 data$0 curr_2$0)) curr_3$0) t_15$0))

(assert (= (read$0 (write$0 data$0 cp_2$0 (read$0 data$0 curr_2$0)) curr_2$0) t_14$0))

(assert (= (read$0 (write$0 data$0 cp_2$0 (read$0 data$0 curr_2$0)) cp_3$0) t_13$0))

(assert (= (read$0 (write$0 data$0 cp_2$0 (read$0 data$0 curr_2$0)) cp_2$0) t_12$0))

(assert (forall ((?d_16 Loc) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$1 next$0 ?y) (read$1 (write$1 next$0 ?x ?d_16) ?y)))))

(assert (forall ((?d_16 Loc) (?x Loc))
        (= (read$1 (write$1 next$0 ?x ?d_16) ?x) ?d_16)))

(assert (forall ((?d_15 Int) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$0 data$0 ?y) (read$0 (write$0 data$0 ?x ?d_15) ?y)))))

(assert (forall ((?d_15 Int) (?x Loc))
        (= (read$0 (write$0 data$0 ?x ?d_15) ?x) ?d_15)))

(assert (forall ((?f FldLoc)) (= (read$1 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Loc)) (not (in$0 x emptyset$0))))

(assert (or (not Axiom_12$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$0 l1 sk_?X_38$0))
                (not (in$0 l2 sk_?X_38$0))))))

(assert (or (and (Btwn$0 next_1$0 curr_2$0 null$0 null$0) Axiom_13$0)
    (not (slseg_struct$0 sk_?X_36$0 data_1$0 next_1$0 curr_2$0 null$0))))

(assert (or (not Axiom_14$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_1$0 l1) (read$0 data_1$0 l2))
                (not (Btwn$0 next_1$0 l1 l2 curr_2$0))
                (not (in$0 l1 sk_?X_37$0)) (not (in$0 l2 sk_?X_37$0))))))

(assert (or (not Axiom_15$0)
    (forall ((l1 Loc))
            (or (<= (read$0 data_1$0 l1) (read$0 data_1$0 curr_2$0))
                (not (in$0 l1 sk_?X_37$0))))))

(assert (or (and (Btwn$0 next_1$0 res_1$0 cp_2$0 cp_2$0) Axiom_17$0 Axiom_16$0)
    (not
         (lslseg_struct$0 sk_?X_34$0 data_1$0 next_1$0 res_1$0 cp_2$0
           (read$0 data_1$0 curr_2$0)))))

(assert (or (not Axiom_18$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_2$0 l1) (read$0 data_2$0 l2))
                (not (Btwn$0 next_2$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_19$0)) (not (in$0 l2 sk_?X_19$0))))))

(assert (or (and (Btwn$0 next_2$0 lst$0 null$0 null$0) Axiom_19$0)
    (not (slseg_struct$0 sk_?X_39$0 data_2$0 next_2$0 lst$0 null$0))))

(assert (or (not Axiom_20$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_2$0 l1) (read$0 data_2$0 l2))
                (not (Btwn$0 next_2$0 l1 l2 curr_3$0))
                (not (in$0 l1 sk_?X_18$0)) (not (in$0 l2 sk_?X_18$0))))))

(assert (or (not Axiom_21$0)
    (forall ((l1 Loc))
            (or (<= (read$0 data_2$0 l1) (read$0 data_2$0 curr_3$0))
                (not (in$0 l1 sk_?X_18$0))))))

(assert (or (and (Btwn$0 next_2$0 res_2$0 cp_3$0 cp_3$0) Axiom_23$0 Axiom_22$0)
    (not
         (lslseg_struct$0 sk_?X_21$0 data_2$0 next_2$0 res_2$0 cp_3$0
           (read$0 data_2$0 curr_3$0)))))

(assert (or (not Axiom_24$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_2$0 l1) (read$0 data_2$0 l2))
                (not (Btwn$0 next_2$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_40$0)) (not (in$0 l2 sk_?X_40$0))))))

(assert (= (read$1 next_2$0 curr_3$0) null$0))

(assert (= FP_1$0 (union$0 FP$0 (setenum$0 tmp_2$0))))

(assert (= FP_Caller_1$0 (setminus$0 FP_Caller$0 FP$0)))

(assert (= cp_2$0 res_1$0))

(assert (= data_1$0 (write$0 data$0 cp_2$0 (read$0 data$0 curr_2$0))))

(assert (= next_1$0 (write$1 next$0 cp_2$0 null$0)))

(assert (= res_2$0 res_1$0))

(assert (Frame$1 FP_2$0 Alloc_1$0 data_1$0 data_2$0))

(assert (= Alloc_2$0 (union$0 FP_3$0 Alloc_2$0)))

(assert (= (read$0 data_1$0 cp_2$0) (read$0 data_1$0 curr_2$0)))

(assert (= emptyset$0 emptyset$0))

(assert (= emptyset$0 (intersection$0 sk_?X_35$0 sk_?X_34$0)))

(assert (= sk_?X_28$0 sk_?X_29$0))

(assert (= sk_?X_29$0 sk_?X_30$0))

(assert (= sk_?X_31$0 sk_?X_32$0))

(assert (= sk_?X_33$0 (union$0 sk_?X_35$0 sk_?X_34$0)))

(assert (= sk_?X_35$0 (union$0 sk_?X_37$0 sk_?X_36$0)))

(assert (= sk_?X_37$0
  (lslseg_domain$0 data_1$0 next_1$0 lst$0 curr_2$0
    (read$0 data_1$0 curr_2$0))))

(assert (lslseg_struct$0 sk_?X_34$0 data_1$0 next_1$0 res_1$0 cp_2$0
  (read$0 data_1$0 curr_2$0)))

(assert (slseg_struct$0 sk_?X_36$0 data_1$0 next_1$0 curr_2$0 null$0))

(assert (= (read$0 data_2$0 cp_3$0) (read$0 data_2$0 curr_3$0)))

(assert (= emptyset$0 emptyset$0))

(assert (= emptyset$0 (intersection$0 sk_?X_20$0 sk_?X_21$0)))

(assert (= sk_?X_18$0
  (lslseg_domain$0 data_2$0 next_2$0 lst_1$0 curr_3$0
    (read$0 data_2$0 curr_3$0))))

(assert (= sk_?X_20$0 (union$0 sk_?X_18$0 sk_?X_19$0)))

(assert (= sk_?X_22$0 (union$0 sk_?X_20$0 sk_?X_21$0)))

(assert (= sk_?X_24$0 sk_?X_23$0))

(assert (= sk_?X_26$0 sk_?X_25$0))

(assert (= sk_?X_27$0 sk_?X_26$0))

(assert (lslseg_struct$0 sk_?X_21$0 data_2$0 next_2$0 res_2$0 cp_3$0
  (read$0 data_2$0 curr_3$0)))

(assert (not (= curr_3$0 null$0)))

(assert (= sk_?X_38$0 (slseg_domain$0 data$0 next$0 lst$0 null$0)))

(assert (slseg_struct$0 sk_?X_38$0 data$0 next$0 lst$0 null$0))

(assert (= sk_?X_40$0 (slseg_domain$0 data_2$0 next_2$0 res_3$0 null$0)))

(assert (or (in$0 sk_l2_2$0 (intersection$0 sk_?X_39$0 sk_?X_40$0))
    (and
         (in$0 sk_l1_2$0
           (union$0 (intersection$0 Alloc_2$0 FP$0)
             (setminus$0 Alloc_2$0 Alloc$0)))
         (not (in$0 sk_l1_2$0 sk_?X_41$0)))
    (and (in$0 sk_l1_2$0 sk_?X_41$0)
         (not
              (in$0 sk_l1_2$0
                (union$0 (intersection$0 Alloc_2$0 FP$0)
                  (setminus$0 Alloc_2$0 Alloc$0)))))
    (not (Btwn$0 next_2$0 lst$0 null$0 null$0))
    (not (Btwn$0 next_2$0 res_3$0 null$0 null$0))
    (and (Btwn$0 next_2$0 sk_l1_2$0 sk_l2_2$0 null$0)
         (in$0 sk_l1_2$0 sk_?X_39$0) (in$0 sk_l2_2$0 sk_?X_39$0)
         (not (<= (read$0 data_2$0 sk_l1_2$0) (read$0 data_2$0 sk_l2_2$0))))
    (and (Btwn$0 next_2$0 sk_l1_2$0 sk_l2_2$0 null$0)
         (in$0 sk_l1_2$0 sk_?X_40$0) (in$0 sk_l2_2$0 sk_?X_40$0)
         (not (<= (read$0 data_2$0 sk_l1_2$0) (read$0 data_2$0 sk_l2_2$0))))))

(assert (not (= tmp_2$0 null$0)))

(assert (not (in$0 null$0 Alloc_2$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 null$0)
                 (in$0 l1 (slseg_domain$0 data$0 next$0 lst$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst$0 l1 null$0)))
                 (not (in$0 l1 (slseg_domain$0 data$0 next$0 lst$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_1$0 lst$0 l1 curr_2$0)
                 (in$0 l1
                   (lslseg_domain$0 data_1$0 next_1$0 lst$0 curr_2$0
                     (read$0 data_1$0 curr_2$0)))
                 (not (= l1 curr_2$0)))
            (and
                 (or (= l1 curr_2$0)
                     (not (Btwn$0 next_1$0 lst$0 l1 curr_2$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data_1$0 next_1$0 lst$0 curr_2$0
                          (read$0 data_1$0 curr_2$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_2$0 curr_3$0 l1 null$0)
                 (in$0 l1 (slseg_domain$0 data_2$0 next_2$0 curr_3$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next_2$0 curr_3$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (slseg_domain$0 data_2$0 next_2$0 curr_3$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_2$0 lst_1$0 l1 curr_3$0)
                 (in$0 l1
                   (lslseg_domain$0 data_2$0 next_2$0 lst_1$0 curr_3$0
                     (read$0 data_2$0 curr_3$0)))
                 (not (= l1 curr_3$0)))
            (and
                 (or (= l1 curr_3$0)
                     (not (Btwn$0 next_2$0 lst_1$0 l1 curr_3$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data_2$0 next_2$0 lst_1$0 curr_3$0
                          (read$0 data_2$0 curr_3$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_2$0 res_3$0 l1 null$0)
                 (in$0 l1 (slseg_domain$0 data_2$0 next_2$0 res_3$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next_2$0 res_3$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (slseg_domain$0 data_2$0 next_2$0 res_3$0 null$0)))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$0 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (not Axiom_25$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (in$0 ?x FP_2$0)
                (and (Btwn$0 next_1$0 ?x ?z ?y) (Btwn$0 next_2$0 ?x ?z ?y))
                (and (not (Btwn$0 next_1$0 ?x ?z ?y))
                     (not (Btwn$0 next_2$0 ?x ?z ?y)))
                (not (= ?x (ep$0 next_1$0 FP_2$0 ?x)))))))

(assert (or (not Axiom_26$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (and (Btwn$0 next_1$0 ?x ?z ?y) (Btwn$0 next_2$0 ?x ?z ?y))
                (and (not (Btwn$0 next_1$0 ?x ?z ?y))
                     (not (Btwn$0 next_2$0 ?x ?z ?y)))
                (not
                     (or (Btwn$0 next_1$0 ?x ?y (ep$0 next_1$0 FP_2$0 ?x))
                         (and (Btwn$0 next_1$0 ?x ?y ?y)
                              (not
                                   (Btwn$0 next_1$0 ?x
                                     (ep$0 next_1$0 FP_2$0 ?x)
                                     (ep$0 next_1$0 FP_2$0 ?x))))))))))

(assert (or (not Axiom_27$0)
    (forall ((?x Loc))
            (or (= (read$1 next_1$0 ?x) (read$1 next_2$0 ?x))
                (not (in$0 ?x (setminus$0 Alloc_1$0 FP_2$0)))))))

(assert (or (not (Frame$1 FP_2$0 Alloc_1$0 data_1$0 data_2$0)) Axiom_28$0))

(assert (or (and (Btwn$0 next$0 lst$0 null$0 null$0) Axiom_12$0)
    (not (slseg_struct$0 sk_?X_38$0 data$0 next$0 lst$0 null$0))))

(assert (or (not Axiom_13$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_1$0 l1) (read$0 data_1$0 l2))
                (not (Btwn$0 next_1$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_36$0)) (not (in$0 l2 sk_?X_36$0))))))

(assert (or (and (Btwn$0 next_1$0 lst$0 curr_2$0 curr_2$0) Axiom_15$0 Axiom_14$0)
    (not
         (lslseg_struct$0 sk_?X_37$0 data_1$0 next_1$0 lst$0 curr_2$0
           (read$0 data_1$0 curr_2$0)))))

(assert (or (not Axiom_16$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_1$0 l1) (read$0 data_1$0 l2))
                (not (Btwn$0 next_1$0 l1 l2 cp_2$0))
                (not (in$0 l1 sk_?X_34$0)) (not (in$0 l2 sk_?X_34$0))))))

(assert (or (not Axiom_17$0)
    (forall ((l1 Loc))
            (or (<= (read$0 data_1$0 l1) (read$0 data_1$0 curr_2$0))
                (not (in$0 l1 sk_?X_34$0))))))

(assert (or (and (Btwn$0 next_2$0 curr_3$0 null$0 null$0) Axiom_18$0)
    (not (slseg_struct$0 sk_?X_19$0 data_2$0 next_2$0 curr_3$0 null$0))))

(assert (or (not Axiom_19$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_2$0 l1) (read$0 data_2$0 l2))
                (not (Btwn$0 next_2$0 l1 l2 null$0))
                (not (in$0 l1 sk_?X_39$0)) (not (in$0 l2 sk_?X_39$0))))))

(assert (or (and (Btwn$0 next_2$0 lst_1$0 curr_3$0 curr_3$0) Axiom_21$0 Axiom_20$0)
    (not
         (lslseg_struct$0 sk_?X_18$0 data_2$0 next_2$0 lst_1$0 curr_3$0
           (read$0 data_2$0 curr_3$0)))))

(assert (or (not Axiom_22$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (<= (read$0 data_2$0 l1) (read$0 data_2$0 l2))
                (not (Btwn$0 next_2$0 l1 l2 cp_3$0))
                (not (in$0 l1 sk_?X_21$0)) (not (in$0 l2 sk_?X_21$0))))))

(assert (or (not Axiom_23$0)
    (forall ((l1 Loc))
            (or (<= (read$0 data_2$0 l1) (read$0 data_2$0 curr_3$0))
                (not (in$0 l1 sk_?X_21$0))))))

(assert (or (and (Btwn$0 next_2$0 res_3$0 null$0 null$0) Axiom_24$0)
    (not (slseg_struct$0 sk_?X_40$0 data_2$0 next_2$0 res_3$0 null$0))))

(assert (= Alloc_1$0 (union$0 Alloc$0 (setenum$0 tmp_2$0))))

(assert (= FP_3$0
  (union$0 (setminus$0 FP_1$0 FP_2$0)
    (union$0 (intersection$0 Alloc_2$0 FP_2$0)
      (setminus$0 Alloc_2$0 Alloc_1$0)))))

(assert (= FP_Caller_final_1$0 (union$0 FP_Caller_1$0 FP_3$0)))

(assert (= curr_2$0 lst$0))

(assert (= lst_1$0 lst$0))

(assert (= res_1$0 tmp_2$0))

(assert (= res_3$0 res_2$0))

(assert (Frame$0 FP_2$0 Alloc_1$0 next_1$0 next_2$0))

(assert (= Alloc$0 (union$0 FP_Caller$0 Alloc$0)))

(assert (= (read$1 next_1$0 cp_2$0) null$0))

(assert (= emptyset$0 (intersection$0 sk_?X_33$0 sk_?X_31$0)))

(assert (= emptyset$0 (intersection$0 sk_?X_37$0 sk_?X_36$0)))

(assert (= sk_?X_28$0 FP_2$0))

(assert (= sk_?X_30$0 (union$0 sk_?X_33$0 sk_?X_31$0)))

(assert (= sk_?X_32$0 (setenum$0 cp_2$0)))

(assert (= sk_?X_34$0
  (lslseg_domain$0 data_1$0 next_1$0 res_1$0 cp_2$0
    (read$0 data_1$0 curr_2$0))))

(assert (= sk_?X_36$0 (slseg_domain$0 data_1$0 next_1$0 curr_2$0 null$0)))

(assert (= FP_1$0 (union$0 FP_2$0 FP_1$0)))

(assert (lslseg_struct$0 sk_?X_37$0 data_1$0 next_1$0 lst$0 curr_2$0
  (read$0 data_1$0 curr_2$0)))

(assert (not (= curr_2$0 null$0)))

(assert (= (read$1 next_2$0 cp_3$0) null$0))

(assert (= emptyset$0 (intersection$0 sk_?X_18$0 sk_?X_19$0)))

(assert (= emptyset$0 (intersection$0 sk_?X_22$0 sk_?X_24$0)))

(assert (= sk_?X_19$0 (slseg_domain$0 data_2$0 next_2$0 curr_3$0 null$0)))

(assert (= sk_?X_21$0
  (lslseg_domain$0 data_2$0 next_2$0 res_2$0 cp_3$0
    (read$0 data_2$0 curr_3$0))))

(assert (= sk_?X_23$0 (setenum$0 cp_3$0)))

(assert (= sk_?X_25$0 (union$0 sk_?X_22$0 sk_?X_24$0)))

(assert (= sk_?X_27$0
  (union$0 (intersection$0 Alloc_2$0 FP_2$0)
    (setminus$0 Alloc_2$0 Alloc_1$0))))

(assert (lslseg_struct$0 sk_?X_18$0 data_2$0 next_2$0 lst_1$0 curr_3$0
  (read$0 data_2$0 curr_3$0)))

(assert (slseg_struct$0 sk_?X_19$0 data_2$0 next_2$0 curr_3$0 null$0))

(assert (= sk_?X_38$0 FP$0))

(assert (= FP_Caller$0 (union$0 FP$0 FP_Caller$0)))

(assert (= sk_?X_39$0 (slseg_domain$0 data_2$0 next_2$0 lst$0 null$0)))

(assert (= sk_?X_41$0 (union$0 sk_?X_39$0 sk_?X_40$0)))

(assert (not (= lst$0 null$0)))

(assert (not (in$0 null$0 Alloc$0)))

(assert (not (in$0 tmp_2$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_1$0 curr_2$0 l1 null$0)
                 (in$0 l1 (slseg_domain$0 data_1$0 next_1$0 curr_2$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next_1$0 curr_2$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (slseg_domain$0 data_1$0 next_1$0 curr_2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_1$0 res_1$0 l1 cp_2$0)
                 (in$0 l1
                   (lslseg_domain$0 data_1$0 next_1$0 res_1$0 cp_2$0
                     (read$0 data_1$0 curr_2$0)))
                 (not (= l1 cp_2$0)))
            (and (or (= l1 cp_2$0) (not (Btwn$0 next_1$0 res_1$0 l1 cp_2$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data_1$0 next_1$0 res_1$0 cp_2$0
                          (read$0 data_1$0 curr_2$0))))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_2$0 lst$0 l1 null$0)
                 (in$0 l1 (slseg_domain$0 data_2$0 next_2$0 lst$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next_2$0 lst$0 l1 null$0)))
                 (not
                      (in$0 l1
                        (slseg_domain$0 data_2$0 next_2$0 lst$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_2$0 res_2$0 l1 cp_3$0)
                 (in$0 l1
                   (lslseg_domain$0 data_2$0 next_2$0 res_2$0 cp_3$0
                     (read$0 data_2$0 curr_3$0)))
                 (not (= l1 cp_3$0)))
            (and (or (= l1 cp_3$0) (not (Btwn$0 next_2$0 res_2$0 l1 cp_3$0)))
                 (not
                      (in$0 l1
                        (lslseg_domain$0 data_2$0 next_2$0 res_2$0 cp_3$0
                          (read$0 data_2$0 curr_3$0))))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$0 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$0 ?y ?X))
            (in$0 (ep$0 ?f ?X ?x) ?X))))

(assert (or (and Axiom_27$0 Axiom_26$0 Axiom_25$0)
    (not (Frame$0 FP_2$0 Alloc_1$0 next_1$0 next_2$0))))

(assert (or (not Axiom_28$0)
    (forall ((?x Loc))
            (or (= (read$0 data_1$0 ?x) (read$0 data_2$0 ?x))
                (not (in$0 ?x (setminus$0 Alloc_1$0 FP_2$0)))))))

(assert (forall ((?u Loc) (?v Loc) (?z Loc))
        (and
             (or (Btwn$0 (write$1 next$0 cp_2$0 null$0) ?z ?u ?v)
                 (not
                      (or
                          (and (Btwn$0 next$0 ?z ?u ?v)
                               (or (Btwn$0 next$0 ?z ?v cp_2$0)
                                   (and (Btwn$0 next$0 ?z ?v ?v)
                                        (not
                                             (Btwn$0 next$0 ?z cp_2$0 cp_2$0)))))
                          (and (not (= cp_2$0 ?v))
                               (or (Btwn$0 next$0 ?z cp_2$0 ?v)
                                   (and (Btwn$0 next$0 ?z cp_2$0 cp_2$0)
                                        (not (Btwn$0 next$0 ?z ?v ?v))))
                               (Btwn$0 next$0 ?z ?u cp_2$0)
                               (or (Btwn$0 next$0 null$0 ?v cp_2$0)
                                   (and (Btwn$0 next$0 null$0 ?v ?v)
                                        (not
                                             (Btwn$0 next$0 null$0 cp_2$0
                                               cp_2$0)))))
                          (and (not (= cp_2$0 ?v))
                               (or (Btwn$0 next$0 ?z cp_2$0 ?v)
                                   (and (Btwn$0 next$0 ?z cp_2$0 cp_2$0)
                                        (not (Btwn$0 next$0 ?z ?v ?v))))
                               (Btwn$0 next$0 null$0 ?u ?v)
                               (or (Btwn$0 next$0 null$0 ?v cp_2$0)
                                   (and (Btwn$0 next$0 null$0 ?v ?v)
                                        (not
                                             (Btwn$0 next$0 null$0 cp_2$0
                                               cp_2$0))))))))
             (or
                 (and (Btwn$0 next$0 ?z ?u ?v)
                      (or (Btwn$0 next$0 ?z ?v cp_2$0)
                          (and (Btwn$0 next$0 ?z ?v ?v)
                               (not (Btwn$0 next$0 ?z cp_2$0 cp_2$0)))))
                 (and (not (= cp_2$0 ?v))
                      (or (Btwn$0 next$0 ?z cp_2$0 ?v)
                          (and (Btwn$0 next$0 ?z cp_2$0 cp_2$0)
                               (not (Btwn$0 next$0 ?z ?v ?v))))
                      (Btwn$0 next$0 ?z ?u cp_2$0)
                      (or (Btwn$0 next$0 null$0 ?v cp_2$0)
                          (and (Btwn$0 next$0 null$0 ?v ?v)
                               (not (Btwn$0 next$0 null$0 cp_2$0 cp_2$0)))))
                 (and (not (= cp_2$0 ?v))
                      (or (Btwn$0 next$0 ?z cp_2$0 ?v)
                          (and (Btwn$0 next$0 ?z cp_2$0 cp_2$0)
                               (not (Btwn$0 next$0 ?z ?v ?v))))
                      (Btwn$0 next$0 null$0 ?u ?v)
                      (or (Btwn$0 next$0 null$0 ?v cp_2$0)
                          (and (Btwn$0 next$0 null$0 ?v ?v)
                               (not (Btwn$0 next$0 null$0 cp_2$0 cp_2$0)))))
                 (not (Btwn$0 (write$1 next$0 cp_2$0 null$0) ?z ?u ?v))))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$1 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$1 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$1 ?f ?x) (read$1 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
