(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/delete.spl:53:12-30:Possible heap access through null or dangling reference
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Alloc_1$0 () SetLoc)
(declare-fun Axiom_13$0 () Bool)
(declare-fun Axiom_14$0 () Bool)
(declare-fun Axiom_15$0 () Bool)
(declare-fun Axiom_16$0 () Bool)
(declare-fun Axiom_17$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_1$0 () SetLoc)
(declare-fun FP_2$0 () SetLoc)
(declare-fun FP_3$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun c1_2$0 () SetInt)
(declare-fun c1_3$0 () SetInt)
(declare-fun c2_2$0 () SetInt)
(declare-fun c2_3$0 () SetInt)
(declare-fun content$0 () SetInt)
(declare-fun content_1$0 () SetInt)
(declare-fun curr_2$0 () Loc)
(declare-fun curr_3$0 () Loc)
(declare-fun curr_4$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst$0 () Loc)
(declare-fun lst_1$0 () Loc)
(declare-fun n_2$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev_2$0 () Loc)
(declare-fun prev_3$0 () Loc)
(declare-fun sk_?X_43$0 () SetLoc)
(declare-fun sk_?X_44$0 () SetLoc)
(declare-fun sk_?X_45$0 () SetLoc)
(declare-fun sk_?X_46$0 () SetLoc)
(declare-fun sk_?X_47$0 () SetLoc)
(declare-fun sk_?X_48$0 () SetLoc)
(declare-fun sk_?X_49$0 () SetLoc)
(declare-fun sk_?X_50$0 () SetLoc)
(declare-fun sk_?X_51$0 () SetLoc)
(declare-fun sk_?X_52$0 () SetLoc)
(declare-fun sk_?X_53$0 () SetLoc)
(declare-fun sk_?X_54$0 () SetLoc)
(declare-fun sk_?X_55$0 () SetLoc)
(declare-fun sk_?X_56$0 () SetLoc)
(declare-fun sk_?X_57$0 () SetLoc)
(declare-fun sk_?X_58$0 () SetLoc)
(declare-fun sk_?X_59$0 () SetLoc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_245$0 () Int)
(declare-fun t_246$0 () Int)
(declare-fun t_247$0 () Int)
(declare-fun t_248$0 () Int)
(declare-fun t_249$0 () Int)
(declare-fun t_250$0 () Int)
(declare-fun t_251$0 () Int)
(declare-fun t_252$0 () Int)
(declare-fun t_253$0 () Int)
(declare-fun t_254$0 () Int)
(declare-fun t_255$0 () Int)
(declare-fun t_256$0 () Int)
(declare-fun t_257$0 () Int)
(declare-fun t_258$0 () Int)
(declare-fun t_259$0 () Int)
(declare-fun t_260$0 () Int)
(declare-fun t_261$0 () Int)
(declare-fun t_262$0 () Int)
(declare-fun t_263$0 () Int)
(declare-fun t_264$0 () Int)
(declare-fun t_265$0 () Int)
(declare-fun t_266$0 () Int)
(declare-fun t_267$0 () Int)
(declare-fun t_268$0 () Int)
(declare-fun t_269$0 () Int)
(declare-fun t_270$0 () Int)
(declare-fun t_271$0 () Int)
(declare-fun t_272$0 () Int)
(declare-fun t_273$0 () Int)
(declare-fun t_274$0 () Int)
(declare-fun t_275$0 () Loc)
(declare-fun t_276$0 () Loc)
(declare-fun t_277$0 () Loc)
(declare-fun t_278$0 () Loc)
(declare-fun t_279$0 () Loc)
(declare-fun t_280$0 () Loc)
(declare-fun t_281$0 () Loc)
(declare-fun t_282$0 () Loc)
(declare-fun t_283$0 () Loc)
(declare-fun t_284$0 () Loc)
(declare-fun t_285$0 () Loc)
(declare-fun t_286$0 () Loc)
(declare-fun t_287$0 () Loc)
(declare-fun t_288$0 () Loc)
(declare-fun t_289$0 () Loc)
(declare-fun t_290$0 () Loc)
(declare-fun t_291$0 () Loc)
(declare-fun t_292$0 () Loc)
(declare-fun t_293$0 () Loc)
(declare-fun t_294$0 () Loc)
(declare-fun t_295$0 () Loc)
(declare-fun t_296$0 () Loc)
(declare-fun t_297$0 () Loc)
(declare-fun t_298$0 () Loc)
(declare-fun t_299$0 () Loc)
(declare-fun t_300$0 () Loc)
(declare-fun t_301$0 () Loc)
(declare-fun t_302$0 () Loc)
(declare-fun t_303$0 () Loc)
(declare-fun t_304$0 () Loc)
(declare-fun t_305$0 () Loc)
(declare-fun t_306$0 () Loc)
(declare-fun t_307$0 () Loc)
(declare-fun t_308$0 () Loc)
(declare-fun t_309$0 () Loc)
(declare-fun t_310$0 () Loc)
(declare-fun t_311$0 () Loc)
(declare-fun t_312$0 () Loc)
(declare-fun t_313$0 () Loc)
(declare-fun t_314$0 () Loc)
(declare-fun t_315$0 () Loc)
(declare-fun t_316$0 () Loc)
(declare-fun t_317$0 () Loc)
(declare-fun t_318$0 () Loc)
(declare-fun t_319$0 () Loc)
(declare-fun t_320$0 () Loc)
(declare-fun t_321$0 () Loc)
(declare-fun t_322$0 () Loc)
(declare-fun t_323$0 () Loc)
(declare-fun t_324$0 () Loc)
(declare-fun t_325$0 () Loc)
(declare-fun t_326$0 () Loc)
(declare-fun t_327$0 () Loc)
(declare-fun t_328$0 () Loc)
(declare-fun t_329$0 () Loc)
(declare-fun t_330$0 () Loc)
(declare-fun t_331$0 () Loc)
(declare-fun t_332$0 () Loc)
(declare-fun t_333$0 () Loc)
(declare-fun t_334$0 () Loc)
(declare-fun t_335$0 () Loc)
(declare-fun t_336$0 () Loc)
(declare-fun t_337$0 () Loc)
(declare-fun t_338$0 () Loc)
(declare-fun t_339$0 () Loc)
(declare-fun t_340$0 () Loc)
(declare-fun val$0 () Int)
(declare-fun val_1$0 () Int)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_340$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_339$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_338$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_337$0))

(assert (= (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_336$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_335$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_334$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_333$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_332$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_331$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_330$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_329$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_328$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_327$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_326$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_325$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_324$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_323$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_322$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_321$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_320$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_319$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_318$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_317$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_3$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_316$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
  t_315$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_314$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_313$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
  t_312$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_311$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_310$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_309$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_308$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_307$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_306$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_305$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_304$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_303$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_302$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_301$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_300$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_299$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_298$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_297$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_296$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_295$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_294$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_293$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_292$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_291$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_290$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_289$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_288$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_287$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_286$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_285$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_284$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_283$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_282$0))

(assert (=
  (ep$0 next$0 FP_1$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_281$0))

(assert (= (ep$0 next$0 FP_1$0 prev_3$0) t_280$0))

(assert (= (ep$0 next$0 FP_1$0 lst_1$0) t_279$0))

(assert (= (ep$0 next$0 FP_1$0 lst$0) t_278$0))

(assert (= (ep$0 next$0 FP_1$0 curr_3$0) t_277$0))

(assert (= (ep$0 next$0 FP_1$0 curr_2$0) t_276$0))

(assert (= (ep$0 next$0 FP_1$0 null$0) t_275$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_274$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_273$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_272$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_271$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_270$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_269$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_268$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_267$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_266$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_265$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_264$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_263$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_262$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_261$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_260$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_259$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_258$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_257$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_256$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_255$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_254$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_253$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_252$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_251$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_3$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_250$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
  t_249$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_248$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_247$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
  t_246$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_245$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (= curr_3$0 null$0) (not (< (read$1 data$0 curr_3$0) val_1$0))))

(assert (or (not Axiom_13$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_56$0))
                (not (in$1 l2 sk_?X_56$0))))))

(assert (or (and (Btwn$0 next$0 curr_3$0 null$0 null$0) Axiom_14$0)
    (not
         (sorted_set_struct$0 sk_?X_45$0 data$0 next$0 curr_3$0 null$0
           c1_3$0))))

(assert (or (not Axiom_15$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_59$0))
                (not (in$1 l2 sk_?X_59$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 curr_2$0 curr_2$0) Axiom_16$0)
    (not
         (sorted_set_struct$0 sk_?X_58$0 data$0 next$0 lst$0 curr_2$0 c2_2$0))))

(assert (or (not Axiom_17$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_3$0))
                (not (in$1 l1 sk_?X_43$0)) (not (in$1 l2 sk_?X_43$0))))))

(assert (= (read$1 data$0 curr_3$0) val_1$0))

(assert (= FP_2$0
  (union$1 (setminus$1 FP$0 FP_1$0)
    (union$1 (intersection$1 Alloc$0 FP_1$0) (setminus$1 Alloc$0 Alloc$0)))))

(assert (= FP_Caller_1$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c2_2$0 emptyset$0))

(assert (= curr_2$0 lst$0))

(assert (= lst_1$0 lst$0))

(assert (= prev_2$0 null$0))

(assert (Frame$1 FP_1$0 Alloc$0 data$0 data$0))

(assert (= Alloc$0 (union$1 FP_2$0 Alloc$0)))

(assert (= content$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))

(assert (= sk_?X_59$0 (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_59$0 data$0 next$0 lst$0 null$0 content$0))

(assert (= sk_?X_44$0 sk_?X_43$0))

(assert (= sk_?X_46$0 sk_?X_45$0))

(assert (= sk_?X_48$0 sk_?X_46$0))

(assert (= sk_?X_50$0 sk_?X_48$0))

(assert (= sk_?X_51$0 sk_?X_53$0))

(assert (= sk_?X_53$0 sk_?X_55$0))

(assert (= sk_?X_55$0 sk_?X_56$0))

(assert (= sk_?X_57$0 sk_?X_58$0))

(assert (= FP$0 (union$1 FP_1$0 FP$0)))

(assert (not (= curr_3$0 null$0)))

(assert (not (in$1 null$0 Alloc$0)))

(assert (not (in$1 prev_3$0 FP_3$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_3$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_3$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 curr_2$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
                 (not (= l1 curr_2$0)))
            (and (or (= l1 curr_2$0) (not (Btwn$0 next$0 lst$0 l1 curr_2$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
              (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (and (Btwn$0 next$0 curr_2$0 null$0 null$0) Axiom_13$0)
    (not
         (sorted_set_struct$0 sk_?X_56$0 data$0 next$0 curr_2$0 null$0
           c1_2$0))))

(assert (or (not Axiom_14$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_45$0))
                (not (in$1 l2 sk_?X_45$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 null$0 null$0) Axiom_15$0)
    (not
         (sorted_set_struct$0 sk_?X_59$0 data$0 next$0 lst$0 null$0
           content$0))))

(assert (or (not Axiom_16$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_2$0))
                (not (in$1 l1 sk_?X_58$0)) (not (in$1 l2 sk_?X_58$0))))))

(assert (or (and (Btwn$0 next$0 lst_1$0 curr_3$0 curr_3$0) Axiom_17$0)
    (not
         (sorted_set_struct$0 sk_?X_43$0 data$0 next$0 lst_1$0 curr_3$0
           c2_3$0))))

(assert (= Alloc_1$0 (setminus$1 Alloc$0 (setenum$1 n_2$0))))

(assert (= FP_3$0 (setminus$1 FP_2$0 (setenum$1 n_2$0))))

(assert (= c1_2$0 content$0))

(assert (= content_1$0 content$0))

(assert (= curr_4$0 (read$0 next$0 curr_3$0)))

(assert (= n_2$0 curr_3$0))

(assert (= val_1$0 val$0))

(assert (Frame$0 FP_1$0 Alloc$0 next$0 next$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_59$0 FP$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (= sk_?X_43$0 (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0)))

(assert (= sk_?X_45$0 (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0)))

(assert (= sk_?X_47$0 (union$1 sk_?X_44$0 sk_?X_46$0)))

(assert (= sk_?X_49$0 sk_?X_47$0))

(assert (or
    (and (= (read$0 next$0 prev_3$0) curr_3$0) (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_44$0 sk_?X_46$0))
         (= c1_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
         (= c2_3$0 (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
         (= content_1$0 (union$0 c1_3$0 c2_3$0))
         (= sk_?X_49$0
           (union$1 (intersection$1 Alloc$0 FP_1$0)
             (setminus$1 Alloc$0 Alloc$0)))
         (> val_1$0 (read$1 data$0 prev_3$0))
         (Btwn$0 next$0 lst_1$0 prev_3$0 curr_3$0)
         (sorted_set_struct$0 sk_?X_43$0 data$0 next$0 lst_1$0 curr_3$0
           c2_3$0)
         (sorted_set_struct$0 sk_?X_45$0 data$0 next$0 curr_3$0 null$0
           c1_3$0)
         (or (= curr_3$0 null$0) (= prev_3$0 null$0)
             (< (read$1 data$0 prev_3$0) (read$1 data$0 curr_3$0)))
         (not (= prev_3$0 curr_3$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_3$0 (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
         (= c2_3$0 emptyset$0) (= content_1$0 (union$0 c1_3$0 c2_3$0))
         (= curr_3$0 lst_1$0) (= prev_3$0 null$0)
         (= sk_?X_50$0
           (union$1 (intersection$1 Alloc$0 FP_1$0)
             (setminus$1 Alloc$0 Alloc$0)))
         (sorted_set_struct$0 sk_?X_45$0 data$0 next$0 curr_3$0 null$0
           c1_3$0)
         (or (= curr_3$0 null$0) (= prev_3$0 null$0)
             (< (read$1 data$0 prev_3$0) (read$1 data$0 curr_3$0))))))

(assert (= sk_?X_52$0 sk_?X_54$0))

(assert (= sk_?X_54$0 (union$1 sk_?X_57$0 sk_?X_55$0)))

(assert (= sk_?X_56$0 (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))

(assert (= sk_?X_58$0 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))

(assert (or
    (and (= (read$0 next$0 prev_2$0) curr_2$0) (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_57$0 sk_?X_55$0))
         (= c1_2$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (= c2_2$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
         (= content$0 (union$0 c1_2$0 c2_2$0)) (= sk_?X_52$0 FP_1$0)
         (> val$0 (read$1 data$0 prev_2$0))
         (Btwn$0 next$0 lst$0 prev_2$0 curr_2$0)
         (sorted_set_struct$0 sk_?X_56$0 data$0 next$0 curr_2$0 null$0
           c1_2$0)
         (sorted_set_struct$0 sk_?X_58$0 data$0 next$0 lst$0 curr_2$0 c2_2$0)
         (or (= curr_2$0 null$0) (= prev_2$0 null$0)
             (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0)))
         (not (= prev_2$0 curr_2$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_2$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (= c2_2$0 emptyset$0) (= content$0 (union$0 c1_2$0 c2_2$0))
         (= curr_2$0 lst$0) (= prev_2$0 null$0) (= sk_?X_51$0 FP_1$0)
         (sorted_set_struct$0 sk_?X_56$0 data$0 next$0 curr_2$0 null$0
           c1_2$0)
         (or (= curr_2$0 null$0) (= prev_2$0 null$0)
             (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0))))))

(assert (not (= prev_3$0 null$0)))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_2$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_1$0 l1 curr_3$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0))
                 (not (= l1 curr_3$0)))
            (and
                 (or (= l1 curr_3$0)
                     (not (Btwn$0 next$0 lst_1$0 l1 curr_3$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_1$0 curr_3$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_1$0 curr_3$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_3$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_3$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
