(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 (S5 S6) Int)
(declare-fun f6 () S5)
(declare-fun f7 (S7 S2) S6)
(declare-fun f8 () S7)
(declare-fun f9 (S8 S9) S6)
(declare-fun f10 () S8)
(declare-fun f11 () S9)
(declare-fun f12 () S4)
(declare-fun f13 () S4)
(declare-fun f14 () S3)
(declare-fun f15 (S6) S3)
(declare-fun f16 (S4) S3)
(declare-fun f17 () S3)
(declare-fun f18 () S3)
(declare-fun f19 (S10 S3) S11)
(declare-fun f20 () S10)
(declare-fun f21 () S11)
(declare-fun f22 (S9 S2) S1)
(declare-fun f23 () S9)
(declare-fun f24 (S4 S12) S1)
(declare-fun f25 () S4)
(declare-fun f26 (S13 S3) S1)
(declare-fun f27 () S13)
(declare-fun f28 (S11 S4) S1)
(declare-fun f29 () S11)
(declare-fun f30 (S15 S14) S1)
(declare-fun f31 () S15)
(declare-fun f32 (S12 S4) S1)
(declare-fun f33 (S16 S17) S12)
(declare-fun f34 (S18 S17) S16)
(declare-fun f35 () S18)
(declare-fun f36 () S17)
(declare-fun f37 () S17)
(declare-fun f38 (S14 S3) S4)
(declare-fun f39 () S14)
(declare-fun f40 (S4 S11) S1)
(declare-fun f41 (S14) S1)
(declare-fun f42 (S14) S1)
(declare-fun f43 (S7 S9) S1)
(declare-fun f44 (S3 S13) S1)
(declare-fun f45 () S13)
(declare-fun f46 () S4)
(declare-fun f47 () S11)
(declare-fun f48 () S13)
(declare-fun f49 () S15)
(declare-fun f50 (S14 S15) S1)
(declare-fun f51 (S2 S9) S1)
(declare-fun f52 () S1)
(declare-fun f53 (S13 S10) S15)
(declare-fun f54 (S9) S9)
(declare-fun f55 (S4) S4)
(declare-fun f56 (S11) S11)
(declare-fun f57 (S13) S13)
(declare-fun f58 (S15) S15)
(declare-fun f59 (S19 Int) S6)
(declare-fun f60 () S19)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (ite (< (f5 f6 (f7 f8 ?v0)) (f5 f6 (f9 f10 f11))) f12 f13))))
(assert (forall ((?v0 S2)) (= (f3 f14 ?v0) (ite (< (f5 f6 (f7 f8 ?v0)) 0) f12 f13))))
(assert (forall ((?v0 S6) (?v1 S2)) (= (f3 (f15 ?v0) ?v1) (ite (< (f5 f6 (f7 f8 ?v1)) (f5 f6 ?v0)) f12 f13))))
(assert (forall ((?v0 S4) (?v1 S2)) (= (f3 (f16 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 f17 ?v0) f13)))
(assert (forall ((?v0 S2)) (= (f3 f18 ?v0) f12)))
(assert (forall ((?v0 S3)) (= (f19 f20 ?v0) f21)))
(assert (forall ((?v0 S2)) (= (= (f22 f23 ?v0) f1) true)))
(assert (forall ((?v0 S12)) (= (= (f24 f25 ?v0) f1) true)))
(assert (forall ((?v0 S3)) (= (= (f26 f27 ?v0) f1) true)))
(assert (forall ((?v0 S4)) (= (= (f28 f29 ?v0) f1) true)))
(assert (forall ((?v0 S14)) (= (= (f30 f31 ?v0) f1) true)))
(assert (not (= (f32 (f33 (f34 f35 f36) f37) (f38 f39 f4)) f1)))
(assert (forall ((?v0 S2)) (= (ite (< (f5 f6 (f7 f8 ?v0)) (f5 f6 (f9 f10 f11))) f12 f13) f12)))
(assert (= (f40 (f38 f39 f18) f21) f1))
(assert (= (f41 f39) f1))
(assert (= (f32 (f33 (f34 f35 f36) f37) f12) f1))
(assert (= (f40 f12 f21) f1))
(assert (= (f41 f39) f1))
(assert (= (f40 f12 f21) f1))
(assert (= (f42 f39) f1))
(assert (= (f40 f13 f21) f1))
(assert (= (f40 (f38 f39 f18) f21) f1))
(assert (not (= f36 f37)))
(assert (= (f32 (f33 (f34 f35 f36) f37) f12) f1))
(assert (forall ((?v0 S2)) (= (ite (< (f5 f6 (f7 f8 ?v0)) (f5 f6 (f9 f10 f11))) f12 f13) f12)))
(assert (= (f32 (f33 (f34 f35 f37) f36) f13) f1))
(assert (= (f40 (f38 f39 f17) f21) f1))
(assert (not (= (f32 (f33 (f34 f35 f37) f36) f12) f1)))
(assert (not (= (f32 (f33 (f34 f35 f36) f37) f13) f1)))
(assert (forall ((?v0 S6)) (= (f40 (f38 f39 (f15 ?v0)) f21) f1)))
(assert (not (= (f32 (f33 (f34 f35 f36) f37) (f38 f39 f14)) f1)))
(assert (=> (forall ((?v0 S4)) (=> (= (f32 (f33 (f34 f35 f36) f37) ?v0) f1) (=> (= (f40 ?v0 f21) f1) false))) false))
(assert (=> (forall ((?v0 S4)) (=> (= (f32 (f33 (f34 f35 f37) f36) ?v0) f1) (=> (= (f40 ?v0 f21) f1) false))) false))
(assert (= (f43 f8 f11) f1))
(assert (forall ((?v0 S6)) (= (f44 (f15 ?v0) f45) f1)))
(assert (forall ((?v0 S2)) (= (f22 f11 ?v0) f1)))
(assert (forall ((?v0 S12)) (= (f24 f46 ?v0) f1)))
(assert (forall ((?v0 S4)) (= (f28 f47 ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f26 f48 ?v0) f1)))
(assert (forall ((?v0 S14)) (= (f30 f49 ?v0) f1)))
(assert (forall ((?v0 S14)) (= (f50 ?v0 f49) f1)))
(assert (forall ((?v0 S3)) (= (f44 ?v0 f48) f1)))
(assert (forall ((?v0 S4)) (= (f40 ?v0 f47) f1)))
(assert (forall ((?v0 S12)) (= (f32 ?v0 f46) f1)))
(assert (forall ((?v0 S2)) (= (f51 ?v0 f11) f1)))
(assert (forall ((?v0 S14)) (= (= (f50 ?v0 f49) f1) true)))
(assert (forall ((?v0 S3)) (= (= (f44 ?v0 f48) f1) true)))
(assert (forall ((?v0 S4)) (= (= (f40 ?v0 f47) f1) true)))
(assert (forall ((?v0 S12)) (= (= (f32 ?v0 f46) f1) true)))
(assert (forall ((?v0 S2)) (= (= (f51 ?v0 f11) f1) true)))
(assert (forall ((?v0 S17) (?v1 S17) (?v2 S17) (?v3 S17) (?v4 S3) (?v5 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v3)) (=> (not (= ?v0 ?v3)) (=> (not (= ?v1 ?v2)) (=> (= (f44 ?v4 f45) f1) (=> (= (f44 ?v5 f45) f1) (=> (forall ((?v6 S2)) (= (= (f32 (f33 (f34 f35 ?v0) ?v1) (f3 ?v4 ?v6)) f1) (= (f32 (f33 (f34 f35 ?v2) ?v3) (f3 ?v5 ?v6)) f1))) (= (= (f32 (f33 (f34 f35 ?v0) ?v1) (f38 f39 ?v4)) f1) (= (f32 (f33 (f34 f35 ?v2) ?v3) (f38 f39 ?v5)) f1)))))))))))
(assert (forall ((?v0 S17) (?v1 S17) (?v2 S17) (?v3 S17) (?v4 S3) (?v5 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v3)) (=> (not (= ?v0 ?v3)) (=> (not (= ?v1 ?v2)) (=> (= (f44 ?v4 f45) f1) (=> (= (f44 ?v5 f45) f1) (=> (forall ((?v6 S2)) (= (= (f32 (f33 (f34 f35 ?v0) ?v1) (f3 ?v4 ?v6)) f1) (= (f32 (f33 (f34 f35 ?v2) ?v3) (f3 ?v5 ?v6)) f1))) (=> (= (f32 (f33 (f34 f35 ?v0) ?v1) (f38 f39 ?v4)) f1) (= (f32 (f33 (f34 f35 ?v2) ?v3) (f38 f39 ?v5)) f1)))))))))))
(assert (forall ((?v0 S17) (?v1 S17) (?v2 S17) (?v3 S3) (?v4 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v1 ?v2)) (=> (not (= ?v0 ?v2)) (=> (= (f44 ?v3 f45) f1) (=> (= (f44 ?v4 f45) f1) (=> (forall ((?v5 S2)) (= (= (f32 (f33 (f34 f35 ?v0) ?v1) (f3 ?v3 ?v5)) f1) (= (f32 (f33 (f34 f35 ?v1) ?v2) (f3 ?v4 ?v5)) f1))) (= (= (f32 (f33 (f34 f35 ?v0) ?v1) (f38 f39 ?v3)) f1) (= (f32 (f33 (f34 f35 ?v1) ?v2) (f38 f39 ?v4)) f1))))))))))
(assert (forall ((?v0 S17) (?v1 S17) (?v2 S17) (?v3 S17) (?v4 S3) (?v5 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v3)) (=> (= (f44 ?v4 f45) f1) (=> (= (f44 ?v5 f45) f1) (=> (forall ((?v6 S2)) (= (= (f32 (f33 (f34 f35 ?v0) ?v1) (f3 ?v4 ?v6)) f1) (= (f32 (f33 (f34 f35 ?v2) ?v3) (f3 ?v5 ?v6)) f1))) (= (= (f32 (f33 (f34 f35 ?v0) ?v1) (f38 f39 ?v4)) f1) (= (f32 (f33 (f34 f35 ?v2) ?v3) (f38 f39 ?v5)) f1)))))))))
(assert (forall ((?v0 S17) (?v1 S17) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f44 ?v2 f45) f1) (=> (= (f44 ?v3 f45) f1) (=> (forall ((?v4 S2)) (= (= (f32 (f33 (f34 f35 ?v0) ?v1) (f3 ?v2 ?v4)) f1) (= (f32 (f33 (f34 f35 ?v1) ?v0) (f3 ?v3 ?v4)) f1))) (= (= (f32 (f33 (f34 f35 ?v0) ?v1) (f38 f39 ?v2)) f1) (= (f32 (f33 (f34 f35 ?v1) ?v0) (f38 f39 ?v3)) f1))))))))
(assert (forall ((?v0 S4) (?v1 S17) (?v2 S17)) (=> (= (f40 ?v0 f21) f1) (=> (not (= ?v1 ?v2)) (= (not (= (f32 (f33 (f34 f35 ?v1) ?v2) ?v0) f1)) (= (f32 (f33 (f34 f35 ?v2) ?v1) ?v0) f1))))))
(assert (forall ((?v0 S4) (?v1 S17) (?v2 S17)) (=> (= (f40 ?v0 f21) f1) (=> (= (f32 (f33 (f34 f35 ?v1) ?v2) ?v0) f1) (=> (= (f32 (f33 (f34 f35 ?v2) ?v1) ?v0) f1) false)))))
(assert (forall ((?v0 S2)) (= (= (f22 f11 ?v0) f1) (= f52 f1))))
(assert (forall ((?v0 S12)) (= (= (f24 f46 ?v0) f1) (= f52 f1))))
(assert (forall ((?v0 S4)) (= (= (f28 f47 ?v0) f1) (= f52 f1))))
(assert (forall ((?v0 S3)) (= (= (f26 f48 ?v0) f1) (= f52 f1))))
(assert (forall ((?v0 S14)) (= (= (f30 f49 ?v0) f1) (= f52 f1))))
(assert (= (f50 f39 (f53 f45 f20)) f1))
(assert (forall ((?v0 S4)) (=> (= (f40 ?v0 f21) f1) (= (f44 (f16 ?v0) f45) f1))))
(assert (= f11 (f54 f23)))
(assert (= f46 (f55 f25)))
(assert (= f47 (f56 f29)))
(assert (= f48 (f57 f27)))
(assert (= f49 (f58 f31)))
(assert (forall ((?v0 S6)) (= (f59 f60 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f59 f60 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f59 f60 ?v0)) 0))))
(check-sat)
(exit)
