(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 (S5 S6) Int)
(declare-fun f6 () S5)
(declare-fun f7 (S7 S2) S6)
(declare-fun f8 () S7)
(declare-fun f9 () S6)
(declare-fun f10 () S4)
(declare-fun f11 () S4)
(declare-fun f12 () S3)
(declare-fun f13 (S8 S9) S4)
(declare-fun f14 (S4) S8)
(declare-fun f15 () S3)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S9) S8)
(declare-fun f18 (S4) S10)
(declare-fun f19 () S9)
(declare-fun f20 (S4) S8)
(declare-fun f21 (S6) S3)
(declare-fun f22 (S6) S3)
(declare-fun f23 (S11 S4) S1)
(declare-fun f24 (S9 S9) S11)
(declare-fun f25 (S12 S3) S4)
(declare-fun f26 () S12)
(declare-fun f27 () S9)
(declare-fun f28 () S9)
(declare-fun f29 (S3 S13) S1)
(declare-fun f30 () S13)
(declare-fun f31 () S9)
(declare-fun f32 (S12) S1)
(declare-fun f33 (S12) S1)
(declare-fun f34 (S4 S14) S1)
(declare-fun f35 () S14)
(declare-fun f36 (S15 S6) S2)
(declare-fun f37 (S16 S7) S15)
(declare-fun f38 (S17 S18) S16)
(declare-fun f39 () S17)
(declare-fun f40 () S18)
(declare-fun f41 (S19 S18) S6)
(declare-fun f42 () S19)
(declare-fun f43 (S20 Int) S6)
(declare-fun f44 () S20)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (ite (< (f5 f6 (f7 f8 ?v0)) (+ (f5 f6 f9) 1)) f10 f11))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f3 f15 ?v0))) (= (f3 f12 ?v0) (ite (< (f5 f6 ?v_0) (f5 f6 f9)) (f13 (f14 ?v_1) f16) (ite (= ?v_0 f9) (f13 (f17 (f18 ?v_1) f19) f16) (f13 (f20 ?v_1) f16)))))))
(assert (forall ((?v0 S6) (?v1 S2)) (= (f3 (f21 ?v0) ?v1) (ite (< (f5 f6 (f7 f8 ?v1)) (+ (f5 f6 ?v0) 1)) f10 f11))))
(assert (forall ((?v0 S6) (?v1 S2)) (= (f3 (f22 ?v0) ?v1) (ite (< (f5 f6 (f7 f8 ?v1)) (f5 f6 ?v0)) f10 f11))))
(assert (not (= (= (f23 (f24 f19 f16) (f25 f26 f12)) f1) (= (f23 (f24 f27 f28) (f25 f26 f4)) f1))))
(assert (forall ((?v0 S2)) (let ((?v_3 (f5 f6 f9)) (?v_0 (f7 f8 ?v0))) (let ((?v_2 (f5 f6 ?v_0)) (?v_1 (f3 f15 ?v0))) (= (= (f23 (f24 f19 f16) (ite (< ?v_2 ?v_3) (f13 (f14 ?v_1) f16) (ite (= ?v_0 f9) (f13 (f17 (f18 ?v_1) f19) f16) (f13 (f20 ?v_1) f16)))) f1) (= (f23 (f24 f27 f28) (ite (< ?v_2 (+ ?v_3 1)) f10 f11)) f1))))))
(assert (=> (not (= f19 f16)) (=> (not (= f27 f28)) (=> (= (f29 f12 f30) f1) (=> (= (f29 f4 f30) f1) (=> (forall ((?v0 S2)) (let ((?v_3 (f5 f6 f9)) (?v_0 (f7 f8 ?v0))) (let ((?v_2 (f5 f6 ?v_0)) (?v_1 (f3 f15 ?v0))) (= (= (f23 (f24 f19 f16) (ite (< ?v_2 ?v_3) (f13 (f14 ?v_1) f16) (ite (= ?v_0 f9) (f13 (f17 (f18 ?v_1) f19) f16) (f13 (f20 ?v_1) f16)))) f1) (= (f23 (f24 f27 f28) (ite (< ?v_2 (+ ?v_3 1)) f10 f11)) f1))))) (= (= (f23 (f24 f19 f16) (f25 f26 f12)) f1) (= (f23 (f24 f27 f28) (f25 f26 f4)) f1))))))))
(assert (not (= f27 f28)))
(assert (distinct f19 f31 f16))
(assert (= (f29 f12 f30) f1))
(assert (forall ((?v0 S6)) (= (f29 (f22 ?v0) f30) f1)))
(assert (= (f29 f15 f30) f1))
(assert (not (= f19 f31)))
(assert (= (f32 f26) f1))
(assert (= (f33 f26) f1))
(assert (not (= f27 f28)))
(assert (distinct f19 f31 f16))
(assert (forall ((?v0 S6)) (= (f29 (f22 ?v0) f30) f1)))
(assert (= (f34 f10 f35) f1))
(assert (= (f34 f11 f35) f1))
(assert (= (f23 (f24 f27 f28) f10) f1))
(assert (= (f23 (f24 f28 f27) f11) f1))
(assert (= (f29 f12 f30) f1))
(assert (not (= (f23 (f24 f27 f28) f11) f1)))
(assert (not (= (f23 (f24 f28 f27) f10) f1)))
(assert (forall ((?v0 S6)) (=> (<= (f5 f6 ?v0) (f5 f6 f9)) (= (f23 (f24 f28 f27) (f25 f26 (f22 ?v0))) f1))))
(assert (= (f23 (f24 f27 f28) (f25 f26 f4)) f1))
(assert (forall ((?v0 S2)) (let ((?v_3 (f5 f6 f9)) (?v_0 (f7 f8 ?v0))) (let ((?v_2 (f5 f6 ?v_0)) (?v_1 (f3 f15 ?v0))) (= (= (f23 (f24 f19 f16) (ite (< ?v_2 ?v_3) (f13 (f14 ?v_1) f16) (ite (= ?v_0 f9) (f13 (f17 (f18 ?v_1) f19) f16) (f13 (f20 ?v_1) f16)))) f1) (= (f23 (f24 f27 f28) (ite (< ?v_2 (+ ?v_3 1)) f10 f11)) f1))))))
(assert (=> (not (= f19 f16)) (=> (not (= f27 f28)) (=> (= (f29 f12 f30) f1) (=> (= (f29 f4 f30) f1) (=> (forall ((?v0 S2)) (let ((?v_3 (f5 f6 f9)) (?v_0 (f7 f8 ?v0))) (let ((?v_2 (f5 f6 ?v_0)) (?v_1 (f3 f15 ?v0))) (= (= (f23 (f24 f19 f16) (ite (< ?v_2 ?v_3) (f13 (f14 ?v_1) f16) (ite (= ?v_0 f9) (f13 (f17 (f18 ?v_1) f19) f16) (f13 (f20 ?v_1) f16)))) f1) (= (f23 (f24 f27 f28) (ite (< ?v_2 (+ ?v_3 1)) f10 f11)) f1))))) (= (= (f23 (f24 f19 f16) (f25 f26 f12)) f1) (= (f23 (f24 f27 f28) (f25 f26 f4)) f1))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9) (?v4 S3) (?v5 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v3)) (=> (not (= ?v0 ?v3)) (=> (not (= ?v1 ?v2)) (=> (= (f29 ?v4 f30) f1) (=> (= (f29 ?v5 f30) f1) (=> (forall ((?v6 S2)) (= (= (f23 (f24 ?v0 ?v1) (f3 ?v4 ?v6)) f1) (= (f23 (f24 ?v2 ?v3) (f3 ?v5 ?v6)) f1))) (= (= (f23 (f24 ?v0 ?v1) (f25 f26 ?v4)) f1) (= (f23 (f24 ?v2 ?v3) (f25 f26 ?v5)) f1)))))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9) (?v4 S3) (?v5 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v3)) (=> (not (= ?v0 ?v3)) (=> (not (= ?v1 ?v2)) (=> (= (f29 ?v4 f30) f1) (=> (= (f29 ?v5 f30) f1) (=> (forall ((?v6 S2)) (= (= (f23 (f24 ?v0 ?v1) (f3 ?v4 ?v6)) f1) (= (f23 (f24 ?v2 ?v3) (f3 ?v5 ?v6)) f1))) (=> (= (f23 (f24 ?v0 ?v1) (f25 f26 ?v4)) f1) (= (f23 (f24 ?v2 ?v3) (f25 f26 ?v5)) f1)))))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S3) (?v4 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v1 ?v2)) (=> (not (= ?v0 ?v2)) (=> (= (f29 ?v3 f30) f1) (=> (= (f29 ?v4 f30) f1) (=> (forall ((?v5 S2)) (= (= (f23 (f24 ?v0 ?v1) (f3 ?v3 ?v5)) f1) (= (f23 (f24 ?v1 ?v2) (f3 ?v4 ?v5)) f1))) (= (= (f23 (f24 ?v0 ?v1) (f25 f26 ?v3)) f1) (= (f23 (f24 ?v1 ?v2) (f25 f26 ?v4)) f1))))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9) (?v4 S3) (?v5 S3)) (=> (not (= ?v0 ?v1)) (=> (not (= ?v2 ?v3)) (=> (= (f29 ?v4 f30) f1) (=> (= (f29 ?v5 f30) f1) (=> (forall ((?v6 S2)) (= (= (f23 (f24 ?v0 ?v1) (f3 ?v4 ?v6)) f1) (= (f23 (f24 ?v2 ?v3) (f3 ?v5 ?v6)) f1))) (= (= (f23 (f24 ?v0 ?v1) (f25 f26 ?v4)) f1) (= (f23 (f24 ?v2 ?v3) (f25 f26 ?v5)) f1)))))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f29 ?v2 f30) f1) (=> (= (f29 ?v3 f30) f1) (=> (forall ((?v4 S2)) (= (= (f23 (f24 ?v0 ?v1) (f3 ?v2 ?v4)) f1) (= (f23 (f24 ?v1 ?v0) (f3 ?v3 ?v4)) f1))) (= (= (f23 (f24 ?v0 ?v1) (f25 f26 ?v2)) f1) (= (f23 (f24 ?v1 ?v0) (f25 f26 ?v3)) f1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f24 f19 f31)) (?v_1 (f3 f15 ?v0)) (?v_2 (f7 f8 ?v0))) (= (= (f23 ?v_0 ?v_1) f1) (= (f23 ?v_0 (ite (< (f5 f6 ?v_2) (f5 f6 f9)) (f13 (f14 ?v_1) f16) (ite (= ?v_2 f9) (f13 (f17 (f18 ?v_1) f19) f16) (f13 (f20 ?v_1) f16)))) f1)))))
(assert (let ((?v_0 (f24 f19 f31))) (= (= (f23 ?v_0 (f25 f26 f15)) f1) (= (f23 ?v_0 (f25 f26 f12)) f1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S4) (?v3 S9)) (let ((?v_0 (f24 ?v0 ?v1))) (= (= (f23 ?v_0 (f13 (f20 ?v2) ?v3)) f1) (and (not (= ?v1 ?v3)) (ite (= ?v0 ?v3) (not (= ?v0 ?v1)) (= (f23 ?v_0 ?v2) f1)))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S4) (?v3 S9)) (let ((?v_0 (f24 ?v0 ?v1))) (= (= (f23 ?v_0 (f13 (f14 ?v2) ?v3)) f1) (and (not (= ?v0 ?v3)) (ite (= ?v1 ?v3) (not (= ?v0 ?v1)) (= (f23 ?v_0 ?v2) f1)))))))
(assert (=> (forall ((?v0 S4)) (=> (= (f23 (f24 f27 f28) ?v0) f1) (=> (= (f34 ?v0 f35) f1) false))) false))
(assert (=> (forall ((?v0 S4)) (=> (= (f23 (f24 f28 f27) ?v0) f1) (=> (= (f34 ?v0 f35) f1) false))) false))
(assert (= (f23 (f24 f19 f31) (f3 f15 (f36 (f37 (f38 f39 f40) f8) f9))) f1))
(assert (exists ((?v0 S6)) (and (< (f5 f6 ?v0) (f5 f6 (f41 f42 f40))) (and (forall ((?v1 S6)) (=> (<= (f5 f6 ?v1) (f5 f6 ?v0)) (= (f23 (f24 f28 f27) (f25 f26 (f22 ?v1))) f1))) (= (f23 (f24 f27 f28) (f25 f26 (f21 ?v0))) f1)))))
(assert (=> (forall ((?v0 S6)) (=> (< (f5 f6 ?v0) (f5 f6 (f41 f42 f40))) (=> (forall ((?v1 S6)) (=> (<= (f5 f6 ?v1) (f5 f6 ?v0)) (= (f23 (f24 f28 f27) (f25 f26 (f22 ?v1))) f1))) (=> (= (f23 (f24 f27 f28) (f25 f26 (f21 ?v0))) f1) false)))) false))
(assert (forall ((?v0 S6)) (= (f43 f44 (f5 f6 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f43 f44 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f5 f6 (f43 f44 ?v0)) 0))))
(check-sat)
(exit)
