(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 S3) S3)
(declare-fun f5 (S2) S4)
(declare-fun f6 (S2 S3) S1)
(declare-fun f7 (S2) S4)
(declare-fun f8 () S3)
(declare-fun f9 (S5 S5) S5)
(declare-fun f10 (S6 S2) S5)
(declare-fun f11 () S6)
(declare-fun f12 () S2)
(declare-fun f13 (S6 S3) S5)
(declare-fun f14 (S7 S2) S3)
(declare-fun f15 (S2) S7)
(declare-fun f16 () S2)
(declare-fun f17 (S3) S4)
(declare-fun f18 (S2) S4)
(declare-fun f19 () S3)
(declare-fun f20 (S8 S2) Int)
(declare-fun f21 () S8)
(declare-fun f22 (S1 S1) S1)
(declare-fun f23 (S3) S3)
(declare-fun f24 (S9 Int) S2)
(declare-fun f25 () S9)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f6 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f7 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f8 ?v0) f1) false)))
(assert (let ((?v_0 (f14 (f15 f12) f16))) (not (= (f9 (f10 f11 f12) (f13 f11 ?v_0)) (f13 f11 (f4 (f17 (f4 (f18 f12) f19)) ?v_0))))))
(assert (< (f20 f21 f12) (f20 f21 f16)))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f18 ?v0))) (= (f4 ?v_0 ?v1) (f4 (f17 (f4 ?v_0 f19)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (=> (= (f6 ?v0 (f4 (f17 ?v1) ?v2)) f1) (=> (=> (= (f6 ?v0 ?v1) f1) false) (=> (=> (= (f6 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (=> (= (f3 (f4 (f17 ?v0) ?v1) ?v2) f1) (=> (=> (= (f3 ?v0 ?v2) f1) false) (=> (=> (= (f3 ?v1 ?v2) f1) false) false)))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (=> (=> (not (= (f3 ?v0 ?v1) f1)) (= (f3 ?v2 ?v1) f1)) (= (f3 (f4 (f17 ?v2) ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (=> (=> (not (= (f6 ?v0 ?v1) f1)) (= (f6 ?v0 ?v2) f1)) (= (f6 ?v0 (f4 (f17 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (=> (= (f6 ?v0 (f4 (f18 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (=> (not (= (f6 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f6 ?v0 (f4 (f18 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2)) (=> (= (f6 ?v0 f19) f1) false)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f17 ?v0) ?v1) ?v2) f1) (= (f22 (f3 ?v0 ?v2) (f3 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f17 ?v0) ?v1) ?v2) f1) (= (f22 (f3 ?v0 ?v2) (f3 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_1 (f17 ?v0)) (?v_0 (f18 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 ?v0))) (= (f4 (f17 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f17 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= ?v0 f19) (not (= (f6 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S3)) (= (= (f23 ?v0) f19) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2)) (= (= (f6 ?v0 f19) f1) false)))
(assert (forall ((?v0 S3)) (= (= f19 (f23 ?v0)) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (=> (= (f6 ?v1 f19) f1) (= (f3 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (and (= (f6 ?v1 f19) f1) (= (f3 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (= (f6 ?v1 ?v0) f1)) (not (= ?v0 f19)))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (not (= (f6 ?v1 ?v0) f1))) (= ?v0 f19))))
(assert (= f19 (f23 f8)))
(assert (forall ((?v0 S2)) (= (= (f3 f19 ?v0) f1) (= (f6 ?v0 f19) f1))))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f6 ?v0 ?v1) f1) (= (f4 (f18 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (= (f6 ?v0 ?v1) f1) (= (f6 ?v0 (f4 (f18 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f18 ?v0))) (=> (not (= (f6 ?v0 ?v1) f1)) (=> (not (= (f6 ?v0 ?v2) f1)) (= (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f18 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (= (= (f6 ?v0 (f4 (f18 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f6 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (let ((?v_1 (f18 ?v0)) (?v_0 (f18 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f18 ?v0))) (let ((?v_1 (f4 ?v_0 ?v1))) (= (f4 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f4 (f18 ?v0) (f23 ?v1)) (f23 (f4 (f7 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f4 (f18 ?v0) ?v1) (f23 (f4 (f5 ?v0) ?v1)))))
(assert (forall ((?v0 S2)) (= (f24 f25 (f20 f21 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f20 f21 (f24 f25 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f20 f21 (f24 f25 ?v0)) 0))))
(check-sat)
(exit)
