(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 () S3)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S2) Int)
(declare-fun f8 () S5)
(declare-fun f9 (S2 S6) S1)
(declare-fun f10 (S3 S6) S1)
(declare-fun f11 () S6)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 f6 (+ (* 2 (f7 f8 ?v0)) 1)))))
(assert (forall ((?v0 S6) (?v1 S3)) (=> (forall ((?v2 S2) (?v3 S2)) (=> (= (f9 ?v2 ?v0) f1) (=> (= (f9 ?v3 ?v0) f1) (=> (= (f3 ?v1 ?v2) (f3 ?v1 ?v3)) (= ?v2 ?v3))))) (= (f10 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (f5 f6 (* 1 (f7 f8 ?v0))) ?v0)))
(assert (not (= (f10 f4 f11) f1)))
(assert (forall ((?v0 S2)) (= (f5 f6 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
