(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S9 S2) S10)
(declare-fun f14 (S11 S10) S9)
(declare-fun f15 () S11)
(declare-fun f16 () S9)
(declare-fun f17 () S2)
(declare-fun f18 () S2)
(declare-fun f19 () S10)
(declare-fun f20 () S4)
(declare-fun f21 () S2)
(declare-fun f22 (S12 Int) S8)
(declare-fun f23 () S12)
(declare-fun f24 () S6)
(declare-fun f25 () S4)
(declare-fun f26 (S13 S10) S10)
(declare-fun f27 (S14 S10) S13)
(declare-fun f28 () S14)
(declare-fun f29 (S15 S4) S4)
(declare-fun f30 (S16 S2) S15)
(declare-fun f31 () S16)
(declare-fun f32 (S17 S14) S11)
(declare-fun f33 (S18 S10) S17)
(declare-fun f34 () S18)
(declare-fun f35 (S19 S7) S12)
(declare-fun f36 (S20 Int) S19)
(declare-fun f37 () S20)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (not (not (= (f13 (f14 f15 (f13 f16 f17)) f18) f19))))
(assert (< 0 (f11 f12 f18)))
(assert (< (f11 f12 f18) (f11 f12 f17)))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 (f13 f16 ?v0)) ?v0) f19)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f20 f21) ?v0) f21)))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 f19) ?v0) f19)))
(assert (forall ((?v0 S2)) (= (f11 (f22 f23 1) ?v0) 1)))
(assert (= (f3 (f4 f20 f21) (f6 f7 2)) f21))
(assert (= (f13 (f14 f15 f19) (f6 f7 2)) f19))
(assert (= (f11 (f22 f23 1) (f6 f7 2)) 1))
(assert (forall ((?v0 S2)) (= (f3 (f4 f20 ?v0) (f6 f7 0)) f21)))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 0)) f19)))
(assert (forall ((?v0 Int)) (= (f11 (f22 f23 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f20 ?v0) (f6 f7 0)) f21)))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 0)) f19)))
(assert (forall ((?v0 Int)) (= (f11 (f22 f23 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f24 (f11 (f22 f23 ?v0) ?v1)) (f11 (f22 f23 (f8 f24 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f22 f23 ?v0) (f6 f7 2)))) (= (f8 f24 ?v_0) ?v_0))))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f20 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f22 f23 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f20 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f22 f23 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f22 f23 (f8 f24 ?v0)) ?v_0) (f11 (f22 f23 ?v0) ?v_0)))))
(assert (= (f8 f24 1) 1))
(assert (forall ((?v0 S2)) (= (= f21 ?v0) (= ?v0 f21))))
(assert (forall ((?v0 S10)) (= (= f19 ?v0) (= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< 0 ?v_0) (= (f13 (f14 f15 (f13 f16 (f6 f7 (f8 ?v_1 (f11 f12 ?v1))))) (f6 f7 (f8 ?v_1 (f11 f12 ?v2)))) (f13 (f14 f15 (f13 f16 ?v1)) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f24 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f24 ?v0)) (f8 f24 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f25 ?v0) ?v1) (f3 (f4 f25 ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 (f3 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f26 (f27 f28 ?v0) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f25 ?v0) (f3 (f4 f20 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f11 (f22 f23 (f11 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f26 (f27 f28 ?v0) (f26 (f27 f28 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f25 ?v0) (f3 (f4 f25 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f8 (f9 f10 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f25 ?v0)) (?v_0 (f4 f25 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_1 (f27 f28 ?v0)) (?v_0 (f27 f28 ?v1))) (= (f26 ?v_1 (f26 ?v_0 ?v2)) (f26 ?v_0 (f26 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f9 f10 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f3 (f4 f25 ?v1) ?v2)) (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2)) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f26 (f27 f28 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f25 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f8 (f9 f10 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f24 ?v0))) (= (f8 (f9 f10 ?v_0) ?v_0) (f8 (f9 f10 ?v0) ?v0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f25 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f28 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f25 ?v0)) (?v_1 (f3 (f4 f25 ?v2) ?v3))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f25 ?v1) ?v_1))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f26 (f27 f28 ?v2) ?v3))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v_1) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f8 (f9 f10 ?v2) ?v3))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f25 (f3 (f4 f25 ?v0) ?v1))) (?v_0 (f4 f25 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_1 (f27 f28 (f26 (f27 f28 ?v0) ?v1))) (?v_0 (f27 f28 ?v2))) (= (f26 ?v_1 (f26 ?v_0 ?v3)) (f26 ?v_0 (f26 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f9 f10 (f8 (f9 f10 ?v0) ?v1))) (?v_0 (f9 f10 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) (f3 (f4 f25 ?v2) ?v3)) (f3 (f4 f25 (f3 ?v_0 ?v2)) (f3 (f4 f25 ?v1) ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) (f26 (f27 f28 ?v2) ?v3)) (f26 (f27 f28 (f26 ?v_0 ?v2)) (f26 (f27 f28 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 (f9 f10 ?v2) ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v2)) (f8 (f9 f10 ?v1) ?v3))))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) f21) ?v0)))
(assert (forall ((?v0 S10)) (= (f26 (f27 f28 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) f21) ?v0)))
(assert (forall ((?v0 S10)) (= (f26 (f27 f28 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) f21) ?v0)))
(assert (forall ((?v0 S10)) (= (f26 (f27 f28 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 f21) ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f26 (f27 f28 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 f21) ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f26 (f27 f28 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 f21) ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f26 (f27 f28 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f26 (f27 f28 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2)) (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2)) (= (f13 (f14 f15 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f28 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f20 (f3 (f4 f25 ?v0) ?v1)) ?v2) (f3 (f4 f25 (f3 (f4 f20 ?v0) ?v2)) (f3 (f4 f20 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f22 f23 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f22 f23 ?v0) ?v2)) (f11 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2)) (= (f13 (f14 f15 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f28 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f20 (f3 (f4 f25 ?v0) ?v1)) ?v2) (f3 (f4 f25 (f3 (f4 f20 ?v0) ?v2)) (f3 (f4 f20 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f22 f23 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f22 f23 ?v0) ?v2)) (f11 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f13 (f14 f15 ?v0) ?v1))) (= (f26 (f27 f28 ?v_0) ?v0) (f26 (f27 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f20 ?v0) ?v1))) (= (f3 (f4 f25 ?v_0) ?v0) (f3 (f4 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f22 f23 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f26 (f27 f28 (f13 ?v_0 ?v1)) ?v0) (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f26 (f27 f28 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f3 (f4 f25 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f26 (f27 f28 ?v0) (f13 ?v_0 ?v1)) (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 (f4 f25 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 3)) (f26 (f27 f28 (f26 (f27 f28 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f20 ?v0) (f6 f7 3)) (f3 (f4 f25 (f3 (f4 f25 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f22 f23 ?v0) (f6 f7 3)) (f8 (f9 f10 (f8 (f9 f10 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 2)) (f26 (f27 f28 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f20 ?v0) (f6 f7 2)) (f3 (f4 f25 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f22 f23 ?v0) (f6 f7 2)) (f8 (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f26 (f27 f28 (f13 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f26 (f27 f28 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f25 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f26 (f27 f28 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f25 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S10)) (= (f26 (f27 f28 ?v0) ?v0) (f13 (f14 f15 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) ?v0) (f3 (f4 f20 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) ?v0) (f11 (f22 f23 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 (f4 f20 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 (f22 f23 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f20 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f11 (f22 f23 (f11 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f3 (f4 f20 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f11 (f22 f23 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f20 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f21 (f3 (f4 f25 ?v0) (f3 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f19 (f26 (f27 f28 ?v0) (f13 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) 1 (f8 (f9 f10 ?v0) (f11 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))
(assert (= f20 (f29 (f30 f31 f21) f25)))
(assert (= f15 (f32 (f33 f34 f19) f28)))
(assert (= f23 (f35 (f36 f37 1) f10)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S10)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f14 f15 ?v2))) (=> (<= ?v_1 ?v_0) (= (f13 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f26 (f27 f28 (f13 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f4 f20 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f25 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f22 f23 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f8 (f9 f10 (f11 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S10)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f14 f15 ?v1))) (=> (< 0 ?v_0) (= (f26 (f27 f28 (f13 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f13 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f4 f20 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f25 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f22 f23 ?v1))) (=> (< 0 ?v_0) (= (f8 (f9 f10 (f11 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f11 ?v_1 ?v0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (<= ?v_0 (f8 ?v_1 (f8 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f11 f12 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (f8 (f9 f10 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f20 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f20 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f20 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f20 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f3 ?v_0 ?v1)) (f11 f12 (f3 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f3 (f4 f20 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S2)) (let ((?v_0 (f22 (f35 (f36 f37 ?v0) ?v1) ?v2))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v3) 1))) (f8 (f9 ?v1 ?v2) (f11 ?v_0 ?v3))))))
(assert (forall ((?v0 S10) (?v1 S14) (?v2 S10) (?v3 S2)) (let ((?v_0 (f14 (f32 (f33 f34 ?v0) ?v1) ?v2))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v3) 1))) (f26 (f27 ?v1 ?v2) (f13 ?v_0 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 (f29 (f30 f31 ?v0) ?v1) ?v2))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v3) 1))) (f3 (f4 ?v1 ?v2) (f3 ?v_0 ?v3))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int)) (= (f11 (f22 (f35 (f36 f37 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 S10) (?v1 S14) (?v2 S10)) (= (f13 (f14 (f32 (f33 f34 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f3 (f4 (f29 (f30 f31 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_3 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (let ((?v_2 (f9 f10 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f8 ?v_2 ?v_1) (f8 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f9 f10 (f11 f12 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f8 ?v_1 ?v_0) (f8 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f8 (f9 f10 ?v_0) ?v_2) (f8 (f9 f10 ?v_1) ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_2)))) ?v_1)) (f6 f7 (- (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_2)) ?v_1)) (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f8 ?v_0 ?v_1)) ?v_2)) (f6 f7 (f8 ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ ?v_1 1)) ?v_0)) (f6 f7 (+ ?v_0 (f8 (f9 f10 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (f8 (f9 f10 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (f11 f12 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_1 (+ ?v_2 1))) (f6 f7 (+ ?v_0 (f8 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (f8 (f9 f10 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f20 ?v0) ?v1)) (f11 (f22 f23 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f20 ?v0) ?v1))) (or (= ?v1 (f6 f7 0)) (< 0 (f11 f12 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f22 f23 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f20 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f22 f23 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f20 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f22 f23 ?v0) ?v1)) (f3 (f4 f20 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f3 (f4 f20 (f6 f7 ?v0)) ?v1) (f6 f7 (f11 (f22 f23 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f11 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f11 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f11 (f22 f23 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
