(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 (S9 S2) S10)
(declare-fun f14 (S11 S10) S9)
(declare-fun f15 () S11)
(declare-fun f16 () S9)
(declare-fun f17 () S2)
(declare-fun f18 (S12 S10) S10)
(declare-fun f19 () S12)
(declare-fun f20 () S10)
(declare-fun f21 (S13 Int) S8)
(declare-fun f22 () S13)
(declare-fun f23 (S14 S10) S12)
(declare-fun f24 () S14)
(declare-fun f25 () S4)
(declare-fun f26 () S4)
(declare-fun f27 () S2)
(declare-fun f28 () S6)
(declare-fun f29 (S15 S7) S13)
(declare-fun f30 (S16 Int) S15)
(declare-fun f31 () S16)
(declare-fun f32 (S17 S14) S11)
(declare-fun f33 (S18 S10) S17)
(declare-fun f34 () S18)
(declare-fun f35 (S19 S4) S4)
(declare-fun f36 (S20 S2) S19)
(declare-fun f37 () S20)
(declare-fun f38 () S7)
(declare-fun f39 () S7)
(declare-fun f40 (S21 Int) S1)
(declare-fun f41 (S22 S2) S1)
(declare-fun f42 (S2) S22)
(declare-fun f43 () S4)
(declare-fun f44 () S4)
(declare-fun f45 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (not (= (f13 (f14 f15 (f13 f16 (f6 f7 (* 2 (f11 f12 f17))))) f17) (f18 f19 f20))))
(assert (< 0 (f11 f12 f17)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (f13 (f14 f15 (f13 f16 (f6 f7 (* ?v_0 2)))) (f6 f7 (* ?v_0 1))) (f13 (f14 f15 (f13 f16 (f6 f7 2))) (f6 f7 1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (= (f13 (f14 f15 (f13 f16 (f6 f7 (* ?v_0 2)))) (f6 f7 (* ?v_0 1))) (f13 (f14 f15 (f13 f16 (f6 f7 2))) (f6 f7 1)))))))
(assert (= (f13 f16 (f6 f7 1)) f20))
(assert (= (f13 f16 (f6 f7 0)) f20))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 (f13 f16 ?v0)) ?v0) f20)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v1))) (?v_1 (f11 f12 ?v2))) (= (f13 (f14 f15 (f13 f16 (f6 f7 (* 2 (f11 f12 ?v0))))) (f6 f7 (f8 ?v_0 (* 2 ?v_1)))) (f13 (f14 f15 (f13 f16 ?v0)) (f6 f7 (f8 ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< 0 ?v_0) (= (f13 (f14 f15 (f13 f16 (f6 f7 (f8 ?v_1 (f11 f12 ?v1))))) (f6 f7 (f8 ?v_1 (f11 f12 ?v2)))) (f13 (f14 f15 (f13 f16 ?v1)) ?v2)))))))
(assert (forall ((?v0 S2)) (= (f11 (f21 f22 (- 1)) (f6 f7 (+ (* 2 (f11 f12 ?v0)) 1))) (- 1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f18 f19 f20))) (= (f13 (f14 f15 ?v_0) (f6 f7 (+ (* 2 (f11 f12 ?v0)) 1))) ?v_0))))
(assert (forall ((?v0 S2)) (= (f11 (f21 f22 (- 1)) (f6 f7 (* 2 (f11 f12 ?v0)))) 1)))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 (f18 f19 f20)) (f6 f7 (* 2 (f11 f12 ?v0)))) f20)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f11 (f21 f22 (- ?v0)) ?v1) (f8 (f9 f10 (f11 (f21 f22 (- 1)) ?v1)) (f11 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S2)) (= (f13 (f14 f15 (f18 f19 ?v0)) ?v1) (f18 (f23 f24 (f13 (f14 f15 (f18 f19 f20)) ?v1)) (f13 (f14 f15 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f6 f7 (* 2 (f11 f12 ?v1))))) (= (f11 (f21 f22 (- ?v0)) ?v_0) (f11 (f21 f22 ?v0) ?v_0)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f6 f7 (* 2 (f11 f12 ?v1))))) (= (f13 (f14 f15 (f18 f19 ?v0)) ?v_0) (f13 (f14 f15 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f11 (f21 f22 (f11 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f26 ?v0) (f3 (f4 f25 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f18 (f23 f24 ?v0) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f8 (f9 f10 ?v0) (f8 (f9 f10 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f3 (f4 f26 ?v0) (f3 (f4 f26 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) (f18 (f23 f24 ?v0) (f18 (f23 f24 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f8 (f9 f10 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f26 ?v_1) ?v_1))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f18 (f23 f24 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int)) (= (= (f11 (f21 f22 ?v0) (f6 f7 2)) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 S10)) (= (= (f13 (f14 f15 ?v0) (f6 f7 2)) f20) (or (= ?v0 f20) (= ?v0 (f18 f19 f20))))))
(assert (forall ((?v0 Int)) (= (- ?v0) (* (- 1) ?v0))))
(assert (forall ((?v0 S10)) (= (f18 f19 ?v0) (f18 (f23 f24 (f18 f19 f20)) ?v0))))
(assert (forall ((?v0 Int)) (= (= (f8 (f9 f10 ?v0) ?v0) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 S10)) (= (= (f18 (f23 f24 ?v0) ?v0) f20) (or (= ?v0 f20) (= ?v0 (f18 f19 f20))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) 1 (f8 (f9 f10 ?v0) (f11 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f20 (f18 (f23 f24 ?v0) (f13 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f27 (f3 (f4 f26 ?v0) (f3 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f11 (f21 f22 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 (f3 ?v_0 (f6 f7 (- (f11 f12 ?v1) 1)))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 (f9 f10 ?v2) ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v2)) (f8 (f9 f10 ?v1) ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f23 f24 ?v0))) (= (f18 (f23 f24 (f18 ?v_0 ?v1)) (f18 (f23 f24 ?v2) ?v3)) (f18 (f23 f24 (f18 ?v_0 ?v2)) (f18 (f23 f24 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f26 (f3 ?v_0 ?v1)) (f3 (f4 f26 ?v2) ?v3)) (f3 (f4 f26 (f3 ?v_0 ?v2)) (f3 (f4 f26 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f9 f10 (f8 (f9 f10 ?v0) ?v1))) (?v_0 (f9 f10 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_1 (f23 f24 (f18 (f23 f24 ?v0) ?v1))) (?v_0 (f23 f24 ?v2))) (= (f18 ?v_1 (f18 ?v_0 ?v3)) (f18 ?v_0 (f18 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f26 (f3 (f4 f26 ?v0) ?v1))) (?v_0 (f4 f26 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f8 (f9 f10 ?v2) ?v3))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v_1))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f18 (f23 f24 ?v2) ?v3))) (= (f18 (f23 f24 (f18 ?v_0 ?v1)) ?v_1) (f18 ?v_0 (f18 (f23 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f26 ?v0)) (?v_1 (f3 (f4 f26 ?v2) ?v3))) (= (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f26 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f23 f24 ?v0))) (= (f18 (f23 f24 (f18 ?v_0 ?v1)) ?v2) (f18 (f23 f24 (f18 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f26 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f23 f24 ?v0))) (= (f18 (f23 f24 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f26 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f28 ?v0))) (= (f8 (f9 f10 ?v_0) ?v_0) (f8 (f9 f10 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f23 f24 ?v0))) (= (f18 ?v_0 (f18 (f23 f24 ?v1) ?v2)) (f18 (f23 f24 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 ?v_0 (f3 (f4 f26 ?v1) ?v2)) (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f9 f10 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_1 (f23 f24 ?v0)) (?v_0 (f23 f24 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f26 ?v0)) (?v_0 (f4 f26 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f23 f24 ?v0) ?v1) (f18 (f23 f24 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f26 ?v0) ?v1) (f3 (f4 f26 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f28 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f28 ?v0)) (f8 f28 ?v1)))))
(assert (= (f8 f28 1) 1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f21 f22 (f8 f28 ?v0)) ?v_0) (f11 (f21 f22 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f11 (f21 f22 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f11 (f21 f22 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f21 f22 ?v0) (f6 f7 2)))) (= (f8 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f28 (f11 (f21 f22 ?v0) ?v1)) (f11 (f21 f22 (f8 f28 ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S10)) (= (f18 (f23 f24 ?v0) f20) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) f27) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f18 (f23 f24 f20) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 f27) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f21 f22 ?v2))) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f8 (f9 f10 (f11 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f4 f25 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f26 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S10)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f14 f15 ?v2))) (=> (<= ?v_1 ?v_0) (= (f13 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f18 (f23 f24 (f13 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f26 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f18 (f23 f24 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2)) (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f21 f22 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f21 f22 ?v0) ?v2)) (f11 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f25 (f3 (f4 f26 ?v0) ?v1)) ?v2) (f3 (f4 f26 (f3 (f4 f25 ?v0) ?v2)) (f3 (f4 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2)) (= (f13 (f14 f15 (f18 (f23 f24 ?v0) ?v1)) ?v2) (f18 (f23 f24 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f21 f22 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f21 f22 ?v0) ?v2)) (f11 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f25 (f3 (f4 f26 ?v0) ?v1)) ?v2) (f3 (f4 f26 (f3 (f4 f25 ?v0) ?v2)) (f3 (f4 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S2)) (= (f13 (f14 f15 (f18 (f23 f24 ?v0) ?v1)) ?v2) (f18 (f23 f24 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f21 f22 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f25 ?v0) ?v1))) (= (f3 (f4 f26 ?v_0) ?v0) (f3 (f4 f26 ?v0) ?v_0)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f13 (f14 f15 ?v0) ?v1))) (= (f18 (f23 f24 ?v_0) ?v0) (f18 (f23 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f18 (f23 f24 (f13 ?v_0 ?v1)) ?v0) (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f3 (f4 f26 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f18 (f23 f24 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1)) (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f26 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f18 (f23 f24 ?v0) (f13 ?v_0 ?v1)) (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (f11 (f21 f22 ?v0) (f6 f7 3)) (f8 (f9 f10 (f8 (f9 f10 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 3)) (f3 (f4 f26 (f3 (f4 f26 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 3)) (f18 (f23 f24 (f18 (f23 f24 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f11 (f21 f22 ?v0) (f6 f7 2)) (f8 (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 2)) (f3 (f4 f26 ?v0) ?v0))))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 2)) (f18 (f23 f24 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f18 (f23 f24 (f13 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f26 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f18 (f23 f24 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f26 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f18 (f23 f24 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 ?v0) ?v0) (f11 (f21 f22 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) ?v0) (f3 (f4 f25 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S10)) (= (f18 (f23 f24 ?v0) ?v0) (f13 (f14 f15 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v0) (f8 (f9 f10 ?v1) ?v1)) (or (= ?v0 ?v1) (= ?v0 (- ?v1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f18 (f23 f24 ?v0) ?v0) (f18 (f23 f24 ?v1) ?v1)) (or (= ?v0 ?v1) (= ?v0 (f18 f19 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) (- ?v1)) (f8 (f9 f10 ?v0) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f23 f24 (f18 f19 ?v0)) (f18 f19 ?v1)) (f18 (f23 f24 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (f8 (f9 f10 ?v0) (- ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f23 f24 (f18 f19 ?v0)) ?v1) (f18 (f23 f24 ?v0) (f18 f19 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (- ?v0)) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 f19 (f18 (f23 f24 ?v0) ?v1)) (f18 (f23 f24 (f18 f19 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (- (f8 ?v_0 ?v1)) (f8 ?v_0 (- ?v1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f23 f24 ?v0))) (= (f18 f19 (f18 ?v_0 ?v1)) (f18 ?v_0 (f18 f19 ?v1))))))
(assert (forall ((?v0 Int)) (= (f11 (f21 f22 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 0)) f20)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 0)) f27)))
(assert (forall ((?v0 Int)) (= (f11 (f21 f22 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S10)) (= (f13 (f14 f15 ?v0) (f6 f7 0)) f20)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 ?v0) (f6 f7 0)) f27)))
(assert (= (f11 (f21 f22 1) (f6 f7 2)) 1))
(assert (= (f13 (f14 f15 f20) (f6 f7 2)) f20))
(assert (= (f3 (f4 f25 f27) (f6 f7 2)) f27))
(assert (forall ((?v0 S2)) (= (f11 (f21 f22 1) ?v0) 1)))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 f20) ?v0) f20)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f25 f27) ?v0) f27)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f21 f22 (- ?v0)) ?v_0) (f11 (f21 f22 ?v0) ?v_0)))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f6 f7 2))) (= (f13 (f14 f15 (f18 f19 ?v0)) ?v_0) (f13 (f14 f15 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f28 (f11 (f21 f22 (- ?v0)) ?v1)) (f8 f28 (f11 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 (f21 f22 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S2) (?v2 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f11 (f21 f22 (f11 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f3 (f4 f25 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S10) (?v1 S2)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (* 2 (f11 f12 ?v1)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f6 f7 2))))))
(assert (= f22 (f29 (f30 f31 1) f10)))
(assert (= f15 (f32 (f33 f34 f20) f24)))
(assert (= f25 (f35 (f36 f37 f27) f26)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 (+ (+ 0 1) 1)))) (= (= (f11 (f21 f22 ?v0) ?v_0) (f11 (f21 f22 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (- ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f6 f7 (+ (+ 0 1) 1)))) (= (= (f13 (f14 f15 ?v0) ?v_0) (f13 (f14 f15 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (f18 f19 ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f23 f24 (f18 f19 ?v0)) ?v1) (f18 f19 (f18 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f23 f24 (f18 f19 ?v0)) ?v1) (f18 f19 (f18 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f23 f24 ?v0))) (= (f18 ?v_0 (f18 f19 ?v1)) (f18 f19 (f18 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S10)) (let ((?v_0 (f23 f24 ?v0))) (= (f18 ?v_0 (f18 f19 ?v1)) (f18 f19 (f18 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f21 f22 ?v1))) (=> (< 0 ?v_0) (= (f8 (f9 f10 (f11 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f11 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f4 f25 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f26 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S10)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f14 f15 ?v1))) (=> (< 0 ?v_0) (= (f18 (f23 f24 (f13 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f13 ?v_1 ?v0))))))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S10)) (= (f18 (f23 f24 ?v0) f20) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) f27) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S10)) (= (f18 (f23 f24 ?v0) f20) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 ?v0) f27) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f18 (f23 f24 f20) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 f27) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f25 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f25 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f25 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f3 ?v_0 ?v1)) (f11 f12 (f3 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f3 (f4 f25 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 (f35 (f36 f37 ?v0) ?v1) ?v2))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v3) 1))) (f3 (f4 ?v1 ?v2) (f3 ?v_0 ?v3))))))
(assert (forall ((?v0 S10) (?v1 S14) (?v2 S10) (?v3 S2)) (let ((?v_0 (f14 (f32 (f33 f34 ?v0) ?v1) ?v2))) (= (f13 ?v_0 (f6 f7 (+ (f11 f12 ?v3) 1))) (f18 (f23 ?v1 ?v2) (f13 ?v_0 ?v3))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S2)) (let ((?v_0 (f21 (f29 (f30 f31 ?v0) ?v1) ?v2))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v3) 1))) (f8 (f9 ?v1 ?v2) (f11 ?v_0 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f3 (f4 (f35 (f36 f37 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 S10) (?v1 S14) (?v2 S10)) (= (f13 (f14 (f32 (f33 f34 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int)) (= (f11 (f21 (f29 (f30 f31 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f23 f24 ?v0))) (= (f18 (f23 f24 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f26 ?v0))) (= (f3 (f4 f26 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f26 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S10)) (= (= f20 ?v0) (= ?v0 f20))))
(assert (forall ((?v0 S2)) (= (= f27 ?v0) (= ?v0 f27))))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 S10)) (= (f18 f19 (f18 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 f28 (- ?v0)) (f8 f28 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 (f9 f38 ?v0) ?v1)) (f8 (f9 f39 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 (f9 f39 ?v0) ?v1)) (f8 (f9 f38 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= ?v0 (f18 f19 ?v1)) (= ?v1 (f18 f19 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f18 f19 ?v0) ?v1) (= (f18 f19 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f18 f19 ?v0) (f18 f19 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f18 (f23 f24 f20) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f26 f27) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f25 ?v0) ?v1)) (f11 (f21 f22 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f25 ?v0) ?v1))) (or (= ?v1 (f6 f7 0)) (< 0 (f11 f12 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f21 f22 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f21 f22 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f25 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f21 f22 ?v0) ?v1)) (f3 (f4 f25 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f3 (f4 f25 (f6 f7 ?v0)) ?v1) (f6 f7 (f11 (f21 f22 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f11 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f11 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f11 (f21 f22 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (= (f11 (f21 f22 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1)))) (f6 f7 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f11 f12 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (<= ?v_0 (f8 ?v_1 (f8 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f11 f12 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (f8 (f9 f10 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (f8 (f9 f10 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_1 (+ ?v_2 1))) (f6 f7 (+ ?v_0 (f8 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (f11 f12 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (f8 (f9 f10 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ ?v_1 1)) ?v_0)) (f6 f7 (+ ?v_0 (f8 (f9 f10 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f8 ?v_0 ?v_1)) ?v_2)) (f6 f7 (f8 ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_2)) ?v_1)) (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_2)))) ?v_1)) (f6 f7 (- (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f8 (f9 f10 ?v_0) ?v_2) (f8 (f9 f10 ?v_1) ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f9 f10 (f11 f12 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f8 ?v_1 ?v_0) (f8 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_3 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (let ((?v_2 (f9 f10 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f8 ?v_2 ?v_1) (f8 ?v_2 ?v_3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f8 (f9 f10 ?v3) ?v4) ?v5))) (=> (= (+ (f8 (f9 f10 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= (+ (f8 ?v_0 ?v1) ?v2) (+ (f8 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f8 (f9 f10 ?v3) ?v4) ?v5))) (=> (= (+ (f8 (f9 f10 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= (+ (f8 ?v_0 ?v1) ?v2) (+ (f8 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f8 (f9 f10 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f8 (f9 f10 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S21) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f40 ?v1 ?v3) f1) (= (f40 ?v1 (- ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f40 ?v1 ?v3) f1) (= (f40 ?v1 (- ?v3 (f8 (f9 f10 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 S21) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f40 ?v1 ?v3) f1) (= (f40 ?v1 (+ ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f40 ?v1 ?v3) f1) (= (f40 ?v1 (+ ?v3 (f8 (f9 f10 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (<= (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v0 (f6 f7 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (= (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_0) (+ (f8 (f9 f10 ?v_2) ?v_0) ?v_3))) (f6 f7 (+ (f8 (f9 f10 (+ ?v_1 ?v_2)) ?v_0) ?v_3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< 0 ?v_0) (= (= (f6 f7 (f8 ?v_1 (f11 f12 ?v1))) (f6 f7 (f8 ?v_1 (f11 f12 ?v2)))) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (< (f8 ?v_1 ?v_2) (f8 ?v_1 ?v_3)) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (<= (f8 ?v_1 ?v_2) (f8 ?v_1 ?v_3)) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_2) (f11 f12 ?v3))) (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_3))) (= ?v3 (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (f6 f7 (- (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4))) (f6 f7 (- ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (< ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (<= ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3)) (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_2) (f11 f12 ?v4)))) (= (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (f6 f7 (- (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4))) (f6 f7 (- (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (< (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f11 f12 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (+ (f11 f12 (f6 f7 (- ?v_0 2))) 1) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 4 (f11 f12 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (+ (f11 f12 (f6 f7 (- ?v_0 2))) 1) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f11 f12 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (f11 f12 (f6 f7 (- ?v_0 1))) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 1 ?v0) (< 1 (f8 (f9 f10 ?v0) (f11 (f21 f22 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f42 f27))) (=> (= (f41 ?v_0 ?v0) f1) (= (f41 ?v_0 (f3 (f4 f26 ?v0) (f3 (f4 f25 ?v0) ?v1))) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f28 ?v0) ?v1) (and (< ?v0 ?v1) (< (- ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) (- ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) ?v1) (< (- ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 (- ?v1)) (< ?v1 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f8 (f9 f39 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f41 (f42 ?v0) ?v1) f1) (= (f41 (f42 (f3 (f4 f43 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f8 (f9 f39 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f41 (f42 ?v0) ?v1) f1) (= (f41 (f42 (f3 (f4 f43 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f8 (f9 f38 ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f42 ?v0))) (=> (= (f41 ?v_0 ?v1) f1) (= (f41 ?v_0 (f3 (f4 f44 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f8 (f9 f38 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f42 ?v0))) (=> (= (f41 ?v_0 ?v1) f1) (= (f41 ?v_0 (f3 (f4 f44 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f42 f27))) (=> (= (f41 ?v_0 ?v0) f1) (=> (= (f41 ?v_0 ?v1) f1) (= (f41 ?v_0 (f3 (f4 f26 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 1 ?v0) (< 1 (f11 (f21 f22 ?v0) (f6 f7 (+ (f11 f12 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f42 f27))) (=> (= (f41 ?v_0 ?v0) f1) (= (f41 ?v_0 (f3 (f4 f25 ?v0) (f6 f7 (+ (f11 f12 ?v1) 1)))) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (= (= (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (=> (= (f41 (f42 f27) ?v0) f1) (= (= (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (= (< (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (=> (= (f41 (f42 f27) ?v0) f1) (= (= (f41 (f42 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) f1) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< 1 ?v0) (=> (< 0 (f11 f12 ?v1)) (< 1 (f11 (f21 f22 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f42 f27))) (=> (= (f41 ?v_0 ?v0) f1) (=> (< 0 (f11 f12 ?v1)) (= (f41 ?v_0 (f3 (f4 f25 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f21 f22 ?v0))) (=> (< 1 ?v0) (=> (< (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v0))) (=> (= (f41 (f42 f27) ?v0) f1) (=> (= (f41 (f42 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) f1) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (< (f11 f12 ?v0) (f11 f12 ?v1)) (=> (< 1 ?v2) (< (f11 ?v_0 ?v0) (f11 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f25 ?v2))) (=> (< (f11 f12 ?v0) (f11 f12 ?v1)) (=> (= (f41 (f42 f27) ?v2) f1) (= (f41 (f42 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f8 f28 ?v0)) (?v_1 (f8 f28 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v1) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f21 f22 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (f8 (f9 f10 ?v0) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f25 ?v0) ?v1))) (=> (= (f41 (f42 f27) ?v0) f1) (= (f41 (f42 ?v_0) (f3 (f4 f26 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S2)) (=> (forall ((?v3 S2)) (< (f11 ?v0 ?v3) (f11 ?v0 (f6 f7 (+ (f11 f12 ?v3) 1))))) (=> (< (f11 f12 ?v1) (f11 f12 ?v2)) (< (f11 ?v0 ?v1) (f11 ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (=> (forall ((?v3 S2)) (= (f41 (f42 (f3 ?v0 ?v3)) (f3 ?v0 (f6 f7 (+ (f11 f12 ?v3) 1)))) f1)) (=> (< (f11 f12 ?v1) (f11 f12 ?v2)) (= (f41 (f42 (f3 ?v0 ?v1)) (f3 ?v0 ?v2)) f1)))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S2)) (=> (forall ((?v3 S2)) (< (f11 ?v0 ?v3) (f11 ?v0 (f6 f7 (+ (f11 f12 ?v3) 1))))) (= (< (f11 ?v0 ?v1) (f11 ?v0 ?v2)) (< (f11 f12 ?v1) (f11 f12 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (=> (forall ((?v3 S2)) (= (f41 (f42 (f3 ?v0 ?v3)) (f3 ?v0 (f6 f7 (+ (f11 f12 ?v3) 1)))) f1)) (= (= (f41 (f42 (f3 ?v0 ?v1)) (f3 ?v0 ?v2)) f1) (< (f11 f12 ?v1) (f11 f12 ?v2))))))
(assert (forall ((?v0 S21) (?v1 S21) (?v2 S21) (?v3 S21)) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f40 ?v0 ?v5) f1) (= (f40 ?v1 ?v5) f1))))) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f40 ?v2 ?v5) f1) (= (f40 ?v3 ?v5) f1))))) (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (or (= (f40 ?v0 ?v5) f1) (= (f40 ?v2 ?v5) f1)) (or (= (f40 ?v1 ?v5) f1) (= (f40 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S22) (?v1 S22) (?v2 S22) (?v3 S22)) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v4) ?v5) f1) (= (= (f41 ?v0 ?v5) f1) (= (f41 ?v1 ?v5) f1))))) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v4) ?v5) f1) (= (= (f41 ?v2 ?v5) f1) (= (f41 ?v3 ?v5) f1))))) (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v4) ?v5) f1) (= (or (= (f41 ?v0 ?v5) f1) (= (f41 ?v2 ?v5) f1)) (or (= (f41 ?v1 ?v5) f1) (= (f41 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S21) (?v1 S21) (?v2 S21) (?v3 S21)) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f40 ?v0 ?v5) f1) (= (f40 ?v1 ?v5) f1))))) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f40 ?v2 ?v5) f1) (= (f40 ?v3 ?v5) f1))))) (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (and (= (f40 ?v0 ?v5) f1) (= (f40 ?v2 ?v5) f1)) (and (= (f40 ?v1 ?v5) f1) (= (f40 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S22) (?v1 S22) (?v2 S22) (?v3 S22)) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v4) ?v5) f1) (= (= (f41 ?v0 ?v5) f1) (= (f41 ?v1 ?v5) f1))))) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v4) ?v5) f1) (= (= (f41 ?v2 ?v5) f1) (= (f41 ?v3 ?v5) f1))))) (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v4) ?v5) f1) (= (and (= (f41 ?v0 ?v5) f1) (= (f41 ?v2 ?v5) f1)) (and (= (f41 ?v1 ?v5) f1) (= (f41 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v2 ?v1) (= (not (= ?v2 ?v0)) true))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (=> (= (f41 (f42 ?v2) ?v1) f1) (= (not (= ?v2 ?v0)) true))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v1 ?v2) (= (not (= ?v2 ?v0)) true))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (=> (= (f41 (f42 ?v1) ?v2) f1) (= (not (= ?v2 ?v0)) true))))))
(assert (forall ((?v0 S21) (?v1 S21) (?v2 S21) (?v3 S21)) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (= (f40 ?v0 ?v5) f1) (= (f40 ?v1 ?v5) f1))))) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (= (f40 ?v2 ?v5) f1) (= (f40 ?v3 ?v5) f1))))) (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (or (= (f40 ?v0 ?v5) f1) (= (f40 ?v2 ?v5) f1)) (or (= (f40 ?v1 ?v5) f1) (= (f40 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S22) (?v1 S22) (?v2 S22) (?v3 S22)) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v5) ?v4) f1) (= (= (f41 ?v0 ?v5) f1) (= (f41 ?v1 ?v5) f1))))) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v5) ?v4) f1) (= (= (f41 ?v2 ?v5) f1) (= (f41 ?v3 ?v5) f1))))) (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v5) ?v4) f1) (= (or (= (f41 ?v0 ?v5) f1) (= (f41 ?v2 ?v5) f1)) (or (= (f41 ?v1 ?v5) f1) (= (f41 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S21) (?v1 S21) (?v2 S21) (?v3 S21)) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (= (f40 ?v0 ?v5) f1) (= (f40 ?v1 ?v5) f1))))) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (= (f40 ?v2 ?v5) f1) (= (f40 ?v3 ?v5) f1))))) (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (and (= (f40 ?v0 ?v5) f1) (= (f40 ?v2 ?v5) f1)) (and (= (f40 ?v1 ?v5) f1) (= (f40 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S22) (?v1 S22) (?v2 S22) (?v3 S22)) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v5) ?v4) f1) (= (= (f41 ?v0 ?v5) f1) (= (f41 ?v1 ?v5) f1))))) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v5) ?v4) f1) (= (= (f41 ?v2 ?v5) f1) (= (f41 ?v3 ?v5) f1))))) (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f41 (f42 ?v5) ?v4) f1) (= (and (= (f41 ?v0 ?v5) f1) (= (f41 ?v2 ?v5) f1)) (and (= (f41 ?v1 ?v5) f1) (= (f41 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v2 ?v1) (= (< ?v0 ?v2) false))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (=> (= (f41 (f42 ?v2) ?v1) f1) (= (= (f41 (f42 ?v0) ?v2) f1) false))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v1 ?v2) (= (< ?v0 ?v2) true))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (=> (= (f41 (f42 ?v1) ?v2) f1) (= (= (f41 (f42 ?v0) ?v2) f1) true))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v1 ?v2) (= (< ?v2 ?v0) false))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (=> (= (f41 (f42 ?v1) ?v2) f1) (= (= (f41 (f42 ?v2) ?v0) f1) false))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v1 ?v2) (= (= ?v2 ?v0) false))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (=> (= (f41 (f42 ?v1) ?v2) f1) (= (= ?v2 ?v0) false))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v2 ?v1) (= (= ?v2 ?v0) false))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (=> (= (f41 (f42 ?v2) ?v1) f1) (= (= ?v2 ?v0) false))))))
(assert (forall ((?v0 Int)) (exists ((?v1 Int)) (forall ((?v2 Int)) (=> (< ?v2 ?v1) (= (< ?v2 ?v0) true))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (forall ((?v2 S2)) (let ((?v_0 (f42 ?v2))) (=> (= (f41 ?v_0 ?v1) f1) (= (= (f41 ?v_0 ?v0) f1) true)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f21 f22 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f8 (f9 f10 ?v0) ?v_0) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f25 ?v0) ?v1))) (=> (= (f41 (f42 f45) ?v0) f1) (=> (= (f41 (f42 ?v0) f27) f1) (= (f41 (f42 (f3 (f4 f26 ?v0) ?v_0)) ?v_0) f1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (< ?v0 0) (< (f11 (f21 f22 ?v0) (f6 f7 (+ (* 2 (f11 f12 ?v1)) 1))) 0))))
(assert (forall ((?v0 Int)) (= (< ?v0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f28 ?v0) (- ?v0)))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) ?v0) (< 0 ?v0))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) 0) (< 0 ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f8 f28 ?v0) (ite (< ?v0 0) (- ?v0) ?v0))))
(assert (forall ((?v0 Int)) (not (< (f8 (f9 f10 ?v0) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
