(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 () S3)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 () S3)
(declare-fun f11 (S7 S3) S3)
(declare-fun f12 () S7)
(declare-fun f13 () S7)
(declare-fun f14 (S8 S2) S7)
(declare-fun f15 () S8)
(declare-fun f16 () S2)
(declare-fun f17 () S2)
(declare-fun f18 (S9 S4) S4)
(declare-fun f19 (S10 S4) S9)
(declare-fun f20 () S10)
(declare-fun f21 () S10)
(declare-fun f22 (S11 S4) S3)
(declare-fun f23 () S11)
(declare-fun f24 () S10)
(declare-fun f25 () S4)
(declare-fun f26 () S3)
(declare-fun f27 (S12 Int) Int)
(declare-fun f28 (S13 Int) S12)
(declare-fun f29 () S13)
(declare-fun f30 () S8)
(declare-fun f31 (S14 Int) S6)
(declare-fun f32 () S14)
(declare-fun f33 (S15 S2) S2)
(declare-fun f34 (S16 S2) S15)
(declare-fun f35 () S16)
(declare-fun f36 () S16)
(declare-fun f37 () S2)
(declare-fun f38 () S16)
(declare-fun f39 () S12)
(declare-fun f40 (S17 S13) S14)
(declare-fun f41 (S18 Int) S17)
(declare-fun f42 () S18)
(declare-fun f43 (S19 S10) S11)
(declare-fun f44 (S20 S4) S19)
(declare-fun f45 () S20)
(declare-fun f46 (S21 S16) S16)
(declare-fun f47 (S22 S2) S21)
(declare-fun f48 () S22)
(declare-fun f49 () S13)
(declare-fun f50 () S16)
(declare-fun f51 () S13)
(declare-fun f52 () S16)
(declare-fun f53 () S10)
(declare-fun f54 () S9)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f3 f5 (f6 f7 (+ (* 2 (f8 f9 ?v0)) 1))))))
(assert (forall ((?v0 S2)) (= (f3 f10 ?v0) (f3 f5 (f6 f7 (* 2 (f8 f9 ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S2)) (= (f3 (f11 f12 ?v0) ?v1) (f3 ?v0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))))))
(assert (forall ((?v0 S3) (?v1 S2)) (= (f3 (f11 f13 ?v0) ?v1) (f3 ?v0 (f6 f7 (* 2 (f8 f9 ?v1)))))))
(assert (let ((?v_0 (f6 f7 (* 2 (f8 f9 f16)))) (?v_1 (f14 f15 f16))) (not (= (f3 (f11 (f14 f15 ?v_0) f5) f17) (f18 (f19 f20 (f3 (f11 ?v_1 f10) f17)) (f18 (f19 f21 (f3 (f22 f23 (f18 (f19 f24 f25) (f3 f26 ?v_0))) f17)) (f3 (f11 ?v_1 f4) f17)))))))
(assert (= (f3 f26 (f6 f7 1)) f25))
(assert (= (f3 f26 (f6 f7 0)) f25))
(assert (forall ((?v0 S2)) (= (f3 (f22 f23 (f3 f26 ?v0)) ?v0) f25)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f28 f29 (f8 f9 ?v1))) (?v_1 (f8 f9 ?v2))) (= (f3 (f22 f23 (f3 f26 (f6 f7 (* 2 (f8 f9 ?v0))))) (f6 f7 (f27 ?v_0 (* 2 ?v_1)))) (f3 (f22 f23 (f3 f26 ?v0)) (f6 f7 (f27 ?v_0 ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v0))) (let ((?v_1 (f28 f29 ?v_0))) (=> (< 0 ?v_0) (= (f3 (f22 f23 (f3 f26 (f6 f7 (f27 ?v_1 (f8 f9 ?v1))))) (f6 f7 (f27 ?v_1 (f8 f9 ?v2)))) (f3 (f22 f23 (f3 f26 ?v1)) ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (let ((?v_0 (f6 f7 (* 2 (f8 f9 ?v0)))) (?v_1 (f14 f30 ?v0))) (= (f3 (f11 (f14 f30 ?v_0) ?v1) ?v2) (f18 (f19 f20 (f3 (f11 ?v_1 (f11 f13 ?v1)) ?v2)) (f18 (f19 f21 (f3 (f22 f23 (f3 f26 ?v_0)) ?v2)) (f3 (f11 ?v_1 (f11 f12 ?v1)) ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f27 (f28 f29 ?v0) (f8 (f31 f32 (f8 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f33 (f34 f36 ?v0) (f33 (f34 f35 (f33 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f18 (f19 f21 ?v0) (f3 (f22 f23 (f3 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f27 (f28 f29 ?v0) (f27 (f28 f29 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (let ((?v_1 (f33 ?v_0 ?v1))) (= (f33 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f33 (f34 f36 ?v0) (f33 (f34 f36 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (+ (* 2 (f8 f9 ?v1)) 1))) (f18 (f19 f21 ?v0) (f18 (f19 f21 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f27 (f28 f29 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (let ((?v_1 (f33 ?v_0 ?v1))) (= (f33 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f33 (f34 f36 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f18 (f19 f21 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f19 f24 f25))) (= (f18 ?v_0 (f3 (f22 f23 ?v0) ?v1)) (f3 (f22 f23 (f18 ?v_0 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f8 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) 1 (f27 (f28 f29 ?v0) (f8 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f25 (f18 (f19 f21 ?v0) (f3 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f37 (f33 (f34 f36 ?v0) (f33 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (f27 (f28 f29 (+ 1 1)) ?v0))))
(assert (forall ((?v0 S4)) (= (f18 (f19 f20 ?v0) ?v0) (f18 (f19 f21 (f18 (f19 f20 f25) f25)) ?v0))))
(assert (forall ((?v0 S2)) (= (f33 (f34 f38 ?v0) ?v0) (f33 (f34 f36 (f33 (f34 f38 f37) f37)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (f27 (f28 f29 ?v1) ?v0)) (f27 (f28 f29 (+ ?v1 1)) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f20 ?v0) (f18 (f19 f21 ?v1) ?v0)) (f18 (f19 f21 (f18 (f19 f20 ?v1) f25)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f33 (f34 f38 ?v0) (f33 (f34 f36 ?v1) ?v0)) (f33 (f34 f36 (f33 (f34 f38 ?v1) f37)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f27 (f28 f29 ?v0) ?v1) ?v1) (f27 (f28 f29 (+ ?v0 1)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f20 (f18 (f19 f21 ?v0) ?v1)) ?v1) (f18 (f19 f21 (f18 (f19 f20 ?v0) f25)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f33 (f34 f38 (f33 (f34 f36 ?v0) ?v1)) ?v1) (f33 (f34 f36 (f33 (f34 f38 ?v0) f37)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f8 ?v_0 (f6 f7 (f27 (f28 f29 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f8 (f31 f32 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f6 f7 (f27 (f28 f29 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f33 (f34 f35 (f33 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (f27 (f28 f29 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f3 (f22 f23 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f8 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f8 (f31 f32 (f8 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f33 (f34 f35 (f33 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (* 2 (f8 f9 ?v1)))) (f3 (f22 f23 (f3 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f8 (f31 f32 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f6 f7 (f27 (f28 f29 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 (f34 f35 (f33 ?v_0 ?v1)) ?v2) (f33 ?v_0 (f6 f7 (f27 (f28 f29 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 (f22 f23 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f27 (f28 f29 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f27 (f28 f29 (f8 f9 ?v0)) (f8 f9 (f33 ?v_0 (f6 f7 (- (f8 f9 ?v1) 1)))))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 (f19 f21 (f18 ?v_0 ?v1)) (f18 (f19 f21 ?v2) ?v3)) (f18 (f19 f21 (f18 ?v_0 ?v2)) (f18 (f19 f21 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 (f28 f29 (f27 ?v_0 ?v1)) (f27 (f28 f29 ?v2) ?v3)) (f27 (f28 f29 (f27 ?v_0 ?v2)) (f27 (f28 f29 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f34 f36 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) (f33 (f34 f36 ?v2) ?v3)) (f33 (f34 f36 (f33 ?v_0 ?v2)) (f33 (f34 f36 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f19 f21 (f18 (f19 f21 ?v0) ?v1))) (?v_0 (f19 f21 ?v2))) (= (f18 ?v_1 (f18 ?v_0 ?v3)) (f18 ?v_0 (f18 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f28 f29 (f27 (f28 f29 ?v0) ?v1))) (?v_0 (f28 f29 ?v2))) (= (f27 ?v_1 (f27 ?v_0 ?v3)) (f27 ?v_0 (f27 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f34 f36 (f33 (f34 f36 ?v0) ?v1))) (?v_0 (f34 f36 ?v2))) (= (f33 ?v_1 (f33 ?v_0 ?v3)) (f33 ?v_0 (f33 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f21 ?v0)) (?v_1 (f18 (f19 f21 ?v2) ?v3))) (= (f18 (f19 f21 (f18 ?v_0 ?v1)) ?v_1) (f18 ?v_0 (f18 (f19 f21 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f28 f29 ?v0)) (?v_1 (f27 (f28 f29 ?v2) ?v3))) (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v_1) (f27 ?v_0 (f27 (f28 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f34 f36 ?v0)) (?v_1 (f33 (f34 f36 ?v2) ?v3))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v_1) (f33 ?v_0 (f33 (f34 f36 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 (f19 f21 (f18 ?v_0 ?v1)) ?v2) (f18 (f19 f21 (f18 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2) (f27 (f28 f29 (f27 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f36 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v2) (f33 (f34 f36 (f33 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 (f19 f21 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f21 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2) (f27 ?v_0 (f27 (f28 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f36 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v2) (f33 ?v_0 (f33 (f34 f36 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f21 ?v1) ?v2)) (f18 (f19 f21 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 ?v_0 (f27 (f28 f29 ?v1) ?v2)) (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f36 ?v0))) (= (f33 ?v_0 (f33 (f34 f36 ?v1) ?v2)) (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f19 f21 ?v0)) (?v_0 (f19 f21 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f28 f29 ?v0)) (?v_0 (f28 f29 ?v1))) (= (f27 ?v_1 (f27 ?v_0 ?v2)) (f27 ?v_0 (f27 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f34 f36 ?v0)) (?v_0 (f34 f36 ?v1))) (= (f33 ?v_1 (f33 ?v_0 ?v2)) (f33 ?v_0 (f33 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f21 ?v0) ?v1) (f18 (f19 f21 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f27 (f28 f29 ?v0) ?v1) (f27 (f28 f29 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f33 (f34 f36 ?v0) ?v1) (f33 (f34 f36 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 (f19 f20 ?v2) ?v3)) (f18 (f19 f20 (f18 ?v_0 ?v2)) (f18 (f19 f20 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f34 f38 ?v0))) (= (f33 (f34 f38 (f33 ?v_0 ?v1)) (f33 (f34 f38 ?v2) ?v3)) (f33 (f34 f38 (f33 ?v_0 ?v2)) (f33 (f34 f38 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 (f19 f20 (f18 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f38 ?v0))) (= (f33 (f34 f38 (f33 ?v_0 ?v1)) ?v2) (f33 (f34 f38 (f33 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f38 ?v0))) (= (f33 (f34 f38 (f33 ?v_0 ?v1)) ?v2) (f33 ?v_0 (f33 (f34 f38 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f38 ?v0))) (= (f33 ?v_0 (f33 (f34 f38 ?v1) ?v2)) (f33 (f34 f38 (f33 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f19 f20 ?v0)) (?v_0 (f19 f20 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f34 f38 ?v0)) (?v_0 (f34 f38 ?v1))) (= (f33 ?v_1 (f33 ?v_0 ?v2)) (f33 ?v_0 (f33 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f33 (f34 f38 ?v0) ?v1) (f33 (f34 f38 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f31 f32 (f27 f39 ?v0)) ?v_0) (f8 (f31 f32 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f8 (f31 f32 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f35 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f22 f23 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 (f31 f32 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f35 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f22 f23 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 (f31 f32 ?v0) (f6 f7 2)))) (= (f27 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f27 f39 (f8 (f31 f32 ?v0) ?v1)) (f8 (f31 f32 (f27 f39 ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (= (f6 f7 (f27 (f28 f29 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f27 (f28 f29 (f8 f9 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f28 f29 ?v0)) (?v_1 (f28 f29 ?v2))) (= (= (+ (f27 ?v_0 ?v1) (f27 ?v_1 ?v3)) (+ (f27 ?v_0 ?v3) (f27 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f21 ?v0)) (?v_1 (f19 f21 ?v2))) (= (= (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 ?v_1 ?v3)) (f18 (f19 f20 (f18 ?v_0 ?v3)) (f18 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f34 f36 ?v0)) (?v_1 (f34 f36 ?v2))) (= (= (f33 (f34 f38 (f33 ?v_0 ?v1)) (f33 ?v_1 ?v3)) (f33 (f34 f38 (f33 ?v_0 ?v3)) (f33 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f27 (f28 f29 ?v0) ?v1) (f27 (f28 f29 ?v2) ?v1)) (f27 (f28 f29 (+ ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f20 (f18 (f19 f21 ?v0) ?v1)) (f18 (f19 f21 ?v2) ?v1)) (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f33 (f34 f38 (f33 (f34 f36 ?v0) ?v1)) (f33 (f34 f36 ?v2) ?v1)) (f33 (f34 f36 (f33 (f34 f38 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f27 (f28 f29 (+ ?v0 ?v1)) ?v2) (+ (f27 (f28 f29 ?v0) ?v2) (f27 (f28 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v1)) ?v2) (f18 (f19 f20 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f33 (f34 f36 (f33 (f34 f38 ?v0) ?v1)) ?v2) (f33 (f34 f38 (f33 (f34 f36 ?v0) ?v2)) (f33 (f34 f36 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f28 f29 ?v0)) (?v_1 (f28 f29 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (f27 ?v_0 ?v2) (f27 ?v_1 ?v3)) (+ (f27 ?v_0 ?v3) (f27 ?v_1 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f19 f21 ?v0)) (?v_1 (f19 f21 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f18 (f19 f20 (f18 ?v_0 ?v2)) (f18 ?v_1 ?v3)) (f18 (f19 f20 (f18 ?v_0 ?v3)) (f18 ?v_1 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f34 f36 ?v0)) (?v_1 (f34 f36 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f33 (f34 f38 (f33 ?v_0 ?v2)) (f33 ?v_1 ?v3)) (f33 (f34 f38 (f33 ?v_0 ?v3)) (f33 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 ?v_0 (+ ?v1 ?v2)) (+ (f27 ?v_0 ?v1) (f27 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f36 ?v0))) (= (f33 ?v_0 (f33 (f34 f38 ?v1) ?v2)) (f33 (f34 f38 (f33 ?v_0 ?v1)) (f33 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S4)) (= (f18 (f19 f21 ?v0) f25) ?v0)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f36 ?v0) f37) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f18 (f19 f21 f25) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f36 f37) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f31 f32 ?v2))) (=> (<= ?v_1 ?v_0) (= (f8 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f27 (f28 f29 (f8 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f34 f35 ?v2))) (=> (<= ?v_1 ?v_0) (= (f33 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f33 (f34 f36 (f33 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (let ((?v_0 (f8 f9 ?v1)) (?v_1 (f8 f9 ?v0)) (?v_2 (f22 f23 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f18 (f19 f21 (f3 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f27 (f28 f29 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) (f33 ?v_0 ?v2)) (f33 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 (f19 f21 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f8 (f31 f32 (f27 (f28 f29 ?v0) ?v1)) ?v2) (f27 (f28 f29 (f8 (f31 f32 ?v0) ?v2)) (f8 (f31 f32 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f33 (f34 f35 (f33 (f34 f36 ?v0) ?v1)) ?v2) (f33 (f34 f36 (f33 (f34 f35 ?v0) ?v2)) (f33 (f34 f35 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (= (f3 (f22 f23 (f18 (f19 f21 ?v0) ?v1)) ?v2) (f18 (f19 f21 (f3 (f22 f23 ?v0) ?v2)) (f3 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f8 (f31 f32 (f27 (f28 f29 ?v0) ?v1)) ?v2) (f27 (f28 f29 (f8 (f31 f32 ?v0) ?v2)) (f8 (f31 f32 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f33 (f34 f35 (f33 (f34 f36 ?v0) ?v1)) ?v2) (f33 (f34 f36 (f33 (f34 f35 ?v0) ?v2)) (f33 (f34 f35 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (= (f3 (f22 f23 (f18 (f19 f21 ?v0) ?v1)) ?v2) (f18 (f19 f21 (f3 (f22 f23 ?v0) ?v2)) (f3 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f8 (f31 f32 ?v0) ?v1))) (= (f27 (f28 f29 ?v_0) ?v0) (f27 (f28 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f33 (f34 f35 ?v0) ?v1))) (= (f33 (f34 f36 ?v_0) ?v0) (f33 (f34 f36 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f3 (f22 f23 ?v0) ?v1))) (= (f18 (f19 f21 ?v_0) ?v0) (f18 (f19 f21 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f27 (f28 f29 (f8 ?v_0 ?v1)) ?v0) (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v0) (f33 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 (f19 f21 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f27 (f28 f29 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f33 (f34 f36 (f33 ?v_0 ?v1)) (f33 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f18 (f19 f21 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f27 (f28 f29 ?v0) (f8 ?v_0 ?v1)) (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 (f34 f36 ?v0) (f33 ?v_0 ?v1)) (f33 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f18 (f19 f21 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (f8 (f31 f32 ?v0) (f6 f7 3)) (f27 (f28 f29 (f27 (f28 f29 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f33 (f34 f35 ?v0) (f6 f7 3)) (f33 (f34 f36 (f33 (f34 f36 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S4)) (= (f3 (f22 f23 ?v0) (f6 f7 3)) (f18 (f19 f21 (f18 (f19 f21 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f8 (f31 f32 ?v0) (f6 f7 2)) (f27 (f28 f29 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f33 (f34 f35 ?v0) (f6 f7 2)) (f33 (f34 f36 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (f3 (f22 f23 ?v0) (f6 f7 2)) (f18 (f19 f21 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f27 (f28 f29 (f8 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f18 (f19 f21 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f27 (f28 f29 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f33 (f34 f36 ?v0) (f33 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f18 (f19 f21 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f27 (f28 f29 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f34 f35 ?v0))) (= (f33 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f33 (f34 f36 ?v0) (f33 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v1) 1))) (f18 (f19 f21 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f27 (f28 f29 ?v0) ?v0) (f8 (f31 f32 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S2)) (= (f33 (f34 f36 ?v0) ?v0) (f33 (f34 f35 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S4)) (= (f18 (f19 f21 ?v0) ?v0) (f3 (f22 f23 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (= (f8 (f31 f32 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S4)) (= (f3 (f22 f23 ?v0) (f6 f7 0)) f25)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f35 ?v0) (f6 f7 0)) f37)))
(assert (forall ((?v0 Int)) (= (f8 (f31 f32 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S4)) (= (f3 (f22 f23 ?v0) (f6 f7 0)) f25)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f35 ?v0) (f6 f7 0)) f37)))
(assert (= (f8 (f31 f32 1) (f6 f7 2)) 1))
(assert (= (f3 (f22 f23 f25) (f6 f7 2)) f25))
(assert (= (f33 (f34 f35 f37) (f6 f7 2)) f37))
(assert (forall ((?v0 S2)) (= (f8 (f31 f32 1) ?v0) 1)))
(assert (forall ((?v0 S2)) (= (f3 (f22 f23 f25) ?v0) f25)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f35 f37) ?v0) f37)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (= (f3 (f22 f23 (f18 (f19 f24 ?v0) ?v1)) ?v2) (f18 (f19 f24 (f3 (f22 f23 ?v0) ?v2)) (f3 (f22 f23 ?v1) ?v2)))))
(assert (= f32 (f40 (f41 f42 1) f29)))
(assert (= f23 (f43 (f44 f45 f25) f21)))
(assert (= f35 (f46 (f47 f48 f37) f36)))
(assert (forall ((?v0 S4)) (= (f18 (f19 f24 ?v0) f25) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f24 (f18 (f19 f20 ?v0) ?v1)) ?v2) (f18 (f19 f20 (f18 (f19 f24 ?v0) ?v2)) (f18 (f19 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f24 (f18 (f19 f20 ?v0) ?v1)) ?v2) (f18 (f19 f20 (f18 (f19 f24 ?v0) ?v2)) (f18 (f19 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f18 (f19 f21 (f18 (f19 f24 ?v0) ?v1)) (f18 (f19 f24 ?v2) ?v3)) (f18 (f19 f24 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f24 ?v1) ?v2)) (f18 (f19 f24 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f31 f32 ?v1))) (=> (< 0 ?v_0) (= (f27 (f28 f29 (f8 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f8 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f34 f35 ?v1))) (=> (< 0 ?v_0) (= (f33 (f34 f36 (f33 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f33 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S4)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f22 f23 ?v1))) (=> (< 0 ?v_0) (= (f18 (f19 f21 (f3 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S4)) (= (f18 (f19 f21 ?v0) f25) ?v0)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f36 ?v0) f37) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S4)) (= (f18 (f19 f21 ?v0) f25) ?v0)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f36 ?v0) f37) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f18 (f19 f21 f25) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f36 f37) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f8 f9 (f33 (f34 f35 ?v0) ?v1))) (or (< 0 (f8 f9 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f33 (f34 f35 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f33 (f34 f35 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f35 ?v0))) (=> (< 0 (f8 f9 ?v0)) (=> (< (f8 f9 (f33 ?v_0 ?v1)) (f8 f9 (f33 ?v_0 ?v2))) (< (f8 f9 ?v1) (f8 f9 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f8 f9 ?v0)) (<= ?v_0 (f8 f9 (f33 (f34 f35 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S16) (?v2 S2) (?v3 S2)) (let ((?v_0 (f34 (f46 (f47 f48 ?v0) ?v1) ?v2))) (= (f33 ?v_0 (f6 f7 (+ (f8 f9 ?v3) 1))) (f33 (f34 ?v1 ?v2) (f33 ?v_0 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S4) (?v3 S2)) (let ((?v_0 (f22 (f43 (f44 f45 ?v0) ?v1) ?v2))) (= (f3 ?v_0 (f6 f7 (+ (f8 f9 ?v3) 1))) (f18 (f19 ?v1 ?v2) (f3 ?v_0 ?v3))))))
(assert (forall ((?v0 Int) (?v1 S13) (?v2 Int) (?v3 S2)) (let ((?v_0 (f31 (f40 (f41 f42 ?v0) ?v1) ?v2))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v3) 1))) (f27 (f28 ?v1 ?v2) (f8 ?v_0 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S16) (?v2 S2)) (= (f33 (f34 (f46 (f47 f48 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S10) (?v2 S4)) (= (f3 (f22 (f43 (f44 f45 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S13) (?v2 Int)) (= (f8 (f31 (f40 (f41 f42 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f27 f39 (f27 (f28 f29 ?v0) ?v1)) (f27 (f28 f29 (f27 f39 ?v0)) (f27 f39 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f27 f39 ?v0))) (= (f27 (f28 f29 ?v_0) ?v_0) (f27 (f28 f29 ?v0) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 (f19 f21 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f21 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f28 f29 ?v0))) (= (f27 (f28 f29 (f27 ?v_0 ?v1)) ?v2) (f27 ?v_0 (f27 (f28 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f36 ?v0))) (= (f33 (f34 f36 (f33 ?v_0 ?v1)) ?v2) (f33 ?v_0 (f33 (f34 f36 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f27 f39 ?v0) (f27 f39 ?v1)))) (= (f27 f39 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f38 ?v0))) (= (f33 (f34 f38 (f33 ?v_0 ?v1)) ?v2) (f33 ?v_0 (f33 (f34 f38 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f27 (f28 f49 ?v0) ?v1) ?v2) (f27 (f28 f49 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f33 (f34 f38 (f33 (f34 f50 ?v0) ?v1)) ?v2) (f33 (f34 f50 (f33 (f34 f38 ?v0) ?v2)) (f33 (f34 f38 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f27 (f28 f51 ?v0) ?v1) ?v2) (f27 (f28 f51 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f33 (f34 f38 (f33 (f34 f52 ?v0) ?v1)) ?v2) (f33 (f34 f52 (f33 (f34 f38 ?v0) ?v2)) (f33 (f34 f38 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f20 ?v0))) (= (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f38 ?v0))) (= (= (f33 ?v_0 ?v1) (f33 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f33 (f34 f38 ?v0) ?v1) (f33 (f34 f38 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f20 ?v0))) (=> (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f38 ?v0))) (=> (= (f33 ?v_0 ?v1) (f33 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f20 ?v0))) (=> (= (f18 ?v_0 ?v1) (f18 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f34 f38 ?v0))) (=> (= (f33 ?v_0 ?v1) (f33 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f33 (f34 f38 ?v0) ?v1) (f33 (f34 f38 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (= (f27 f39 1) 1))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S4)) (= (= f25 ?v0) (= ?v0 f25))))
(assert (forall ((?v0 S2)) (= (= f37 ?v0) (= ?v0 f37))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f19 f21 ?v0))) (= (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f27 (f28 f29 (+ ?v0 ?v1)) ?v2) (+ (f27 (f28 f29 ?v0) ?v2) (f27 (f28 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v1)) ?v2) (f18 (f19 f20 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f33 (f34 f36 (f33 (f34 f38 ?v0) ?v1)) ?v2) (f33 (f34 f38 (f33 (f34 f36 ?v0) ?v2)) (f33 (f34 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v1)) ?v2) (f18 (f19 f20 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v1)) ?v2) (f18 (f19 f20 (f18 (f19 f21 ?v0) ?v2)) (f18 (f19 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (f27 (f28 f29 ?v0) ?v1) (+ (f27 (f28 f29 ?v2) ?v1) ?v3)) (+ (f27 (f28 f29 (+ ?v0 ?v2)) ?v1) ?v3))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f18 (f19 f20 (f18 (f19 f21 ?v0) ?v1)) (f18 (f19 f20 (f18 (f19 f21 ?v2) ?v1)) ?v3)) (f18 (f19 f20 (f18 (f19 f21 (f18 (f19 f20 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f33 (f34 f38 (f33 (f34 f36 ?v0) ?v1)) (f33 (f34 f38 (f33 (f34 f36 ?v2) ?v1)) ?v3)) (f33 (f34 f38 (f33 (f34 f36 (f33 (f34 f38 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f18 (f19 f21 f25) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f33 (f34 f36 f37) ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v1))) (let ((?v_2 (f6 f7 (* 2 ?v_0))) (?v_4 (f14 f30 ?v0)) (?v_3 (f6 f7 (- ?v_1 ?v_0)))) (=> (< 0 ?v_0) (=> (<= ?v_0 ?v_1) (= (f3 (f11 (f14 f30 ?v_2) ?v2) ?v1) (f18 (f19 f53 (f3 (f11 ?v_4 (f11 f13 ?v2)) ?v_3)) (f18 (f19 f21 (f3 (f22 f23 (f3 f26 ?v_2)) ?v_3)) (f3 (f11 ?v_4 (f11 f12 ?v2)) ?v_3))))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f8 f9 ?v0))) (=> (< 0 ?v_0) (= (f3 (f22 f23 (f3 f26 (f6 f7 (* 2 ?v_0)))) ?v0) (f18 f54 f25))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 f9 (f33 (f34 f35 ?v0) ?v1)) (f8 (f31 f32 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f8 f9 (f33 (f34 f35 ?v0) ?v1))) (or (= ?v1 (f6 f7 0)) (< 0 (f8 f9 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f31 f32 (f8 f9 ?v0)) ?v1) (f8 f9 (f33 (f34 f35 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f31 f32 (f8 f9 ?v0)) ?v1) (f8 f9 (f33 (f34 f35 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f8 (f31 f32 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f8 (f31 f32 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f53 ?v0) ?v1) (f18 (f19 f20 ?v0) (f18 f54 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f53 ?v0) ?v1) (f18 (f19 f20 ?v0) (f18 f54 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 (- ?v1)) (+ ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f18 (f19 f53 ?v0) (f18 f54 ?v1)) (f18 (f19 f20 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f31 f32 ?v0))) (= (f8 ?v_0 (f6 f7 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f27 (f28 f29 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f8 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f18 (f19 f53 ?v0) ?v1) (f18 (f19 f53 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f27 (f28 f51 ?v0) ?v1) ?v2) (f27 (f28 f51 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f27 (f28 f49 ?v0) ?v1) ?v2) (f27 (f28 f49 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f18 f54 ?v0) (f18 f54 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f18 f54 ?v0) ?v1) (= (f18 f54 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 (f18 f54 ?v1)) (= ?v1 (f18 f54 ?v0)))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
