(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S3)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S6) S3)
(declare-fun f7 (S7 S3) S5)
(declare-fun f8 () S7)
(declare-fun f9 () S3)
(declare-fun f10 () S6)
(declare-fun f11 () S6)
(declare-fun f12 (S8 S6) Int)
(declare-fun f13 () S8)
(declare-fun f14 (S9 Int) S6)
(declare-fun f15 () S9)
(declare-fun f16 () S3)
(declare-fun f17 () S3)
(declare-fun f18 (S10 Int) S8)
(declare-fun f19 () S10)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 f9)) (?v_1 (f12 f13 f10)) (?v_2 (f12 f13 f11))) (not (= (f3 (f4 f5 (f6 ?v_0 f10)) (f6 ?v_0 f11)) (ite (<= ?v_2 ?v_1) (f6 ?v_0 (f14 f15 (- ?v_1 ?v_2))) (f6 (f7 f8 (f3 (f4 f5 f16) f9)) (f14 f15 (- ?v_2 ?v_1))))))))
(assert (not (= f9 f17)))
(assert (not (<= (f12 f13 f11) (f12 f13 f10))))
(assert (forall ((?v0 Int)) (= (f12 (f18 f19 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) (f14 f15 0)) f16)))
(assert (forall ((?v0 Int)) (= (f12 (f18 f19 ?v0) (f14 f15 0)) 1)))
(assert (forall ((?v0 S6)) (= (f14 f15 (f12 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f13 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f13 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
