(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S4) S2)
(declare-fun f4 (S5 S2) S3)
(declare-fun f5 () S5)
(declare-fun f6 (S6 Int) S4)
(declare-fun f7 () S6)
(declare-fun f8 (S7 Int) Int)
(declare-fun f9 (S8 Int) S7)
(declare-fun f10 () S8)
(declare-fun f11 (S9 S4) Int)
(declare-fun f12 () S9)
(declare-fun f13 () S2)
(declare-fun f14 (S10 S2) S2)
(declare-fun f15 (S11 S2) S10)
(declare-fun f16 () S11)
(declare-fun f17 () S2)
(declare-fun f18 () S4)
(declare-fun f19 () S4)
(declare-fun f20 () S4)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f5 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S4)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (=> (not (= ?v0 f13)) (= (f3 (f4 f5 (f14 (f15 f16 ?v1) ?v0)) ?v2) (f14 (f15 f16 (f3 (f4 f5 ?v1) ?v2)) (f3 (f4 f5 ?v0) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S4)) (=> (not (= ?v0 f13)) (not (= (f3 (f4 f5 ?v0) ?v1) f13)))))
(assert (let ((?v_0 (f4 f5 f17)) (?v_1 (f11 f12 f18))) (not (=> (not (= f17 f13)) (= (f14 (f15 f16 (f3 ?v_0 (f6 f7 (f8 (f9 f10 ?v_1) (f11 f12 f19))))) (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 f20)) ?v_1)))) (f3 (f4 f5 (f14 (f15 f16 (f3 ?v_0 f19)) (f3 ?v_0 f20))) f18))))))
(assert (forall ((?v0 S4)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
