(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S2)
(declare-fun f8 () S4)
(declare-fun f9 (S5 S6) S2)
(declare-fun f10 (S7 S2) S5)
(declare-fun f11 () S7)
(declare-fun f12 () S6)
(declare-fun f13 () S2)
(declare-fun f14 () S2)
(declare-fun f15 (S8 Int) S6)
(declare-fun f16 () S8)
(declare-fun f17 (S9 S6) Int)
(declare-fun f18 () S9)
(declare-fun f19 (S10 S6) S6)
(declare-fun f20 (S11 S6) S10)
(declare-fun f21 () S11)
(declare-fun f22 () S6)
(declare-fun f23 () S11)
(declare-fun f24 (S12 Int) S9)
(declare-fun f25 () S12)
(declare-fun f26 (S13 Int) Int)
(declare-fun f27 (S14 Int) S13)
(declare-fun f28 () S14)
(declare-fun f29 () S6)
(declare-fun f30 () S11)
(declare-fun f31 () S13)
(declare-fun f32 (S15 S11) S11)
(declare-fun f33 (S16 S6) S15)
(declare-fun f34 () S16)
(declare-fun f35 (S17 S4) S7)
(declare-fun f36 (S18 S2) S17)
(declare-fun f37 () S18)
(declare-fun f38 (S19 S14) S12)
(declare-fun f39 (S20 Int) S19)
(declare-fun f40 () S20)
(declare-fun f41 () S14)
(declare-fun f42 () S14)
(declare-fun f43 () S3)
(declare-fun f44 (S6 S6) S1)
(declare-fun f45 (S6 S6) S1)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 S2)) (=> (= (f4 (f5 f6 f7) (f4 (f5 f8 (f9 (f10 f11 ?v0) f12)) f13)) f14) (= f3 f1))))
(assert (exists ((?v0 S2)) (= (f4 (f5 f6 f7) (f4 (f5 f8 ?v0) (f4 (f5 f8 f13) (f9 (f10 f11 ?v0) (f15 f16 (- (f17 f18 f12) 1)))))) f14)))
(assert (not (= f12 (f15 f16 0))))
(assert (not (= f12 (f15 f16 0))))
(assert (not (= f13 f14)))
(assert (exists ((?v0 S2)) (= (f4 (f5 f6 f7) (f4 (f5 f8 ?v0) (f4 (f5 f8 f13) (f9 (f10 f11 ?v0) (f15 f16 (- (f17 f18 f12) 1)))))) f14)))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 ?v1) (ite (= ?v1 (f15 f16 0)) f22 (f19 (f20 f23 ?v0) (f19 ?v_0 (f15 f16 (- (f17 f18 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 ?v1) (ite (= ?v1 (f15 f16 0)) f7 (f4 (f5 f8 ?v0) (f9 ?v_0 (f15 f16 (- (f17 f18 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 ?v1) (ite (= ?v1 (f15 f16 0)) 1 (f26 (f27 f28 ?v0) (f17 ?v_0 (f15 f16 (- (f17 f18 ?v1) 1)))))))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f21 f29) ?v0) (ite (= ?v0 (f15 f16 0)) f22 f29))))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f14) ?v0) (ite (= ?v0 (f15 f16 0)) f7 f14))))
(assert (forall ((?v0 S6)) (= (f17 (f24 f25 0) ?v0) (ite (= ?v0 (f15 f16 0)) 1 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (= (+ (f17 (f24 f25 ?v0) ?v_0) (f17 (f24 f25 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f30 ?v0) ?v0) (f19 (f20 f23 (f19 (f20 f30 f22) f22)) ?v0))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) ?v0) (f4 (f5 f8 (f4 (f5 f6 f7) f7)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (f26 (f27 f28 (+ 1 1)) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f19 (f20 f30 ?v0) (f19 (f20 f23 ?v1) ?v0)) (f19 (f20 f23 (f19 (f20 f30 ?v1) f22)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 ?v0) (f4 (f5 f8 ?v1) ?v0)) (f4 (f5 f8 (f4 (f5 f6 ?v1) f7)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (f26 (f27 f28 ?v1) ?v0)) (f26 (f27 f28 (+ ?v1 1)) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f19 (f20 f30 (f19 (f20 f23 ?v0) ?v1)) ?v1) (f19 (f20 f23 (f19 (f20 f30 ?v0) f22)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 (f4 (f5 f8 ?v0) ?v1)) ?v1) (f4 (f5 f8 (f4 (f5 f6 ?v0) f7)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f26 (f27 f28 ?v0) ?v1) ?v1) (f26 (f27 f28 (+ ?v0 1)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (f26 (f27 f28 ?v0) ?v0) (f26 (f27 f28 ?v1) ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6) (?v4 S6)) (let ((?v_0 (f20 f23 ?v0))) (=> (not (= ?v0 f29)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f19 (f20 f30 ?v1) (f19 ?v_0 ?v3)) (f19 (f20 f30 ?v2) (f19 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f5 f8 ?v0))) (=> (not (= ?v0 f14)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f4 (f5 f6 ?v1) (f4 ?v_0 ?v3)) (f4 (f5 f6 ?v2) (f4 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f27 f28 ?v0))) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (f26 ?v_0 ?v3)) (+ ?v2 (f26 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f21 f22) ?v0) f22)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f7) ?v0) f7)))
(assert (forall ((?v0 S6)) (= (f17 (f24 f25 1) ?v0) 1)))
(assert (= (f19 (f20 f21 f22) (f15 f16 2)) f22))
(assert (= (f9 (f10 f11 f7) (f15 f16 2)) f7))
(assert (= (f17 (f24 f25 1) (f15 f16 2)) 1))
(assert (forall ((?v0 S6)) (= (f19 (f20 f21 ?v0) (f15 f16 0)) f22)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f15 f16 0)) f7)))
(assert (forall ((?v0 Int)) (= (f17 (f24 f25 ?v0) (f15 f16 0)) 1)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f21 ?v0) (f15 f16 0)) f22)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f15 f16 0)) f7)))
(assert (forall ((?v0 Int)) (= (f17 (f24 f25 ?v0) (f15 f16 0)) 1)))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f15 f16 (f26 (f27 f28 (f17 f18 ?v1)) (f17 f18 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 (f20 f21 (f19 ?v_0 ?v1)) ?v2) (f19 ?v_0 (f15 f16 (f26 (f27 f28 (f17 f18 ?v1)) (f17 f18 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 (f24 f25 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f15 f16 (f26 (f27 f28 (f17 f18 ?v1)) (f17 f18 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f19 (f20 f21 (f19 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f17 (f24 f25 (f17 ?v_0 ?v1)) (f15 f16 2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f15 f16 (f26 (f27 f28 (f17 f18 ?v1)) (f17 f18 ?v2)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f15 f16 (f26 (f27 f28 (f17 f18 ?v1)) (f17 f18 ?v2)))) (f19 (f20 f21 (f19 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (f15 f16 (f26 (f27 f28 (f17 f18 ?v1)) (f17 f18 ?v2)))) (f17 (f24 f25 (f17 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f20 f23 ?v0))) (= (f19 (f20 f23 (f19 ?v_0 ?v1)) (f19 (f20 f23 ?v2) ?v3)) (f19 (f20 f23 (f19 ?v_0 ?v2)) (f19 (f20 f23 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 (f5 f8 (f4 ?v_0 ?v1)) (f4 (f5 f8 ?v2) ?v3)) (f4 (f5 f8 (f4 ?v_0 ?v2)) (f4 (f5 f8 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) (f26 (f27 f28 ?v2) ?v3)) (f26 (f27 f28 (f26 ?v_0 ?v2)) (f26 (f27 f28 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_1 (f20 f23 (f19 (f20 f23 ?v0) ?v1))) (?v_0 (f20 f23 ?v2))) (= (f19 ?v_1 (f19 ?v_0 ?v3)) (f19 ?v_0 (f19 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f5 f8 (f4 (f5 f8 ?v0) ?v1))) (?v_0 (f5 f8 ?v2))) (= (f4 ?v_1 (f4 ?v_0 ?v3)) (f4 ?v_0 (f4 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f27 f28 (f26 (f27 f28 ?v0) ?v1))) (?v_0 (f27 f28 ?v2))) (= (f26 ?v_1 (f26 ?v_0 ?v3)) (f26 ?v_0 (f26 ?v_1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f20 f23 ?v0)) (?v_1 (f19 (f20 f23 ?v2) ?v3))) (= (f19 (f20 f23 (f19 ?v_0 ?v1)) ?v_1) (f19 ?v_0 (f19 (f20 f23 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f8 ?v0)) (?v_1 (f4 (f5 f8 ?v2) ?v3))) (= (f4 (f5 f8 (f4 ?v_0 ?v1)) ?v_1) (f4 ?v_0 (f4 (f5 f8 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f26 (f27 f28 ?v2) ?v3))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v_1) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f23 ?v0))) (= (f19 (f20 f23 (f19 ?v_0 ?v1)) ?v2) (f19 (f20 f23 (f19 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 (f5 f8 (f4 ?v_0 ?v1)) ?v2) (f4 (f5 f8 (f4 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f28 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f23 ?v0))) (= (f19 (f20 f23 (f19 ?v_0 ?v1)) ?v2) (f19 ?v_0 (f19 (f20 f23 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 (f5 f8 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f23 ?v0))) (= (f19 ?v_0 (f19 (f20 f23 ?v1) ?v2)) (f19 (f20 f23 (f19 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 ?v_0 (f4 (f5 f8 ?v1) ?v2)) (f4 (f5 f8 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2)) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_1 (f20 f23 ?v0)) (?v_0 (f20 f23 ?v1))) (= (f19 ?v_1 (f19 ?v_0 ?v2)) (f19 ?v_0 (f19 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f5 f8 ?v0)) (?v_0 (f5 f8 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f27 f28 ?v0)) (?v_0 (f27 f28 ?v1))) (= (f26 ?v_1 (f26 ?v_0 ?v2)) (f26 ?v_0 (f26 ?v_1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f19 (f20 f23 ?v0) ?v1) (f19 (f20 f23 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f8 ?v0) ?v1) (f4 (f5 f8 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 (f5 f6 ?v2) ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v2)) (f4 (f5 f6 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 (f5 f6 (f4 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f5 f6 ?v0)) (?v_0 (f5 f6 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2))) (= (f17 (f24 f25 (f26 f31 ?v0)) ?v_0) (f17 (f24 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f21 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f17 (f24 f25 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f21 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f17 (f24 f25 ?v0) (f15 f16 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 (f24 f25 ?v0) (f15 f16 2)))) (= (f26 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (f26 f31 (f17 (f24 f25 ?v0) ?v1)) (f17 (f24 f25 (f26 f31 ?v0)) ?v1))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 ?v0) f29) f29)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 ?v0) f14) f14)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 f29) ?v0) f29)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 f14) ?v0) f14)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= ?v0 (f19 (f20 f30 ?v0) ?v1)) (= ?v1 f29))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 (f4 (f5 f6 ?v0) ?v1)) (= ?v1 f14))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f30 ?v0) f29) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f30 f29) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f20 f23 ?v0)) (?v_1 (f20 f23 ?v2))) (= (= (f19 (f20 f30 (f19 ?v_0 ?v1)) (f19 ?v_1 ?v3)) (f19 (f20 f30 (f19 ?v_0 ?v3)) (f19 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f8 ?v0)) (?v_1 (f5 f8 ?v2))) (= (= (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 ?v_1 ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v3)) (f4 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f27 f28 ?v2))) (= (= (+ (f26 ?v_0 ?v1) (f26 ?v_1 ?v3)) (+ (f26 ?v_0 ?v3) (f26 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f19 (f20 f30 (f19 (f20 f23 ?v0) ?v1)) (f19 (f20 f23 ?v2) ?v1)) (f19 (f20 f23 (f19 (f20 f30 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f6 (f4 (f5 f8 ?v0) ?v1)) (f4 (f5 f8 ?v2) ?v1)) (f4 (f5 f8 (f4 (f5 f6 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) (f26 (f27 f28 (+ ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f19 (f20 f23 (f19 (f20 f30 ?v0) ?v1)) ?v2) (f19 (f20 f30 (f19 (f20 f23 ?v0) ?v2)) (f19 (f20 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f8 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f8 ?v0) ?v2)) (f4 (f5 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f26 (f27 f28 (+ ?v0 ?v1)) ?v2) (+ (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (let ((?v_0 (f20 f23 ?v0)) (?v_1 (f20 f23 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f19 (f20 f30 (f19 ?v_0 ?v2)) (f19 ?v_1 ?v3)) (f19 (f20 f30 (f19 ?v_0 ?v3)) (f19 ?v_1 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f5 f8 ?v0)) (?v_1 (f5 f8 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f4 (f5 f6 (f4 ?v_0 ?v2)) (f4 ?v_1 ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v3)) (f4 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f27 f28 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (f26 ?v_0 ?v2) (f26 ?v_1 ?v3)) (+ (f26 ?v_0 ?v3) (f26 ?v_1 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f23 ?v0))) (= (f19 ?v_0 (f19 (f20 f30 ?v1) ?v2)) (f19 (f20 f30 (f19 ?v_0 ?v1)) (f19 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (+ ?v1 ?v2)) (+ (f26 ?v_0 ?v1) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 ?v0) f22) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 ?v0) f7) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 f22) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 f7) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (not (= ?v0 f14)) (not (= (f9 (f10 f11 ?v0) ?v1) f14)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (not (= ?v0 0)) (not (= (f17 (f24 f25 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2)) (= (= (f9 (f10 f11 ?v0) (f15 f16 2)) f14) (= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= (f17 (f24 f25 ?v0) (f15 f16 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f19 (f20 f21 ?v0) ?v1) f29) (and (= ?v0 f29) (not (= ?v1 (f15 f16 0)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (= (f9 (f10 f11 ?v0) ?v1) f14) (and (= ?v0 f14) (not (= ?v1 (f15 f16 0)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (= (f17 (f24 f25 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f15 f16 0)))))))
(assert (= (f19 (f20 f21 f29) (f15 f16 2)) f29))
(assert (= (f9 (f10 f11 f14) (f15 f16 2)) f14))
(assert (= (f17 (f24 f25 0) (f15 f16 2)) 0))
(assert (forall ((?v0 S6)) (= (f19 (f20 f21 f29) (f15 f16 (+ (f17 f18 ?v0) 1))) f29)))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f14) (f15 f16 (+ (f17 f18 ?v0) 1))) f14)))
(assert (forall ((?v0 S6)) (= (f17 (f24 f25 0) (f15 f16 (+ (f17 f18 ?v0) 1))) 0)))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0)) (?v_2 (f10 f11 ?v2))) (=> (<= ?v_1 ?v_0) (= (f9 ?v_2 (f15 f16 (- (+ ?v_0 1) ?v_1))) (f4 (f5 f8 (f9 ?v_2 (f15 f16 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0)) (?v_2 (f20 f21 ?v2))) (=> (<= ?v_1 ?v_0) (= (f19 ?v_2 (f15 f16 (- (+ ?v_0 1) ?v_1))) (f19 (f20 f23 (f19 ?v_2 (f15 f16 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0)) (?v_2 (f24 f25 ?v2))) (=> (<= ?v_1 ?v_0) (= (f17 ?v_2 (f15 f16 (- (+ ?v_0 1) ?v_1))) (f26 (f27 f28 (f17 ?v_2 (f15 f16 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f4 (f5 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 (f20 f23 (f19 ?v_0 ?v1)) (f19 ?v_0 ?v2)) (f19 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f26 (f27 f28 (f17 ?v_0 ?v1)) (f17 ?v_0 ?v2)) (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (= (f9 (f10 f11 (f4 (f5 f8 ?v0) ?v1)) ?v2) (f4 (f5 f8 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f19 (f20 f21 (f19 (f20 f23 ?v0) ?v1)) ?v2) (f19 (f20 f23 (f19 (f20 f21 ?v0) ?v2)) (f19 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f17 (f24 f25 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f28 (f17 (f24 f25 ?v0) ?v2)) (f17 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (= (f9 (f10 f11 (f4 (f5 f8 ?v0) ?v1)) ?v2) (f4 (f5 f8 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f19 (f20 f21 (f19 (f20 f23 ?v0) ?v1)) ?v2) (f19 (f20 f23 (f19 (f20 f21 ?v0) ?v2)) (f19 (f20 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f17 (f24 f25 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f28 (f17 (f24 f25 ?v0) ?v2)) (f17 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (= (f4 (f5 f8 ?v_0) ?v0) (f4 (f5 f8 ?v0) ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f19 (f20 f21 ?v0) ?v1))) (= (f19 (f20 f23 ?v_0) ?v0) (f19 (f20 f23 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f17 (f24 f25 ?v0) ?v1))) (= (f26 (f27 f28 ?v_0) ?v0) (f26 (f27 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f4 (f5 f8 (f9 ?v_0 ?v1)) ?v0) (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 (f20 f23 (f19 ?v_0 ?v1)) ?v0) (f19 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f26 (f27 f28 (f17 ?v_0 ?v1)) ?v0) (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f4 (f5 f8 ?v_1) ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f19 ?v_0 ?v1))) (= (f19 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f19 (f20 f23 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 (f15 f16 (* 2 (f17 f18 ?v1)))) (f26 (f27 f28 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2)))) (f4 (f5 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2)))) (f19 (f20 f23 (f19 ?v_0 ?v1)) (f19 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) (f17 f18 ?v2)))) (f26 (f27 f28 (f17 ?v_0 ?v1)) (f17 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f4 (f5 f8 ?v0) (f9 ?v_0 ?v1)) (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 (f20 f23 ?v0) (f19 ?v_0 ?v1)) (f19 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f26 (f27 f28 ?v0) (f17 ?v_0 ?v1)) (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f15 f16 (+ (* 2 (f17 f18 ?v1)) 1))) (f4 (f5 f8 ?v0) (f4 (f5 f8 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (let ((?v_1 (f19 ?v_0 ?v1))) (= (f19 ?v_0 (f15 f16 (+ (* 2 (f17 f18 ?v1)) 1))) (f19 (f20 f23 ?v0) (f19 (f20 f23 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (let ((?v_1 (f17 ?v_0 ?v1))) (= (f17 ?v_0 (f15 f16 (+ (* 2 (f17 f18 ?v1)) 1))) (f26 (f27 f28 ?v0) (f26 (f27 f28 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f15 f16 (+ (* 2 (f17 f18 ?v1)) 1))) (f4 (f5 f8 ?v0) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f15 f16 2)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f15 f16 (+ (* 2 (f17 f18 ?v1)) 1))) (f19 (f20 f23 ?v0) (f19 (f20 f21 (f19 ?v_0 ?v1)) (f15 f16 2)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (f15 f16 (+ (* 2 (f17 f18 ?v1)) 1))) (f26 (f27 f28 ?v0) (f17 (f24 f25 (f17 ?v_0 ?v1)) (f15 f16 2)))))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f15 f16 3)) (f4 (f5 f8 (f4 (f5 f8 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f21 ?v0) (f15 f16 3)) (f19 (f20 f23 (f19 (f20 f23 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f17 (f24 f25 ?v0) (f15 f16 3)) (f26 (f27 f28 (f26 (f27 f28 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f15 f16 2)) (f4 (f5 f8 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f21 ?v0) (f15 f16 2)) (f19 (f20 f23 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f17 (f24 f25 ?v0) (f15 f16 2)) (f26 (f27 f28 ?v0) ?v0))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f4 (f5 f8 (f9 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f19 (f20 f23 (f19 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f26 (f27 f28 (f17 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f4 (f5 f8 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f19 (f20 f23 ?v0) (f19 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f26 (f27 f28 ?v0) (f17 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f4 (f5 f8 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f19 (f20 f23 ?v0) (f19 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v1) 1))) (f26 (f27 f28 ?v0) (f17 ?v_0 ?v1))))))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 ?v0) ?v0) (f9 (f10 f11 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 ?v0) ?v0) (f19 (f20 f21 ?v0) (f15 f16 2)))))
(assert (forall ((?v0 Int)) (= (f26 (f27 f28 ?v0) ?v0) (f17 (f24 f25 ?v0) (f15 f16 2)))))
(assert (= f21 (f32 (f33 f34 f22) f23)))
(assert (= f11 (f35 (f36 f37 f7) f8)))
(assert (= f25 (f38 (f39 f40 1) f28)))
(assert (forall ((?v0 S6) (?v1 S2)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f10 f11 ?v1))) (=> (< 0 ?v_0) (= (f4 (f5 f8 (f9 ?v_1 (f15 f16 (- ?v_0 1)))) ?v1) (f9 ?v_1 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f20 f21 ?v1))) (=> (< 0 ?v_0) (= (f19 (f20 f23 (f19 ?v_1 (f15 f16 (- ?v_0 1)))) ?v1) (f19 ?v_1 ?v0))))))
(assert (forall ((?v0 S6) (?v1 Int)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f24 f25 ?v1))) (=> (< 0 ?v_0) (= (f26 (f27 f28 (f17 ?v_1 (f15 f16 (- ?v_0 1)))) ?v1) (f17 ?v_1 ?v0))))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 ?v0) f22) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 ?v0) f7) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 ?v0) f22) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 ?v0) f7) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 f22) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 f7) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 f22) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 f7) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (= (f19 (f20 f30 (f19 (f20 f23 ?v0) ?v1)) (f19 (f20 f30 (f19 (f20 f23 ?v2) ?v1)) ?v3)) (f19 (f20 f30 (f19 (f20 f23 (f19 (f20 f30 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f4 (f5 f6 (f4 (f5 f8 ?v0) ?v1)) (f4 (f5 f6 (f4 (f5 f8 ?v2) ?v1)) ?v3)) (f4 (f5 f6 (f4 (f5 f8 (f4 (f5 f6 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (f26 (f27 f28 ?v0) ?v1) (+ (f26 (f27 f28 ?v2) ?v1) ?v3)) (+ (f26 (f27 f28 (+ ?v0 ?v2)) ?v1) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f8 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f8 ?v0) ?v2)) (f4 (f5 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f8 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f8 ?v0) ?v2)) (f4 (f5 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f19 (f20 f23 (f19 (f20 f30 ?v0) ?v1)) ?v2) (f19 (f20 f30 (f19 (f20 f23 ?v0) ?v2)) (f19 (f20 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f4 (f5 f8 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f4 (f5 f8 ?v0) ?v2)) (f4 (f5 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f26 (f27 f28 (+ ?v0 ?v1)) ?v2) (+ (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f20 f21 ?v0))) (= (f19 ?v_0 ?v1) (ite (= ?v1 (f15 f16 0)) (f15 f16 1) (f15 f16 (f26 (f27 f28 (f17 f18 ?v0)) (f17 f18 (f19 ?v_0 (f15 f16 (- (f17 f18 ?v1) 1)))))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f15 f16 0)) (?v_2 (f17 f18 ?v0)) (?v_1 (f17 f18 ?v1))) (= (f15 f16 (f26 (f27 f28 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f15 f16 (+ ?v_1 (f26 (f27 f28 (f17 f18 (f15 f16 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f17 f18 ?v0))) (= (f15 f16 (* ?v_0 2)) (f15 f16 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f17 f18 ?v0))) (= (f15 f16 (* 2 ?v_0)) (f15 f16 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 Int) (?v3 S6)) (let ((?v_0 (f24 (f38 (f39 f40 ?v0) ?v1) ?v2))) (= (f17 ?v_0 (f15 f16 (+ (f17 f18 ?v3) 1))) (f26 (f27 ?v1 ?v2) (f17 ?v_0 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2) (?v3 S6)) (let ((?v_0 (f10 (f35 (f36 f37 ?v0) ?v1) ?v2))) (= (f9 ?v_0 (f15 f16 (+ (f17 f18 ?v3) 1))) (f4 (f5 ?v1 ?v2) (f9 ?v_0 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S11) (?v2 S6) (?v3 S6)) (let ((?v_0 (f20 (f32 (f33 f34 ?v0) ?v1) ?v2))) (= (f19 ?v_0 (f15 f16 (+ (f17 f18 ?v3) 1))) (f19 (f20 ?v1 ?v2) (f19 ?v_0 ?v3))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 Int)) (= (f17 (f24 (f38 (f39 f40 ?v0) ?v1) ?v2) (f15 f16 0)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f9 (f10 (f35 (f36 f37 ?v0) ?v1) ?v2) (f15 f16 0)) ?v0)))
(assert (forall ((?v0 S6) (?v1 S11) (?v2 S6)) (= (f19 (f20 (f32 (f33 f34 ?v0) ?v1) ?v2) (f15 f16 0)) ?v0)))
(assert (= (f26 f31 0) 0))
(assert (forall ((?v0 S6)) (= (= f29 ?v0) (= ?v0 f29))))
(assert (forall ((?v0 S2)) (= (= f14 ?v0) (= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f26 f31 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 f31 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f26 f31 ?v0)) (f26 f31 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f26 f31 ?v0))) (= (f26 (f27 f28 ?v_0) ?v_0) (f26 (f27 f28 ?v0) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f23 ?v0))) (= (f19 (f20 f23 (f19 ?v_0 ?v1)) ?v2) (f19 ?v_0 (f19 (f20 f23 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 (f5 f8 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f26 f31 ?v0) (f26 f31 ?v1)))) (= (f26 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f26 (f27 f41 ?v0) ?v1) ?v2) (f26 (f27 f41 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f26 (f27 f42 ?v0) ?v1) ?v2) (f26 (f27 f42 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (= (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (= (f26 f31 1) 1))
(assert (forall ((?v0 S6)) (= (= f22 ?v0) (= ?v0 f22))))
(assert (forall ((?v0 S2)) (= (= f7 ?v0) (= ?v0 f7))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 f29) ?v0) f29)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 f14) ?v0) f14)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 f14) ?v0) f14)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 f14) ?v0) f14)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f23 ?v0) f29) f29)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 ?v0) f14) f14)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 ?v0) f14) f14)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f8 ?v0) f14) f14)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 (f5 f8 ?v0) ?v1) f14) (or (= ?v0 f14) (= ?v1 f14)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f26 (f27 f28 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 f29)) (=> (not (= ?v1 f29)) (not (= (f19 (f20 f23 ?v0) ?v1) f29))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f14)) (=> (not (= ?v1 f14)) (not (= (f4 (f5 f8 ?v0) ?v1) f14))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f26 (f27 f28 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f19 (f20 f23 ?v0) ?v1) f29) (or (= ?v0 f29) (= ?v1 f29)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f5 f8 ?v0) ?v1) f14) (or (= ?v0 f14) (= ?v1 f14)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 (f27 f28 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f30 f29) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f30 f29) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S6)) (= (f19 (f20 f30 ?v0) f29) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S6)) (= (f19 (f20 f30 ?v0) f29) ?v0)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (not (= f22 f29)))
(assert (not (= f7 f14)))
(assert (not (= 1 0)))
(assert (not (= f29 f22)))
(assert (not (= f14 f7)))
(assert (not (= 0 1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f5 f8 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 (f4 f43 ?v0)) (f15 f16 2)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (<= (+ (f26 (f27 f28 ?v3) ?v0) (f26 (f27 f28 ?v4) ?v2)) ?v1))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f19 (f20 f21 ?v0) ?v1))) (=> (= (f44 f29 ?v0) f1) (=> (= (f44 ?v0 f22) f1) (= (f44 (f19 (f20 f23 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f17 (f24 f25 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f26 (f27 f28 ?v0) ?v_0) ?v_0))))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f17 f18 ?v0))) (<= ?v_0 (f26 (f27 f28 ?v_0) ?v_0)))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f17 f18 ?v0))) (let ((?v_1 (f27 f28 ?v_0))) (<= ?v_0 (f26 ?v_1 (f26 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f44 ?v0 ?v1) f1) (=> (= (f45 ?v2 ?v3) f1) (= (f44 (f19 (f20 f30 ?v0) ?v2) (f19 (f20 f30 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f45 ?v0 ?v1) f1) (=> (= (f44 ?v2 ?v3) f1) (= (f44 (f19 (f20 f30 ?v0) ?v2) (f19 (f20 f30 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f26 f31 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f26 f31 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (=> (< 0 ?v0) (= (<= (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (<= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (=> (< ?v0 0) (= (<= (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (<= ?v2 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f44 ?v0 ?v1) f1) (=> (= (f44 ?v2 ?v3) f1) (=> (= (f44 f29 ?v1) f1) (=> (= (f45 f29 ?v2) f1) (= (f44 (f19 (f20 f23 ?v0) ?v2) (f19 (f20 f23 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f44 ?v0 ?v1) f1) (=> (= (f44 ?v2 ?v3) f1) (=> (= (f45 f29 ?v0) f1) (=> (= (f45 f29 ?v2) f1) (= (f44 (f19 (f20 f23 ?v0) ?v2) (f19 (f20 f23 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f44 ?v0 ?v1) f1) (=> (= (f45 ?v2 ?v3) f1) (=> (= (f45 f29 ?v0) f1) (=> (= (f44 f29 ?v2) f1) (= (f44 (f19 (f20 f23 ?v0) ?v2) (f19 (f20 f23 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f45 ?v0 ?v1) f1) (=> (= (f44 ?v2 ?v3) f1) (=> (= (f44 f29 ?v0) f1) (=> (= (f45 f29 ?v2) f1) (= (f44 (f19 (f20 f23 ?v0) ?v2) (f19 (f20 f23 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f44 (f19 (f20 f23 ?v0) ?v1) (f19 (f20 f23 ?v2) ?v1)) f1) (=> (= (f45 f29 ?v1) f1) (= (f44 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f44 (f19 (f20 f23 ?v0) ?v1) (f19 (f20 f23 ?v2) ?v1)) f1) (=> (= (f45 f29 ?v1) f1) (= (f44 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f23 ?v0))) (=> (= (f44 (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) f1) (=> (= (f45 f29 ?v0) f1) (= (f44 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (=> (< (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f23 ?v0))) (=> (= (f44 (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) f1) (=> (= (f45 f29 ?v0) f1) (= (f44 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (=> (< (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f45 (f19 (f20 f23 ?v0) ?v1) (f19 (f20 f23 ?v2) ?v1)) f1) (=> (= (f44 f29 ?v1) f1) (= (f45 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f23 ?v0))) (=> (= (f45 (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) f1) (=> (= (f44 f29 ?v0) f1) (= (f45 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (=> (<= (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f44 f29 ?v0) f1) (=> (= (f45 f29 ?v1) f1) (= (f44 f29 (f19 (f20 f30 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f45 f29 ?v0) f1) (=> (= (f44 f29 ?v1) f1) (= (f44 f29 (f19 (f20 f30 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f44 f29 ?v0) f1) (=> (= (f45 ?v1 ?v2) f1) (= (f44 ?v1 (f19 (f20 f30 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (<= ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f45 f29 ?v0) f1) (=> (= (f44 ?v1 ?v2) f1) (= (f44 ?v1 (f19 (f20 f30 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f44 ?v0 f29) f1) (=> (= (f45 ?v1 f29) f1) (= (f44 (f19 (f20 f30 ?v0) ?v1) f29) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (<= ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f45 ?v0 f29) f1) (=> (= (f44 ?v1 f29) f1) (= (f44 (f19 (f20 f30 ?v0) ?v1) f29) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f44 ?v0 ?v1) f1) (=> (= (f45 f29 ?v0) f1) (=> (< 0 (f17 f18 ?v2)) (= (f44 (f19 (f20 f21 ?v0) ?v2) (f19 (f20 f21 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f17 f18 ?v2)) (< (f17 (f24 f25 ?v0) ?v2) (f17 (f24 f25 ?v1) ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f44 (f19 (f20 f21 ?v0) ?v1) (f19 (f20 f21 ?v2) ?v1)) f1) (=> (= (f45 f29 ?v2) f1) (= (f44 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (=> (< (f17 (f24 f25 ?v0) ?v1) (f17 (f24 f25 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f15 f16 2))) (=> (= (f44 (f19 (f20 f21 ?v0) ?v_0) (f19 (f20 f21 ?v1) ?v_0)) f1) (=> (= (f45 f29 ?v1) f1) (= (f44 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (=> (< (f17 (f24 f25 ?v0) ?v_0) (f17 (f24 f25 ?v1) ?v_0)) (=> (<= 0 ?v1) (< ?v0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f44 f22 ?v0) f1) (= (= (f45 (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) f1) (<= (f17 f18 ?v1) (f17 f18 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 1 ?v0) (= (<= (f17 ?v_0 ?v1) (f17 ?v_0 ?v2)) (<= (f17 f18 ?v1) (f17 f18 ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f44 f22 ?v0) f1) (=> (= (f45 (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) f1) (<= (f17 f18 ?v1) (f17 f18 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 1 ?v0) (=> (<= (f17 ?v_0 ?v1) (f17 ?v_0 ?v2)) (<= (f17 f18 ?v1) (f17 f18 ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f17 f18 ?v0)) (<= ?v_0 (f17 f18 (f19 (f20 f21 ?v0) ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f21 ?v0))) (=> (< 0 (f17 f18 ?v0)) (=> (< (f17 f18 (f19 ?v_0 ?v1)) (f17 f18 (f19 ?v_0 ?v2))) (< (f17 f18 ?v1) (f17 f18 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (<= 0 ?v0) (= (f15 f16 (f17 (f24 f25 ?v0) ?v1)) (f19 (f20 f21 (f15 f16 ?v0)) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f15 f16 (+ 0 1)))) (= (= (f19 (f20 f21 ?v0) ?v1) ?v_0) (or (= ?v1 (f15 f16 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f17 (f24 f25 (f17 f18 ?v0)) ?v1) (f17 f18 (f19 (f20 f21 ?v0) ?v1)))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f15 f16 (+ 0 1)))) (= (f19 (f20 f21 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (< 0 (f17 f18 (f19 (f20 f21 ?v0) ?v1))) (or (< 0 (f17 f18 ?v0)) (= ?v1 (f15 f16 0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f17 f18 (f19 (f20 f21 ?v0) ?v1)) (f17 (f24 f25 (f17 f18 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f26 f31 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f26 f31 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f26 f31 ?v0) 0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f26 f31 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f26 f31 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (<= 0 (f26 f31 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f26 f31 ?v0)) (?v_1 (f26 f31 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f26 (f27 f28 ?v_0) ?v_1) (f26 (f27 f28 ?v1) ?v3)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f20 f30 ?v0))) (=> (= (f44 (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) f1) (= (f44 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f26 f31 (+ ?v0 ?v1)) (+ (f26 f31 ?v0) (f26 f31 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (< (+ (f26 (f27 f28 ?v3) ?v0) (f26 (f27 f28 ?v4) ?v2)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f26 ?v_0 ?v1) (f26 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f26 (f27 f28 ?v1) ?v2) (f26 (f27 f28 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (f26 (f27 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f26 (f27 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (=> (< ?v0 0) (= (< (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (< ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f26 (f27 f28 ?v0) ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f26 (f27 f28 ?v0) ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f26 (f27 f28 ?v1) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f26 (f27 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (f26 (f27 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (=> (< 0 ?v0) (= (< (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (< (f26 ?v_0 ?v1) (f26 ?v_0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 Int)) (not (< (f26 (f27 f28 ?v0) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (< 0 (+ ?v0 ?v0)) (< 0 ?v0))))
(assert (< 0 1))
(assert (not (< 1 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f26 (f27 f28 ?v0) ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f26 f31 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f26 f31 ?v0)) (f26 f31 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f26 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f26 ?v_0 ?v1) (f26 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f26 (f27 f28 ?v1) ?v2) (f26 (f27 f28 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f26 ?v_0 ?v0) (f26 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f26 (f27 f28 ?v0) ?v2) (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f26 (f27 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f26 (f27 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f26 (f27 f28 ?v1) ?v0) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f26 (f27 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f26 (f27 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f26 (f27 f28 (f26 f31 ?v1)) ?v0) (f26 f31 (f26 (f27 f28 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f26 (f27 f28 ?v0) ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (f26 (f27 f28 ?v0) ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 Int)) (<= 0 (f26 (f27 f28 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (+ ?v0 ?v1) 0) (and (= ?v0 0) (= ?v1 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 Int)) (= (<= (+ ?v0 ?v0) 0) (<= ?v0 0))))
(assert (forall ((?v0 Int)) (= (<= 0 (+ ?v0 ?v0)) (<= 0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (f26 (f27 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 0 ?v0) (< 0 (f17 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f44 f29 ?v0) f1) (= (f44 f29 (f19 (f20 f21 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (f17 (f24 f25 ?v0) (f15 f16 2))) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (not (< (f17 (f24 f25 ?v0) (f15 f16 2)) 0))))
(assert (<= 0 1))
(assert (not (<= 1 0)))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (=> (= (f17 (f24 f25 ?v0) ?v_0) (f17 (f24 f25 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f15 f16 2))) (=> (= (f19 (f20 f21 ?v0) ?v_0) (f19 (f20 f21 ?v1) ?v_0)) (=> (= (f45 f29 ?v0) f1) (=> (= (f45 f29 ?v1) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (=> (<= (f17 (f24 f25 ?v0) ?v_0) (f17 (f24 f25 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f15 f16 2))) (=> (= (f45 (f19 (f20 f21 ?v0) ?v_0) (f19 (f20 f21 ?v1) ?v_0)) f1) (=> (= (f45 f29 ?v1) f1) (= (f45 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (let ((?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))) (=> (= (f17 (f24 f25 ?v0) ?v_0) (f17 (f24 f25 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))) (=> (= (f19 (f20 f21 ?v0) ?v_0) (f19 (f20 f21 ?v2) ?v_0)) (=> (= (f45 f29 ?v0) f1) (=> (= (f45 f29 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (let ((?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))) (=> (<= (f17 (f24 f25 ?v0) ?v_0) (f17 (f24 f25 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f15 f16 (+ (f17 f18 ?v1) 1)))) (=> (= (f45 (f19 (f20 f21 ?v0) ?v_0) (f19 (f20 f21 ?v2) ?v_0)) f1) (=> (= (f45 f29 ?v2) f1) (= (f45 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S6)) (= (f15 f16 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
