(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 (S4 S2) S3)
(declare-fun f6 () S4)
(declare-fun f7 () S2)
(declare-fun f8 (S5 S6) S2)
(declare-fun f9 (S7 S2) S5)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S9) S2)
(declare-fun f12 () S8)
(declare-fun f13 () S9)
(declare-fun f14 (S10 Int) S6)
(declare-fun f15 () S10)
(declare-fun f16 (S11 S6) Int)
(declare-fun f17 () S11)
(declare-fun f18 () S6)
(declare-fun f19 () S2)
(declare-fun f20 () S2)
(declare-fun f21 () S2)
(declare-fun f22 () S3)
(declare-fun f23 (S2 S2) S1)
(declare-fun f24 (S12 S9) S9)
(declare-fun f25 (S13 S9) S12)
(declare-fun f26 () S13)
(declare-fun f27 () S3)
(declare-fun f28 (S14 Int) Int)
(declare-fun f29 (S15 Int) S14)
(declare-fun f30 () S15)
(declare-fun f31 (S16 Int) S11)
(declare-fun f32 () S16)
(declare-fun f33 () S3)
(declare-fun f34 (S17 S6) S9)
(declare-fun f35 (S18 S9) S17)
(declare-fun f36 () S18)
(declare-fun f37 () S9)
(declare-fun f38 () S9)
(declare-fun f39 () S14)
(declare-fun f40 () S12)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 f7) (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19)) f20) f1)))
(assert (= (f3 f21 f7) f1))
(assert (= (f3 f7 f20) f1))
(assert (= (f3 f7 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1))
(assert (= (f3 f21 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1))
(assert (not (= f18 (f14 f15 0))))
(assert (= (f3 f21 f7) f1))
(assert (= (f3 f7 f20) f1))
(assert (= (f3 f21 f19) f1))
(assert (= (f3 f7 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1))
(assert (= (f3 f21 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1))
(assert (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (exists ((?v1 S2)) (and (= (f3 f21 ?v1) f1) (and (= (f3 ?v1 f20) f1) (= (f3 ?v1 ?v0) f1)))))))
(assert (=> (forall ((?v0 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v0 f20) f1) (=> (= (f3 ?v0 (f4 f22 (f4 (f5 f6 (f8 (f9 f10 (f11 f12 f13)) (f14 f15 (+ (f16 f17 f18) 1)))) f19))) f1) false)))) false))
(assert (let ((?v_0 (f11 f12 f13))) (= (f23 (f4 (f5 f6 f7) ?v_0) (f4 (f5 f6 f20) ?v_0)) f1)))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S9) (?v3 S2)) (=> (= (f3 (f11 f12 ?v0) ?v1) f1) (=> (= (f3 (f11 f12 ?v2) ?v3) f1) (= (f3 (f11 f12 (f24 (f25 f26 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f4 f27 ?v0) ?v1) f1) (=> (= (f3 (f4 f27 ?v2) ?v3) f1) (= (f3 (f4 f27 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 1 ?v0) (< 1 (f28 (f29 f30 ?v0) (f16 (f31 f32 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f20 ?v0) f1) (= (f3 f20 (f4 (f5 f6 ?v0) (f8 (f9 f10 ?v0) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f16 (f31 f32 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (f28 (f29 f30 ?v0) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (f3 f20 ?v0) f1) (= (f3 ?v_0 (f4 (f5 f6 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f4 f33 ?v0) f20) f1) (= (f3 (f8 (f9 f10 ?v0) (f14 f15 2)) f20) f1))))
(assert (forall ((?v0 S9) (?v1 S6)) (= (f11 f12 (f34 (f35 f36 ?v0) ?v1)) (f8 (f9 f10 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f4 f27 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f27 ?v0)) ?v1))))
(assert (= (f11 f12 f37) f20))
(assert (= (f4 f27 f20) f20))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f11 f12 (f24 (f25 f26 ?v0) ?v1)) (f4 (f5 f6 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 f27 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f27 ?v0)) (f4 f27 ?v1)))))
(assert (forall ((?v0 S9) (?v1 S6)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) f37 (f24 (f25 f26 ?v0) (f34 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f16 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) 1 (f28 (f29 f30 ?v0) (f16 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 ?v1) (ite (= ?v1 (f14 f15 0)) f20 (f4 (f5 f6 ?v0) (f8 ?v_0 (f14 f15 (- (f16 f17 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 1 ?v0) (< 1 (f16 (f31 f32 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f20 ?v0) f1) (= (f3 f20 (f8 (f9 f10 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1)))) f1))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (=> (< 1 ?v0) (= (= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (= (= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S9)) (= (= (f23 (f11 f12 ?v0) f21) f1) (= ?v0 f38))))
(assert (forall ((?v0 S2)) (= (= (f23 (f4 f27 ?v0) f21) f1) (= ?v0 f21))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f8 (f9 f10 ?v0) ?v_0) (f8 (f9 f10 ?v2) ?v_0)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 f21 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f16 (f31 f32 ?v0) ?v_0) (f16 (f31 f32 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (= (f23 (f8 (f9 f10 ?v0) ?v_0) (f8 (f9 f10 ?v2) ?v_0)) f1) (=> (= (f23 f21 ?v2) f1) (= (f23 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (let ((?v_0 (f14 f15 (+ (f16 f17 ?v1) 1)))) (=> (<= (f16 (f31 f32 ?v0) ?v_0) (f16 (f31 f32 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (=> (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1)) (=> (= (f23 f21 ?v0) f1) (=> (= (f23 f21 ?v2) f1) (=> (< 0 (f16 f17 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (=> (= (f16 (f31 f32 ?v0) ?v1) (f16 (f31 f32 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f16 f17 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 f21 ?v0) f1) (= (f23 (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f16 (f31 f32 ?v0) ?v2) (f16 (f31 f32 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f23 f21 ?v0) f1) (= (f23 f21 (f8 (f9 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (<= 0 ?v0) (<= 0 (f16 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S6)) (<= 0 (f16 (f31 f32 (f28 f39 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f23 f21 (f8 (f9 f10 (f4 f33 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 S2)) (= (f23 f21 (f4 f27 ?v0)) f1)))
(assert (forall ((?v0 S9)) (= (f23 f21 (f11 f12 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (= (f16 ?v_0 (f14 f15 (f28 (f29 f30 (f16 f17 ?v1)) (f16 f17 ?v2)))) (f16 (f31 f32 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S9) (?v1 S6) (?v2 S6)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f14 f15 (f28 (f29 f30 (f16 f17 ?v1)) (f16 f17 ?v2)))) (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f14 f15 (f28 (f29 f30 (f16 f17 ?v1)) (f16 f17 ?v2)))) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S9)) (=> (not (= ?v0 f38)) (= (f11 f12 (f24 f40 ?v0)) (f4 f22 (f11 f12 ?v0))))))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f21)) (= (f4 f27 (f4 f22 ?v0)) (f4 f22 (f4 f27 ?v0))))))
(assert (forall ((?v0 S2)) (= (f4 f27 (f4 f22 ?v0)) (f4 f22 (f4 f27 ?v0)))))
(assert (forall ((?v0 S9)) (= (f11 f12 (f24 f40 ?v0)) (f4 f22 (f11 f12 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S6)) (=> (not (= ?v0 f38)) (= (f24 f40 (f34 (f35 f36 ?v0) ?v1)) (f34 (f35 f36 (f24 f40 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (not (= ?v0 f21)) (= (f4 f22 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f22 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (=> (= (f3 (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1)) f1) (=> (= (f23 f21 ?v2) f1) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int)) (=> (< (f16 (f31 f32 ?v0) ?v1) (f16 (f31 f32 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f23 f21 ?v0) f1) (=> (< 0 (f16 f17 ?v2)) (= (f3 (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f16 f17 ?v2)) (< (f16 (f31 f32 ?v0) ?v2) (f16 (f31 f32 ?v1) ?v2)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f31 f32 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v0))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f23 f21 ?v2) f1) (=> (= (f23 ?v2 f20) f1) (= (f23 (f8 ?v_0 ?v1) (f8 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S9)) (= (= (f11 f12 ?v0) f21) (= ?v0 f38))))
(assert (forall ((?v0 S2)) (= (= (f4 f27 ?v0) f21) (= ?v0 f21))))
(assert (= (f11 f12 f38) f21))
(assert (= (f4 f27 f21) f21))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f31 f32 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (<= 1 ?v2) (<= (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (<= (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f23 f20 ?v2) f1) (= (f23 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (<= 1 ?v0) (<= 1 (f16 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f23 f20 ?v0) f1) (= (f23 f20 (f8 (f9 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S9) (?v1 S6)) (= (f24 f40 (f34 (f35 f36 ?v0) ?v1)) (f34 (f35 f36 (f24 f40 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f4 f22 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f22 ?v0)) ?v1))))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 ?v0) f38) f38)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f21) f21)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 ?v0) f38) f38)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 ?v0) f21) f21)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 f38) ?v0) f38)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f21) ?v0) f21)))
(assert (forall ((?v0 S9)) (= (f24 (f25 f26 f38) ?v0) f38)))
(assert (forall ((?v0 S2)) (= (f4 (f5 f6 f21) ?v0) f21)))
(assert (forall ((?v0 S9) (?v1 S6)) (=> (not (= ?v0 f38)) (not (= (f34 (f35 f36 ?v0) ?v1) f38)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (not (= ?v0 f21)) (not (= (f8 (f9 f10 ?v0) ?v1) f21)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (not (= ?v0 0)) (not (= (f16 (f31 f32 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S9) (?v1 S6)) (= (= (f34 (f35 f36 ?v0) ?v1) f38) (and (= ?v0 f38) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (= (f8 (f9 f10 ?v0) ?v1) f21) (and (= ?v0 f21) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (= (f16 (f31 f32 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f14 f15 0)))))))
(assert (forall ((?v0 S6)) (= (f34 (f35 f36 f38) (f14 f15 (+ (f16 f17 ?v0) 1))) f38)))
(assert (forall ((?v0 S6)) (= (f8 (f9 f10 f21) (f14 f15 (+ (f16 f17 ?v0) 1))) f21)))
(assert (forall ((?v0 S6)) (= (f16 (f31 f32 0) (f14 f15 (+ (f16 f17 ?v0) 1))) 0)))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (=> (< 1 ?v0) (=> (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (=> (= (f23 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f31 f32 ?v0))) (=> (< 1 ?v0) (= (<= (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f3 f20 ?v0) f1) (= (= (f23 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (<= (f16 f17 ?v1) (f16 f17 ?v2)))))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (f23 (f11 f12 (f24 (f25 f26 ?v0) ?v1)) (f4 (f5 f6 (f11 f12 ?v0)) (f11 f12 ?v1))) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f23 (f4 f27 (f4 (f5 f6 ?v0) ?v1)) (f4 (f5 f6 (f4 f27 ?v0)) (f4 f27 ?v1))) f1)))
(assert (forall ((?v0 S9) (?v1 S6)) (= (f23 (f11 f12 (f34 (f35 f36 ?v0) ?v1)) (f8 (f9 f10 (f11 f12 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f23 (f4 f27 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f27 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 f21 ?v1) f1) (=> (= (f3 (f4 (f5 f6 ?v1) ?v2) (f4 (f5 f6 ?v0) ?v3)) f1) (= (f3 (f4 (f5 f6 (f4 f22 ?v0)) ?v2) (f4 (f5 f6 (f4 f22 ?v1)) ?v3)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 f21 ?v1) f1) (=> (= (f3 (f4 (f5 f6 ?v1) ?v2) (f4 (f5 f6 ?v0) ?v3)) f1) (= (f3 (f4 (f5 f6 ?v2) (f4 f22 ?v0)) (f4 (f5 f6 ?v3) (f4 f22 ?v1))) f1))))))
(assert (forall ((?v0 S9)) (= (= (f3 f21 (f11 f12 ?v0)) f1) (not (= ?v0 f38)))))
(assert (forall ((?v0 S2)) (= (= (f3 f21 (f4 f27 ?v0)) f1) (not (= ?v0 f21)))))
(assert (forall ((?v0 Int)) (= (f16 (f31 f32 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S9)) (= (f34 (f35 f36 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) (f14 f15 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S6)) (= (f28 f39 (f16 (f31 f32 ?v0) ?v1)) (f16 (f31 f32 (f28 f39 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (f4 f33 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f4 f33 ?v0)) ?v1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f27 ?v0))) (= (f4 f33 ?v_0) ?v_0))))
(assert (forall ((?v0 S9)) (let ((?v_0 (f11 f12 ?v0))) (= (f4 f33 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f21 ?v0) f1) (= (f3 f21 (f8 (f9 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 0 ?v0) (< 0 (f16 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 S6)) (= (f34 (f35 f36 f38) ?v0) (ite (= ?v0 (f14 f15 0)) f37 f38))))
(assert (forall ((?v0 S6)) (= (f16 (f31 f32 0) ?v0) (ite (= ?v0 (f14 f15 0)) 1 0))))
(assert (forall ((?v0 S6)) (= (f8 (f9 f10 f21) ?v0) (ite (= ?v0 (f14 f15 0)) f20 f21))))
(assert (forall ((?v0 S2)) (not (= (f3 (f4 f27 ?v0) f21) f1))))
(assert (forall ((?v0 S9)) (not (= (f3 (f11 f12 ?v0) f21) f1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f31 f32 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f16 ?v_0 ?v1) (f16 ?v_0 ?v0))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f9 f10 ?v2))) (=> (< (f16 f17 ?v0) (f16 f17 ?v1)) (=> (= (f3 f21 ?v2) f1) (=> (= (f3 ?v2 f20) f1) (= (f3 (f8 ?v_0 ?v1) (f8 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f16 (f31 f32 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) 1)))))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (= (f3 f21 ?v0) f1) (=> (= (f3 ?v0 f20) f1) (= (f3 (f8 (f9 f10 ?v0) (f14 f15 (+ (f16 f17 ?v1) 1))) f20) f1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S9)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0)) (?v_2 (f35 f36 ?v2))) (=> (<= ?v_1 ?v_0) (= (f34 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f24 (f25 f26 (f34 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 Int)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0)) (?v_2 (f31 f32 ?v2))) (=> (<= ?v_1 ?v_0) (= (f16 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f28 (f29 f30 (f16 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S2)) (let ((?v_0 (f16 f17 ?v1)) (?v_1 (f16 f17 ?v0)) (?v_2 (f9 f10 ?v2))) (=> (<= ?v_1 ?v_0) (= (f8 ?v_2 (f14 f15 (- (+ ?v_0 1) ?v_1))) (f4 (f5 f6 (f8 ?v_2 (f14 f15 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S6)) (= (f34 (f35 f36 (f24 (f25 f26 ?v0) ?v1)) ?v2) (f24 (f25 f26 (f34 (f35 f36 ?v0) ?v2)) (f34 (f35 f36 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (= (f16 (f31 f32 (f28 (f29 f30 ?v0) ?v1)) ?v2) (f28 (f29 f30 (f16 (f31 f32 ?v0) ?v2)) (f16 (f31 f32 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6)) (= (f8 (f9 f10 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f8 (f9 f10 ?v0) ?v2)) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 S6)) (= (f14 f15 (f16 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f17 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
