(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S3 S4) S2)
(declare-fun f6 (S5 S2) S3)
(declare-fun f7 () S5)
(declare-fun f8 () S2)
(declare-fun f9 () S4)
(declare-fun f10 (S2 S2) S1)
(declare-fun f11 (S6 S2) S2)
(declare-fun f12 (S7 S2) S6)
(declare-fun f13 () S7)
(declare-fun f14 () S6)
(declare-fun f15 () S6)
(declare-fun f16 (S9 S8) S2)
(declare-fun f17 () S9)
(declare-fun f18 (S10 S8) S8)
(declare-fun f19 (S11 S8) S10)
(declare-fun f20 () S11)
(declare-fun f21 () S8)
(declare-fun f22 () S8)
(declare-fun f23 (S12 Int) S4)
(declare-fun f24 () S12)
(declare-fun f25 (S13 S4) Int)
(declare-fun f26 () S13)
(declare-fun f27 (S14 S15) S4)
(declare-fun f28 () S14)
(declare-fun f29 (S8 S15) S15)
(declare-fun f30 () S8)
(declare-fun f31 (S8 S4) S15)
(declare-fun f32 () S8)
(declare-fun f33 () S6)
(declare-fun f34 (S16 S4) S8)
(declare-fun f35 (S17 S8) S16)
(declare-fun f36 () S17)
(declare-fun f37 (S18 S2) S8)
(declare-fun f38 () S18)
(declare-fun f39 (S19 S15) S10)
(declare-fun f40 () S19)
(declare-fun f41 () S15)
(declare-fun f42 () S2)
(declare-fun f43 () S2)
(assert (not (= f1 f2)))
(assert (= (f3 f4 (f5 (f6 f7 f8) f9)) f1))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f12 f13 ?v0))) (=> (= (f3 f4 ?v0) f1) (= (= (f10 (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) f1) (= (f10 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 (f12 f13 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f11 (f12 f13 ?v1) ?v2))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f15 ?v0))) (= (f11 f14 ?v_0) ?v_0))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f16 f17 ?v0))) (= (f11 f14 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f11 f15 ?v0) ?v1) f1) (=> (= (f3 (f11 f15 ?v2) ?v3) f1) (= (f3 (f11 f15 (f11 (f12 f13 ?v0) ?v2)) (f11 (f12 f13 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S8) (?v1 S2) (?v2 S8) (?v3 S2)) (=> (= (f3 (f16 f17 ?v0) ?v1) f1) (=> (= (f3 (f16 f17 ?v2) ?v3) f1) (= (f3 (f16 f17 (f18 (f19 f20 ?v0) ?v2)) (f11 (f12 f13 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S4)) (=> (= (f3 f4 ?v0) f1) (= (f3 f4 (f5 (f6 f7 ?v0) ?v1)) f1))))
(assert (not (= f21 f22)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 (f11 f15 ?v0)) f1) (not (= ?v0 f4)))))
(assert (forall ((?v0 S8)) (= (= (f3 f4 (f16 f17 ?v0)) f1) (not (= ?v0 f22)))))
(assert (let ((?v_0 (f25 f26 f9))) (= (f23 f24 (+ ?v_0 1)) (f27 f28 (f29 f30 (f31 f32 (f23 f24 (- ?v_0 1))))))))
(assert (= (f3 f4 f8) f1))
(assert (= (f11 f15 f4) f4))
(assert (= (f16 f17 f22) f4))
(assert (= (f11 f33 f4) f4))
(assert (forall ((?v0 S2)) (= (f11 (f12 f13 ?v0) f4) f4)))
(assert (forall ((?v0 S8)) (= (f18 (f19 f20 ?v0) f22) f22)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f23 f24 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f34 (f35 f36 ?v0) (f23 f24 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S4)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f11 (f12 f13 (f5 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S4)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f23 f24 (+ (f25 f26 ?v1) 1))) (f18 (f19 f20 (f34 ?v_0 ?v1)) ?v0)))))
(assert (let ((?v_0 (f18 (f19 f20 (f37 f38 f8)) f21))) (let ((?v_1 (f18 (f39 f40 f41) ?v_0)) (?v_4 (f12 f13 (f5 (f6 f7 f8) f9))) (?v_5 (f12 f13 f8)) (?v_6 (f12 f13 (f5 (f6 f7 (f16 f17 f21)) (f23 f24 (+ (f25 f26 f9) 1)))))) (let ((?v_2 (f16 f17 ?v_1))) (let ((?v_3 (f11 ?v_4 (f11 ?v_5 (f11 ?v_6 ?v_2))))) (not (=> (= (f16 f17 (f18 (f19 f20 (f18 (f19 f20 (f34 (f35 f36 ?v_0) f9)) ?v_0)) ?v_1)) ?v_3) (=> (= (f3 f4 f8) f1) (=> (= (f3 f8 f42) f1) (=> (= (f10 ?v_2 f43) f1) (=> (not (= f21 f22)) (= (f10 ?v_3 (f11 ?v_4 (f11 ?v_5 (f11 ?v_6 f43)))) f1))))))))))))
(assert (forall ((?v0 S4)) (= (f23 f24 (f25 f26 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f25 f26 (f23 f24 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f25 f26 (f23 f24 ?v0)) 0))))
(check-sat)
(exit)
