(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 () S2)
(declare-fun f7 () S2)
(declare-fun f8 () S2)
(declare-fun f9 (S5 Int) Int)
(declare-fun f10 () S5)
(declare-fun f11 (S6 S2) S2)
(declare-fun f12 () S6)
(declare-fun f13 (S7 S2) S6)
(declare-fun f14 () S7)
(declare-fun f15 (S8 Int) S5)
(declare-fun f16 () S8)
(declare-fun f17 () S7)
(declare-fun f18 () S8)
(declare-fun f19 (S9 S2) Int)
(declare-fun f20 (S10 Int) S2)
(declare-fun f21 (S11 S9) S1)
(declare-fun f22 () S11)
(declare-fun f23 (S12 S10) S1)
(declare-fun f24 () S12)
(declare-fun f25 () S6)
(declare-fun f26 () S5)
(declare-fun f27 () S11)
(declare-fun f28 () S12)
(declare-fun f29 (S13 S3) S1)
(declare-fun f30 (S14 S2) S13)
(declare-fun f31 () S14)
(declare-fun f32 () S7)
(declare-fun f33 () S8)
(declare-fun f34 () S4)
(declare-fun f35 () S2)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 S2)) (let ((?v_0 (f4 f5 ?v0))) (and (= (f3 (f4 f5 f6) ?v0) f1) (and (= (f3 ?v_0 f7) f1) (= (f3 ?v_0 f8) f1)))))))
(assert (= (f3 (f4 f5 f6) f7) f1))
(assert (= (f3 (f4 f5 f6) f8) f1))
(assert (forall ((?v0 Int)) (not (< (f9 f10 ?v0) 0))))
(assert (forall ((?v0 S2)) (not (= (f3 (f4 f5 (f11 f12 ?v0)) f6) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (f9 f10 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f5 f6) (f11 f12 ?v0)) f1) (not (= ?v0 f6)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f11 f12 ?v0) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (exists ((?v2 S2)) (let ((?v_1 (f4 f5 ?v2))) (and (= (f3 ?v_0 ?v2) f1) (and (= (f3 ?v_1 ?v0) f1) (= (f3 ?v_1 ?v1) f1))))))))))
(assert (forall ((?v0 S2)) (not (= (f3 (f4 f5 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= ?v0 ?v1)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (or (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f11 (f13 f14 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f9 (f15 f16 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f11 (f13 f17 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f9 (f15 f18 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 f5 (f11 (f13 f14 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f9 (f15 f16 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 f5 (f11 (f13 f17 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f9 (f15 f18 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 Int)) (= (= (f9 f10 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f11 f12 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= f6 ?v0) (= ?v0 f6))))
(assert (= (f9 f10 0) 0))
(assert (= (f11 f12 f6) f6))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (=> (not false) (= (f3 (f4 f5 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f3 (f4 f5 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (not (= (f3 (f4 f5 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 Int) (?v3 S2)) (=> (< (f19 ?v0 ?v1) ?v2) (=> (= (f3 (f4 f5 ?v3) ?v1) f1) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (< (f19 ?v0 ?v5) (f19 ?v0 ?v4)))) (< (f19 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S10) (?v1 Int) (?v2 S2) (?v3 Int)) (=> (= (f3 (f4 f5 (f20 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f3 (f4 f5 (f20 ?v0 ?v5)) (f20 ?v0 ?v4)) f1))) (= (f3 (f4 f5 (f20 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2) (?v3 S2)) (=> (= ?v0 (f11 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v3) ?v2) f1) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (= (f3 (f4 f5 (f11 ?v1 ?v5)) (f11 ?v1 ?v4)) f1))) (= (f3 (f4 f5 (f11 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f9 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f9 ?v1 ?v5) (f9 ?v1 ?v4)))) (< (f9 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (< ?v0 (f19 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (< (f19 ?v1 ?v4) (f19 ?v1 ?v5)))) (< ?v0 (f19 ?v1 ?v3)))))))
(assert (forall ((?v0 S2) (?v1 S10) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 (f20 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f5 (f20 ?v1 ?v4)) (f20 ?v1 ?v5)) f1))) (= (f3 ?v_0 (f20 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 S2) (?v1 S10) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f20 ?v1 ?v2)) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f5 (f20 ?v1 ?v4)) (f20 ?v1 ?v5)) f1))) (= (f3 (f4 f5 ?v0) (f20 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= ?v0 (f19 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (< (f19 ?v1 ?v4) (f19 ?v1 ?v5)))) (< ?v0 (f19 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10) (?v3 S2)) (=> (< ?v0 ?v1) (=> (= (f3 (f4 f5 (f20 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f5 (f20 ?v2 ?v4)) (f20 ?v2 ?v5)) f1))) (= (f3 (f4 f5 (f20 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S9) (?v3 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (< (f19 ?v2 ?v1) ?v3) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (< (f19 ?v2 ?v4) (f19 ?v2 ?v5)))) (< (f19 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10) (?v3 S2)) (=> (< ?v0 ?v1) (=> (= (f20 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f5 (f20 ?v2 ?v4)) (f20 ?v2 ?v5)) f1))) (= (f3 (f4 f5 (f20 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S9) (?v3 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f19 ?v2 ?v1) ?v3) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (< (f19 ?v2 ?v4) (f19 ?v2 ?v5)))) (< (f19 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S6) (?v3 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f11 ?v2 ?v0) ?v3) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (= (f3 (f4 f5 (f11 ?v2 ?v5)) (f11 ?v2 ?v4)) f1))) (= (f3 (f4 f5 ?v3) (f11 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f9 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f9 ?v2 ?v5) (f9 ?v2 ?v4)))) (< ?v3 (f9 ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 S10)) (let ((?v_0 (f4 f5 ?v2))) (=> (< ?v0 ?v1) (=> (= (f3 ?v_0 (f20 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f3 (f4 f5 (f20 ?v3 ?v5)) (f20 ?v3 ?v4)) f1))) (= (f3 ?v_0 (f20 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int) (?v3 S9)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (< ?v2 (f19 ?v3 ?v0)) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (< (f19 ?v3 ?v5) (f19 ?v3 ?v4)))) (< ?v2 (f19 ?v3 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (exists ((?v2 S2)) (and (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v2) ?v1) f1))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f11 (f13 f14 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f9 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f11 (f13 f14 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f9 (f15 f16 ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f11 (f13 f17 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f9 (f15 f18 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f11 (f13 f17 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f9 (f15 f18 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S2)) (=> (= (f21 f22 ?v0) f1) (= (< (f19 ?v0 ?v1) (f19 ?v0 ?v2)) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S10) (?v1 Int) (?v2 Int)) (=> (= (f23 f24 ?v0) f1) (= (= (f3 (f4 f5 (f20 ?v0 ?v1)) (f20 ?v0 ?v2)) f1) (< ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 Int) (?v2 Int)) (=> (= (f23 f24 ?v0) f1) (=> (< ?v1 ?v2) (= (f3 (f4 f5 (f20 ?v0 ?v1)) (f20 ?v0 ?v2)) f1)))))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S2)) (=> (= (f21 f22 ?v0) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (< (f19 ?v0 ?v1) (f19 ?v0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 Int) (?v2 Int)) (=> (= (f23 f24 ?v0) f1) (= (= (f20 ?v0 ?v1) (f20 ?v0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S2)) (=> (= (f21 f22 ?v0) f1) (= (= (f19 ?v0 ?v1) (f19 ?v0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S10)) (=> (forall ((?v1 Int) (?v2 Int)) (=> (< ?v1 ?v2) (= (f3 (f4 f5 (f20 ?v0 ?v1)) (f20 ?v0 ?v2)) f1))) (= (f23 f24 ?v0) f1))))
(assert (forall ((?v0 S9)) (=> (forall ((?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (< (f19 ?v0 ?v1) (f19 ?v0 ?v2)))) (= (f21 f22 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f5 (f11 f25 ?v0)) f6) f1) (= (f3 (f4 f5 ?v0) f6) f1))))
(assert (forall ((?v0 Int)) (= (< (f9 f26 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 ?v_0 (f11 f25 ?v0)) f1) (= (f3 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f9 f26 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S9)) (=> (= (f21 f22 ?v0) f1) (= (f21 f27 ?v0) f1))))
(assert (forall ((?v0 S10)) (=> (= (f23 f24 ?v0) f1) (= (f23 f28 ?v0) f1))))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 S2)) (=> (= (f29 (f30 f31 ?v1) ?v0) f1) (= (f3 (f4 f5 f6) ?v1) f1))) (=> (exists ((?v1 S2)) (= (f29 (f30 f31 ?v1) ?v0) f1)) (=> (exists ((?v1 S2)) (forall ((?v2 S2)) (=> (= (f29 (f30 f31 ?v2) ?v0) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))) (exists ((?v1 S2)) (forall ((?v2 S2)) (= (exists ((?v3 S2)) (and (= (f29 (f30 f31 ?v3) ?v0) f1) (= (f3 (f4 f5 ?v2) ?v3) f1))) (= (f3 (f4 f5 ?v2) ?v1) f1)))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f11 (f13 f32 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S2)) (= (f11 f12 ?v0) (f11 (f13 f32 ?v0) (f11 f25 ?v0)))))
(assert (forall ((?v0 Int)) (= (f9 f10 ?v0) (f9 (f15 f33 ?v0) (f9 f26 ?v0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f25 ?v0))) (= (f11 f25 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f26 ?v0))) (= (f9 f26 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f11 (f13 f32 ?v0) ?v1)) (f11 (f13 f32 (f11 f12 ?v0)) (f11 f12 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 f10 (f9 (f15 f33 ?v0) ?v1)) (f9 (f15 f33 (f9 f10 ?v0)) (f9 f10 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f25 (f11 (f13 f32 ?v0) ?v1)) (f11 (f13 f32 (f11 f25 ?v0)) (f11 f25 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 f26 (f9 (f15 f33 ?v0) ?v1)) (f9 (f15 f33 (f9 f26 ?v0)) (f9 f26 ?v1)))))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 (f11 f25 ?v0)) (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (f9 (f15 f33 (f9 f26 ?v0)) (f9 f10 ?v0)) ?v0)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f11 (f13 f32 ?v_0) ?v_0) (f11 (f13 f32 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f9 (f15 f33 ?v_0) ?v_0) (f9 (f15 f33 ?v0) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f13 f32 ?v0) ?v1) (f11 (f13 f32 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (= (f11 (f13 f32 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f11 (f13 f32 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v0))) (= (f9 (f15 f33 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f15 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (= (f11 (f13 f32 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f11 (f13 f32 ?v1) ?v2))))))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S2)) (=> (= (f21 f27 ?v0) f1) (= (f9 (f15 f16 (f19 ?v0 ?v1)) (f19 ?v0 ?v2)) (f19 ?v0 (f11 (f13 f14 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f11 (f13 f32 ?v0) ?v1) f6) (or (= ?v0 f6) (= ?v1 f6)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 (f15 f33 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (= (f29 (f30 f31 ?v0) ?v1) f1) (= (f3 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f6)) (=> (not (= ?v1 f6)) (not (= (f11 (f13 f32 ?v0) ?v1) f6))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f9 (f15 f33 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f11 (f13 f32 ?v0) ?v1) f6) (or (= ?v0 f6) (= ?v1 f6)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f9 (f15 f33 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 ?v0) f6) f6)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 f6) ?v0) f6)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f9 f10 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f9 (f15 f33 ?v_0) ?v_1) (f9 (f15 f33 ?v1) ?v3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (= (f3 (f4 f5 ?v_0) ?v1) f1) (=> (= (f3 (f4 f5 ?v_1) ?v3) f1) (= (f3 (f4 f5 (f11 (f13 f32 ?v_0) ?v_1)) (f11 (f13 f32 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f6)) (= (= (f11 (f13 f32 ?v1) ?v0) (f11 (f13 f32 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (=> (not (= ?v0 f6)) (= (= (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (= (f9 f26 0) 0))
(assert (= (f11 f25 f6) f6))
(assert (forall ((?v0 Int)) (= (= (f9 f26 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= (f11 f25 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 S2)) (not (= (f3 (f4 f5 (f11 (f13 f32 ?v0) ?v0)) f6) f1))))
(assert (forall ((?v0 Int)) (not (< (f9 (f15 f33 ?v0) ?v0) 0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 f5 (f11 (f13 f32 ?v0) ?v1)) (f11 (f13 f32 ?v2) ?v1)) f1) (or (and (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)) (and (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f9 (f15 f33 ?v0) ?v1) (f9 (f15 f33 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (= (= (f3 (f4 f5 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) f1) (or (and (= (f3 (f4 f5 f6) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v0))) (= (< (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f5 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v0))) (=> (< 0 ?v0) (= (< (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (< ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f11 (f13 f32 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (f9 (f15 f33 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 (f11 (f13 f32 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f9 (f15 f33 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 (f11 (f13 f32 ?v1) ?v0)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f9 (f15 f33 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 (f11 (f13 f32 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f9 (f15 f33 ?v0) ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 (f11 (f13 f32 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f9 (f15 f33 ?v0) ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (= (f3 (f4 f5 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v0))) (=> (< ?v0 0) (= (< (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (< ?v2 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f5 (f11 (f13 f32 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f9 (f15 f33 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 f6) (f11 (f13 f32 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (f9 (f15 f33 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f11 (f13 f32 ?v0) ?v2)) (f11 (f13 f32 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f9 (f15 f33 ?v0) ?v2) (f9 (f15 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f11 ?v_0 ?v0)) (f11 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f11 ?v_0 ?v0)) (f11 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 (f11 (f13 f32 ?v1) ?v2)) (f11 (f13 f32 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f9 (f15 f33 ?v1) ?v2) (f9 (f15 f33 ?v0) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v2))) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f9 ?v_0 ?v1) (f9 ?v_0 ?v0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f5 (f11 (f13 f32 ?v1) ?v0)) (f11 (f13 f32 ?v2) ?v0)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S2)) (= (not (= (f3 (f4 f5 f6) (f11 (f13 f32 ?v0) ?v0)) f1)) (= ?v0 f6))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f25 (f11 (f13 f32 ?v0) ?v1)) (f11 (f13 f32 (f11 f25 ?v0)) (f11 f25 ?v1)))))
(assert (forall ((?v0 S2)) (= (= (f11 f25 ?v0) f6) (= ?v0 f6))))
(assert (= (f11 f25 f6) f6))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 ?v0) f6) f6)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 ?v0) f6) f6)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 ?v0) f6) f6)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f15 f33 ?v0) ?v1) (f9 (f15 f33 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f13 f32 ?v0) ?v1) (f11 (f13 f32 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f15 f33 ?v0)) (?v_0 (f15 f33 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f13 f32 ?v0)) (?v_0 (f13 f32 ?v1))) (= (f11 ?v_1 (f11 ?v_0 ?v2)) (f11 ?v_0 (f11 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v0))) (= (f9 ?v_0 (f9 (f15 f33 ?v1) ?v2)) (f9 (f15 f33 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (= (f11 ?v_0 (f11 (f13 f32 ?v1) ?v2)) (f11 (f13 f32 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v0))) (= (f9 (f15 f33 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f15 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (= (f11 (f13 f32 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f11 (f13 f32 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v0))) (= (f9 (f15 f33 (f9 ?v_0 ?v1)) ?v2) (f9 (f15 f33 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (= (f11 (f13 f32 (f11 ?v_0 ?v1)) ?v2) (f11 (f13 f32 (f11 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f15 f33 ?v0)) (?v_1 (f9 (f15 f33 ?v2) ?v3))) (= (f9 (f15 f33 (f9 ?v_0 ?v1)) ?v_1) (f9 ?v_0 (f9 (f15 f33 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f13 f32 ?v0)) (?v_1 (f11 (f13 f32 ?v2) ?v3))) (= (f11 (f13 f32 (f11 ?v_0 ?v1)) ?v_1) (f11 ?v_0 (f11 (f13 f32 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f15 f33 (f9 (f15 f33 ?v0) ?v1))) (?v_0 (f15 f33 ?v2))) (= (f9 ?v_1 (f9 ?v_0 ?v3)) (f9 ?v_0 (f9 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f13 f32 (f11 (f13 f32 ?v0) ?v1))) (?v_0 (f13 f32 ?v2))) (= (f11 ?v_1 (f11 ?v_0 ?v3)) (f11 ?v_0 (f11 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f15 f33 ?v0))) (= (f9 (f15 f33 (f9 ?v_0 ?v1)) (f9 (f15 f33 ?v2) ?v3)) (f9 (f15 f33 (f9 ?v_0 ?v2)) (f9 (f15 f33 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f13 f32 ?v0))) (= (f11 (f13 f32 (f11 ?v_0 ?v1)) (f11 (f13 f32 ?v2) ?v3)) (f11 (f13 f32 (f11 ?v_0 ?v2)) (f11 (f13 f32 ?v1) ?v3))))))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 f6) ?v0) f6)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 f6) ?v0) f6)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 f6) ?v0) f6)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f34 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) f1) (= (f3 (f4 f34 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (= (f3 (f4 f34 (f11 (f13 f32 ?v1) ?v0)) (f11 (f13 f32 ?v2) ?v0)) f1) (= (f3 (f4 f34 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f11 f25 ?v0) f35))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f9 f26 ?v0) 1))))
(assert (forall ((?v0 S2)) (= (= (f11 f25 ?v0) f35) (= (f3 (f4 f5 f6) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (= (f9 f26 ?v0) 1) (< 0 ?v0))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f34 ?v0) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 ?v0) f35) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 f35) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f34 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f34 ?v1) f35) f1) (= (f3 (f4 f34 (f11 (f13 f32 ?v0) ?v1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f9 (f15 f33 ?v0) ?v1) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f34 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f34 ?v1) f35) f1) (= (f3 (f4 f34 (f11 (f13 f32 ?v1) ?v0)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f9 (f15 f33 ?v1) ?v0) ?v0))))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f4 f34 f6) ?v0) f1) (= (f11 f12 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f10 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f34 (f11 f12 ?v0)) f6) f1) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (<= (f9 f10 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f34 f6) (f11 f12 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f9 f10 ?v0))))
(assert (not (= f35 f6)))
(assert (not (= 1 0)))
(assert (not (= f6 f35)))
(assert (not (= 0 1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) ?v0) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f34 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f34 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f34 ?v1) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (= (f3 (f4 f34 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= (f3 (f4 f34 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f34 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f34 ?v0) ?v1) f1) (not (= (f3 (f4 f34 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f34 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= (f3 (f4 f34 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 ?v0) f35) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 ?v0) f35) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 f35) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 f35) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f34 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f34 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (not (= f6 f35)))
(assert (forall ((?v0 S2)) (= (f11 (f13 f32 f35) ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f9 (f15 f16 ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f34 ?v0) (f11 (f13 f14 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f9 (f15 f16 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f34 ?v0) (f11 (f13 f14 ?v1) ?v0)) f1)))
(assert (= (f11 f12 f35) f35))
(assert (= (f9 f10 1) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f9 (f15 f18 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f34 (f11 (f13 f17 ?v0) ?v1)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f9 (f15 f18 ?v0) ?v1) ?v1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f34 (f11 (f13 f17 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f9 (f15 f16 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f11 (f13 f14 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f9 (f15 f18 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f11 (f13 f17 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f9 (f15 f18 ?v1) ?v2)) (and (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (= (= (f3 ?v_0 (f11 (f13 f17 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v0))) (<= (f9 ?v_0 (f9 (f15 f18 ?v1) ?v2)) (f9 (f15 f18 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 ?v0))) (= (f3 (f4 f34 (f11 ?v_0 (f11 (f13 f17 ?v1) ?v2))) (f11 (f13 f17 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f9 (f15 f16 ?v0) ?v1) ?v2) (and (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 f34 (f11 (f13 f14 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f34 ?v0) ?v2) f1) (= (f3 (f4 f34 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f18 ?v0))) (<= (f9 (f15 f16 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 (f15 f16 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f17 ?v0))) (= (f3 (f4 f34 (f11 (f13 f14 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))) (f11 ?v_0 (f11 (f13 f14 ?v1) ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f9 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f11 (f13 f14 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f9 (f15 f16 ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f11 (f13 f14 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f9 (f15 f18 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f34 (f11 (f13 f17 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f9 (f15 f18 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f34 (f11 (f13 f17 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f9 (f15 f16 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f11 (f13 f14 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f9 (f15 f18 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f11 (f13 f17 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f9 (f15 f16 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f11 (f13 f14 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f9 (f15 f18 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f11 (f13 f17 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f9 (f15 f18 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f11 (f13 f17 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f9 (f15 f18 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f11 (f13 f17 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f9 (f15 f16 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) ?v1) f1) (= (f3 (f4 f34 (f11 (f13 f14 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f9 (f15 f16 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) ?v1) f1) (= (f3 (f4 f34 (f11 (f13 f14 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f9 (f15 f16 ?v0) ?v2) (f9 (f15 f16 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) ?v3) f1) (= (f3 (f4 f34 (f11 (f13 f14 ?v0) ?v2)) (f11 (f13 f14 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f9 (f15 f18 ?v0) ?v2) (f9 (f15 f18 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) ?v3) f1) (= (f3 (f4 f34 (f11 (f13 f17 ?v0) ?v2)) (f11 (f13 f17 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f9 (f15 f18 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 (f11 (f13 f17 ?v1) ?v2)) f1) (=> (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) false)) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f9 (f15 f16 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f34 (f11 (f13 f14 ?v0) ?v1)) ?v2) f1) (=> (=> (= (f3 (f4 f34 ?v0) ?v2) f1) (=> (= (f3 (f4 f34 ?v1) ?v2) f1) false)) false))))
(assert (= (f3 (f4 f34 f6) f35) f1))
(assert (<= 0 1))
(assert (not (= (f3 (f4 f34 f35) f6) f1)))
(assert (not (<= 1 0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f34 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f9 f10 ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f34 ?v0) (f11 f12 ?v0)) f1)))
(assert (forall ((?v0 S2)) (= (= f35 ?v0) (= ?v0 f35))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 ?v1) (and (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f34 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f9 (f15 f16 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (= (= (f3 ?v_0 (f11 (f13 f14 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f9 (f15 f18 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 f34 (f11 (f13 f17 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f34 ?v0) ?v2) f1) (= (f3 (f4 f34 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 ?v1) (= (f3 (f4 f34 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (= (f3 (f4 f34 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f34 ?v1) ?v2) f1) (= (f3 (f4 f34 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f34 ?v2) ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f34 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f34 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f34 ?v2))) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f9 f10 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 (f11 f12 ?v0)) ?v1) f1) (= (f3 (f4 f34 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (=> (= (f3 (f4 f34 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f34 ?v1) ?v0) f1) false) false))))
(assert (= (f11 f25 f35) f35))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S2)) (=> (= (f21 f27 ?v0) f1) (=> (= (f3 (f4 f34 ?v1) ?v2) f1) (<= (f19 ?v0 ?v1) (f19 ?v0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 Int) (?v2 Int)) (=> (= (f23 f28 ?v0) f1) (=> (<= ?v1 ?v2) (= (f3 (f4 f34 (f20 ?v0 ?v1)) (f20 ?v0 ?v2)) f1)))))
(assert (forall ((?v0 S10) (?v1 Int) (?v2 Int)) (=> (= (f23 f24 ?v0) f1) (= (= (f3 (f4 f34 (f20 ?v0 ?v1)) (f20 ?v0 ?v2)) f1) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S2) (?v2 S2)) (=> (= (f21 f22 ?v0) f1) (= (<= (f19 ?v0 ?v1) (f19 ?v0 ?v2)) (= (f3 (f4 f34 ?v1) ?v2) f1)))))
(assert (not (= (f3 (f4 f5 f35) f6) f1)))
(assert (not (< 1 0)))
(assert (= (f3 (f4 f5 f6) f35) f1))
(assert (< 0 1))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f34 f6))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f34 ?v1) f6) f1)) (and (= (f3 (f4 f34 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1))) (= (f3 (f4 f34 (f11 (f13 f32 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f9 (f15 f33 ?v0) ?v1) 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f34 f6))) (=> (and (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f34 ?v0) f6) f1)) (or (= (f3 ?v_0 ?v1) f1) (= (f3 (f4 f34 ?v1) f6) f1))) (= (f11 f12 (f11 (f13 f32 ?v0) ?v1)) (f11 (f13 f32 (f11 f12 ?v0)) (f11 f12 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f9 f10 (f9 (f15 f33 ?v0) ?v1)) (f9 (f15 f33 (f9 f10 ?v0)) (f9 f10 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f34 f6))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f34 ?v0) f6) f1) (= (f3 (f4 f34 ?v1) f6) f1))) (= (f3 ?v_0 (f11 (f13 f32 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f9 (f15 f33 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f34 f6))) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f34 (f11 (f13 f32 ?v0) ?v2)) (f11 (f13 f32 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f9 (f15 f33 ?v0) ?v2) (f9 (f15 f33 ?v1) ?v3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f34 f6))) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 f34 (f11 (f13 f32 ?v0) ?v2)) (f11 (f13 f32 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f9 (f15 f33 ?v0) ?v2) (f9 (f15 f33 ?v1) ?v3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v2))) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) f6) f1) (= (f3 (f4 f34 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f9 ?v_0 ?v1) (f9 ?v_0 ?v0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) f6) f1) (= (f3 (f4 f34 (f11 (f13 f32 ?v1) ?v2)) (f11 (f13 f32 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f9 (f15 f33 ?v1) ?v2) (f9 (f15 f33 ?v0) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v2))) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 f6) ?v2) f1) (= (f3 (f4 f34 (f11 ?v_0 ?v0)) (f11 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v2))) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 f6) ?v2) f1) (= (f3 (f4 f34 (f11 ?v_0 ?v0)) (f11 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 f6) ?v2) f1) (= (f3 (f4 f34 (f11 (f13 f32 ?v0) ?v2)) (f11 (f13 f32 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f9 (f15 f33 ?v0) ?v2) (f9 (f15 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) f6) f1) (=> (= (f3 (f4 f34 ?v1) f6) f1) (= (f3 (f4 f34 f6) (f11 (f13 f32 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f9 (f15 f33 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 ?v0) f6) f1) (=> (= (f3 (f4 f34 f6) ?v1) f1) (= (f3 (f4 f34 (f11 (f13 f32 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f9 (f15 f33 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 f6) ?v0) f1) (=> (= (f3 (f4 f34 ?v1) f6) f1) (= (f3 (f4 f34 (f11 (f13 f32 ?v1) ?v0)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f9 (f15 f33 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 f6) ?v0) f1) (=> (= (f3 (f4 f34 ?v1) f6) f1) (= (f3 (f4 f34 (f11 (f13 f32 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f9 (f15 f33 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f34 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f11 (f13 f32 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f9 (f15 f33 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f34 f6) ?v0) f1) (= (f11 (f13 f32 (f11 f12 ?v1)) ?v0) (f11 f12 (f11 (f13 f32 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f9 (f15 f33 (f9 f10 ?v1)) ?v0) (f9 f10 (f9 (f15 f33 ?v1) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f34 f6))) (= (= (f3 (f4 f34 (f11 (f13 f32 ?v0) ?v1)) f6) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f34 ?v1) f6) f1)) (and (= (f3 (f4 f34 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f9 (f15 f33 ?v0) ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f34 f6))) (= (= (f3 ?v_0 (f11 (f13 f32 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f34 ?v0) f6) f1) (= (f3 (f4 f34 ?v1) f6) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (f9 (f15 f33 ?v0) ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f34 f6) (f11 (f13 f32 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f9 (f15 f33 ?v0) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 f35))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f11 (f13 f32 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (f9 (f15 f33 ?v0) ?v1))))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f11 f25 ?v0) f35))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (=> (= (f3 (f4 f34 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f3 (f4 f34 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v0))) (=> (<= (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f34 (f11 (f13 f32 ?v0) ?v1)) (f11 (f13 f32 ?v2) ?v1)) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f34 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f9 (f15 f33 ?v0) ?v1) (f9 (f15 f33 ?v2) ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (=> (= (f3 (f4 f5 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f34 f6) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v0))) (=> (< (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f32 ?v0))) (=> (= (f3 (f4 f5 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f34 f6) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f33 ?v0))) (=> (< (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 (f11 (f13 f32 ?v0) ?v1)) (f11 (f13 f32 ?v2) ?v1)) f1) (=> (= (f3 (f4 f34 f6) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f9 (f15 f33 ?v0) ?v1) (f9 (f15 f33 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 (f4 f5 (f11 (f13 f32 ?v0) ?v1)) (f11 (f13 f32 ?v2) ?v1)) f1) (=> (= (f3 (f4 f34 f6) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f9 (f15 f33 ?v0) ?v1) (f9 (f15 f33 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(check-sat)
(exit)
