(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S3 S2) S2)
(declare-fun f6 (S4 S2) S3)
(declare-fun f7 () S4)
(declare-fun f8 () S4)
(declare-fun f9 () S2)
(declare-fun f10 () S2)
(declare-fun f11 (S5 Int) S2)
(declare-fun f12 () S5)
(declare-fun f13 (S6 Int) Int)
(declare-fun f14 () S6)
(declare-fun f15 () S6)
(declare-fun f16 () Int)
(declare-fun f17 () S6)
(declare-fun f18 (S7 Int) S8)
(declare-fun f19 () S7)
(declare-fun f20 () S8)
(declare-fun f21 (S9 S8) Int)
(declare-fun f22 () S9)
(declare-fun f23 () S7)
(declare-fun f24 () S3)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f5 (f6 f7 (f5 (f6 f8 f9) f10)) (f11 f12 (f13 f14 (f13 f15 f16)))))) (not (and (= (f3 f4 ?v_0) f1) (and (= (f3 ?v_0 f9) f1) (= (f3 ?v_0 f10) f1))))))
(assert (= (f3 f4 f9) f1))
(assert (= (f3 f4 f10) f1))
(assert (forall ((?v0 S2)) (= (= (f3 f4 (f5 (f6 f7 ?v0) (f11 f12 (f13 f14 (f13 f15 f16))))) f1) (= (f3 f4 ?v0) f1))))
(assert (forall ((?v0 S2)) (=> (= (f3 f4 ?v0) f1) (= (f3 f4 (f5 (f6 f7 ?v0) (f11 f12 (f13 f14 (f13 f15 f16))))) f1))))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f11 f12 (f13 f15 f16))) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f11 f12 (f13 f15 f16))) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 (f6 f7 ?v0) (f11 f12 f16)) f4)))
(assert (forall ((?v0 Int)) (= (= (f3 f4 (f11 f12 ?v0)) f1) (< f16 ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f13 f17 ?v0)) (< f16 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f3 (f11 f12 ?v0) f4) f1) (< ?v0 f16))))
(assert (forall ((?v0 Int)) (= (< (f13 f17 ?v0) 0) (< ?v0 f16))))
(assert (= f4 (f11 f12 f16)))
(assert (= 0 0))
(assert (= (f11 f12 f16) f4))
(assert (= 0 0))
(assert (= (f18 f19 f16) f20))
(assert (= (f11 f12 f16) f4))
(assert (= 0 0))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f4 (f5 (f6 f7 ?v0) ?v1)) f1) (or (and (= (f3 f4 ?v0) f1) (= (f3 f4 ?v1) f1)) (and (= (f3 ?v0 f4) f1) (= (f3 ?v1 f4) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f5 (f6 f7 ?v0) ?v1) f4) f1) (or (and (= (f3 f4 ?v0) f1) (= (f3 ?v1 f4) f1)) (and (= (f3 ?v0 f4) f1) (= (f3 f4 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f21 f22 (f18 f19 ?v0)) (f21 f22 (f18 f19 ?v1))) (ite (< ?v0 ?v1) (< f16 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f21 f22 (f18 f19 ?v0)) (f21 f22 (f18 f19 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f16)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 f23 (+ (f21 f22 (f18 f19 ?v0)) (f21 f22 (f18 f19 ?v1)))) (ite (< ?v0 f16) (f18 f23 (f13 f17 ?v1)) (ite (< ?v1 f16) (f18 f23 (f13 f17 ?v0)) (f18 f23 (f13 f17 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f18 f23 (f13 f17 ?v0)) (f18 f23 0)) (<= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (f18 f23 0) (f18 f23 (f13 f17 ?v0))) (<= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (< 0 (f21 f22 (f18 f19 ?v0))) (< f16 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 f12 ?v0) (f11 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 f17 ?v0) (f13 f17 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f18 f19 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f17 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f15 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f15 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f15 ?v0) (f13 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f15 ?v0) (f13 f15 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 f15 ?v0) (f13 f15 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f13 f15 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f13 f15 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f16) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f16) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f16 ?v0) ?v0)))
(assert (= (<= f16 f16) true))
(assert (= (< f16 0) false))
(assert (= (< f16 f16) false))
(assert (= (= f16 f16) true))
(assert (= (- f16) f16))
(assert (= f16 0))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f14 ?v0) (f13 f14 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f14 ?v0) (f13 f14 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f14 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f14 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f13 f14 ?v0) (f13 f14 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f13 f14 ?v0) (f13 f14 ?v1)) (f13 f14 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f13 f14 ?v0) (f13 f14 ?v1)) (f13 f14 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f13 f14 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f13 f14 ?v0)) (f13 f14 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f13 f14 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f5 f24 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f24 ?v0)) (f5 f24 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f11 f12 ?v0) (f11 f12 ?v1)) f1) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f17 ?v0) (f13 f17 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f4)) (= (f5 f24 (f5 (f6 f7 ?v1) ?v0)) (f5 (f6 f7 (f5 f24 ?v1)) (f5 f24 ?v0))))))
(assert (forall ((?v0 Int)) (= (<= (f13 f15 ?v0) f16) (< ?v0 f16))))
(assert (forall ((?v0 Int)) (= (< (f13 f15 ?v0) f16) (< ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (f13 f15 ?v0) f16) false)))
(assert (forall ((?v0 Int)) (= (<= f16 (f13 f15 ?v0)) (<= f16 ?v0))))
(assert (forall ((?v0 Int)) (= (< f16 (f13 f15 ?v0)) (<= f16 ?v0))))
(assert (forall ((?v0 Int)) (= (= f16 (f13 f15 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f15 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f15 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f14 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f13 f14 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f15 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f15 ?v0) (f13 f14 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f14 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f13 f14 ?v0) (f13 f15 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 S8)) (= (f18 f23 (f21 f22 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f21 f22 (f18 f23 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f21 f22 (f18 f23 ?v0)) 0))))
(check-sat)
(exit)
