(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S4 S5) Int)
(declare-fun f4 () S4)
(declare-fun f5 (S6 S3) S5)
(declare-fun f6 () S6)
(declare-fun f7 (S7 S3) S3)
(declare-fun f8 (S8 S2) S7)
(declare-fun f9 () S8)
(declare-fun f10 () S8)
(declare-fun f11 () S3)
(declare-fun f12 (S9 Int) S5)
(declare-fun f13 () S9)
(declare-fun f14 (S10 S2) S3)
(declare-fun f15 (S11 S3) S10)
(declare-fun f16 () S11)
(declare-fun f17 () S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3)) (<= (f3 f4 (f5 f6 (f7 (f8 f9 ?v0) ?v1))) (f3 f4 (f5 f6 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f5 f6 (f7 (f8 f10 ?v0) ?v1)) (ite (= ?v1 f11) (f12 f13 0) (f12 f13 (+ (f3 f4 (f5 f6 ?v1)) 1))))))
(assert (forall ((?v0 S3) (?v1 S2)) (= (= (f14 (f15 f16 ?v0) ?v1) f11) (= ?v0 f11))))
(assert (not (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 (f15 f16 ?v1) f17))) (=> (= (f5 f6 ?v_0) (f5 f6 ?v1)) (=> (not (= ?v1 f11)) (< (f3 f4 (f5 f6 (f7 (f8 f9 f17) ?v_0))) (f3 f4 (f5 f6 (f7 (f8 f10 ?v0) ?v_0))))))))))
(assert (forall ((?v0 S5)) (= (f12 f13 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
