(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S4) S1)
(declare-fun f4 (S5 S2) S3)
(declare-fun f5 () S5)
(declare-fun f6 (S6 S4) S4)
(declare-fun f7 () S6)
(declare-fun f8 () S4)
(declare-fun f9 (S4 S2) S1)
(declare-fun f10 () S2)
(declare-fun f11 (S7 S2) S4)
(declare-fun f12 () S7)
(declare-fun f13 () S2)
(declare-fun f14 (S8 Int) Int)
(declare-fun f15 (S9 Int) S8)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S2) S2)
(declare-fun f18 (S11 S2) S10)
(declare-fun f19 () S11)
(declare-fun f20 () S9)
(declare-fun f21 () S11)
(declare-fun f22 (S12 Int) S1)
(declare-fun f23 (S13 S14) Int)
(declare-fun f24 (S15 Int) S14)
(declare-fun f25 () S15)
(declare-fun f26 () S13)
(declare-fun f27 (S16 S14) S2)
(declare-fun f28 () S7)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 S2)) (= (f3 (f4 f5 ?v0) (f6 f7 f8)) f1))))
(assert (exists ((?v0 S2)) (= (f9 f8 ?v0) f1)))
(assert (exists ((?v0 S2)) (= (f9 f8 ?v0) f1)))
(assert (= (f9 f8 f10) f1))
(assert (exists ((?v0 S2)) (forall ((?v1 S2)) (=> (= (f9 f8 ?v1) f1) (= (f9 (f11 f12 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f9 f8 ?v0) f1) (= (f9 (f11 f12 ?v0) f13) f1))))
(assert (=> (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 f8 ?v0) f1) (=> (forall ((?v2 S2)) (=> (= (f9 f8 ?v2) f1) (= (f9 (f11 f12 ?v2) ?v1) f1))) false))) false))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S2)) (not (= (f9 (f11 f12 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= ?v0 ?v1)) (or (= (f9 (f11 f12 ?v0) ?v1) f1) (= (f9 (f11 f12 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (not (= (f9 (f11 f12 ?v0) ?v1) f1)) (or (= (f9 (f11 f12 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (or (= (f9 (f11 f12 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f9 (f11 f12 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f14 (f15 f16 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (= (f9 ?v_0 (f17 (f18 f19 ?v1) ?v2)) f1) (or (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f14 (f15 f20 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (= (f9 ?v_0 (f17 (f18 f21 ?v1) ?v2)) f1) (and (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f14 (f15 f16 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f9 (f11 f12 (f17 (f18 f19 ?v0) ?v1)) ?v2) f1) (and (= (f9 (f11 f12 ?v0) ?v2) f1) (= (f9 (f11 f12 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f14 (f15 f20 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f9 (f11 f12 (f17 (f18 f21 ?v0) ?v1)) ?v2) f1) (or (= (f9 (f11 f12 ?v0) ?v2) f1) (= (f9 (f11 f12 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= (f9 (f11 f12 ?v0) ?v1) f1)) (= (not (= (f9 (f11 f12 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f9 (f11 f12 ?v0) ?v1) f1) false) (=> (=> (= (f9 (f11 f12 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f9 (f11 f12 ?v0) ?v1) f1) false) (=> (=> (= (f9 (f11 f12 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (=> (= (f9 (f11 f12 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f9 (f11 f12 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (=> (=> (not false) (= (f9 (f11 f12 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (=> (= (f9 ?v_0 ?v0) f1) (= (f9 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 (f11 f12 ?v1) ?v2) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f9 (f11 f12 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (=> (= ?v0 ?v1) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 ?v1) (=> (= (f9 (f11 f12 ?v1) ?v2) f1) (= (f9 (f11 f12 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (=> (= (f9 (f11 f12 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (=> (= (f9 (f11 f12 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S1)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (= (=> (= (f9 (f11 f12 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (= (not (= (f9 (f11 f12 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (not (= (f9 (f11 f12 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f14 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f14 ?v1 ?v5) (f14 ?v1 ?v4)))) (< (f14 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S10) (?v2 S2) (?v3 S2)) (=> (= ?v0 (f17 ?v1 ?v2)) (=> (= (f9 (f11 f12 ?v3) ?v2) f1) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f9 (f11 f12 ?v5) ?v4) f1) (= (f9 (f11 f12 (f17 ?v1 ?v5)) (f17 ?v1 ?v4)) f1))) (= (f9 (f11 f12 (f17 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f14 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f14 ?v2 ?v5) (f14 ?v2 ?v4)))) (< ?v3 (f14 ?v2 ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S10) (?v3 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (=> (= (f17 ?v2 ?v0) ?v3) (=> (forall ((?v4 S2) (?v5 S2)) (=> (= (f9 (f11 f12 ?v5) ?v4) f1) (= (f9 (f11 f12 (f17 ?v2 ?v5)) (f17 ?v2 ?v4)) f1))) (= (f9 (f11 f12 ?v3) (f17 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (exists ((?v2 S2)) (and (= (f9 (f11 f12 ?v0) ?v2) f1) (= (f9 (f11 f12 ?v2) ?v1) f1))))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (= (f9 (f11 f12 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2)) (exists ((?v1 S2)) (= (f9 (f11 f12 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f14 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f17 (f18 f19 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f14 (f15 f16 ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f17 (f18 f19 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f14 (f15 f20 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (= (f9 (f11 f12 (f17 (f18 f21 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f14 (f15 f20 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f9 (f11 f12 ?v0) ?v1) f1) (= (f9 (f11 f12 (f17 (f18 f21 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12) (?v3 S12)) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f22 ?v0 ?v5) f1) (= (f22 ?v1 ?v5) f1))))) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f22 ?v2 ?v5) f1) (= (f22 ?v3 ?v5) f1))))) (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (or (= (f22 ?v0 ?v5) f1) (= (f22 ?v2 ?v5) f1)) (or (= (f22 ?v1 ?v5) f1) (= (f22 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v4) ?v5) f1) (= (= (f9 ?v0 ?v5) f1) (= (f9 ?v1 ?v5) f1))))) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v4) ?v5) f1) (= (= (f9 ?v2 ?v5) f1) (= (f9 ?v3 ?v5) f1))))) (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v4) ?v5) f1) (= (or (= (f9 ?v0 ?v5) f1) (= (f9 ?v2 ?v5) f1)) (or (= (f9 ?v1 ?v5) f1) (= (f9 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12) (?v3 S12)) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f22 ?v0 ?v5) f1) (= (f22 ?v1 ?v5) f1))))) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (= (f22 ?v2 ?v5) f1) (= (f22 ?v3 ?v5) f1))))) (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v4 ?v5) (= (and (= (f22 ?v0 ?v5) f1) (= (f22 ?v2 ?v5) f1)) (and (= (f22 ?v1 ?v5) f1) (= (f22 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v4) ?v5) f1) (= (= (f9 ?v0 ?v5) f1) (= (f9 ?v1 ?v5) f1))))) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v4) ?v5) f1) (= (= (f9 ?v2 ?v5) f1) (= (f9 ?v3 ?v5) f1))))) (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v4) ?v5) f1) (= (and (= (f9 ?v0 ?v5) f1) (= (f9 ?v2 ?v5) f1)) (and (= (f9 ?v1 ?v5) f1) (= (f9 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12) (?v3 S12)) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (= (f22 ?v0 ?v5) f1) (= (f22 ?v1 ?v5) f1))))) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (= (f22 ?v2 ?v5) f1) (= (f22 ?v3 ?v5) f1))))) (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (or (= (f22 ?v0 ?v5) f1) (= (f22 ?v2 ?v5) f1)) (or (= (f22 ?v1 ?v5) f1) (= (f22 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v5) ?v4) f1) (= (= (f9 ?v0 ?v5) f1) (= (f9 ?v1 ?v5) f1))))) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v5) ?v4) f1) (= (= (f9 ?v2 ?v5) f1) (= (f9 ?v3 ?v5) f1))))) (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v5) ?v4) f1) (= (or (= (f9 ?v0 ?v5) f1) (= (f9 ?v2 ?v5) f1)) (or (= (f9 ?v1 ?v5) f1) (= (f9 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12) (?v3 S12)) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (= (f22 ?v0 ?v5) f1) (= (f22 ?v1 ?v5) f1))))) (=> (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (= (f22 ?v2 ?v5) f1) (= (f22 ?v3 ?v5) f1))))) (exists ((?v4 Int)) (forall ((?v5 Int)) (=> (< ?v5 ?v4) (= (and (= (f22 ?v0 ?v5) f1) (= (f22 ?v2 ?v5) f1)) (and (= (f22 ?v1 ?v5) f1) (= (f22 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v5) ?v4) f1) (= (= (f9 ?v0 ?v5) f1) (= (f9 ?v1 ?v5) f1))))) (=> (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v5) ?v4) f1) (= (= (f9 ?v2 ?v5) f1) (= (f9 ?v3 ?v5) f1))))) (exists ((?v4 S2)) (forall ((?v5 S2)) (=> (= (f9 (f11 f12 ?v5) ?v4) f1) (= (and (= (f9 ?v0 ?v5) f1) (= (f9 ?v2 ?v5) f1)) (and (= (f9 ?v1 ?v5) f1) (= (f9 ?v3 ?v5) f1))))))))))
(assert (forall ((?v0 S13) (?v1 S14) (?v2 S14)) (=> (forall ((?v3 S14)) (< (f23 ?v0 ?v3) (f23 ?v0 (f24 f25 (+ (f23 f26 ?v3) 1))))) (=> (< (f23 f26 ?v1) (f23 f26 ?v2)) (< (f23 ?v0 ?v1) (f23 ?v0 ?v2))))))
(assert (forall ((?v0 S16) (?v1 S14) (?v2 S14)) (=> (forall ((?v3 S14)) (= (f9 (f11 f12 (f27 ?v0 ?v3)) (f27 ?v0 (f24 f25 (+ (f23 f26 ?v3) 1)))) f1)) (=> (< (f23 f26 ?v1) (f23 f26 ?v2)) (= (f9 (f11 f12 (f27 ?v0 ?v1)) (f27 ?v0 ?v2)) f1)))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S2)) (= (f9 (f11 f28 ?v0) ?v0) f1)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f9 (f11 f28 (f17 (f18 f19 ?v0) ?v1)) ?v2) f1) (=> (=> (= (f9 (f11 f28 ?v0) ?v2) f1) (=> (= (f9 (f11 f28 ?v1) ?v2) f1) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f14 (f15 f16 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f28 ?v0))) (=> (= (f9 ?v_0 (f17 (f18 f21 ?v1) ?v2)) f1) (=> (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 ?v_0 ?v2) f1) false)) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f14 (f15 f20 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (=> (= (f9 (f11 f28 ?v2) ?v3) f1) (= (f9 (f11 f28 (f17 (f18 f21 ?v0) ?v2)) (f17 (f18 f21 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f14 (f15 f20 ?v0) ?v2) (f14 (f15 f20 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (=> (= (f9 (f11 f28 ?v2) ?v3) f1) (= (f9 (f11 f28 (f17 (f18 f19 ?v0) ?v2)) (f17 (f18 f19 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f14 (f15 f16 ?v0) ?v2) (f14 (f15 f16 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (=> (= (f9 (f11 f28 ?v2) ?v1) f1) (= (f9 (f11 f28 (f17 (f18 f19 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f14 (f15 f16 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (=> (= (f9 (f11 f28 ?v2) ?v1) f1) (= (f9 (f11 f28 (f17 (f18 f19 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f14 (f15 f16 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f28 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f17 (f18 f21 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f14 (f15 f20 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f28 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (=> (= (f9 ?v_0 ?v2) f1) (= (f9 ?v_0 (f17 (f18 f21 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f14 (f15 f20 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (= (f17 (f18 f21 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f14 (f15 f20 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (= (f17 (f18 f19 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f14 (f15 f16 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (= (f17 (f18 f21 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f14 (f15 f20 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (= (f17 (f18 f19 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f14 (f15 f16 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (= (f9 (f11 f28 (f17 (f18 f21 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f14 (f15 f20 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (= (f9 (f11 f28 (f17 (f18 f21 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f14 (f15 f20 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f28 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f17 (f18 f19 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f14 (f15 f16 ?v2) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f9 ?v1 ?v0) f1))))
(assert (forall ((?v0 S4)) (= (f6 f7 ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f28 ?v0))) (=> (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 (f17 (f18 f19 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f14 (f15 f16 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f18 f21 ?v0))) (= (f9 (f11 f28 (f17 (f18 f19 (f17 ?v_0 ?v1)) (f17 ?v_0 ?v2))) (f17 ?v_0 (f17 (f18 f19 ?v1) ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f20 ?v0))) (<= (f14 (f15 f16 (f14 ?v_0 ?v1)) (f14 ?v_0 ?v2)) (f14 ?v_0 (f14 (f15 f16 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f9 (f11 f28 (f17 (f18 f19 ?v0) ?v1)) ?v2) f1) (and (= (f9 (f11 f28 ?v0) ?v2) f1) (= (f9 (f11 f28 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f14 (f15 f16 ?v0) ?v1) ?v2) (and (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f18 f19 ?v0))) (= (f9 (f11 f28 (f17 ?v_0 (f17 (f18 f21 ?v1) ?v2))) (f17 (f18 f21 (f17 ?v_0 ?v1)) (f17 ?v_0 ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v0))) (<= (f14 ?v_0 (f14 (f15 f20 ?v1) ?v2)) (f14 (f15 f20 (f14 ?v_0 ?v1)) (f14 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f28 ?v0))) (= (= (f9 ?v_0 (f17 (f18 f21 ?v1) ?v2)) f1) (and (= (f9 ?v_0 ?v1) f1) (= (f9 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f14 (f15 f20 ?v1) ?v2)) (and (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f9 (f11 f28 ?v0) ?v1) f1) (= (f17 (f18 f21 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f14 (f15 f20 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f9 (f11 f28 ?v0) ?v1) f1) (= (f17 (f18 f19 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f14 (f15 f16 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f11 f28 (f17 (f18 f21 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f14 (f15 f20 ?v0) ?v1) ?v1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f11 f28 (f17 (f18 f21 ?v0) ?v1)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f14 (f15 f20 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f11 f28 ?v0) (f17 (f18 f19 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f14 (f15 f16 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f9 (f11 f28 ?v0) (f17 (f18 f19 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f14 (f15 f16 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (=> (= (f9 (f11 f28 ?v0) ?v1) f1) false) (=> (=> (= (f9 (f11 f28 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f28 ?v2))) (=> (= (f9 (f11 f28 ?v0) ?v1) f1) (=> (= (f9 ?v_0 ?v0) f1) (= (f9 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S14)) (= (f24 f25 (f23 f26 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f23 f26 (f24 f25 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f23 f26 (f24 f25 ?v0)) 0))))
(check-sat)
(exit)
