(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S6 S4) S1)
(declare-fun f7 () S6)
(declare-fun f8 (S8 S7) S1)
(declare-fun f9 (S9 S7) S8)
(declare-fun f10 () S9)
(declare-fun f11 () S7)
(declare-fun f12 (S11 S10) Int)
(declare-fun f13 () S11)
(declare-fun f14 (S12 S5) S7)
(declare-fun f15 () S12)
(declare-fun f16 (S13 S5) S5)
(declare-fun f17 (S14 S5) S13)
(declare-fun f18 () S14)
(declare-fun f19 (S15 S10) S5)
(declare-fun f20 () S15)
(declare-fun f21 (S4 S10) S10)
(declare-fun f22 () S9)
(declare-fun f23 () S7)
(declare-fun f24 () S5)
(declare-fun f25 (S16 S7) S7)
(declare-fun f26 () S16)
(declare-fun f27 (S17 S7) S16)
(declare-fun f28 () S17)
(declare-fun f29 () S2)
(declare-fun f30 () S16)
(declare-fun f31 () S3)
(declare-fun f32 () S17)
(declare-fun f33 () S3)
(declare-fun f34 () S17)
(declare-fun f35 (S18 S7) Int)
(declare-fun f36 (S19 Int) S7)
(declare-fun f37 (S20 Int) S10)
(declare-fun f38 () S20)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (exists ((?v0 S4) (?v1 S5)) (and (= (f6 f7 ?v0) f1) (forall ((?v2 S7)) (=> (= (f8 (f9 f10 f11) ?v2) f1) (exists ((?v3 S10)) (forall ((?v4 S10)) (=> (<= (f12 f13 ?v3) (f12 f13 ?v4)) (= (f8 (f9 f10 (f14 f15 (f16 (f17 f18 (f19 f20 (f21 ?v0 ?v4))) ?v1))) ?v2) f1))))))))))
(assert (forall ((?v0 S10)) (= (f8 (f9 f22 (f14 f15 (f19 f20 ?v0))) f23) f1)))
(assert (forall ((?v0 S5)) (= (= (f8 (f9 f10 f11) (f14 f15 ?v0)) f1) (not (= ?v0 f24)))))
(assert (forall ((?v0 S7)) (= (= (f8 (f9 f10 f11) (f25 f26 ?v0)) f1) (not (= ?v0 f11)))))
(assert (forall ((?v0 S7)) (not (= (f8 (f9 f10 (f25 f26 ?v0)) f11) f1))))
(assert (forall ((?v0 S5)) (not (= (f8 (f9 f10 (f14 f15 ?v0)) f11) f1))))
(assert (forall ((?v0 S5)) (= (= (f14 f15 ?v0) f11) (= ?v0 f24))))
(assert (forall ((?v0 S7)) (= (= (f25 f26 ?v0) f11) (= ?v0 f11))))
(assert (= (f14 f15 f24) f11))
(assert (= (f25 f26 f11) f11))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f8 (f9 f10 ?v0) ?v1) f1) (= (f8 (f9 f10 (f25 (f27 f28 ?v0) ?v1)) f11) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (< (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f14 f15 (f16 (f17 f18 ?v0) ?v1)) (f14 f15 (f16 (f17 f18 ?v1) ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f25 f26 (f25 (f27 f28 ?v0) ?v1)) (f25 f26 (f25 (f27 f28 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f25 (f27 f28 ?v0) ?v1) (f25 (f27 f28 ?v2) ?v3)) (= (= (f8 (f9 f10 ?v0) ?v1) f1) (= (f8 (f9 f10 ?v2) ?v3) f1)))))
(assert (forall ((?v0 S5)) (= (f16 (f17 f18 ?v0) f24) ?v0)))
(assert (forall ((?v0 S7)) (= (f25 (f27 f28 ?v0) f11) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f16 (f17 f18 ?v0) ?v0) f24)))
(assert (forall ((?v0 S7)) (= (f25 (f27 f28 ?v0) ?v0) f11)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (= (f16 (f17 f18 ?v0) ?v1) f24))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 ?v1) (= (f25 (f27 f28 ?v0) ?v1) f11))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f16 (f17 f18 ?v0) ?v1) f24) (= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f25 (f27 f28 ?v0) ?v1) f11) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 f29 ?v0))))
(assert (forall ((?v0 S7)) (= (f8 (f9 f22 ?v0) (f25 f30 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f3 f29 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f22 (f25 f30 ?v0)) ?v1) f1) (= (f8 (f9 f22 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f29 ?v0) ?v0))))
(assert (forall ((?v0 S7)) (=> (= (f8 (f9 f22 f11) ?v0) f1) (= (f25 f30 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f3 f29 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S7)) (= (= (f8 (f9 f22 (f25 f30 ?v0)) f11) f1) (= ?v0 f11))))
(assert (forall ((?v0 Int)) (<= 0 (f3 f29 ?v0))))
(assert (forall ((?v0 S7)) (= (f8 (f9 f22 f11) (f25 f30 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f25 (f27 f28 ?v0) ?v1) (f25 (f27 f28 ?v2) ?v3)) (= (= (f8 (f9 f22 ?v0) ?v1) f1) (= (f8 (f9 f22 ?v2) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f29 ?v0) (f3 f29 ?v1)) (f3 f29 (- ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f8 (f9 f22 (f25 (f27 f28 (f25 f30 ?v0)) (f25 f30 ?v1))) (f25 f30 (f25 (f27 f28 ?v1) ?v0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f29 ?v0) (f3 f29 ?v1)) (f3 f29 (- ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f8 (f9 f22 (f25 (f27 f28 (f25 f30 ?v0)) (f25 f30 ?v1))) (f25 f30 (f25 (f27 f28 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f29 (- (f3 f29 ?v0) (f3 f29 ?v1))) (f3 f29 (- ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f8 (f9 f22 (f25 f30 (f25 (f27 f28 (f25 f30 ?v0)) (f25 f30 ?v1)))) (f25 f30 (f25 (f27 f28 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f8 (f9 f22 ?v0) ?v1) f1) (= (f8 (f9 f22 (f25 (f27 f28 ?v0) ?v1)) f11) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (<= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f9 f22 (f25 (f27 f28 (f14 f15 ?v0)) (f14 f15 ?v1))) (f14 f15 (f16 (f17 f18 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f8 (f9 f22 (f25 (f27 f28 (f25 f26 ?v0)) (f25 f26 ?v1))) (f25 f26 (f25 (f27 f28 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f9 f22 (f25 f30 (f25 (f27 f28 (f14 f15 ?v0)) (f14 f15 ?v1)))) (f14 f15 (f16 (f17 f18 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f8 (f9 f22 (f25 f30 (f25 (f27 f28 (f25 f26 ?v0)) (f25 f26 ?v1)))) (f25 f26 (f25 (f27 f28 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S7)) (= (f8 (f9 f22 f11) (f25 f26 ?v0)) f1)))
(assert (forall ((?v0 S5)) (= (f8 (f9 f22 f11) (f14 f15 ?v0)) f1)))
(assert (forall ((?v0 S5)) (= (= (f8 (f9 f22 (f14 f15 ?v0)) f11) f1) (= ?v0 f24))))
(assert (forall ((?v0 S7)) (= (= (f8 (f9 f22 (f25 f26 ?v0)) f11) f1) (= ?v0 f11))))
(assert (forall ((?v0 Int)) (= (= (f3 f29 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S7)) (= (= (f25 f30 ?v0) f11) (= ?v0 f11))))
(assert (forall ((?v0 S5)) (= (= f24 ?v0) (= ?v0 f24))))
(assert (forall ((?v0 S7)) (= (= f11 ?v0) (= ?v0 f11))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (= (f3 f29 0) 0))
(assert (= (f25 f30 f11) f11))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f16 (f17 f18 ?v0) ?v1) (f16 (f17 f18 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f25 (f27 f28 ?v0) ?v1) (f25 (f27 f28 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f31 ?v0) ?v1) ?v2) (f3 (f4 f31 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f25 (f27 f28 (f25 (f27 f32 ?v0) ?v1)) ?v2) (f25 (f27 f32 (f25 (f27 f28 ?v0) ?v2)) (f25 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f33 ?v0) ?v1) ?v2) (f3 (f4 f33 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f25 (f27 f28 (f25 (f27 f34 ?v0) ?v1)) ?v2) (f25 (f27 f34 (f25 (f27 f28 ?v0) ?v2)) (f25 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f29 (- ?v0 ?v1)) (f3 f29 (- ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f25 f30 (f25 (f27 f28 ?v0) ?v1)) (f25 f30 (f25 (f27 f28 ?v1) ?v0)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f25 f26 ?v0))) (= (f25 f30 ?v_0) ?v_0))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f14 f15 ?v0))) (= (f25 f30 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 f29 ?v0) ?v0))))
(assert (forall ((?v0 S7)) (=> (= (f8 (f9 f10 f11) ?v0) f1) (= (f25 f30 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f3 f29 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S7)) (= (= (f8 (f9 f10 f11) (f25 f30 ?v0)) f1) (not (= ?v0 f11)))))
(assert (forall ((?v0 Int)) (not (< (f3 f29 ?v0) 0))))
(assert (forall ((?v0 S7)) (not (= (f8 (f9 f10 (f25 f30 ?v0)) f11) f1))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S7)) (= (f8 (f9 f22 ?v0) ?v0) f1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f8 (f9 f22 ?v0) ?v1) f1) (or (= (f8 (f9 f10 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f8 (f9 f10 ?v0) ?v1) f1) (and (= (f8 (f9 f22 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f8 (f9 f22 ?v0) ?v1) f1) (= (f8 (f9 f22 (f25 (f27 f28 ?v0) ?v1)) f11) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f10 ?v2))) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (= (f8 ?v_0 ?v0) f1) (= (f8 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (= (f8 (f9 f10 ?v1) ?v2) f1) (= (f8 (f9 f10 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (=> (= (f8 (f9 f22 ?v2) ?v0) f1) (= (f8 (f9 f10 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= (f8 (f9 f22 ?v1) ?v2) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f8 (f9 f10 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f8 (f9 f10 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (or (= (f8 (f9 f10 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (=> (= (f8 (f9 f22 ?v0) ?v1) f1) false) (=> (=> (= (f8 (f9 f22 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f22 ?v2))) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (= (f8 ?v_0 ?v0) f1) (= (f8 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (= (f8 (f9 f22 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f22 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= (f8 (f9 f22 ?v1) ?v2) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (= (f8 (f9 f22 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f8 (f9 f22 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f22 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f22 ?v2))) (=> (= ?v0 ?v1) (=> (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= ?v0 ?v1) (=> (= (f8 (f9 f22 ?v1) ?v2) f1) (= (f8 (f9 f22 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (= (= (f8 (f9 f22 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= ?v0 ?v1) (= (f8 (f9 f22 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f3 (f4 f31 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f8 (f9 f22 (f25 (f27 f32 ?v0) ?v1)) ?v2) f1) (or (= (f8 (f9 f22 ?v0) ?v2) f1) (= (f8 (f9 f22 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f3 (f4 f33 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f22 ?v0))) (= (= (f8 ?v_0 (f25 (f27 f34 ?v1) ?v2)) f1) (or (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 ?v1) (and (= (f8 (f9 f22 ?v0) ?v1) f1) (= (f8 (f9 f22 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f8 (f9 f22 ?v0) ?v1) f1) (= (f8 (f9 f22 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S7)) (not (= (f8 (f9 f10 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= ?v0 ?v1)) (or (= (f8 (f9 f10 ?v0) ?v1) f1) (= (f8 (f9 f10 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= (f8 (f9 f10 ?v0) ?v1) f1)) (or (= (f8 (f9 f10 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f8 (f9 f10 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f8 (f9 f10 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f3 (f4 f33 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f10 ?v0))) (= (= (f8 ?v_0 (f25 (f27 f34 ?v1) ?v2)) f1) (or (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f3 (f4 f31 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f10 ?v0))) (= (= (f8 ?v_0 (f25 (f27 f32 ?v1) ?v2)) f1) (and (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f3 (f4 f33 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f8 (f9 f10 (f25 (f27 f34 ?v0) ?v1)) ?v2) f1) (and (= (f8 (f9 f10 ?v0) ?v2) f1) (= (f8 (f9 f10 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f3 (f4 f31 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f8 (f9 f10 (f25 (f27 f32 ?v0) ?v1)) ?v2) f1) (or (= (f8 (f9 f10 ?v0) ?v2) f1) (= (f8 (f9 f10 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f8 (f9 f10 ?v0) ?v1) f1)) (= (not (= (f8 (f9 f10 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f8 (f9 f10 ?v0) ?v1) f1) false) (=> (=> (= (f8 (f9 f10 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (not (= (f8 (f9 f10 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (= (not (= (f8 (f9 f10 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S1)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (= (=> (= (f8 (f9 f10 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (=> (= (f8 (f9 f10 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (=> (= (f8 (f9 f10 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= ?v0 ?v1) (=> (= (f8 (f9 f10 ?v1) ?v2) f1) (= (f8 (f9 f10 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f10 ?v2))) (=> (= ?v0 ?v1) (=> (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f8 (f9 f10 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= (f8 (f9 f10 ?v1) ?v2) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f10 ?v2))) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (=> (= (f8 ?v_0 ?v0) f1) (= (f8 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (=> (=> (not false) (= (f8 (f9 f10 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (=> (= (f8 (f9 f10 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f8 (f9 f10 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (= (f8 (f9 f22 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f9 f22 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= (f8 (f9 f22 ?v1) ?v2) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f8 (f9 f22 ?v0) ?v1) f1) (= (f8 (f9 f22 ?v1) ?v0) f1))))
(assert (forall ((?v0 S7)) (= (f8 (f9 f22 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= (f8 (f9 f10 ?v0) ?v1) f1)) (= (f8 (f9 f22 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (not (= (f8 (f9 f22 ?v0) ?v1) f1)) (= (f8 (f9 f10 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (or (= (f8 (f9 f22 ?v0) ?v1) f1) (= (f8 (f9 f10 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f8 (f9 f10 ?v0) ?v1) f1) (and (= (f8 (f9 f22 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f8 (f9 f10 ?v0) ?v1) f1) (and (= (f8 (f9 f22 ?v0) ?v1) f1) (not (= (f8 (f9 f22 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f8 (f9 f22 ?v0) ?v1) f1) (or (= (f8 (f9 f10 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f8 (f9 f10 ?v0) ?v1) f1)) (= (f8 (f9 f22 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f8 (f9 f22 ?v0) ?v1) f1)) (= (f8 (f9 f10 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= (f8 (f9 f10 ?v0) ?v1) f1)) (= (= (f8 (f9 f22 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 ?v1)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (= (f8 (f9 f10 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 ?v1)) (=> (= (f8 (f9 f22 ?v1) ?v0) f1) (= (f8 (f9 f10 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (not (= (f8 (f9 f10 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (= (f8 (f9 f22 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (= (not (= (f8 (f9 f10 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f9 f10 f11))) (=> (= (f8 ?v_0 ?v0) f1) (=> (= (f8 ?v_0 ?v1) f1) (exists ((?v2 S7)) (let ((?v_1 (f9 f10 ?v2))) (and (= (f8 ?v_0 ?v2) f1) (and (= (f8 ?v_1 ?v0) f1) (= (f8 ?v_1 ?v1) f1))))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (forall ((?v2 S7)) (=> (= (f8 (f9 f10 ?v2) ?v0) f1) (= (f8 (f9 f22 ?v2) ?v1) f1))) (= (f8 (f9 f22 ?v0) ?v1) f1))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (=> (forall ((?v3 S7)) (=> (= (f8 (f9 f10 ?v0) ?v3) f1) (=> (= (f8 (f9 f10 ?v3) ?v1) f1) (= (f8 (f9 f22 ?v3) ?v2) f1)))) (= (f8 (f9 f22 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (< ?v0 ?v1) (=> (<= ?v2 (f3 ?v3 ?v0)) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f3 ?v3 ?v5) (f3 ?v3 ?v4)))) (< ?v2 (f3 ?v3 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int) (?v3 S18)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (=> (<= ?v2 (f35 ?v3 ?v0)) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f8 (f9 f10 ?v5) ?v4) f1) (< (f35 ?v3 ?v5) (f35 ?v3 ?v4)))) (< ?v2 (f35 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 S19)) (=> (< ?v0 ?v1) (=> (= (f8 (f9 f22 ?v2) (f36 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f8 (f9 f10 (f36 ?v3 ?v5)) (f36 ?v3 ?v4)) f1))) (= (f8 (f9 f10 ?v2) (f36 ?v3 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (<= ?v0 ?v1) (=> (< ?v2 (f3 ?v3 ?v0)) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f3 ?v3 ?v5) (f3 ?v3 ?v4)))) (< ?v2 (f3 ?v3 ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int) (?v3 S18)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (< ?v2 (f35 ?v3 ?v0)) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f8 (f9 f22 ?v5) ?v4) f1) (<= (f35 ?v3 ?v5) (f35 ?v3 ?v4)))) (< ?v2 (f35 ?v3 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= (f3 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (< (f3 ?v2 ?v4) (f3 ?v2 ?v5)))) (< (f3 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S18) (?v3 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (=> (<= (f35 ?v2 ?v1) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f8 (f9 f10 ?v4) ?v5) f1) (< (f35 ?v2 ?v4) (f35 ?v2 ?v5)))) (< (f35 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S19) (?v3 S7)) (=> (< ?v0 ?v1) (=> (= (f8 (f9 f22 (f36 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f8 (f9 f10 (f36 ?v2 ?v4)) (f36 ?v2 ?v5)) f1))) (= (f8 (f9 f10 (f36 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< (f3 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (<= (f3 ?v2 ?v4) (f3 ?v2 ?v5)))) (< (f3 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S18) (?v3 Int)) (=> (= (f8 (f9 f22 ?v0) ?v1) f1) (=> (< (f35 ?v2 ?v1) ?v3) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f8 (f9 f22 ?v4) ?v5) f1) (<= (f35 ?v2 ?v4) (f35 ?v2 ?v5)))) (< (f35 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 Int)) (=> (< ?v0 (f3 ?v1 ?v2)) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (<= (f3 ?v1 ?v4) (f3 ?v1 ?v5)))) (< ?v0 (f3 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S18) (?v2 S7) (?v3 S7)) (=> (< ?v0 (f35 ?v1 ?v2)) (=> (= (f8 (f9 f22 ?v2) ?v3) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f8 (f9 f22 ?v4) ?v5) f1) (<= (f35 ?v1 ?v4) (f35 ?v1 ?v5)))) (< ?v0 (f35 ?v1 ?v3)))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= (f3 ?v0 ?v1) ?v2) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f3 ?v0 ?v5) (f3 ?v0 ?v4)))) (< (f3 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S18) (?v1 S7) (?v2 Int) (?v3 S7)) (=> (<= (f35 ?v0 ?v1) ?v2) (=> (= (f8 (f9 f10 ?v3) ?v1) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f8 (f9 f10 ?v5) ?v4) f1) (< (f35 ?v0 ?v5) (f35 ?v0 ?v4)))) (< (f35 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S19) (?v1 Int) (?v2 S7) (?v3 Int)) (=> (= (f8 (f9 f22 (f36 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f8 (f9 f10 (f36 ?v0 ?v5)) (f36 ?v0 ?v4)) f1))) (= (f8 (f9 f10 (f36 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< (f3 ?v0 ?v1) ?v2) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f3 ?v0 ?v5) (f3 ?v0 ?v4)))) (< (f3 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S18) (?v1 S7) (?v2 Int) (?v3 S7)) (=> (< (f35 ?v0 ?v1) ?v2) (=> (= (f8 (f9 f22 ?v3) ?v1) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f8 (f9 f22 ?v5) ?v4) f1) (<= (f35 ?v0 ?v5) (f35 ?v0 ?v4)))) (< (f35 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 Int)) (=> (<= ?v0 (f3 ?v1 ?v2)) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (< (f3 ?v1 ?v4) (f3 ?v1 ?v5)))) (< ?v0 (f3 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S18) (?v2 S7) (?v3 S7)) (=> (<= ?v0 (f35 ?v1 ?v2)) (=> (= (f8 (f9 f10 ?v2) ?v3) f1) (=> (forall ((?v4 S7) (?v5 S7)) (=> (= (f8 (f9 f10 ?v4) ?v5) f1) (< (f35 ?v1 ?v4) (f35 ?v1 ?v5)))) (< ?v0 (f35 ?v1 ?v3)))))))
(assert (forall ((?v0 S7) (?v1 S19) (?v2 Int) (?v3 Int)) (=> (= (f8 (f9 f22 ?v0) (f36 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f8 (f9 f10 (f36 ?v1 ?v4)) (f36 ?v1 ?v5)) f1))) (= (f8 (f9 f10 ?v0) (f36 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f8 (f9 f10 ?v0) ?v1) f1) (=> (= (f8 (f9 f10 ?v1) ?v2) f1) (exists ((?v3 S7)) (and (= (f8 (f9 f10 f11) ?v3) f1) (forall ((?v4 S7)) (=> (= (f8 (f9 f10 (f25 f30 (f25 (f27 f28 ?v1) ?v4))) ?v3) f1) (and (= (f8 (f9 f22 ?v0) ?v4) f1) (= (f8 (f9 f22 ?v4) ?v2) f1))))))))))
(assert (forall ((?v0 S10)) (= (f37 f38 (f12 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f13 (f37 f38 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f13 (f37 f38 ?v0)) 0))))
(check-sat)
(exit)
