(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () S1)
(declare-fun f7 (S4) S1)
(declare-fun f8 (S7 S6) S1)
(declare-fun f9 (S6) S7)
(declare-fun f10 () S6)
(declare-fun f11 (S9 S8) Int)
(declare-fun f12 () S9)
(declare-fun f13 (S10 S5) S6)
(declare-fun f14 () S10)
(declare-fun f15 (S11 S5) S5)
(declare-fun f16 (S12 S5) S11)
(declare-fun f17 () S12)
(declare-fun f18 (S13 S8) S5)
(declare-fun f19 () S13)
(declare-fun f20 (S4 S8) S8)
(declare-fun f21 () S5)
(declare-fun f22 (S14 S6) S6)
(declare-fun f23 () S14)
(declare-fun f24 (S15 S6) S14)
(declare-fun f25 () S15)
(declare-fun f26 () S2)
(declare-fun f27 () S14)
(declare-fun f28 () S3)
(declare-fun f29 () S15)
(declare-fun f30 () S3)
(declare-fun f31 () S15)
(declare-fun f32 (S16 Int) S8)
(declare-fun f33 () S16)
(declare-fun f34 (S6) S7)
(declare-fun f35 () S6)
(declare-fun f36 (S18 S17) S11)
(declare-fun f37 () S18)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (= f6 f1)))
(assert (forall ((?v0 S4) (?v1 S5)) (=> (= (f7 ?v0) f1) (=> (forall ((?v2 S6)) (=> (= (f8 (f9 f10) ?v2) f1) (exists ((?v3 S8)) (forall ((?v4 S8)) (=> (<= (f11 f12 ?v3) (f11 f12 ?v4)) (= (f8 (f9 (f13 f14 (f15 (f16 f17 (f18 f19 (f20 ?v0 ?v4))) ?v1))) ?v2) f1)))))) (= f6 f1)))))
(assert (exists ((?v0 S4) (?v1 S5)) (and (= (f7 ?v0) f1) (forall ((?v2 S6)) (=> (= (f8 (f9 f10) ?v2) f1) (exists ((?v3 S8)) (forall ((?v4 S8)) (=> (<= (f11 f12 ?v3) (f11 f12 ?v4)) (= (f8 (f9 (f13 f14 (f15 (f16 f17 (f18 f19 (f20 ?v0 ?v4))) ?v1))) ?v2) f1)))))))))
(assert (exists ((?v0 S4) (?v1 S5)) (and (= (f7 ?v0) f1) (forall ((?v2 S6)) (=> (= (f8 (f9 f10) ?v2) f1) (exists ((?v3 S8)) (forall ((?v4 S8)) (=> (<= (f11 f12 ?v3) (f11 f12 ?v4)) (= (f8 (f9 (f13 f14 (f15 (f16 f17 (f18 f19 (f20 ?v0 ?v4))) ?v1))) ?v2) f1)))))))))
(assert (forall ((?v0 S5)) (= (= (f8 (f9 f10) (f13 f14 ?v0)) f1) (not (= ?v0 f21)))))
(assert (forall ((?v0 S6)) (= (= (f8 (f9 f10) (f22 f23 ?v0)) f1) (not (= ?v0 f10)))))
(assert (forall ((?v0 S6)) (not (= (f8 (f9 (f22 f23 ?v0)) f10) f1))))
(assert (forall ((?v0 S5)) (not (= (f8 (f9 (f13 f14 ?v0)) f10) f1))))
(assert (= (f13 f14 f21) f10))
(assert (= (f22 f23 f10) f10))
(assert (forall ((?v0 S5)) (= (= (f13 f14 ?v0) f10) (= ?v0 f21))))
(assert (forall ((?v0 S6)) (= (= (f22 f23 ?v0) f10) (= ?v0 f10))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f8 (f9 ?v0) ?v1) f1) (= (f8 (f9 (f22 (f24 f25 ?v0) ?v1)) f10) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (< (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f13 f14 (f15 (f16 f17 ?v0) ?v1)) (f13 f14 (f15 (f16 f17 ?v1) ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f22 f23 (f22 (f24 f25 ?v0) ?v1)) (f22 f23 (f22 (f24 f25 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f22 (f24 f25 ?v0) ?v1) (f22 (f24 f25 ?v2) ?v3)) (= (= (f8 (f9 ?v0) ?v1) f1) (= (f8 (f9 ?v2) ?v3) f1)))))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) f21) ?v0)))
(assert (forall ((?v0 S6)) (= (f22 (f24 f25 ?v0) f10) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f15 (f16 f17 ?v0) ?v0) f21)))
(assert (forall ((?v0 S6)) (= (f22 (f24 f25 ?v0) ?v0) f10)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (= (f15 (f16 f17 ?v0) ?v1) f21))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= ?v0 ?v1) (= (f22 (f24 f25 ?v0) ?v1) f10))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f15 (f16 f17 ?v0) ?v1) f21) (= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f22 (f24 f25 ?v0) ?v1) f10) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (not (< (f3 f26 ?v0) 0))))
(assert (forall ((?v0 S6)) (not (= (f8 (f9 (f22 f27 ?v0)) f10) f1))))
(assert (forall ((?v0 Int)) (= (= (f3 f26 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S6)) (= (= (f22 f27 ?v0) f10) (= ?v0 f10))))
(assert (forall ((?v0 S5)) (= (= f21 ?v0) (= ?v0 f21))))
(assert (forall ((?v0 S6)) (= (= f10 ?v0) (= ?v0 f10))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (= (f3 f26 0) 0))
(assert (= (f22 f27 f10) f10))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f15 (f16 f17 ?v0) ?v1) (f15 (f16 f17 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f22 (f24 f25 ?v0) ?v1) (f22 (f24 f25 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f28 ?v0) ?v1) ?v2) (f3 (f4 f28 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f22 (f24 f25 (f22 (f24 f29 ?v0) ?v1)) ?v2) (f22 (f24 f29 (f22 (f24 f25 ?v0) ?v2)) (f22 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f30 ?v0) ?v1) ?v2) (f3 (f4 f30 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (f22 (f24 f25 (f22 (f24 f31 ?v0) ?v1)) ?v2) (f22 (f24 f31 (f22 (f24 f25 ?v0) ?v2)) (f22 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f26 (- ?v0 ?v1)) (f3 f26 (- ?v1 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f22 f27 (f22 (f24 f25 ?v0) ?v1)) (f22 f27 (f22 (f24 f25 ?v1) ?v0)))))
(assert (forall ((?v0 S6)) (let ((?v_0 (f22 f23 ?v0))) (= (f22 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f13 f14 ?v0))) (= (f22 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 f26 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (=> (= (f8 (f9 f10) ?v0) f1) (= (f22 f27 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f3 f26 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S6)) (= (= (f8 (f9 f10) (f22 f27 ?v0)) f1) (not (= ?v0 f10)))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (= (f7 ?v0) f1) (<= (f11 f12 ?v1) (f11 f12 (f20 ?v0 ?v1))))))
(assert (forall ((?v0 S4)) (= (= (f7 ?v0) f1) (forall ((?v1 S8)) (< (f11 f12 (f20 ?v0 ?v1)) (f11 f12 (f20 ?v0 (f32 f33 (+ (f11 f12 ?v1) 1)))))))))
(assert (forall ((?v0 S4)) (= (= (f7 ?v0) f1) (forall ((?v1 S8) (?v2 S8)) (=> (< (f11 f12 ?v1) (f11 f12 ?v2)) (< (f11 f12 (f20 ?v0 ?v1)) (f11 f12 (f20 ?v0 ?v2))))))))
(assert (forall ((?v0 S8)) (= (f8 (f34 (f13 f14 (f18 f19 ?v0))) f35) f1)))
(assert (forall ((?v0 S7)) (=> (exists ((?v1 S6)) (= (f8 ?v0 ?v1) f1)) (=> (exists ((?v1 S6)) (forall ((?v2 S6)) (=> (= (f8 ?v0 ?v2) f1) (= (f8 (f9 ?v2) ?v1) f1)))) (exists ((?v1 S6)) (forall ((?v2 S6)) (= (exists ((?v3 S6)) (and (= (f8 ?v0 ?v3) f1) (= (f8 (f9 ?v2) ?v3) f1))) (= (f8 (f9 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S6) (?v1 S5) (?v2 S17)) (=> (= (f8 (f9 f10) ?v0) f1) (exists ((?v3 S6)) (and (= (f8 (f9 f10) ?v3) f1) (forall ((?v4 S5)) (let ((?v_0 (f13 f14 (f15 (f16 f17 ?v4) ?v1))) (?v_1 (f36 f37 ?v2))) (=> (and (= (f8 (f9 f10) ?v_0) f1) (= (f8 (f9 ?v_0) ?v3) f1)) (= (f8 (f9 (f13 f14 (f15 (f16 f17 (f15 ?v_1 ?v4)) (f15 ?v_1 ?v1)))) ?v0) f1)))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f8 (f9 ?v0) ?v1) f1) (=> (= (f8 (f9 ?v1) ?v2) f1) (exists ((?v3 S6)) (and (= (f8 (f9 f10) ?v3) f1) (forall ((?v4 S6)) (=> (= (f8 (f9 (f22 f27 (f22 (f24 f25 ?v1) ?v4))) ?v3) f1) (and (= (f8 (f9 ?v0) ?v4) f1) (= (f8 (f9 ?v4) ?v2) f1))))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (let ((?v_0 (f9 f10))) (=> (= (f8 ?v_0 ?v0) f1) (=> (= (f8 ?v_0 ?v1) f1) (exists ((?v2 S6)) (let ((?v_1 (f9 ?v2))) (and (= (f8 ?v_0 ?v2) f1) (and (= (f8 ?v_1 ?v0) f1) (= (f8 ?v_1 ?v1) f1))))))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (=> (= (f8 (f9 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f8 (f9 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (= (f8 (f34 f10) f35) f1))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S6)) (= (f8 (f34 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 f26 ?v0))))
(assert (forall ((?v0 S6)) (= (f8 (f34 ?v0) (f22 f27 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f3 f26 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 (f22 f27 ?v0)) ?v1) f1) (= (f8 (f34 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (=> (= (f8 (f34 ?v0) ?v1) f1) false) (=> (=> (= (f8 (f34 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f3 (f4 f30 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f8 (f34 (f22 (f24 f31 ?v0) ?v1)) ?v2) f1) (=> (=> (= (f8 (f34 ?v0) ?v2) f1) (=> (= (f8 (f34 ?v1) ?v2) f1) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f3 (f4 f28 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v0))) (=> (= (f8 ?v_0 (f22 (f24 f29 ?v1) ?v2)) f1) (=> (=> (= (f8 ?v_0 ?v1) f1) (=> (= (f8 ?v_0 ?v2) f1) false)) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f3 (f4 f28 ?v0) ?v2) (f3 (f4 f28 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= (f8 (f34 ?v2) ?v3) f1) (= (f8 (f34 (f22 (f24 f29 ?v0) ?v2)) (f22 (f24 f29 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f3 (f4 f30 ?v0) ?v2) (f3 (f4 f30 ?v1) ?v3))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= (f8 (f34 ?v2) ?v3) f1) (= (f8 (f34 (f22 (f24 f31 ?v0) ?v2)) (f22 (f24 f31 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f3 (f4 f30 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= (f8 (f34 ?v2) ?v1) f1) (= (f8 (f34 (f22 (f24 f31 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f3 (f4 f30 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= (f8 (f34 ?v2) ?v1) f1) (= (f8 (f34 (f22 (f24 f31 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f3 (f4 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= (f8 ?v_0 ?v2) f1) (= (f8 ?v_0 (f22 (f24 f29 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f3 (f4 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= (f8 ?v_0 ?v2) f1) (= (f8 ?v_0 (f22 (f24 f29 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= (f8 (f34 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v2))) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= (f8 ?v_0 ?v0) f1) (= (f8 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= (f8 (f34 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= (f8 (f34 ?v1) ?v2) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= (f8 (f34 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= (f8 (f34 ?v1) ?v2) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f8 (f34 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v2))) (=> (= ?v0 ?v1) (=> (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= ?v0 ?v1) (=> (= (f8 (f34 ?v1) ?v2) f1) (= (f8 (f34 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (= (= (f8 (f34 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f3 (f4 f28 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (= (f22 (f24 f29 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f3 (f4 f30 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (= (f22 (f24 f31 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f3 (f4 f28 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (= (f22 (f24 f29 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f3 (f4 f30 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (= (f22 (f24 f31 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f3 (f4 f28 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (= (f8 (f34 (f22 (f24 f29 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f3 (f4 f28 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (= (f8 (f34 (f22 (f24 f29 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f3 (f4 f30 ?v2) ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 (f22 (f24 f31 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f3 (f4 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 (f22 (f24 f31 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= ?v0 ?v1) (= (f8 (f34 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (<= (f3 (f4 f30 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 (f4 f30 ?v1) ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f29 ?v0))) (= (f8 (f34 (f22 (f24 f31 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))) (f22 ?v_0 (f22 (f24 f31 ?v1) ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f3 (f4 f28 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (= (f8 (f34 (f22 (f24 f29 ?v0) ?v1)) ?v2) f1) (or (= (f8 (f34 ?v0) ?v2) f1) (= (f8 (f34 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f3 (f4 f30 ?v0) ?v1) ?v2) (and (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (= (= (f8 (f34 (f22 (f24 f31 ?v0) ?v1)) ?v2) f1) (and (= (f8 (f34 ?v0) ?v2) f1) (= (f8 (f34 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f30 ?v0))) (<= (f3 ?v_0 (f3 (f4 f28 ?v1) ?v2)) (f3 (f4 f28 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f24 f31 ?v0))) (= (f8 (f34 (f22 ?v_0 (f22 (f24 f29 ?v1) ?v2))) (f22 (f24 f29 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f3 (f4 f30 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v0))) (= (= (f8 ?v_0 (f22 (f24 f31 ?v1) ?v2)) f1) (or (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f3 (f4 f28 ?v1) ?v2)) (and (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f34 ?v0))) (= (= (f8 ?v_0 (f22 (f24 f29 ?v1) ?v2)) f1) (and (= (f8 ?v_0 ?v1) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= ?v0 ?v1) (and (= (f8 (f34 ?v0) ?v1) f1) (= (f8 (f34 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f3 (f4 f28 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f8 (f34 ?v0) ?v1) f1) (= (f22 (f24 f29 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f3 (f4 f30 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f8 (f34 ?v0) ?v1) f1) (= (f22 (f24 f31 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (or (= (f8 (f34 ?v0) ?v1) f1) (= (f8 (f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (or (= (f8 (f34 ?v0) ?v1) f1) (= (f8 (f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 (f4 f28 ?v0) ?v1) ?v1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f8 (f34 (f22 (f24 f29 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 (f4 f28 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f8 (f34 (f22 (f24 f29 ?v0) ?v1)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f3 (f4 f30 ?v1) ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f8 (f34 ?v0) (f22 (f24 f31 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f3 (f4 f30 ?v0) ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f8 (f34 ?v0) (f22 (f24 f31 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S6)) (= (f8 (f34 ?v0) ?v0) f1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (not (= (f8 (f9 ?v0) ?v1) f1)) (= (f8 (f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (not (= (f8 (f34 ?v0) ?v1) f1)) (= (f8 (f9 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (or (= (f8 (f34 ?v0) ?v1) f1) (= (f8 (f9 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f8 (f9 ?v0) ?v1) f1) (and (= (f8 (f34 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f8 (f9 ?v0) ?v1) f1) (and (= (f8 (f34 ?v0) ?v1) f1) (not (= (f8 (f34 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f8 (f34 ?v0) ?v1) f1) (or (= (f8 (f9 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= (f8 (f9 ?v0) ?v1) f1)) (= (f8 (f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= (f8 (f34 ?v0) ?v1) f1)) (= (f8 (f9 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= (f8 (f9 ?v0) ?v1) f1)) (= (= (f8 (f34 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 ?v1)) (=> (= (f8 (f34 ?v0) ?v1) f1) (= (f8 (f9 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (not (= ?v0 ?v1)) (=> (= (f8 (f34 ?v1) ?v0) f1) (= (f8 (f9 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (not (= (f8 (f9 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f9 ?v0) ?v1) f1) (= (f8 (f34 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (= (not (= (f8 (f9 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (or (= (f8 (f9 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f8 (f9 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f8 (f9 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 ?v0))) (=> (= (f8 ?v_0 ?v1) f1) (=> (= (f8 (f34 ?v1) ?v2) f1) (= (f8 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f8 (f9 ?v0) ?v1) f1) (=> (= (f8 (f34 ?v2) ?v0) f1) (= (f8 (f9 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= (f8 (f9 ?v1) ?v2) f1) (= (f8 (f9 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6)) (let ((?v_0 (f9 ?v2))) (=> (= (f8 (f34 ?v0) ?v1) f1) (=> (= (f8 ?v_0 ?v0) f1) (= (f8 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f8 (f9 ?v0) ?v1) f1) (and (= (f8 (f34 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f8 (f34 ?v0) ?v1) f1) (or (= (f8 (f9 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f8 (f34 ?v0) ?v1) f1) (= (f8 (f34 (f22 (f24 f25 ?v0) ?v1)) f10) f1))))
(assert (forall ((?v0 Int)) (<= 0 (f3 f26 ?v0))))
(assert (forall ((?v0 S6)) (= (f8 (f34 f10) (f22 f27 ?v0)) f1)))
(assert (forall ((?v0 Int)) (= (<= (f3 f26 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S6)) (= (= (f8 (f34 (f22 f27 ?v0)) f10) f1) (= ?v0 f10))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f26 ?v0) ?v0))))
(assert (forall ((?v0 S6)) (=> (= (f8 (f34 f10) ?v0) f1) (= (f22 f27 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f26 (- (f3 f26 ?v0) (f3 f26 ?v1))) (f3 f26 (- ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f8 (f34 (f22 f27 (f22 (f24 f25 (f22 f27 ?v0)) (f22 f27 ?v1)))) (f22 f27 (f22 (f24 f25 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f26 ?v0) (f3 f26 ?v1)) (f3 f26 (- ?v0 ?v1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f8 (f34 (f22 (f24 f25 (f22 f27 ?v0)) (f22 f27 ?v1))) (f22 f27 (f22 (f24 f25 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f26 ?v0) (f3 f26 ?v1)) (f3 f26 (- ?v1 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f8 (f34 (f22 (f24 f25 (f22 f27 ?v0)) (f22 f27 ?v1))) (f22 f27 (f22 (f24 f25 ?v1) ?v0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S6) (?v3 S6)) (=> (= (f22 (f24 f25 ?v0) ?v1) (f22 (f24 f25 ?v2) ?v3)) (= (= (f8 (f34 ?v0) ?v1) f1) (= (f8 (f34 ?v2) ?v3) f1)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f8 (f34 ?v0) ?v1) f1) (= (f8 (f34 (f22 (f24 f25 ?v0) ?v1)) f10) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (<= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f34 (f22 f27 (f22 (f24 f25 (f13 f14 ?v0)) (f13 f14 ?v1)))) (f13 f14 (f15 (f16 f17 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f8 (f34 (f22 f27 (f22 (f24 f25 (f22 f23 ?v0)) (f22 f23 ?v1)))) (f22 f23 (f22 (f24 f25 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f34 (f22 (f24 f25 (f13 f14 ?v0)) (f13 f14 ?v1))) (f13 f14 (f15 (f16 f17 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S6) (?v1 S6)) (= (f8 (f34 (f22 (f24 f25 (f22 f23 ?v0)) (f22 f23 ?v1))) (f22 f23 (f22 (f24 f25 ?v0) ?v1))) f1)))
(assert (forall ((?v0 S6)) (= (f8 (f34 f10) (f22 f23 ?v0)) f1)))
(assert (forall ((?v0 S5)) (= (f8 (f34 f10) (f13 f14 ?v0)) f1)))
(assert (forall ((?v0 S5)) (= (= (f8 (f34 (f13 f14 ?v0)) f10) f1) (= ?v0 f21))))
(assert (forall ((?v0 S6)) (= (= (f8 (f34 (f22 f23 ?v0)) f10) f1) (= ?v0 f10))))
(assert (forall ((?v0 S6)) (not (= (f8 (f9 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (not (= ?v0 ?v1)) (or (= (f8 (f9 ?v0) ?v1) f1) (= (f8 (f9 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S8)) (= (f32 f33 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f32 f33 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f32 f33 ?v0)) 0))))
(check-sat)
(exit)
