(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S3)
(declare-fun f7 () S3)
(declare-fun f8 (S5 S3) S3)
(declare-fun f9 () S5)
(declare-fun f10 (S6 S3) S5)
(declare-fun f11 () S6)
(declare-fun f12 () S3)
(declare-fun f13 () S3)
(declare-fun f14 () S4)
(declare-fun f15 () S6)
(declare-fun f16 (S7 Int) S3)
(declare-fun f17 () S7)
(declare-fun f18 (S8 Int) Int)
(declare-fun f19 () S8)
(declare-fun f20 () S8)
(declare-fun f21 () Int)
(declare-fun f22 () S6)
(declare-fun f23 (S10 S9) S9)
(declare-fun f24 (S11 S9) S10)
(declare-fun f25 () S11)
(declare-fun f26 (S12 Int) S9)
(declare-fun f27 () S12)
(declare-fun f28 () S11)
(declare-fun f29 (S13 Int) S8)
(declare-fun f30 () S13)
(declare-fun f31 () S8)
(declare-fun f32 () S8)
(declare-fun f33 () S6)
(declare-fun f34 () S13)
(declare-fun f35 () S11)
(declare-fun f36 (S14 S9) S1)
(declare-fun f37 (S15 S9) S14)
(declare-fun f38 () S15)
(declare-fun f39 () S6)
(declare-fun f40 () S13)
(declare-fun f41 () S11)
(declare-fun f42 () S15)
(declare-fun f43 () S12)
(declare-fun f44 (S16 S9) Int)
(declare-fun f45 () S16)
(assert (not (= f1 f2)))
(assert (not false))
(assert (= (f3 (f4 f5 f6) f7) f1))
(assert (= (f3 (f4 f5 (f8 f9 (f8 (f10 f11 f12) f13))) f7) f1))
(assert (= (f3 (f4 f14 (f8 (f10 f15 (f16 f17 (f18 f19 (f18 f20 f21)))) f7)) (f8 (f10 f22 (f8 f9 (f8 (f10 f11 f12) f13))) f6)) f1))
(assert (forall ((?v0 S3)) (= (f8 (f10 f15 ?v0) (f16 f17 (f18 f19 (f18 f20 f21)))) (f8 (f10 f22 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S9)) (= (f23 (f24 f25 ?v0) (f26 f27 (f18 f19 (f18 f20 f21)))) (f23 (f24 f28 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f8 (f10 f15 ?v0) (f16 f17 (f18 f19 (f18 f20 f21)))) (f8 (f10 f22 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* ?v0 2) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f8 (f10 f15 (f16 f17 (f18 f19 (f18 f20 f21)))) ?v0) (f8 (f10 f22 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S9)) (= (f23 (f24 f25 (f26 f27 (f18 f19 (f18 f20 f21)))) ?v0) (f23 (f24 f28 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f8 (f10 f15 (f16 f17 (f18 f19 (f18 f20 f21)))) ?v0) (f8 (f10 f22 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (* 2 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 S3)) (= (f8 (f10 f15 ?v0) (f16 f17 (f18 f20 f21))) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f8 (f10 f15 (f16 f17 (f18 f20 f21))) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3) (?v4 S3)) (= (= (f3 (f4 f5 (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v1)) ?v2)) (f8 (f10 f22 (f8 (f10 f15 ?v3) ?v1)) ?v4)) f1) (= (f3 (f4 f5 ?v2) (f8 (f10 f22 (f8 (f10 f15 (f8 (f10 f11 ?v3) ?v0)) ?v1)) ?v4)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (< (+ (f18 (f29 f30 ?v0) ?v1) ?v2) (+ (f18 (f29 f30 ?v3) ?v1) ?v4)) (< ?v2 (+ (f18 (f29 f30 (- ?v3 ?v0)) ?v1) ?v4)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3) (?v4 S3)) (= (= (f3 (f4 f5 (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v1)) ?v2)) (f8 (f10 f22 (f8 (f10 f15 ?v3) ?v1)) ?v4)) f1) (= (f3 (f4 f5 (f8 (f10 f22 (f8 (f10 f15 (f8 (f10 f11 ?v0) ?v3)) ?v1)) ?v2)) ?v4) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (< (+ (f18 (f29 f30 ?v0) ?v1) ?v2) (+ (f18 (f29 f30 ?v3) ?v1) ?v4)) (< (+ (f18 (f29 f30 (- ?v0 ?v3)) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3) (?v4 S3)) (= (= (f3 (f4 f14 (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v1)) ?v2)) (f8 (f10 f22 (f8 (f10 f15 ?v3) ?v1)) ?v4)) f1) (= (f3 (f4 f14 ?v2) (f8 (f10 f22 (f8 (f10 f15 (f8 (f10 f11 ?v3) ?v0)) ?v1)) ?v4)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (<= (+ (f18 (f29 f30 ?v0) ?v1) ?v2) (+ (f18 (f29 f30 ?v3) ?v1) ?v4)) (<= ?v2 (+ (f18 (f29 f30 (- ?v3 ?v0)) ?v1) ?v4)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3) (?v4 S3)) (= (= (f3 (f4 f14 (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v1)) ?v2)) (f8 (f10 f22 (f8 (f10 f15 ?v3) ?v1)) ?v4)) f1) (= (f3 (f4 f14 (f8 (f10 f22 (f8 (f10 f15 (f8 (f10 f11 ?v0) ?v3)) ?v1)) ?v2)) ?v4) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (<= (+ (f18 (f29 f30 ?v0) ?v1) ?v2) (+ (f18 (f29 f30 ?v3) ?v1) ?v4)) (<= (+ (f18 (f29 f30 (- ?v0 ?v3)) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S3)) (= (f8 (f10 f22 ?v0) (f16 f17 f21)) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f8 (f10 f22 (f16 f17 f21)) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (f18 (f29 f30 f21) ?v0) f21)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f29 f30 (f18 f19 ?v0)) ?v1) (f18 f19 (f18 (f29 f30 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f29 f30 (f18 f20 ?v0)) ?v1) (+ (f18 f19 (f18 (f29 f30 ?v0) ?v1)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f18 f31 ?v0))) (= (f18 (f29 f30 ?v_0) ?v_0) (f18 (f29 f30 ?v0) ?v0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f8 f9 ?v0))) (= (f8 (f10 f15 ?v_0) ?v_0) (f8 (f10 f15 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 f31 (f18 (f29 f30 ?v0) ?v1)) (f18 (f29 f30 (f18 f31 ?v0)) (f18 f31 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f8 f9 (f8 (f10 f15 ?v0) ?v1)) (f8 (f10 f15 (f8 f9 ?v0)) (f8 f9 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 f17 ?v0) (f16 f17 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 f32 ?v0) (f18 f32 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f16 f17 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f32 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S9)) (let ((?v_0 (f26 f27 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f18 f20 ?v0) (f18 f20 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f18 f20 ?v0) (f18 f20 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f18 f20 ?v0) (f18 f20 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f18 f20 ?v0) (f18 f20 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 f20 ?v0) (f18 f20 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f18 f20 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f18 f20 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0 f21) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f21) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f21 ?v0) ?v0)))
(assert (= (<= f21 f21) true))
(assert (= (< f21 0) false))
(assert (= (< f21 f21) false))
(assert (= (= f21 f21) true))
(assert (= (- f21) f21))
(assert (= f21 0))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f18 f19 ?v0) (f18 f19 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f18 f19 ?v0) (f18 f19 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f18 f19 ?v0) (f18 f19 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f18 f19 ?v0) (f18 f19 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 f19 ?v0) (f18 f19 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f18 f19 ?v0) (f18 f19 ?v1)) (f18 f19 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f18 f19 ?v0) (f18 f19 ?v1)) (f18 f19 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< (f18 f19 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (- (f18 f19 ?v0)) (f18 f19 (- ?v0)))))
(assert (forall ((?v0 Int)) (= (f18 f19 ?v0) (+ ?v0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f18 f31 ?v0)) (?v_1 (f18 f31 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f18 (f29 f30 ?v_0) ?v_1) (f18 (f29 f30 ?v1) ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f8 f9 ?v0)) (?v_1 (f8 f9 ?v2))) (=> (= (f3 (f4 f5 ?v_0) ?v1) f1) (=> (= (f3 (f4 f5 ?v_1) ?v3) f1) (= (f3 (f4 f5 (f8 (f10 f15 ?v_0) ?v_1)) (f8 (f10 f15 ?v1) ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f16 f17 ?v1))) (= (f8 (f10 f33 ?v_0) ?v_1) (ite (= (f3 (f4 f14 ?v_0) ?v_1) f1) ?v_0 ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f32 ?v0)) (?v_1 (f18 f32 ?v1))) (= (f18 (f29 f34 ?v_0) ?v_1) (ite (<= ?v_0 ?v_1) ?v_0 ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f26 f27 ?v1))) (= (f23 (f24 f35 ?v_0) ?v_1) (ite (= (f36 (f37 f38 ?v_0) ?v_1) f1) ?v_0 ?v_1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 ?v0)) (?v_1 (f16 f17 ?v1))) (= (f8 (f10 f39 ?v_0) ?v_1) (ite (= (f3 (f4 f14 ?v_0) ?v_1) f1) ?v_1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f32 ?v0)) (?v_1 (f18 f32 ?v1))) (= (f18 (f29 f40 ?v_0) ?v_1) (ite (<= ?v_0 ?v_1) ?v_1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f26 f27 ?v1))) (= (f23 (f24 f41 ?v_0) ?v_1) (ite (= (f36 (f37 f38 ?v_0) ?v_1) f1) ?v_1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f14 (f16 f17 ?v0)) (f16 f17 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f18 f32 ?v0) (f18 f32 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 (f16 f17 ?v0)) (f16 f17 ?v1)) f1) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f18 f32 ?v0) (f18 f32 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (= (f23 (f24 f28 (f23 (f24 f25 ?v0) ?v1)) (f23 (f24 f28 (f23 (f24 f25 ?v2) ?v1)) ?v3)) (f23 (f24 f28 (f23 (f24 f25 (f23 (f24 f28 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v1)) (f8 (f10 f22 (f8 (f10 f15 ?v2) ?v1)) ?v3)) (f8 (f10 f22 (f8 (f10 f15 (f8 (f10 f22 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (f18 (f29 f30 ?v0) ?v1) (+ (f18 (f29 f30 ?v2) ?v1) ?v3)) (+ (f18 (f29 f30 (+ ?v0 ?v2)) ?v1) ?v3))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (f23 (f24 f25 (f23 (f24 f28 ?v0) ?v1)) ?v2) (f23 (f24 f28 (f23 (f24 f25 ?v0) ?v2)) (f23 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f8 (f10 f15 (f8 (f10 f22 ?v0) ?v1)) ?v2) (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v2)) (f8 (f10 f15 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f18 (f29 f30 (+ ?v0 ?v1)) ?v2) (+ (f18 (f29 f30 ?v0) ?v2) (f18 (f29 f30 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f8 (f10 f15 (f16 f17 ?v0)) (f8 (f10 f15 (f16 f17 ?v1)) ?v2)) (f8 (f10 f15 (f16 f17 (f18 (f29 f30 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f18 (f29 f30 (f18 f32 ?v0)) (f18 (f29 f30 (f18 f32 ?v1)) ?v2)) (f18 (f29 f30 (f18 f32 (f18 (f29 f30 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f10 f15 (f16 f17 ?v0)) (f16 f17 ?v1)) (f16 f17 (f18 (f29 f30 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f29 f30 (f18 f32 ?v0)) (f18 f32 ?v1)) (f18 f32 (f18 (f29 f30 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f17 (f18 (f29 f30 ?v0) ?v1)) (f8 (f10 f15 (f16 f17 ?v0)) (f16 f17 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 f32 (f18 (f29 f30 ?v0) ?v1)) (f18 (f29 f30 (f18 f32 ?v0)) (f18 f32 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f8 (f10 f22 (f16 f17 ?v0)) (f8 (f10 f22 (f16 f17 ?v1)) ?v2)) (f8 (f10 f22 (f16 f17 (+ ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f18 f32 ?v0) (+ (f18 f32 ?v1) ?v2)) (+ (f18 f32 (+ ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f10 f22 (f16 f17 ?v0)) (f16 f17 ?v1)) (f16 f17 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f18 f32 ?v0) (f18 f32 ?v1)) (f18 f32 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f17 (+ ?v0 ?v1)) (f8 (f10 f22 (f16 f17 ?v0)) (f16 f17 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 f32 (+ ?v0 ?v1)) (+ (f18 f32 ?v0) (f18 f32 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f10 f11 (f16 f17 ?v0)) (f16 f17 ?v1)) (f16 f17 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f18 f32 ?v0) (f18 f32 ?v1)) (f18 f32 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 f17 (- ?v0 ?v1)) (f8 (f10 f11 (f16 f17 ?v0)) (f16 f17 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 f32 (- ?v0 ?v1)) (- (f18 f32 ?v0) (f18 f32 ?v1)))))
(assert (forall ((?v0 Int)) (= (<= (f18 f20 ?v0) f21) (< ?v0 f21))))
(assert (forall ((?v0 Int)) (= (< (f18 f20 ?v0) f21) (< ?v0 f21))))
(assert (forall ((?v0 Int)) (= (= (f18 f20 ?v0) f21) false)))
(assert (forall ((?v0 Int)) (= (<= f21 (f18 f20 ?v0)) (<= f21 ?v0))))
(assert (forall ((?v0 Int)) (= (< f21 (f18 f20 ?v0)) (<= f21 ?v0))))
(assert (forall ((?v0 Int)) (= (= f21 (f18 f20 ?v0)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f18 f20 ?v0) (f18 f19 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f18 f20 ?v0) (f18 f19 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f18 f19 ?v0) (f18 f20 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f18 f19 ?v0) (f18 f20 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f18 f20 ?v0) (f18 f19 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f18 f20 ?v0) (f18 f19 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f18 f19 ?v0) (f18 f20 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f18 f19 ?v0) (f18 f20 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f18 f20 ?v0) (f18 f20 ?v1)) (f18 f19 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f18 f20 ?v0) (f18 f19 ?v1)) (f18 f20 (- ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f18 f20 ?v0) (f18 f19 ?v1)) (f18 f20 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f18 f19 ?v0) (f18 f20 ?v1)) (f18 f20 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 f20 ?v0) (f18 f19 ?v1)) false)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 f19 ?v0) (f18 f20 ?v1)) false)))
(assert (forall ((?v0 Int)) (= (<= (f18 f19 ?v0) f21) (<= ?v0 f21))))
(assert (forall ((?v0 Int)) (= (< (f18 f19 ?v0) f21) (< ?v0 f21))))
(assert (forall ((?v0 Int)) (= (= (f18 f19 ?v0) f21) (= ?v0 f21))))
(assert (forall ((?v0 Int)) (= (<= f21 (f18 f19 ?v0)) (<= f21 ?v0))))
(assert (forall ((?v0 Int)) (= (< f21 (f18 f19 ?v0)) (< f21 ?v0))))
(assert (forall ((?v0 Int)) (= (= f21 (f18 f19 ?v0)) (= f21 ?v0))))
(assert (forall ((?v0 Int)) (= (- f21 (f18 f19 ?v0)) (f18 f19 (- f21 ?v0)))))
(assert (= (f18 f19 f21) f21))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_1 (f26 f27 ?v0)) (?v_0 (f26 f27 ?v1))) (= (= (f36 (f37 f38 ?v_1) ?v_0) f1) (not (= (f36 (f37 f42 ?v_0) ?v_1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_1 (f16 f17 ?v0)) (?v_0 (f16 f17 ?v1))) (= (= (f3 (f4 f14 ?v_1) ?v_0) f1) (not (= (f3 (f4 f5 ?v_0) ?v_1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 f32 ?v1)) (?v_1 (f18 f32 ?v0))) (= (<= ?v_1 ?v_0) (not (< ?v_0 ?v_1))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 Int)) (let ((?v_0 (f26 f27 ?v2))) (= (f23 (f24 f25 (f23 (f24 f28 ?v0) ?v1)) ?v_0) (f23 (f24 f28 (f23 (f24 f25 ?v0) ?v_0)) (f23 (f24 f25 ?v1) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (= (f8 (f10 f15 (f8 (f10 f22 ?v0) ?v1)) ?v_0) (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v_0)) (f8 (f10 f15 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f32 ?v2))) (= (f18 (f29 f30 (+ ?v0 ?v1)) ?v_0) (+ (f18 (f29 f30 ?v0) ?v_0) (f18 (f29 f30 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S9)) (let ((?v_0 (f24 f25 (f26 f27 ?v0)))) (= (f23 ?v_0 (f23 (f24 f28 ?v1) ?v2)) (f23 (f24 f28 (f23 ?v_0 ?v1)) (f23 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f15 (f16 f17 ?v0)))) (= (f8 ?v_0 (f8 (f10 f22 ?v1) ?v2)) (f8 (f10 f22 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f30 (f18 f32 ?v0)))) (= (f18 ?v_0 (+ ?v1 ?v2)) (+ (f18 ?v_0 ?v1) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3) (?v4 S3)) (= (= (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v1)) ?v2) (f8 (f10 f22 (f8 (f10 f15 ?v3) ?v1)) ?v4)) (= (f8 (f10 f22 (f8 (f10 f15 (f8 (f10 f11 ?v0) ?v3)) ?v1)) ?v2) ?v4))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (f18 (f29 f30 ?v0) ?v1) ?v2) (+ (f18 (f29 f30 ?v3) ?v1) ?v4)) (= (+ (f18 (f29 f30 (- ?v0 ?v3)) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3) (?v4 S3)) (= (= (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v1)) ?v2) (f8 (f10 f22 (f8 (f10 f15 ?v3) ?v1)) ?v4)) (= ?v2 (f8 (f10 f22 (f8 (f10 f15 (f8 (f10 f11 ?v3) ?v0)) ?v1)) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (f18 (f29 f30 ?v0) ?v1) ?v2) (+ (f18 (f29 f30 ?v3) ?v1) ?v4)) (= ?v2 (+ (f18 (f29 f30 (- ?v3 ?v0)) ?v1) ?v4)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f16 f17 ?v2))) (= (f8 (f10 f15 (f8 (f10 f11 ?v0) ?v1)) ?v_0) (f8 (f10 f11 (f8 (f10 f15 ?v0) ?v_0)) (f8 (f10 f15 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f18 f32 ?v2))) (= (f18 (f29 f30 (- ?v0 ?v1)) ?v_0) (- (f18 (f29 f30 ?v0) ?v_0) (f18 (f29 f30 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f15 (f16 f17 ?v0)))) (= (f8 ?v_0 (f8 (f10 f11 ?v1) ?v2)) (f8 (f10 f11 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f30 (f18 f32 ?v0)))) (= (f18 ?v_0 (- ?v1 ?v2)) (- (f18 ?v_0 ?v1) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f8 (f10 f22 (f16 f17 ?v0)) (f8 (f10 f11 (f16 f17 ?v1)) ?v2)) (f8 (f10 f11 (f16 f17 (+ ?v0 ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f18 f32 ?v0) (- (f18 f32 ?v1) ?v2)) (- (f18 f32 (+ ?v0 ?v1)) ?v2))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (= (f8 (f10 f22 (f16 f17 ?v0)) (f8 (f10 f11 ?v1) (f16 f17 ?v2))) (f8 (f10 f22 (f16 f17 (+ ?v0 (- ?v2)))) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f18 f32 ?v0) (- ?v1 (f18 f32 ?v2))) (+ (f18 f32 (+ ?v0 (- ?v2))) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f21 ?v0) (=> (<= f21 ?v1) (= (f23 (f24 f28 (f26 f27 ?v0)) (f26 f27 ?v1)) (f26 f27 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f21 ?v0) (=> (<= f21 ?v1) (= (f8 (f10 f22 (f16 f17 ?v0)) (f16 f17 ?v1)) (f16 f17 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f21 ?v0) (=> (<= f21 ?v1) (= (+ (f18 f32 ?v0) (f18 f32 ?v1)) (f18 f32 (+ ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f21 ?v0) (=> (<= f21 ?v1) (= (f23 (f24 f25 (f26 f27 ?v0)) (f26 f27 ?v1)) (f26 f27 (f18 (f29 f30 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f21 ?v0) (=> (<= f21 ?v1) (= (f8 (f10 f15 (f16 f17 ?v0)) (f16 f17 ?v1)) (f16 f17 (f18 (f29 f30 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f21 ?v0) (=> (<= f21 ?v1) (= (f18 (f29 f30 (f18 f32 ?v0)) (f18 f32 ?v1)) (f18 f32 (f18 (f29 f30 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f10 f15 ?v2)) (?v_0 (f10 f15 (f8 (f10 f11 ?v0) ?v2))) (?v_2 (f8 (f10 f11 ?v1) ?v3))) (= (f8 (f10 f11 (f8 (f10 f15 ?v0) ?v1)) (f8 ?v_1 ?v3)) (f8 (f10 f22 (f8 (f10 f22 (f8 ?v_0 ?v_2)) (f8 ?v_0 ?v3))) (f8 ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f10 f15 ?v0))) (= (f8 (f10 f11 (f8 ?v_0 ?v1)) (f8 (f10 f15 ?v2) ?v3)) (f8 (f10 f22 (f8 ?v_0 (f8 (f10 f11 ?v1) ?v3))) (f8 (f10 f15 (f8 (f10 f11 ?v0) ?v2)) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f29 f30 ?v0))) (= (- (f18 ?v_0 ?v1) (f18 (f29 f30 ?v2) ?v3)) (+ (f18 ?v_0 (- ?v1 ?v3)) (f18 (f29 f30 (- ?v0 ?v2)) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f18 f31 (- ?v0 ?v1)) ?v2) (and (< (- ?v1 ?v2) ?v0) (< ?v0 (+ ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f8 f9 (f8 (f10 f11 ?v0) ?v1))) ?v2) f1) (and (= (f3 (f4 f5 (f8 (f10 f11 ?v1) ?v2)) ?v0) f1) (= (f3 (f4 f5 ?v0) (f8 (f10 f22 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (<= (f18 f31 (- (+ ?v0 ?v1) (+ ?v2 ?v3))) (+ (f18 f31 (- ?v0 ?v2)) (f18 f31 (- ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f3 (f4 f14 (f8 f9 (f8 (f10 f11 (f8 (f10 f22 ?v0) ?v1)) (f8 (f10 f22 ?v2) ?v3)))) (f8 (f10 f22 (f8 f9 (f8 (f10 f11 ?v0) ?v2))) (f8 f9 (f8 (f10 f11 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f18 f31 (- ?v0 ?v1)) (+ (f18 f31 ?v0) (f18 f31 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f14 (f8 f9 (f8 (f10 f11 ?v0) ?v1))) (f8 (f10 f22 (f8 f9 ?v0)) (f8 f9 ?v1))) f1)))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (= (f36 (f37 f42 ?v2) ?v3) f1) (= (f36 (f37 f42 (f23 (f24 f28 ?v0) ?v2)) (f23 (f24 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f8 (f10 f22 ?v0) ?v2)) (f8 (f10 f22 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (=> (= (f36 (f37 f38 ?v2) ?v3) f1) (= (f36 (f37 f42 (f23 (f24 f28 ?v0) ?v2)) (f23 (f24 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f14 ?v2) ?v3) f1) (= (f3 (f4 f5 (f8 (f10 f22 ?v0) ?v2)) (f8 (f10 f22 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S9)) (= (f36 (f37 f38 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f14 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f8 (f10 f15 (f8 (f10 f22 ?v0) ?v1)) ?v2) (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v2)) (f8 (f10 f15 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 (f29 f30 ?v0) ?v1))) (= (f26 f43 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f26 f43 (f18 (f29 f30 (f44 f45 (f26 f43 (ite (< ?v0 0) (- ?v0) ?v0)))) (f44 f45 (f26 f43 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f18 (f29 f30 (f44 f45 ?v0)) (f44 f45 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f29 f30 ?v0) ?v1) (f18 (f29 f30 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f30 ?v0))) (= (f18 ?v_0 (+ ?v1 ?v2)) (+ (f18 ?v_0 ?v1) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f30 ?v0))) (= (f18 ?v_0 (- ?v1 ?v2)) (- (f18 ?v_0 ?v1) (f18 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f29 f30 (- ?v0)) ?v1) (- (f18 (f29 f30 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f29 f30 (f18 f32 ?v0)) (f18 f32 ?v1)) (f18 f32 (f18 (f29 f30 ?v0) ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (let ((?v_0 (f18 (f29 f30 (f44 f45 ?v0)) (f44 f45 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 (f29 f30 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f30 ?v0))) (= (f18 (f29 f30 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f29 f30 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f18 (f29 f30 (+ ?v0 ?v1)) ?v2) (+ (f18 (f29 f30 ?v0) ?v2) (f18 (f29 f30 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f18 (f29 f30 (- ?v0 ?v1)) ?v2) (- (f18 (f29 f30 ?v0) ?v2) (f18 (f29 f30 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f26 f43 (f18 (f29 f30 ?v0) ?v1)) (f26 f43 (f18 (f29 f30 (f44 f45 (f26 f43 ?v0))) (f44 f45 (f26 f43 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f18 (f29 f30 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f26 f43 (f18 (f29 f30 ?v0) ?v1)) (f26 f43 (f18 (f29 f30 (f44 f45 (f26 f43 (- ?v0)))) (f44 f45 (f26 f43 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f30 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f18 ?v_0 ?v0) (f18 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9)) (let ((?v_0 (f44 f45 ?v2))) (let ((?v_1 (f29 f30 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f18 ?v_1 ?v0) (f18 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f18 (f29 f30 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 (f29 f30 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f18 f31 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f14 ?v0) (f8 f9 ?v0)) f1)))
(assert (forall ((?v0 S9) (?v1 S9)) (or (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f36 (f37 f38 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f14 ?v0) ?v1) f1) (= (f3 (f4 f14 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (= ?v0 ?v1) (and (= (f36 (f37 f38 ?v0) ?v1) f1) (= (f36 (f37 f38 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f3 (f4 f14 ?v0) ?v1) f1) (= (f3 (f4 f14 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f38 ?v0))) (= (= (f36 ?v_0 (f23 (f24 f41 ?v1) ?v2)) f1) (or (= (f36 ?v_0 ?v1) f1) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v0))) (= (= (f3 ?v_0 (f8 (f10 f39 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f18 (f29 f40 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (= (f36 (f37 f38 (f23 (f24 f35 ?v0) ?v1)) ?v2) f1) (or (= (f36 (f37 f38 ?v0) ?v2) f1) (= (f36 (f37 f38 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f14 (f8 (f10 f33 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f14 ?v0) ?v2) f1) (= (f3 (f4 f14 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f18 (f29 f34 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= ?v0 ?v1) (= (f36 (f37 f38 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f3 (f4 f14 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (= (= (f36 (f37 f38 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (= (= (f3 (f4 f14 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (=> (= ?v0 ?v1) (=> (= (f36 (f37 f38 ?v1) ?v2) f1) (= (f36 (f37 f38 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f14 ?v1) ?v2) f1) (= (f3 (f4 f14 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f38 ?v2))) (=> (= ?v0 ?v1) (=> (= (f36 ?v_0 ?v1) f1) (= (f36 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f36 (f37 f38 ?v2) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f14 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (= (f36 (f37 f38 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 (f4 f14 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= (f36 (f37 f38 ?v1) ?v2) f1) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f14 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (= (f36 (f37 f38 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 (f4 f14 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f38 ?v2))) (=> (= (f36 (f37 f38 ?v0) ?v1) f1) (=> (= (f36 ?v_0 ?v0) f1) (= (f36 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v2))) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f18 f31 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 (f8 f9 ?v0)) ?v1) f1) (= (f3 (f4 f14 ?v0) ?v1) f1))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (=> (= (f36 (f37 f38 ?v0) ?v1) f1) false) (=> (=> (= (f36 (f37 f38 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f14 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f14 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S9)) (not (= (f36 (f37 f42 ?v0) ?v0) f1))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f5 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (not (= ?v0 ?v1)) (or (= (f36 (f37 f42 ?v0) ?v1) f1) (= (f36 (f37 f42 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= ?v0 ?v1)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (= (not (= (f36 (f37 f42 ?v0) ?v1) f1)) (or (= (f36 (f37 f42 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (or (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (or (= (f36 (f37 f42 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f36 (f37 f42 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f42 ?v0))) (= (= (f36 ?v_0 (f23 (f24 f41 ?v1) ?v2)) f1) (or (= (f36 ?v_0 ?v1) f1) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f8 (f10 f39 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f18 (f29 f40 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f42 ?v0))) (= (= (f36 ?v_0 (f23 (f24 f35 ?v1) ?v2)) f1) (and (= (f36 ?v_0 ?v1) f1) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f8 (f10 f33 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f18 (f29 f34 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (= (f36 (f37 f42 (f23 (f24 f41 ?v0) ?v1)) ?v2) f1) (and (= (f36 (f37 f42 ?v0) ?v2) f1) (= (f36 (f37 f42 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f8 (f10 f39 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f18 (f29 f40 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (= (= (f36 (f37 f42 (f23 (f24 f35 ?v0) ?v1)) ?v2) f1) (or (= (f36 (f37 f42 ?v0) ?v2) f1) (= (f36 (f37 f42 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f8 (f10 f33 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f18 (f29 f34 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (not (= (f36 (f37 f42 ?v0) ?v1) f1)) (= (not (= (f36 (f37 f42 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (not (= (f3 (f4 f5 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f36 (f37 f42 ?v0) ?v1) f1) false) (=> (=> (= (f36 (f37 f42 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (not (= (f36 (f37 f42 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (= (not (= (f36 (f37 f42 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f3 (f4 f5 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S1)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (= (=> (= (f36 (f37 f42 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (=> (= (f36 (f37 f42 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (=> (= (f36 (f37 f42 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (=> (= ?v0 ?v1) (=> (= (f36 (f37 f42 ?v1) ?v2) f1) (= (f36 (f37 f42 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f42 ?v2))) (=> (= ?v0 ?v1) (=> (= (f36 ?v_0 ?v1) f1) (= (f36 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f42 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f36 (f37 f42 ?v2) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f42 ?v0))) (=> (= (f36 ?v_0 ?v1) f1) (=> (= (f36 (f37 f42 ?v1) ?v2) f1) (= (f36 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9)) (let ((?v_0 (f37 f42 ?v2))) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (=> (= (f36 ?v_0 ?v0) f1) (= (f36 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S9) (?v1 S9)) (=> (= (f36 (f37 f42 ?v0) ?v1) f1) (=> (=> (not false) (= (f36 (f37 f42 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (=> (not false) (= (f3 (f4 f5 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f29 f30 ?v0))) (= (f18 (f29 f30 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f29 f30 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f15 ?v0))) (= (f8 (f10 f15 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f10 f15 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f8 (f10 f22 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= (f8 f9 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f18 f31 ?v0) (f18 f31 ?v1)))) (= (f18 f31 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f22 ?v0))) (= (f8 (f10 f22 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f10 f22 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f18 (f29 f40 ?v0) ?v1) ?v2) (f18 (f29 f40 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f8 (f10 f22 (f8 (f10 f39 ?v0) ?v1)) ?v2) (f8 (f10 f39 (f8 (f10 f22 ?v0) ?v2)) (f8 (f10 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f18 (f29 f34 ?v0) ?v1) ?v2) (f18 (f29 f34 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f8 (f10 f22 (f8 (f10 f33 ?v0) ?v1)) ?v2) (f8 (f10 f33 (f8 (f10 f22 ?v0) ?v2)) (f8 (f10 f22 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f22 ?v0))) (= (= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f8 (f10 f22 ?v0) ?v1) (f8 (f10 f22 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f22 ?v0))) (=> (= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f22 ?v0))) (=> (= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f8 (f10 f22 ?v0) ?v1) (f8 (f10 f22 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f8 f9 (f8 (f10 f11 ?v0) ?v1)) (f8 f9 (f8 (f10 f11 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 f31 (- ?v0 ?v1)) (f18 f31 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f18 (f29 f40 ?v0) ?v1) ?v2) (f18 (f29 f40 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f8 (f10 f11 (f8 (f10 f39 ?v0) ?v1)) ?v2) (f8 (f10 f39 (f8 (f10 f11 ?v0) ?v2)) (f8 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f18 (f29 f34 ?v0) ?v1) ?v2) (f18 (f29 f34 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f8 (f10 f11 (f8 (f10 f33 ?v0) ?v1)) ?v2) (f8 (f10 f33 (f8 (f10 f11 ?v0) ?v2)) (f8 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f8 (f10 f11 ?v0) ?v1) (f8 (f10 f11 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f14 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f14 ?v0) ?v1) f1) (= (f3 (f4 f14 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f14 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 (f4 f14 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f44 f45 (f26 f27 ?v0))) (< f21 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f26 f43 0) (f26 f43 (f18 f32 ?v0))) (<= ?v0 f21))))
(assert (forall ((?v0 Int)) (= (= (f26 f43 (f18 f32 ?v0)) (f26 f43 0)) (<= ?v0 f21))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 f43 (+ (f44 f45 (f26 f27 ?v0)) (f44 f45 (f26 f27 ?v1)))) (ite (< ?v0 f21) (f26 f43 (f18 f32 ?v1)) (ite (< ?v1 f21) (f26 f43 (f18 f32 ?v0)) (f26 f43 (f18 f32 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f44 f45 (f26 f27 ?v0)) (f44 f45 (f26 f27 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f21)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f44 f45 (f26 f27 ?v0)) (f44 f45 (f26 f27 ?v1))) (ite (< ?v0 ?v1) (< f21 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S9)) (let ((?v_0 (f44 f45 ?v2))) (= (f26 f43 (f18 (f29 f30 (f44 f45 (f26 f27 ?v0))) (f18 (f29 f30 (f44 f45 (f26 f27 ?v1))) ?v_0))) (ite (< ?v0 f21) (f26 f43 0) (f26 f43 (f18 (f29 f30 (f44 f45 (f26 f27 (f18 (f29 f30 ?v0) ?v1)))) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 f43 (f18 (f29 f30 (f44 f45 (f26 f27 ?v0))) (f44 f45 (f26 f27 ?v1)))) (ite (< ?v0 f21) (f26 f43 0) (f26 f43 (f18 f32 (f18 (f29 f30 ?v0) ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f8 (f10 f15 ?v0) ?v1) (f8 (f10 f15 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f15 ?v0))) (= (f8 (f10 f15 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f10 f15 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f14 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f14 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f14 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f14 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f14 ?v0) ?v1) f1) (not (= (f3 (f4 f14 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f14 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f14 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f14 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (= (f3 (f4 f14 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f14 ?v1) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f14 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f14 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f14 ?v2) ?v0) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f14 (f8 f9 (f8 (f10 f22 ?v0) ?v1))) (f8 (f10 f22 (f8 f9 ?v0)) (f8 f9 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f18 f31 (+ ?v0 ?v1)) (+ (f18 f31 ?v0) (f18 f31 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f14 (f8 (f10 f22 ?v0) ?v1)) (f8 (f10 f22 ?v2) ?v1)) f1) (= (f3 (f4 f14 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f22 ?v0))) (= (= (f3 (f4 f14 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) f1) (= (f3 (f4 f14 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (= (f3 (f4 f14 (f8 (f10 f22 ?v0) ?v2)) (f8 (f10 f22 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f22 ?v2))) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (= (f3 (f4 f14 (f8 ?v_0 ?v0)) (f8 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f14 ?v0) ?v1) f1) (=> (= (f3 (f4 f14 ?v2) ?v3) f1) (= (f3 (f4 f14 (f8 (f10 f22 ?v0) ?v2)) (f8 (f10 f22 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14 (f8 (f10 f22 ?v0) ?v1)) (f8 (f10 f22 ?v2) ?v1)) f1) (= (f3 (f4 f14 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f22 ?v0))) (=> (= (f3 (f4 f14 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) f1) (= (f3 (f4 f14 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f8 (f10 f22 ?v0) ?v1)) (f8 (f10 f22 ?v2) ?v1)) f1) (= (f3 (f4 f5 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f22 ?v0))) (= (= (f3 (f4 f5 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f8 (f10 f22 ?v0) ?v2)) (f8 (f10 f22 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f22 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f8 ?v_0 ?v0)) (f8 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f8 (f10 f22 ?v0) ?v2)) (f8 (f10 f22 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 (f8 (f10 f22 ?v0) ?v1)) (f8 (f10 f22 ?v2) ?v1)) f1) (= (f3 (f4 f5 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f22 ?v0))) (=> (= (f3 (f4 f5 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f14 (f8 f9 (f8 (f10 f11 (f8 f9 ?v0)) (f8 f9 ?v1)))) (f8 f9 (f8 (f10 f11 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f18 f31 (- (f18 f31 ?v0) (f18 f31 ?v1))) (f18 f31 (- ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f14 (f8 (f10 f11 (f8 f9 ?v0)) (f8 f9 ?v1))) (f8 f9 (f8 (f10 f11 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f18 f31 ?v0) (f18 f31 ?v1)) (f18 f31 (- ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f14 (f8 (f10 f11 (f8 f9 ?v0)) (f8 f9 ?v1))) (f8 f9 (f8 (f10 f11 ?v1) ?v0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f18 f31 ?v0) (f18 f31 ?v1)) (f18 f31 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f8 (f10 f11 ?v0) ?v1) (f8 (f10 f11 ?v2) ?v3)) (= (= (f3 (f4 f14 ?v0) ?v1) f1) (= (f3 (f4 f14 ?v2) ?v3) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f15 ?v0))) (= (f8 ?v_0 (f8 (f10 f22 ?v1) ?v2)) (f8 (f10 f22 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f15 ?v0))) (= (f8 ?v_0 (f8 (f10 f22 ?v1) ?v2)) (f8 (f10 f22 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f8 (f10 f15 (f8 (f10 f22 ?v0) ?v1)) ?v2) (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v2)) (f8 (f10 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f8 (f10 f15 (f8 (f10 f22 ?v0) ?v1)) ?v2) (f8 (f10 f22 (f8 (f10 f15 ?v0) ?v2)) (f8 (f10 f15 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f8 (f10 f11 ?v0) ?v1) (f8 (f10 f11 ?v2) ?v3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v2) ?v3) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f15 ?v0))) (= (f8 ?v_0 (f8 (f10 f11 ?v1) ?v2)) (f8 (f10 f11 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f10 f15 ?v0))) (= (f8 ?v_0 (f8 (f10 f11 ?v1) ?v2)) (f8 (f10 f11 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f8 (f10 f15 (f8 (f10 f11 ?v0) ?v1)) ?v2) (f8 (f10 f11 (f8 (f10 f15 ?v0) ?v2)) (f8 (f10 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S9)) (= (f26 f43 (f44 f45 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f44 f45 (f26 f43 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f44 f45 (f26 f43 ?v0)) 0))))
(check-sat)
(exit)
