(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S3) S3)
(declare-fun f7 (S6 S3) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S5)
(declare-fun f10 () S3)
(declare-fun f11 () S6)
(declare-fun f12 () S3)
(declare-fun f13 (S7 S8) S3)
(declare-fun f14 () S7)
(declare-fun f15 (S9 Int) S8)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S8) Int)
(declare-fun f18 () S10)
(declare-fun f19 (S11 S8) S8)
(declare-fun f20 () S11)
(declare-fun f21 () S8)
(declare-fun f22 () S8)
(declare-fun f23 (S12 S11) S1)
(declare-fun f24 () S12)
(declare-fun f25 () S5)
(declare-fun f26 () S3)
(declare-fun f27 () S3)
(declare-fun f28 () S6)
(declare-fun f29 (S13 Int) Int)
(declare-fun f30 (S14 Int) S13)
(declare-fun f31 () S14)
(declare-fun f32 () S6)
(declare-fun f33 () S14)
(declare-fun f34 () S4)
(declare-fun f35 () S3)
(declare-fun f36 () S13)
(declare-fun f37 (S15 S16) S3)
(declare-fun f38 () S15)
(declare-fun f39 () S16)
(declare-fun f40 (S8) S16)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 (f6 f9 f10))) (?v_1 (f7 f11 f12)) (?v_2 (+ (f17 f18 f21) (f17 f18 f22)))) (not (= (f3 (f4 f5 (f6 ?v_0 (f6 ?v_1 (f13 f14 (f15 f16 (+ (f17 f18 (f19 f20 (f15 f16 ?v_2))) 1)))))) (f6 ?v_0 (f6 ?v_1 (f13 f14 (f15 f16 (+ ?v_2 1)))))) f1))))
(assert (let ((?v_0 (f7 f11 f12)) (?v_1 (+ (f17 f18 f21) (f17 f18 f22)))) (= (f3 (f4 f5 (f6 ?v_0 (f13 f14 (f15 f16 (+ (f17 f18 (f19 f20 (f15 f16 ?v_1))) 1))))) (f6 ?v_0 (f13 f14 (f15 f16 (+ ?v_1 1))))) f1)))
(assert (= (f3 (f4 f5 f12) f12) f1))
(assert (= (f23 f24 f20) f1))
(assert (let ((?v_0 (f7 f11 f12)) (?v_1 (+ (f17 f18 f21) (f17 f18 f22)))) (= (f3 (f4 f5 (f6 ?v_0 (f13 f14 (f15 f16 (+ (f17 f18 (f19 f20 (f15 f16 ?v_1))) 1))))) (f6 ?v_0 (f13 f14 (f15 f16 (+ ?v_1 1))))) f1)))
(assert (let ((?v_0 (+ (f17 f18 f21) (f17 f18 f22)))) (<= ?v_0 (f17 f18 (f19 f20 (f15 f16 ?v_0))))))
(assert (let ((?v_0 (+ (f17 f18 f21) (f17 f18 f22)))) (= (f3 (f4 f5 (f13 f14 (f15 f16 (+ ?v_0 1)))) (f13 f14 (f15 f16 (+ (f17 f18 (f19 f20 (f15 f16 ?v_0))) 1)))) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (< (f17 f18 ?v0) (f17 f18 ?v1)) (= (f3 (f4 f5 (f6 (f7 f8 (f13 f14 ?v0)) f12)) (f13 f14 ?v1)) f1))))
(assert (forall ((?v0 S8)) (= (f13 f14 (f15 f16 (+ (f17 f18 ?v0) 1))) (f6 (f7 f8 (f13 f14 ?v0)) f12))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f6 f9 ?v2)) (?v_2 (f6 f9 ?v3))) (= (f3 (f4 f5 (f6 f25 (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 (f7 f8 ?v_1) ?v_2)))) (f6 (f7 f8 (f6 f25 (f6 ?v_0 ?v_1))) (f6 f25 (f6 (f7 f8 ?v1) ?v_2)))) f1))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f25 (f6 (f7 f8 ?v0) (f6 f9 ?v1))) (f6 f25 (f6 (f7 f8 ?v1) (f6 f9 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f13 f14 (f15 f16 (+ (f17 f18 ?v0) (f17 f18 ?v1)))) (f6 (f7 f8 (f13 f14 ?v0)) (f13 f14 ?v1)))))
(assert (= (f13 f14 (f15 f16 1)) f12))
(assert (= (f13 f14 (f15 f16 (+ 0 1))) f12))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f6 f25 ?v0)) ?v1) f1) (and (= (f3 (f4 f5 (f6 f9 ?v1)) ?v0) f1) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (= (f3 (f4 f5 f26) f12) f1))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f3 (f4 f5 (f13 f14 ?v0)) (f13 f14 ?v1)) f1) (<= (f17 f18 ?v0) (f17 f18 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1)))))
(assert (= (f3 (f4 f5 f26) f27) f1))
(assert (forall ((?v0 S8)) (= (f3 (f4 f5 f26) (f13 f14 ?v0)) f1)))
(assert (not (= f26 f12)))
(assert (forall ((?v0 S8)) (= (= (f13 f14 ?v0) f26) (= ?v0 (f15 f16 0)))))
(assert (= (f13 f14 (f15 f16 0)) f26))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f6 (f7 f8 ?v0) ?v1) f26) (= ?v1 (f6 f9 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ ?v0 ?v1) 0) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f26))) (= (= (f3 ?v_0 (f6 (f7 f11 ?v0) ?v1)) f1) (and (or (= (f3 (f4 f5 ?v0) f26) f1) (= (f3 ?v_0 ?v1) f1)) (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f26) f1)))))))
(assert (forall ((?v0 S8)) (= (= (f3 (f4 f5 (f13 f14 ?v0)) f26) f1) (= ?v0 (f15 f16 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f6 (f7 f8 ?v0) (f6 f9 ?v1)) f26) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f6 (f7 f8 ?v0) ?v1) f26) (= ?v1 (f6 f9 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) f26) f1) (= (f3 (f4 f5 ?v1) (f6 f9 ?v0)) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 f26) (f6 (f7 f8 ?v0) ?v1)) f1) (= (f3 (f4 f5 (f6 f9 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f6 (f7 f28 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f29 (f30 f31 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f32 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f29 (f30 f33 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f13 f14 ?v0) (f13 f14 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f6 f25 ?v_0) ?v_0))))
(assert (= (f3 (f4 f34 f26) (f13 f14 (f15 f16 (+ (+ (f17 f18 f21) (f17 f18 f22)) 1)))) f1))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f26)) (= (f6 (f7 f11 (f6 f9 ?v1)) (f6 f9 ?v0)) (f6 (f7 f11 ?v1) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f11 ?v1))) (=> (not (= ?v0 f26)) (= (f6 f9 (f6 ?v_0 ?v0)) (f6 ?v_0 (f6 f9 ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f26)) (= (= (f6 (f7 f11 ?v1) ?v0) f12) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f26)) (= (f6 (f7 f11 ?v0) ?v0) f12))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f11 ?v0) ?v0) (ite (= ?v0 f26) f26 f12))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f6 (f7 f8 ?v0) ?v1) f26) (= (f6 f9 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (+ ?v0 ?v1) 0) (= (- ?v0) ?v1))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 (f6 f9 ?v0)) ?v0) f26)))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 (f6 f9 ?v0)) ?v0) f26)))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 (f6 f9 ?v1)) (= (f6 (f7 f8 ?v0) ?v1) f26))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= (+ ?v0 ?v1) 0))))
(assert (= (f3 (f4 f34 f26) f35) f1))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f34 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= ?v0 ?v1)) (or (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f34 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f34 ?v0) ?v1) f1)) (or (= (f3 (f4 f34 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f34 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f3 (f4 f34 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f29 (f30 f33 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f32 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f29 (f30 f31 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 ?v0))) (= (= (f3 ?v_0 (f6 (f7 f28 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f29 (f30 f33 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f34 (f6 (f7 f32 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f34 ?v0) ?v2) f1) (= (f3 (f4 f34 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f29 (f30 f31 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f34 (f6 (f7 f28 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f34 ?v0) ?v2) f1) (= (f3 (f4 f34 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f34 ?v0) ?v1) f1)) (= (not (= (f3 (f4 f34 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f34 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f34 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (not (= (f3 (f4 f34 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (not (= (f3 (f4 f34 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (=> (= (f3 (f4 f34 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f34 ?v1) ?v2) f1) (= (f3 (f4 f34 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f34 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f34 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 ?v2))) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (=> (not false) (= (f3 (f4 f34 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f34 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f3 (f4 f34 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f34 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f34 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f29 f36 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f34 f26) ?v0) f1) (= (f6 f25 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f29 f36 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f34 f26) (f6 f25 ?v0)) f1) (not (= ?v0 f26)))))
(assert (forall ((?v0 Int)) (not (< (f29 f36 ?v0) 0))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f34 (f6 f25 ?v0)) f26) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v1)) f1) (= (f3 (f4 f34 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f3 (f4 f34 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f34 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f34 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) ?v3) f1) (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v1)) f1) (= (f3 (f4 f34 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f34 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f34 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 (- ?v1)) (< ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f34 ?v0) (f6 f9 ?v1)) f1) (= (f3 (f4 f34 ?v1) (f6 f9 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) ?v1) (< (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f34 (f6 f9 ?v0)) ?v1) f1) (= (f3 (f4 f34 (f6 f9 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f29 f36 ?v0) ?v1) (and (< ?v0 ?v1) (< (- ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f34 (f6 f25 ?v0)) ?v1) f1) (and (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f34 (f6 f9 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) (- ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f34 (f6 f9 ?v0)) (f6 f9 ?v1)) f1) (= (f3 (f4 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f34 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f34 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f34 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f34 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f34 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f34 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f34 ?v0) ?v1) f1)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f34 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= (f3 (f4 f34 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f34 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f3 (f4 f34 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f34 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f3 (f4 f34 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f3 (f4 f34 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v0) f1) (= (f3 (f4 f34 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v1) ?v2) f1) (= (f3 (f4 f34 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f34 ?v0) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f3 (f4 f34 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f3 (f4 f34 (f13 f14 ?v0)) (f13 f14 ?v1)) f1) (< (f17 f18 ?v0) (f17 f18 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) f26) f1) (=> (= (f3 (f4 f34 ?v1) f26) f1) (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v1)) f26) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 ?v1))) (=> (= (f3 (f4 f34 f26) ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f34 f26))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v0)) f26) f1) (= (f3 (f4 f34 ?v0) f26) f1))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f34 f26))) (= (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v0)) f1) (= (f3 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (+ ?v0 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f34 ?v2) ?v3) f1) (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (= (f3 (f4 f34 f26) f12) f1))
(assert (< 0 1))
(assert (not (= (f3 (f4 f34 f12) f26) f1)))
(assert (not (< 1 0)))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f29 f36 ?v0) (- ?v0)))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f34 ?v0) f26) f1) (= (f6 f25 ?v0) (f6 f9 ?v0)))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) ?v0) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f34 (f6 f9 ?v0)) ?v0) f1) (= (f3 (f4 f34 f26) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) 0) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f34 (f6 f9 ?v0)) f26) f1) (= (f3 (f4 f34 f26) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< ?v0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f34 ?v0))) (= (= (f3 ?v_0 (f6 f9 ?v0)) f1) (= (f3 ?v_0 f26) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f34 f26) (f6 f9 ?v0)) f1) (= (f3 (f4 f34 ?v0) f26) f1))))
(assert (forall ((?v0 Int)) (= (f29 f36 ?v0) (ite (< ?v0 0) (- ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f6 f25 ?v0) (ite (= (f3 (f4 f34 ?v0) f26) f1) (f6 f9 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f34 ?v0) (f6 (f7 f8 ?v0) f12)) f1)))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f34 f26))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f5 f26) ?v1) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f34 f26))) (=> (= (f3 (f4 f5 f26) ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f34 f26) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f34 ?v1) (f6 (f7 f8 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (<= ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f34 ?v1))) (=> (= (f3 (f4 f5 f26) ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) f26) f1) (=> (= (f3 (f4 f5 ?v1) f26) f1) (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v1)) f26) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (<= ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f26) f1) (=> (= (f3 (f4 f34 ?v1) f26) f1) (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v1)) f26) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (= (f3 (f4 f34 f26) (f6 (f7 f8 f12) f12)) f1))
(assert (< 0 (+ 1 1)))
(assert (forall ((?v0 S8)) (= (= (f3 (f4 f34 f26) (f13 f14 ?v0)) f1) (< 0 (f17 f18 ?v0)))))
(assert (forall ((?v0 S8)) (= (f3 (f4 f34 f26) (f13 f14 (f15 f16 (+ (f17 f18 ?v0) 1)))) f1)))
(assert (forall ((?v0 S8)) (not (= (f3 (f4 f34 (f13 f14 ?v0)) f26) f1))))
(assert (forall ((?v0 S3)) (= (f6 f25 ?v0) (ite (= (f3 (f4 f34 ?v0) f26) f1) (f6 f9 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f6 f25 ?v0) (ite (= (f3 (f4 f34 ?v0) f26) f1) (f6 f9 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f34 (f6 (f7 f8 (f6 f25 ?v0)) f12)) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (= (f29 f36 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f6 f25 ?v0) f26) (= ?v0 f26))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= f26 ?v0) (= ?v0 f26))))
(assert (= (f29 f36 0) 0))
(assert (= (f6 f25 f26) f26))
(assert (forall ((?v0 Int)) (<= ?v0 (f29 f36 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) (f6 f25 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f29 f36 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 (f6 f25 ?v0)) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f29 f36 ?v0) (f29 f36 ?v1)))) (= (f29 f36 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 (f7 f8 (f6 f25 ?v0)) (f6 f25 ?v1)))) (= (f6 f25 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f8 (f6 (f7 f32 ?v0) ?v1)) ?v2) (f6 (f7 f32 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f29 (f30 f33 ?v0) ?v1) ?v2) (f29 (f30 f33 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f8 (f6 (f7 f28 ?v0) ?v1)) ?v2) (f6 (f7 f28 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f29 (f30 f31 ?v0) ?v1) ?v2) (f29 (f30 f31 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f34 f26) (f6 (f7 f8 f12) (f6 f25 ?v0))) f1)))
(assert (= (f29 f36 1) 1))
(assert (= (f6 f25 f12) f12))
(assert (forall ((?v0 S3)) (= (= f12 ?v0) (= ?v0 f12))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f34 f26) (f6 (f7 f8 ?v0) ?v1)) f1) (= (f3 (f4 f34 (f6 f9 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f34 (f6 (f7 f8 ?v0) ?v1)) f26) f1) (= (f3 (f4 f34 ?v1) (f6 f9 ?v0)) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (<= (f17 f18 ?v0) (f17 f18 ?v1)) (= (f3 (f4 f34 (f13 f14 ?v0)) (f6 (f7 f8 (f13 f14 ?v1)) f12)) f1))))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 f9 (f6 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (f29 f36 (- ?v0)) (f29 f36 ?v0))))
(assert (forall ((?v0 S3)) (= (f6 f25 (f6 f9 ?v0)) (f6 f25 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f29 (f30 f33 ?v0) ?v1)) (f29 (f30 f31 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f9 (f6 (f7 f32 ?v0) ?v1)) (f6 (f7 f28 (f6 f9 ?v0)) (f6 f9 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f29 (f30 f31 ?v0) ?v1)) (f29 (f30 f33 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f9 (f6 (f7 f28 ?v0) ?v1)) (f6 (f7 f32 (f6 f9 ?v0)) (f6 f9 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 (f6 f9 ?v1)) (= ?v1 (f6 f9 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f6 f9 ?v0) ?v1) (= (f6 f9 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f6 f9 ?v0) (f6 f9 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (<= 0 (f29 f36 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f26) (f6 f25 ?v0)) f1)))
(assert (forall ((?v0 Int)) (= (<= (f29 f36 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f6 f25 ?v0)) f26) f1) (= ?v0 f26))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f29 f36 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 f26) ?v0) f1) (= (f6 f25 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f26) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 f26) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (= f26 (f6 (f7 f8 ?v0) ?v0)) (= ?v0 f26))))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) f26) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) f26) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f29 f36 (+ ?v0 ?v1)) (+ (f29 f36 ?v0) (f29 f36 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f6 f25 (f6 (f7 f8 ?v0) ?v1))) (f6 (f7 f8 (f6 f25 ?v0)) (f6 f25 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v1)) f1) (= (f3 (f4 f5 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (= (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f6 ?v_0 ?v0)) (f6 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v1)) f1) (= (f3 (f4 f5 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (not (= f12 f26)))
(assert (not (= 1 0)))
(assert (not (= f26 f12)))
(assert (not (= 0 1)))
(assert (= 0 0))
(assert (= (f6 f9 f26) f26))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= f26 (f6 f9 ?v0)) (= f26 ?v0))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= ?v0 (f6 f9 ?v0)) (= ?v0 f26))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f6 f9 ?v0) f26) (= ?v0 f26))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) ?v0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f6 f9 ?v0) ?v0) (= ?v0 f26))))
(assert (forall ((?v0 Int)) (<= (- ?v0) (f29 f36 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f6 f9 ?v0)) (f6 f25 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 (- ?v1)) (<= ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) (f6 f9 ?v1)) f1) (= (f3 (f4 f5 ?v1) (f6 f9 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) ?v1) (<= (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f6 f9 ?v0)) ?v1) f1) (= (f3 (f4 f5 (f6 f9 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f29 f36 ?v0) ?v1) (and (<= ?v0 ?v1) (<= (- ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f6 f25 ?v0)) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f6 f9 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) (- ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f6 f9 ?v0)) (f6 f9 ?v1)) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (<= (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f6 f9 ?v1)) (f6 f9 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= (- ?v0) ?v1) (<= (f29 f36 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 (f6 f9 ?v0)) ?v1) f1) (= (f3 (f4 f5 (f6 f25 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f29 f36 ?v0) ?v1) (<= (- ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 (f6 f25 ?v0)) ?v1) f1) (= (f3 (f4 f5 (f6 f9 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f11 f26) ?v0) f26)))
(assert (forall ((?v0 S3)) (= (f6 (f7 f11 ?v0) f26) f26)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f9 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f6 f9 ?v0)) (f6 f9 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v0) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f9 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f6 f9 ?v1)) (f6 f9 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 (f7 f8 ?v0) (f6 (f7 f8 (f6 f9 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (+ (- ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 (f7 f8 (f6 f9 ?v0)) (f6 (f7 f8 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0) (+ ?v0 ?v1)) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f6 (f7 f11 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f11 ?v0) ?v2)) (f6 (f7 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f11 ?v0) f12) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f6 f9 (f6 (f7 f11 ?v0) ?v1)) (f6 (f7 f11 (f6 f9 ?v0)) ?v1))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f5 f26))) (= (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v0)) f1) (= (f3 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (<= 0 (+ ?v0 ?v0)) (<= 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v0)) f26) f1) (= (f3 (f4 f5 ?v0) f26) f1))))
(assert (forall ((?v0 Int)) (= (<= (+ ?v0 ?v0) 0) (<= ?v0 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f26))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f26))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (= (f6 (f7 f8 ?v0) ?v1) f26) (and (= ?v0 f26) (= ?v1 f26))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (+ ?v0 ?v1) 0) (and (= ?v0 0) (= ?v1 0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v1))) (=> (= (f3 (f4 f5 f26) ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v1))) (=> (= (f3 (f4 f5 f26) ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f6 (f7 f8 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f26) f1) (=> (= (f3 (f4 f5 ?v1) f26) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) f26) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= (+ ?v0 ?v1) 0)))))
(assert (not (= (f3 (f4 f5 f12) f26) f1)))
(assert (not (<= 1 0)))
(assert (= (f3 (f4 f5 f26) f12) f1))
(assert (<= 0 1))
(assert (forall ((?v0 Int)) (<= (- (f29 f36 ?v0)) 0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f6 f9 (f6 f25 ?v0))) f26) f1)))
(assert (forall ((?v0 Int)) (= (<= 0 (- ?v0)) (<= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 f26) (f6 f9 ?v0)) f1) (= (f3 (f4 f5 ?v0) f26) f1))))
(assert (forall ((?v0 Int)) (= (<= ?v0 (- ?v0)) (<= ?v0 0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f6 f9 ?v0)) f1) (= (f3 ?v_0 f26) f1)))))
(assert (forall ((?v0 Int)) (= (<= (- ?v0) 0) (<= 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f6 f9 ?v0)) f26) f1) (= (f3 (f4 f5 f26) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (<= (- ?v0) ?v0) (<= 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f6 f9 ?v0)) ?v0) f1) (= (f3 (f4 f5 f26) ?v0) f1))))
(assert (forall ((?v0 Int)) (=> (<= ?v0 0) (= (f29 f36 ?v0) (- ?v0)))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 ?v0) f26) f1) (= (f6 f25 ?v0) (f6 f9 ?v0)))))
(assert (forall ((?v0 S3)) (= (f6 (f7 f8 ?v0) (f6 f9 ?v0)) f26)))
(assert (forall ((?v0 Int)) (= (+ ?v0 (- ?v0)) 0)))
(assert (= (f3 (f4 f5 (f37 f38 f39)) f27) f1))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f34 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f6 (f7 f11 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 f12) f12))) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f34 ?v0) ?v1) f1) (= (f3 (f4 f34 (f6 (f7 f11 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 f12) f12))) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f6 (f7 f11 ?v0) ?v1)) (f6 (f7 f11 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f34 f26) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)) (=> (= (f3 (f4 f34 ?v1) f26) f1) (= (f3 (f4 f5 ?v2) ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f26))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f34 f26) ?v1) f1) (= (f3 ?v_0 (f6 (f7 f11 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f26) ?v0) f1) (=> (= (f3 (f4 f34 ?v1) f26) f1) (= (f3 (f4 f5 (f6 (f7 f11 ?v0) ?v1)) f26) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f34 f26))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 (f4 f34 ?v2) ?v3) f1) (= (f3 (f4 f34 (f6 (f7 f11 ?v0) ?v3)) (f6 (f7 f11 ?v1) ?v2)) f1))))))))
(assert (forall ((?v0 S8)) (= (f3 (f4 f5 (f37 f38 (f40 ?v0))) f27) f1)))
(assert (forall ((?v0 S8)) (= (f15 f16 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
