(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S3 S3) S1)
(declare-fun f5 (S5 S2) S3)
(declare-fun f6 (S4) S5)
(declare-fun f7 (S3) S1)
(declare-fun f8 (S2 S2) S1)
(declare-fun f9 (S7 S3) S2)
(declare-fun f10 (S6) S7)
(declare-fun f11 (S9 S2) S2)
(declare-fun f12 (S8) S9)
(declare-fun f13 (S11 S3) S3)
(declare-fun f14 (S10) S11)
(declare-fun f15 (S12 S3) S1)
(declare-fun f16 (S13 S3) S14)
(declare-fun f17 () S13)
(declare-fun f18 (S12) S11)
(declare-fun f19 (S15 Int) S14)
(declare-fun f20 () S15)
(declare-fun f21 (S16 S14) Int)
(declare-fun f22 () S16)
(declare-fun f23 (S17 S2) S1)
(declare-fun f24 (S18 S2) S14)
(declare-fun f25 () S18)
(declare-fun f26 (S17) S9)
(declare-fun f27 () S2)
(declare-fun f28 () S4)
(declare-fun f29 (S4 S17) S12)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S4)) (=> (= (f3 ?v0) f1) (=> (= (f4 ?v1 (f5 (f6 ?v2) ?v0)) f1) (= (f7 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S6)) (=> (= (f7 ?v0) f1) (=> (= (f8 ?v1 (f9 (f10 ?v2) ?v0)) f1) (= (f3 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S8)) (=> (= (f3 ?v0) f1) (=> (= (f8 ?v1 (f11 (f12 ?v2) ?v0)) f1) (= (f3 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S10)) (=> (= (f7 ?v0) f1) (=> (= (f4 ?v1 (f13 (f14 ?v2) ?v0)) f1) (= (f7 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S12)) (=> (= (f7 ?v0) f1) (=> (not (= (f15 ?v1 ?v0) f1)) (= (f16 f17 (f13 (f18 ?v1) ?v0)) (f19 f20 (+ (f21 f22 (f16 f17 ?v0)) 1)))))))
(assert (forall ((?v0 S2) (?v1 S17)) (=> (= (f3 ?v0) f1) (=> (not (= (f23 ?v1 ?v0) f1)) (= (f24 f25 (f11 (f26 ?v1) ?v0)) (f19 f20 (+ (f21 f22 (f24 f25 ?v0)) 1)))))))
(assert (not (forall ((?v0 S14) (?v1 S3) (?v2 S19) (?v3 S17)) (let ((?v_0 (f5 (f6 f28) f27))) (let ((?v_1 (f21 f22 (f16 f17 ?v_0))) (?v_4 (f21 f22 ?v0))) (let ((?v_2 (+ ?v_4 1)) (?v_3 (f29 f28 ?v3))) (=> (= (f3 f27) f1) (=> (= (f4 ?v1 ?v_0) f1) (=> (<= ?v_2 ?v_1) (=> (= (f16 f17 ?v1) (f19 f20 (- ?v_1 ?v_2))) (=> (= (f23 ?v3 f27) f1) (=> (not (= (f15 ?v_3 ?v1) f1)) (= (f16 f17 (f13 (f18 ?v_3) ?v1)) (f19 f20 (- ?v_1 ?v_4)))))))))))))))
(assert (forall ((?v0 S14)) (= (f19 f20 (f21 f22 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f21 f22 (f19 f20 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f21 f22 (f19 f20 ?v0)) 0))))
(check-sat)
(exit)
