(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 S3) S3)
(declare-fun f5 (S2) S4)
(declare-fun f6 (S2 S3) S1)
(declare-fun f7 (S2) S4)
(declare-fun f8 () S3)
(declare-fun f9 () S3)
(declare-fun f10 (S5) S3)
(declare-fun f11 () S3)
(declare-fun f12 (S3 S3) S1)
(declare-fun f13 () S3)
(declare-fun f14 (S6 Int) S5)
(declare-fun f15 () S6)
(declare-fun f16 (S7 S5) Int)
(declare-fun f17 () S7)
(declare-fun f18 (S3 S3) S1)
(declare-fun f19 () S3)
(declare-fun f20 (S3 S3) S1)
(declare-fun f21 (S10 S8) S2)
(declare-fun f22 (S11 S12) S10)
(declare-fun f23 (S13 S8) S11)
(declare-fun f24 () S13)
(declare-fun f25 (S14 S9) S12)
(declare-fun f26 () S14)
(declare-fun f27 (S17 S16) S1)
(declare-fun f28 (S8 S15) S17)
(declare-fun f29 (S12 S16 S5 S16) S1)
(declare-fun f30 (S2) S4)
(declare-fun f31 () S1)
(declare-fun f32 (S3) S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f6 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f7 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f8 ?v0) f1) false)))
(assert (not (forall ((?v0 S5)) (=> (forall ((?v1 S2)) (=> (= (f6 ?v1 f9) f1) (= (f3 (f10 ?v0) ?v1) f1))) (forall ((?v1 S2)) (=> (= (f6 ?v1 f11) f1) (= (f3 (f10 ?v0) ?v1) f1)))))))
(assert (= (f12 f13 f11) f1))
(assert (forall ((?v0 S5)) (=> (forall ((?v1 S2)) (=> (= (f6 ?v1 f13) f1) (= (f3 (f10 ?v0) ?v1) f1))) (forall ((?v1 S2)) (=> (= (f6 ?v1 f11) f1) (= (f3 (f10 ?v0) ?v1) f1))))))
(assert (= (f12 f9 f13) f1))
(assert (forall ((?v0 S5)) (=> (forall ((?v1 S2)) (=> (= (f6 ?v1 f9) f1) (= (f3 (f10 ?v0) ?v1) f1))) (forall ((?v1 S2)) (=> (= (f6 ?v1 f13) f1) (= (f3 (f10 ?v0) ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f12 ?v0 ?v1) f1) (=> (= (f12 ?v2 ?v0) f1) (= (f12 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S5)) (=> (forall ((?v2 S2)) (=> (= (f6 ?v2 ?v0) f1) (= (f3 (f10 (f14 f15 (+ (f16 f17 ?v1) 1))) ?v2) f1))) (forall ((?v2 S2)) (=> (= (f6 ?v2 ?v0) f1) (= (f3 (f10 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S2)) (=> (= (f3 (f10 (f14 f15 (+ (f16 f17 ?v0) 1))) ?v1) f1) (= (f3 (f10 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f18 ?v0 ?v1) f1) (forall ((?v2 S5)) (=> (forall ((?v3 S2)) (=> (= (f6 ?v3 ?v0) f1) (= (f3 (f10 ?v2) ?v3) f1))) (forall ((?v3 S2)) (=> (= (f6 ?v3 ?v1) f1) (= (f3 (f10 ?v2) ?v3) f1))))))))
(assert (forall ((?v0 S3)) (= (f12 ?v0 f19) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f20 ?v0 ?v1) f1) (= (f12 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f12 ?v0 ?v1) f1) (=> (= (f20 ?v2 ?v1) f1) (= (f12 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f12 ?v0 ?v1) f1) (=> (= (f20 ?v0 ?v2) f1) (= (f12 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S8) (?v1 S9) (?v2 S8)) (= (f3 (f10 (f14 f15 0)) (f21 (f22 (f23 f24 ?v0) (f25 f26 ?v1)) ?v2)) f1)))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S12) (?v3 S8)) (= (= (f3 (f10 ?v0) (f21 (f22 (f23 f24 ?v1) ?v2) ?v3)) f1) (forall ((?v4 S15) (?v5 S16)) (=> (= (f27 (f28 ?v1 ?v4) ?v5) f1) (forall ((?v6 S16)) (=> (= (f29 ?v2 ?v5 ?v0 ?v6) f1) (= (f27 (f28 ?v3 ?v4) ?v6) f1))))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_0 (f30 ?v1))) (=> (= (f12 ?v0 (f4 ?v_0 f19)) f1) (=> (= (f12 ?v0 ?v2) f1) (= (f12 ?v0 (f4 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_0 (f30 ?v1))) (=> (= (f12 ?v0 (f4 ?v_0 ?v2)) f1) (and (= (f12 ?v0 (f4 ?v_0 f19)) f1) (= (f12 ?v0 ?v2) f1))))))
(assert (= (= f31 f1) (exists ((?v0 S16) (?v1 S16)) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S8) (?v1 S12) (?v2 S8) (?v3 S8) (?v4 S12) (?v5 S8)) (= (= (f21 (f22 (f23 f24 ?v0) ?v1) ?v2) (f21 (f22 (f23 f24 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 S3)) (= (f20 f19 ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S12) (?v3 S8) (?v4 S8)) (let ((?v_0 (f22 (f23 f24 ?v1) ?v2))) (=> (= (f12 ?v0 (f4 (f30 (f21 ?v_0 ?v3)) f19)) f1) (=> (forall ((?v5 S15) (?v6 S16)) (=> (= (f27 (f28 ?v3 ?v5) ?v6) f1) (= (f27 (f28 ?v4 ?v5) ?v6) f1))) (= (f12 ?v0 (f4 (f30 (f21 ?v_0 ?v4)) f19)) f1))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S12) (?v3 S8) (?v4 S8)) (=> (= (f12 ?v0 (f4 (f30 (f21 (f22 (f23 f24 ?v1) ?v2) ?v3)) f19)) f1) (=> (forall ((?v5 S15) (?v6 S16)) (=> (= (f27 (f28 ?v4 ?v5) ?v6) f1) (= (f27 (f28 ?v1 ?v5) ?v6) f1))) (= (f12 ?v0 (f4 (f30 (f21 (f22 (f23 f24 ?v4) ?v2) ?v3)) f19)) f1)))))
(assert (forall ((?v0 S3) (?v1 S2)) (let ((?v_0 (f4 (f30 ?v1) f19))) (=> (= (f20 ?v0 ?v_0) f1) (or (= ?v0 f19) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f6 ?v2 ?v0) f1) (= (f6 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f20 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (=> (= f31 f1) (forall ((?v0 S16)) (=> (forall ((?v1 S16)) (= ?v1 ?v0)) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (=> (= (f6 ?v0 (f4 (f30 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (=> (not (= (f6 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f6 ?v0 (f4 (f30 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S12) (?v3 S8) (?v4 S8) (?v5 S8)) (=> (= (f12 ?v0 (f4 (f30 (f21 (f22 (f23 f24 ?v1) ?v2) ?v3)) f19)) f1) (=> (forall ((?v6 S15) (?v7 S16)) (=> (= (f27 (f28 ?v4 ?v6) ?v7) f1) (forall ((?v8 S16)) (=> (forall ((?v9 S15)) (=> (= (f27 (f28 ?v1 ?v9) ?v7) f1) (= (f27 (f28 ?v3 ?v9) ?v8) f1))) (= (f27 (f28 ?v5 ?v6) ?v8) f1))))) (= (f12 ?v0 (f4 (f30 (f21 (f22 (f23 f24 ?v4) ?v2) ?v5)) f19)) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f6 ?v0 f19) f1) false)))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= ?v0 f19) (not (= (f6 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S3)) (= (= (f32 ?v0) f19) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2)) (= (= (f6 ?v0 f19) f1) false)))
(assert (forall ((?v0 S3)) (= (= f19 (f32 ?v0)) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (=> (= (f6 ?v1 f19) f1) (= (f3 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (and (= (f6 ?v1 f19) f1) (= (f3 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (= (f6 ?v1 ?v0) f1)) (not (= ?v0 f19)))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (not (= (f6 ?v1 ?v0) f1))) (= ?v0 f19))))
(assert (= f19 (f32 f8)))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f6 ?v0 ?v1) f1) (= (f4 (f30 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (= (f6 ?v0 ?v1) f1) (= (f6 ?v0 (f4 (f30 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f30 ?v0))) (=> (not (= (f6 ?v0 ?v1) f1)) (=> (not (= (f6 ?v0 ?v2) f1)) (= (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f30 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (= (= (f6 ?v0 (f4 (f30 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f6 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (let ((?v_1 (f30 ?v0)) (?v_0 (f30 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f30 ?v0))) (let ((?v_1 (f4 ?v_0 ?v1))) (= (f4 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f4 (f30 ?v0) (f32 ?v1)) (f32 (f4 (f7 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f4 (f30 ?v0) ?v1) (f32 (f4 (f5 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f6 ?v0 (f4 (f30 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (=> (=> (= (f20 ?v0 ?v1) f1) (=> (= (f20 ?v1 ?v0) f1) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f20 ?v1 ?v2) f1) (= (f20 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f6 ?v2 ?v0) f1) (= (f6 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f20 ?v1 ?v2) f1) (= (f6 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f6 ?v2 ?v0) f1) (= (f6 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f20 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f20 ?v0 ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f20 ?v0 ?v1) f1) (= (f20 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S3)) (= (f20 ?v0 ?v0) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f30 ?v0) f19) (f4 (f30 ?v1) f19)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f6 ?v0 (f4 (f30 ?v1) f19)) f1) (=> (=> (= ?v0 ?v1) false) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f4 (f30 ?v0) (f4 (f30 ?v1) f19)) (f4 (f30 ?v2) (f4 (f30 ?v3) f19))) (or (and (= ?v0 ?v2) (= ?v1 ?v3)) (and (= ?v0 ?v3) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f6 ?v0 (f4 (f30 ?v1) f19)) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= (f4 (f30 ?v0) ?v1) f19))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= f19 (f4 (f30 ?v0) ?v1)))))
(assert (forall ((?v0 S3)) (= (= (f20 ?v0 f19) f1) (= ?v0 f19))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (let ((?v_0 (f30 ?v2))) (=> (= (f20 ?v0 ?v1) f1) (= (f20 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5)) (= (f14 f15 (f16 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f17 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
