(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 S3) S3)
(declare-fun f5 (S2) S4)
(declare-fun f6 (S2 S3) S1)
(declare-fun f7 (S2) S4)
(declare-fun f8 () S3)
(declare-fun f9 (S5) S3)
(declare-fun f10 () S5)
(declare-fun f11 (S6 S7) S2)
(declare-fun f12 (S8 S9) S6)
(declare-fun f13 (S10 S7) S8)
(declare-fun f14 () S10)
(declare-fun f15 () S7)
(declare-fun f16 () S9)
(declare-fun f17 () S7)
(declare-fun f18 (S13 S12) S1)
(declare-fun f19 (S7 S11) S13)
(declare-fun f20 (S3 S3) S1)
(declare-fun f21 () S3)
(declare-fun f22 (S2) S4)
(declare-fun f23 () S3)
(declare-fun f24 (S14 Int) S5)
(declare-fun f25 () S14)
(declare-fun f26 (S15 S5) Int)
(declare-fun f27 () S15)
(declare-fun f28 (S17 S2) S5)
(declare-fun f29 (S18 S16) S17)
(declare-fun f30 () S18)
(declare-fun f31 (S3) S3)
(declare-fun f32 (S19 S3) S2)
(declare-fun f33 () S19)
(declare-fun f34 () S1)
(declare-fun f35 () S9)
(declare-fun f36 (S20 S9) S9)
(declare-fun f37 (S21 S9) S20)
(declare-fun f38 () S21)
(declare-fun f39 () S17)
(declare-fun f40 (S3 S3) S1)
(declare-fun f41 (S22) S4)
(declare-fun f42 (S22 S19) S1)
(declare-fun f43 (S24 S23) S9)
(declare-fun f44 () S24)
(declare-fun f45 (S9 S12 S5 S12) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f6 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f7 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f8 ?v0) f1) false)))
(assert (not (= (f3 (f9 f10) (f11 (f12 (f13 f14 f15) f16) f17)) f1)))
(assert (forall ((?v0 S11) (?v1 S12)) (=> (= (f18 (f19 f15 ?v0) ?v1) f1) (exists ((?v2 S7) (?v3 S7)) (and (and (= (f20 f21 (f4 (f22 (f11 (f12 (f13 f14 ?v2) f16) ?v3)) f23)) f1) (forall ((?v4 S5)) (=> (forall ((?v5 S2)) (=> (= (f6 ?v5 f21) f1) (= (f3 (f9 ?v4) ?v5) f1))) (forall ((?v5 S2)) (=> (= (f6 ?v5 (f4 (f22 (f11 (f12 (f13 f14 ?v2) f16) ?v3)) f23)) f1) (= (f3 (f9 ?v4) ?v5) f1)))))) (forall ((?v4 S12)) (=> (forall ((?v5 S11)) (=> (= (f18 (f19 ?v2 ?v5) ?v1) f1) (= (f18 (f19 ?v3 ?v5) ?v4) f1))) (= (f18 (f19 f17 ?v0) ?v4) f1))))))))
(assert (forall ((?v0 S2)) (=> (= (f6 ?v0 f21) f1) (= (f3 (f9 f10) ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f20 ?v0 f23) f1)))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7) (?v3 S7) (?v4 S9) (?v5 S7)) (= (= (f11 (f12 (f13 f14 ?v0) ?v1) ?v2) (f11 (f12 (f13 f14 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f20 ?v2 ?v0) f1) (= (f20 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S5)) (=> (forall ((?v2 S2)) (=> (= (f6 ?v2 ?v0) f1) (= (f3 (f9 (f24 f25 (+ (f26 f27 ?v1) 1))) ?v2) f1))) (forall ((?v2 S2)) (=> (= (f6 ?v2 ?v0) f1) (= (f3 (f9 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_0 (f22 ?v1))) (=> (= (f20 ?v0 (f4 ?v_0 f23)) f1) (=> (= (f20 ?v0 ?v2) f1) (= (f20 ?v0 (f4 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_0 (f22 ?v1))) (=> (= (f20 ?v0 (f4 ?v_0 ?v2)) f1) (and (= (f20 ?v0 (f4 ?v_0 f23)) f1) (= (f20 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S2)) (=> (= (f3 (f9 (f24 f25 (+ (f26 f27 ?v0) 1))) ?v1) f1) (= (f3 (f9 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S9) (?v3 S7) (?v4 S7)) (let ((?v_0 (f12 (f13 f14 ?v1) ?v2))) (=> (= (f20 ?v0 (f4 (f22 (f11 ?v_0 ?v3)) f23)) f1) (=> (forall ((?v5 S11) (?v6 S12)) (=> (= (f18 (f19 ?v3 ?v5) ?v6) f1) (= (f18 (f19 ?v4 ?v5) ?v6) f1))) (= (f20 ?v0 (f4 (f22 (f11 ?v_0 ?v4)) f23)) f1))))))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S9) (?v3 S7) (?v4 S7)) (=> (= (f20 ?v0 (f4 (f22 (f11 (f12 (f13 f14 ?v1) ?v2) ?v3)) f23)) f1) (=> (forall ((?v5 S11) (?v6 S12)) (=> (= (f18 (f19 ?v4 ?v5) ?v6) f1) (= (f18 (f19 ?v1 ?v5) ?v6) f1))) (= (f20 ?v0 (f4 (f22 (f11 (f12 (f13 f14 ?v4) ?v2) ?v3)) f23)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (=> (= (f6 ?v0 (f4 (f22 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (=> (not (= (f6 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f6 ?v0 (f4 (f22 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S9) (?v3 S7) (?v4 S7) (?v5 S7)) (=> (= (f20 ?v0 (f4 (f22 (f11 (f12 (f13 f14 ?v1) ?v2) ?v3)) f23)) f1) (=> (forall ((?v6 S11) (?v7 S12)) (=> (= (f18 (f19 ?v4 ?v6) ?v7) f1) (forall ((?v8 S12)) (=> (forall ((?v9 S11)) (=> (= (f18 (f19 ?v1 ?v9) ?v7) f1) (= (f18 (f19 ?v3 ?v9) ?v8) f1))) (= (f18 (f19 ?v5 ?v6) ?v8) f1))))) (= (f20 ?v0 (f4 (f22 (f11 (f12 (f13 f14 ?v4) ?v2) ?v5)) f23)) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f6 ?v0 f23) f1) false)))
(assert (forall ((?v0 S16) (?v1 S7) (?v2 S9) (?v3 S7)) (= (f28 (f29 f30 ?v0) (f11 (f12 (f13 f14 ?v1) ?v2) ?v3)) (f24 f25 0))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= f23 (f4 (f22 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= (f4 (f22 ?v0) ?v1) f23))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f6 ?v0 (f4 (f22 ?v1) f23)) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= ?v0 f23) (not (= (f6 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S3)) (= (= (f31 ?v0) f23) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2)) (= (= (f6 ?v0 f23) f1) false)))
(assert (forall ((?v0 S3)) (= (= f23 (f31 ?v0)) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (=> (= (f6 ?v1 f23) f1) (= (f3 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (and (= (f6 ?v1 f23) f1) (= (f3 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (= (f6 ?v1 ?v0) f1)) (not (= ?v0 f23)))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (not (= (f6 ?v1 ?v0) f1))) (= ?v0 f23))))
(assert (= f23 (f31 f8)))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f6 ?v0 ?v1) f1) (= (f4 (f22 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (= (f6 ?v0 ?v1) f1) (= (f6 ?v0 (f4 (f22 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 ?v0))) (=> (not (= (f6 ?v0 ?v1) f1)) (=> (not (= (f6 ?v0 ?v2) f1)) (= (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f22 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (= (= (f6 ?v0 (f4 (f22 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f6 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (let ((?v_1 (f22 ?v0)) (?v_0 (f22 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f22 ?v0))) (let ((?v_1 (f4 ?v_0 ?v1))) (= (f4 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f4 (f22 ?v0) (f31 ?v1)) (f31 (f4 (f7 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f4 (f22 ?v0) ?v1) (f31 (f4 (f5 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f6 ?v0 (f4 (f22 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f22 ?v0) f23) (f4 (f22 ?v1) f23)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f6 ?v0 (f4 (f22 ?v1) f23)) f1) (=> (=> (= ?v0 ?v1) false) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f4 (f22 ?v0) (f4 (f22 ?v1) f23)) (f4 (f22 ?v2) (f4 (f22 ?v3) f23))) (or (and (= ?v0 ?v2) (= ?v1 ?v3)) (and (= ?v0 ?v3) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2)) (= (f32 f33 (f4 (f22 ?v0) f23)) ?v0)))
(assert (forall ((?v0 S2)) (= (= (f3 f23 ?v0) f1) (= f34 f1))))
(assert (forall ((?v0 S2)) (= (= (f3 f23 ?v0) f1) (= f34 f1))))
(assert (forall ((?v0 S3) (?v1 S7)) (= (f20 ?v0 (f4 (f22 (f11 (f12 (f13 f14 ?v1) f35) ?v1)) f23)) f1)))
(assert (forall ((?v0 S3) (?v1 S7) (?v2 S9) (?v3 S7) (?v4 S9) (?v5 S7)) (let ((?v_0 (f13 f14 ?v1))) (=> (= (f20 ?v0 (f4 (f22 (f11 (f12 ?v_0 ?v2) ?v3)) f23)) f1) (=> (= (f20 ?v0 (f4 (f22 (f11 (f12 (f13 f14 ?v3) ?v4) ?v5)) f23)) f1) (= (f20 ?v0 (f4 (f22 (f11 (f12 ?v_0 (f36 (f37 f38 ?v2) ?v4)) ?v5)) f23)) f1))))))
(assert (forall ((?v0 S7) (?v1 S9) (?v2 S7)) (= (f28 f39 (f11 (f12 (f13 f14 ?v0) ?v1) ?v2)) (f24 f25 0))))
(assert (forall ((?v0 S2)) (=> (forall ((?v1 S7) (?v2 S9) (?v3 S7)) (=> (= ?v0 (f11 (f12 (f13 f14 ?v1) ?v2) ?v3)) false)) false)))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f6 ?v0 ?v1) f1) (=> (forall ((?v2 S3)) (=> (= ?v1 (f4 (f22 ?v0) ?v2)) (=> (not (= (f6 ?v0 ?v2) f1)) false))) false))))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f6 ?v0 ?v1) f1) (exists ((?v2 S3)) (and (= ?v1 (f4 (f22 ?v0) ?v2)) (not (= (f6 ?v0 ?v2) f1)))))))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 S2)) (=> (= (f6 ?v1 ?v0) f1) false)) (= ?v0 f23))))
(assert (forall ((?v0 S9) (?v1 S9)) (not (= (f36 (f37 f38 ?v0) ?v1) f35))))
(assert (forall ((?v0 S9) (?v1 S9)) (not (= f35 (f36 (f37 f38 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S9) (?v3 S7)) (=> (forall ((?v4 S11) (?v5 S12)) (=> (= (f18 (f19 ?v0 ?v4) ?v5) f1) (exists ((?v6 S7) (?v7 S7)) (and (= (f20 ?v1 (f4 (f22 (f11 (f12 (f13 f14 ?v6) ?v2) ?v7)) f23)) f1) (forall ((?v8 S12)) (=> (forall ((?v9 S11)) (=> (= (f18 (f19 ?v6 ?v9) ?v5) f1) (= (f18 (f19 ?v7 ?v9) ?v8) f1))) (= (f18 (f19 ?v3 ?v4) ?v8) f1))))))) (= (f20 ?v1 (f4 (f22 (f11 (f12 (f13 f14 ?v0) ?v2) ?v3)) f23)) f1))))
(assert (forall ((?v0 S9) (?v1 S9) (?v2 S9) (?v3 S9)) (= (= (f36 (f37 f38 ?v0) ?v1) (f36 (f37 f38 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f40 ?v0 ?v1) f1) (forall ((?v2 S5)) (=> (forall ((?v3 S2)) (=> (= (f6 ?v3 ?v0) f1) (= (f3 (f9 ?v2) ?v3) f1))) (forall ((?v3 S2)) (=> (= (f6 ?v3 ?v1) f1) (= (f3 (f9 ?v2) ?v3) f1))))))))
(assert (forall ((?v0 S3)) (= (not (= ?v0 f23)) (exists ((?v1 S2) (?v2 S3)) (and (= ?v0 (f4 (f22 ?v1) ?v2)) (not (= (f6 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 S2)) (= (= (f3 f23 ?v0) f1) (= (f6 ?v0 f23) f1))))
(assert (forall ((?v0 S22) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 (f41 ?v0) (f4 (f22 ?v1) f23)) ?v2) f1) (= ?v1 ?v2))))
(assert (forall ((?v0 S22) (?v1 S19) (?v2 S2)) (=> (= (f42 ?v0 ?v1) f1) (= (f32 ?v1 (f4 (f22 ?v2) f23)) ?v2))))
(assert (forall ((?v0 S7) (?v1 S23) (?v2 S7)) (= (f3 (f9 (f24 f25 0)) (f11 (f12 (f13 f14 ?v0) (f43 f44 ?v1)) ?v2)) f1)))
(assert (forall ((?v0 S5) (?v1 S7) (?v2 S9) (?v3 S7)) (= (= (f3 (f9 ?v0) (f11 (f12 (f13 f14 ?v1) ?v2) ?v3)) f1) (forall ((?v4 S11) (?v5 S12)) (=> (= (f18 (f19 ?v1 ?v4) ?v5) f1) (forall ((?v6 S12)) (=> (= (f45 ?v2 ?v5 ?v0 ?v6) f1) (= (f18 (f19 ?v3 ?v4) ?v6) f1))))))))
(assert (forall ((?v0 S5)) (= (f24 f25 (f26 f27 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f26 f27 (f24 f25 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f26 f27 (f24 f25 ?v0)) 0))))
(check-sat)
(exit)
