(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2) Int)
(declare-fun f6 (S4 S5 S6) S1)
(declare-fun f7 () S4)
(declare-fun f8 (S7 S5) S5)
(declare-fun f9 () S7)
(declare-fun f10 () S5)
(declare-fun f11 () S6)
(declare-fun f12 (S3 S5) S1)
(declare-fun f13 (S8 S5) S7)
(declare-fun f14 () S8)
(declare-fun f15 () S8)
(declare-fun f16 () S7)
(declare-fun f17 () S5)
(declare-fun f18 () S5)
(declare-fun f19 () S8)
(declare-fun f20 () S8)
(declare-fun f21 (S9 S2) S5)
(declare-fun f22 () S9)
(declare-fun f23 () S7)
(declare-fun f24 (S10 S2) S2)
(declare-fun f25 (S11 S10) S7)
(declare-fun f26 () S11)
(declare-fun f27 () S9)
(declare-fun f28 (S12 S6) S1)
(declare-fun f29 (S4 S2) S12)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (not (= (f5 ?v0) 0)))))
(assert (not (= (= (f6 f7 (f8 f9 f10) f11) f1) (= (f6 f7 f10 f11) f1))))
(assert (= (f12 f4 f10) f1))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f12 f4 ?v0) f1) (=> (= (f12 f4 ?v1) f1) (= (f12 f4 (f8 (f13 f14 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f12 f4 ?v0) f1) (=> (= (f12 f4 ?v1) f1) (= (f12 f4 (f8 (f13 f15 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5)) (= (= (f12 f4 (f8 f16 ?v0)) f1) (= (f12 f4 ?v0) f1))))
(assert (= (f12 f4 f17) f1))
(assert (= (f12 f4 f18) f1))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f12 f4 (f8 (f13 f19 ?v0) ?v1)) f1) (and (= (f12 f4 ?v0) f1) (= (f12 f4 ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f12 f4 (f8 (f13 f20 ?v0) ?v1)) f1) (and (= (f12 f4 ?v0) f1) (= (f12 f4 ?v1) f1)))))
(assert (forall ((?v0 S2)) (= (= (f12 f4 (f21 f22 ?v0)) f1) (not (= (f5 ?v0) 0)))))
(assert (forall ((?v0 S5)) (= (= (f12 f4 (f8 f23 ?v0)) f1) (= (f12 f4 ?v0) f1))))
(assert (forall ((?v0 S10) (?v1 S5)) (=> (forall ((?v2 S2)) (= (not (= (f5 (f24 ?v0 ?v2)) 0)) (not (= (f5 ?v2) 0)))) (= (= (f12 f4 (f8 (f25 f26 ?v0) ?v1)) f1) (= (f12 f4 ?v1) f1)))))
(assert (forall ((?v0 S2)) (=> (not (= (f5 ?v0) 0)) (= (f12 f4 (f21 f27 ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (= (f6 f7 (f21 f27 ?v0) ?v1) f1) (not (= (f28 (f29 f7 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S6)) (= (= (f6 f7 (f8 (f13 f14 ?v0) ?v1) ?v2) f1) (= (f6 f7 (f8 (f13 f20 ?v0) ?v1) ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S6)) (= (= (f6 f7 (f8 (f13 f15 ?v0) ?v1) ?v2) f1) (= (f6 f7 (f8 (f13 f19 ?v0) ?v1) ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f13 f15 ?v0) ?v1) (ite (= ?v0 f17) ?v1 (ite (= ?v1 f17) ?v0 (ite (or (= ?v0 f18) (= ?v1 f18)) f18 (f8 (f13 f19 ?v0) ?v1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f13 f14 ?v0) ?v1) (ite (= ?v0 f18) ?v1 (ite (= ?v1 f18) ?v0 (ite (or (= ?v0 f17) (= ?v1 f17)) f17 (f8 (f13 f20 ?v0) ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f8 f16 ?v1)) (f8 f16 (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S10) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f8 (f13 f19 ?v1) ?v2)) (f8 (f13 f19 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S5) (?v2 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f8 (f13 f20 ?v1) ?v2)) (f8 (f13 f20 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S2)) (= (f8 (f25 f26 ?v0) (f21 f22 ?v1)) (f21 f22 (f24 ?v0 ?v1)))))
(assert (forall ((?v0 S10)) (= (f8 (f25 f26 ?v0) f17) f17)))
(assert (forall ((?v0 S10)) (= (f8 (f25 f26 ?v0) f18) f18)))
(assert (forall ((?v0 S10) (?v1 S5)) (let ((?v_0 (f25 f26 ?v0))) (= (f8 ?v_0 (f8 f23 ?v1)) (f8 f23 (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (not (= (f8 f16 ?v0) (f8 (f13 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (not (= (f8 (f13 f19 ?v0) ?v1) (f8 f16 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f8 f23 ?v0) (f8 f23 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f21 f22 ?v0) (f21 f22 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (= (f8 (f13 f20 ?v0) ?v1) (f8 (f13 f20 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (= (f8 (f13 f19 ?v0) ?v1) (f8 (f13 f19 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f8 f16 ?v0) (f8 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S5) (?v2 S6)) (= (= (f6 ?v0 (f8 f23 ?v1) ?v2) f1) (not (= (f6 ?v0 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S6)) (= (= (f6 ?v0 f17 ?v1) f1) true)))
(check-sat)
(exit)
