(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-sort S25 0)
(declare-sort S26 0)
(declare-sort S27 0)
(declare-sort S28 0)
(declare-sort S29 0)
(declare-sort S30 0)
(declare-sort S31 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 Int) S3)
(declare-fun f5 (S5 Int) S4)
(declare-fun f6 () S5)
(declare-fun f7 (S6 S2) Int)
(declare-fun f8 (S7 Int) S6)
(declare-fun f9 () S7)
(declare-fun f10 () S4)
(declare-fun f11 (S8 S2) S1)
(declare-fun f12 () S8)
(declare-fun f13 (S9 S2) S2)
(declare-fun f14 (S10 Int) S9)
(declare-fun f15 () S10)
(declare-fun f16 () Int)
(declare-fun f17 () S2)
(declare-fun f18 () Int)
(declare-fun f19 (S11 S8) Int)
(declare-fun f20 () S11)
(declare-fun f21 (S12 Int) Int)
(declare-fun f22 (S13 Int) S12)
(declare-fun f23 () S13)
(declare-fun f24 () S11)
(declare-fun f25 (S16 S14) S14)
(declare-fun f26 (S17 S15) S16)
(declare-fun f27 () S17)
(declare-fun f28 (S19 S15) S15)
(declare-fun f29 (S20 S18) S19)
(declare-fun f30 () S20)
(declare-fun f31 (S4 S5 S5 S8) S1)
(declare-fun f32 (S21 S7) S6)
(declare-fun f33 (S22 Int) S21)
(declare-fun f34 () S22)
(declare-fun f35 (S2) S1)
(declare-fun f36 (S14) S1)
(declare-fun f37 (S15) S1)
(declare-fun f38 (S23 S8) S8)
(declare-fun f39 (S24 S2) S23)
(declare-fun f40 (S25 Int) S24)
(declare-fun f41 () S25)
(declare-fun f42 (S26 S2) S6)
(declare-fun f43 () S26)
(declare-fun f44 (Int S2) S1)
(declare-fun f45 (S15 S14) S1)
(declare-fun f46 (S18 S15) S1)
(declare-fun f47 (S2 Int) S1)
(declare-fun f48 (S14 S15) S1)
(declare-fun f49 (S15 S18) S1)
(declare-fun f50 (S27 S2) S9)
(declare-fun f51 () S27)
(declare-fun f52 (S28 S14) S16)
(declare-fun f53 () S28)
(declare-fun f54 (S29 S15) S19)
(declare-fun f55 () S29)
(declare-fun f56 () S23)
(declare-fun f57 (S30 S2) S8)
(declare-fun f58 (S31 Int) S30)
(declare-fun f59 () S31)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (= (f3 (f4 (f5 f6 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f7 (f8 f9 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f3 (f4 f10 ?v0) ?v1) f1) false)))
(assert (not (= (= (f11 f12 (f13 (f14 f15 f16) f17)) f1) (= (f11 f12 (f13 (f14 f15 f18) f17)) f1))))
(assert (= (f19 f20 f12) 1))
(assert (let ((?v_0 (f19 f24 f12))) (= (f21 (f22 f23 f16) ?v_0) (f21 (f22 f23 f18) ?v_0))))
(assert (forall ((?v0 S2) (?v1 Int)) (not (= ?v0 (f13 (f14 f15 ?v1) ?v0)))))
(assert (forall ((?v0 S14) (?v1 S15)) (not (= ?v0 (f25 (f26 f27 ?v1) ?v0)))))
(assert (forall ((?v0 S15) (?v1 S18)) (not (= ?v0 (f28 (f29 f30 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (not (= (f13 (f14 f15 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S15) (?v1 S14)) (not (= (f25 (f26 f27 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S18) (?v1 S15)) (not (= (f28 (f29 f30 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (= (= (f13 (f14 f15 ?v0) ?v1) (f13 (f14 f15 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S15) (?v1 S14) (?v2 S15) (?v3 S14)) (= (= (f25 (f26 f27 ?v0) ?v1) (f25 (f26 f27 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S18) (?v1 S15) (?v2 S18) (?v3 S15)) (= (= (f28 (f29 f30 ?v0) ?v1) (f28 (f29 f30 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (= (f31 f10 f6 f6 f12) f1))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S2)) (= (f7 (f32 (f33 f34 ?v0) ?v1) (f13 (f14 f15 ?v2) ?v3)) (f7 (f8 ?v1 ?v2) ?v3))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f35 (f13 (f14 f15 ?v0) ?v1)) f1) false)))
(assert (forall ((?v0 S15) (?v1 S14)) (= (= (f36 (f25 (f26 f27 ?v0) ?v1)) f1) false)))
(assert (forall ((?v0 S18) (?v1 S15)) (= (= (f37 (f28 (f29 f30 ?v0) ?v1)) f1) false)))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S8) (?v3 S2)) (= (= (f11 (f38 (f39 (f40 f41 ?v0) ?v1) ?v2) ?v3) f1) (= (f11 ?v2 (f13 (f14 f15 (+ ?v0 (f7 (f42 f43 ?v1) ?v3))) ?v3)) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f44 ?v0 (f13 (f14 f15 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S15) (?v1 S14)) (= (f45 ?v0 (f25 (f26 f27 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S18) (?v1 S15)) (= (f46 ?v0 (f28 (f29 f30 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int)) (= (= (f47 (f13 (f14 f15 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f47 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S15) (?v1 S14) (?v2 S15)) (= (= (f48 (f25 (f26 f27 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f48 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S18) (?v1 S15) (?v2 S18)) (= (= (f49 (f28 (f29 f30 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f49 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f14 f15 ?v0)) (?v_1 (f14 f15 ?v2))) (= (f13 (f50 f51 (f13 ?v_0 ?v1)) (f13 ?v_1 ?v3)) (f13 ?v_0 (f13 ?v_1 (f13 (f50 f51 ?v1) ?v3)))))))
(assert (forall ((?v0 S15) (?v1 S14) (?v2 S15) (?v3 S14)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f26 f27 ?v2))) (= (f25 (f52 f53 (f25 ?v_0 ?v1)) (f25 ?v_1 ?v3)) (f25 ?v_0 (f25 ?v_1 (f25 (f52 f53 ?v1) ?v3)))))))
(assert (forall ((?v0 S18) (?v1 S15) (?v2 S18) (?v3 S15)) (let ((?v_0 (f29 f30 ?v0)) (?v_1 (f29 f30 ?v2))) (= (f28 (f54 f55 (f28 ?v_0 ?v1)) (f28 ?v_1 ?v3)) (f28 ?v_0 (f28 ?v_1 (f28 (f54 f55 ?v1) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S8)) (= (f19 f24 (f38 (f39 (f40 f41 ?v0) ?v1) ?v2)) (f19 f24 ?v2))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int)) (=> (= (f44 ?v0 ?v1) f1) (= (f44 ?v0 (f13 (f14 f15 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S15) (?v1 S14) (?v2 S15)) (=> (= (f45 ?v0 ?v1) f1) (= (f45 ?v0 (f25 (f26 f27 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S18) (?v1 S15) (?v2 S18)) (=> (= (f46 ?v0 ?v1) f1) (= (f46 ?v0 (f28 (f29 f30 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S8) (?v1 Int) (?v2 S2)) (=> (not (not (= (f19 f20 ?v0) 0))) (= (= (f11 ?v0 (f13 (f14 f15 ?v1) ?v2)) f1) (= (f11 (f38 f56 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (= (= (f11 (f57 (f58 f59 ?v0) ?v1) ?v2) f1) (<= ?v0 (f7 (f42 f43 ?v1) ?v2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 (f22 f23 ?v0) 2))) (= (not (= ?v_0 0)) (= ?v_0 1)))))
(assert (forall ((?v0 Int)) (= (f21 (f22 f23 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f21 (f22 f23 ?v0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f21 (f22 f23 ?v0) (- 1)) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 (f22 f23 ?v0) (- ?v1)) (- (f21 (f22 f23 (- ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f22 f23 ?v0))) (let ((?v_1 (f21 ?v_0 ?v1))) (= (f21 ?v_0 (- ?v1)) (ite (= ?v_1 0) 0 (- ?v_1 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 (f22 f23 ?v0) ?v1))) (= (f21 (f22 f23 (- ?v0)) ?v1) (ite (= ?v_0 0) 0 (- ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 (f22 f23 (- ?v0)) (- ?v1)) (- (f21 (f22 f23 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 (f22 f23 (- (f21 (f22 f23 ?v0) ?v1))) ?v1) (f21 (f22 f23 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (= (= (f57 (f58 f59 ?v0) ?v1) (f57 (f58 f59 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f19 f24 (f57 (f58 f59 ?v0) ?v1)) 1)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f19 f20 (f57 (f58 f59 ?v0) ?v1)) (f7 (f32 (f33 f34 0) f9) ?v1))))
(assert (forall ((?v0 S4) (?v1 S5) (?v2 S5) (?v3 Int) (?v4 S2)) (= (= (f31 ?v0 ?v1 ?v2 (f57 (f58 f59 ?v3) ?v4)) f1) (= (f3 (f4 ?v0 ?v3) ?v4) f1))))
(assert (forall ((?v0 S8)) (=> (not (not (= (f19 f20 ?v0) 0))) (=> (not (= (f19 f24 ?v0) 0)) (not (= (f19 f24 (f38 f56 ?v0)) 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 (f22 f23 ?v0) ?v1))) (= (f21 (f22 f23 ?v_0) ?v1) ?v_0))))
(check-sat)
(exit)
