(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S4 S3) Int)
(declare-fun f6 (S5 S3) S4)
(declare-fun f7 () S5)
(declare-fun f8 () S3)
(declare-fun f9 (S6 S7) S1)
(declare-fun f10 (Int S3) S6)
(declare-fun f11 (S8) S7)
(declare-fun f12 (S9) S8)
(declare-fun f13 () S9)
(declare-fun f14 (S10 Int) Int)
(declare-fun f15 (S11 Int) S10)
(declare-fun f16 () S11)
(declare-fun f17 (S12 S2) Int)
(declare-fun f18 () S12)
(declare-fun f19 (S2) S2)
(declare-fun f20 () Int)
(declare-fun f21 (S13 S14) Int)
(declare-fun f22 () S13)
(declare-fun f23 () S14)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int)) (= (= (f3 f4 ?v0) f1) (exists ((?v1 S3) (?v2 Int)) (and (= ?v0 (- ?v2 (f5 (f6 f7 ?v1) f8))) (= (f9 (f10 ?v2 ?v1) (f11 (f12 f13))) f1))))))
(assert (let ((?v_0 (f17 f18 (f19 f4))) (?v_1 (f21 f22 f23))) (not (= (f14 (f15 f16 (+ ?v_0 (- f20 ?v_0))) ?v_1) (f14 (f15 f16 f20) ?v_1)))))
(check-sat)
(exit)
