(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2) Int)
(declare-fun f6 (S6 S5) S4)
(declare-fun f7 (S7 S4) S6)
(declare-fun f8 () S7)
(declare-fun f9 (S3 S4) S1)
(declare-fun f10 (S8 S9) S6)
(declare-fun f11 (S10 S6) S8)
(declare-fun f12 () S10)
(declare-fun f13 () S6)
(declare-fun f14 () S9)
(declare-fun f15 () S5)
(declare-fun f16 (S2 S3) S1)
(declare-fun f17 (S5) S3)
(declare-fun f18 (S2) Int)
(declare-fun f19 (S9 S5) S5)
(declare-fun f20 (S4) S1)
(declare-fun f21 (S11 S4) S4)
(declare-fun f22 (S12 S4) S11)
(declare-fun f23 () S12)
(declare-fun f24 () S12)
(declare-fun f25 () S11)
(declare-fun f26 () S4)
(declare-fun f27 () S4)
(declare-fun f28 () S12)
(declare-fun f29 () S12)
(declare-fun f30 (S13 S2) S2)
(declare-fun f31 () S13)
(declare-fun f32 (S14 S2) S4)
(declare-fun f33 () S14)
(declare-fun f34 () S11)
(declare-fun f35 (S15 S13) S11)
(declare-fun f36 () S15)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (not (= (f5 ?v0) 0)))))
(assert (forall ((?v0 S4) (?v1 S5)) (= (f6 (f7 f8 ?v0) ?v1) ?v0)))
(assert (not (= (f9 f4 (f6 (f10 (f11 f12 f13) f14) f15)) f1)))
(assert (forall ((?v0 S2)) (=> (= (f16 ?v0 (f17 f15)) f1) (and (not (= (f18 ?v0) 0)) (not (= (f5 ?v0) 0))))))
(assert (forall ((?v0 S5) (?v1 S2)) (=> (forall ((?v2 S2)) (=> (= (f16 ?v2 (f17 ?v0)) f1) (not (= (f5 ?v2) 0)))) (=> (forall ((?v2 S2)) (=> (= (f16 ?v2 (f17 ?v0)) f1) (not (= (f18 ?v2) 0)))) (=> (= (f16 ?v1 (f17 (f19 f14 ?v0))) f1) (not (= (f5 ?v1) 0)))))))
(assert (forall ((?v0 S5)) (= (f20 (f6 (f10 (f11 f12 f13) f14) ?v0)) f1)))
(assert (forall ((?v0 S4) (?v1 S9) (?v2 S5)) (= (f6 (f10 (f11 f12 (f7 f8 ?v0)) ?v1) ?v2) ?v0)))
(assert (forall ((?v0 S6) (?v1 S9) (?v2 S5)) (= (f6 (f10 (f11 f12 ?v0) ?v1) ?v2) (f6 ?v0 (f19 ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S9) (?v2 S5)) (= (f6 (f10 (f11 f12 ?v0) ?v1) ?v2) (f6 ?v0 (f19 ?v1 ?v2)))))
(assert (forall ((?v0 S6) (?v1 S9) (?v2 S6) (?v3 S5)) (=> (= (f10 (f11 f12 ?v0) ?v1) ?v2) (= (f6 ?v0 (f19 ?v1 ?v3)) (f6 ?v2 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f9 f4 ?v0) f1) (=> (= (f9 f4 ?v1) f1) (= (f9 f4 (f21 (f22 f23 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f9 f4 ?v0) f1) (=> (= (f9 f4 ?v1) f1) (= (f9 f4 (f21 (f22 f24 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f20 ?v0) f1) (=> (= (f20 ?v1) f1) (= (f20 (f21 (f22 f23 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f20 ?v0) f1) (=> (= (f20 ?v1) f1) (= (f20 (f21 (f22 f24 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S4)) (= (= (f9 f4 (f21 f25 ?v0)) f1) (= (f9 f4 ?v0) f1))))
(assert (= (f9 f4 f26) f1))
(assert (= (f9 f4 f27) f1))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f9 f4 (f21 (f22 f28 ?v0) ?v1)) f1) (and (= (f9 f4 ?v0) f1) (= (f9 f4 ?v1) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f9 f4 (f21 (f22 f29 ?v0) ?v1)) f1) (and (= (f9 f4 ?v0) f1) (= (f9 f4 ?v1) f1)))))
(assert (forall ((?v0 S2)) (=> (not (not (= (f18 ?v0) 0))) (=> (not (= (f5 ?v0) 0)) (not (= (f5 (f30 f31 ?v0)) 0))))))
(assert (forall ((?v0 S2)) (= (= (f9 f4 (f32 f33 ?v0)) f1) (not (= (f5 ?v0) 0)))))
(assert (forall ((?v0 S4)) (= (= (f9 f4 (f21 f34 ?v0)) f1) (= (f9 f4 ?v0) f1))))
(assert (forall ((?v0 S13) (?v1 S4)) (=> (forall ((?v2 S2)) (= (not (= (f5 (f30 ?v0 ?v2)) 0)) (not (= (f5 ?v2) 0)))) (= (= (f9 f4 (f21 (f35 f36 ?v0) ?v1)) f1) (= (f9 f4 ?v1) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f21 (f22 f23 ?v0) ?v1) (ite (= ?v0 f26) ?v1 (ite (= ?v1 f26) ?v0 (ite (or (= ?v0 f27) (= ?v1 f27)) f27 (f21 (f22 f29 ?v0) ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f21 (f22 f24 ?v0) ?v1) (ite (= ?v0 f27) ?v1 (ite (= ?v1 f27) ?v0 (ite (or (= ?v0 f26) (= ?v1 f26)) f26 (f21 (f22 f28 ?v0) ?v1)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (= (f21 (f22 f28 ?v0) ?v1) (f21 (f22 f28 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (= (f21 (f22 f29 ?v0) ?v1) (f21 (f22 f29 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f32 f33 ?v0) (f32 f33 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f21 f34 ?v0) (f21 f34 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f21 f25 ?v0) (f21 f25 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S13) (?v1 S4) (?v2 S4)) (let ((?v_0 (f35 f36 ?v0))) (= (f21 ?v_0 (f21 (f22 f28 ?v1) ?v2)) (f21 (f22 f28 (f21 ?v_0 ?v1)) (f21 ?v_0 ?v2))))))
(assert (forall ((?v0 S13) (?v1 S4) (?v2 S4)) (let ((?v_0 (f35 f36 ?v0))) (= (f21 ?v_0 (f21 (f22 f29 ?v1) ?v2)) (f21 (f22 f29 (f21 ?v_0 ?v1)) (f21 ?v_0 ?v2))))))
(assert (forall ((?v0 S13) (?v1 S4)) (let ((?v_0 (f35 f36 ?v0))) (= (f21 ?v_0 (f21 f34 ?v1)) (f21 f34 (f21 ?v_0 ?v1))))))
(assert (forall ((?v0 S13) (?v1 S4)) (let ((?v_0 (f35 f36 ?v0))) (= (f21 ?v_0 (f21 f25 ?v1)) (f21 f25 (f21 ?v_0 ?v1))))))
(assert (forall ((?v0 S13) (?v1 S2)) (= (f21 (f35 f36 ?v0) (f32 f33 ?v1)) (f32 f33 (f30 ?v0 ?v1)))))
(assert (forall ((?v0 S13)) (= (f21 (f35 f36 ?v0) f26) f26)))
(assert (forall ((?v0 S13)) (= (f21 (f35 f36 ?v0) f27) f27)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (not (= (f21 (f22 f28 ?v0) ?v1) (f21 (f22 f29 ?v2) ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (not (= (f21 (f22 f29 ?v0) ?v1) (f21 (f22 f28 ?v2) ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (not (= (f21 (f22 f28 ?v0) ?v1) (f32 f33 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f21 (f22 f28 ?v0) ?v1) (f21 f34 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f21 (f22 f28 ?v0) ?v1) (f21 f25 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (not (= (f21 (f22 f29 ?v0) ?v1) (f32 f33 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f21 (f22 f29 ?v0) ?v1) (f21 f34 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f21 (f22 f29 ?v0) ?v1) (f21 f25 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f21 (f22 f28 ?v0) ?v1) f26))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f21 (f22 f28 ?v0) ?v1) f27))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f21 (f22 f29 ?v0) ?v1) f26))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f21 (f22 f29 ?v0) ?v1) f27))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S4)) (not (= (f32 f33 ?v0) (f21 (f22 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S4)) (not (= (f32 f33 ?v0) (f21 (f22 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f21 f34 ?v0) (f21 (f22 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f21 f34 ?v0) (f21 (f22 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f21 f25 ?v0) (f21 (f22 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (not (= (f21 f25 ?v0) (f21 (f22 f29 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S4)) (not (= (f32 f33 ?v0) (f21 f34 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S4)) (not (= (f32 f33 ?v0) (f21 f25 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S2)) (not (= (f21 f34 ?v0) (f32 f33 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f21 f34 ?v0) (f21 f25 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S2)) (not (= (f21 f25 ?v0) (f32 f33 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (not (= (f21 f25 ?v0) (f21 f34 ?v1)))))
(assert (forall ((?v0 S2)) (not (= (f32 f33 ?v0) f26))))
(assert (forall ((?v0 S2)) (not (= (f32 f33 ?v0) f27))))
(check-sat)
(exit)
