(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S2) S2)
(declare-fun f5 (S2) S4)
(declare-fun f6 () S2)
(declare-fun f7 (S5 S6) S3)
(declare-fun f8 (S7 S3) S5)
(declare-fun f9 (S8 S3) S7)
(declare-fun f10 () S8)
(declare-fun f11 (S9 S10) S3)
(declare-fun f12 (S11 S3) S9)
(declare-fun f13 (S12 S13) S11)
(declare-fun f14 () S12)
(declare-fun f15 () S13)
(declare-fun f16 () S5)
(declare-fun f17 () S6)
(declare-fun f18 () S10)
(declare-fun f19 () S3)
(declare-fun f20 () S6)
(declare-fun f21 () S3)
(declare-fun f22 () S3)
(declare-fun f23 (S14 S3) S3)
(declare-fun f24 (S13 S3) S14)
(declare-fun f25 (S15 S6) Int)
(declare-fun f26 () S15)
(declare-fun f27 (S16 Int) S6)
(declare-fun f28 () S16)
(declare-fun f29 (S17 S3 S18) S1)
(declare-fun f30 (S19 S18) S17)
(declare-fun f31 (S20 S6) S19)
(declare-fun f32 (S21 S17) S20)
(declare-fun f33 () S21)
(declare-fun f34 () S17)
(declare-fun f35 () S18)
(declare-fun f36 () S18)
(declare-fun f37 (S2 S10) S1)
(declare-fun f38 () S14)
(declare-fun f39 (S22 S18) S18)
(declare-fun f40 (S23 S18) S22)
(declare-fun f41 () S23)
(declare-fun f42 (S17 S6) S18)
(declare-fun f43 () S17)
(declare-fun f44 () S6)
(declare-fun f45 () S18)
(declare-fun f46 (S3) S2)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (= (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (and (= (f3 ?v0 ?v2) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (not (= (f3 f6 (f7 (f8 (f9 f10 (f11 (f12 (f13 f14 f15) (f7 f16 f17)) f18)) f19) f20)) f1)))
(assert (= (f3 f6 f21) f1))
(assert (= (f3 f6 f22) f1))
(assert (= (f3 f6 f19) f1))
(assert (= f17 f20))
(assert (forall ((?v0 S6)) (= (f3 f6 (f7 f16 ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S6)) (=> (= (f3 f6 ?v0) f1) (= (f3 f6 (f23 (f24 f15 ?v0) (f7 f16 ?v1))) f1))))
(assert (forall ((?v0 S3) (?v1 S6) (?v2 S6)) (=> (= (f3 f6 ?v0) f1) (= (f3 f6 (f7 (f8 (f9 f10 ?v0) (f7 f16 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S6) (?v1 S10) (?v2 S6) (?v3 S10)) (let ((?v_0 (f13 f14 f15))) (= (= (f11 (f12 ?v_0 (f7 f16 ?v0)) ?v1) (f11 (f12 ?v_0 (f7 f16 ?v2)) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S3)) (= (f7 (f8 (f9 f10 (f7 f16 ?v0)) ?v1) ?v0) ?v1)))
(assert (forall ((?v0 S6) (?v1 S3) (?v2 S6)) (let ((?v_1 (f7 f16 ?v0)) (?v_0 (f25 f26 ?v0))) (= (f7 (f8 (f9 f10 ?v_1) ?v1) ?v2) (ite (< (f25 f26 ?v2) ?v_0) (f7 f16 (f27 f28 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S3)) (let ((?v_0 (f7 f16 ?v0))) (=> (< (f25 f26 ?v0) (f25 f26 ?v1)) (= (f7 (f8 (f9 f10 ?v_0) ?v2) ?v1) ?v_0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S3)) (let ((?v_0 (f25 f26 ?v1))) (=> (< (f25 f26 ?v0) ?v_0) (= (f7 (f8 (f9 f10 (f7 f16 ?v1)) ?v2) ?v0) (f7 f16 (f27 f28 (- ?v_0 1))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S6)) (= (f7 (f8 (f9 f10 (f23 (f24 f15 ?v0) ?v1)) ?v2) ?v3) (f23 (f24 f15 (f7 (f8 (f9 f10 ?v0) ?v2) ?v3)) (f7 (f8 (f9 f10 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S6) (?v1 S3) (?v2 S3)) (not (= (f7 f16 ?v0) (f23 (f24 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S6)) (not (= (f23 (f24 f15 ?v0) ?v1) (f7 f16 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S10) (?v2 S3)) (let ((?v_0 (f13 f14 f15))) (= (= (f11 (f12 ?v_0 ?v0) ?v1) (f11 (f12 ?v_0 ?v2) ?v1)) (= ?v0 ?v2)))))
(assert (= (f29 (f30 (f31 (f32 f33 f34) f20) f35) (f11 (f12 (f13 f14 f15) (f7 f16 f17)) f18) f36) f1))
(assert (forall ((?v0 S10) (?v1 S6)) (=> (= (f37 f6 ?v0) f1) (= (f3 f6 (f11 (f12 (f13 f14 f15) (f7 f16 ?v1)) ?v0)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S10)) (let ((?v_0 (f13 f14 f15))) (=> (= (f3 f6 (f11 (f12 ?v_0 (f7 (f8 (f9 f10 ?v0) ?v1) (f27 f28 0))) ?v2)) f1) (=> (= (f3 f6 ?v1) f1) (= (f3 f6 (f11 (f12 ?v_0 (f23 (f24 f15 (f23 f38 ?v0)) ?v1)) ?v2)) f1))))))
(assert (= (f29 f34 f19 f35) f1))
(assert (forall ((?v0 S3)) (=> (= (f3 f6 ?v0) f1) (= (f3 f6 (f23 f38 ?v0)) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f23 f38 ?v0) (f23 f38 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (not (= (f23 (f24 f15 ?v0) ?v1) (f23 f38 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (not (= (f23 f38 ?v0) (f23 (f24 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S6) (?v1 S3)) (not (= (f7 f16 ?v0) (f23 f38 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S6)) (not (= (f23 f38 ?v0) (f7 f16 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S10) (?v2 S3) (?v3 S10)) (let ((?v_0 (f13 f14 f15))) (= (= (f11 (f12 ?v_0 (f23 f38 ?v0)) ?v1) (f11 (f12 ?v_0 (f23 f38 ?v2)) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S6) (?v1 S10) (?v2 S3) (?v3 S10)) (let ((?v_0 (f13 f14 f15))) (not (= (f11 (f12 ?v_0 (f7 f16 ?v0)) ?v1) (f11 (f12 ?v_0 (f23 f38 ?v2)) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S6) (?v3 S10)) (not (= (f23 (f24 f15 (f23 f38 ?v0)) ?v1) (f11 (f12 (f13 f14 f15) (f7 f16 ?v2)) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (= (f23 (f24 f15 ?v0) ?v1) (f23 (f24 f15 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6)) (= (= (f7 f16 ?v0) (f7 f16 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S18) (?v1 S18) (?v2 S3) (?v3 S17) (?v4 S6) (?v5 S18) (?v6 S3)) (=> (= f35 (f39 (f40 f41 ?v0) ?v1)) (=> (= (f3 f6 ?v2) f1) (=> (= (f29 (f30 (f31 (f32 f33 ?v3) ?v4) ?v1) ?v2 ?v5) f1) (=> (= (f3 f6 ?v6) f1) (=> (= (f29 ?v3 ?v6 ?v1) f1) (= (f3 f6 (f7 (f8 (f9 f10 ?v2) ?v6) ?v4)) f1))))))))
(assert (forall ((?v0 S18) (?v1 S18) (?v2 S3) (?v3 S17) (?v4 S6) (?v5 S18) (?v6 S3)) (=> (= f35 (f39 (f40 f41 ?v0) ?v1)) (=> (= (f3 f6 ?v2) f1) (=> (= (f29 (f30 (f31 (f32 f33 ?v3) ?v4) ?v0) ?v2 ?v5) f1) (=> (= (f3 f6 ?v6) f1) (=> (= (f29 ?v3 ?v6 ?v0) f1) (= (f3 f6 (f7 (f8 (f9 f10 ?v2) ?v6) ?v4)) f1))))))))
(assert (forall ((?v0 S17) (?v1 S6) (?v2 S18)) (=> (= (f29 ?v0 (f7 f16 ?v1) ?v2) f1) (=> (=> (= (f42 ?v0 ?v1) ?v2) false) false))))
(assert (forall ((?v0 S17) (?v1 S6) (?v2 S18)) (=> (= (f42 ?v0 ?v1) ?v2) (= (f29 ?v0 (f7 f16 ?v1) ?v2) f1))))
(assert (forall ((?v0 S17) (?v1 S6) (?v2 S10) (?v3 S18) (?v4 S18)) (let ((?v_0 (f11 (f12 (f13 f14 f15) (f7 f16 ?v1)) ?v2))) (=> (= (f29 ?v0 ?v_0 ?v3) f1) (=> (= (f29 ?v0 ?v_0 ?v4) f1) (= ?v3 ?v4))))))
(assert (forall ((?v0 S17) (?v1 S3) (?v2 S18) (?v3 S17) (?v4 S3) (?v5 S18) (?v6 S6)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v5) f1) (=> (= ?v0 (f30 (f31 (f32 f33 ?v3) ?v6) ?v5)) (= (f29 ?v3 (f7 (f8 (f9 f10 ?v1) ?v4) ?v6) ?v2) f1))))))
(assert (forall ((?v0 S3)) (= (= (f3 f6 ?v0) f1) (or (exists ((?v1 S10) (?v2 S6)) (and (= ?v0 (f11 (f12 (f13 f14 f15) (f7 f16 ?v2)) ?v1)) (= (f37 f6 ?v1) f1))) (or (exists ((?v1 S3)) (and (= ?v0 (f23 f38 ?v1)) (= (f3 f6 ?v1) f1))) (exists ((?v1 S3) (?v2 S3) (?v3 S10)) (let ((?v_0 (f13 f14 f15))) (and (= ?v0 (f11 (f12 ?v_0 (f23 (f24 f15 (f23 f38 ?v1)) ?v2)) ?v3)) (and (= (f3 f6 (f11 (f12 ?v_0 (f7 (f8 (f9 f10 ?v1) ?v2) (f27 f28 0))) ?v3)) f1) (= (f3 f6 ?v2) f1))))))))))
(assert (= (f29 (f30 (f31 (f32 f33 f43) f44) f35) (f11 (f12 (f13 f14 f15) (f7 f16 f17)) f18) f45) f1))
(assert (forall ((?v0 S17) (?v1 S3) (?v2 S18)) (=> (= (f29 ?v0 (f23 f38 ?v1) ?v2) f1) (=> (forall ((?v3 S18) (?v4 S18)) (=> (= (f29 (f30 (f31 (f32 f33 ?v0) (f27 f28 0)) ?v3) ?v1 ?v4) f1) false)) false))))
(assert (= (f29 f43 f22 f35) f1))
(assert (forall ((?v0 S17) (?v1 S3) (?v2 S18) (?v3 S18) (?v4 S3)) (=> (= (f29 ?v0 ?v1 (f39 (f40 f41 ?v2) ?v3)) f1) (=> (= (f29 ?v0 ?v4 ?v2) f1) (= (f29 ?v0 (f23 (f24 f15 ?v1) ?v4) ?v3) f1)))))
(assert (forall ((?v0 S17) (?v1 S18) (?v2 S3) (?v3 S18)) (=> (= (f29 (f30 (f31 (f32 f33 ?v0) (f27 f28 0)) ?v1) ?v2 ?v3) f1) (= (f29 ?v0 (f23 f38 ?v2) (f39 (f40 f41 ?v1) ?v3)) f1))))
(assert (forall ((?v0 S18) (?v1 S18) (?v2 S18) (?v3 S18)) (= (= (f39 (f40 f41 ?v0) ?v1) (f39 (f40 f41 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S17) (?v3 S18)) (let ((?v_0 (f25 f26 ?v1))) (=> (< (f25 f26 ?v0) ?v_0) (= (f42 (f30 (f31 (f32 f33 ?v2) ?v0) ?v3) ?v1) (f42 ?v2 (f27 f28 (- ?v_0 1))))))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S17) (?v3 S18)) (=> (< (f25 f26 ?v0) (f25 f26 ?v1)) (= (f42 (f30 (f31 (f32 f33 ?v2) ?v1) ?v3) ?v0) (f42 ?v2 ?v0)))))
(assert (forall ((?v0 S6) (?v1 S6) (?v2 S17) (?v3 S18)) (=> (= ?v0 ?v1) (= (f42 (f30 (f31 (f32 f33 ?v2) ?v0) ?v3) ?v1) ?v3))))
(assert (forall ((?v0 S17) (?v1 S6) (?v2 S18) (?v3 S18)) (let ((?v_1 (f27 f28 0)) (?v_0 (f32 f33 ?v0))) (= (f30 (f31 (f32 f33 (f30 (f31 ?v_0 ?v1) ?v2)) ?v_1) ?v3) (f30 (f31 (f32 f33 (f30 (f31 ?v_0 ?v_1) ?v3)) (f27 f28 (+ (f25 f26 ?v1) 1))) ?v2)))))
(assert (forall ((?v0 S17) (?v1 S6) (?v2 S18) (?v3 S6)) (let ((?v_0 (f25 f26 ?v3))) (= (f42 (f30 (f31 (f32 f33 ?v0) ?v1) ?v2) ?v3) (ite (< ?v_0 (f25 f26 ?v1)) (f42 ?v0 ?v3) (ite (= ?v3 ?v1) ?v2 (f42 ?v0 (f27 f28 (- ?v_0 1)))))))))
(assert (forall ((?v0 S17) (?v1 S3) (?v2 S18)) (=> (= (f29 ?v0 (f23 f38 ?v1) ?v2) f1) (=> (forall ((?v3 S18) (?v4 S18)) (=> (= ?v2 (f39 (f40 f41 ?v3) ?v4)) (=> (= (f29 (f30 (f31 (f32 f33 ?v0) (f27 f28 0)) ?v3) ?v1 ?v4) f1) false))) false))))
(assert (forall ((?v0 S17) (?v1 S3) (?v2 S3) (?v3 S18)) (=> (= (f29 ?v0 (f23 (f24 f15 ?v1) ?v2) ?v3) f1) (=> (forall ((?v4 S18)) (=> (= (f29 ?v0 ?v1 (f39 (f40 f41 ?v4) ?v3)) f1) (=> (= (f29 ?v0 ?v2 ?v4) f1) false))) false))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S10)) (= (= (f37 (f4 (f5 ?v0) ?v1) ?v2) f1) (and (= (f37 ?v0 ?v2) f1) (= (f37 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f46 (f23 (f24 f15 (f23 f38 ?v0)) ?v1)) (f7 (f8 (f9 f10 ?v0) ?v1) (f27 f28 0))) f1)))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 S6)) (=> (= ?v0 (f7 f16 ?v1)) false)) (=> (forall ((?v1 S3) (?v2 S3)) (=> (= ?v0 (f23 (f24 f15 ?v1) ?v2)) false)) (=> (forall ((?v1 S3)) (=> (= ?v0 (f23 f38 ?v1)) false)) false)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S10) (?v2 S3)) (and (= ?v0 (f11 (f12 (f13 f14 f15) ?v2) ?v1)) (or (exists ((?v3 S6)) (= ?v2 (f7 f16 ?v3))) (exists ((?v3 S3)) (= ?v2 (f23 f38 ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f24 f15 ?v2))) (=> (= (f3 (f46 ?v0) ?v1) f1) (= (f3 (f46 (f23 ?v_0 ?v0)) (f23 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f46 ?v0) ?v1) f1) (= (f3 (f46 (f23 (f24 f15 ?v0) ?v2)) (f23 (f24 f15 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S6) (?v1 S3)) (=> (= (f3 (f46 (f7 f16 ?v0)) ?v1) f1) false)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f46 ?v0) ?v1) f1) (= (f3 (f46 (f23 f38 ?v0)) (f23 f38 ?v1)) f1))))
(assert (forall ((?v0 S17) (?v1 S3) (?v2 S18) (?v3 S3)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f3 (f46 ?v1) ?v3) f1) (= (f29 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S6)) (=> (= (f3 (f46 ?v0) ?v1) f1) (= (f3 (f46 (f7 (f8 (f9 f10 ?v0) ?v2) ?v3)) (f7 (f8 (f9 f10 ?v1) ?v2) ?v3)) f1))))
(assert (forall ((?v0 S6)) (= (f27 f28 (f25 f26 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f25 f26 (f27 f28 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f25 f26 (f27 f28 ?v0)) 0))))
(check-sat)
(exit)
