(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S4 S2) S3)
(declare-fun f4 (S5 S3) S4)
(declare-fun f5 (S6 S3) S5)
(declare-fun f6 () S6)
(declare-fun f7 () S4)
(declare-fun f8 (S7 S2) Int)
(declare-fun f9 () S7)
(declare-fun f10 (S8 Int) S2)
(declare-fun f11 () S8)
(declare-fun f12 () S5)
(declare-fun f13 (S9 S3) S2)
(declare-fun f14 () S9)
(declare-fun f15 (S10 S3) S3)
(declare-fun f16 (S11 S3) S10)
(declare-fun f17 () S11)
(declare-fun f18 (S3) S1)
(declare-fun f19 () S3)
(declare-fun f20 () S3)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (let ((?v_1 (f3 f7 ?v0)) (?v_0 (f8 f9 ?v0))) (= (f3 (f4 (f5 f6 ?v_1) ?v1) ?v2) (ite (< (f8 f9 ?v2) ?v_0) (f3 f7 (f10 f11 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (= (f3 (f4 (f5 f6 (f3 (f4 f12 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S2)) (= (f13 f14 (f3 f7 ?v0)) (f10 f11 0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S2)) (= (f3 (f4 (f5 f6 (f15 (f16 f17 ?v0) ?v1)) ?v2) ?v3) (f15 (f16 f17 (f3 (f4 (f5 f6 ?v0) ?v2) ?v3)) (f3 (f4 (f5 f6 ?v1) ?v2) ?v3)))))
(assert (let ((?v_0 (f10 f11 0))) (not (=> (= (f18 (f3 (f4 (f5 f6 (f15 (f16 f17 (f3 f7 ?v_0)) (f3 (f4 f12 f19) ?v_0))) f20) ?v_0)) f1) (= (f18 (f15 (f16 f17 f20) f19)) f1)))))
(assert (forall ((?v0 S2)) (= (f10 f11 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
