(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 () S4)
(declare-fun f8 (S6 Int) S5)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 (Int) S1)
(declare-fun f16 (S9 S8) Int)
(declare-fun f17 () S9)
(declare-fun f18 (S10 Int) S1)
(declare-fun f19 (S11 S5) S1)
(declare-fun f20 () S2)
(declare-fun f21 (S12 Int) S8)
(declare-fun f22 () S12)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f4 f5 f11)) (?v_1 (f4 f5 f12))) (not (= (f3 (f4 f5 (f6 f7 (f8 (f9 f10 f11) f12))) (f6 f7 (f8 (f9 f10 f13) f14))) (f6 f7 (f8 (f9 f10 (+ (f3 ?v_0 f13) (f3 ?v_1 f14))) (- (f3 ?v_0 f14) (f3 ?v_1 f13))))))))
(assert (forall ((?v0 Int)) (= (= (f15 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f6 f7 (f8 (f9 f10 ?v1) ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (- ?v1 ?v2)) (- (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 (- ?v0)) ?v1) (- (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v2) (- (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f4 f5 ?v1))) (= (+ (f3 (f4 f5 (- ?v0 (f3 ?v_0 ?v2))) ?v3) (f3 (f4 f5 (- ?v4 (f3 ?v_0 ?v5))) ?v6)) (- (+ (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v4) ?v6)) (f3 ?v_0 (+ (f3 (f4 f5 ?v2) ?v3) (f3 (f4 f5 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f3 (f4 f5 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f3 (f4 f5 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (let ((?v_0 (f16 f17 ?v2))) (let ((?v_1 (f4 f5 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f3 ?v_1 ?v0) (f3 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f18 ?v1 ?v3) f1) (= (f18 ?v1 (- ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f18 ?v1 ?v3) f1) (= (f18 ?v1 (- ?v3 (f3 (f4 f5 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f18 ?v1 ?v3) f1) (= (f18 ?v1 (+ ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f18 ?v1 ?v3) f1) (= (f18 ?v1 (+ ?v3 (f3 (f4 f5 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f3 (f4 f5 ?v3) ?v4) ?v5))) (=> (= (+ (f3 (f4 f5 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (<= (+ (f3 ?v_0 ?v1) ?v2) (+ (f3 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f3 (f4 f5 ?v3) ?v4) ?v5))) (=> (= (+ (f3 (f4 f5 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (<= (+ (f3 ?v_0 ?v1) ?v2) (+ (f3 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f3 (f4 f5 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f3 (f4 f5 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f3 (f4 f5 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f3 (f4 f5 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f3 (f4 f5 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (let ((?v_1 (f3 (f4 f5 ?v2) ?v0))) (let ((?v_0 (- ?v1 ?v_1))) (<= (ite (< ?v_0 0) (* (- 2) ?v_0) (- (* 2 ?v1) (* 2 ?v_1))) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f3 (f4 f5 ?v0) ?v1))))))
(assert (forall ((?v0 S11)) (= (forall ((?v1 S5)) (= (f19 ?v0 ?v1) f1)) (forall ((?v1 Int) (?v2 Int)) (= (f19 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v3)) (=> (=> (= ?v0 ?v2) (=> (= ?v1 ?v3) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f20 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f3 f20 ?v0)) (f3 f20 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f21 f22 (f3 (f4 f5 (f16 f17 (f21 f22 ?v0))) (f16 f17 (f21 f22 ?v1)))) (f21 f22 (f3 (f4 f5 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f3 (f4 f5 (f16 f17 ?v0)) (f16 f17 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f21 f22 (f3 (f4 f5 ?v0) ?v1)) (f21 f22 (f3 (f4 f5 (f16 f17 (f21 f22 (- ?v0)))) (f16 f17 (f21 f22 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f21 f22 (f3 (f4 f5 ?v0) ?v1)) (f21 f22 (f3 (f4 f5 (f16 f17 (f21 f22 ?v0))) (f16 f17 (f21 f22 ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f3 (f4 f5 (f16 f17 ?v0)) (f16 f17 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f3 (f4 f5 (f16 f17 ?v0)) (f16 f17 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f21 f22 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f21 f22 (f3 (f4 f5 (f16 f17 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)))) (f16 f17 (f21 f22 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) (f3 (f4 f5 ?v2) ?v3)) (f3 (f4 f5 (f3 ?v_0 ?v2)) (f3 (f4 f5 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f4 f5 (f3 (f4 f5 ?v0) ?v1))) (?v_0 (f4 f5 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v0)) (?v_1 (f3 (f4 f5 ?v2) ?v3))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f5 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 S8)) (= (f21 f22 (f16 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f21 f22 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f17 (f21 f22 ?v0)) 0))))
(check-sat)
(exit)
