(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 () S4)
(declare-fun f8 (Int Int) S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 (Int) S1)
(declare-fun f14 (S7 S6) Int)
(declare-fun f15 () S7)
(declare-fun f16 (S8 Int) S1)
(declare-fun f17 (S9 Int) S6)
(declare-fun f18 () S9)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f4 f5 f9)) (?v_1 (f4 f5 f10))) (not (= (f3 (f4 f5 (f6 f7 (f8 f9 f10))) (f6 f7 (f8 f11 f12))) (f6 f7 (f8 (+ (f3 ?v_0 f11) (f3 ?v_1 f12)) (- (f3 ?v_0 f12) (f3 ?v_1 f11))))))))
(assert (forall ((?v0 Int)) (= (= (f13 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f6 f7 (f8 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (- ?v1 ?v2)) (- (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 (- ?v0)) ?v1) (- (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v2) (- (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f4 f5 ?v1))) (= (+ (f3 (f4 f5 (- ?v0 (f3 ?v_0 ?v2))) ?v3) (f3 (f4 f5 (- ?v4 (f3 ?v_0 ?v5))) ?v6)) (- (+ (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v4) ?v6)) (f3 ?v_0 (+ (f3 (f4 f5 ?v2) ?v3) (f3 (f4 f5 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f3 (f4 f5 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f3 (f4 f5 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6)) (let ((?v_0 (f14 f15 ?v2))) (let ((?v_1 (f4 f5 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f3 ?v_1 ?v0) (f3 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f16 ?v1 ?v3) f1) (= (f16 ?v1 (- ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f16 ?v1 ?v3) f1) (= (f16 ?v1 (- ?v3 (f3 (f4 f5 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f16 ?v1 ?v3) f1) (= (f16 ?v1 (+ ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f16 ?v1 ?v3) f1) (= (f16 ?v1 (+ ?v3 (f3 (f4 f5 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f3 (f4 f5 ?v3) ?v4) ?v5))) (=> (= (+ (f3 (f4 f5 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (<= (+ (f3 ?v_0 ?v1) ?v2) (+ (f3 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f3 (f4 f5 ?v3) ?v4) ?v5))) (=> (= (+ (f3 (f4 f5 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (<= (+ (f3 ?v_0 ?v1) ?v2) (+ (f3 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f3 (f4 f5 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f3 (f4 f5 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 S6)) (= (f17 f18 (f14 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f15 (f17 f18 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f14 f15 (f17 f18 ?v0)) 0))))
(check-sat)
(exit)
