(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 (Int) S1)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 (S9 Int) S1)
(declare-fun f17 () S6)
(declare-fun f18 (S11 S10) S10)
(declare-fun f19 () S11)
(declare-fun f20 (S12 S10) S11)
(declare-fun f21 () S12)
(declare-fun f22 () S4)
(declare-fun f23 (S13 Int) S3)
(declare-fun f24 () S13)
(declare-fun f25 () S6)
(declare-fun f26 (S14 Int) S10)
(declare-fun f27 () S14)
(declare-fun f28 () S6)
(declare-fun f29 () S14)
(declare-fun f30 () S5)
(declare-fun f31 (S2 S15) S1)
(declare-fun f32 (S15 S2) S1)
(declare-fun f33 (S10 S16) S1)
(declare-fun f34 (S16 S10) S1)
(declare-fun f35 (Int S9) S1)
(declare-fun f36 () Int)
(declare-fun f37 () S16)
(declare-fun f38 () S9)
(declare-fun f39 (Int) S1)
(declare-fun f40 (S10) S1)
(declare-fun f41 () S6)
(declare-fun f42 () S15)
(declare-fun f43 (Int) S1)
(declare-fun f44 () S10)
(declare-fun f45 () S2)
(declare-fun f46 (S2) S1)
(declare-fun f47 (S17 S2) S10)
(declare-fun f48 () S17)
(declare-fun f49 () S6)
(declare-fun f50 () S3)
(declare-fun f51 () S6)
(declare-fun f52 () S10)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (not (= (f13 (f8 (f9 f10 f14) f15)) f1)))
(assert (= (f13 f14) f1))
(assert (= (f13 f15) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f9 f10 ?v1))) (= (+ (f8 (f9 f10 (- ?v0 (f8 ?v_0 ?v2))) ?v3) (f8 (f9 f10 (- ?v4 (f8 ?v_0 ?v5))) ?v6)) (- (+ (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v4) ?v6)) (f8 ?v_0 (+ (f8 (f9 f10 ?v2) ?v3) (f8 (f9 f10 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f16 ?v1 ?v3) f1) (= (f16 ?v1 (- ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f16 ?v1 ?v3) f1) (= (f16 ?v1 (- ?v3 (f8 (f9 f10 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f16 ?v1 ?v3) f1) (= (f16 ?v1 (+ ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f16 ?v1 ?v3) f1) (= (f16 ?v1 (+ ?v3 (f8 (f9 f10 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f8 (f9 f10 ?v3) ?v4) ?v5))) (=> (= (+ (f8 (f9 f10 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= (+ (f8 ?v_0 ?v1) ?v2) (+ (f8 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f8 (f9 f10 ?v3) ?v4) ?v5))) (=> (= (+ (f8 (f9 f10 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (<= (+ (f8 ?v_0 ?v1) ?v2) (+ (f8 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f8 (f9 f10 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f8 (f9 f10 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f8 (f9 f10 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (let ((?v_1 (f8 (f9 f10 ?v2) ?v0))) (let ((?v_0 (- ?v1 ?v_1))) (<= (ite (< ?v_0 0) (* (- 2) ?v_0) (- (* 2 ?v1) (* 2 ?v_1))) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f8 (f9 f10 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f17 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f17 ?v0)) (f8 f17 ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 f19 (f18 (f20 f21 ?v0) ?v1)) (f18 (f20 f21 (f18 f19 ?v0)) (f18 f19 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f22 ?v0) ?v1) (f3 (f4 f22 ?v1) ?v0))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f18 (f20 f21 ?v0) ?v1) (f18 (f20 f21 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f9 f10 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f4 f22 ?v0)) (?v_0 (f4 f22 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_1 (f20 f21 ?v0)) (?v_0 (f20 f21 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f22 ?v0))) (= (f3 ?v_0 (f3 (f4 f22 ?v1) ?v2)) (f3 (f4 f22 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f20 f21 ?v0))) (= (f18 ?v_0 (f18 (f20 f21 ?v1) ?v2)) (f18 (f20 f21 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1)))) (f6 f7 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f11 f12 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 (f9 f10 ?v2) ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v2)) (f8 (f9 f10 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f22 ?v0))) (= (f3 (f4 f22 (f3 ?v_0 ?v1)) (f3 (f4 f22 ?v2) ?v3)) (f3 (f4 f22 (f3 ?v_0 ?v2)) (f3 (f4 f22 ?v1) ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f20 f21 ?v0))) (= (f18 (f20 f21 (f18 ?v_0 ?v1)) (f18 (f20 f21 ?v2) ?v3)) (f18 (f20 f21 (f18 ?v_0 ?v2)) (f18 (f20 f21 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f9 f10 (f8 (f9 f10 ?v0) ?v1))) (?v_0 (f9 f10 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f22 (f3 (f4 f22 ?v0) ?v1))) (?v_0 (f4 f22 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_1 (f20 f21 (f18 (f20 f21 ?v0) ?v1))) (?v_0 (f20 f21 ?v2))) (= (f18 ?v_1 (f18 ?v_0 ?v3)) (f18 ?v_0 (f18 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f8 (f9 f10 ?v2) ?v3))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f22 ?v0)) (?v_1 (f3 (f4 f22 ?v2) ?v3))) (= (f3 (f4 f22 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f22 ?v1) ?v_1))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (let ((?v_0 (f20 f21 ?v0)) (?v_1 (f18 (f20 f21 ?v2) ?v3))) (= (f18 (f20 f21 (f18 ?v_0 ?v1)) ?v_1) (f18 ?v_0 (f18 (f20 f21 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f22 ?v0))) (= (f3 (f4 f22 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f22 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f20 f21 ?v0))) (= (f18 (f20 f21 (f18 ?v_0 ?v1)) ?v2) (f18 (f20 f21 (f18 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f22 ?v0))) (= (f3 (f4 f22 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f20 f21 ?v0))) (= (f18 (f20 f21 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f20 f21 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f17 ?v0))) (= (f8 (f9 f10 ?v_0) ?v_0) (f8 (f9 f10 ?v0) ?v0)))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f18 f19 ?v0))) (= (f18 (f20 f21 ?v_0) ?v_0) (f18 (f20 f21 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f22 ?v0))) (= (f3 (f4 f22 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10)) (let ((?v_0 (f20 f21 ?v0))) (= (f18 (f20 f21 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f20 f21 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S9)) (=> (< 0 ?v0) (=> (forall ((?v3 Int) (?v4 Int)) (= (= (f16 ?v1 ?v3) f1) (= (f16 ?v1 (- ?v3 (f8 (f9 f10 ?v4) ?v0))) f1))) (=> (exists ((?v3 Int)) (forall ((?v4 Int)) (=> (< ?v4 ?v3) (= (= (f16 ?v2 ?v4) f1) (= (f16 ?v1 ?v4) f1))))) (=> (exists ((?v3 Int)) (= (f16 ?v1 ?v3) f1)) (exists ((?v3 Int)) (= (f16 ?v2 ?v3) f1))))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S9)) (=> (< 0 ?v0) (=> (forall ((?v3 Int) (?v4 Int)) (= (= (f16 ?v1 ?v3) f1) (= (f16 ?v1 (- ?v3 (f8 (f9 f10 ?v4) ?v0))) f1))) (=> (exists ((?v3 Int)) (forall ((?v4 Int)) (=> (< ?v3 ?v4) (= (= (f16 ?v2 ?v4) f1) (= (f16 ?v1 ?v4) f1))))) (=> (exists ((?v3 Int)) (= (f16 ?v1 ?v3) f1)) (exists ((?v3 Int)) (= (f16 ?v2 ?v3) f1))))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f3 (f23 f24 ?v0) ?v1) (f6 f7 (+ (f11 f12 (f6 f7 ?v0)) (f11 f12 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (f8 f25 ?v0)) (f8 (f9 f10 (f8 f25 ?v1)) ?v2)) (f8 (f9 f10 (f8 f25 (f8 (f9 f10 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (f18 (f20 f21 (f26 f27 ?v0)) (f18 (f20 f21 (f26 f27 ?v1)) ?v2)) (f18 (f20 f21 (f26 f27 (f8 (f9 f10 ?v0) ?v1))) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (f8 f25 ?v0)) (f8 f25 ?v1)) (f8 f25 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f18 (f20 f21 (f26 f27 ?v0)) (f26 f27 ?v1)) (f26 f27 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f25 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f25 ?v0)) (f8 f25 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 f27 (f8 (f9 f10 ?v0) ?v1)) (f18 (f20 f21 (f26 f27 ?v0)) (f26 f27 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f28 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f28 ?v0)) (f8 f28 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 f29 (f8 (f9 f10 ?v0) ?v1)) (f18 (f20 f21 (f26 f29 ?v0)) (f26 f29 ?v1)))))
(assert (forall ((?v0 Int)) (= (f8 f25 ?v0) (f8 f28 ?v0))))
(assert (forall ((?v0 Int)) (= (f26 f27 ?v0) (f26 f29 ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f25 ?v0))) (= (f8 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (f26 f29 (f8 f25 ?v0)) (f26 f27 ?v0))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f26 f27 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f6 f30 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f25 ?v0))) (= (= ?v_0 ?v1) (= ?v1 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f28 ?v0) (f8 f28 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f26 f29 ?v0) (f26 f29 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f26 f27 ?v0) (f26 f27 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f25 ?v0) (f8 f25 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (f8 f25 ?v0)) (f8 f25 ?v1)) (f8 f25 (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (<= ?v_0 (f8 ?v_1 (f8 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f11 f12 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (f8 (f9 f10 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 Int)) (= (f8 f25 ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 f25 ?v0) (f8 f28 ?v0))))
(assert (forall ((?v0 Int)) (= (- (f8 f25 ?v0)) (f8 f25 (- ?v0)))))
(assert (forall ((?v0 S2) (?v1 S15)) (= (= (f31 ?v0 ?v1) f1) (= (f32 ?v1 ?v0) f1))))
(assert (forall ((?v0 S10) (?v1 S16)) (= (= (f33 ?v0 ?v1) f1) (= (f34 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S9)) (= (= (f35 ?v0 ?v1) f1) (= (f16 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f8 f25 ?v0) (f8 f25 ?v1)) (f8 f25 (+ ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f8 f25 ?v0) (f8 f25 ?v1)) (f8 f25 (+ ?v0 (- ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f25 ?v0) (f8 f25 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f25 ?v0) (f8 f25 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f8 f25 ?v1))) (= (= (f11 f12 ?v0) ?v_0) (and (= ?v0 (f6 f7 ?v_0)) (<= 0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f11 f12 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (or (= ?v1 (f6 f7 1)) (= ?v0 (f6 f7 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_3 (f11 f12 ?v3)) (?v_1 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_3 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v2))) (let ((?v_2 (f9 f10 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f8 ?v_2 ?v_1) (f8 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f9 f10 (f11 f12 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f8 ?v_1 ?v_0) (f8 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f8 (f9 f10 ?v_0) ?v_2) (f8 (f9 f10 ?v_1) ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (+ (f11 f12 ?v0) 1)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_2)))) ?v_1)) (f6 f7 (- (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_2)) ?v_1)) (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f8 ?v_0 ?v_1)) ?v_2)) (f6 f7 (f8 ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ ?v_1 1)) ?v_0)) (f6 f7 (+ ?v_0 (f8 (f9 f10 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (f8 (f9 f10 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (f11 f12 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_1 (+ ?v_2 1))) (f6 f7 (+ ?v_0 (f8 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (f8 (f9 f10 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f8 f25 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f8 f25 ?v0)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 (f6 f7 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f6 f7 (f8 (f9 f10 ?v_0) ?v_0)) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0 1)))) (f11 f12 (f6 f7 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (<= (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (< (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (f6 f7 (- (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4))) (f6 f7 (- (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 (f6 f30 ?v0)))) (=> (< 0 ?v_0) (= (f6 f7 (f8 f25 ?v0)) (f6 f7 (+ (f11 f12 (f6 f7 (- ?v_0 1))) 1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f8 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0)) (?v_2 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v0 (f6 f7 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (= (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_0) (+ (f8 (f9 f10 ?v_2) ?v_0) ?v_3))) (f6 f7 (+ (f8 (f9 f10 (+ ?v_1 ?v_2)) ?v_0) ?v_3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< 0 ?v_0) (= (= (f6 f7 (f8 ?v_1 (f11 f12 ?v1))) (f6 f7 (f8 ?v_1 (f11 f12 ?v2)))) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (< (f8 ?v_1 ?v_2) (f8 ?v_1 ?v_3)) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (=> (< 0 ?v_0) (= (<= (f8 ?v_1 ?v_2) (f8 ?v_1 ?v_3)) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_2) (f11 f12 ?v3))) (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_3))) (= ?v3 (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (f6 f7 (- (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4))) (f6 f7 (- ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (< ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_4 (f11 f12 ?v4)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3) (+ (f8 (f9 f10 ?v_1) ?v_2) ?v_4)) (<= ?v_3 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_1 ?v_0)))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v2)) (?v_3 (f11 f12 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_2) ?v_3)) (f6 f7 (+ (f8 (f9 f10 ?v_1) ?v_2) (f11 f12 ?v4)))) (= (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_1)))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f11 f12 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (+ (f11 f12 (f6 f7 (- ?v_0 2))) 1) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 4 (f11 f12 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (+ (f11 f12 (f6 f7 (- ?v_0 2))) 1) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f11 f12 ?v0)))) (=> (not (= ?v0 (f6 f7 0))) (= (f6 f7 (+ (f11 f12 (f6 f7 (- ?v_0 1))) 1)) (f6 f7 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< 0 ?v_0) (=> (= (f6 f7 (f8 ?v_1 (f11 f12 ?v1))) (f6 f7 (f8 ?v_1 (f11 f12 ?v2)))) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (=> (< 0 ?v_0) (=> (= (f6 f7 (f8 (f9 f10 ?v_0) (f11 f12 ?v1))) ?v0) (= ?v1 (f6 f7 (+ 0 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v2))) (=> (< 0 ?v_1) (=> (< 0 ?v_2) (=> (< (+ 0 1) ?v_0) (=> (= (f6 f7 (f8 (f9 f10 ?v_0) ?v_1)) ?v1) (< ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (+ 0 1)) (?v_2 (f11 f12 ?v1))) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) ?v_2))) (=> (not (= ?v0 (f6 f7 ?v_0))) (=> (< ?v_1 ?v_0) (< ?v_1 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0))) (=> (not (= ?v0 (f6 f7 (f8 (f9 f10 ?v_1) (f11 f12 ?v1))))) (=> (not (= ?v0 (f6 f7 ?v_0))) (< ?v_0 ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f30 ?v0))) (f11 f12 (f6 f30 ?v1)))) (ite (< ?v0 f36) (f6 f7 0) (f6 f7 (f8 f25 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f30 ?v0))) (f8 (f9 f10 (f11 f12 (f6 f30 ?v1))) ?v_0))) (ite (< ?v0 f36) (f6 f7 0) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f30 (f8 (f9 f10 ?v0) ?v1)))) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f36 ?v0) (=> (<= f36 ?v1) (= (f8 (f9 f10 (f8 f25 ?v0)) (f8 f25 ?v1)) (f8 f25 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f36 ?v0) (=> (<= f36 ?v1) (= (f18 (f20 f21 (f26 f27 ?v0)) (f26 f27 ?v1)) (f26 f27 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= f36 ?v0) (=> (<= f36 ?v1) (= (f3 (f4 f22 (f6 f30 ?v0)) (f6 f30 ?v1)) (f6 f30 (f8 (f9 f10 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f11 f12 (f6 f30 ?v0)) (f11 f12 (f6 f30 ?v1))) (ite (< ?v0 ?v1) (< f36 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f12 (f6 f30 ?v0)) (f11 f12 (f6 f30 ?v1))) (ite (<= ?v0 ?v1) true (<= ?v0 f36)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 f7 (+ (f11 f12 (f6 f30 ?v0)) (f11 f12 (f6 f30 ?v1)))) (ite (< ?v0 f36) (f6 f7 (f8 f25 ?v1)) (ite (< ?v1 f36) (f6 f7 (f8 f25 ?v0)) (f6 f7 (f8 f25 (+ ?v0 ?v1))))))))
(assert (forall ((?v0 Int)) (= (= (f6 f7 (f8 f25 ?v0)) (f6 f7 0)) (<= ?v0 f36))))
(assert (forall ((?v0 Int)) (= (= (f6 f7 0) (f6 f7 (f8 f25 ?v0))) (<= ?v0 f36))))
(assert (forall ((?v0 Int)) (= (< 0 (f11 f12 (f6 f30 ?v0))) (< f36 ?v0))))
(assert (forall ((?v0 Int)) (= (f8 (f9 f10 f36) ?v0) f36)))
(assert (forall ((?v0 Int)) (= (- ?v0 f36) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 f36) ?v0)))
(assert (forall ((?v0 Int)) (= (+ f36 ?v0) ?v0)))
(assert (= (<= f36 f36) true))
(assert (= (< f36 0) false))
(assert (= (< f36 f36) false))
(assert (= (= f36 f36) true))
(assert (= (- f36) f36))
(assert (= f36 0))
(assert (forall ((?v0 Int)) (=> (<= f36 ?v0) (= (f33 (f26 f27 ?v0) f37) f1))))
(assert (forall ((?v0 Int)) (=> (<= f36 ?v0) (= (f35 (f8 f25 ?v0) f38) f1))))
(assert (= (f39 0) f1))
(assert (= (f40 (f26 f27 f36)) f1))
(assert (forall ((?v0 Int)) (= (f6 f7 (+ (f11 f12 (f6 f30 ?v0)) 1)) (ite (< ?v0 f36) (f6 f7 1) (f6 f7 (f8 f25 (f8 f41 ?v0)))))))
(assert (forall ((?v0 Int)) (= (f8 f41 ?v0) (+ ?v0 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f25 ?v0) (f8 f25 ?v1)) (= (f39 (f8 f25 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f26 f27 ?v0) (f26 f27 ?v1)) (= (f40 (f26 f27 (+ ?v0 (- ?v1)))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f35 ?v0 f38) f1) (=> (= (f35 ?v1 f38) f1) (= (f35 (f8 (f9 f10 ?v0) ?v1) f38) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f31 ?v0 f42) f1) (=> (= (f31 ?v1 f42) f1) (= (f31 (f3 (f4 f22 ?v0) ?v1) f42) f1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f33 ?v0 f37) f1) (=> (= (f33 ?v1 f37) f1) (= (f33 (f18 (f20 f21 ?v0) ?v1) f37) f1)))))
(assert (forall ((?v0 Int)) (= (f6 f7 (+ 1 (f11 f12 (f6 f30 ?v0)))) (ite (< ?v0 f36) (f6 f7 1) (f6 f7 (f8 f25 (f8 f41 ?v0)))))))
(assert (forall ((?v0 Int)) (= (f6 f7 (+ (f11 f12 (f6 f30 ?v0)) 1)) (ite (= (f43 (f8 f25 ?v0)) f1) (f6 f7 1) (f6 f7 (f8 f25 (f8 f41 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (f6 f7 (+ (+ (f11 f12 (f6 f30 ?v0)) ?v_0) 1)) (ite (= (f43 (f8 f25 ?v0)) f1) (f6 f7 (+ 1 ?v_0)) (f6 f7 (+ (f11 f12 (f6 f30 (f8 f41 ?v0))) ?v_0)))))))
(assert (forall ((?v0 Int)) (= (= 0 (f8 f25 ?v0)) (= (f39 (f8 f25 (+ f36 (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= f44 (f26 f27 ?v0)) (= (f40 (f26 f27 (+ f36 (- ?v0)))) f1))))
(assert (= (f35 0 f38) f1))
(assert (= (f31 f45 f42) f1))
(assert (= (f33 f44 f37) f1))
(assert (= (f39 0) f1))
(assert (= (f40 f44) f1))
(assert (= (f46 f45) f1))
(assert (forall ((?v0 Int)) (= (= (f39 ?v0) f1) (= ?v0 0))))
(assert (forall ((?v0 S10)) (= (= (f40 ?v0) f1) (= ?v0 f44))))
(assert (forall ((?v0 S2)) (= (= (f46 ?v0) f1) (= ?v0 f45))))
(assert (forall ((?v0 Int)) (=> (not (= (f43 ?v0) f1)) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f43 ?v0) f1) (= (f6 f7 ?v0) (f6 f7 0)))))
(assert (forall ((?v0 Int)) (= (not (= (f43 ?v0) f1)) (<= 0 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f43 ?v0) f1) (< ?v0 0))))
(assert (forall ((?v0 S2)) (= (f43 (- (+ (f11 f12 ?v0) 1))) f1)))
(assert (forall ((?v0 S2)) (not (= (f43 (f11 f12 ?v0)) f1))))
(assert (not (= (f43 0) f1)))
(assert (= (f43 (- 1)) f1))
(assert (not (= (f43 0) f1)))
(assert (not (= (f43 1) f1)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f22 f45) ?v0) f45)))
(assert (forall ((?v0 S10)) (= (f18 (f20 f21 f44) ?v0) f44)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f22 f45) ?v0) f45)))
(assert (forall ((?v0 S10)) (= (f18 (f20 f21 f44) ?v0) f44)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f22 ?v0) f45) f45)))
(assert (forall ((?v0 S10)) (= (f18 (f20 f21 ?v0) f44) f44)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f22 ?v0) f45) f45)))
(assert (forall ((?v0 S10)) (= (f18 (f20 f21 ?v0) f44) f44)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (= (f18 (f20 f21 ?v0) ?v1) f44) (or (= ?v0 f44) (= ?v1 f44)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f8 (f9 f10 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f45)) (=> (not (= ?v1 f45)) (not (= (f3 (f4 f22 ?v0) ?v1) f45))))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (not (= ?v0 f44)) (=> (not (= ?v1 f44)) (not (= (f18 (f20 f21 ?v0) ?v1) f44))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 (f4 f22 ?v0) ?v1) f45) (or (= ?v0 f45) (= ?v1 f45)))))
(assert (forall ((?v0 S10) (?v1 S10)) (=> (= (f18 (f20 f21 ?v0) ?v1) f44) (or (= ?v0 f44) (= ?v1 f44)))))
(assert (= (f8 f28 0) 0))
(assert (= (f26 f29 0) f44))
(assert (forall ((?v0 Int)) (= (= 0 (f8 f28 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= f44 (f26 f29 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f8 f28 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f26 f29 ?v0) f44) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f8 f17 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S10)) (= (= (f18 f19 ?v0) f44) (= ?v0 f44))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (= f45 ?v0) (= ?v0 f45))))
(assert (forall ((?v0 S10)) (= (= f44 ?v0) (= ?v0 f44))))
(assert (= (f8 f17 0) 0))
(assert (= (f18 f19 f44) f44))
(assert (= 0 0))
(assert (= (f26 f27 f36) f44))
(assert (= 0 0))
(assert (= (f26 f27 f36) f44))
(assert (= (f6 f30 f36) f45))
(assert (= 0 0))
(assert (= f44 (f26 f27 f36)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f25 ?v0))) (= (f11 f12 (f6 f7 ?v_0)) (ite (= (f43 ?v_0) f1) 0 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 f25 ?v0)) (?v_1 (f8 f25 ?v1))) (= (= (f6 f7 ?v_0) (f6 f7 ?v_1)) (ite (= (f43 ?v_0) f1) (<= ?v_1 0) (ite (= (f43 ?v_1) f1) (= ?v_0 0) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_1 (f11 f12 (f6 f30 ?v0))) (?v_2 (f11 f12 ?v2))) (let ((?v_0 (+ (f11 f12 (f6 f30 ?v1)) ?v_2))) (= (f6 f7 (+ ?v_1 ?v_0)) (ite (= (f43 (f8 f25 ?v0)) f1) (f6 f7 ?v_0) (ite (= (f43 (f8 f25 ?v1)) f1) (f6 f7 (+ ?v_1 ?v_2)) (f6 f7 (+ (f11 f12 (f6 f30 (+ ?v0 ?v1))) ?v_2)))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f25 ?v0))) (=> (= (f43 ?v_0) f1) (= (f6 f7 ?v_0) (f6 f7 0))))))
(assert (forall ((?v0 Int)) (= (= (f8 f25 ?v0) 0) (= (f39 (f8 f25 (+ ?v0 (- f36)))) f1))))
(assert (forall ((?v0 Int)) (= (= (f26 f27 ?v0) f44) (= (f40 (f26 f27 (+ ?v0 (- f36)))) f1))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f25 ?v0))) (= (f11 f12 (f6 f7 ?v_0)) (ite (= (f43 ?v_0) f1) 0 ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f25 ?v0))) (= (f47 f48 (f6 f7 ?v_0)) (ite (= (f43 ?v_0) f1) f44 (f26 f27 ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f43 (f8 f25 (f8 f49 ?v0))) f1) (= (f6 f7 (f8 f25 ?v0)) (f6 f7 0)))))
(assert (forall ((?v0 Int)) (= (f6 f7 (- (f11 f12 (f6 f30 ?v0)) 1)) (ite (<= ?v0 f36) (f6 f7 0) (f6 f7 (f8 f25 (f8 f49 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 f12 ?v1))) (=> (< f36 ?v0) (= (f6 f7 (- (+ ?v_0 1) (f11 f12 (f6 f30 ?v0)))) (f6 f7 (- ?v_0 (f11 f12 (f6 f30 (f8 f49 ?v0))))))))))
(assert (forall ((?v0 S2)) (= (f35 (f11 f12 ?v0) f38) f1)))
(assert (forall ((?v0 S2)) (= (f31 (f3 f50 ?v0) f42) f1)))
(assert (forall ((?v0 S2)) (= (f33 (f47 f48 ?v0) f37) f1)))
(assert (forall ((?v0 Int)) (= (f8 f41 (f8 f49 ?v0)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= (f11 f12 (f6 f7 ?v_0)) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 f50 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (f3 (f4 f22 (f3 f50 ?v0)) (f3 f50 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f47 f48 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (f18 (f20 f21 (f47 f48 ?v0)) (f47 f48 ?v1)))))
(assert (forall ((?v0 S2)) (= (f26 f27 (f11 f12 ?v0)) (f47 f48 ?v0))))
(assert (forall ((?v0 S2)) (= (f6 f30 (f11 f12 ?v0)) (f3 f50 ?v0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f8 f25 ?v_0) ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f8 f28 ?v_0) ?v_0))))
(assert (forall ((?v0 S2)) (= (f26 f29 (f11 f12 ?v0)) (f47 f48 ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) (f8 f28 ?v0)))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f47 f48 (f6 f7 ?v0)) (f26 f29 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (< (f8 f49 ?v0) ?v1))))
(assert (forall ((?v0 Int)) (= (f8 f49 ?v0) (- ?v0 1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f11 f12 ?v0) (f11 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f50 ?v0) (f3 f50 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f47 f48 ?v0) (f47 f48 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (= (f8 f17 ?v_0) ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f47 f48 ?v0))) (= (f18 f19 ?v_0) ?v_0))))
(assert (= (f11 f12 (f6 f7 0)) 0))
(assert (= (f3 f50 (f6 f7 0)) f45))
(assert (= (f47 f48 (f6 f7 0)) f44))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f25 ?v0))) (= (f11 f12 (f6 f7 ?v_0)) (ite (<= 0 ?v_0) ?v_0 0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f25 ?v0))) (= (f47 f48 (f6 f7 ?v_0)) (ite (<= 0 ?v_0) (f26 f27 ?v0) f44)))))
(assert (forall ((?v0 Int) (?v1 S9)) (=> (= (f35 ?v0 f38) f1) (=> (forall ((?v2 S2)) (= (f16 ?v1 (f11 f12 ?v2)) f1)) (= (f16 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S15)) (=> (= (f31 ?v0 f42) f1) (=> (forall ((?v2 S2)) (= (f32 ?v1 (f3 f50 ?v2)) f1)) (= (f32 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S10) (?v1 S16)) (=> (= (f33 ?v0 f37) f1) (=> (forall ((?v2 S2)) (= (f34 ?v1 (f47 f48 ?v2)) f1)) (= (f34 ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f35 ?v0 f38) f1) (=> (forall ((?v1 S2)) (=> (= ?v0 (f11 f12 ?v1)) false)) false))))
(assert (forall ((?v0 S2)) (=> (= (f31 ?v0 f42) f1) (=> (forall ((?v1 S2)) (=> (= ?v0 (f3 f50 ?v1)) false)) false))))
(assert (forall ((?v0 S10)) (=> (= (f33 ?v0 f37) f1) (=> (forall ((?v1 S2)) (=> (= ?v0 (f47 f48 ?v1)) false)) false))))
(assert (forall ((?v0 Int)) (= (= (f40 (f26 f27 ?v0)) f1) (= (f39 (f8 f25 ?v0)) f1))))
(assert (not (= (f39 1) f1)))
(assert (not (= (f40 (f26 f27 (f8 f51 f36))) f1)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S10)) (= (f18 (f20 f21 ?v0) (f26 f27 (f8 f51 f36))) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S10)) (= (f18 (f20 f21 (f26 f27 (f8 f51 f36))) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (= (f43 (f8 f25 (f8 f51 ?v0))) f1) (= (f43 (f8 f25 ?v0)) f1))))
(assert (forall ((?v0 Int)) (not (= (f39 (f8 f25 (f8 f51 ?v0))) f1))))
(assert (forall ((?v0 Int)) (not (= (f40 (f26 f27 (f8 f51 ?v0))) f1))))
(assert (= (f8 f41 f36) (f8 f51 f36)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f51 ?v0) (f8 f51 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f8 f51 ?v0) (f8 f51 ?v1)) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f51 ?v0) (f8 f51 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f8 f51 ?v0) (f8 f51 ?v1)) (< ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 f51 ?v0) (f8 f51 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (= (< (f8 f51 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int)) (= (f8 f51 ?v0) (+ (+ 1 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (= f36 (f8 f51 ?v0)) false)))
(assert (forall ((?v0 Int)) (= (< f36 (f8 f51 ?v0)) (<= f36 ?v0))))
(assert (forall ((?v0 Int)) (= (<= f36 (f8 f51 ?v0)) (<= f36 ?v0))))
(assert (forall ((?v0 Int)) (= (= (f8 f51 ?v0) f36) false)))
(assert (forall ((?v0 Int)) (= (< (f8 f51 ?v0) f36) (< ?v0 f36))))
(assert (forall ((?v0 Int)) (= (<= (f8 f51 ?v0) f36) (< ?v0 f36))))
(assert (forall ((?v0 Int)) (= (- (f8 f51 ?v0)) (f8 f51 (f8 f49 (- ?v0))))))
(assert (forall ((?v0 Int)) (= (= 1 (f8 f25 ?v0)) (= (f39 (f8 f25 (+ (f8 f51 f36) (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= f52 (f26 f27 ?v0)) (= (f40 (f26 f27 (+ (f8 f51 f36) (- ?v0)))) f1))))
(assert (forall ((?v0 Int)) (= (= (f8 f25 ?v0) 1) (= (f39 (f8 f25 (+ ?v0 (- (f8 f51 f36))))) f1))))
(assert (forall ((?v0 Int)) (= (= (f26 f27 ?v0) f52) (= (f40 (f26 f27 (+ ?v0 (- (f8 f51 f36))))) f1))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
