(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (Int) S1)
(declare-fun f8 (S4 Int) S5)
(declare-fun f9 () S4)
(declare-fun f10 () S4)
(declare-fun f11 () S3)
(declare-fun f12 (Int S6) S1)
(declare-fun f13 (Int Int) S6)
(declare-fun f14 (Int) S6)
(declare-fun f15 (S6) S1)
(declare-fun f16 (S5) S1)
(declare-fun f17 (S7 S5) Int)
(declare-fun f18 () S7)
(declare-fun f19 (Int Int Int) S1)
(declare-fun f20 () S3)
(declare-fun f21 (S8 S6) S5)
(declare-fun f22 () S8)
(declare-fun f23 (Int) S6)
(declare-fun f24 (Int Int) S1)
(declare-fun f25 (Int Int) S1)
(declare-fun f26 (S6 Int) S1)
(declare-fun f27 (S10 Int) S6)
(declare-fun f28 (S9 S6) S10)
(declare-fun f29 () S6)
(declare-fun f30 () S6)
(declare-fun f31 () S2)
(declare-fun f32 (S11 Int) S7)
(declare-fun f33 () S11)
(declare-fun f34 () S3)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (- 1)) (+ (* 4 f6) 1)) 1)))
(assert (= (f7 (+ (* 4 f6) 1)) f1))
(assert (= (f7 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f7 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int)) (=> (= (f7 ?v0) f1) (= (f8 f9 ?v0) (f8 f10 (- ?v0 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f3 (f4 f11 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f3 (f4 f11 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f3 (f4 f11 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f3 (f4 f11 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f3 (f4 f11 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f3 (f4 f11 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f11 ?v0))) (=> (= (f7 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f3 ?v_0 (f3 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f7 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f12 ?v2 (f13 ?v1 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f7 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f12 ?v2 (f13 ?v1 ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f12 ?v0 (f13 ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (not (= (f12 ?v1 (f13 (- ?v0 1) ?v2)) f1)) (=> (= (f12 ?v1 (f13 ?v0 ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f3 (f4 f11 ?v2) ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f12 ?v1 (f13 (- ?v0 1) ?v2)) f1) (= (f12 ?v1 (f13 ?v0 ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 ?v1 ?v0))) (=> (= (f7 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f12 ?v2 ?v_0) f1) (= (f12 (f3 (f4 f11 ?v0) ?v2) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f13 ?v1 ?v0))) (=> (= (f7 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f12 (f3 (f4 f11 ?v0) ?v2) ?v_1) f1) (= (f12 ?v2 ?v_1) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f7 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f12 ?v2 (f13 ?v1 ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f7 ?v0) f1) (= (f14 ?v_0) (f13 ?v_0 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f15 (f13 ?v0 ?v1)) f1)))
(assert (forall ((?v0 S5)) (=> (= (f16 ?v0) f1) (= (f7 (f17 f18 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f19 (f3 (f4 f20 ?v1) (f3 (f4 f11 ?v0) ?v1)) 1 ?v0) f1))))))
(assert (forall ((?v0 Int)) (= (f8 f9 ?v0) (f21 f22 (f23 ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f7 ?v1) f1) (= (f24 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (ite (= (f19 ?v0 0 ?v1) f1) 0 (ite (= (f25 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 S9) (?v1 Int) (?v2 Int)) (=> (forall ((?v3 Int) (?v4 Int)) (= (f26 (f27 (f28 ?v0 f29) ?v3) ?v4) f1)) (=> (forall ((?v3 Int) (?v4 Int)) (let ((?v_0 (- ?v3 1))) (=> (< 1 ?v3) (=> (= (f26 (f27 (f28 ?v0 (f13 ?v_0 ?v4)) ?v_0) ?v4) f1) (= (f26 (f27 (f28 ?v0 (f13 ?v3 ?v4)) ?v3) ?v4) f1))))) (= (f26 (f27 (f28 ?v0 (f13 ?v1 ?v2)) ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f7 ?v0) f1) (= (= (f12 ?v0 f30) f1) (< 2 ?v0)))))
(assert (forall ((?v0 Int)) (=> (= (f7 ?v0) f1) (= (f19 (f3 f31 (- ?v0 1)) (- 1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (= (f19 (f3 (f4 f5 ?v1) ?v0) (f17 (f32 f33 ?v1) (f8 f10 (f3 (f4 f34 (- ?v0 1)) 2))) ?v0) f1)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f17 (f32 f33 ?v0) (f8 f10 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f8 f10 2))) (let ((?v_0 (f17 (f32 f33 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f17 (f32 f33 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f8 f10 3))) (let ((?v_0 (f17 (f32 f33 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f17 (f32 f33 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 S5)) (= (f8 f10 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f8 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f8 f10 ?v0)) 0))))
(check-sat)
(exit)
