(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 (Int Int) S1)
(assert (not (= f1 f2)))
(assert (not false))
(assert (< 2 (+ (* 4 f3) 1)))
(assert (let ((?v_0 (+ (* 4 f3) 1))) (or (= (f4 ?v_0 1) f1) (= (f4 ?v_0 2) f1))))
(assert (< 2 (+ (* 4 f3) 1)))
(assert (let ((?v_0 (+ (* 4 f3) 1))) (or (= (f4 ?v_0 1) f1) (= (f4 ?v_0 2) f1))))
(assert (forall ((?v0 Int)) (= (= (f4 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f4 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(check-sat)
(exit)
