(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (Int) S1)
(declare-fun f8 (S4 Int) S1)
(declare-fun f9 (S5 Int) S4)
(declare-fun f10 (Int) S5)
(declare-fun f11 (Int) S4)
(declare-fun f12 () S2)
(declare-fun f13 (Int S4) S1)
(declare-fun f14 (Int S4) S1)
(declare-fun f15 () S3)
(declare-fun f16 (S6 S7) Int)
(declare-fun f17 (S8 Int) S6)
(declare-fun f18 () S8)
(declare-fun f19 (S9 Int) S7)
(declare-fun f20 () S9)
(declare-fun f21 () S3)
(declare-fun f22 () S6)
(declare-fun f23 (S10 S7) S11)
(declare-fun f24 () S10)
(declare-fun f25 (S11 S7) S7)
(declare-fun f26 () S10)
(declare-fun f27 () S2)
(declare-fun f28 () S3)
(declare-fun f29 () S3)
(declare-fun f30 (Int) S5)
(declare-fun f31 (Int) S4)
(declare-fun f32 (Int) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (- 1)) (+ (* 4 f6) 1)) 1)))
(assert (= (f7 (+ (* 4 f6) 1)) f1))
(assert (= (f7 (+ (* 4 f6) 1)) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f7 ?v_0) f1) (= (f3 (f4 f5 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (ite (= (f8 (f9 (f10 ?v0) 0) ?v1) f1) 0 (ite (= (f8 (f11 ?v1) ?v0) f1) 1 (- 1))))))
(assert (= (f7 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f7 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 (f10 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (= (f8 (f9 (f10 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 (f10 ?v0) ?v1))) (= (= (f8 ?v_0 (- ?v2)) f1) (= (f8 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (f8 (f9 (f10 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 (f10 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 (f10 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f8 (f9 (f10 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f8 (f9 (f10 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f8 (f9 (f10 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (=> (= (f8 (f9 (f10 ?v3) ?v4) ?v2) f1) (= (f8 (f9 (f10 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (=> (= (f8 (f9 (f10 ?v3) ?v4) ?v2) f1) (= (f8 (f9 (f10 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 ?v0))) (=> (= (f8 (f9 ?v_0 ?v1) ?v2) f1) (=> (= (f8 (f9 (f10 ?v1) ?v3) ?v2) f1) (= (f8 (f9 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f10 ?v0))) (=> (= (f8 (f9 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f8 (f9 (f10 ?v3) ?v4) ?v2) f1) (= (f8 (f9 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (= (f8 (f9 (f10 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 ?v1))) (=> (< 2 ?v0) (=> (= (f8 (f9 ?v_0 (- 1)) ?v0) f1) (not (= (f8 (f9 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f8 (f9 (f10 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f8 (f9 (f10 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int)) (=> (= (f7 ?v0) f1) (= (f8 (f9 (f10 (f3 f12 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f8 (f9 (f10 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f8 (f9 (f10 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f8 (f9 (f10 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (= (f13 ?v0 ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f14 ?v2 ?v1) f1) (and (= (f14 ?v3 ?v1) f1) (= (f8 (f9 (f10 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f10 ?v1)) (?v_0 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 ?v_1 0) ?v0) f1)) (=> (not (= (f8 (f9 (f10 ?v2) 0) ?v0) f1)) (=> (= (f8 (f9 (f10 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) ?v0) f1) (= (f8 (f9 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (= (f8 (f9 (f10 (f3 ?v_0 (f3 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (not (= (f8 (f9 (f10 (f3 (f4 f15 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f11 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f8 (f9 (f10 (f16 (f17 f18 ?v2) (f19 f20 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 ?v1))) (=> (= (f7 ?v0) f1) (=> (< 0 ?v1) (=> (= (f8 (f9 (f10 (f3 (f4 f21 ?v1) ?v1)) 1) ?v0) f1) (or (= (f8 (f9 ?v_0 1) ?v0) f1) (= (f8 (f9 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f7 ?v0) f1) (=> (< 0 ?v1) (=> (= (f8 (f9 (f10 (f3 (f4 f21 ?v1) ?v2)) 0) ?v0) f1) (or (= (f8 (f9 (f10 ?v1) 0) ?v0) f1) (= (f8 (f9 (f10 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (= (f16 (f17 f18 ?v0) (f19 f20 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f3 (f4 f21 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f4 f21 ?v1))) (= (+ (f3 (f4 f21 (- ?v0 (f3 ?v_0 ?v2))) ?v3) (f3 (f4 f21 (- ?v4 (f3 ?v_0 ?v5))) ?v6)) (- (+ (f3 (f4 f21 ?v0) ?v3) (f3 (f4 f21 ?v4) ?v6)) (f3 ?v_0 (+ (f3 (f4 f21 ?v2) ?v3) (f3 (f4 f21 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (= (f16 (f17 f18 ?v0) ?v_0) (f16 (f17 f18 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 2)) (?v_1 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_1 ?v_0)) ?v_0) (f16 ?v_1 (f19 f20 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f3 (f4 f21 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f16 (f17 f18 ?v0) ?v_0) (f16 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f19 f20 2)) (?v_0 (f19 f20 3)) (?v_3 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0))) (= (f16 (f17 f18 (- ?v0 ?v1)) ?v_0) (- (+ (- (f16 ?v_1 ?v_0) (f3 (f4 f21 (* 3 (f16 ?v_1 ?v_2))) ?v1)) (f3 (f4 f21 (* 3 ?v0)) (f16 ?v_3 ?v_2))) (f16 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f19 f20 2)) (?v_0 (f19 f20 3)) (?v_1 (f17 f18 ?v0)) (?v_3 (f17 f18 ?v1))) (= (f16 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f16 ?v_1 ?v_0) (f3 (f4 f21 (* 3 (f16 ?v_1 ?v_2))) ?v1)) (f3 (f4 f21 (* 3 ?v0)) (f16 ?v_3 ?v_2))) (f16 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f16 (f17 f18 (- ?v0 ?v1)) ?v_0) (+ (- (f16 (f17 f18 ?v0) ?v_0) (f3 (f4 f21 (* 2 ?v0)) ?v1)) (f16 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f16 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (f16 (f17 f18 ?v0) ?v_0) (f3 (f4 f21 (* 2 ?v0)) ?v1)) (f16 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 3))) (= (f16 (f17 f18 (- ?v0)) ?v_0) (- (f16 (f17 f18 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f3 (f4 f21 ?v0) (f16 ?v_0 (f19 f20 2))) (f16 ?v_0 (f19 f20 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f15 ?v0) ?v1) (f16 (f17 f18 ?v1) (f19 f20 (- ?v0 2))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f19 f20 3))) (let ((?v_0 (f16 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f16 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f19 f20 2))) (let ((?v_0 (f16 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f16 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f16 (f17 f18 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f16 (f17 f18 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f21 (f3 (f4 f15 ?v3) ?v0)))) (=> (= (f8 (f9 (f10 (f3 (f4 f21 ?v0) ?v1)) ?v2) ?v3) f1) (= (f8 (f9 (f10 (f3 (f4 f21 (f3 ?v_0 ?v0)) ?v1)) (f3 ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f3 (f4 f21 ?v1) (f3 (f4 f15 ?v2) ?v3)))) (=> (= (f8 (f9 (f10 ?v0) ?v_0) ?v2) f1) (= (f8 (f9 (f10 (f3 (f4 f21 ?v0) ?v3)) (f3 (f4 f21 ?v_0) ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f21 ?v3)) (?v_1 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f8 (f9 (f10 ?v1) ?v2) ?v0) f1) (= (f8 (f9 (f10 (f3 ?v_0 (f3 ?v_1 ?v1))) (f3 ?v_0 (f3 ?v_1 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 (- 1)))) (let ((?v_1 (f16 ?v_0 ?v1)) (?v_2 (f16 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f8 (f9 (f10 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (= (f8 (f9 (f10 (f3 (f4 f21 ?v1) (f3 (f4 f15 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f15 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (let ((?v_2 (f3 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (= (f8 (f9 (f10 ?v_2) (f3 (f4 f21 (f3 (f4 f21 ?v1) ?v_1)) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (= (f8 (f9 (f10 (f3 (f4 f21 (f3 (f4 f15 ?v0) ?v1)) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f15 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (= (f8 (f9 (f10 (f3 (f4 f21 (f3 (f4 f21 ?v1) ?v_1)) (f3 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_2 (f10 ?v3)) (?v_0 (f4 f21 ?v1)) (?v_1 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (=> (not (= (f8 (f9 (f10 ?v2) 0) ?v0) f1)) (=> (not (= (f8 (f9 ?v_2 0) ?v0) f1)) (=> (= (f8 (f9 (f10 (f3 ?v_0 (f3 ?v_1 ?v3))) (f3 ?v_0 (f3 ?v_1 ?v2))) ?v0) f1) (= (f8 (f9 ?v_2 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f10 ?v1)) (?v_0 (f10 ?v2)) (?v_2 (f4 f21 ?v3)) (?v_3 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 ?v_1 0) ?v0) f1)) (=> (not (= (f8 (f9 ?v_0 0) ?v0) f1)) (=> (= (f8 (f9 ?v_0 (f3 ?v_2 (f3 ?v_3 ?v1))) ?v0) f1) (= (f8 (f9 ?v_1 (f3 ?v_2 (f3 ?v_3 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 (f3 (f4 f21 ?v2) ?v1)))) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (=> (= (f8 (f9 ?v_0 (f3 (f4 f21 (f3 (f4 f21 ?v3) (f3 (f4 f15 ?v0) ?v1))) ?v1)) ?v0) f1) (= (f8 (f9 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f3 (f4 f15 ?v0) ?v1))) (let ((?v_0 (f4 f21 ?v_1))) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (=> (= (f8 (f9 (f10 (f3 (f4 f21 (f3 ?v_0 ?v1)) ?v2)) (f3 ?v_0 ?v3)) ?v0) f1) (= (f8 (f9 (f10 ?v2) (f3 (f4 f21 ?v3) ?v_1)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S7)) (=> (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (= (f8 (f9 (f10 (f16 (f17 f18 ?v0) ?v3)) (f16 (f17 f18 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f3 (f4 f21 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f8 (f9 (f10 (f3 (f4 f21 ?v0) ?v_0)) 1) ?v1) f1) (= (f8 (f9 (f10 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 (f10 (f3 (f4 f21 ?v0) ?v1)) (f3 (f4 f21 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f10 ?v3))) (=> (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (= (= (f8 (f9 ?v_0 (f3 (f4 f21 ?v0) ?v4)) ?v2) f1) (= (f8 (f9 ?v_0 (f3 (f4 f21 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f10 ?v3)) (?v_1 (f4 f21 ?v4))) (=> (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (= (= (f8 (f9 ?v_0 (f3 ?v_1 ?v0)) ?v2) f1) (= (f8 (f9 ?v_0 (f3 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (= (f8 (f9 (f10 (f3 (f4 f21 ?v0) ?v3)) (f3 (f4 f21 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f21 ?v3))) (=> (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (= (f8 (f9 (f10 (f3 ?v_0 ?v0)) (f3 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f8 (f9 (f10 ?v0) ?v1) ?v2) f1) (=> (= (f8 (f9 (f10 ?v3) ?v4) ?v2) f1) (= (f8 (f9 (f10 (f3 (f4 f21 ?v0) ?v3)) (f3 (f4 f21 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f15 ?v0))) (=> (< 2 ?v0) (=> (= (f8 (f9 (f10 ?v1) ?v2) ?v0) f1) (= (f8 (f9 (f10 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (=> (not (= (f8 (f9 (f10 ?v2) 0) ?v0) f1)) (not (= (f8 (f9 (f10 (f3 (f4 f21 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f8 (f9 (f10 (f3 (f4 f21 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f7 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (not (= (f8 (f9 (f10 ?v2) 0) ?v0) f1))) (not (= (f8 (f9 (f10 (f3 (f4 f21 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 S4)) (= (= (f14 ?v0 ?v1) f1) (= (f8 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 ?v2))) (=> (= (f7 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (=> (not (= (f8 (f9 ?v_0 0) ?v0) f1)) (=> (not (= (f8 (f11 ?v0) ?v1) f1)) (not (= (f8 (f9 ?v_0 (f3 (f4 f21 ?v1) (f3 (f4 f15 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 Int)) (= (f3 f12 ?v0) (ite (<= ?v0 0) 1 (f3 (f4 f21 ?v0) (f3 f12 (- ?v0 1)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f19 f20 (+ (f16 f22 ?v1) (f16 f22 ?v2)))) (f3 (f4 f21 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f19 f20 ?v0))) (=> (< 0 ?v0) (= (f16 ?v_0 ?v_1) (f3 (f4 f21 ?v1) (f16 ?v_0 (f19 f20 (- (f16 f22 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f21 ?v0) ?v0) (f16 (f17 f18 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 S7)) (= (f25 (f23 f24 ?v0) ?v0) (f25 (f23 f26 ?v0) (f19 f20 2)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f19 f20 (+ (f16 f22 ?v1) 1))) (f3 (f4 f21 ?v0) (f16 ?v_0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 ?v_0 (f19 f20 (+ (f16 f22 ?v1) 1))) (f25 (f23 f24 ?v0) (f25 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f19 f20 (+ (f16 f22 ?v1) 1))) (f3 (f4 f21 ?v0) (f16 ?v_0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 ?v_0 (f19 f20 (+ (f16 f22 ?v1) 1))) (f25 (f23 f24 ?v0) (f25 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f19 f20 (+ (f16 f22 ?v1) 1))) (f3 (f4 f21 (f16 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 ?v_0 (f19 f20 (+ (f16 f22 ?v1) 1))) (f25 (f23 f24 (f25 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f16 (f17 f18 ?v0) (f19 f20 2)) (f3 (f4 f21 ?v0) ?v0))))
(assert (forall ((?v0 S7)) (= (f25 (f23 f26 ?v0) (f19 f20 2)) (f25 (f23 f24 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f19 f20 (f3 (f4 f21 (f16 f22 ?v1)) (f16 f22 ?v2)))) (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 ?v_0 (f19 f20 (f3 (f4 f21 (f16 f22 ?v1)) (f16 f22 ?v2)))) (f25 (f23 f26 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f19 f20 (* 2 (f16 f22 ?v1)))) (f16 (f17 f18 (f16 ?v_0 ?v1)) (f19 f20 2))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 ?v_0 (f19 f20 (* 2 (f16 f22 ?v1)))) (f25 (f23 f26 (f25 ?v_0 ?v1)) (f19 f20 2))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f19 f20 (f3 (f4 f21 (f16 f22 ?v1)) (f16 f22 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 (f23 f26 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f19 f20 (f3 (f4 f21 (f16 f22 ?v1)) (f16 f22 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f19 f20 (f3 (f4 f21 ?v0) ?v1)) (f19 f20 (f3 (f4 f21 (f16 f22 (f19 f20 (- ?v0)))) (f16 f22 (f19 f20 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f19 f20 (f3 (f4 f21 ?v0) ?v1)) (f19 f20 (f3 (f4 f21 (f16 f22 (f19 f20 ?v0))) (f16 f22 (f19 f20 ?v1))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f3 (f4 f21 (f16 f22 ?v0)) (f16 f22 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f3 (f4 f21 (f16 f22 ?v0)) (f16 f22 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f21 ?v0) ?v1))) (= (f19 f20 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f19 f20 (f3 (f4 f21 (f16 f22 (f19 f20 (ite (< ?v0 0) (- ?v0) ?v0)))) (f16 f22 (f19 f20 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f19 f20 (f16 (f17 f18 ?v0) ?v1)) (f25 (f23 f26 (f19 f20 ?v0)) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f16 (f17 f18 (f16 f22 ?v0)) ?v1) (f16 f22 (f25 (f23 f26 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f16 f22 (f25 (f23 f26 ?v0) ?v1)) (f16 (f17 f18 (f16 f22 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f19 f20 (f3 (f4 f21 (f16 f22 ?v1)) (f16 f22 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S7)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f8 (f9 (f10 (f16 ?v_0 ?v1)) 1) ?v2) f1) (= (f8 (f9 (f10 (f16 ?v_0 (f19 f20 (f3 (f4 f21 (f16 f22 ?v1)) (f16 f22 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f25 (f23 f24 (f25 ?v_0 ?v1)) (f25 (f23 f24 ?v2) ?v3)) (f25 (f23 f24 (f25 ?v_0 ?v2)) (f25 (f23 f24 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f21 ?v0))) (= (f3 (f4 f21 (f3 ?v_0 ?v1)) (f3 (f4 f21 ?v2) ?v3)) (f3 (f4 f21 (f3 ?v_0 ?v2)) (f3 (f4 f21 ?v1) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_1 (f23 f24 (f25 (f23 f24 ?v0) ?v1))) (?v_0 (f23 f24 ?v2))) (= (f25 ?v_1 (f25 ?v_0 ?v3)) (f25 ?v_0 (f25 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f4 f21 (f3 (f4 f21 ?v0) ?v1))) (?v_0 (f4 f21 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f25 (f23 f24 ?v2) ?v3))) (= (f25 (f23 f24 (f25 ?v_0 ?v1)) ?v_1) (f25 ?v_0 (f25 (f23 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f21 ?v0)) (?v_1 (f3 (f4 f21 ?v2) ?v3))) (= (f3 (f4 f21 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f21 ?v1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f25 (f23 f24 (f25 ?v_0 ?v1)) ?v2) (f25 (f23 f24 (f25 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f21 ?v0))) (= (f3 (f4 f21 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f21 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f25 (f23 f24 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f21 ?v0))) (= (f3 (f4 f21 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f21 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f25 ?v_0 (f25 (f23 f24 ?v1) ?v2)) (f25 (f23 f24 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f21 ?v0))) (= (f3 ?v_0 (f3 (f4 f21 ?v1) ?v2)) (f3 (f4 f21 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f23 f24 ?v0)) (?v_0 (f23 f24 ?v1))) (= (f25 ?v_1 (f25 ?v_0 ?v2)) (f25 ?v_0 (f25 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f4 f21 ?v0)) (?v_0 (f4 f21 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f25 (f23 f24 ?v0) ?v1) (f25 (f23 f24 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f21 ?v0) ?v1) (f3 (f4 f21 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 2))) (= (f16 (f17 f18 (f3 f27 ?v0)) ?v_0) (f16 (f17 f18 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f16 (f17 f18 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f25 (f23 f26 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f16 (f17 f18 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f25 (f23 f26 ?v0) (f19 f20 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 (f17 f18 ?v0) (f19 f20 2)))) (= (f3 f27 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f3 f27 (f16 (f17 f18 ?v0) ?v1)) (f16 (f17 f18 (f3 f27 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f21 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f21 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (let ((?v_0 (f16 f22 ?v2))) (let ((?v_1 (f4 f21 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f3 ?v_1 ?v0) (f3 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f21 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f3 (f4 f21 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f21 (- ?v0 ?v1)) ?v2) (- (f3 (f4 f21 ?v0) ?v2) (f3 (f4 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f21 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f21 ?v0) ?v2) (f3 (f4 f21 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f21 ?v0))) (= (f3 (f4 f21 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f21 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f21 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f21 (- ?v0)) ?v1) (- (f3 (f4 f21 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f21 ?v0))) (= (f3 ?v_0 (- ?v1 ?v2)) (- (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f21 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f21 ?v0) ?v1) (f3 (f4 f21 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (< 0 (f16 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f19 f20 0))))))
(assert (forall ((?v0 Int) (?v1 S7)) (<= 0 (f16 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f3 (f4 f21 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2)) (f16 ?v_0 (f19 f20 (+ (f16 f22 ?v1) (f16 f22 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 (f23 f24 (f25 ?v_0 ?v1)) (f25 ?v_0 ?v2)) (f25 ?v_0 (f19 f20 (+ (f16 f22 ?v1) (f16 f22 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f16 (f17 f18 (f3 (f4 f21 ?v0) ?v1)) ?v2) (f3 (f4 f21 (f16 (f17 f18 ?v0) ?v2)) (f16 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f25 (f23 f26 (f25 (f23 f24 ?v0) ?v1)) ?v2) (f25 (f23 f24 (f25 (f23 f26 ?v0) ?v2)) (f25 (f23 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f16 (f17 f18 (f3 (f4 f21 ?v0) ?v1)) ?v2) (f3 (f4 f21 (f16 (f17 f18 ?v0) ?v2)) (f16 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f25 (f23 f26 (f25 (f23 f24 ?v0) ?v1)) ?v2) (f25 (f23 f24 (f25 (f23 f26 ?v0) ?v2)) (f25 (f23 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f16 (f17 f18 ?v0) ?v1))) (= (f3 (f4 f21 ?v_0) ?v0) (f3 (f4 f21 ?v0) ?v_0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f25 (f23 f26 ?v0) ?v1))) (= (f25 (f23 f24 ?v_0) ?v0) (f25 (f23 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f3 (f4 f21 (f16 ?v_0 ?v1)) ?v0) (f16 ?v_0 (f19 f20 (+ (f16 f22 ?v1) 1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 (f23 f24 (f25 ?v_0 ?v1)) ?v0) (f25 ?v_0 (f19 f20 (+ (f16 f22 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f17 f18 ?v0))) (let ((?v_1 (f16 ?v_0 ?v1))) (= (f16 ?v_0 (f19 f20 (* 2 (f16 f22 ?v1)))) (f3 (f4 f21 ?v_1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f26 ?v0))) (let ((?v_1 (f25 ?v_0 ?v1))) (= (f25 ?v_0 (f19 f20 (* 2 (f16 f22 ?v1)))) (f25 (f23 f24 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f19 f20 (+ (f16 f22 ?v1) (f16 f22 ?v2)))) (f3 (f4 f21 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 ?v_0 (f19 f20 (+ (f16 f22 ?v1) (f16 f22 ?v2)))) (f25 (f23 f24 (f25 ?v_0 ?v1)) (f25 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f3 (f4 f21 ?v0) (f16 ?v_0 ?v1)) (f16 ?v_0 (f19 f20 (+ (f16 f22 ?v1) 1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 (f23 f24 ?v0) (f25 ?v_0 ?v1)) (f25 ?v_0 (f19 f20 (+ (f16 f22 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f17 f18 ?v0))) (let ((?v_1 (f16 ?v_0 ?v1))) (= (f16 ?v_0 (f19 f20 (+ (* 2 (f16 f22 ?v1)) 1))) (f3 (f4 f21 ?v0) (f3 (f4 f21 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f26 ?v0))) (let ((?v_1 (f25 ?v_0 ?v1))) (= (f25 ?v_0 (f19 f20 (+ (* 2 (f16 f22 ?v1)) 1))) (f25 (f23 f24 ?v0) (f25 (f23 f24 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f19 f20 (+ (* 2 (f16 f22 ?v1)) 1))) (f3 (f4 f21 ?v0) (f16 (f17 f18 (f16 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 ?v_0 (f19 f20 (+ (* 2 (f16 f22 ?v1)) 1))) (f25 (f23 f24 ?v0) (f25 (f23 f26 (f25 ?v_0 ?v1)) (f19 f20 2)))))))
(assert (forall ((?v0 Int)) (= (f16 (f17 f18 ?v0) (f19 f20 3)) (f3 (f4 f21 (f3 (f4 f21 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S7)) (= (f25 (f23 f26 ?v0) (f19 f20 3)) (f25 (f23 f24 (f25 (f23 f24 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f16 f22 ?v1)) (?v_1 (f16 f22 ?v0)) (?v_2 (f17 f18 ?v2))) (=> (<= ?v_1 ?v_0) (= (f16 ?v_2 (f19 f20 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f21 (f16 ?v_2 (f19 f20 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f22 ?v1)) (?v_1 (f16 f22 ?v0)) (?v_2 (f23 f26 ?v2))) (=> (<= ?v_1 ?v_0) (= (f25 ?v_2 (f19 f20 (- (+ ?v_0 1) ?v_1))) (f25 (f23 f24 (f25 ?v_2 (f19 f20 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_0 (f16 f22 ?v0)) (?v_1 (f17 f18 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f21 (f16 ?v_1 (f19 f20 (- ?v_0 1)))) ?v1) (f16 ?v_1 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f16 f22 ?v0)) (?v_1 (f23 f26 ?v1))) (=> (< 0 ?v_0) (= (f25 (f23 f24 (f25 ?v_1 (f19 f20 (- ?v_0 1)))) ?v1) (f25 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f7 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (=> (not (= (f8 (f11 ?v0) ?v1) f1)) (= (f8 (f9 (f10 (f3 f12 ?v_0)) (f16 (f17 f18 ?v1) (f19 f20 (f3 (f4 f28 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f8 (f9 (f10 (f3 (f4 f21 ?v1) (f3 (f4 f29 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (= (f8 (f9 (f10 (f3 (f4 f5 ?v1) ?v0)) (f16 (f17 f18 ?v1) (f19 f20 (f3 (f4 f28 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (let ((?v_1 (f3 (f4 f21 ?v2) ?v0))) (let ((?v_0 (- ?v1 ?v_1))) (<= (ite (< ?v_0 0) (* (- 2) ?v_0) (- (* 2 ?v1) (* 2 ?v_1))) ?v0)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f22 (f19 f20 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f19 f20 (f3 (f4 f21 ?v_0) ?v_0)) (f19 f20 (+ (f3 (f4 f21 (f16 f22 (f19 f20 (- ?v0 1)))) (f16 f22 (f19 f20 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (< 0 (f16 f22 (f25 (f23 f26 ?v0) ?v1))) (or (< 0 (f16 f22 ?v0)) (= ?v1 (f19 f20 0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f26 ?v0))) (= (f25 ?v_0 ?v1) (ite (= ?v1 (f19 f20 0)) (f19 f20 1) (f19 f20 (f3 (f4 f21 (f16 f22 ?v0)) (f16 f22 (f25 ?v_0 (f19 f20 (- (f16 f22 ?v1) 1)))))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f19 f20 0)) (?v_2 (f16 f22 ?v0)) (?v_1 (f16 f22 ?v1))) (= (f19 f20 (f3 (f4 f21 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f19 f20 (+ ?v_1 (f3 (f4 f21 (f16 f22 (f19 f20 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f16 f22 ?v0))) (= (f19 f20 (* ?v_0 2)) (f19 f20 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f19 f20 (+ 0 1)))) (= (f25 (f23 f26 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f16 f22 ?v0))) (= (f19 f20 (* 2 ?v_0)) (f19 f20 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f4 f28 (- ?v0 1)) 2))) (= (f19 f20 (* 2 (f16 f22 (f19 f20 ?v_0)))) (f19 f20 (* 2 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f19 f20 (+ 0 1)))) (= (= (f25 (f23 f26 ?v0) ?v1) ?v_0) (or (= ?v1 (f19 f20 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f26 ?v0))) (=> (< 0 (f16 f22 ?v0)) (=> (< (f16 f22 (f25 ?v_0 ?v1)) (f16 f22 (f25 ?v_0 ?v2))) (< (f16 f22 ?v1) (f16 f22 ?v2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f16 f22 ?v0)) (<= ?v_0 (f16 f22 (f25 (f23 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (f3 (f4 f21 ?v2) ?v0) ?v0)) (<= (f3 (f4 f28 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (f3 (f4 f21 ?v2) ?v0)) (< (f3 (f4 f28 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (f3 (f4 f21 ?v0) (f3 (f4 f28 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f3 (f4 f29 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f3 (f4 f29 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f3 (f4 f29 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f3 (f4 f29 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f3 (f4 f29 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f7 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f3 (f4 f29 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f29 ?v0))) (=> (= (f7 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f3 ?v_0 (f3 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (= (f8 (f9 (f10 ?v1) 0) ?v0) f1) (= (f8 (f9 (f10 0) (f16 (f17 f18 ?v1) (f19 f20 (f3 (f4 f28 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (=> (not (= (f8 (f11 ?v0) ?v1) f1)) (= (f8 (f9 (f10 (f16 (f17 f18 ?v1) (f19 f20 (f3 (f4 f28 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f7 ?v0) f1) (=> (not (= (f8 (f9 (f10 ?v1) 0) ?v0) f1)) (=> (= (f8 (f11 ?v0) ?v1) f1) (= (f8 (f9 (f10 (f16 (f17 f18 ?v1) (f19 f20 (f3 (f4 f28 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f16 (f17 f18 (f16 f22 ?v0)) ?v1) (f16 f22 (f25 (f23 f26 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f25 (f23 f26 (f19 f20 ?v0)) ?v1) (f19 f20 (f16 (f17 f18 ?v0) ?v1))))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_1 (f16 f22 ?v0)) (?v_0 (f17 f18 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f3 (f4 f28 (f16 ?v_0 ?v0)) ?v1) (f16 ?v_0 (f19 f20 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f3 (f4 f21 ?v3) ?v4) ?v5))) (=> (= (+ (f3 (f4 f21 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f4 f21 ?v0))) (=> (<= (+ (f3 ?v_0 ?v1) ?v2) (+ (f3 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f3 (f4 f21 ?v3) ?v4) ?v5))) (=> (= (+ (f3 (f4 f21 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f4 f21 ?v0))) (=> (<= (+ (f3 ?v_0 ?v1) ?v2) (+ (f3 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f3 (f4 f21 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f3 (f4 f21 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f3 (f4 f21 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f3 (f4 f21 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f3 (f4 f21 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f3 (f4 f28 ?v1) ?v2) (f3 (f4 f28 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f3 (f4 f28 ?v0) ?v2) (f3 (f4 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f3 (f4 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f3 (f4 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f3 (f4 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f3 (f4 f28 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f3 (f4 f28 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f3 (f4 f28 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f3 (f4 f28 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f3 (f4 f28 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f3 (f4 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f3 (f4 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f3 ?v_0 ?v2) (f3 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f3 (f4 f28 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f3 (f4 f28 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f3 (f4 f28 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f3 (f4 f28 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f3 (f4 f28 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 (f4 f28 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f3 (f4 f28 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f3 (f4 f28 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f3 (f4 f28 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f3 (f4 f28 ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f28 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f28 (- ?v0)) (- ?v1)) (f3 (f4 f28 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f28 ?v0) (- ?v1)) (f3 (f4 f28 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f28 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f28 0) ?v0) 0)))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (<= 0 (f16 (f17 f18 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f19 f20 (f3 (f4 f21 (f16 f22 (f19 f20 ?v0))) (f16 f22 (f19 f20 ?v1)))) (f19 f20 (f3 (f4 f21 ?v0) ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f3 (f4 f21 (f16 f22 ?v0)) (f16 f22 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (f3 (f4 f21 ?v1) ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f3 (f4 f28 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f28 ?v1))) (=> (< 0 ?v0) (= (f3 ?v_0 (f3 (f4 f21 ?v2) ?v0)) (f3 (f4 f28 (f3 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 Int) (?v2 Int)) (= (= (f8 ?v0 (f3 (f4 f28 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f8 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (f3 (f4 f21 ?v2) ?v3) ?v4)))) (= (f8 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (f3 (f4 f21 ?v2) ?v3) ?v4)))) (= (f8 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f19 f20 2)) (?v_1 (f16 f22 ?v0)) (?v_2 (f16 f22 ?v1))) (= (f19 f20 (- (f16 f22 (f25 (f23 f26 ?v0) ?v_0)) (f16 f22 (f25 (f23 f26 ?v1) ?v_0)))) (f19 f20 (f3 (f4 f21 (+ ?v_1 ?v_2)) (f16 f22 (f19 f20 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 (+ (f16 f22 ?v1) 1)))) (= (<= (f16 f22 (f25 (f23 f26 ?v0) ?v_0)) (f16 f22 (f25 (f23 f26 ?v2) ?v_0))) (<= (f16 f22 ?v0) (f16 f22 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 (+ (f16 f22 ?v1) 1)))) (= (< (f16 f22 (f25 (f23 f26 ?v0) ?v_0)) (f16 f22 (f25 (f23 f26 ?v2) ?v_0))) (< (f16 f22 ?v0) (f16 f22 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f19 f20 1))) (= (= (f19 f20 (f3 (f4 f21 (f16 f22 ?v0)) (f16 f22 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f19 f20 0))) (= (= (f25 (f23 f26 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f19 f20 1))) (= (= (f25 (f23 f26 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f19 f20 0)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 (+ (f16 f22 ?v1) 1)))) (= (= (f25 (f23 f26 ?v0) ?v_0) (f25 (f23 f26 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (< 0 (f16 f22 (f25 (f23 f26 ?v0) ?v1))) (or (= ?v1 (f19 f20 0)) (< 0 (f16 f22 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 (f30 ?v1) ?v0))) (=> (= (f7 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f14 ?v2 ?v_0) f1) (= (f14 (f3 (f4 f29 ?v0) ?v2) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (not (= (f14 ?v1 (f9 (f30 (- ?v0 1)) ?v2)) f1)) (=> (= (f14 ?v1 (f9 (f30 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f3 (f4 f29 ?v2) ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f14 ?v0 (f9 (f30 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f14 ?v1 (f9 (f30 (- ?v0 1)) ?v2)) f1) (= (f14 ?v1 (f9 (f30 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f7 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f14 ?v2 (f9 (f30 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f7 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f14 ?v2 (f9 (f30 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f7 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f14 ?v2 (f9 (f30 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f9 (f30 ?v1) ?v0))) (=> (= (f7 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f14 (f3 (f4 f29 ?v0) ?v2) ?v_1) f1) (= (f14 ?v2 ?v_1) f1))))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f7 ?v0) f1) (= (f31 ?v_0) (f9 (f30 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f32 ?v0) f1) (=> (= (f32 ?v1) f1) (= (f32 (f3 (f4 f21 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0 (f31 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0 (f31 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f14 ?v1 (f31 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f14 ?v0 (f31 ?v1)) f1)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f16 f22 ?v0))) (<= ?v_0 (f3 (f4 f21 ?v_0) ?v_0)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f16 f22 ?v0))) (let ((?v_1 (f4 f21 ?v_0))) (<= ?v_0 (f3 ?v_1 (f3 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1)) (?v_2 (f16 f22 ?v0)) (?v_1 (f16 f22 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f3 (f4 f21 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1)) (?v_1 (f16 f22 ?v0)) (?v_2 (f16 f22 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f3 (f4 f21 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1)) (?v_1 (f16 f22 ?v0)) (?v_2 (f16 f22 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f3 (f4 f21 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= ?v0 (f19 f20 (f3 (f4 f21 (f16 f22 ?v0)) (f16 f22 ?v1)))) (or (= ?v1 (f19 f20 1)) (= ?v0 (f19 f20 0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_2 (f16 f22 ?v1)) (?v_0 (f16 f22 ?v0)) (?v_3 (f16 f22 ?v3)) (?v_1 (f16 f22 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f3 (f4 f21 ?v_0) ?v_1) (f3 (f4 f21 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_3 (f16 f22 ?v1)) (?v_1 (f16 f22 ?v0)) (?v_0 (f16 f22 ?v2))) (let ((?v_2 (f4 f21 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f3 ?v_2 ?v_1) (f3 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_2 (f16 f22 ?v1)) (?v_0 (f16 f22 ?v0)) (?v_1 (f16 f22 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f3 (f4 f21 ?v_0) ?v_1) (f3 (f4 f21 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_2 (f16 f22 ?v1)) (?v_0 (f16 f22 ?v0)) (?v_1 (f4 f21 (f16 f22 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f3 ?v_1 ?v_0) (f3 ?v_1 ?v_2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f16 f22 ?v1)) (?v_0 (f16 f22 ?v0)) (?v_2 (f16 f22 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f3 (f4 f21 ?v_0) ?v_2) (f3 (f4 f21 ?v_1) ?v_2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f4 f21 (+ (f16 f22 ?v0) 1))) (?v_2 (f16 f22 ?v2)) (?v_1 (f16 f22 ?v1))) (= (<= (f3 ?v_0 ?v_1) (f3 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f4 f21 (+ (f16 f22 ?v0) 1))) (?v_2 (f16 f22 ?v2)) (?v_1 (f16 f22 ?v1))) (= (< (f3 ?v_0 ?v_1) (f3 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f4 f21 (+ (f16 f22 ?v0) 1)))) (= (= (f19 f20 (f3 ?v_0 (f16 f22 ?v1))) (f19 f20 (f3 ?v_0 (f16 f22 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f22 ?v1))) (= (= (f19 f20 (f3 (f4 f21 (f16 f22 ?v0)) ?v_0)) (f19 f20 (f3 (f4 f21 (f16 f22 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f19 f20 0)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f4 f21 (f16 f22 ?v0)))) (= (= (f19 f20 (f3 ?v_0 (f16 f22 ?v1))) (f19 f20 (f3 ?v_0 (f16 f22 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f19 f20 0)))))))
(assert (forall ((?v0 S7)) (= (f19 f20 (f16 f22 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f22 (f19 f20 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f22 (f19 f20 ?v0)) 0))))
(check-sat)
(exit)
