(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 Int) S1)
(declare-fun f6 (S3 Int) S2)
(declare-fun f7 (Int) S3)
(declare-fun f8 () Int)
(declare-fun f9 (Int) S1)
(declare-fun f10 (S4 Int) Int)
(declare-fun f11 (S5 Int) S4)
(declare-fun f12 () S5)
(declare-fun f13 (S6 S7) Int)
(declare-fun f14 (S8 Int) S6)
(declare-fun f15 () S8)
(declare-fun f16 (S9 Int) S7)
(declare-fun f17 () S9)
(declare-fun f18 (Int) S2)
(declare-fun f19 () S4)
(declare-fun f20 () S5)
(declare-fun f21 () S4)
(declare-fun f22 (S10 S7) S7)
(declare-fun f23 (S11 S7) S10)
(declare-fun f24 () S11)
(declare-fun f25 () S6)
(declare-fun f26 (Int S2) S1)
(declare-fun f27 (Int S2) S1)
(declare-fun f28 () S5)
(declare-fun f29 () S5)
(declare-fun f30 () S11)
(declare-fun f31 () S5)
(declare-fun f32 (Int) S3)
(declare-fun f33 (Int) S2)
(declare-fun f34 (Int) S1)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f5 (f6 (f7 f8) ?v0) ?v_0) f1))) (= f3 f1)))))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f5 (f6 (f7 f8) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f5 (f6 (f7 f8) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f5 (f6 (f7 f8) ?v0) ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f5 (f6 (f7 f8) ?v1) ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (= (f9 (+ (* 4 f4) 1)) f1))
(assert (= (f10 (f11 f12 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (= (f5 (f6 (f7 (f13 (f14 f15 f8) (f16 f17 2))) (- 1)) (+ (* 4 f4) 1)) f1))
(assert (= (f5 (f18 (+ (* 4 f4) 1)) (- 1)) f1))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f5 (f18 ?v_0) (- 1)) f1)) (not (= (f10 (f11 f12 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f5 (f6 (f7 (f13 (f14 f15 ?v0) (f16 f17 2))) (- 1)) (+ (* 4 f4) 1)) f1) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f5 (f6 (f7 ?v0) ?v1) 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f5 (f6 (f7 ?v1) ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 (f7 ?v0) ?v1))) (= (= (f5 ?v_0 (- ?v2)) f1) (= (f5 ?v_0 ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (f5 (f6 (f7 ?v0) 0) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 (f7 ?v0) ?v1) 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 (f7 ?v0) ?v0) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f5 (f6 (f7 ?v0) 0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f5 (f6 (f7 ?v0) ?v2) ?v1) f1))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f9 ?v_0) f1) (= (f10 (f11 f12 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S7)) (=> (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f5 (f6 (f7 (f13 (f14 f15 ?v0) ?v3)) (f13 (f14 f15 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (=> (= (f5 (f6 (f7 ?v3) ?v4) ?v2) f1) (= (f5 (f6 (f7 (- ?v0 ?v3)) (- ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (=> (= (f5 (f6 (f7 ?v3) ?v4) ?v2) f1) (= (f5 (f6 (f7 (+ ?v0 ?v3)) (+ ?v1 ?v4)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 ?v0))) (=> (= (f5 (f6 ?v_0 ?v1) ?v2) f1) (=> (= (f5 (f6 (f7 ?v1) ?v3) ?v2) f1) (= (f5 (f6 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f7 ?v0))) (=> (= (f5 (f6 ?v_0 ?v1) ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f5 (f6 (f7 ?v3) ?v4) ?v2) f1) (= (f5 (f6 ?v_0 ?v4) ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f5 (f6 (f7 (+ ?v0 ?v3)) (+ ?v1 ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 ?v1))) (=> (< 2 ?v0) (=> (= (f5 (f6 ?v_0 (- 1)) ?v0) f1) (not (= (f5 (f6 ?v_0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f5 (f6 (f7 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f5 (f6 (f7 ?v0) 0) ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f5 (f6 (f7 ?v0) ?v2) ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 ?v0) ?v1) (ite (= (f5 (f6 (f7 ?v0) 0) ?v1) f1) 0 (ite (= (f5 (f18 ?v1) ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f5 (f18 ?v0) ?v1) f1) (exists ((?v2 Int)) (= (f5 (f6 (f7 (f13 (f14 f15 ?v2) (f16 f17 2))) ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f15 (- 1)))) (let ((?v_1 (f13 ?v_0 ?v1)) (?v_2 (f13 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f5 (f6 (f7 ?v_1) ?v_2) ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (and (and (<= 0 ?v2) (and (< ?v2 ?v0) (= (f5 (f6 (f7 ?v1) ?v2) ?v0) f1))) (forall ((?v3 Int)) (=> (and (<= 0 ?v3) (and (< ?v3 ?v0) (= (f5 (f6 (f7 ?v1) ?v3) ?v0) f1))) (= ?v3 ?v2))))))))
(assert (= (f9 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S7)) (<= 0 (f13 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f13 (f14 f15 ?v0) (f16 f17 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f16 f17 2))) (let ((?v_0 (f13 (f14 f15 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f13 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f16 f17 3))) (let ((?v_0 (f13 (f14 f15 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f13 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f5 (f6 (f7 1) (- 1)) ?v0) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f13 (f14 f15 ?v0) (f16 f17 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f13 (f14 f15 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (= (f13 (f14 f15 ?v0) ?v_0) (f13 (f14 f15 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 2)) (?v_1 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_1 ?v_0)) ?v_0) (f13 ?v_1 (f16 f17 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 3))) (= (f13 (f14 f15 (- ?v0)) ?v_0) (- (f13 (f14 f15 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (< 0 (f13 (f14 f15 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f16 f17 0))))))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (= (f5 (f6 (f7 (f10 f19 (- ?v0 1))) (- 1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (<= 0 (f13 (f14 f15 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (= (f5 (f6 (f7 (f10 (f11 f12 ?v1) ?v0)) (f13 (f14 f15 ?v1) (f16 f17 (f10 (f11 f20 (- ?v0 1)) 2)))) ?v0) f1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 2))) (= (f13 (f14 f15 (f10 f21 ?v0)) ?v_0) (f13 (f14 f15 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f13 (f14 f15 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f22 (f23 f24 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f13 (f14 f15 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f22 (f23 f24 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 (f14 f15 ?v0) (f16 f17 2)))) (= (f10 f21 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (f10 f21 (f13 (f14 f15 ?v0) ?v1)) (f13 (f14 f15 (f10 f21 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f22 (f23 f24 (f16 f17 ?v0)) ?v1) (f16 f17 (f13 (f14 f15 ?v0) ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f13 (f14 f15 (f13 f25 ?v0)) ?v1) (f13 f25 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f13 f25 (f22 (f23 f24 ?v0) ?v1)) (f13 (f14 f15 (f13 f25 ?v0)) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f13 (f14 f15 (f13 f25 ?v0)) ?v1) (f13 f25 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S7)) (=> (<= 0 ?v0) (= (f16 f17 (f13 (f14 f15 ?v0) ?v1)) (f22 (f23 f24 (f16 f17 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (= (f5 (f6 (f7 ?v1) 0) ?v0) f1) (= (f5 (f6 (f7 0) (f13 (f14 f15 ?v1) (f16 f17 (f10 (f11 f20 (- ?v0 1)) 2)))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f5 (f18 ?v0) ?v1) f1)) (= (f5 (f6 (f7 (f10 f19 ?v_0)) (f13 (f14 f15 ?v1) (f16 f17 (f10 (f11 f20 ?v_0) 2)))) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f5 (f18 ?v0) ?v1) f1)) (= (f5 (f6 (f7 (f13 (f14 f15 ?v1) (f16 f17 (f10 (f11 f20 (- ?v0 1)) 2)))) (- 1)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (= (f5 (f18 ?v0) ?v1) f1) (= (f5 (f6 (f7 (f13 (f14 f15 ?v1) (f16 f17 (f10 (f11 f20 (- ?v0 1)) 2)))) 1) ?v0) f1)))))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_1 (f13 f25 ?v0)) (?v_0 (f14 f15 ?v1))) (=> (< 0 ?v_1) (=> (< 0 ?v1) (= (f10 (f11 f20 (f13 ?v_0 ?v0)) ?v1) (f13 ?v_0 (f16 f17 (- ?v_1 (+ 0 1))))))))))
(assert (forall ((?v0 Int)) (= (f10 (f11 f20 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f10 (f11 f20 ?v0) (- 1)) (- ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f20 ?v0) (- ?v1)) (f10 (f11 f20 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f20 (- ?v0)) (- ?v1)) (f10 (f11 f20 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f11 f20 ?v0) ?v1) 0) (or (= ?v1 0) (or (and (<= 0 ?v0) (< ?v0 ?v1)) (and (<= ?v0 0) (< ?v1 ?v0)))))))
(assert (forall ((?v0 Int)) (=> (not (= ?v0 0)) (= (f10 (f11 f20 ?v0) ?v0) 1))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f13 f25 ?v0)) (<= ?v_0 (f13 f25 (f22 (f23 f24 ?v0) ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (=> (< 0 (f13 f25 ?v0)) (=> (< (f13 f25 (f22 ?v_0 ?v1)) (f13 f25 (f22 ?v_0 ?v2))) (< (f13 f25 ?v1) (f13 f25 ?v2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f16 f17 (+ 0 1)))) (= (= (f22 (f23 f24 ?v0) ?v1) ?v_0) (or (= ?v1 (f16 f17 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f16 f17 (+ 0 1)))) (= (f22 (f23 f24 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (< 0 (f13 f25 (f22 (f23 f24 ?v0) ?v1))) (or (< 0 (f13 f25 ?v0)) (= ?v1 (f16 f17 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 0) (<= (f10 (f11 f20 ?v1) ?v2) (f10 (f11 f20 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f26 ?v0 ?v1) f1) (= (f5 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< 0 ?v2) (<= (f10 (f11 f20 ?v0) ?v2) (f10 (f11 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f10 (f11 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f20 ?v0))) (=> (< ?v0 0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< 0 ?v1) (<= (f10 (f11 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f10 (f11 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (< (f10 (f11 f20 ?v1) ?v0) 0) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f10 (f11 f20 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f10 (f11 f20 (+ ?v1 1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (= (<= 0 (f10 (f11 f20 ?v1) ?v0)) (<= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= (+ ?v0 ?v1) 0) (= (f10 (f11 f20 ?v0) ?v1) (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f10 (f11 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v1 0) (<= (f10 (f11 f20 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f20 ?v0))) (=> (<= 0 ?v0) (=> (< 0 ?v1) (=> (<= ?v1 ?v2) (<= (f10 ?v_0 ?v2) (f10 ?v_0 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 1 ?v1) (< (f10 (f11 f20 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f10 (f11 f20 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< (f10 (f11 f20 ?v1) ?v0) 0) (< ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f10 (f11 f20 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (f10 (f11 f20 ?v1) ?v0)))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f10 (f11 f20 (- 1)) ?v0) (- 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (< 0 (f10 (f11 f20 ?v0) ?v1)) (and (<= ?v1 ?v0) (< 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (< 0 (f10 (f11 f20 ?v1) ?v0)) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (<= 0 (f10 (f11 f20 ?v1) ?v0)) (<= 0 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 (+ (f13 f25 ?v1) 1)))) (= (<= (f13 f25 (f22 (f23 f24 ?v0) ?v_0)) (f13 f25 (f22 (f23 f24 ?v2) ?v_0))) (<= (f13 f25 ?v0) (f13 f25 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 (+ (f13 f25 ?v1) 1)))) (= (< (f13 f25 (f22 (f23 f24 ?v0) ?v_0)) (f13 f25 (f22 (f23 f24 ?v2) ?v_0))) (< (f13 f25 ?v0) (f13 f25 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f16 f17 (+ (f13 f25 ?v1) 1)))) (= (= (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v2) ?v_0)) (= ?v0 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f16 f17 1))) (= (= (f22 (f23 f24 ?v0) ?v1) ?v_0) (or (= ?v0 ?v_0) (= ?v1 (f16 f17 0)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f16 f17 0))) (= (= (f22 (f23 f24 ?v0) ?v1) ?v_0) (and (not (= ?v1 ?v_0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (< 0 (f13 f25 (f22 (f23 f24 ?v0) ?v1))) (or (= ?v1 (f16 f17 0)) (< 0 (f13 f25 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f27 ?v0 ?v1) f1) (forall ((?v2 Int) (?v3 Int)) (=> (and (= (f26 ?v2 ?v1) f1) (and (= (f26 ?v3 ?v1) f1) (= (f5 (f6 (f7 ?v2) ?v3) ?v0) f1))) (= ?v2 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (not (= (f5 (f6 (f7 (f10 (f11 f28 ?v0) ?v1)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (= (f5 (f6 (f7 (f10 ?v_0 (f10 ?v_0 ?v1))) ?v1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f7 ?v1)) (?v_0 (f11 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 ?v_1 0) ?v0) f1)) (=> (not (= (f5 (f6 (f7 ?v2) 0) ?v0) f1)) (=> (= (f5 (f6 (f7 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) ?v0) f1) (= (f5 (f6 ?v_1 ?v2) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f5 (f6 (f7 ?v1) ?v2) ?v0) f1) (= (f5 (f6 (f7 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f28 ?v0) ?v1) (f13 (f14 f15 ?v1) (f16 f17 (- ?v0 2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 ?v2))) (=> (= (f9 ?v0) f1) (=> (< 2 ?v0) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f5 (f6 ?v_0 0) ?v0) f1)) (=> (not (= (f5 (f18 ?v0) ?v1) f1)) (not (= (f5 (f6 ?v_0 (f10 (f11 f29 ?v1) (f10 (f11 f28 ?v0) ?v2))) ?v0) f1))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (= (f5 (f6 (f7 (f10 (f11 f29 ?v1) (f10 (f11 f28 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f28 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (let ((?v_2 (f10 ?v_0 ?v_1))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (= (f5 (f6 (f7 ?v_2) (f10 (f11 f29 (f10 (f11 f29 ?v1) ?v_1)) ?v_2)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (= (f5 (f6 (f7 (f10 (f11 f29 (f10 (f11 f28 ?v0) ?v1)) ?v1)) 1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f28 ?v0))) (let ((?v_1 (f10 ?v_0 ?v1))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (= (f5 (f6 (f7 (f10 (f11 f29 (f10 (f11 f29 ?v1) ?v_1)) (f10 ?v_0 ?v_1))) ?v1) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f5 (f6 (f7 (f10 (f11 f29 ?v0) ?v_0)) 1) ?v1) f1) (= (f5 (f6 (f7 ?v0) ?v_0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f10 (f11 f29 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f5 (f6 (f7 (f10 (f11 f29 ?v0) ?v1)) (f10 (f11 f29 ?v2) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f7 ?v3))) (=> (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (= (f5 (f6 ?v_0 (f10 (f11 f29 ?v0) ?v4)) ?v2) f1) (= (f5 (f6 ?v_0 (f10 (f11 f29 ?v1) ?v4)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f7 ?v3)) (?v_1 (f11 f29 ?v4))) (=> (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (= (f5 (f6 ?v_0 (f10 ?v_1 ?v0)) ?v2) f1) (= (f5 (f6 ?v_0 (f10 ?v_1 ?v1)) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f5 (f6 (f7 (f10 (f11 f29 ?v0) ?v3)) (f10 (f11 f29 ?v1) ?v3)) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f29 ?v3))) (=> (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (= (f5 (f6 (f7 (f10 ?v_0 ?v0)) (f10 ?v_0 ?v1)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f5 (f6 (f7 ?v0) ?v1) ?v2) f1) (=> (= (f5 (f6 (f7 ?v3) ?v4) ?v2) f1) (= (f5 (f6 (f7 (f10 (f11 f29 ?v0) ?v3)) (f10 (f11 f29 ?v1) ?v4)) ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (= (= (f5 ?v0 (f10 (f11 f20 ?v1) ?v2)) f1) (and (=> (= ?v2 0) (= (f5 ?v0 0) f1)) (and (=> (< 0 ?v2) (forall ((?v3 Int) (?v4 Int)) (=> (and (<= 0 ?v4) (and (< ?v4 ?v2) (= ?v1 (+ (f10 (f11 f29 ?v2) ?v3) ?v4)))) (= (f5 ?v0 ?v3) f1)))) (=> (< ?v2 0) (forall ((?v3 Int) (?v4 Int)) (=> (and (< ?v2 ?v4) (and (<= ?v4 0) (= ?v1 (+ (f10 (f11 f29 ?v2) ?v3) ?v4)))) (= (f5 ?v0 ?v3) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f20 ?v1))) (=> (< 0 ?v0) (= (f10 ?v_0 (f10 (f11 f29 ?v2) ?v0)) (f10 (f11 f20 (f10 ?v_0 ?v2)) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= ?v0 (+ (f10 (f11 f29 ?v1) ?v2) ?v3)) (=> (ite (< 0 ?v1) (and (<= 0 ?v3) (< ?v3 ?v1)) (and (< ?v1 ?v3) (<= ?v3 0))) (=> (not (= ?v1 0)) (= (f10 (f11 f20 ?v0) ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= (f10 (f11 f29 ?v0) (f10 (f11 f20 ?v1) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (f10 (f11 f29 ?v2) ?v0)) (< (f10 (f11 f20 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 (+ (f10 (f11 f29 ?v2) ?v0) ?v0)) (<= (f10 (f11 f20 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f10 (f11 f29 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f13 (f14 f15 ?v0) ?v_0) (f13 (f14 f15 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f16 f17 2)) (?v_0 (f16 f17 3)) (?v_3 (f14 f15 ?v1)) (?v_1 (f14 f15 ?v0))) (= (f13 (f14 f15 (- ?v0 ?v1)) ?v_0) (- (+ (- (f13 ?v_1 ?v_0) (f10 (f11 f29 (* 3 (f13 ?v_1 ?v_2))) ?v1)) (f10 (f11 f29 (* 3 ?v0)) (f13 ?v_3 ?v_2))) (f13 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f16 f17 2)) (?v_0 (f16 f17 3)) (?v_1 (f14 f15 ?v0)) (?v_3 (f14 f15 ?v1))) (= (f13 (f14 f15 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f13 ?v_1 ?v_0) (f10 (f11 f29 (* 3 (f13 ?v_1 ?v_2))) ?v1)) (f10 (f11 f29 (* 3 ?v0)) (f13 ?v_3 ?v_2))) (f13 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f13 (f14 f15 (- ?v0 ?v1)) ?v_0) (+ (- (f13 (f14 f15 ?v0) ?v_0) (f10 (f11 f29 (* 2 ?v0)) ?v1)) (f13 (f14 f15 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (f13 (f14 f15 (+ ?v0 ?v1)) ?v_0) (+ (+ (f13 (f14 f15 ?v0) ?v_0) (f10 (f11 f29 (* 2 ?v0)) ?v1)) (f13 (f14 f15 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 ?v0))) (= (f10 (f11 f29 ?v0) (f13 ?v_0 (f16 f17 2))) (f13 ?v_0 (f16 f17 3))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (+ (f13 f25 ?v1) (f13 f25 ?v2)))) (f10 (f11 f29 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 ?v1)) (?v_1 (f16 f17 ?v0))) (=> (< 0 ?v0) (= (f13 ?v_0 ?v_1) (f10 (f11 f29 ?v1) (f13 ?v_0 (f16 f17 (- (f13 f25 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f16 f17 (* 2 (f13 f25 ?v1)))) (f10 (f11 f29 ?v_1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f16 f17 (* 2 (f13 f25 ?v1)))) (f22 (f23 f30 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f16 f17 (+ (* 2 (f13 f25 ?v1)) 1))) (f10 (f11 f29 ?v0) (f10 (f11 f29 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f16 f17 (+ (* 2 (f13 f25 ?v1)) 1))) (f22 (f23 f30 ?v0) (f22 (f23 f30 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (+ (* 2 (f13 f25 ?v1)) 1))) (f10 (f11 f29 ?v0) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f16 f17 2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f16 f17 (+ (* 2 (f13 f25 ?v1)) 1))) (f22 (f23 f30 ?v0) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f16 f17 2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f10 (f11 f29 ?v3) ?v4) ?v5))) (=> (= (+ (f10 (f11 f29 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f11 f29 ?v0))) (=> (<= (+ (f10 ?v_0 ?v1) ?v2) (+ (f10 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f10 (f11 f29 ?v3) ?v4) ?v5))) (=> (= (+ (f10 (f11 f29 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f11 f29 ?v0))) (=> (<= (+ (f10 ?v_0 ?v1) ?v2) (+ (f10 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f10 (f11 f29 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f10 (f11 f29 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f10 (f11 f29 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f10 (f11 f29 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f11 f29 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f11 f29 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (let ((?v_0 (f13 f25 ?v2))) (let ((?v_1 (f11 f29 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f10 ?v_1 ?v0) (f10 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f29 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f10 (f11 f29 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f10 (f11 f29 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f29 (- ?v0 ?v1)) ?v2) (- (f10 (f11 f29 ?v0) ?v2) (f10 (f11 f29 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f29 (+ ?v0 ?v1)) ?v2) (+ (f10 (f11 f29 ?v0) ?v2) (f10 (f11 f29 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f29 ?v0))) (= (f10 (f11 f29 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f11 f29 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f29 (- ?v0)) ?v1) (- (f10 (f11 f29 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f29 ?v0))) (= (f10 ?v_0 (- ?v1 ?v2)) (- (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f29 ?v0))) (= (f10 ?v_0 (+ ?v1 ?v2)) (+ (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f29 ?v0) ?v1) (f10 (f11 f29 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f11 f29 ?v1))) (= (+ (f10 (f11 f29 (- ?v0 (f10 ?v_0 ?v2))) ?v3) (f10 (f11 f29 (- ?v4 (f10 ?v_0 ?v5))) ?v6)) (- (+ (f10 (f11 f29 ?v0) ?v3) (f10 (f11 f29 ?v4) ?v6)) (f10 ?v_0 (+ (f10 (f11 f29 ?v2) ?v3) (f10 (f11 f29 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f10 (f11 f29 ?v0) ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f23 f30 ?v0))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) (f22 (f23 f30 ?v2) ?v3)) (f22 (f23 f30 (f22 ?v_0 ?v2)) (f22 (f23 f30 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f29 ?v0))) (= (f10 (f11 f29 (f10 ?v_0 ?v1)) (f10 (f11 f29 ?v2) ?v3)) (f10 (f11 f29 (f10 ?v_0 ?v2)) (f10 (f11 f29 ?v1) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_1 (f23 f30 (f22 (f23 f30 ?v0) ?v1))) (?v_0 (f23 f30 ?v2))) (= (f22 ?v_1 (f22 ?v_0 ?v3)) (f22 ?v_0 (f22 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f11 f29 (f10 (f11 f29 ?v0) ?v1))) (?v_0 (f11 f29 ?v2))) (= (f10 ?v_1 (f10 ?v_0 ?v3)) (f10 ?v_0 (f10 ?v_1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f23 f30 ?v0)) (?v_1 (f22 (f23 f30 ?v2) ?v3))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v_1) (f22 ?v_0 (f22 (f23 f30 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f29 ?v0)) (?v_1 (f10 (f11 f29 ?v2) ?v3))) (= (f10 (f11 f29 (f10 ?v_0 ?v1)) ?v_1) (f10 ?v_0 (f10 (f11 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f30 ?v0))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v2) (f22 (f23 f30 (f22 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f29 ?v0))) (= (f10 (f11 f29 (f10 ?v_0 ?v1)) ?v2) (f10 (f11 f29 (f10 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f30 ?v0))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f23 f30 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f29 ?v0))) (= (f10 (f11 f29 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f30 ?v0))) (= (f22 ?v_0 (f22 (f23 f30 ?v1) ?v2)) (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f29 ?v0))) (= (f10 ?v_0 (f10 (f11 f29 ?v1) ?v2)) (f10 (f11 f29 (f10 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f23 f30 ?v0)) (?v_0 (f23 f30 ?v1))) (= (f22 ?v_1 (f22 ?v_0 ?v2)) (f22 ?v_0 (f22 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f11 f29 ?v0)) (?v_0 (f11 f29 ?v1))) (= (f10 ?v_1 (f10 ?v_0 ?v2)) (f10 ?v_0 (f10 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f22 (f23 f30 ?v0) ?v1) (f22 (f23 f30 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f29 ?v0) ?v1) (f10 (f11 f29 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (f10 (f11 f29 ?v0) ?v0) (f13 (f14 f15 ?v0) (f16 f17 2)))))
(assert (forall ((?v0 S7)) (= (f22 (f23 f30 ?v0) ?v0) (f22 (f23 f24 ?v0) (f16 f17 2)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (+ (f13 f25 ?v1) 1))) (f10 (f11 f29 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f16 f17 (+ (f13 f25 ?v1) 1))) (f22 (f23 f30 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (+ (f13 f25 ?v1) 1))) (f10 (f11 f29 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f16 f17 (+ (f13 f25 ?v1) 1))) (f22 (f23 f30 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (+ (f13 f25 ?v1) 1))) (f10 (f11 f29 (f13 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f16 f17 (+ (f13 f25 ?v1) 1))) (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int)) (= (f13 (f14 f15 ?v0) (f16 f17 2)) (f10 (f11 f29 ?v0) ?v0))))
(assert (forall ((?v0 S7)) (= (f22 (f23 f24 ?v0) (f16 f17 2)) (f22 (f23 f30 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f13 (f14 f15 ?v0) (f16 f17 3)) (f10 (f11 f29 (f10 (f11 f29 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S7)) (= (f22 (f23 f24 ?v0) (f16 f17 3)) (f22 (f23 f30 (f22 (f23 f30 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f10 (f11 f29 ?v0) (f13 ?v_0 ?v1)) (f13 ?v_0 (f16 f17 (+ (f13 f25 ?v1) 1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f30 ?v0) (f22 ?v_0 ?v1)) (f22 ?v_0 (f16 f17 (+ (f13 f25 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (+ (f13 f25 ?v1) (f13 f25 ?v2)))) (f10 (f11 f29 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f16 f17 (+ (f13 f25 ?v1) (f13 f25 ?v2)))) (f22 (f23 f30 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f10 (f11 f29 (f13 ?v_0 ?v1)) ?v0) (f13 ?v_0 (f16 f17 (+ (f13 f25 ?v1) 1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) ?v0) (f22 ?v_0 (f16 f17 (+ (f13 f25 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f13 (f14 f15 ?v0) ?v1))) (= (f10 (f11 f29 ?v_0) ?v0) (f10 (f11 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f22 (f23 f24 ?v0) ?v1))) (= (f22 (f23 f30 ?v_0) ?v0) (f22 (f23 f30 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f13 (f14 f15 (f10 (f11 f29 ?v0) ?v1)) ?v2) (f10 (f11 f29 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f22 (f23 f24 (f22 (f23 f30 ?v0) ?v1)) ?v2) (f22 (f23 f30 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (= (f13 (f14 f15 (f10 (f11 f29 ?v0) ?v1)) ?v2) (f10 (f11 f29 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (f22 (f23 f24 (f22 (f23 f30 ?v0) ?v1)) ?v2) (f22 (f23 f30 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f10 (f11 f29 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2)) (f13 ?v_0 (f16 f17 (+ (f13 f25 ?v1) (f13 f25 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f30 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2)) (f22 ?v_0 (f16 f17 (+ (f13 f25 ?v1) (f13 f25 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f5 (f6 (f7 ?v2) 0) ?v0) f1)) (not (= (f5 (f6 (f7 (f10 (f11 f29 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f5 (f6 (f7 (f10 (f11 f29 ?v1) ?v1)) 1) ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (not (= (f5 (f6 (f7 ?v2) 0) ?v0) f1))) (not (= (f5 (f6 (f7 (f10 (f11 f29 ?v1) ?v2)) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (= (f5 (f6 (f7 (f10 (f11 f29 ?v1) ?v2)) 0) ?v0) f1) (or (= (f5 (f6 (f7 ?v1) 0) ?v0) f1) (= (f5 (f6 (f7 ?v2) 0) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 ?v1))) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (= (f5 (f6 (f7 (f10 (f11 f29 ?v1) ?v1)) 1) ?v0) f1) (or (= (f5 (f6 ?v_0 1) ?v0) f1) (= (f5 (f6 ?v_0 (- ?v0 1)) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f29 (f10 (f11 f28 ?v3) ?v0)))) (=> (= (f5 (f6 (f7 (f10 (f11 f29 ?v0) ?v1)) ?v2) ?v3) f1) (= (f5 (f6 (f7 (f10 (f11 f29 (f10 ?v_0 ?v0)) ?v1)) (f10 ?v_0 ?v2)) ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 (f11 f29 ?v1) (f10 (f11 f28 ?v2) ?v3)))) (=> (= (f5 (f6 (f7 ?v0) ?v_0) ?v2) f1) (= (f5 (f6 (f7 (f10 (f11 f29 ?v0) ?v3)) (f10 (f11 f29 ?v_0) ?v3)) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f11 f29 ?v3)) (?v_1 (f11 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f5 (f6 (f7 ?v1) ?v2) ?v0) f1) (= (f5 (f6 (f7 (f10 ?v_0 (f10 ?v_1 ?v1))) (f10 ?v_0 (f10 ?v_1 ?v2))) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f10 (f11 f28 ?v0) ?v1))) (let ((?v_0 (f11 f29 ?v_1))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (= (f5 (f6 (f7 (f10 (f11 f29 (f10 ?v_0 ?v1)) ?v2)) (f10 ?v_0 ?v3)) ?v0) f1) (= (f5 (f6 (f7 ?v2) (f10 (f11 f29 ?v3) ?v_1)) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 (f10 (f11 f29 ?v2) ?v1)))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (= (f5 (f6 ?v_0 (f10 (f11 f29 (f10 (f11 f29 ?v3) (f10 (f11 f28 ?v0) ?v1))) ?v1)) ?v0) f1) (= (f5 (f6 ?v_0 ?v3) ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f7 ?v1)) (?v_0 (f7 ?v2)) (?v_2 (f11 f29 ?v3)) (?v_3 (f11 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 ?v_1 0) ?v0) f1)) (=> (not (= (f5 (f6 ?v_0 0) ?v0) f1)) (=> (= (f5 (f6 ?v_0 (f10 ?v_2 (f10 ?v_3 ?v1))) ?v0) f1) (= (f5 (f6 ?v_1 (f10 ?v_2 (f10 ?v_3 ?v2))) ?v0) f1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_2 (f7 ?v3)) (?v_0 (f11 f29 ?v1)) (?v_1 (f11 f28 ?v0))) (=> (< 2 ?v0) (=> (= (f9 ?v0) f1) (=> (not (= (f5 (f6 (f7 ?v1) 0) ?v0) f1)) (=> (not (= (f5 (f6 (f7 ?v2) 0) ?v0) f1)) (=> (not (= (f5 (f6 ?v_2 0) ?v0) f1)) (=> (= (f5 (f6 (f7 (f10 ?v_0 (f10 ?v_1 ?v3))) (f10 ?v_0 (f10 ?v_1 ?v2))) ?v0) f1) (= (f5 (f6 ?v_2 ?v2) ?v0) f1))))))))))
(assert (forall ((?v0 Int)) (= (f10 f19 ?v0) (ite (<= ?v0 0) 1 (f10 (f11 f29 ?v0) (f10 f19 (- ?v0 1)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 Int)) (let ((?v_0 (f13 f25 ?v1)) (?v_1 (f13 f25 ?v0)) (?v_2 (f14 f15 ?v2))) (=> (<= ?v_1 ?v_0) (= (f13 ?v_2 (f16 f17 (- (+ ?v_0 1) ?v_1))) (f10 (f11 f29 (f13 ?v_2 (f16 f17 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f13 f25 ?v1)) (?v_1 (f13 f25 ?v0)) (?v_2 (f23 f24 ?v2))) (=> (<= ?v_1 ?v_0) (= (f22 ?v_2 (f16 f17 (- (+ ?v_0 1) ?v_1))) (f22 (f23 f30 (f22 ?v_2 (f16 f17 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S7) (?v1 Int)) (let ((?v_0 (f13 f25 ?v0)) (?v_1 (f14 f15 ?v1))) (=> (< 0 ?v_0) (= (f10 (f11 f29 (f13 ?v_1 (f16 f17 (- ?v_0 1)))) ?v1) (f13 ?v_1 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f13 f25 ?v0)) (?v_1 (f23 f24 ?v1))) (=> (< 0 ?v_0) (= (f22 (f23 f30 (f22 ?v_1 (f16 f17 (- ?v_0 1)))) ?v1) (f22 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f5 (f6 (f7 (f10 (f11 f29 ?v1) (f10 (f11 f31 ?v0) ?v1))) 1) ?v0) f1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 (f11 f20 (- ?v0 1)) 2))) (= (f16 f17 (* 2 (f13 f25 (f16 f17 ?v_0)))) (f16 f17 (* 2 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f16 f17 (f10 (f11 f29 (f13 f25 ?v1)) (f13 f25 ?v2))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f25 (f16 f17 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f16 f17 (f10 (f11 f29 ?v_0) ?v_0)) (f16 f17 (+ (f10 (f11 f29 (f13 f25 (f16 f17 (- ?v0 1)))) (f13 f25 (f16 f17 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f16 f17 (f10 (f11 f29 ?v0) ?v1)) (f16 f17 (f10 (f11 f29 (f13 f25 (f16 f17 (- ?v0)))) (f13 f25 (f16 f17 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f16 f17 (f10 (f11 f29 ?v0) ?v1)) (f16 f17 (f10 (f11 f29 (f13 f25 (f16 f17 ?v0))) (f13 f25 (f16 f17 ?v1))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f10 (f11 f29 (f13 f25 ?v0)) (f13 f25 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f10 (f11 f29 (f13 f25 ?v0)) (f13 f25 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f11 f29 ?v0) ?v1))) (= (f16 f17 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f16 f17 (f10 (f11 f29 (f13 f25 (f16 f17 (ite (< ?v0 0) (- ?v0) ?v0)))) (f13 f25 (f16 f17 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f16 f17 (f10 (f11 f29 (f13 f25 (f16 f17 ?v0))) (f13 f25 (f16 f17 ?v1)))) (f16 f17 (f10 (f11 f29 ?v0) ?v1)))))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f13 f25 ?v0))) (= (f16 f17 (* 2 ?v_0)) (f16 f17 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f10 (f11 f29 (f13 f25 ?v0)) (f13 f25 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f13 f25 ?v0))) (= (f16 f17 (* ?v_0 2)) (f16 f17 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f16 f17 0)) (?v_2 (f13 f25 ?v0)) (?v_1 (f13 f25 ?v1))) (= (f16 f17 (f10 (f11 f29 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f16 f17 (+ ?v_1 (f10 (f11 f29 (f13 f25 (f16 f17 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (f10 (f11 f29 (f13 f25 ?v1)) (f13 f25 ?v2)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f16 f17 (f10 (f11 f29 (f13 f25 ?v1)) (f13 f25 ?v2)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f16 f17 (* 2 (f13 f25 ?v1)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f16 f17 2))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f16 f17 (* 2 (f13 f25 ?v1)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f16 f17 2))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f16 f17 (f10 (f11 f29 (f13 f25 ?v1)) (f13 f25 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f16 f17 (f10 (f11 f29 (f13 f25 ?v1)) (f13 f25 ?v2))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f16 f17 1))) (= (= (f16 f17 (f10 (f11 f29 (f13 f25 ?v0)) (f13 f25 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f16 f17 2)) (?v_1 (f13 f25 ?v0)) (?v_2 (f13 f25 ?v1))) (= (f16 f17 (- (f13 f25 (f22 (f23 f24 ?v0) ?v_0)) (f13 f25 (f22 (f23 f24 ?v1) ?v_0)))) (f16 f17 (f10 (f11 f29 (+ ?v_1 ?v_2)) (f13 f25 (f16 f17 (- ?v_1 ?v_2)))))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f16 f17 0)) (f16 f17 1) (f16 f17 (f10 (f11 f29 (f13 f25 ?v0)) (f13 f25 (f22 ?v_0 (f16 f17 (- (f13 f25 ?v1) 1)))))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f31 ?v0))) (=> (= (f9 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f10 ?v_0 (f10 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f10 (f11 f31 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f10 (f11 f31 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f10 (f11 f31 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f10 (f11 f31 ?v0) ?v1) 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= (f10 (f11 f31 ?v0) ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (not (= ?v1 (f10 (f11 f31 ?v0) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S7)) (let ((?v_0 (f14 f15 ?v0))) (=> (= (f5 (f6 (f7 (f13 ?v_0 ?v1)) 1) ?v2) f1) (= (f5 (f6 (f7 (f13 ?v_0 (f16 f17 (f10 (f11 f29 (f13 f25 ?v1)) (f13 f25 ?v3))))) 1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (exists ((?v2 Int)) (let ((?v_1 (f10 (f11 f29 ?v2) ?v0))) (let ((?v_0 (- ?v1 ?v_1))) (<= (ite (< ?v_0 0) (* (- 2) ?v_0) (- (* 2 ?v1) (* 2 ?v_1))) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 (f32 ?v1) ?v0))) (=> (= (f9 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 (- ?v0 1)) (=> (= (f26 ?v2 ?v_0) f1) (= (f26 (f10 (f11 f31 ?v0) ?v2) ?v_0) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (not (= (f26 ?v1 (f6 (f32 (- ?v0 1)) ?v2)) f1)) (=> (= (f26 ?v1 (f6 (f32 ?v0) ?v2)) f1) (or (= ?v1 ?v0) (= ?v1 (f10 (f11 f31 ?v2) ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 ?v0) f1) (=> (< ?v1 ?v_0) (=> (= (f26 ?v2 (f6 (f32 ?v1) ?v0)) f1) (< ?v2 ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (= (f26 ?v2 (f6 (f32 ?v1) ?v0)) f1) (< 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f9 ?v0) f1) (=> (< ?v1 (- ?v0 1)) (=> (< 1 ?v2) (=> (<= ?v2 ?v1) (= (f26 ?v2 (f6 (f32 ?v1) ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 1 ?v0) (=> (= (f26 ?v1 (f6 (f32 (- ?v0 1)) ?v2)) f1) (= (f26 ?v1 (f6 (f32 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (= (f26 ?v0 (f6 (f32 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v0 1)) (?v_1 (f6 (f32 ?v1) ?v0))) (=> (= (f9 ?v0) f1) (=> (<= 5 ?v0) (=> (< ?v1 ?v_0) (=> (< 1 ?v2) (=> (< ?v2 ?v_0) (=> (= (f26 (f10 (f11 f31 ?v0) ?v2) ?v_1) f1) (= (f26 ?v2 ?v_1) f1))))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (- ?v0 2))) (=> (= (f9 ?v0) f1) (= (f33 ?v_0) (f6 (f32 ?v_0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f34 ?v0) f1) (=> (= (f34 ?v1) f1) (= (f34 (f10 (f11 f29 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (<= ?v0 ?v1) (= (f26 ?v0 (f33 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= (f26 ?v1 (f33 ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0 (f33 ?v1)) f1) (< 1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 ?v0 (f33 ?v1)) f1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f13 f25 ?v0))) (<= ?v_0 (f10 (f11 f29 ?v_0) ?v_0)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f13 f25 ?v0))) (let ((?v_1 (f11 f29 ?v_0))) (<= ?v_0 (f10 ?v_1 (f10 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1)) (?v_2 (f13 f25 ?v0)) (?v_1 (f13 f25 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f10 (f11 f29 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1)) (?v_1 (f13 f25 ?v0)) (?v_2 (f13 f25 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f10 (f11 f29 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (+ 0 1)) (?v_1 (f13 f25 ?v0)) (?v_2 (f13 f25 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f10 (f11 f29 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= ?v0 (f16 f17 (f10 (f11 f29 (f13 f25 ?v0)) (f13 f25 ?v1)))) (or (= ?v1 (f16 f17 1)) (= ?v0 (f16 f17 0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_2 (f13 f25 ?v1)) (?v_0 (f13 f25 ?v0)) (?v_3 (f13 f25 ?v3)) (?v_1 (f13 f25 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f10 (f11 f29 ?v_0) ?v_1) (f10 (f11 f29 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S7)) (= (f16 f17 (f13 f25 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f13 f25 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f13 f25 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
