(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 (S6 Int) Int)
(declare-fun f10 (S7 Int) S6)
(declare-fun f11 () S7)
(declare-fun f12 () Int)
(declare-fun f13 (Int) S1)
(declare-fun f14 () S7)
(declare-fun f15 (Int Int) S1)
(declare-fun f16 () Int)
(declare-fun f17 () S2)
(declare-fun f18 (Int) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (let ((?v_1 (- ?v_0 1))) (not (= (f3 (f4 f5 ?v_1) (f7 f8 2)) (- (f9 (f10 f11 ?v_0) ?v_1) ?v_1))))))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (not (< f12 (+ (* 4 f6) 1))))
(assert (= (f13 (+ (* 4 f6) 1)) f1))
(assert (= (f9 (f10 f14 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (= (f15 (+ (* 4 f6) 1) (- 1)) f1))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (let ((?v_1 (f10 f11 ?v_0))) (< (f9 ?v_1 (- ?v_0 1)) (f9 ?v_1 f12)))))
(assert (< (- (+ (* 4 f6) 1) 1) f12))
(assert (let ((?v_0 (f7 f8 2))) (<= (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 (- (+ (* 4 f6) 1) 1)) ?v_0))))
(assert (= (+ (f3 (f4 f5 f16) (f7 f8 2)) 1) (f9 (f10 f11 (+ (* 4 f6) 1)) f12)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f17 ?v1) (f3 f17 ?v2)))) (f9 (f10 f11 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f9 (f10 f11 ?v0) (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f9 (f10 f11 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f9 (f10 f11 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f9 (f10 f11 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f9 (f10 f11 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f9 (f10 f11 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f9 (f10 f11 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f9 (f10 f11 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (let ((?v_0 (f3 (f4 f5 f16) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (<= f16 (- (+ (* 4 f6) 1) 1)))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (=> (not (= (f15 ?v_0 (- 1)) f1)) (not (= (f9 (f10 f14 (- 1)) ?v_0) 1)))))
(assert (= (f9 (f10 f11 (+ (* 4 f6) 1)) f12) (+ (f3 (f4 f5 f16) (f7 f8 2)) 1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f16) (f7 f8 2)) 1) (f9 (f10 f11 (+ (* 4 f6) 1)) ?v0)) false)) false))
(assert (= (f18 (f9 (f10 f11 (+ (* 4 f6) 1)) f12)) f1))
(assert (= (f13 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f13 ?v_0) f1) (= (f9 (f10 f14 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 (f10 f11 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f17 ?v2))) (let ((?v_1 (f10 f11 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f9 ?v_1 ?v0) (f9 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f9 (f10 f11 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f9 (f10 f11 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f9 (f10 f11 (- ?v0 ?v1)) ?v2) (- (f9 (f10 f11 ?v0) ?v2) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f9 (f10 f11 (+ ?v0 ?v1)) ?v2) (+ (f9 (f10 f11 ?v0) ?v2) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f17 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f17 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f17 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
