(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 (S2 Int) Int)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 (S4 S5) Int)
(declare-fun f9 () S4)
(declare-fun f10 () S5)
(declare-fun f11 () Int)
(declare-fun f12 (S6 Int) S5)
(declare-fun f13 () S6)
(declare-fun f14 (Int) S1)
(declare-fun f15 () S3)
(declare-fun f16 (Int Int) S1)
(declare-fun f17 (S7 Int) S4)
(declare-fun f18 () S7)
(declare-fun f19 () Int)
(declare-fun f20 (Int Int) S1)
(declare-fun f21 (Int Int Int) S1)
(declare-fun f22 (S8 S9) Int)
(declare-fun f23 () S8)
(declare-fun f24 (Int Int) S9)
(declare-fun f25 () Int)
(declare-fun f26 (S10 S5) S11)
(declare-fun f27 () S10)
(declare-fun f28 (S11 S5) S5)
(declare-fun f29 () S10)
(declare-fun f30 (S5 S5) S1)
(declare-fun f31 () S2)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 (f8 f9 f10)))) f1))))
(assert (< (+ 1 (f8 f9 f10)) (+ (* 4 f7) 1)))
(assert (< 1 f11))
(assert (< 0 (f8 f9 f10)))
(assert (< 0 (+ (* 4 f7) 1)))
(assert (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 0))) f1)))
(assert (= f10 (f12 f13 (- (f8 f9 (f12 f13 f11)) 1))))
(assert (= (f14 (+ (* 4 f7) 1)) f1))
(assert (= (f4 (f5 f15 (- 1)) (+ (* 4 f7) 1)) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (= (f16 (+ (* 4 f7) 1) (- 1)) f1))
(assert (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) f11)) f1))
(assert (< f11 (+ (* 4 f7) 1)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (=> (not (= (f16 ?v_0 (- 1)) f1)) (not (= (f4 (f5 f15 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (+ ?v1 ?v2)) (+ (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (- ?v1 ?v2)) (- (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 (- ?v0)) ?v1) (- (f4 (f5 f6 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v2) (+ (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v2) (- (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (<= 1 f11))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f12 f13 (- (f8 f9 (f12 f13 f11)) 1))) (=> (< 0 (f8 f9 ?v0)) false))) false))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f14 ?v_0) f1) (= (f4 (f5 f15 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f4 (f5 f6 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f8 f9 ?v2))) (let ((?v_1 (f5 f6 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f4 ?v_1 ?v0) (f4 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (= (+ (f8 (f17 f18 f19) (f12 f13 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) f11)))
(assert (=> (= f11 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (+ (f8 (f17 f18 ?v0) ?v_0) (f8 (f17 f18 ?v1) ?v_0)) (+ (* 4 f7) 1))))))
(assert (= (f14 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f14 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f4 (f5 f6 ?v3) ?v4) ?v5))) (=> (= (+ (f4 (f5 f6 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (<= (+ (f4 ?v_0 ?v1) ?v2) (+ (f4 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f4 (f5 f6 ?v3) ?v4) ?v5))) (=> (= (+ (f4 (f5 f6 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (<= (+ (f4 ?v_0 ?v1) ?v2) (+ (f4 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f4 (f5 f6 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f4 (f5 f6 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (let ((?v_0 (f8 (f17 f18 f19) (f12 f13 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f8 (f17 f18 f19) (f12 f13 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f8 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f8 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f12 f13 0))))))
(assert (forall ((?v0 Int)) (=> (= (f8 (f17 f18 ?v0) (f12 f13 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (= (f8 (f17 f18 ?v0) ?v_0) (f8 (f17 f18 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 2)) (?v_1 (f17 f18 ?v0))) (= (f8 (f17 f18 (f8 ?v_1 ?v_0)) ?v_0) (f8 ?v_1 (f12 f13 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 3))) (= (f8 (f17 f18 (- ?v0)) ?v_0) (- (f8 (f17 f18 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f12 f13 3))) (let ((?v_0 (f8 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f12 f13 2))) (let ((?v_0 (f8 (f17 f18 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f8 (f17 f18 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f4 (f5 f6 ?v0) (f8 ?v_0 (f12 f13 2))) (f8 ?v_0 (f12 f13 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f8 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (f8 (f17 f18 ?v0) ?v_0) (f4 (f5 f6 (* 2 ?v0)) ?v1)) (f8 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f8 (f17 f18 (- ?v0 ?v1)) ?v_0) (+ (- (f8 (f17 f18 ?v0) ?v_0) (f4 (f5 f6 (* 2 ?v0)) ?v1)) (f8 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f12 f13 2)) (?v_0 (f12 f13 3)) (?v_1 (f17 f18 ?v0)) (?v_3 (f17 f18 ?v1))) (= (f8 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f8 ?v_1 ?v_0) (f4 (f5 f6 (* 3 (f8 ?v_1 ?v_2))) ?v1)) (f4 (f5 f6 (* 3 ?v0)) (f8 ?v_3 ?v_2))) (f8 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f12 f13 2)) (?v_0 (f12 f13 3)) (?v_3 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0))) (= (f8 (f17 f18 (- ?v0 ?v1)) ?v_0) (- (+ (- (f8 ?v_1 ?v_0) (f4 (f5 f6 (* 3 (f8 ?v_1 ?v_2))) ?v1)) (f4 (f5 f6 (* 3 ?v0)) (f8 ?v_3 ?v_2))) (f8 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f4 (f5 f6 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f8 (f17 f18 ?v0) ?v_0) (f8 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f8 ?v_0 (f12 f13 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f4 (f5 f6 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f4 (f5 f6 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (= (f20 (+ (* 4 f7) 1) (+ (f8 (f17 f18 f19) (f12 f13 2)) 1)) f1))
(assert (= (f20 (+ (* 4 f7) 1) (- (f8 (f17 f18 f19) (f12 f13 2)) (- 1))) f1))
(assert (= (f21 (f8 (f17 f18 f19) (f12 f13 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (= (f22 f23 (f24 f19 1)) (f4 (f5 f6 (+ (* 4 f7) 1)) f11)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (and (<= 0 f19) (and (< f19 ?v_0) (= (f21 f25 f19 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f12 f13 ?v0))) (=> (< 0 ?v0) (= (f8 ?v_0 ?v_1) (f4 (f5 f6 ?v1) (f8 ?v_0 (f12 f13 (- (f8 f9 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (= (f4 (f5 f6 ?v0) ?v0) (f8 (f17 f18 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 S5)) (= (f28 (f26 f27 ?v0) ?v0) (f28 (f26 f29 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f8 ?v_0 (f12 f13 (+ (f8 f9 ?v1) 1))) (f4 (f5 f6 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f26 f29 ?v0))) (= (f28 ?v_0 (f12 f13 (+ (f8 f9 ?v1) 1))) (f28 (f26 f27 ?v0) (f28 ?v_0 ?v1))))))
(assert (= (f21 (f8 (f17 f18 f25) (f12 f13 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f21 (f8 (f17 f18 ?v0) (f12 f13 2)) (- 1) (+ (* 4 f7) 1)) f1) false)) false))
(assert (let ((?v_0 (f12 f13 2))) (= (f21 (f8 (f17 f18 f19) ?v_0) (f8 (f17 f18 f25) ?v_0) (+ (* 4 f7) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 f25 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f21 f25 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f21 f25 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f21 (f8 ?v_0 ?v1) 1 ?v2) f1) (= (f21 (f8 ?v_0 (f12 f13 (f4 (f5 f6 (f8 f9 ?v1)) (f8 f9 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f26 f29 ?v0))) (=> (= (f30 (f28 ?v_0 ?v1) ?v2) f1) (=> (<= (f8 f9 ?v3) (f8 f9 ?v1)) (= (f30 (f28 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f20 (f8 ?v_0 ?v1) ?v2) f1) (=> (<= (f8 f9 ?v3) (f8 f9 ?v1)) (= (f20 (f8 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f30 ?v0 ?v1) f1) (=> (<= (f8 f9 ?v2) (f8 f9 ?v3)) (= (f30 (f28 (f26 f29 ?v0) ?v2) (f28 (f26 f29 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S5)) (=> (= (f20 ?v0 ?v1) f1) (=> (<= (f8 f9 ?v2) (f8 f9 ?v3)) (= (f20 (f8 (f17 f18 ?v0) ?v2) (f8 (f17 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f29 ?v2))) (=> (<= (f8 f9 ?v0) (f8 f9 ?v1)) (= (f30 (f28 ?v_0 ?v0) (f28 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f17 f18 ?v2))) (=> (<= (f8 f9 ?v0) (f8 f9 ?v1)) (= (f20 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f30 ?v0 ?v1) f1) (= (f30 (f28 (f26 f29 ?v0) ?v2) (f28 (f26 f29 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f20 ?v0 ?v1) f1) (= (f20 (f8 (f17 f18 ?v0) ?v2) (f8 (f17 f18 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f21 ?v0 0 ?v1) f1)) (=> (= (f21 (f8 (f17 f18 ?v2) (f12 f13 2)) ?v0 ?v1) f1) (not (= (f20 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f8 (f17 f18 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f12 f13 (f4 (f5 f6 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f29 ?v0))) (= (f28 (f26 f29 (f28 ?v_0 ?v1)) ?v2) (f28 ?v_0 (f12 f13 (f4 (f5 f6 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f8 ?v_0 (f12 f13 (f4 (f5 f6 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f8 (f17 f18 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f29 ?v0))) (= (f28 ?v_0 (f12 f13 (f4 (f5 f6 (f8 f9 ?v1)) (f8 f9 ?v2)))) (f28 (f26 f29 (f28 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f20 ?v0 (- ?v1 ?v2)) f1) (=> (= (f20 ?v0 ?v2) f1) (= (f20 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f20 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f20 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f20 ?v0 ?v1) f1) (=> (= (f20 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f20 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f20 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 f6 ?v0)) (?v_1 (f5 f6 ?v1))) (= (f4 (f5 f6 (f22 f23 (f24 ?v0 ?v1))) (f22 f23 (f24 ?v2 ?v3))) (f22 f23 (f24 (+ (f4 ?v_0 ?v2) (f4 ?v_1 ?v3)) (- (f4 ?v_0 ?v3) (f4 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f21 (f4 (f5 f6 ?v0) ?v_0) 1 ?v1) f1) (= (f21 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f20 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f20 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f20 ?v0 ?v1) f1) (= (= (f20 ?v0 (+ ?v2 ?v3)) f1) (= (f20 ?v0 (+ (+ ?v2 (f4 (f5 f6 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f20 (f4 (f5 f6 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f20 ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) f1) (= (f20 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f12 f13 (f4 (f5 f6 ?v0) ?v1)) (f12 f13 (f4 (f5 f6 (f8 f9 (f12 f13 (- ?v0)))) (f8 f9 (f12 f13 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f12 f13 (f4 (f5 f6 ?v0) ?v1)) (f12 f13 (f4 (f5 f6 (f8 f9 (f12 f13 ?v0))) (f8 f9 (f12 f13 ?v1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f4 (f5 f6 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f4 (f5 f6 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (= (f12 f13 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f12 f13 (f4 (f5 f6 (f8 f9 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)))) (f8 f9 (f12 f13 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f12 f13 (f8 (f17 f18 ?v0) ?v1)) (f28 (f26 f29 (f12 f13 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f17 f18 (f8 f9 ?v0)) ?v1) (f8 f9 (f28 (f26 f29 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 f9 (f28 (f26 f29 ?v0) ?v1)) (f8 (f17 f18 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f8 (f17 f18 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f12 f13 (f4 (f5 f6 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f14 ?v0) f1) (=> (= (f20 ?v0 (f8 (f17 f18 ?v1) ?v2)) f1) (= (f20 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f8 (f17 f18 ?v0) ?v2))) (=> (= (f14 ?v0) f1) (=> (not (= (f20 ?v0 ?v1) f1)) (=> (= (f20 ?v_0 (f4 (f5 f6 ?v1) ?v3)) f1) (= (f20 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f8 (f17 f18 ?v0) ?v2))) (=> (= (f14 ?v0) f1) (=> (not (= (f20 ?v0 ?v1) f1)) (=> (= (f20 ?v_0 (f4 (f5 f6 ?v3) ?v1)) f1) (= (f20 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f26 f27 ?v0))) (= (f28 (f26 f27 (f28 ?v_0 ?v1)) (f28 (f26 f27 ?v2) ?v3)) (f28 (f26 f27 (f28 ?v_0 ?v2)) (f28 (f26 f27 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 (f5 f6 ?v2) ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v2)) (f4 (f5 f6 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f26 f27 (f28 (f26 f27 ?v0) ?v1))) (?v_0 (f26 f27 ?v2))) (= (f28 ?v_1 (f28 ?v_0 ?v3)) (f28 ?v_0 (f28 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f5 f6 (f4 (f5 f6 ?v0) ?v1))) (?v_0 (f5 f6 ?v2))) (= (f4 ?v_1 (f4 ?v_0 ?v3)) (f4 ?v_0 (f4 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f26 f27 ?v0)) (?v_1 (f28 (f26 f27 ?v2) ?v3))) (= (f28 (f26 f27 (f28 ?v_0 ?v1)) ?v_1) (f28 ?v_0 (f28 (f26 f27 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 f6 ?v0)) (?v_1 (f4 (f5 f6 ?v2) ?v3))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v_1) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f27 ?v0))) (= (f28 (f26 f27 (f28 ?v_0 ?v1)) ?v2) (f28 (f26 f27 (f28 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 (f5 f6 (f4 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f27 ?v0))) (= (f28 (f26 f27 (f28 ?v_0 ?v1)) ?v2) (f28 ?v_0 (f28 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f27 ?v0))) (= (f28 ?v_0 (f28 (f26 f27 ?v1) ?v2)) (f28 (f26 f27 (f28 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f26 f27 ?v0)) (?v_0 (f26 f27 ?v1))) (= (f28 ?v_1 (f28 ?v_0 ?v2)) (f28 ?v_0 (f28 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f5 f6 ?v0)) (?v_0 (f5 f6 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f28 (f26 f27 ?v0) ?v1) (f28 (f26 f27 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f4 f31 (f8 (f17 f18 ?v0) ?v1)) (f8 (f17 f18 (f4 f31 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f8 (f17 f18 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f28 (f26 f29 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f8 (f17 f18 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f28 (f26 f29 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f4 (f5 f6 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) (f8 ?v_0 (f12 f13 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f29 ?v0))) (= (f28 (f26 f27 (f28 ?v_0 ?v1)) (f28 ?v_0 ?v2)) (f28 ?v_0 (f12 f13 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f8 (f17 f18 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f8 (f17 f18 ?v0) ?v2)) (f8 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f28 (f26 f29 (f28 (f26 f27 ?v0) ?v1)) ?v2) (f28 (f26 f27 (f28 (f26 f29 ?v0) ?v2)) (f28 (f26 f29 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f8 (f17 f18 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f8 (f17 f18 ?v0) ?v2)) (f8 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f28 (f26 f29 (f28 (f26 f27 ?v0) ?v1)) ?v2) (f28 (f26 f27 (f28 (f26 f29 ?v0) ?v2)) (f28 (f26 f29 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f8 (f17 f18 ?v0) ?v1))) (= (f4 (f5 f6 ?v_0) ?v0) (f4 (f5 f6 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f28 (f26 f29 ?v0) ?v1))) (= (f28 (f26 f27 ?v_0) ?v0) (f28 (f26 f27 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f4 (f5 f6 (f8 ?v_0 ?v1)) ?v0) (f8 ?v_0 (f12 f13 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f26 f29 ?v0))) (= (f28 (f26 f27 (f28 ?v_0 ?v1)) ?v0) (f28 ?v_0 (f12 f13 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f12 f13 (* 2 (f8 f9 ?v1)))) (f4 (f5 f6 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f26 f29 ?v0))) (let ((?v_1 (f28 ?v_0 ?v1))) (= (f28 ?v_0 (f12 f13 (* 2 (f8 f9 ?v1)))) (f28 (f26 f27 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f8 ?v_0 (f12 f13 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f4 (f5 f6 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f26 f29 ?v0))) (= (f28 ?v_0 (f12 f13 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f28 (f26 f27 (f28 ?v_0 ?v1)) (f28 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (= (f4 (f5 f6 ?v0) (f8 ?v_0 ?v1)) (f8 ?v_0 (f12 f13 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f26 f29 ?v0))) (= (f28 (f26 f27 ?v0) (f28 ?v_0 ?v1)) (f28 ?v_0 (f12 f13 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f17 f18 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f12 f13 (+ (* 2 (f8 f9 ?v1)) 1))) (f4 (f5 f6 ?v0) (f4 (f5 f6 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f26 f29 ?v0))) (let ((?v_1 (f28 ?v_0 ?v1))) (= (f28 ?v_0 (f12 f13 (+ (* 2 (f8 f9 ?v1)) 1))) (f28 (f26 f27 ?v0) (f28 (f26 f27 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5)) (= (f12 f13 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
