(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 (S6 Int) Int)
(declare-fun f10 (S7 Int) S6)
(declare-fun f11 () S7)
(declare-fun f12 () Int)
(declare-fun f13 () S2)
(declare-fun f14 () S3)
(declare-fun f15 (Int) S1)
(declare-fun f16 () Int)
(declare-fun f17 (Int) S1)
(declare-fun f18 () S7)
(declare-fun f19 (Int Int) S1)
(declare-fun f20 () S3)
(declare-fun f21 () Int)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 (Int Int Int) S1)
(declare-fun f24 (S8 S9) Int)
(declare-fun f25 () S8)
(declare-fun f26 (Int Int) S9)
(declare-fun f27 () Int)
(declare-fun f28 (S10 S3) S3)
(declare-fun f29 (S11 S3) S10)
(declare-fun f30 () S11)
(declare-fun f31 () S11)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (f9 (f10 f11 (+ (* 4 f12) 1)) (+ 1 (f4 f13 f14)))) (= f3 f1)))))
(assert (< 0 (f4 f13 f14)))
(assert (let ((?v_0 (+ (* 4 f12) 1)) (?v_1 (+ 1 (f4 f13 f14)))) (and (< ?v_1 ?v_0) (= (f15 (f9 (f10 f11 ?v_0) ?v_1)) f1))))
(assert (< 1 f16))
(assert (< 0 (f4 f13 f14)))
(assert (not (= (f15 (f9 (f10 f11 (+ (* 4 f12) 1)) (+ 1 0))) f1)))
(assert (< 0 (+ (* 4 f12) 1)))
(assert (let ((?v_0 (+ (* 4 f12) 1)) (?v_1 (+ 1 (f4 f13 f14)))) (and (< ?v_1 ?v_0) (= (f15 (f9 (f10 f11 ?v_0) ?v_1)) f1))))
(assert (let ((?v_0 (+ (* 4 f12) 1)) (?v_1 (+ 1 (f4 f13 f14)))) (not (=> (< ?v_1 ?v_0) (not (= (f15 (f9 (f10 f11 ?v_0) ?v_1)) f1))))))
(assert (= (f17 (+ (* 4 f12) 1)) f1))
(assert (= (f9 (f10 f18 (- 1)) (+ (* 4 f12) 1)) 1))
(assert (= (f19 (+ (* 4 f12) 1) (- 1)) f1))
(assert (= f20 (f7 f8 (- (f4 f13 (f7 f8 f16)) 1))))
(assert (< f16 (+ (* 4 f12) 1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (= (f15 ?v1) f1) (= (f15 (f9 (f10 f11 ?v0) ?v1)) f1)))))
(assert (= (f15 (f9 (f10 f11 (+ (* 4 f12) 1)) f16)) f1))
(assert (= (+ (f4 (f5 f6 f21) (f7 f8 2)) 1) (f9 (f10 f11 (+ (* 4 f12) 1)) f16)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f4 (f5 f6 f21) (f7 f8 2)) 1) (f9 (f10 f11 (+ (* 4 f12) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f7 f8 (+ (f4 f13 ?v1) (f4 f13 ?v2)))) (f9 (f10 f11 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f9 (f10 f11 ?v0) (f4 ?v_0 (f7 f8 2))) (f4 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v_0) (+ (+ (f4 (f5 f6 ?v0) ?v_0) (f9 (f10 f11 (* 2 ?v0)) ?v1)) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v_0) (+ (- (f4 (f5 f6 ?v0) ?v_0) (f9 (f10 f11 (* 2 ?v0)) ?v1)) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f5 f6 ?v0)) (?v_3 (f5 f6 ?v1))) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f4 ?v_1 ?v_0) (f9 (f10 f11 (* 3 (f4 ?v_1 ?v_2))) ?v1)) (f9 (f10 f11 (* 3 ?v0)) (f4 ?v_3 ?v_2))) (f4 ?v_3 ?v_0))))))
(assert (< 0 (f4 f13 f20)))
(assert (<= 1 f16))
(assert (let ((?v_0 (f4 (f5 f6 f21) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f4 f13 (f7 f8 f16)) 1))) (=> (< 0 (f4 f13 ?v0)) false))) false))
(assert (let ((?v_0 (+ (* 4 f12) 1))) (=> (not (= (f19 ?v_0 (- 1)) f1)) (not (= (f9 (f10 f18 (- 1)) ?v_0) 1)))))
(assert (=> (= f16 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (+ (* 4 f12) 1))))))
(assert (= (f17 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f17 ?v_0) f1) (= (f9 (f10 f18 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 (f10 f11 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f4 f13 ?v2))) (let ((?v_1 (f10 f11 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f9 ?v_1 ?v0) (f9 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f9 ?v_0 ?v0) (f9 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f9 (f10 f11 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f9 (f10 f11 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f9 (f10 f11 (- ?v0 ?v1)) ?v2) (- (f9 (f10 f11 ?v0) ?v2) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f9 (f10 f11 (+ ?v0 ?v1)) ?v2) (+ (f9 (f10 f11 ?v0) ?v2) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f9 (f10 f11 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f11 (- ?v0)) ?v1) (- (f9 (f10 f11 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (- ?v1 ?v2)) (- (f9 ?v_0 ?v1) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (+ ?v1 ?v2)) (+ (f9 ?v_0 ?v1) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f4 (f5 f6 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_1 ?v_0)) ?v_0) (f4 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f4 (f5 f6 (- ?v0)) ?v_0) (- (f4 (f5 f6 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f4 (f5 f6 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f4 (f5 f6 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f4 (f5 f6 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f4 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f9 (f10 f11 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f5 f6 ?v1)) (?v_1 (f5 f6 ?v0))) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v_0) (- (+ (- (f4 ?v_1 ?v_0) (f9 (f10 f11 (* 3 (f4 ?v_1 ?v_2))) ?v1)) (f9 (f10 f11 (* 3 ?v0)) (f4 ?v_3 ?v_2))) (f4 ?v_3 ?v_0))))))
(assert (= (f22 (+ (* 4 f12) 1) (- (f4 (f5 f6 f21) (f7 f8 2)) (- 1))) f1))
(assert (= (f22 (+ (* 4 f12) 1) (+ (f4 (f5 f6 f21) (f7 f8 2)) 1)) f1))
(assert (= (f23 (f4 (f5 f6 f21) (f7 f8 2)) (- 1) (+ (* 4 f12) 1)) f1))
(assert (= (f24 f25 (f26 f21 1)) (f9 (f10 f11 (+ (* 4 f12) 1)) f16)))
(assert (let ((?v_0 (+ (* 4 f12) 1))) (and (<= 0 f21) (and (< f21 ?v_0) (= (f23 f27 f21 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f5 f6 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f4 ?v_0 ?v_1) (f9 (f10 f11 ?v1) (f4 ?v_0 (f7 f8 (- (f4 f13 ?v_1) 1)))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f4 f13 ?v1)) (?v_1 (f4 f13 ?v0)) (?v_2 (f5 f6 ?v2))) (=> (<= ?v_1 ?v_0) (= (f4 ?v_2 (f7 f8 (- (+ ?v_0 1) ?v_1))) (f9 (f10 f11 (f4 ?v_2 (f7 f8 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f13 ?v1)) (?v_1 (f4 f13 ?v0)) (?v_2 (f29 f30 ?v2))) (=> (<= ?v_1 ?v_0) (= (f28 ?v_2 (f7 f8 (- (+ ?v_0 1) ?v_1))) (f28 (f29 f31 (f28 ?v_2 (f7 f8 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f4 f13 ?v0)) (?v_1 (f5 f6 ?v1))) (=> (< 0 ?v_0) (= (f9 (f10 f11 (f4 ?v_1 (f7 f8 (- ?v_0 1)))) ?v1) (f4 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f13 ?v0)) (?v_1 (f29 f30 ?v1))) (=> (< 0 ?v_0) (= (f28 (f29 f31 (f28 ?v_1 (f7 f8 (- ?v_0 1)))) ?v1) (f28 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f9 (f10 f11 (f4 ?v_0 ?v1)) (f4 ?v_0 ?v2)) (f4 ?v_0 (f7 f8 (+ (f4 f13 ?v1) (f4 f13 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f29 f30 ?v0))) (= (f28 (f29 f31 (f28 ?v_0 ?v1)) (f28 ?v_0 ?v2)) (f28 ?v_0 (f7 f8 (+ (f4 f13 ?v1) (f4 f13 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f4 (f5 f6 (f9 (f10 f11 ?v0) ?v1)) ?v2) (f9 (f10 f11 (f4 (f5 f6 ?v0) ?v2)) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f28 (f29 f30 (f28 (f29 f31 ?v0) ?v1)) ?v2) (f28 (f29 f31 (f28 (f29 f30 ?v0) ?v2)) (f28 (f29 f30 ?v1) ?v2)))))
(assert (= (f23 (f4 (f5 f6 f27) (f7 f8 2)) (- 1) (+ (* 4 f12) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f23 (f4 (f5 f6 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f12) 1)) f1) false)) false))
(assert (let ((?v_0 (f7 f8 2))) (= (f23 (f4 (f5 f6 f21) ?v_0) (f4 (f5 f6 f27) ?v_0) (+ (* 4 f12) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f12) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f27 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f23 f27 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f12) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f27 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int)) (= (= (f22 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f22 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f22 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f22 ?v0 (- ?v1 ?v2)) f1) (=> (= (f22 ?v0 ?v2) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f23 ?v0 0 ?v1) f1)) (=> (= (f23 (f4 (f5 f6 ?v2) (f7 f8 2)) ?v0 ?v1) f1) (not (= (f22 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f7 f8 (f9 (f10 f11 (f4 f13 ?v1)) (f4 f13 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f29 f30 ?v0))) (= (f28 (f29 f30 (f28 ?v_0 ?v1)) ?v2) (f28 ?v_0 (f7 f8 (f9 (f10 f11 (f4 f13 ?v1)) (f4 f13 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v0)) (?v_1 (f10 f11 ?v1))) (= (f9 (f10 f11 (f24 f25 (f26 ?v0 ?v1))) (f24 f25 (f26 ?v2 ?v3))) (f24 f25 (f26 (+ (f9 ?v_0 ?v2) (f9 ?v_1 ?v3)) (- (f9 ?v_0 ?v3) (f9 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 (+ ?v1 (f9 (f10 f11 ?v0) ?v2))) f1) (= (f22 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f22 (f9 (f10 f11 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1) f1) (= (= (f22 ?v0 (+ ?v2 ?v3)) f1) (= (f22 ?v0 (+ (+ ?v2 (f9 (f10 f11 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f22 (f9 ?v_0 ?v1) (f9 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f22 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (= (f7 f8 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f7 f8 (f9 (f10 f11 (f4 f13 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)))) (f4 f13 (f7 f8 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 (f10 f11 (f4 f13 ?v0)) (f4 f13 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f9 (f10 f11 (f4 f13 ?v0)) (f4 f13 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f9 (f10 f11 ?v0) ?v1)) (f7 f8 (f9 (f10 f11 (f4 f13 (f7 f8 ?v0))) (f4 f13 (f7 f8 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f7 f8 (f9 (f10 f11 ?v0) ?v1)) (f7 f8 (f9 (f10 f11 (f4 f13 (f7 f8 (- ?v0)))) (f4 f13 (f7 f8 (- ?v1)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f4 f13 (f28 (f29 f30 ?v0) ?v1)) (f4 (f5 f6 (f4 f13 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f4 (f5 f6 (f4 f13 ?v0)) ?v1) (f4 f13 (f28 (f29 f30 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f7 f8 (f4 (f5 f6 ?v0) ?v1)) (f28 (f29 f30 (f7 f8 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f7 f8 (f9 (f10 f11 (f4 f13 ?v1)) (f4 f13 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f17 ?v0) f1) (=> (= (f22 ?v0 (f4 (f5 f6 ?v1) ?v2)) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v2))) (=> (= (f17 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (f9 (f10 f11 ?v1) ?v3)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v2))) (=> (= (f17 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (f9 (f10 f11 ?v3) ?v1)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f28 (f29 f31 ?v0) ?v1) (f28 (f29 f31 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f29 f31 ?v0)) (?v_0 (f29 f31 ?v1))) (= (f28 ?v_1 (f28 ?v_0 ?v2)) (f28 ?v_0 (f28 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f10 f11 ?v0)) (?v_0 (f10 f11 ?v1))) (= (f9 ?v_1 (f9 ?v_0 ?v2)) (f9 ?v_0 (f9 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f29 f31 ?v0))) (= (f28 ?v_0 (f28 (f29 f31 ?v1) ?v2)) (f28 (f29 f31 (f28 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2)) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f29 f31 ?v0))) (= (f28 (f29 f31 (f28 ?v_0 ?v1)) ?v2) (f28 ?v_0 (f28 (f29 f31 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f9 (f10 f11 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f29 f31 ?v0))) (= (f28 (f29 f31 (f28 ?v_0 ?v1)) ?v2) (f28 (f29 f31 (f28 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 (f10 f11 (f9 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f29 f31 ?v0)) (?v_1 (f28 (f29 f31 ?v2) ?v3))) (= (f28 (f29 f31 (f28 ?v_0 ?v1)) ?v_1) (f28 ?v_0 (f28 (f29 f31 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v0)) (?v_1 (f9 (f10 f11 ?v2) ?v3))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v_1) (f9 ?v_0 (f9 (f10 f11 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f29 f31 (f28 (f29 f31 ?v0) ?v1))) (?v_0 (f29 f31 ?v2))) (= (f28 ?v_1 (f28 ?v_0 ?v3)) (f28 ?v_0 (f28 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f10 f11 (f9 (f10 f11 ?v0) ?v1))) (?v_0 (f10 f11 ?v2))) (= (f9 ?v_1 (f9 ?v_0 ?v3)) (f9 ?v_0 (f9 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f29 f31 ?v0))) (= (f28 (f29 f31 (f28 ?v_0 ?v1)) (f28 (f29 f31 ?v2) ?v3)) (f28 (f29 f31 (f28 ?v_0 ?v2)) (f28 (f29 f31 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) (f9 (f10 f11 ?v2) ?v3)) (f9 (f10 f11 (f9 ?v_0 ?v2)) (f9 (f10 f11 ?v1) ?v3))))))
(assert (forall ((?v0 Int)) (= (f4 (f5 f6 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f28 (f29 f30 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f9 (f10 f11 ?v0) ?v0) (f4 (f5 f6 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 S3)) (= (f28 (f29 f31 ?v0) ?v0) (f28 (f29 f30 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f7 f8 (+ (f4 f13 ?v1) 1))) (f9 (f10 f11 ?v0) (f4 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f29 f30 ?v0))) (= (f28 ?v_0 (f7 f8 (+ (f4 f13 ?v1) 1))) (f28 (f29 f31 ?v0) (f28 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (let ((?v_1 (f4 ?v_0 ?v1))) (= (f4 ?v_0 (f7 f8 (+ (* 2 (f4 f13 ?v1)) 1))) (f9 (f10 f11 ?v0) (f9 (f10 f11 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f29 f30 ?v0))) (let ((?v_1 (f28 ?v_0 ?v1))) (= (f28 ?v_0 (f7 f8 (+ (* 2 (f4 f13 ?v1)) 1))) (f28 (f29 f31 ?v0) (f28 (f29 f31 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f9 (f10 f11 ?v0) (f4 ?v_0 ?v1)) (f4 ?v_0 (f7 f8 (+ (f4 f13 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f29 f30 ?v0))) (= (f28 (f29 f31 ?v0) (f28 ?v_0 ?v1)) (f28 ?v_0 (f7 f8 (+ (f4 f13 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (let ((?v_1 (f4 ?v_0 ?v1))) (= (f4 ?v_0 (f7 f8 (* 2 (f4 f13 ?v1)))) (f9 (f10 f11 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f29 f30 ?v0))) (let ((?v_1 (f28 ?v_0 ?v1))) (= (f28 ?v_0 (f7 f8 (* 2 (f4 f13 ?v1)))) (f28 (f29 f31 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f5 f6 ?v0))) (= (f9 (f10 f11 (f4 ?v_0 ?v1)) ?v0) (f4 ?v_0 (f7 f8 (+ (f4 f13 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f29 f30 ?v0))) (= (f28 (f29 f31 (f28 ?v_0 ?v1)) ?v0) (f28 ?v_0 (f7 f8 (+ (f4 f13 ?v1) 1)))))))
(assert (forall ((?v0 Int)) (= (= (f15 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f24 f25 (f26 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (= (f23 (f4 (f5 f6 ?v1) (f7 f8 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f9 (f10 f18 ?v0) ?v1) (ite (= (f23 ?v0 0 ?v1) f1) 0 (ite (= (f19 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f19 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f23 (f4 (f5 f6 ?v2) (f7 f8 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f17 ?v0) f1) (=> (= (f22 ?v0 (f4 (f5 f6 ?v1) ?v2)) f1) (=> (< 0 (f4 f13 ?v2)) (= (f22 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f17 ?v1) f1) (=> (= (f22 ?v1 (f9 (f10 f11 ?v0) ?v2)) f1) (or (= (f22 ?v1 ?v0) f1) (= (f22 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f17 ?v0) f1) (=> (= (f22 ?v0 (f9 (f10 f11 ?v1) ?v2)) f1) (or (= (f22 ?v0 ?v1) f1) (= (f22 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f10 f11 ?v1))) (= (+ (f9 (f10 f11 (- ?v0 (f9 ?v_0 ?v2))) ?v3) (f9 (f10 f11 (- ?v4 (f9 ?v_0 ?v5))) ?v6)) (- (+ (f9 (f10 f11 ?v0) ?v3) (f9 (f10 f11 ?v4) ?v6)) (f9 ?v_0 (+ (f9 (f10 f11 ?v2) ?v3) (f9 (f10 f11 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 ?v1 ?v2) f1) (= (f23 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 ?v1 (- ?v2)) f1) (= (f23 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f23 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f23 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f23 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f23 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f4 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f13 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f13 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
