(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S1)
(declare-fun f4 () Int)
(declare-fun f5 (S2 Int) Int)
(declare-fun f6 (S3 Int) S2)
(declare-fun f7 () S3)
(declare-fun f8 (S4 S5) Int)
(declare-fun f9 () S4)
(declare-fun f10 () S5)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () S5)
(declare-fun f16 (S6 Int) S5)
(declare-fun f17 () S6)
(declare-fun f18 () Int)
(declare-fun f19 (Int) S1)
(declare-fun f20 (S7 Int) S4)
(declare-fun f21 () S7)
(declare-fun f22 (Int) S1)
(declare-fun f23 () S3)
(declare-fun f24 () Int)
(assert (not (= f1 f2)))
(assert (not (= f3 f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f8 f9 f10)))) (=> (and (= ?v0 (- f4 (f5 (f6 f7 ?v1) ?v_0))) (<= (ite (< ?v0 0) (* (- 2) ?v0) (* 2 ?v0)) ?v_0)) (= f3 f1)))))
(assert (< 0 (+ 1 (f8 f9 f10))))
(assert (< 1 f11))
(assert (< 0 (+ 1 (f8 f9 f10))))
(assert (< 0 (f8 f9 f10)))
(assert (let ((?v_0 (+ 1 (f8 f9 f10)))) (and (= f12 (- f13 (f5 (f6 f7 f14) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (= f15 (f16 f17 (- (f8 f9 (f16 f17 f11)) 1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f8 f9 f10)))) (=> (and (= ?v1 (- f13 (f5 (f6 f7 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_1 (+ 1 (f8 f9 f10))) (?v_0 (+ (* 4 f18) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f19 (f5 (f6 f7 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (f16 f17 2))) (= (+ (f8 (f20 f21 f13) ?v_0) (f8 (f20 f21 f4) ?v_0)) (f5 (f6 f7 (+ (* 4 f18) 1)) (+ 1 (f8 f9 f10))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (+ ?v1 ?v2)) (+ (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (- ?v1 ?v2)) (- (f5 ?v_0 ?v1) (f5 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f5 (f6 f7 (- ?v0)) ?v1) (- (f5 (f6 f7 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f5 (f6 f7 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f5 (f6 f7 (+ ?v0 ?v1)) ?v2) (+ (f5 (f6 f7 ?v0) ?v2) (f5 (f6 f7 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f5 (f6 f7 (- ?v0 ?v1)) ?v2) (- (f5 (f6 f7 ?v0) ?v2) (f5 (f6 f7 ?v1) ?v2)))))
(assert (< 0 (f8 f9 f15)))
(assert (< 0 (+ (* 4 f18) 1)))
(assert (not (= (f19 (f5 (f6 f7 (+ (* 4 f18) 1)) (+ 1 0))) f1)))
(assert (<= 1 f11))
(assert (< f11 (+ (* 4 f18) 1)))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f16 f17 (- (f8 f9 (f16 f17 f11)) 1))) (=> (< 0 (f8 f9 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f8 f9 f10))) (?v_0 (+ (* 4 f18) 1))) (and (< ?v_1 ?v_0) (= (f19 (f5 (f6 f7 ?v_0) ?v_1)) f1))))
(assert (= (f19 (f5 (f6 f7 (+ (* 4 f18) 1)) f11)) f1))
(assert (= (f22 (+ (* 4 f18) 1)) f1))
(assert (= (f5 (f6 f23 (- 1)) (+ (* 4 f18) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (=> (= (+ (f8 (f20 f21 ?v0) ?v_0) (f8 (f20 f21 ?v1) ?v_0)) (f5 (f6 f7 (+ (* 4 f18) 1)) (+ 1 (f8 f9 f10)))) false))) false))
(assert (= (+ (f8 (f20 f21 f24) (f16 f17 2)) 1) (f5 (f6 f7 (+ (* 4 f18) 1)) f11)))
(assert (=> (= f11 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (+ (f8 (f20 f21 ?v0) ?v_0) (f8 (f20 f21 ?v1) ?v_0)) (+ (* 4 f18) 1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f8 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f8 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f16 f17 0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f20 f21 ?v0))) (= (f8 ?v_0 (f16 f17 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f5 (f6 f7 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S5)) (= (f16 f17 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
