(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 (S6 Int) Int)
(declare-fun f11 (S7 Int) S6)
(declare-fun f12 () S7)
(declare-fun f13 () Int)
(declare-fun f14 () S2)
(declare-fun f15 () S3)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 (Int) S1)
(declare-fun f20 (Int) S1)
(declare-fun f21 () S7)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 (Int Int) S1)
(declare-fun f25 () S3)
(declare-fun f26 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_6 (f11 f12 (* 2 f9))) (?v_1 (+ 1 (f3 f14 f15)))) (let ((?v_3 (f10 (f11 f12 f16) ?v_1)) (?v_5 (f11 f12 (* 2 f6))) (?v_2 (f10 (f11 f12 f13) ?v_1)) (?v_0 (f7 f8 2)) (?v_4 (f11 f12 ?v_1))) (let ((?v_7 (f11 f12 (f3 (f4 f5 ?v_1) ?v_0)))) (not (= (+ (+ (- (- (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (f10 ?v_5 ?v_2)) (f10 ?v_6 ?v_3)) (f3 (f4 f5 ?v_2) ?v_0)) (f3 (f4 f5 ?v_3) ?v_0)) (+ (+ (- (- (f10 ?v_4 (+ (* 4 f17) 1)) (f10 ?v_4 (f10 ?v_5 f13))) (f10 ?v_4 (f10 ?v_6 f16))) (f10 ?v_7 (f3 (f4 f5 f13) ?v_0))) (f10 ?v_7 (f3 (f4 f5 f16) ?v_0)))))))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (f10 (f11 f12 (+ (* 4 f17) 1)) (+ 1 (f3 f14 f15))))))
(assert (let ((?v_0 (+ 1 (f3 f14 f15)))) (let ((?v_3 (f10 (f11 f12 f16) ?v_0)) (?v_2 (f10 (f11 f12 f13) ?v_0)) (?v_1 (f7 f8 2))) (= (+ (f3 (f4 f5 (- f6 ?v_2)) ?v_1) (f3 (f4 f5 (- f9 ?v_3)) ?v_1)) (+ (+ (- (- (+ (f3 (f4 f5 f6) ?v_1) (f3 (f4 f5 f9) ?v_1)) (f10 (f11 f12 (* 2 f6)) ?v_2)) (f10 (f11 f12 (* 2 f9)) ?v_3)) (f3 (f4 f5 ?v_2) ?v_1)) (f3 (f4 f5 ?v_3) ?v_1))))))
(assert (< 1 f18))
(assert (< 0 (f3 f14 f15)))
(assert (< 0 (+ (* 4 f17) 1)))
(assert (< 0 (+ 1 (f3 f14 f15))))
(assert (not (= (f19 (f10 (f11 f12 (+ (* 4 f17) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (f10 (f11 f12 (+ (* 4 f17) 1)) (+ 1 (f3 f14 f15))))))
(assert (let ((?v_1 (+ 1 (f3 f14 f15))) (?v_0 (+ (* 4 f17) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f19 (f10 (f11 f12 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (+ 1 (f3 f14 f15)))) (let ((?v_3 (f10 (f11 f12 f16) ?v_0)) (?v_2 (f10 (f11 f12 f13) ?v_0)) (?v_1 (f7 f8 2))) (= (+ (f3 (f4 f5 (- f6 ?v_2)) ?v_1) (f3 (f4 f5 (- f9 ?v_3)) ?v_1)) (+ (+ (- (- (+ (f3 (f4 f5 f6) ?v_1) (f3 (f4 f5 f9) ?v_1)) (f10 (f11 f12 (* 2 f6)) ?v_2)) (f10 (f11 f12 (* 2 f9)) ?v_3)) (f3 (f4 f5 ?v_2) ?v_1)) (f3 (f4 f5 ?v_3) ?v_1))))))
(assert (= (f20 (+ (* 4 f17) 1)) f1))
(assert (= (f10 (f11 f21 (- 1)) (+ (* 4 f17) 1)) 1))
(assert (let ((?v_0 (+ 1 (f3 f14 f15)))) (and (= f22 (- f6 (f10 (f11 f12 f13) ?v_0))) (<= (ite (< f22 0) (* (- 2) f22) (* 2 f22)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f14 f15)))) (and (= f23 (- f9 (f10 (f11 f12 f16) ?v_0))) (<= (ite (< f23 0) (* (- 2) f23) (* 2 f23)) ?v_0))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f14 f15)))) (=> (and (= ?v1 (- f6 (f10 (f11 f12 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f14 f15)))) (=> (and (= ?v1 (- f9 (f10 (f11 f12 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f10 (f11 f12 (+ (* 4 f17) 1)) (+ 1 (f3 f14 f15)))) false))) false))
(assert (let ((?v_1 (+ 1 (f3 f14 f15))) (?v_0 (+ (* 4 f17) 1))) (and (< ?v_1 ?v_0) (= (f19 (f10 (f11 f12 ?v_0) ?v_1)) f1))))
(assert (= (f24 (+ (* 4 f17) 1) (- 1)) f1))
(assert (= f25 (f7 f8 (- (f3 f14 (f7 f8 f18)) 1))))
(assert (let ((?v_1 (+ 1 (f3 f14 f15))) (?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f22) ?v_0) (f3 (f4 f5 f23) ?v_0)) (+ (f3 (f4 f5 (- f6 (f10 (f11 f12 f13) ?v_1))) ?v_0) (f3 (f4 f5 (- f9 (f10 (f11 f12 f16) ?v_1))) ?v_0)))))
(assert (let ((?v_1 (+ 1 (f3 f14 f15)))) (let ((?v_3 (f10 (f11 f12 f16) ?v_1)) (?v_2 (f10 (f11 f12 f13) ?v_1)) (?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f22) ?v_0) (f3 (f4 f5 f23) ?v_0)) (+ (+ (- (- (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (f10 (f11 f12 (* 2 f6)) ?v_2)) (f10 (f11 f12 (* 2 f9)) ?v_3)) (f3 (f4 f5 ?v_2) ?v_0)) (f3 (f4 f5 ?v_3) ?v_0))))))
(assert (< f18 (+ (* 4 f17) 1)))
(assert (= (+ (f3 (f4 f5 f26) (f7 f8 2)) 1) (f10 (f11 f12 (+ (* 4 f17) 1)) f18)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f26) (f7 f8 2)) 1) (f10 (f11 f12 (+ (* 4 f17) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f14 ?v1) (f3 f14 ?v2)))) (f10 (f11 f12 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f10 (f11 f12 ?v0) (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f10 (f11 f12 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f10 (f11 f12 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f10 (f11 f12 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f10 (f11 f12 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (< 0 (f3 f14 f25)))
(assert (<= 1 f18))
(assert (let ((?v_0 (f3 (f4 f5 f26) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f14 (f7 f8 f18)) 1))) (=> (< 0 (f3 f14 ?v0)) false))) false))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f14 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f14 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f14 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
