(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 (S6 Int) Int)
(declare-fun f11 (S7 Int) S6)
(declare-fun f12 () S7)
(declare-fun f13 () S2)
(declare-fun f14 () S3)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (Int) S1)
(declare-fun f22 (Int) S1)
(declare-fun f23 () S7)
(declare-fun f24 (Int Int) S1)
(declare-fun f25 () S3)
(declare-fun f26 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (f11 f12 (+ 1 (f3 f13 f14))))) (not (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (f10 ?v_1 (+ (- (- (+ (* 4 f15) 1) (f10 (f11 f12 (* 2 f16)) f17)) (f10 (f11 f12 (* 2 f18)) f19)) (f10 ?v_1 (+ (f3 (f4 f5 f17) ?v_0) (f3 (f4 f5 f19) ?v_0)))))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_2 (+ 1 (f3 f13 f14)))) (let ((?v_1 (f11 f12 ?v_2)) (?v_3 (f11 f12 (f3 (f4 f5 ?v_2) ?v_0)))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (+ (- (- (f10 ?v_1 (+ (* 4 f15) 1)) (f10 ?v_1 (f10 (f11 f12 (* 2 f16)) f17))) (f10 ?v_1 (f10 (f11 f12 (* 2 f18)) f19))) (f10 ?v_3 (f3 (f4 f5 f17) ?v_0))) (f10 ?v_3 (f3 (f4 f5 f19) ?v_0)))))))
(assert (< 1 f20))
(assert (< 0 (f3 f13 f14)))
(assert (< 0 (+ 1 (f3 f13 f14))))
(assert (< 0 (+ (* 4 f15) 1)))
(assert (not (= (f21 (f10 (f11 f12 (+ (* 4 f15) 1)) (+ 1 0))) f1)))
(assert (let ((?v_1 (+ 1 (f3 f13 f14))) (?v_0 (+ (* 4 f15) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f21 (f10 (f11 f12 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (+ 1 (f3 f13 f14)))) (and (= f6 (- f16 (f10 (f11 f12 f17) ?v_0))) (<= (ite (< f6 0) (* (- 2) f6) (* 2 f6)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f13 f14)))) (and (= f9 (- f18 (f10 (f11 f12 f19) ?v_0))) (<= (ite (< f9 0) (* (- 2) f9) (* 2 f9)) ?v_0))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f18) ?v_0)) (f10 (f11 f12 (+ (* 4 f15) 1)) (+ 1 (f3 f13 f14))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_2 (+ 1 (f3 f13 f14)))) (let ((?v_1 (f11 f12 ?v_2)) (?v_3 (f11 f12 (f3 (f4 f5 ?v_2) ?v_0)))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (+ (- (- (f10 ?v_1 (+ (* 4 f15) 1)) (f10 ?v_1 (f10 (f11 f12 (* 2 f16)) f17))) (f10 ?v_1 (f10 (f11 f12 (* 2 f18)) f19))) (f10 ?v_3 (f3 (f4 f5 f17) ?v_0))) (f10 ?v_3 (f3 (f4 f5 f19) ?v_0)))))))
(assert (= (f22 (+ (* 4 f15) 1)) f1))
(assert (= (f10 (f11 f23 (- 1)) (+ (* 4 f15) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f13 f14)))) (=> (and (= ?v1 (- f16 (f10 (f11 f12 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f13 f14)))) (=> (and (= ?v1 (- f18 (f10 (f11 f12 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f10 (f11 f12 (+ (* 4 f15) 1)) (+ 1 (f3 f13 f14)))) false))) false))
(assert (let ((?v_1 (f7 f8 2)) (?v_0 (+ 1 (f3 f13 f14)))) (let ((?v_2 (f10 (f11 f12 f17) ?v_0)) (?v_3 (f10 (f11 f12 f19) ?v_0))) (= (+ (f3 (f4 f5 (- f16 ?v_2)) ?v_1) (f3 (f4 f5 (- f18 ?v_3)) ?v_1)) (+ (+ (- (- (+ (f3 (f4 f5 f16) ?v_1) (f3 (f4 f5 f18) ?v_1)) (f10 (f11 f12 (* 2 f16)) ?v_2)) (f10 (f11 f12 (* 2 f18)) ?v_3)) (f3 (f4 f5 ?v_2) ?v_1)) (f3 (f4 f5 ?v_3) ?v_1))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f13 f14)))) (let ((?v_4 (f11 f12 ?v_1)) (?v_6 (f11 f12 (* 2 f18))) (?v_5 (f11 f12 (* 2 f16))) (?v_7 (f11 f12 (f3 (f4 f5 ?v_1) ?v_0))) (?v_2 (f10 (f11 f12 f17) ?v_1)) (?v_3 (f10 (f11 f12 f19) ?v_1))) (= (+ (+ (- (- (+ (f3 (f4 f5 f16) ?v_0) (f3 (f4 f5 f18) ?v_0)) (f10 ?v_5 ?v_2)) (f10 ?v_6 ?v_3)) (f3 (f4 f5 ?v_2) ?v_0)) (f3 (f4 f5 ?v_3) ?v_0)) (+ (+ (- (- (f10 ?v_4 (+ (* 4 f15) 1)) (f10 ?v_4 (f10 ?v_5 f17))) (f10 ?v_4 (f10 ?v_6 f19))) (f10 ?v_7 (f3 (f4 f5 f17) ?v_0))) (f10 ?v_7 (f3 (f4 f5 f19) ?v_0)))))))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f13 f14)))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (f3 (f4 f5 (- f16 (f10 (f11 f12 f17) ?v_1))) ?v_0) (f3 (f4 f5 (- f18 (f10 (f11 f12 f19) ?v_1))) ?v_0)))))
(assert (let ((?v_1 (+ 1 (f3 f13 f14))) (?v_0 (+ (* 4 f15) 1))) (and (< ?v_1 ?v_0) (= (f21 (f10 (f11 f12 ?v_0) ?v_1)) f1))))
(assert (= (f24 (+ (* 4 f15) 1) (- 1)) f1))
(assert (= f25 (f7 f8 (- (f3 f13 (f7 f8 f20)) 1))))
(assert (< f20 (+ (* 4 f15) 1)))
(assert (= (+ (f3 (f4 f5 f26) (f7 f8 2)) 1) (f10 (f11 f12 (+ (* 4 f15) 1)) f20)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f26) (f7 f8 2)) 1) (f10 (f11 f12 (+ (* 4 f15) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f13 ?v1) (f3 f13 ?v2)))) (f10 (f11 f12 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f10 (f11 f12 ?v0) (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f10 (f11 f12 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f10 (f11 f12 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f10 (f11 f12 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f10 (f11 f12 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f10 (f11 f12 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f10 (f11 f12 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f10 (f11 f12 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (< 0 (f3 f13 f25)))
(assert (<= 1 f20))
(assert (let ((?v_0 (f3 (f4 f5 f26) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f13 (f7 f8 f20)) 1))) (=> (< 0 (f3 f13 ?v0)) false))) false))
(assert (let ((?v_0 (+ (* 4 f15) 1))) (=> (not (= (f24 ?v_0 (- 1)) f1)) (not (= (f10 (f11 f23 (- 1)) ?v_0) 1)))))
(assert (= (f21 (f10 (f11 f12 (+ (* 4 f15) 1)) f20)) f1))
(assert (=> (= f20 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f15) 1))))))
(assert (= (f22 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f22 ?v_0) f1) (= (f10 (f11 f23 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0) f1) (=> (= (f21 ?v1) f1) (= (f21 (f10 (f11 f12 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 (f11 f12 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 (f11 f12 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f13 ?v2))) (let ((?v_1 (f11 f12 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f10 ?v_1 ?v0) (f10 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f10 ?v_0 ?v0) (f10 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f10 (f11 f12 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f10 (f11 f12 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f12 (- ?v0 ?v1)) ?v2) (- (f10 (f11 f12 ?v0) ?v2) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f10 (f11 f12 (+ ?v0 ?v1)) ?v2) (+ (f10 (f11 f12 ?v0) ?v2) (f10 (f11 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 (f11 f12 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f11 f12 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f10 (f11 f12 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 (- ?v0)) ?v1) (- (f10 (f11 f12 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (- ?v1 ?v2)) (- (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f11 f12 ?v0))) (= (f10 ?v_0 (+ ?v1 ?v2)) (+ (f10 ?v_0 ?v1) (f10 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f10 (f11 f12 ?v0) ?v1) (f10 (f11 f12 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f13 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f13 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
