(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) Int)
(declare-fun f7 () S4)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () S5)
(declare-fun f12 (S6 Int) S5)
(declare-fun f13 () S6)
(declare-fun f14 () Int)
(declare-fun f15 (Int) S1)
(declare-fun f16 (Int) S1)
(declare-fun f17 () S3)
(declare-fun f18 (Int Int) S1)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (S7 Int) S4)
(declare-fun f22 () S7)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(declare-fun f33 () Int)
(declare-fun f34 (S5 S5) S1)
(declare-fun f35 (S10 S5) S5)
(declare-fun f36 (S11 S5) S10)
(declare-fun f37 () S11)
(declare-fun f38 () S2)
(declare-fun f39 () S11)
(assert (not (= f1 f2)))
(assert (not false))
(assert (let ((?v_0 (f6 f7 f8))) (< (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))) 0)))
(assert (let ((?v_0 (f6 f7 f8))) (< (- 1) (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))))))
(assert (< 1 f10))
(assert (< 0 (+ 1 (f6 f7 f8))))
(assert (<= (- (+ 1 (f6 f7 f8)) f9) 0))
(assert (< (- (+ 2 (* 2 (f6 f7 f8))) (* 4 f9)) 0))
(assert (<= (- (+ 4 (* 4 (f6 f7 f8))) (* 4 f9)) 0))
(assert (= f11 (f12 f13 (- (f6 f7 (f12 f13 f10)) 1))))
(assert (<= 1 f10))
(assert (let ((?v_0 (f6 f7 f8))) (<= 0 (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))))))
(assert (let ((?v_0 (f6 f7 f8))) (< (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))) (+ 0 (* 0 ?v_0)))))
(assert (let ((?v_1 (+ 1 (f6 f7 f8)))) (let ((?v_0 (f4 f5 ?v_1))) (<= (* (f3 ?v_0 f9) 4) (* (f3 ?v_0 ?v_1) 2)))))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f12 f13 (- (f6 f7 (f12 f13 f10)) 1))) (=> (< 0 (f6 f7 ?v0)) false))) false))
(assert (< 0 (+ (* 4 f14) 1)))
(assert (< 0 (f6 f7 f8)))
(assert (< 0 (f6 f7 f11)))
(assert (let ((?v_0 (f6 f7 f8))) (< (- 1) (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))))))
(assert (let ((?v_0 (f6 f7 f8))) (< (f3 (f4 f5 (+ 1 ?v_0)) (- (+ 2 (* 2 ?v_0)) (* 4 f9))) 0)))
(assert (not (< f9 (+ 1 (f6 f7 f8)))))
(assert (not (= (f15 (f3 (f4 f5 (+ (* 4 f14) 1)) (+ 1 0))) f1)))
(assert (< f10 (+ (* 4 f14) 1)))
(assert (let ((?v_1 (+ 1 (f6 f7 f8))) (?v_0 (+ (* 4 f14) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f15 (f3 (f4 f5 ?v_0) ?v_1)) f1))))))
(assert (= (f16 (+ (* 4 f14) 1)) f1))
(assert (= (f3 (f4 f17 (- 1)) (+ (* 4 f14) 1)) 1))
(assert (let ((?v_1 (+ 1 (f6 f7 f8))) (?v_0 (+ (* 4 f14) 1))) (and (< ?v_1 ?v_0) (= (f15 (f3 (f4 f5 ?v_0) ?v_1)) f1))))
(assert (= (f15 (f3 (f4 f5 (+ (* 4 f14) 1)) f10)) f1))
(assert (= (f18 (+ (* 4 f14) 1) (- 1)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f8)))) (=> (and (= ?v1 (- f19 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f6 f7 f8)))) (=> (and (= ?v1 (- f20 (f3 (f4 f5 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f6 f7 f8))) (let ((?v_1 (f6 (f21 f22 (+ 1 ?v_0)) (f12 f13 2)))) (<= (f3 (f4 f5 (+ 4 (* 4 ?v_0))) f9) (+ ?v_1 ?v_1)))))
(assert (let ((?v_0 (+ 1 (f6 f7 f8)))) (and (= f23 (- f19 (f3 (f4 f5 f24) ?v_0))) (<= (ite (< f23 0) (* (- 2) f23) (* 2 f23)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f6 f7 f8)))) (and (= f25 (- f20 (f3 (f4 f5 f26) ?v_0))) (<= (ite (< f25 0) (* (- 2) f25) (* 2 f25)) ?v_0))))
(assert (= (+ (f6 (f21 f22 f27) (f12 f13 2)) 1) (f3 (f4 f5 (+ (* 4 f14) 1)) f10)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (=> (= (+ (f6 (f21 f22 ?v0) ?v_0) (f6 (f21 f22 ?v1) ?v_0)) (f3 (f4 f5 (+ (* 4 f14) 1)) (+ 1 (f6 f7 f8)))) false))) false))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (f6 (f21 f22 f19) ?v_0) (f6 (f21 f22 f20) ?v_0)) (f3 (f4 f5 (+ (* 4 f14) 1)) (+ 1 (f6 f7 f8))))))
(assert (let ((?v_0 (+ (* 4 f14) 1))) (=> (not (= (f18 ?v_0 (- 1)) f1)) (not (= (f3 (f4 f17 (- 1)) ?v_0) 1)))))
(assert (=> (= f10 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (+ (f6 (f21 f22 ?v0) ?v_0) (f6 (f21 f22 ?v1) ?v_0)) (+ (* 4 f14) 1))))))
(assert (let ((?v_0 (f6 (f21 f22 f27) (f12 f13 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (and (<= 0 (ite (< f23 0) (* (- 2) f23) (* 2 f23))) (<= 0 (ite (< f25 0) (* (- 2) f25) (* 2 f25)))))
(assert (let ((?v_0 (f12 f13 2))) (let ((?v_1 (f6 (f21 f22 (+ 1 (f6 f7 f8))) ?v_0))) (<= (+ ?v_1 (f6 (f21 f22 (ite (< f25 0) (* (- 2) f25) (* 2 f25))) ?v_0)) (+ ?v_1 ?v_1)))))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (f6 (f21 f22 f23) ?v_0) (f6 (f21 f22 f25) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f7 f8))) f9))))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (* 4 (f6 (f21 f22 f23) ?v_0)) (* 4 (f6 (f21 f22 f25) ?v_0))) (+ (f6 (f21 f22 (ite (< f23 0) (* (- 2) f23) (* 2 f23))) ?v_0) (f6 (f21 f22 (ite (< f25 0) (* (- 2) f25) (* 2 f25))) ?v_0)))))
(assert (let ((?v_0 (f12 f13 2))) (let ((?v_1 (f6 (f21 f22 (ite (< f25 0) (* (- 2) f25) (* 2 f25))) ?v_0))) (<= (+ (f6 (f21 f22 (ite (< f23 0) (* (- 2) f23) (* 2 f23))) ?v_0) ?v_1) (+ (f6 (f21 f22 (+ 1 (f6 f7 f8))) ?v_0) ?v_1)))))
(assert (let ((?v_0 (f12 f13 2))) (= (f3 (f4 f5 (+ 4 (* 4 (f6 f7 f8)))) f9) (+ (* 4 (f6 (f21 f22 f23) ?v_0)) (* 4 (f6 (f21 f22 f25) ?v_0))))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f6 (f21 f22 f27) (f12 f13 2)) 1) (f3 (f4 f5 (+ (* 4 f14) 1)) ?v0)) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f12 f13 2))) (=> (= (+ (f6 (f21 f22 f23) ?v_0) (f6 (f21 f22 f25) ?v_0)) (f3 (f4 f5 (+ 1 (f6 f7 f8))) ?v0)) false))) false))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f16 ?v_0) f1) (= (f3 (f4 f17 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (= (f15 ?v1) f1) (= (f15 (f3 (f4 f5 ?v0) ?v1)) f1)))))
(assert (let ((?v_0 (f12 f13 2))) (= (f28 (+ 1 (f6 f7 f8)) (+ (f6 (f21 f22 f23) ?v_0) (f6 (f21 f22 f25) ?v_0))) f1)))
(assert (= (f28 (+ (* 4 f14) 1) (- (f6 (f21 f22 f27) (f12 f13 2)) (- 1))) f1))
(assert (= (f28 (+ (* 4 f14) 1) (+ (f6 (f21 f22 f27) (f12 f13 2)) 1)) f1))
(assert (= (f29 (f6 (f21 f22 f27) (f12 f13 2)) (- 1) (+ (* 4 f14) 1)) f1))
(assert (= (f30 f31 (f32 f27 1)) (f3 (f4 f5 (+ (* 4 f14) 1)) f10)))
(assert (let ((?v_0 (+ (* 4 f14) 1))) (and (<= 0 f27) (and (< f27 ?v_0) (= (f29 f33 f27 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 ?v1)) (?v_1 (f12 f13 ?v0))) (=> (< 0 ?v0) (= (f6 ?v_0 ?v_1) (f3 (f4 f5 ?v1) (f6 ?v_0 (f12 f13 (- (f6 f7 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f6 (f21 f22 ?v0) ?v_0) (f6 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f12 f13 2)) (?v_0 (f12 f13 3)) (?v_3 (f21 f22 ?v1)) (?v_1 (f21 f22 ?v0))) (= (f6 (f21 f22 (- ?v0 ?v1)) ?v_0) (- (+ (- (f6 ?v_1 ?v_0) (f3 (f4 f5 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f3 (f4 f5 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (= (f29 (f6 (f21 f22 f33) (f12 f13 2)) (- 1) (+ (* 4 f14) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f6 (f21 f22 ?v0) (f12 f13 2)) (- 1) (+ (* 4 f14) 1)) f1) false)) false))
(assert (let ((?v_0 (f12 f13 2))) (= (f29 (f6 (f21 f22 f27) ?v_0) (f6 (f21 f22 f33) ?v_0) (+ (* 4 f14) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f14) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f33 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f14) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f29 ?v0 0 ?v1) f1)) (=> (= (f29 (f6 (f21 f22 ?v2) (f12 f13 2)) ?v0 ?v1) f1) (not (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v0)) (?v_1 (f4 f5 ?v1))) (= (f3 (f4 f5 (f30 f31 (f32 ?v0 ?v1))) (f30 f31 (f32 ?v2 ?v3))) (f30 f31 (f32 (+ (f3 ?v_0 ?v2) (f3 ?v_1 ?v3)) (- (f3 ?v_0 ?v3) (f3 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f16 ?v0) f1) (=> (= (f28 ?v0 (f6 (f21 f22 ?v1) ?v2)) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f6 (f21 f22 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (f3 (f4 f5 ?v3) ?v1)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f6 (f21 f22 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (f3 (f4 f5 ?v1) ?v3)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f3 (f4 f5 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int)) (<= ?v0 (f6 (f21 f22 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f12 f13 2))) (let ((?v_0 (f6 (f21 f22 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f12 f13 3))) (let ((?v_0 (f6 (f21 f22 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f6 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 3))) (= (f6 (f21 f22 (- ?v0)) ?v_0) (- (f6 (f21 f22 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 2)) (?v_1 (f21 f22 ?v0))) (= (f6 (f21 f22 (f6 ?v_1 ?v_0)) ?v_0) (f6 ?v_1 (f12 f13 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (= (f6 (f21 f22 ?v0) ?v_0) (f6 (f21 f22 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (=> (= (f6 (f21 f22 ?v0) (f12 f13 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f16 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (f3 (f4 f5 ?v0) (f6 ?v_0 (f12 f13 2))) (f6 ?v_0 (f12 f13 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f6 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (+ (f6 (f21 f22 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f6 (f21 f22 (- ?v0 ?v1)) ?v_0) (+ (- (f6 (f21 f22 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f6 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f12 f13 2)) (?v_0 (f12 f13 3)) (?v_1 (f21 f22 ?v0)) (?v_3 (f21 f22 ?v1))) (= (f6 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f6 ?v_1 ?v_0) (f3 (f4 f5 (* 3 (f6 ?v_1 ?v_2))) ?v1)) (f3 (f4 f5 (* 3 ?v0)) (f6 ?v_3 ?v_2))) (f6 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int)) (= (= (f15 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f30 f31 (f32 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (= (f29 (f6 (f21 f22 ?v1) (f12 f13 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f17 ?v0) ?v1) (ite (= (f29 ?v0 0 ?v1) f1) 0 (ite (= (f18 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f18 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f29 (f6 (f21 f22 ?v2) (f12 f13 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f16 ?v0) f1) (=> (= (f28 ?v0 (f6 (f21 f22 ?v1) ?v2)) f1) (=> (< 0 (f6 f7 ?v2)) (= (f28 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f16 ?v1) f1) (=> (= (f28 ?v1 (f3 (f4 f5 ?v0) ?v2)) f1) (or (= (f28 ?v1 ?v0) f1) (= (f28 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (= (f28 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (or (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f4 f5 ?v1))) (= (+ (f3 (f4 f5 (- ?v0 (f3 ?v_0 ?v2))) ?v3) (f3 (f4 f5 (- ?v4 (f3 ?v_0 ?v5))) ?v6)) (- (+ (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v4) ?v6)) (f3 ?v_0 (+ (f3 (f4 f5 ?v2) ?v3) (f3 (f4 f5 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v1 ?v3 ?v2) f1) (= (f29 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v1 (- 1) ?v0) f1) (not (= (f29 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f29 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f29 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int)) (= (f29 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 (- ?v2)) f1) (= (f29 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f3 (f4 f5 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f29 (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f3 (f4 f5 ?v0) ?v4) ?v2) f1) (= (f29 ?v3 (f3 (f4 f5 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f4 f5 ?v4))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f3 ?v_0 ?v0) ?v2) f1) (= (f29 ?v3 (f3 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v3))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S5)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f6 (f21 f22 ?v0) ?v3) (f6 (f21 f22 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 ?v1 ?v2) f1) (= (f28 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (=> (< 0 (f6 f7 ?v0)) (=> (= (f28 ?v1 ?v2) f1) (= (f28 ?v1 (f6 (f21 f22 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f16 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f28 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (not (= (f29 ?v1 0 ?v0) f1)) (=> (not (= (f29 ?v2 0 ?v0) f1)) (not (= (f29 (f3 (f4 f5 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f29 (f3 (f4 f5 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f29 ?v1 0 ?v0) f1)) (not (= (f29 ?v2 0 ?v0) f1))) (not (= (f29 (f3 (f4 f5 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f29 (f3 (f4 f5 ?v1) ?v2) 0 ?v0) f1) (or (= (f29 ?v1 0 ?v0) f1) (= (f29 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0) f1) (=> (< 0 ?v1) (=> (= (f29 (f3 (f4 f5 ?v1) ?v1) 1 ?v0) f1) (or (= (f29 ?v1 1 ?v0) f1) (= (f29 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f16 ?v1) f1) (= (f28 ?v1 ?v0) f1))))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f12 f13 0))) (= (= (f28 (f6 (f21 f22 ?v1) ?v0) (f6 (f21 f22 ?v2) ?v0)) f1) (= (f28 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (= (f28 (f6 (f21 f22 ?v0) ?v1) (f6 (f21 f22 ?v2) ?v1)) f1) (=> (not (= ?v1 (f12 f13 0))) (= (f28 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 (- 1)))) (let ((?v_1 (f6 ?v_0 ?v1)) (?v_2 (f6 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f29 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 (+ ?v1 (f3 (f4 f5 ?v0) ?v2))) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f28 (f3 (f4 f5 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (- ?v1 ?v2)) (- (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 (- ?v0)) ?v1) (- (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v2) (- (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f6 f7 ?v2))) (let ((?v_1 (f4 f5 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f3 ?v_1 ?v0) (f3 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f29 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f6 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f6 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f12 f13 0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f6 (f21 f22 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int)) (= (= (f28 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f28 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f28 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 (- ?v1 ?v2)) f1) (=> (= (f28 ?v0 ?v2) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f6 ?v_0 (f12 f13 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f28 (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (= (f28 ?v0 (+ ?v2 ?v3)) f1) (= (f28 ?v0 (+ (+ ?v2 (f3 (f4 f5 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (not (= ?v0 0)) (= (= (f28 ?v1 ?v2) f1) (= (f28 (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f29 (f3 (f4 f5 ?v0) ?v_0) 1 ?v1) f1) (= (f29 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f21 f22 ?v0))) (=> (= (f28 (f6 ?v_0 ?v1) ?v2) f1) (=> (<= (f6 f7 ?v3) (f6 f7 ?v1)) (= (f28 (f6 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f34 (f35 ?v_0 ?v1) ?v2) f1) (=> (<= (f6 f7 ?v3) (f6 f7 ?v1)) (= (f34 (f35 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S5)) (=> (= (f28 ?v0 ?v1) f1) (=> (<= (f6 f7 ?v2) (f6 f7 ?v3)) (= (f28 (f6 (f21 f22 ?v0) ?v2) (f6 (f21 f22 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f34 ?v0 ?v1) f1) (=> (<= (f6 f7 ?v2) (f6 f7 ?v3)) (= (f34 (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f12 f13 (f6 (f21 f22 ?v0) ?v1)) (f35 (f36 f37 (f12 f13 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f21 f22 (f6 f7 ?v0)) ?v1) (f6 f7 (f35 (f36 f37 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f7 (f35 (f36 f37 ?v0) ?v1)) (f6 (f21 f22 (f6 f7 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (= (f34 (f12 f13 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f28 ?v0 (f6 f7 ?v1)) f1) (= ?v1 (f12 f13 0))))))
(assert (forall ((?v0 S5) (?v1 Int)) (= (= (f28 (f6 f7 ?v0) ?v1) f1) (= (f34 ?v0 (f12 f13 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (= (f28 ?v0 (f6 f7 ?v1)) f1) (= (f34 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f34 ?v0 ?v1) f1) (= (f28 (f6 f7 ?v0) (f6 f7 ?v1)) f1))))
(assert (forall ((?v0 Int)) (= (f6 (f21 f22 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f35 (f36 f37 ?v0) (f12 f13 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S5)) (= (f3 f38 (f6 (f21 f22 ?v0) ?v1)) (f6 (f21 f22 (f3 f38 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f3 (f4 f5 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f3 (f4 f5 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 ?v1) f1) (= (f28 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 Int)) (=> (= (f16 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f6 (f21 f22 (f3 (f4 f5 ?v0) ?v1)) ?v2) (f3 (f4 f5 (f6 (f21 f22 ?v0) ?v2)) (f6 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f35 (f36 f37 (f35 (f36 f39 ?v0) ?v1)) ?v2) (f35 (f36 f39 (f35 (f36 f37 ?v0) ?v2)) (f35 (f36 f37 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f6 (f21 f22 ?v0) ?v1))) (= (f3 (f4 f5 ?v_0) ?v0) (f3 (f4 f5 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f35 (f36 f37 ?v0) ?v1))) (= (f35 (f36 f39 ?v_0) ?v0) (f35 (f36 f39 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f6 ?v_0 (f12 f13 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (f3 (f4 f5 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f12 f13 (+ (f6 f7 ?v1) (f6 f7 ?v2)))) (f35 (f36 f39 (f35 ?v_0 ?v1)) (f35 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f6 ?v_0 (f12 f13 (+ (f6 f7 ?v1) 1))) (f3 (f4 f5 (f6 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f12 f13 (+ (f6 f7 ?v1) 1))) (f35 (f36 f39 (f35 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f6 ?v_0 (f12 f13 (+ (f6 f7 ?v1) 1))) (f3 (f4 f5 ?v0) (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f12 f13 (+ (f6 f7 ?v1) 1))) (f35 (f36 f39 ?v0) (f35 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f28 ?v0 ?v1) f1) (= (f28 (f6 (f21 f22 ?v0) ?v2) (f6 (f21 f22 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 Int)) (let ((?v_0 (f21 f22 ?v2))) (=> (<= (f6 f7 ?v0) (f6 f7 ?v1)) (= (f28 (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f36 f37 ?v2))) (=> (<= (f6 f7 ?v0) (f6 f7 ?v1)) (= (f34 (f35 ?v_0 ?v0) (f35 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f28 ?v0 (f3 (f4 f5 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f34 ?v0 (f35 (f36 f39 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f28 ?v0 (f3 (f4 f5 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f34 ?v0 (f35 (f36 f39 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 ?v0 (f35 (f36 f39 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f6 (f21 f22 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f12 f13 (f3 (f4 f5 (f6 f7 ?v1)) (f6 f7 ?v2))))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 1))) (=> (= (f34 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (< 0 (f6 f7 ?v0)) (=> (= (f34 ?v1 ?v0) f1) (< 0 (f6 f7 ?v1))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 0))) (=> (= (f34 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 1))) (= (= (f34 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 0))) (= (= (f34 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 0))) (= (not (= ?v0 ?v_0)) (and (= (f34 ?v0 ?v_0) f1) (not (= (f34 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 1))) (= (not (= ?v0 ?v_0)) (and (= (f34 ?v_0 ?v0) f1) (not (= (f34 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S5)) (= (f34 ?v0 (f12 f13 0)) f1)))
(assert (forall ((?v0 S5)) (= (f34 (f12 f13 1) ?v0) f1)))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 1))) (not (and (= (f34 ?v0 ?v_0) f1) (not (= (f34 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 0))) (not (and (= (f34 ?v_0 ?v0) f1) (not (= (f34 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (not (= ?v0 (f12 f13 0))) (= (= (f34 (f35 (f36 f37 ?v1) ?v0) (f35 (f36 f37 ?v2) ?v0)) f1) (= (f34 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f34 (f35 ?v_0 ?v1) (f35 ?v_0 ?v2)) f1) (=> (< 1 (f6 f7 ?v0)) (<= (f6 f7 ?v1) (f6 f7 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (< 0 (f6 f7 (f35 (f36 f37 ?v0) ?v1))) (or (< 0 (f6 f7 ?v0)) (= ?v1 (f12 f13 0))))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f12 f13 (+ 0 1)))) (= (f35 (f36 f37 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f12 f13 (+ 0 1)))) (= (= (f35 (f36 f37 ?v0) ?v1) ?v_0) (or (= ?v1 (f12 f13 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f36 f37 ?v0))) (=> (< 0 (f6 f7 ?v0)) (=> (< (f6 f7 (f35 ?v_0 ?v1)) (f6 f7 (f35 ?v_0 ?v2))) (< (f6 f7 ?v1) (f6 f7 ?v2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f6 f7 ?v0)) (<= ?v_0 (f6 f7 (f35 (f36 f37 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f6 ?v_0 (f12 f13 (f3 (f4 f5 (f6 f7 ?v1)) (f6 f7 ?v2)))) (f6 (f21 f22 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f36 f37 ?v0))) (= (f35 ?v_0 (f12 f13 (f3 (f4 f5 (f6 f7 ?v1)) (f6 f7 ?v2)))) (f35 (f36 f37 (f35 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f12 f13 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f12 f13 (f3 (f4 f5 (f6 f7 (f12 f13 (ite (< ?v0 0) (- ?v0) ?v0)))) (f6 f7 (f12 f13 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f3 (f4 f5 (f6 f7 ?v0)) (f6 f7 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f3 (f4 f5 (f6 f7 ?v0)) (f6 f7 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f12 f13 (f3 (f4 f5 ?v0) ?v1)) (f12 f13 (f3 (f4 f5 (f6 f7 (f12 f13 ?v0))) (f6 f7 (f12 f13 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f12 f13 (f3 (f4 f5 ?v0) ?v1)) (f12 f13 (f3 (f4 f5 (f6 f7 (f12 f13 (- ?v0)))) (f6 f7 (f12 f13 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f21 f22 ?v0))) (=> (= (f29 (f6 ?v_0 ?v1) 1 ?v2) f1) (= (f29 (f6 ?v_0 (f12 f13 (f3 (f4 f5 (f6 f7 ?v1)) (f6 f7 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f38 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f3 f38 ?v0)) (f3 f38 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f38 ?v0))) (= (f3 (f4 f5 ?v_0) ?v_0) (f3 (f4 f5 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (= (f28 ?v0 ?v0) f1)))
(assert (forall ((?v0 S5)) (= (f34 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 (f3 f38 ?v1)) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 (f3 f38 ?v0) ?v1) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v2) f1) (= (f28 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f34 ?v0 ?v1) f1) (=> (= (f34 ?v1 ?v2) f1) (= (f34 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 f38 ?v0) (f3 f38 ?v1)) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 (f3 (f4 f5 ?v0) ?v1) ?v2) f1) (= (f28 ?v1 ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f34 (f35 (f36 f39 ?v0) ?v1) ?v2) f1) (= (f34 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 (f3 (f4 f5 ?v0) ?v1) ?v2) f1) (= (f28 ?v0 ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f34 (f35 (f36 f39 ?v0) ?v1) ?v2) f1) (= (f34 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f3 (f4 f5 ?v1) ?v2)) (= (f28 ?v1 ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 (f35 (f36 f39 ?v1) ?v2)) (= (f34 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v2 ?v3) f1) (= (f28 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f34 ?v0 ?v1) f1) (=> (= (f34 ?v2 ?v3) f1) (= (f34 (f35 (f36 f39 ?v0) ?v2) (f35 (f36 f39 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (f28 ?v0 (f3 (f4 f5 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 ?v0 (f35 (f36 f39 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S5)) (= (f34 ?v0 ?v0) f1)))
(assert (forall ((?v0 S5)) (= (f34 (f12 f13 (+ 0 1)) ?v0) f1)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 (f12 f13 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f12 f13 (f3 (f4 f5 ?v_0) ?v_0)) (f12 f13 (+ (f3 (f4 f5 (f6 f7 (f12 f13 (- ?v0 1)))) (f6 f7 (f12 f13 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1)) (?v_2 (f6 f7 ?v0)) (?v_1 (f6 f7 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f3 (f4 f5 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1)) (?v_1 (f6 f7 ?v0)) (?v_2 (f6 f7 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f3 (f4 f5 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (+ 0 1)) (?v_1 (f6 f7 ?v0)) (?v_2 (f6 f7 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f3 (f4 f5 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 (f12 f13 (f3 (f4 f5 (f6 f7 ?v0)) (f6 f7 ?v1)))) (or (= ?v1 (f12 f13 1)) (= ?v0 (f12 f13 0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_2 (f6 f7 ?v1)) (?v_0 (f6 f7 ?v0)) (?v_3 (f6 f7 ?v3)) (?v_1 (f6 f7 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f3 (f4 f5 ?v_0) ?v_1) (f3 (f4 f5 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_3 (f6 f7 ?v1)) (?v_1 (f6 f7 ?v0)) (?v_0 (f6 f7 ?v2))) (let ((?v_2 (f4 f5 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f3 ?v_2 ?v_1) (f3 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_2 (f6 f7 ?v1)) (?v_0 (f6 f7 ?v0)) (?v_1 (f6 f7 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f3 (f4 f5 ?v_0) ?v_1) (f3 (f4 f5 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_2 (f6 f7 ?v1)) (?v_0 (f6 f7 ?v0)) (?v_1 (f4 f5 (f6 f7 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f3 ?v_1 ?v_0) (f3 ?v_1 ?v_2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f6 f7 ?v1)) (?v_0 (f6 f7 ?v0)) (?v_2 (f6 f7 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f3 (f4 f5 ?v_0) ?v_2) (f3 (f4 f5 ?v_1) ?v_2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f4 f5 (+ (f6 f7 ?v0) 1))) (?v_2 (f6 f7 ?v2)) (?v_1 (f6 f7 ?v1))) (= (<= (f3 ?v_0 ?v_1) (f3 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f4 f5 (+ (f6 f7 ?v0) 1))) (?v_2 (f6 f7 ?v2)) (?v_1 (f6 f7 ?v1))) (= (< (f3 ?v_0 ?v_1) (f3 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f4 f5 (+ (f6 f7 ?v0) 1)))) (= (= (f12 f13 (f3 ?v_0 (f6 f7 ?v1))) (f12 f13 (f3 ?v_0 (f6 f7 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f6 f7 ?v1))) (= (= (f12 f13 (f3 (f4 f5 (f6 f7 ?v0)) ?v_0)) (f12 f13 (f3 (f4 f5 (f6 f7 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f12 f13 0)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f4 f5 (f6 f7 ?v0)))) (= (= (f12 f13 (f3 ?v_0 (f6 f7 ?v1))) (f12 f13 (f3 ?v_0 (f6 f7 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f12 f13 0)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_2 (f6 f7 ?v2)) (?v_0 (f6 f7 ?v1)) (?v_1 (f6 f7 ?v0))) (= (<= (f3 (f4 f5 ?v_1) ?v_0) (f3 (f4 f5 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f6 f7 ?v0))) (let ((?v_0 (f4 f5 ?v_1)) (?v_3 (f6 f7 ?v2)) (?v_2 (f6 f7 ?v1))) (= (<= (f3 ?v_0 ?v_2) (f3 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_2 (f6 f7 ?v2)) (?v_0 (f6 f7 ?v1)) (?v_1 (f6 f7 ?v0))) (= (< (f3 (f4 f5 ?v_1) ?v_0) (f3 (f4 f5 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f6 f7 ?v0))) (let ((?v_0 (f4 f5 ?v_1)) (?v_3 (f6 f7 ?v2)) (?v_2 (f6 f7 ?v1))) (= (< (f3 ?v_0 ?v_2) (f3 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f12 f13 (+ 0 1)))) (= (= (f12 f13 (f3 (f4 f5 (f6 f7 ?v0)) (f6 f7 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_2 (f6 f7 ?v1)) (?v_0 (f6 f7 ?v0)) (?v_1 (f6 f7 ?v2))) (= (f12 f13 (f3 (f4 f5 (f6 f7 (f12 f13 (- ?v_0 ?v_2)))) ?v_1)) (f12 f13 (- (f3 (f4 f5 ?v_0) ?v_1) (f3 (f4 f5 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f6 f7 ?v0)) (?v_2 (f6 f7 ?v1)) (?v_1 (f6 f7 ?v2))) (= (f12 f13 (f3 (f4 f5 (+ ?v_0 ?v_2)) ?v_1)) (f12 f13 (+ (f3 (f4 f5 ?v_0) ?v_1) (f3 (f4 f5 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f4 f5 (f6 f7 ?v0))) (?v_1 (f6 f7 ?v1)) (?v_2 (f6 f7 ?v2))) (= (f12 f13 (f3 (f4 f5 (f3 ?v_0 ?v_1)) ?v_2)) (f12 f13 (f3 ?v_0 (f3 (f4 f5 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f12 f13 0))) (= (= (f12 f13 (f3 (f4 f5 (f6 f7 ?v0)) (f6 f7 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f12 f13 1))) (= (= (f12 f13 (f3 (f4 f5 (f6 f7 ?v0)) (f6 f7 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_1 (f6 f7 ?v0)) (?v_0 (f6 f7 ?v1))) (= (f12 f13 (f3 (f4 f5 (+ ?v_1 1)) ?v_0)) (f12 f13 (+ ?v_0 (f3 (f4 f5 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S5)) (= (f12 f13 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f6 f7 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
