(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) Int)
(declare-fun f7 (S6 Int) S5)
(declare-fun f8 () S6)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 (S7 Int) S3)
(declare-fun f15 () S7)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () S2)
(declare-fun f19 () S3)
(declare-fun f20 (Int) S1)
(declare-fun f21 (Int) S1)
(declare-fun f22 () S6)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 () S3)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 f9)) (?v_1 (f7 f8 f11)) (?v_2 (f14 f15 2))) (not (= (+ (f3 (f4 f5 (+ (+ (f6 ?v_0 f10) (f6 ?v_1 f12)) f13)) ?v_2) (f3 (f4 f5 (- (f6 ?v_0 f12) (f6 ?v_1 f10))) ?v_2)) (f6 (f7 f8 (+ (* 4 f16) 1)) f13)))))
(assert (< 1 f17))
(assert (< 0 (f3 f18 f19)))
(assert (< 0 (+ (* 4 f16) 1)))
(assert (not (= (f20 (f6 (f7 f8 (+ (* 4 f16) 1)) (+ 1 0))) f1)))
(assert (= (f21 (+ (* 4 f16) 1)) f1))
(assert (= (f6 (f7 f22 (- 1)) (+ (* 4 f16) 1)) 1))
(assert (let ((?v_0 (f14 f15 2))) (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f18 f19))) f13))))
(assert (= (f23 (+ (* 4 f16) 1) (- 1)) f1))
(assert (= f24 (f14 f15 (- (f3 f18 (f14 f15 f17)) 1))))
(assert (let ((?v_0 (+ 1 (f3 f18 f19)))) (and (= f10 (- f25 (f6 (f7 f8 f9) ?v_0))) (<= (ite (< f10 0) (* (- 2) f10) (* 2 f10)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f18 f19)))) (and (= f12 (- f26 (f6 (f7 f8 f11) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (< f17 (+ (* 4 f16) 1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f14 f15 2))) (=> (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f18 f19))) ?v0)) false))) false))
(assert (= (+ (f3 (f4 f5 f27) (f14 f15 2)) 1) (f6 (f7 f8 (+ (* 4 f16) 1)) f17)))
(assert (let ((?v_0 (+ (* 4 f16) 1)) (?v_1 (+ 1 (f3 f18 f19)))) (not (=> (< ?v_1 ?v_0) (not (= (f20 (f6 (f7 f8 ?v_0) ?v_1)) f1))))))
(assert (< f13 (+ 1 (f3 f18 f19))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f27) (f14 f15 2)) 1) (f6 (f7 f8 (+ (* 4 f16) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f14 f15 (+ (f3 f18 ?v1) (f3 f18 ?v2)))) (f6 (f7 f8 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f6 (f7 f8 ?v0) (f3 ?v_0 (f14 f15 2))) (f3 ?v_0 (f14 f15 3))))))
(assert (< 0 (f3 f18 f24)))
(assert (< 0 (+ 1 (f3 f18 f19))))
(assert (<= 1 f17))
(assert (let ((?v_0 (f3 (f4 f5 f27) (f14 f15 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f14 f15 (- (f3 f18 (f14 f15 f17)) 1))) (=> (< 0 (f3 f18 ?v0)) false))) false))
(assert (let ((?v_0 (+ (* 4 f16) 1))) (=> (not (= (f23 ?v_0 (- 1)) f1)) (not (= (f6 (f7 f22 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (f14 f15 2))) (= (+ (f3 (f4 f5 f25) ?v_0) (f3 (f4 f5 f26) ?v_0)) (f6 (f7 f8 (+ (* 4 f16) 1)) (+ 1 (f3 f18 f19))))))
(assert (let ((?v_0 (+ (* 4 f16) 1)) (?v_1 (+ 1 (f3 f18 f19)))) (and (< ?v_1 ?v_0) (= (f20 (f6 (f7 f8 ?v_0) ?v_1)) f1))))
(assert (= (f20 (f6 (f7 f8 (+ (* 4 f16) 1)) f17)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f18 f19)))) (=> (and (= ?v1 (- f26 (f6 (f7 f8 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f18 f19)))) (=> (and (= ?v1 (- f25 (f6 (f7 f8 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f6 (f7 f8 (+ (* 4 f16) 1)) (+ 1 (f3 f18 f19)))) false))) false))
(assert (=> (= f17 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f16) 1))))))
(assert (= (f21 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f21 ?v_0) f1) (= (f6 (f7 f22 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f20 ?v0) f1) (=> (= (f20 ?v1) f1) (= (f20 (f6 (f7 f8 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f18 ?v2))) (let ((?v_1 (f7 f8 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f6 ?v_1 ?v0) (f6 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f6 (f7 f8 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v2) (- (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v2) (+ (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 (- ?v0)) ?v1) (- (f6 (f7 f8 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (- ?v1 ?v2)) (- (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (+ ?v1 ?v2)) (+ (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f14 f15 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f14 f15 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f14 f15 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f14 f15 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f14 f15 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f14 f15 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f14 f15 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f14 f15 2)) (?v_0 (f14 f15 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f14 f15 2)) (?v_0 (f14 f15 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 S3)) (= (f14 f15 (f3 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f18 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f18 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
