(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) Int)
(declare-fun f7 (S6 Int) S5)
(declare-fun f8 () S6)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 (S7 Int) S3)
(declare-fun f14 () S7)
(declare-fun f15 () Int)
(declare-fun f16 () S2)
(declare-fun f17 () S3)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () S3)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 (Int) S1)
(declare-fun f25 (Int) S1)
(declare-fun f26 () S6)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (S3 S3) S1)
(declare-fun f30 (S8 S3) S3)
(declare-fun f31 (S9 S3) S8)
(declare-fun f32 () S9)
(declare-fun f33 () S5)
(declare-fun f34 () S9)
(declare-fun f35 (Int Int Int) S1)
(declare-fun f36 (S10 S11) Int)
(declare-fun f37 () S10)
(declare-fun f38 (Int Int) S11)
(declare-fun f39 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 f9)) (?v_1 (f7 f8 f11)) (?v_2 (f13 f14 2)) (?v_3 (+ 1 (f3 f16 f17)))) (let ((?v_4 (f7 f8 (+ (f6 (f7 f8 f15) ?v_3) f10))) (?v_5 (f7 f8 (+ (f6 (f7 f8 f18) ?v_3) f12)))) (not (= (+ (f3 (f4 f5 (+ (f6 ?v_0 f10) (f6 ?v_1 f12))) ?v_2) (f3 (f4 f5 (- (f6 ?v_0 f12) (f6 ?v_1 f10))) ?v_2)) (+ (f3 (f4 f5 (+ (f6 ?v_4 f10) (f6 ?v_5 f12))) ?v_2) (f3 (f4 f5 (- (f6 ?v_4 f12) (f6 ?v_5 f10))) ?v_2)))))))
(assert (let ((?v_0 (+ 1 (f3 f16 f17)))) (and (= f10 (- f9 (f6 (f7 f8 f15) ?v_0))) (<= (ite (< f10 0) (* (- 2) f10) (* 2 f10)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f16 f17)))) (and (= f12 (- f11 (f6 (f7 f8 f18) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (let ((?v_1 (f7 f8 f9)) (?v_2 (f7 f8 f11)) (?v_0 (f13 f14 2))) (= (f6 (f7 f8 (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0))) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) (+ (f3 (f4 f5 (+ (f6 ?v_1 f10) (f6 ?v_2 f12))) ?v_0) (f3 (f4 f5 (- (f6 ?v_1 f12) (f6 ?v_2 f10))) ?v_0)))))
(assert (< 1 f19))
(assert (< 0 (f3 f16 f17)))
(assert (< 0 (+ 1 (f3 f16 f17))))
(assert (let ((?v_1 (f7 f8 f9)) (?v_2 (f7 f8 f11)) (?v_0 (f13 f14 2))) (= (f6 (f7 f8 (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0))) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) (+ (f3 (f4 f5 (+ (f6 ?v_1 f10) (f6 ?v_2 f12))) ?v_0) (f3 (f4 f5 (- (f6 ?v_1 f12) (f6 ?v_2 f10))) ?v_0)))))
(assert (let ((?v_0 (+ 1 (f3 f16 f17)))) (and (= f10 (- f9 (f6 (f7 f8 f15) ?v_0))) (<= (ite (< f10 0) (* (- 2) f10) (* 2 f10)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f16 f17)))) (and (= f12 (- f11 (f6 (f7 f8 f18) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (< f20 (+ 1 (f3 f16 f17))))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f16 f17))) f20))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f16 f17)))) (=> (and (= ?v1 (- f9 (f6 (f7 f8 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f16 f17)))) (=> (and (= ?v1 (- f11 (f6 (f7 f8 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f16 f17))) ?v0)) false))) false))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0)) (f6 (f7 f8 (+ (* 4 f21) 1)) (+ 1 (f3 f16 f17))))))
(assert (= f22 (f13 f14 (- (f3 f16 (f13 f14 f19)) 1))))
(assert (let ((?v_0 (f13 f14 2))) (let ((?v_1 (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0)))) (= (f6 (f7 f8 (f6 (f7 f8 (+ (* 4 f21) 1)) (+ 1 (f3 f16 f17)))) ?v_1) (f6 (f7 f8 (+ (f3 (f4 f5 f9) ?v_0) (f3 (f4 f5 f11) ?v_0))) ?v_1)))))
(assert (let ((?v_1 (f7 f8 f9)) (?v_2 (f7 f8 f11)) (?v_0 (f13 f14 2))) (= (f6 (f7 f8 (f6 (f7 f8 (+ (* 4 f21) 1)) (+ 1 (f3 f16 f17)))) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) (+ (f3 (f4 f5 (+ (f6 ?v_1 f10) (f6 ?v_2 f12))) ?v_0) (f3 (f4 f5 (- (f6 ?v_1 f12) (f6 ?v_2 f10))) ?v_0)))))
(assert (let ((?v_0 (f13 f14 2))) (= (f23 (+ 1 (f3 f16 f17)) (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f12) ?v_0))) f1)))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f16 ?v1) (f3 f16 ?v2)))) (f6 (f7 f8 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f6 (f7 f8 ?v0) (f3 ?v_0 (f13 f14 2))) (f3 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (< 0 (f3 f16 f22)))
(assert (< 0 (+ (* 4 f21) 1)))
(assert (<= 1 f19))
(assert (not (= (f24 (f6 (f7 f8 (+ (* 4 f21) 1)) (+ 1 0))) f1)))
(assert (< f19 (+ (* 4 f21) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f13 f14 (- (f3 f16 (f13 f14 f19)) 1))) (=> (< 0 (f3 f16 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f3 f16 f17))) (?v_0 (+ (* 4 f21) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f24 (f6 (f7 f8 ?v_0) ?v_1)) f1))))))
(assert (= (f25 (+ (* 4 f21) 1)) f1))
(assert (= (f6 (f7 f26 (- 1)) (+ (* 4 f21) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f6 (f7 f8 (+ (* 4 f21) 1)) (+ 1 (f3 f16 f17)))) false))) false))
(assert (= (+ (f3 (f4 f5 f27) (f13 f14 2)) 1) (f6 (f7 f8 (+ (* 4 f21) 1)) f19)))
(assert (let ((?v_1 (+ 1 (f3 f16 f17))) (?v_0 (+ (* 4 f21) 1))) (and (< ?v_1 ?v_0) (= (f24 (f6 (f7 f8 ?v_0) ?v_1)) f1))))
(assert (= (f24 (f6 (f7 f8 (+ (* 4 f21) 1)) f19)) f1))
(assert (=> (= f19 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f21) 1))))))
(assert (forall ((?v0 Int)) (= (= (f23 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f23 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f23 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f23 ?v0 (- ?v1 ?v2)) f1) (=> (= (f23 ?v0 ?v2) f1) (= (f23 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f23 (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f23 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1) f1) (= (= (f23 ?v0 (+ ?v2 ?v3)) f1) (= (f23 ?v0 (+ (+ ?v2 (f6 (f7 f8 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f23 (f6 (f7 f8 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 (+ ?v1 (f6 (f7 f8 ?v0) ?v2))) f1) (= (f23 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f16 ?v2))) (let ((?v_1 (f7 f8 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f6 ?v_1 ?v0) (f6 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f6 (f7 f8 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v2) (- (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v2) (+ (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 (- ?v0)) ?v1) (- (f6 (f7 f8 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (- ?v1 ?v2)) (- (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (+ ?v1 ?v2)) (+ (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f13 f14 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f13 f14 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (= (f28 (+ (* 4 f21) 1) (- 1)) f1))
(assert (= (f23 (+ (* 4 f21) 1) (- (f3 (f4 f5 f27) (f13 f14 2)) (- 1))) f1))
(assert (= (f23 (+ (* 4 f21) 1) (+ (f3 (f4 f5 f27) (f13 f14 2)) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f27) (f13 f14 2)) 1) (f6 (f7 f8 (+ (* 4 f21) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f23 (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v2) ?v1)) f1) (=> (not (= ?v1 (f13 f14 0))) (= (f23 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f16 ?v0)) (=> (= (f23 ?v1 ?v2) f1) (= (f23 ?v1 (f3 (f4 f5 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f13 f14 0))) (= (= (f23 (f3 (f4 f5 ?v1) ?v0) (f3 (f4 f5 ?v2) ?v0)) f1) (= (f23 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (=> (not (= ?v0 0)) (= (= (f23 ?v1 ?v2) f1) (= (f23 (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f13 f14 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f6 (f7 f8 ?v1) (f3 ?v_0 (f13 f14 (- (f3 f16 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f23 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f16 ?v3) (f3 f16 ?v1)) (= (f23 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f31 f32 ?v0))) (=> (= (f29 (f30 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f16 ?v3) (f3 f16 ?v1)) (= (f29 (f30 ?v_0 ?v3) ?v2) f1))))))
(assert (let ((?v_0 (f3 (f4 f5 f27) (f13 f14 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (+ (* 4 f21) 1))) (=> (not (= (f28 ?v_0 (- 1)) f1)) (not (= (f6 (f7 f26 (- 1)) ?v_0) 1)))))
(assert (= (f25 2) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f25 ?v_0) f1) (= (f6 (f7 f26 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f16 (f30 (f31 f32 ?v0) ?v1)) (f3 (f4 f5 (f3 f16 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f16 ?v0)) ?v1) (f3 f16 (f30 (f31 f32 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f13 f14 (f3 (f4 f5 ?v0) ?v1)) (f30 (f31 f32 (f13 f14 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f29 (f13 f14 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f23 ?v0 (f3 f16 ?v1)) f1) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f23 (f3 f16 ?v0) ?v1) f1) (= (f29 ?v0 (f13 f14 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f23 ?v0 (f3 f16 ?v1)) f1) (= (f29 (f13 f14 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f29 ?v0 ?v1) f1) (= (f23 (f3 f16 ?v0) (f3 f16 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f25 ?v0) f1) (=> (= (f23 ?v0 (f6 (f7 f8 ?v1) ?v2)) f1) (or (= (f23 ?v0 ?v1) f1) (= (f23 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f25 ?v0) f1) (=> (= (f23 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (=> (< 0 (f3 f16 ?v2)) (= (f23 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f25 ?v0) f1) (=> (= (f23 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (= (f23 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f24 ?v0) f1) (=> (= (f24 ?v1) f1) (= (f24 (f6 (f7 f8 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f6 f33 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f6 f33 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f30 (f31 f32 ?v0) (f13 f14 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f25 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (=> (= (f23 ?v_0 (f6 (f7 f8 ?v1) ?v3)) f1) (= (f23 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v2))) (=> (= (f25 ?v0) f1) (=> (not (= (f23 ?v0 ?v1) f1)) (=> (= (f23 ?v_0 (f6 (f7 f8 ?v3) ?v1)) f1) (= (f23 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f6 (f7 f8 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f6 (f7 f8 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 ?v0 ?v1) f1) (= (f23 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f23 ?v0 ?v1) f1) (= (f23 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f16 ?v1) 1))) (f6 (f7 f8 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f13 f14 (+ (f3 f16 ?v1) 1))) (f30 (f31 f34 ?v0) (f30 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f16 ?v1) 1))) (f6 (f7 f8 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f13 f14 (+ (f3 f16 ?v1) 1))) (f30 (f31 f34 (f30 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f13 f14 (+ (f3 f16 ?v1) (f3 f16 ?v2)))) (f6 (f7 f8 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f31 f32 ?v0))) (= (f30 ?v_0 (f13 f14 (+ (f3 f16 ?v1) (f3 f16 ?v2)))) (f30 (f31 f34 (f30 ?v_0 ?v1)) (f30 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f6 (f7 f8 ?v_0) ?v0) (f6 (f7 f8 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f30 (f31 f32 ?v0) ?v1))) (= (f30 (f31 f34 ?v_0) ?v0) (f30 (f31 f34 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f3 (f4 f5 ?v0) ?v2)) (f3 (f4 f5 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f30 (f31 f32 (f30 (f31 f34 ?v0) ?v1)) ?v2) (f30 (f31 f34 (f30 (f31 f32 ?v0) ?v2)) (f30 (f31 f32 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f23 ?v0 ?v1) f1) (= (f23 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f29 ?v0 ?v1) f1) (= (f29 (f30 (f31 f32 ?v0) ?v2) (f30 (f31 f32 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (<= (f3 f16 ?v0) (f3 f16 ?v1)) (= (f23 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f31 f32 ?v2))) (=> (<= (f3 f16 ?v0) (f3 f16 ?v1)) (= (f29 (f30 ?v_0 ?v0) (f30 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f23 ?v0 ?v1) f1) (=> (<= (f3 f16 ?v2) (f3 f16 ?v3)) (= (f23 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f29 ?v0 ?v1) f1) (=> (<= (f3 f16 ?v2) (f3 f16 ?v3)) (= (f29 (f30 (f31 f32 ?v0) ?v2) (f30 (f31 f32 ?v1) ?v3)) f1)))))
(assert (= (f35 (f3 (f4 f5 f27) (f13 f14 2)) (- 1) (+ (* 4 f21) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f25 ?v1) f1) (=> (= (f23 ?v1 (f6 (f7 f8 ?v0) ?v2)) f1) (or (= (f23 ?v1 ?v0) f1) (= (f23 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f25 ?v1) f1) (= (f23 ?v1 ?v0) f1))))))
(assert (= (f36 f37 (f38 f27 1)) (f6 (f7 f8 (+ (* 4 f21) 1)) f19)))
(assert (let ((?v_0 (+ (* 4 f21) 1))) (and (<= 0 f27) (and (< f27 ?v_0) (= (f35 f39 f27 ?v_0) f1)))))
(assert (forall ((?v0 Int)) (= (= (f25 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f23 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (= (f35 (f3 (f4 f5 f39) (f13 f14 2)) (- 1) (+ (* 4 f21) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f35 (f3 (f4 f5 ?v0) (f13 f14 2)) (- 1) (+ (* 4 f21) 1)) f1) false)) false))
(assert (let ((?v_0 (f13 f14 2))) (= (f35 (f3 (f4 f5 f27) ?v_0) (f3 (f4 f5 f39) ?v_0) (+ (* 4 f21) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f21) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f35 f39 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f35 f39 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f21) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f35 f39 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 S3)) (let ((?v_0 (f13 f14 0))) (not (and (= (f29 ?v_0 ?v0) f1) (not (= (f29 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (= (f13 f14 (f3 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f16 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f16 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
