(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int Int) S1)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 () S2)
(declare-fun f8 () S3)
(declare-fun f9 (S5 Int) S3)
(declare-fun f10 () S5)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () S3)
(declare-fun f16 (S6 Int) Int)
(declare-fun f17 (S7 Int) S6)
(declare-fun f18 () S7)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(declare-fun f21 (Int) S1)
(declare-fun f22 () S7)
(declare-fun f23 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f9 f10 2))) (not (= (f3 (f4 (f5 f6 (+ 1 (f4 f7 f8))) ?v_0) (+ (f4 (f5 f6 f11) ?v_0) (f4 (f5 f6 f12) ?v_0))) f1))))
(assert (let ((?v_0 (f9 f10 2))) (let ((?v_1 (f4 (f5 f6 (+ 1 (f4 f7 f8))) ?v_0))) (and (= (f3 ?v_1 (f4 (f5 f6 f11) ?v_0)) f1) (= (f3 ?v_1 (f4 (f5 f6 f12) ?v_0)) f1)))))
(assert (< 1 f13))
(assert (< 0 (f4 f7 f8)))
(assert (< 0 (+ 1 (f4 f7 f8))))
(assert (let ((?v_0 (f9 f10 2))) (let ((?v_1 (f4 (f5 f6 (+ 1 (f4 f7 f8))) ?v_0))) (and (= (f3 ?v_1 (f4 (f5 f6 f11) ?v_0)) f1) (= (f3 ?v_1 (f4 (f5 f6 f12) ?v_0)) f1)))))
(assert (let ((?v_0 (+ 1 (f4 f7 f8)))) (and (= (f3 ?v_0 f11) f1) (= (f3 ?v_0 f12) f1))))
(assert (< f14 (+ 1 (f4 f7 f8))))
(assert (= f15 (f9 f10 (- (f4 f7 (f9 f10 f13)) 1))))
(assert (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f5 f6 f11) ?v_0) (f4 (f5 f6 f12) ?v_0)) (f16 (f17 f18 (+ (* 4 f19) 1)) (+ 1 (f4 f7 f8))))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f9 f10 0))) (= (= (f3 (f4 (f5 f6 ?v1) ?v0) (f4 (f5 f6 ?v2) ?v0)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f4 f7 ?v0)) (=> (= (f3 ?v1 ?v2) f1) (= (f3 ?v1 (f4 (f5 f6 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f3 (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v2) ?v1)) f1) (=> (not (= ?v1 (f9 f10 0))) (= (f3 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f3 ?v0 ?v1) f1) (= (f3 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (=> (<= (f4 f7 ?v0) (f4 f7 ?v1)) (= (f3 (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f3 ?v0 ?v1) f1) (=> (<= (f4 f7 ?v2) (f4 f7 ?v3)) (= (f3 (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f3 (f4 ?v_0 ?v1) ?v2) f1) (=> (<= (f4 f7 ?v3) (f4 f7 ?v1)) (= (f3 (f4 ?v_0 ?v3) ?v2) f1))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f4 f7 f8)))) (=> (and (= ?v1 (- f11 (f16 (f17 f18 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f4 f7 f8)))) (=> (and (= ?v1 (- f12 (f16 (f17 f18 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (< 0 (f4 f7 f15)))
(assert (< 0 (+ (* 4 f19) 1)))
(assert (<= 1 f13))
(assert (not (= (f20 (f16 (f17 f18 (+ (* 4 f19) 1)) (+ 1 0))) f1)))
(assert (< f13 (+ (* 4 f19) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f9 f10 (- (f4 f7 (f9 f10 f13)) 1))) (=> (< 0 (f4 f7 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f4 f7 f8))) (?v_0 (+ (* 4 f19) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f20 (f16 (f17 f18 ?v_0) ?v_1)) f1))))))
(assert (= (f21 (+ (* 4 f19) 1)) f1))
(assert (= (f16 (f17 f22 (- 1)) (+ (* 4 f19) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (=> (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (f16 (f17 f18 (+ (* 4 f19) 1)) (+ 1 (f4 f7 f8)))) false))) false))
(assert (= (+ (f4 (f5 f6 f23) (f9 f10 2)) 1) (f16 (f17 f18 (+ (* 4 f19) 1)) f13)))
(assert (let ((?v_1 (+ 1 (f4 f7 f8))) (?v_0 (+ (* 4 f19) 1))) (and (< ?v_1 ?v_0) (= (f20 (f16 (f17 f18 ?v_0) ?v_1)) f1))))
(assert (= (f20 (f16 (f17 f18 (+ (* 4 f19) 1)) f13)) f1))
(assert (= (f20 (f16 (f17 f18 (+ (* 4 f19) 1)) f14)) f1))
(assert (=> (= f13 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f9 f10 2))) (= (+ (f4 (f5 f6 ?v0) ?v_0) (f4 (f5 f6 ?v1) ?v_0)) (+ (* 4 f19) 1))))))
(assert (forall ((?v0 S3)) (= (f9 f10 (f4 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f7 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f7 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
