(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 Int) Int)
(declare-fun f9 (S7 Int) S6)
(declare-fun f10 () S7)
(declare-fun f11 (S8 S2) Int)
(declare-fun f12 () S8)
(declare-fun f13 () S2)
(declare-fun f14 () Int)
(declare-fun f15 (Int) S1)
(declare-fun f16 (Int Int) S1)
(declare-fun f17 () Int)
(declare-fun f18 () S7)
(declare-fun f19 () Int)
(declare-fun f20 (Int Int) S1)
(declare-fun f21 () S2)
(declare-fun f22 (Int) S1)
(declare-fun f23 (S9 Int) S8)
(declare-fun f24 () S9)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 () Int)
(declare-fun f29 () Int)
(declare-fun f30 () Int)
(declare-fun f31 () Int)
(declare-fun f32 (Int Int Int) S1)
(declare-fun f33 (S10 S11) Int)
(declare-fun f34 () S10)
(declare-fun f35 (Int Int) S11)
(declare-fun f36 () Int)
(declare-fun f37 (S2 S2) S1)
(declare-fun f38 () S4)
(declare-fun f39 () S6)
(declare-fun f40 () S4)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) ?v1) (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))))))
(assert (let ((?v_0 (+ 1 (f11 f12 f13)))) (not (or (= ?v_0 1) (= ?v_0 (+ (* 4 f14) 1))))))
(assert (= (f15 (+ (* 4 f14) 1)) f1))
(assert (let ((?v_0 (+ 1 (f11 f12 f13)))) (and (<= 0 ?v_0) (= (f16 ?v_0 (+ (* 4 f14) 1)) f1))))
(assert (< 1 f17))
(assert (= (f15 (+ (* 4 f14) 1)) f1))
(assert (< 0 (f11 f12 f13)))
(assert (let ((?v_0 (+ 1 (f11 f12 f13)))) (and (<= 0 ?v_0) (= (f16 ?v_0 (+ (* 4 f14) 1)) f1))))
(assert (< 0 (+ (* 4 f14) 1)))
(assert (not (= (+ 1 (f11 f12 f13)) 0)))
(assert (< 0 (+ 1 (f11 f12 f13))))
(assert (= (f16 (+ 1 (f11 f12 f13)) (+ (* 4 f14) 1)) f1))
(assert (= (f8 (f9 f18 (- 1)) (+ (* 4 f14) 1)) 1))
(assert (< f19 (+ 1 (f11 f12 f13))))
(assert (= (f20 (+ (* 4 f14) 1) (- 1)) f1))
(assert (= f21 (f6 f7 (- (f11 f12 (f6 f7 f17)) 1))))
(assert (< f17 (+ (* 4 f14) 1)))
(assert (let ((?v_1 (+ 1 (f11 f12 f13))) (?v_0 (+ (* 4 f14) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f22 (f8 (f9 f10 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (+ 1 (f11 f12 f13)))) (let ((?v_1 (f9 f10 ?v_0))) (= (f16 (f8 ?v_1 ?v_0) (f8 ?v_1 (+ (* 4 f14) 1))) f1))))
(assert (not (= (f22 (f8 (f9 f10 (+ (* 4 f14) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f14) 1))) (=> (not (= (f20 ?v_0 (- 1)) f1)) (not (= (f8 (f9 f18 (- 1)) ?v_0) 1)))))
(assert (let ((?v_1 (+ 1 (f11 f12 f13))) (?v_0 (+ (* 4 f14) 1))) (and (< ?v_1 ?v_0) (= (f22 (f8 (f9 f10 ?v_0) ?v_1)) f1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (=> (= (+ (f11 (f23 f24 ?v0) ?v_0) (f11 (f23 f24 ?v1) ?v_0)) (f8 (f9 f10 (+ (* 4 f14) 1)) (+ 1 (f11 f12 f13)))) false))) false))
(assert (let ((?v_0 (+ 1 (f11 f12 f13)))) (and (= (f16 ?v_0 f25) f1) (= (f16 ?v_0 f26) f1))))
(assert (<= 1 f17))
(assert (< 0 (f11 f12 f21)))
(assert (=> (forall ((?v0 S2)) (=> (= ?v0 (f6 f7 (- (f11 f12 (f6 f7 f17)) 1))) (=> (< 0 (f11 f12 ?v0)) false))) false))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f23 f24 f25) ?v_0) (f11 (f23 f24 f26) ?v_0)) (f8 (f9 f10 (+ (* 4 f14) 1)) (+ 1 (f11 f12 f13))))))
(assert (= (f22 (f8 (f9 f10 (+ (* 4 f14) 1)) f17)) f1))
(assert (= (f22 (f8 (f9 f10 (+ (* 4 f14) 1)) f19)) f1))
(assert (let ((?v_0 (f6 f7 2))) (let ((?v_1 (f11 (f23 f24 (+ 1 (f11 f12 f13))) ?v_0))) (and (= (f16 ?v_1 (f11 (f23 f24 f25) ?v_0)) f1) (= (f16 ?v_1 (f11 (f23 f24 f26) ?v_0)) f1)))))
(assert (let ((?v_0 (f6 f7 2))) (= (f16 (f11 (f23 f24 (+ 1 (f11 f12 f13))) ?v_0) (+ (f11 (f23 f24 f25) ?v_0) (f11 (f23 f24 f26) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f11 f12 f13)))) (=> (and (= ?v1 (- f26 (f8 (f9 f10 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f11 f12 f13)))) (=> (and (= ?v1 (- f25 (f8 (f9 f10 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (= (+ (f11 (f23 f24 f27) (f6 f7 2)) 1) (f8 (f9 f10 (+ (* 4 f14) 1)) f17)))
(assert (=> (= f17 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f23 f24 ?v0) ?v_0) (f11 (f23 f24 ?v1) ?v_0)) (+ (* 4 f14) 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0) f1) (=> (= (f22 ?v1) f1) (= (f22 (f8 (f9 f10 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f15 ?v_0) f1) (= (f8 (f9 f18 (- 1)) ?v_0) 1)))))
(assert (let ((?v_0 (+ 1 (f11 f12 f13)))) (and (= f28 (- f26 (f8 (f9 f10 f29) ?v_0))) (<= (ite (< f28 0) (* (- 2) f28) (* 2 f28)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f11 f12 f13)))) (and (= f30 (- f25 (f8 (f9 f10 f31) ?v_0))) (<= (ite (< f30 0) (* (- 2) f30) (* 2 f30)) ?v_0))))
(assert (= (f16 (+ (* 4 f14) 1) (- (f11 (f23 f24 f27) (f6 f7 2)) (- 1))) f1))
(assert (= (f16 (+ (* 4 f14) 1) (+ (f11 (f23 f24 f27) (f6 f7 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f11 (f23 f24 ?v0) ?v2))) (=> (= (f15 ?v0) f1) (=> (not (= (f16 ?v0 ?v1) f1)) (=> (= (f16 ?v_0 (f8 (f9 f10 ?v1) ?v3)) f1) (= (f16 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f11 (f23 f24 ?v0) ?v2))) (=> (= (f15 ?v0) f1) (=> (not (= (f16 ?v0 ?v1) f1)) (=> (= (f16 ?v_0 (f8 (f9 f10 ?v3) ?v1)) f1) (= (f16 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f15 ?v0) f1) (=> (= (f16 ?v0 (f11 (f23 f24 ?v1) ?v2)) f1) (= (f16 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f15 ?v0) f1) (=> (= (f16 ?v0 (f11 (f23 f24 ?v1) ?v2)) f1) (=> (< 0 (f11 f12 ?v2)) (= (f16 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (= (f16 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1) (or (= (f16 ?v0 ?v1) f1) (= (f16 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f15 ?v1) f1) (=> (= (f16 ?v1 (f8 (f9 f10 ?v0) ?v2)) f1) (or (= (f16 ?v1 ?v0) f1) (= (f16 ?v1 ?v2) f1)))))))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f23 f24 f30) ?v_0) (f11 (f23 f24 f28) ?v_0)) 0)))
(assert (let ((?v_0 (f11 (f23 f24 f27) (f6 f7 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (and (= f30 0) (= f28 0)))
(assert (let ((?v_0 (f6 f7 2))) (=> (not (= f28 0)) (< 0 (+ (f11 (f23 f24 f30) ?v_0) (f11 (f23 f24 f28) ?v_0))))))
(assert (let ((?v_0 (f6 f7 2))) (=> (not (= f30 0)) (< 0 (+ (f11 (f23 f24 f30) ?v_0) (f11 (f23 f24 f28) ?v_0))))))
(assert (let ((?v_0 (f6 f7 2))) (= (+ (f11 (f23 f24 f30) ?v_0) (f11 (f23 f24 f28) ?v_0)) (f8 (f9 f10 (+ 1 (f11 f12 f13))) f19))))
(assert (let ((?v_0 (f6 f7 2))) (= (f16 (+ 1 (f11 f12 f13)) (+ (f11 (f23 f24 f30) ?v_0) (f11 (f23 f24 f28) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f11 (f23 f24 f27) (f6 f7 2)) 1) (f8 (f9 f10 (+ (* 4 f14) 1)) ?v0)) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (=> (= (+ (f11 (f23 f24 f30) ?v_0) (f11 (f23 f24 f28) ?v_0)) (f8 (f9 f10 (+ 1 (f11 f12 f13))) ?v0)) false))) false))
(assert (let ((?v_2 (f6 f7 2)) (?v_1 (f9 f10 f29)) (?v_0 (f9 f10 f31))) (= (+ (f11 (f23 f24 (+ (+ (f8 ?v_0 f30) (f8 ?v_1 f28)) f19)) ?v_2) (f11 (f23 f24 (- (f8 ?v_0 f28) (f8 ?v_1 f30))) ?v_2)) (f8 (f9 f10 (+ (* 4 f14) 1)) f19))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f8 (f9 f10 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f9 f10 ?v1))) (= (+ (f8 (f9 f10 (- ?v0 (f8 ?v_0 ?v2))) ?v3) (f8 (f9 f10 (- ?v4 (f8 ?v_0 ?v5))) ?v6)) (- (+ (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v4) ?v6)) (f8 ?v_0 (+ (f8 (f9 f10 ?v2) ?v3) (f8 (f9 f10 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f11 (f23 f24 ?v0) (f6 f7 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (f11 (f23 f24 ?v0) ?v_0) (f11 (f23 f24 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2)) (?v_1 (f23 f24 ?v0))) (= (f11 (f23 f24 (f11 ?v_1 ?v_0)) ?v_0) (f11 ?v_1 (f6 f7 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 3))) (= (f11 (f23 f24 (- ?v0)) ?v_0) (- (f11 (f23 f24 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 3))) (let ((?v_0 (f11 (f23 f24 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f11 (f23 f24 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f11 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 (f23 f24 ?v0) (f6 f7 2)))))
(assert (= (f15 2) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f8 (f9 f10 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f11 (f23 f24 ?v0) ?v_0) (f11 (f23 f24 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_3 (f23 f24 ?v1)) (?v_1 (f23 f24 ?v0))) (= (f11 (f23 f24 (- ?v0 ?v1)) ?v_0) (- (+ (- (f11 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f11 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f6 f7 2)) (?v_0 (f6 f7 3)) (?v_1 (f23 f24 ?v0)) (?v_3 (f23 f24 ?v1))) (= (f11 (f23 f24 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f11 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f11 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f11 ?v_3 ?v_2))) (f11 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f23 f24 (- ?v0 ?v1)) ?v_0) (+ (- (f11 (f23 f24 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f11 (f23 f24 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (f11 (f23 f24 (+ ?v0 ?v1)) ?v_0) (+ (+ (f11 (f23 f24 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f11 (f23 f24 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (f8 (f9 f10 ?v0) (f11 ?v_0 (f6 f7 2))) (f11 ?v_0 (f6 f7 3))))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (< 0 (f11 f12 ?v0)) (=> (= (f16 ?v1 ?v2) f1) (= (f16 ?v1 (f11 (f23 f24 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f15 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f16 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (= (f32 (f11 (f23 f24 f27) (f6 f7 2)) (- 1) (+ (* 4 f14) 1)) f1))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f15 ?v1) f1) (= (f16 ?v1 ?v0) f1))))))
(assert (= (f33 f34 (f35 f27 1)) (f8 (f9 f10 (+ (* 4 f14) 1)) f17)))
(assert (let ((?v_0 (+ (* 4 f14) 1))) (and (<= 0 f27) (and (< f27 ?v_0) (= (f32 f36 f27 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int)) (=> (= (f16 (f11 (f23 f24 ?v0) ?v1) (f11 (f23 f24 ?v2) ?v1)) f1) (=> (not (= ?v1 (f6 f7 0))) (= (f16 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f16 (f11 (f23 f24 ?v1) ?v0) (f11 (f23 f24 ?v2) ?v0)) f1) (= (f16 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f23 f24 ?v1)) (?v_1 (f6 f7 ?v0))) (=> (< 0 ?v0) (= (f11 ?v_0 ?v_1) (f8 (f9 f10 ?v1) (f11 ?v_0 (f6 f7 (- (f11 f12 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (= (f32 (f11 (f23 f24 f36) (f6 f7 2)) (- 1) (+ (* 4 f14) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f32 (f11 (f23 f24 ?v0) (f6 f7 2)) (- 1) (+ (* 4 f14) 1)) f1) false)) false))
(assert (let ((?v_0 (f6 f7 2))) (= (f32 (f11 (f23 f24 f27) ?v_0) (f11 (f23 f24 f36) ?v_0) (+ (* 4 f14) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f14) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f32 f36 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f14) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f32 f36 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f32 f36 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (= (f32 ?v3 ?v4 ?v2) f1) (= (f32 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (= (f32 ?v3 ?v4 ?v2) f1) (= (f32 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (= (f32 ?v1 ?v3 ?v2) f1) (= (f32 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f32 ?v3 ?v4 ?v2) f1) (= (f32 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (f32 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f32 ?v1 (- 1) ?v0) f1) (not (= (f32 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f32 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f32 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f32 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f32 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f32 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f32 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f32 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int)) (= (f32 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f32 ?v0 ?v1 (- ?v2)) f1) (= (f32 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f32 ?v0 ?v1 ?v2) f1) (= (f32 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f32 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f9 f10 ?v1))) (= (f8 (f9 f10 (f33 f34 (f35 ?v0 ?v1))) (f33 f34 (f35 ?v2 ?v3))) (f33 f34 (f35 (+ (f8 ?v_0 ?v2) (f8 ?v_1 ?v3)) (- (f8 ?v_0 ?v3) (f8 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f32 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f8 (f9 f10 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f32 (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (= (f32 ?v3 (f8 (f9 f10 ?v0) ?v4) ?v2) f1) (= (f32 ?v3 (f8 (f9 f10 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f9 f10 ?v4))) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (= (f32 ?v3 (f8 ?v_0 ?v0) ?v2) f1) (= (f32 ?v3 (f8 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (f32 (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v3))) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (f32 (f8 ?v_0 ?v0) (f8 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (=> (= (f32 ?v3 ?v4 ?v2) f1) (= (f32 (f8 (f9 f10 ?v0) ?v3) (f8 (f9 f10 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f32 ?v0 0 ?v1) f1) (= (f16 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f32 ?v0 0 ?v1) f1) (= (f16 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f32 ?v0 ?v1 ?v2) f1) (= (f16 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f32 ?v0 ?v1 ?v2) f1) (= (f32 (f11 (f23 f24 ?v0) ?v3) (f11 (f23 f24 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f32 ?v0 0 ?v1) f1)) (=> (= (f32 (f11 (f23 f24 ?v2) (f6 f7 2)) ?v0 ?v1) f1) (not (= (f16 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (not (= (f32 ?v1 0 ?v0) f1)) (=> (not (= (f32 ?v2 0 ?v0) f1)) (not (= (f32 (f8 (f9 f10 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f32 (f8 (f9 f10 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f32 ?v1 0 ?v0) f1)) (not (= (f32 ?v2 0 ?v0) f1))) (not (= (f32 (f8 (f9 f10 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (= (f32 (f8 (f9 f10 ?v1) ?v2) 0 ?v0) f1) (or (= (f32 ?v1 0 ?v0) f1) (= (f32 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (< 0 ?v1) (=> (= (f32 (f8 (f9 f10 ?v1) ?v1) 1 ?v0) f1) (or (= (f32 ?v1 1 ?v0) f1) (= (f32 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f11 f12 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int)) (= (= (f16 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f16 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f16 ?v0 ?v1) f1) (=> (= (f16 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f16 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 ?v0 ?v1) f1) (=> (= (f16 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0 (- ?v1 ?v2)) f1) (=> (= (f16 ?v0 ?v2) f1) (= (f16 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f11 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f11 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f16 ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) f1) (= (f16 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f16 (f8 (f9 f10 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f16 ?v0 ?v1) f1) (= (= (f16 ?v0 (+ ?v2 ?v3)) f1) (= (f16 ?v0 (+ (+ ?v2 (f8 (f9 f10 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f16 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f16 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int)) (= (= (f22 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f33 f34 (f35 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (not (= (f16 ?v0 ?v1) f1)) (= (f32 (f11 (f23 f24 ?v1) (f6 f7 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f18 ?v0) ?v1) (ite (= (f32 ?v0 0 ?v1) f1) 0 (ite (= (f20 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f32 (f11 (f23 f24 ?v2) (f6 f7 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 (- 1)))) (let ((?v_1 (f11 ?v_0 ?v1)) (?v_2 (f11 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f32 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (not (= ?v0 0)) (= (= (f16 ?v1 ?v2) f1) (= (f16 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f8 (f9 f10 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f32 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 ?v0 ?v1) f1) (= (f16 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 ?v0 ?v1) f1) (= (f16 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 (f23 f24 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f32 (f8 (f9 f10 ?v0) ?v_0) 1 ?v1) f1) (= (f32 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f16 (f11 ?v_0 ?v1) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f16 (f11 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f38 ?v0))) (=> (= (f37 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f11 f12 ?v3) (f11 f12 ?v1)) (= (f37 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 S2)) (=> (= (f16 ?v0 ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f16 (f11 (f23 f24 ?v0) ?v2) (f11 (f23 f24 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f37 ?v0 ?v1) f1) (=> (<= (f11 f12 ?v2) (f11 f12 ?v3)) (= (f37 (f3 (f4 f38 ?v0) ?v2) (f3 (f4 f38 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 f12 (f3 (f4 f38 ?v0) ?v1)) (f11 (f23 f24 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f11 (f23 f24 (f11 f12 ?v0)) ?v1) (f11 f12 (f3 (f4 f38 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f6 f7 (f11 (f23 f24 ?v0) ?v1)) (f3 (f4 f38 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f37 ?v0 ?v1) f1) (= (f16 (f11 f12 ?v0) (f11 f12 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f16 ?v0 (f11 f12 ?v1)) f1) (= (f37 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 Int)) (= (= (f16 (f11 f12 ?v0) ?v1) f1) (= (f37 ?v0 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f37 (f6 f7 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f16 ?v0 (f11 f12 ?v1)) f1) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f8 f39 (f11 (f23 f24 ?v0) ?v1)) (f11 (f23 f24 (f8 f39 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (= (f11 (f23 f24 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f38 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (=> (= (f15 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 ?v0) (f11 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f38 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f40 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f8 (f9 f10 (f11 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f38 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) 1))) (f3 (f4 f40 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f8 (f9 f10 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f38 ?v0))) (= (f3 ?v_0 (f6 f7 (+ (f11 f12 ?v1) (f11 f12 ?v2)))) (f3 (f4 f40 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f11 (f23 f24 ?v0) ?v1))) (= (f8 (f9 f10 ?v_0) ?v0) (f8 (f9 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f4 f38 ?v0) ?v1))) (= (f3 (f4 f40 ?v_0) ?v0) (f3 (f4 f40 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f11 (f23 f24 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f11 (f23 f24 ?v0) ?v2)) (f11 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f4 f38 (f3 (f4 f40 ?v0) ?v1)) ?v2) (f3 (f4 f40 (f3 (f4 f38 ?v0) ?v2)) (f3 (f4 f38 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f16 ?v0 ?v1) f1) (= (f16 (f11 (f23 f24 ?v0) ?v2) (f11 (f23 f24 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 ?v0 ?v1) f1) (= (f37 (f3 (f4 f38 ?v0) ?v2) (f3 (f4 f38 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f23 f24 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f16 (f11 ?v_0 ?v0) (f11 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f38 ?v2))) (=> (<= (f11 f12 ?v0) (f11 f12 ?v1)) (= (f37 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 ?v0 (f8 (f9 f10 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f37 ?v0 (f3 (f4 f40 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 ?v0 (f8 (f9 f10 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f37 ?v0 (f3 (f4 f40 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0 ?v1) f1) (= (f16 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 ?v0 ?v1) f1) (= (f37 ?v0 (f3 (f4 f40 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 (f23 f24 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f23 f24 ?v0))) (= (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f11 (f23 f24 (f11 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f38 ?v0))) (= (f3 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v2)))) (f3 (f4 f38 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f38 ?v0))) (=> (= (f37 (f3 ?v_0 ?v1) (f3 ?v_0 ?v2)) f1) (=> (< 1 (f11 f12 ?v0)) (<= (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f11 f12 ?v0)) (<= ?v_0 (f11 f12 (f3 (f4 f38 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f38 ?v0))) (=> (< 0 (f11 f12 ?v0)) (=> (< (f11 f12 (f3 ?v_0 ?v1)) (f11 f12 (f3 ?v_0 ?v2))) (< (f11 f12 ?v1) (f11 f12 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f3 (f4 f38 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f3 (f4 f38 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f11 f12 (f3 (f4 f38 ?v0) ?v1))) (or (< 0 (f11 f12 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (not (and (= (f37 ?v_0 ?v0) f1) (not (= (f37 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (not (and (= (f37 ?v0 ?v_0) f1) (not (= (f37 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S2)) (= (f37 (f6 f7 1) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f37 ?v0 (f6 f7 0)) f1)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (not (= ?v0 ?v_0)) (and (= (f37 ?v_0 ?v0) f1) (not (= (f37 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (= (not (= ?v0 ?v_0)) (and (= (f37 ?v0 ?v_0) f1) (not (= (f37 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f37 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f37 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 (f6 f7 0))) (= (= (f37 (f3 (f4 f38 ?v1) ?v0) (f3 (f4 f38 ?v2) ?v0)) f1) (= (f37 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 0))) (=> (= (f37 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (< 0 (f11 f12 ?v0)) (=> (= (f37 ?v1 ?v0) f1) (< 0 (f11 f12 ?v1))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f6 f7 1))) (=> (= (f37 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0)))) (f11 f12 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f8 (f9 f10 ?v0) ?v1)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 ?v0))) (f11 f12 (f6 f7 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f11 f12 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f32 (f11 ?v_0 ?v1) 1 ?v2) f1) (= (f32 (f11 ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v1)) (f11 f12 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f8 f39 ?v0))) (= (f8 (f9 f10 ?v_0) ?v_0) (f8 (f9 f10 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 f39 (f8 (f9 f10 ?v0) ?v1)) (f8 (f9 f10 (f8 f39 ?v0)) (f8 f39 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 f39 ?v0) (f8 f39 ?v1)) (= (f16 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0 ?v1) f1) (=> (= (f16 ?v1 ?v2) f1) (= (f16 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 ?v0 ?v1) f1) (=> (= (f37 ?v1 ?v2) f1) (= (f37 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 (f8 f39 ?v0) ?v1) f1) (= (f16 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 ?v0 (f8 f39 ?v1)) f1) (= (f16 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int)) (= (f16 ?v0 ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f37 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 (f8 (f9 f10 ?v0) ?v1) ?v2) f1) (= (f16 ?v1 ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 (f3 (f4 f40 ?v0) ?v1) ?v2) f1) (= (f37 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 (f8 (f9 f10 ?v0) ?v1) ?v2) f1) (= (f16 ?v0 ?v2) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 (f3 (f4 f40 ?v0) ?v1) ?v2) f1) (= (f37 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f8 (f9 f10 ?v1) ?v2)) (= (f16 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= ?v0 (f3 (f4 f40 ?v1) ?v2)) (= (f37 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f16 ?v0 ?v1) f1) (=> (= (f16 ?v2 ?v3) f1) (= (f16 (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f37 ?v0 ?v1) f1) (=> (= (f37 ?v2 ?v3) f1) (= (f37 (f3 (f4 f40 ?v0) ?v2) (f3 (f4 f40 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0 ?v1) f1) (= (f16 ?v0 (f8 (f9 f10 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f37 ?v0 ?v1) f1) (= (f37 ?v0 (f3 (f4 f40 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2)) (= (f37 (f6 f7 (+ 0 1)) ?v0) f1)))
(assert (forall ((?v0 S2)) (= (f37 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f12 (f6 f7 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f6 f7 (f8 (f9 f10 ?v_0) ?v_0)) (f6 f7 (+ (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v0 1)))) (f11 f12 (f6 f7 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (<= ?v_0 (f8 (f9 f10 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0))) (<= ?v_0 (f8 ?v_1 (f8 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 0 (f11 f12 ?v0))) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* 1 (f11 f12 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v1))) (= (< 0 (f8 (f9 f10 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= ?v_0 (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 0)) (f6 f7 0))))
(assert (forall ((?v0 S2)) (= (f6 f7 (* (f11 f12 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 ?v_1) ?v_0)) (f6 f7 (f8 (f9 f10 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f11 f12 ?v0))) (let ((?v_1 (f9 f10 ?v_0)) (?v_2 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_1 (+ ?v_2 1))) (f6 f7 (+ ?v_0 (f8 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 ?v_0 (+ ?v_1 ?v_2))) (f6 f7 (+ (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_2 (f11 f12 ?v2)) (?v_1 (f11 f12 ?v1))) (= (f6 f7 (f8 ?v_0 (f11 f12 (f6 f7 (- ?v_1 ?v_2))))) (f6 f7 (- (f8 ?v_0 ?v_1) (f8 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1))) (= (<= ?v_0 (f8 (f9 f10 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f11 f12 ?v0)) (?v_0 (f11 f12 ?v1))) (= (f6 f7 (f8 (f9 f10 (+ ?v_1 1)) ?v_0)) (f6 f7 (+ ?v_0 (f8 (f9 f10 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 0))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0))) (?v_1 (f11 f12 ?v1)) (?v_2 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f8 ?v_0 ?v_1)) ?v_2)) (f6 f7 (f8 ?v_0 (f8 (f9 f10 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v0)) (?v_2 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (+ ?v_0 ?v_2)) ?v_1)) (f6 f7 (+ (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v1)) (?v_0 (f11 f12 ?v0)) (?v_1 (f11 f12 ?v2))) (= (f6 f7 (f8 (f9 f10 (f11 f12 (f6 f7 (- ?v_0 ?v_2)))) ?v_1)) (f6 f7 (- (f8 (f9 f10 ?v_0) ?v_1) (f8 (f9 f10 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) (f11 f12 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (< (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (< (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f11 f12 ?v0))) (let ((?v_0 (f9 f10 ?v_1)) (?v_3 (f11 f12 ?v2)) (?v_2 (f11 f12 ?v1))) (= (<= (f8 ?v_0 ?v_2) (f8 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f11 f12 ?v2)) (?v_0 (f11 f12 ?v1)) (?v_1 (f11 f12 ?v0))) (= (<= (f8 (f9 f10 ?v_1) ?v_0) (f8 (f9 f10 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 (f11 f12 ?v0)))) (= (= (f6 f7 (f8 ?v_0 (f11 f12 ?v1))) (f6 f7 (f8 ?v_0 (f11 f12 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f11 f12 ?v1))) (= (= (f6 f7 (f8 (f9 f10 (f11 f12 ?v0)) ?v_0)) (f6 f7 (f8 (f9 f10 (f11 f12 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2)) (= (f6 f7 (f11 f12 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f11 f12 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
