(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 (S2 Int) Int)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 (S4 S5) Int)
(declare-fun f9 () S4)
(declare-fun f10 () S5)
(declare-fun f11 (S6 Int) S5)
(declare-fun f12 () S6)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f7) 1)) (?v_1 (+ 1 (f8 f9 f10)))) (and (< ?v_1 ?v_0) (= (f3 (f4 (f5 f6 ?v_0) ?v_1)) f1))))
(assert (let ((?v_0 (+ 1 (f8 f9 f10)))) (or (= ?v_0 1) (= ?v_0 (+ (* 4 f7) 1)))))
(assert (let ((?v_0 (+ (* 4 f7) 1)) (?v_1 (+ 1 (f8 f9 f10)))) (and (< ?v_1 ?v_0) (= (f3 (f4 (f5 f6 ?v_0) ?v_1)) f1))))
(assert (< 0 (f8 f9 f10)))
(assert (forall ((?v0 S5)) (= (f11 f12 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f11 f12 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f11 f12 ?v0)) 0))))
(check-sat)
(exit)
