(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 () S2)
(declare-fun f12 () S3)
(declare-fun f13 () S3)
(declare-fun f14 () Int)
(declare-fun f15 (Int Int) S1)
(declare-fun f16 (S6 Int) Int)
(declare-fun f17 (S7 Int) S6)
(declare-fun f18 () S7)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 (Int) S1)
(declare-fun f26 (Int) S1)
(declare-fun f27 () S7)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(declare-fun f33 () Int)
(declare-fun f34 (S3 S3) S1)
(declare-fun f35 (S10 S3) S3)
(declare-fun f36 (S11 S3) S10)
(declare-fun f37 () S11)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 2))) (not (and (<= 0 (f3 (f4 f5 f6) ?v_0)) (<= 0 (f3 (f4 f5 f9) ?v_0))))))
(assert (< 1 f10))
(assert (< 0 (f3 f11 f12)))
(assert (let ((?v_0 (f7 f8 2))) (not (= (+ (f3 (f4 f5 f6) ?v_0) (* 1 (f3 (f4 f5 f9) ?v_0))) 0))))
(assert (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) 0) false)))
(assert (= f13 (f7 f8 (- (f3 f11 (f7 f8 f10)) 1))))
(assert (let ((?v_0 (f3 (f4 f5 f14) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (let ((?v_0 (f7 f8 2))) (= (f15 (+ 1 (f3 f11 f12)) (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0))) f1)))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (f16 (f17 f18 (+ 1 (f3 f11 f12))) f19))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (< 0 (f3 f11 f13)))
(assert (< 0 (+ 1 (f3 f11 f12))))
(assert (<= 1 f10))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f11 (f7 f8 f10)) 1))) (=> (< 0 (f3 f11 ?v0)) false))) false))
(assert (< f19 (+ 1 (f3 f11 f12))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f9 (- f20 (f16 (f17 f18 f21) ?v_0))) (<= (ite (< f9 0) (* (- 2) f9) (* 2 f9)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f11 f12)))) (and (= f6 (- f22 (f16 (f17 f18 f23) ?v_0))) (<= (ite (< f6 0) (* (- 2) f6) (* 2 f6)) ?v_0))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (f16 (f17 f18 (+ 1 (f3 f11 f12))) ?v0)) false))) false))
(assert (forall ((?v0 Int)) (= (= (f15 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f18 ?v0) ?v1) (f16 (f17 f18 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (+ ?v1 ?v2)) (+ (f16 ?v_0 ?v1) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (- ?v1 ?v2)) (- (f16 ?v_0 ?v1) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f15 ?v0 (+ ?v1 (f16 (f17 f18 ?v0) ?v2))) f1) (= (f15 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f16 (f17 f18 (- ?v0)) ?v1) (- (f16 (f17 f18 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f16 (f17 f18 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f17 f18 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f17 f18 (+ ?v0 ?v1)) ?v2) (+ (f16 (f17 f18 ?v0) ?v2) (f16 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f16 (f17 f18 (- ?v0 ?v1)) ?v2) (- (f16 (f17 f18 ?v0) ?v2) (f16 (f17 f18 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f15 (f16 (f17 f18 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f15 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f16 (f17 f18 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f15 ?v0 ?v1) f1) (=> (= (f15 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f16 (f17 f18 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f15 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f15 ?v0 ?v1) f1) (= (= (f15 ?v0 (+ ?v2 ?v3)) f1) (= (f15 ?v0 (+ (+ ?v2 (f16 (f17 f18 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f11 ?v2))) (let ((?v_1 (f17 f18 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f16 ?v_1 ?v0) (f16 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0 ?v1) f1) (=> (= (f15 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f15 ?v0 (- ?v1 ?v2)) f1) (=> (= (f15 ?v0 ?v2) f1) (= (f15 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 (f17 f18 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f16 (f17 f18 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f15 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f15 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f16 (f17 f18 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f16 (f17 f18 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f16 (f17 f18 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f16 (f17 f18 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f16 (f17 f18 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f16 (f17 f18 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f16 (f17 f18 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f16 (f17 f18 ?v0) (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f11 ?v1) (f3 f11 ?v2)))) (f16 (f17 f18 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (+ (f3 (f4 f5 f14) (f7 f8 2)) 1) (f16 (f17 f18 (+ (* 4 f24) 1)) f10)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f22 (f16 (f17 f18 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f11 f12)))) (=> (and (= ?v1 (- f20 (f16 (f17 f18 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f15 (f3 (f4 f5 ?v0) ?v1) (f3 (f4 f5 ?v2) ?v1)) f1) (=> (not (= ?v1 (f7 f8 0))) (= (f15 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f11 ?v0)) (=> (= (f15 ?v1 ?v2) f1) (= (f15 ?v1 (f3 (f4 f5 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f15 (f3 (f4 f5 ?v1) ?v0) (f3 (f4 f5 ?v2) ?v0)) f1) (= (f15 ?v1 ?v2) f1)))))
(assert (= (f15 (+ (* 4 f24) 1) (- (f3 (f4 f5 f14) (f7 f8 2)) (- 1))) f1))
(assert (= (f15 (+ (* 4 f24) 1) (+ (f3 (f4 f5 f14) (f7 f8 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f16 (f17 f18 ?v1) (f3 ?v_0 (f7 f8 (- (f3 f11 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f17 f18 ?v0))) (=> (not (= ?v0 0)) (= (= (f15 ?v1 ?v2) f1) (= (f15 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1))))))
(assert (< 0 (+ (* 4 f24) 1)))
(assert (not (= (f25 (f16 (f17 f18 (+ (* 4 f24) 1)) (+ 1 0))) f1)))
(assert (< f10 (+ (* 4 f24) 1)))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f24) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f25 (f16 (f17 f18 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f22) ?v_0) (f3 (f4 f5 f20) ?v_0)) (f16 (f17 f18 (+ (* 4 f24) 1)) (+ 1 (f3 f11 f12))))))
(assert (= (f26 (+ (* 4 f24) 1)) f1))
(assert (= (f16 (f17 f27 (- 1)) (+ (* 4 f24) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f16 (f17 f18 (+ (* 4 f24) 1)) (+ 1 (f3 f11 f12)))) false))) false))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f4 f5 f14) (f7 f8 2)) 1) (f16 (f17 f18 (+ (* 4 f24) 1)) ?v0)) false)) false))
(assert (let ((?v_2 (f7 f8 2)) (?v_1 (f17 f18 f21)) (?v_0 (f17 f18 f23))) (= (+ (f3 (f4 f5 (+ (+ (f16 ?v_0 f6) (f16 ?v_1 f9)) f19)) ?v_2) (f3 (f4 f5 (- (f16 ?v_0 f9) (f16 ?v_1 f6))) ?v_2)) (f16 (f17 f18 (+ (* 4 f24) 1)) f19))))
(assert (let ((?v_1 (+ 1 (f3 f11 f12))) (?v_0 (+ (* 4 f24) 1))) (and (< ?v_1 ?v_0) (= (f25 (f16 (f17 f18 ?v_0) ?v_1)) f1))))
(assert (= (f25 (f16 (f17 f18 (+ (* 4 f24) 1)) f10)) f1))
(assert (= (f25 (f16 (f17 f18 (+ (* 4 f24) 1)) f19)) f1))
(assert (=> (= f10 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f24) 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f16 (f17 f18 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f16 (f17 f18 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 ?v0 ?v1) f1) (= (f15 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 ?v0 ?v1) f1) (= (f15 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (= (f28 (+ (* 4 f24) 1) (- 1)) f1))
(assert (= (f29 (f3 (f4 f5 f14) (f7 f8 2)) (- 1) (+ (* 4 f24) 1)) f1))
(assert (= (f30 f31 (f32 f14 1)) (f16 (f17 f18 (+ (* 4 f24) 1)) f10)))
(assert (let ((?v_0 (+ (* 4 f24) 1))) (and (<= 0 f14) (and (< f14 ?v_0) (= (f29 f33 f14 ?v_0) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f34 ?v0 ?v1) f1) (= (f34 (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f15 ?v0 ?v1) f1) (= (f15 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v2))) (=> (<= (f3 f11 ?v0) (f3 f11 ?v1)) (= (f34 (f35 ?v_0 ?v0) (f35 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f4 f5 ?v2))) (=> (<= (f3 f11 ?v0) (f3 f11 ?v1)) (= (f15 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (= (f29 (f3 (f4 f5 f33) (f7 f8 2)) (- 1) (+ (* 4 f24) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f24) 1))) (=> (not (= (f28 ?v_0 (- 1)) f1)) (not (= (f16 (f17 f27 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f3 (f4 f5 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f24) 1)) f1) false)) false))
(assert (let ((?v_0 (f7 f8 2))) (= (f29 (f3 (f4 f5 f14) ?v_0) (f3 (f4 f5 f33) ?v_0) (+ (* 4 f24) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f24) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f33 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f24) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f26 ?v0) f1) (=> (not (= (f29 ?v1 0 ?v0) f1)) (=> (not (= (f29 ?v2 0 ?v0) f1)) (not (= (f29 (f16 (f17 f18 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f26 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f29 ?v1 0 ?v0) f1)) (not (= (f29 ?v2 0 ?v0) f1))) (not (= (f29 (f16 (f17 f18 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f26 ?v0) f1) (=> (< 0 ?v1) (=> (= (f29 (f16 (f17 f18 ?v1) ?v2) 0 ?v0) f1) (or (= (f29 ?v1 0 ?v0) f1) (= (f29 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f29 ?v3 ?v4 ?v2) f1) (= (f29 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f29 ?v1 (- 1) ?v0) f1) (not (= (f29 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f29 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f29 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int)) (= (f29 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f17 f18 ?v0)) (?v_1 (f17 f18 ?v1))) (= (f16 (f17 f18 (f30 f31 (f32 ?v0 ?v1))) (f30 f31 (f32 ?v2 ?v3))) (f30 f31 (f32 (+ (f16 ?v_0 ?v2) (f16 ?v_1 ?v3)) (- (f16 ?v_0 ?v3) (f16 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f26 ?v_0) f1) (= (f16 (f17 f27 (- 1)) ?v_0) 1)))))
(assert (= (f26 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f16 (f17 f18 ?v0) ?v4) ?v2) f1) (= (f29 ?v3 (f16 (f17 f18 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f17 f18 ?v4))) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (= (f29 ?v3 (f16 ?v_0 ?v0) ?v2) f1) (= (f29 ?v3 (f16 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f15 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 0 ?v1) f1) (= (f15 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f29 ?v0 ?v1 ?v2) f1) (= (f29 (f3 (f4 f5 ?v0) ?v3) (f3 (f4 f5 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f7 f8 (f3 (f4 f5 ?v0) ?v1)) (f35 (f36 f37 (f7 f8 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f3 f11 ?v0)) ?v1) (f3 f11 (f35 (f36 f37 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f11 (f35 (f36 f37 ?v0) ?v1)) (f3 (f4 f5 (f3 f11 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f34 ?v0 ?v1) f1) (= (f15 (f3 f11 ?v0) (f3 f11 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f15 ?v0 (f3 f11 ?v1)) f1) (= (f34 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f15 (f3 f11 ?v0) ?v1) f1) (= (f34 ?v0 (f7 f8 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f34 (f7 f8 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f15 ?v0 (f3 f11 ?v1)) f1) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f29 ?v0 0 ?v1) f1)) (=> (= (f29 (f3 (f4 f5 ?v2) (f7 f8 2)) ?v0 ?v1) f1) (not (= (f15 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f26 ?v0) f1) (=> (= (f15 ?v0 (f16 (f17 f18 ?v1) ?v2)) f1) (or (= (f15 ?v0 ?v1) f1) (= (f15 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f11 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f11 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f11 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
