(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) Int)
(declare-fun f4 () S3)
(declare-fun f5 () S2)
(declare-fun f6 () Int)
(declare-fun f7 (Int) S1)
(declare-fun f8 (S4 Int) Int)
(declare-fun f9 (S5 Int) S4)
(declare-fun f10 () S5)
(declare-fun f11 () S2)
(declare-fun f12 (S6 Int) S2)
(declare-fun f13 () S6)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 (Int) S1)
(declare-fun f17 () S5)
(declare-fun f18 (Int Int) S1)
(declare-fun f19 () S2)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 (S7 Int) S3)
(declare-fun f23 () S7)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 () Int)
(declare-fun f29 (Int Int) S1)
(declare-fun f30 (Int Int Int) S1)
(declare-fun f31 (S8 S9) Int)
(declare-fun f32 () S8)
(declare-fun f33 (Int Int) S9)
(declare-fun f34 () Int)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 S2)) (let ((?v_0 (f3 f4 ?v0)) (?v_1 (+ (* 4 f6) 1))) (let ((?v_2 (+ 1 ?v_0))) (and (< ?v_0 (f3 f4 f5)) (not (=> (< ?v_2 ?v_1) (not (= (f7 (f8 (f9 f10 ?v_1) ?v_2)) f1))))))))))
(assert (and (= f11 (f12 f13 (- (f3 f4 (f12 f13 f14)) 1))) (= (f7 (f8 (f9 f10 (+ (* 4 f6) 1)) (+ 1 (f3 f4 f11)))) f1)))
(assert (< (f3 f4 f11) (f3 f4 f5)))
(assert (< (+ 1 (f3 f4 f11)) (+ (* 4 f6) 1)))
(assert (< 0 f14))
(assert (= (+ 1 (f3 f4 (f12 f13 (- (f3 f4 (f12 f13 f14)) 1)))) f14))
(assert (< 1 f15))
(assert (< (+ 1 (f3 f4 f11)) (+ (* 4 f6) 1)))
(assert (< (f3 f4 f11) (f3 f4 f5)))
(assert (< 0 (f3 f4 f5)))
(assert (and (= f11 (f12 f13 (- (f3 f4 (f12 f13 f14)) 1))) (= (f7 (f8 (f9 f10 (+ (* 4 f6) 1)) (+ 1 (f3 f4 f11)))) f1)))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (< 0 (+ 1 (f3 f4 f5))))
(assert (not (= (f7 (f8 (f9 f10 (+ (* 4 f6) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f5)))) (not (=> (< ?v_1 ?v_0) (not (= (f7 (f8 (f9 f10 ?v_0) ?v_1)) f1))))))
(assert (< f14 (+ 1 (f3 f4 f5))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f5)))) (and (< ?v_1 ?v_0) (= (f7 (f8 (f9 f10 ?v_0) ?v_1)) f1))))
(assert (= (f7 (f8 (f9 f10 (+ (* 4 f6) 1)) f14)) f1))
(assert (= (f7 (f8 (f9 f10 (+ (* 4 f6) 1)) (+ 1 (f3 f4 (f12 f13 (- (f3 f4 (f12 f13 f14)) 1)))))) f1))
(assert (= (f16 (+ (* 4 f6) 1)) f1))
(assert (= (f8 (f9 f17 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (=> (forall ((?v0 S2)) (=> (and (= ?v0 (f12 f13 (- (f3 f4 (f12 f13 f14)) 1))) (= (f7 (f8 (f9 f10 (+ (* 4 f6) 1)) (+ 1 (f3 f4 ?v0)))) f1)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f7 ?v0) f1) (=> (= (f7 ?v1) f1) (= (f7 (f8 (f9 f10 ?v0) ?v1)) f1)))))
(assert (= (f18 (+ (* 4 f6) 1) (- 1)) f1))
(assert (= f19 (f12 f13 (- (f3 f4 (f12 f13 f15)) 1))))
(assert (= (f7 (f8 (f9 f10 (+ (* 4 f6) 1)) f15)) f1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f20 (f8 (f9 f10 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f5)))) (=> (and (= ?v1 (- f21 (f8 (f9 f10 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (< f15 (+ (* 4 f6) 1)))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (=> (= (+ (f3 (f22 f23 ?v0) ?v_0) (f3 (f22 f23 ?v1) ?v_0)) (f8 (f9 f10 (+ (* 4 f6) 1)) (+ 1 (f3 f4 f5)))) false))) false))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f24 (- f20 (f8 (f9 f10 f25) ?v_0))) (<= (ite (< f24 0) (* (- 2) f24) (* 2 f24)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f4 f5)))) (and (= f26 (- f21 (f8 (f9 f10 f27) ?v_0))) (<= (ite (< f26 0) (* (- 2) f26) (* 2 f26)) ?v_0))))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (f3 (f22 f23 f20) ?v_0) (f3 (f22 f23 f21) ?v_0)) (f8 (f9 f10 (+ (* 4 f6) 1)) (+ 1 (f3 f4 f5))))))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (=> (not (= (f18 ?v_0 (- 1)) f1)) (not (= (f8 (f9 f17 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (< 0 (f3 f4 f19)))
(assert (<= 1 f15))
(assert (=> (forall ((?v0 S2)) (=> (= ?v0 (f12 f13 (- (f3 f4 (f12 f13 f15)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (let ((?v_0 (f12 f13 2))) (= (+ (f3 (f22 f23 f24) ?v_0) (f3 (f22 f23 f26) ?v_0)) (f8 (f9 f10 (+ 1 (f3 f4 f5))) f14))))
(assert (= (+ (f3 (f22 f23 f28) (f12 f13 2)) 1) (f8 (f9 f10 (+ (* 4 f6) 1)) f15)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f12 f13 2))) (=> (= (+ (f3 (f22 f23 f24) ?v_0) (f3 (f22 f23 f26) ?v_0)) (f8 (f9 f10 (+ 1 (f3 f4 f5))) ?v0)) false))) false))
(assert (let ((?v_2 (f12 f13 2)) (?v_0 (f9 f10 f25)) (?v_1 (f9 f10 f27))) (= (+ (f3 (f22 f23 (+ (+ (f8 ?v_0 f24) (f8 ?v_1 f26)) f14)) ?v_2) (f3 (f22 f23 (- (f8 ?v_0 f26) (f8 ?v_1 f24))) ?v_2)) (f8 (f9 f10 (+ (* 4 f6) 1)) f14))))
(assert (=> (= f15 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (+ (f3 (f22 f23 ?v0) ?v_0) (f3 (f22 f23 ?v1) ?v_0)) (+ (* 4 f6) 1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f3 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f3 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f12 f13 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f16 ?v_0) f1) (= (f8 (f9 f17 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f22 f23 ?v0))) (= (f3 ?v_0 (f12 f13 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f8 (f9 f10 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f8 (f9 f10 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f8 (f9 f10 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f3 f4 ?v2))) (let ((?v_1 (f9 f10 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f8 ?v_1 ?v0) (f8 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f8 ?v_0 ?v0) (f8 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (- ?v0 ?v1)) ?v2) (- (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f8 (f9 f10 (+ ?v0 ?v1)) ?v2) (+ (f8 (f9 f10 ?v0) ?v2) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f8 (f9 f10 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f8 (f9 f10 (- ?v0)) ?v1) (- (f8 (f9 f10 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (- ?v1 ?v2)) (- (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (+ ?v1 ?v2)) (+ (f8 ?v_0 ?v1) (f8 ?v_0 ?v2))))))
(assert (let ((?v_0 (f12 f13 2))) (= (f29 (+ 1 (f3 f4 f5)) (+ (f3 (f22 f23 f24) ?v_0) (f3 (f22 f23 f26) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f22 f23 f28) (f12 f13 2)) 1) (f8 (f9 f10 (+ (* 4 f6) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f22 f23 ?v1)) (?v_1 (f12 f13 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f8 (f9 f10 ?v1) (f3 ?v_0 (f12 f13 (- (f3 f4 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f8 (f9 f10 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f22 f23 ?v0) ?v_0) (f3 (f22 f23 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f12 f13 2)) (?v_0 (f12 f13 3)) (?v_3 (f22 f23 ?v1)) (?v_1 (f22 f23 ?v0))) (= (f3 (f22 f23 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f12 f13 2)) (?v_0 (f12 f13 3)) (?v_1 (f22 f23 ?v0)) (?v_3 (f22 f23 ?v1))) (= (f3 (f22 f23 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f8 (f9 f10 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f8 (f9 f10 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f3 (f22 f23 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f22 f23 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f3 (f22 f23 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (f3 (f22 f23 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f22 f23 ?v0) ?v_0) (f8 (f9 f10 (* 2 ?v0)) ?v1)) (f3 (f22 f23 ?v1) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f8 (f9 f10 ?v0) (f3 ?v_0 (f12 f13 2))) (f3 ?v_0 (f12 f13 3))))))
(assert (let ((?v_0 (f3 (f22 f23 f28) (f12 f13 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f29 (+ (* 4 f6) 1) (+ (f3 (f22 f23 f28) (f12 f13 2)) 1)) f1))
(assert (= (f29 (+ (* 4 f6) 1) (- (f3 (f22 f23 f28) (f12 f13 2)) (- 1))) f1))
(assert (forall ((?v0 Int)) (= (= (f29 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f29 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0 (- ?v1 ?v2)) f1) (=> (= (f29 ?v0 ?v2) f1) (= (f29 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 (+ ?v1 (f8 (f9 f10 ?v0) ?v2))) f1) (= (f29 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f29 (f8 (f9 f10 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1) f1) (= (= (f29 ?v0 (+ ?v2 ?v3)) f1) (= (f29 ?v0 (+ (+ ?v2 (f8 (f9 f10 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f29 (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f29 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f16 ?v0) f1) (=> (= (f29 ?v0 (f3 (f22 f23 ?v1) ?v2)) f1) (= (f29 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f3 (f22 f23 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (=> (= (f29 ?v_0 (f8 (f9 f10 ?v3) ?v1)) f1) (= (f29 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2) (?v3 Int)) (let ((?v_0 (f3 (f22 f23 ?v0) ?v2))) (=> (= (f16 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (=> (= (f29 ?v_0 (f8 (f9 f10 ?v1) ?v3)) f1) (= (f29 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f8 (f9 f10 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f22 f23 ?v0) (f12 f13 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 2))) (= (= (f3 (f22 f23 ?v0) ?v_0) (f3 (f22 f23 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 2)) (?v_1 (f22 f23 ?v0))) (= (f3 (f22 f23 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f12 f13 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f13 3))) (= (f3 (f22 f23 (- ?v0)) ?v_0) (- (f3 (f22 f23 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f12 f13 3))) (let ((?v_0 (f3 (f22 f23 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f12 f13 2))) (let ((?v_0 (f3 (f22 f23 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f22 f23 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f22 f23 ?v0) (f12 f13 2)))))
(assert (= (f16 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (=> (= (f16 ?v0) f1) (=> (= (f29 ?v0 (f3 (f22 f23 ?v1) ?v2)) f1) (=> (< 0 (f3 f4 ?v2)) (= (f29 ?v0 ?v1) f1))))))
(assert (= (f30 (f3 (f22 f23 f28) (f12 f13 2)) (- 1) (+ (* 4 f6) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f16 ?v1) f1) (=> (= (f29 ?v1 (f8 (f9 f10 ?v0) ?v2)) f1) (or (= (f29 ?v1 ?v0) f1) (= (f29 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f16 ?v0) f1) (=> (= (f29 ?v0 (f8 (f9 f10 ?v1) ?v2)) f1) (or (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f16 ?v1) f1) (= (f29 ?v1 ?v0) f1))))))
(assert (= (f31 f32 (f33 f28 1)) (f8 (f9 f10 (+ (* 4 f6) 1)) f15)))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (and (<= 0 f28) (and (< f28 ?v_0) (= (f30 f34 f28 ?v_0) f1)))))
(assert (= (f30 (f3 (f22 f23 f34) (f12 f13 2)) (- 1) (+ (* 4 f6) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f30 (f3 (f22 f23 ?v0) (f12 f13 2)) (- 1) (+ (* 4 f6) 1)) f1) false)) false))
(assert (let ((?v_0 (f12 f13 2))) (= (f30 (f3 (f22 f23 f28) ?v_0) (f3 (f22 f23 f34) ?v_0) (+ (* 4 f6) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f30 f34 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f30 f34 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f30 f34 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (= (f29 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S2)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f3 (f22 f23 ?v0) ?v3) (f3 (f22 f23 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f9 f10 ?v0)) (?v_1 (f9 f10 ?v1))) (= (f8 (f9 f10 (f31 f32 (f33 ?v0 ?v1))) (f31 f32 (f33 ?v2 ?v3))) (f31 f32 (f33 (+ (f8 ?v_0 ?v2) (f8 ?v_1 ?v3)) (- (f8 ?v_0 ?v3) (f8 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 (- ?v2)) f1) (= (f30 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f30 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f30 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f30 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f30 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f30 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f30 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f30 ?v1 (- 1) ?v0) f1) (not (= (f30 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v1 ?v3 ?v2) f1) (= (f30 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 S2)) (= (f12 f13 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
