(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (S4 Int) S3)
(declare-fun f8 () S4)
(declare-fun f9 () Int)
(declare-fun f10 (Int) S1)
(declare-fun f11 (S5 Int) Int)
(declare-fun f12 (S6 Int) S5)
(declare-fun f13 () S6)
(declare-fun f14 (Int Int) S1)
(declare-fun f15 (Int) S1)
(declare-fun f16 () S6)
(declare-fun f17 (S7 Int) S2)
(declare-fun f18 () S7)
(declare-fun f19 () Int)
(declare-fun f20 (Int Int Int) S1)
(declare-fun f21 () Int)
(declare-fun f22 (S8 S9) Int)
(declare-fun f23 () S8)
(declare-fun f24 (Int Int) S9)
(assert (not (= f1 f2)))
(assert (not (and (< (+ 1 (f3 f4 f5)) (+ (* 4 f6) 1)) (= f5 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1))))))
(assert (= f5 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1))))
(assert (<= 1 f9))
(assert (< f9 (+ (* 4 f6) 1)))
(assert (<= 1 f9))
(assert (< 1 f9))
(assert (< 0 (f3 f4 f5)))
(assert (< f9 (+ (* 4 f6) 1)))
(assert (= f5 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1))))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (= (f10 (+ (* 4 f6) 1)) f1))
(assert (= (f11 (f12 f13 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (= (f14 (+ (* 4 f6) 1) (- 1)) f1))
(assert (not (= (f15 (f11 (f12 f16 (+ (* 4 f6) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f3 f4 f5)))) (=> (< ?v_1 ?v_0) (not (= (f15 (f11 (f12 f16 ?v_0) ?v_1)) f1)))))
(assert (= (f15 (f11 (f12 f16 (+ (* 4 f6) 1)) f9)) f1))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (=> (not (= (f14 ?v_0 (- 1)) f1)) (not (= (f11 (f12 f13 (- 1)) ?v_0) 1)))))
(assert (=> (= f9 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f17 f18 ?v0) ?v_0) (f3 (f17 f18 ?v1) ?v_0)) (+ (* 4 f6) 1))))))
(assert (= (+ (f3 (f17 f18 f19) (f7 f8 2)) 1) (f11 (f12 f16 (+ (* 4 f6) 1)) f9)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 f21 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f20 f21 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f6) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f20 f21 ?v0 ?v_0) f1))) false))) false))
(assert (= (f22 f23 (f24 f19 1)) (f11 (f12 f16 (+ (* 4 f6) 1)) f9)))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (and (<= 0 f19) (and (< f19 ?v_0) (= (f20 f21 f19 ?v_0) f1)))))
(assert (= (f20 (f3 (f17 f18 f21) (f7 f8 2)) (- 1) (+ (* 4 f6) 1)) f1))
(assert (let ((?v_0 (f3 (f17 f18 f19) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f20 (f3 (f17 f18 f19) (f7 f8 2)) (- 1) (+ (* 4 f6) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f20 (f3 (f17 f18 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f6) 1)) f1) false)) false))
(assert (let ((?v_0 (f7 f8 2))) (= (f20 (f3 (f17 f18 f19) ?v_0) (f3 (f17 f18 f21) ?v_0) (+ (* 4 f6) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f17 f18 f19) (f7 f8 2)) 1) (f11 (f12 f16 (+ (* 4 f6) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f16 ?v0)) (?v_1 (f12 f16 ?v1))) (= (f11 (f12 f16 (f22 f23 (f24 ?v0 ?v1))) (f22 f23 (f24 ?v2 ?v3))) (f22 f23 (f24 (+ (f11 ?v_0 ?v2) (f11 ?v_1 ?v3)) (- (f11 ?v_0 ?v3) (f11 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (= (f15 ?v1) f1) (= (f15 (f11 (f12 f16 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f10 ?v_0) f1) (= (f11 (f12 f13 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int)) (= (= (f15 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f22 f23 (f24 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 ?v0) ?v1) (ite (= (f20 ?v0 0 ?v1) f1) 0 (ite (= (f14 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f14 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f20 (f3 (f17 f18 ?v2) (f7 f8 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
