(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
      Tokeneer case study <http://www.adacore.com/home/products/gnatpro/tokeneer/>
  |)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun field.cryptotypes__issuert.id () Int)
(declare-fun field.cryptotypes__issuert.namelength () Int)
(declare-fun field.cryptotypes__issuert.name () Int)
(declare-fun field.certtypes__idt.issuer () Int)
(declare-fun field.certtypes__idt.serialnumber () Int)
(declare-fun field.contentst.id () Int)
(declare-fun field.contentst.notbefore () Int)
(declare-fun field.contentst.notafter () Int)
(declare-fun field.contentst.mechanism () Int)
(declare-fun certtypes__serialnumbert__base__first () Int)
(declare-fun certtypes__serialnumbert__base__last () Int)
(declare-fun certtypes__serialnumbert__first () Int)
(declare-fun certtypes__serialnumbert__last () Int)
(declare-fun certtypes__serialnumbert__size () Int)
(declare-fun character__base__first () Int)
(declare-fun character__base__last () Int)
(declare-fun character__first () Int)
(declare-fun character__last () Int)
(declare-fun character__size () Int)
(declare-fun cryptotypes__algorithmt__base__first () Int)
(declare-fun cryptotypes__algorithmt__base__last () Int)
(declare-fun cryptotypes__algorithmt__first () Int)
(declare-fun cryptotypes__algorithmt__last () Int)
(declare-fun cryptotypes__algorithmt__size () Int)
(declare-fun cryptotypes__issueridt__base__first () Int)
(declare-fun cryptotypes__issueridt__base__last () Int)
(declare-fun cryptotypes__issueridt__first () Int)
(declare-fun cryptotypes__issueridt__last () Int)
(declare-fun cryptotypes__issueridt__size () Int)
(declare-fun cryptotypes__md2 () Int)
(declare-fun cryptotypes__md2_rsa () Int)
(declare-fun cryptotypes__md5 () Int)
(declare-fun cryptotypes__md5_rsa () Int)
(declare-fun cryptotypes__namecountt__base__first () Int)
(declare-fun cryptotypes__namecountt__base__last () Int)
(declare-fun cryptotypes__namecountt__first () Int)
(declare-fun cryptotypes__namecountt__last () Int)
(declare-fun cryptotypes__namecountt__size () Int)
(declare-fun cryptotypes__namei__base__first () Int)
(declare-fun cryptotypes__namei__base__last () Int)
(declare-fun cryptotypes__namei__first () Int)
(declare-fun cryptotypes__namei__last () Int)
(declare-fun cryptotypes__namei__size () Int)
(declare-fun cryptotypes__ripemd128 () Int)
(declare-fun cryptotypes__ripemd128_rsa () Int)
(declare-fun cryptotypes__ripemd160 () Int)
(declare-fun cryptotypes__ripemd160_rsa () Int)
(declare-fun cryptotypes__rsa () Int)
(declare-fun cryptotypes__sha1_rsa () Int)
(declare-fun cryptotypes__sha_1 () Int)
(declare-fun integer__base__first () Int)
(declare-fun integer__base__last () Int)
(declare-fun integer__first () Int)
(declare-fun integer__last () Int)
(declare-fun integer__size () Int)
(declare-fun null__string () Int)
(declare-fun positive__base__first () Int)
(declare-fun positive__base__last () Int)
(declare-fun positive__first () Int)
(declare-fun positive__last () Int)
(declare-fun positive__size () Int)
(declare-fun contents () Int)
(declare-fun init.contents () Int)
(declare-fun bit__and (Int Int) Int)
(declare-fun bit__not (Int Int) Int)
(declare-fun bit__or (Int Int) Int)
(declare-fun bit__xor (Int Int) Int)
(declare-fun character__pos (Int) Int)
(declare-fun character__val (Int) Int)
(declare-fun cryptotypes__algorithmt__pos (Int) Int)
(declare-fun cryptotypes__algorithmt__pred (Int) Int)
(declare-fun cryptotypes__algorithmt__succ (Int) Int)
(declare-fun cryptotypes__algorithmt__val (Int) Int)
(declare-fun integer__pred (Int) Int)
(declare-fun integer__succ (Int) Int)
(declare-fun round__ (Int) Int)
(declare-fun i.div (Int Int) Int)
(declare-fun i.mod (Int Int) Int)
(declare-fun i.mult (Int Int) Int)
(declare-fun i.exp (Int Int) Int)
(declare-fun tm.true () Int)
(declare-fun tm.false () Int)
(declare-fun tm.not (Int) Int)
(declare-fun tm.and (Int Int) Int)
(declare-fun tm.or (Int Int) Int)
(declare-fun tm.iff (Int Int) Int)
(declare-fun tm.eq (Int Int) Int)
(declare-fun tm.ne (Int Int) Int)
(declare-fun tm.lt (Int Int) Int)
(declare-fun tm.le (Int Int) Int)
(declare-fun tuple.2 (Int Int) Int)
(declare-fun a.store (Int Int Int) Int)
(declare-fun a.select (Int Int) Int)
(declare-fun a.mk_const_array (Int) Int)
(declare-fun a.default_array () Int)
(declare-fun r.default_record () Int)
(declare-fun cryptotypes__algorithmt__LE (Int Int) Bool)
(declare-fun cryptotypes__algorithmt__LT (Int Int) Bool)
(assert (forall ((?i Int)) (=> (and (<= 0 ?i) (< ?i 11)) (= (cryptotypes__algorithmt__pos ?i) ?i))))
(assert (forall ((?i Int)) (=> (and (<= 0 ?i) (< ?i 11)) (= (cryptotypes__algorithmt__val ?i) ?i))))
(assert (forall ((?i Int)) (=> (and (<= 0 ?i) (< ?i 10)) (= (cryptotypes__algorithmt__succ ?i) (+ ?i 1)))))
(assert (forall ((?i Int)) (=> (and (<= 1 ?i) (< ?i 11)) (= (cryptotypes__algorithmt__pred ?i) (- ?i 1)))))
(assert (= cryptotypes__rsa 0))
(assert (= cryptotypes__md2 1))
(assert (= cryptotypes__md5 2))
(assert (= cryptotypes__sha_1 3))
(assert (= cryptotypes__ripemd128 4))
(assert (= cryptotypes__ripemd160 5))
(assert (= cryptotypes__md2_rsa 6))
(assert (= cryptotypes__md5_rsa 7))
(assert (= cryptotypes__sha1_rsa 8))
(assert (= cryptotypes__ripemd128_rsa 9))
(assert (= cryptotypes__ripemd160_rsa 10))
(assert (<= 0 integer__size))
(assert (= integer__first (- 2147483648)))
(assert (= integer__last 2147483647))
(assert (= integer__base__first (- 2147483648)))
(assert (= integer__base__last 2147483647))
(assert (<= 0 character__size))
(assert (= character__first 0))
(assert (= character__last 255))
(assert (= character__base__first 0))
(assert (= character__base__last 255))
(assert (<= 0 positive__size))
(assert (= positive__first 1))
(assert (= positive__last 2147483647))
(assert (= positive__base__first (- 2147483648)))
(assert (= positive__base__last 2147483647))
(assert (<= 0 cryptotypes__namecountt__size))
(assert (= cryptotypes__namecountt__first 0))
(assert (= cryptotypes__namecountt__last 40))
(assert (= cryptotypes__namecountt__base__first (- 2147483648)))
(assert (= cryptotypes__namecountt__base__last 2147483647))
(assert (<= 0 cryptotypes__namei__size))
(assert (= cryptotypes__namei__first 1))
(assert (= cryptotypes__namei__last 40))
(assert (= cryptotypes__namei__base__first (- 2147483648)))
(assert (= cryptotypes__namei__base__last 2147483647))
(assert (<= 0 cryptotypes__issueridt__size))
(assert (= cryptotypes__issueridt__first 0))
(assert (= cryptotypes__issueridt__last 4294967295))
(assert (<= cryptotypes__issueridt__base__first cryptotypes__issueridt__base__last))
(assert (<= cryptotypes__issueridt__base__first cryptotypes__issueridt__first))
(assert (<= cryptotypes__issueridt__last cryptotypes__issueridt__base__last))
(assert (<= 0 cryptotypes__algorithmt__size))
(assert (= cryptotypes__algorithmt__first cryptotypes__rsa))
(assert (= cryptotypes__algorithmt__last cryptotypes__ripemd160_rsa))
(assert (= cryptotypes__algorithmt__base__first cryptotypes__rsa))
(assert (= cryptotypes__algorithmt__base__last cryptotypes__ripemd160_rsa))
(assert (<= 0 certtypes__serialnumbert__size))
(assert (= certtypes__serialnumbert__first 0))
(assert (= certtypes__serialnumbert__last 4294967295))
(assert (<= certtypes__serialnumbert__base__first certtypes__serialnumbert__base__last))
(assert (<= certtypes__serialnumbert__base__first certtypes__serialnumbert__first))
(assert (<= certtypes__serialnumbert__last certtypes__serialnumbert__base__last))
(assert (forall ((?X Int) (?Y Int)) (=> (< 0 ?Y) (<= 0 (i.mod ?X ?Y)))))
(assert (forall ((?X Int) (?Y Int)) (=> (< 0 ?Y) (< (i.mod ?X ?Y) ?Y))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (< 0 ?Y)) (<= (i.mult ?Y (i.div ?X ?Y)) ?X))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (< 0 ?Y)) (< (- ?X ?Y) (i.mult ?Y (i.div ?X ?Y))))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= ?X 0) (< 0 ?Y)) (<= ?X (i.mult ?Y (i.div ?X ?Y))))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= ?X 0) (< 0 ?Y)) (< (i.mult ?Y (i.div ?X ?Y)) (+ ?X ?Y)))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (<= 0 ?Y)) (<= 0 (bit__or ?X ?Y)))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (<= 0 ?Y)) (<= ?X (bit__or ?X ?Y)))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (<= 0 ?Y)) (<= ?Y (bit__or ?X ?Y)))))
(assert (forall ((?X Int) (?Y Int)) (=> (and (<= 0 ?X) (<= 0 ?Y)) (<= (bit__or ?X ?Y) (+ ?X ?Y)))))
(assert (distinct field.cryptotypes__issuert.id field.cryptotypes__issuert.namelength field.cryptotypes__issuert.name))
(assert (distinct field.certtypes__idt.issuer field.certtypes__idt.serialnumber))
(assert (distinct field.contentst.id field.contentst.notbefore field.contentst.notafter field.contentst.mechanism))
(assert (distinct tm.true tm.false))
(assert (forall ((?x Int)) (! (= (= (tm.not ?x) tm.true) (not (= ?x tm.true))) :pattern ((tm.not ?x)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.and ?x ?y) tm.true) (and (= ?x tm.true) (= ?y tm.true))) :pattern ((tm.and ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.or ?x ?y) tm.true) (or (= ?x tm.true) (= ?y tm.true))) :pattern ((tm.or ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.iff ?x ?y) tm.true) (= (= ?x tm.true) (= ?y tm.true))) :pattern ((tm.iff ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.eq ?x ?y) tm.true) (= ?x ?y)) :pattern ((tm.eq ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.ne ?x ?y) tm.true) (not (= ?x ?y))) :pattern ((tm.ne ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.lt ?x ?y) tm.true) (< ?x ?y)) :pattern ((tm.lt ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (! (= (= (tm.le ?x ?y) tm.true) (<= ?x ?y)) :pattern ((tm.le ?x ?y)) )))
(assert (forall ((?a Int) (?i Int) (?v Int)) (! (= (a.select (a.store ?a ?i ?v) ?i) ?v) :pattern ((a.select (a.store ?a ?i ?v) ?i)) )))
(assert (forall ((?a Int) (?i Int) (?v Int) (?j Int)) (! (or (= ?i ?j) (= (a.select (a.store ?a ?i ?v) ?j) (a.select ?a ?j))) :pattern ((a.select (a.store ?a ?i ?v) ?j)) )))
(assert (forall ((?i Int) (?v Int)) (! (= (a.select (a.mk_const_array ?v) ?i) ?v) :pattern ((a.select (a.mk_const_array ?v) ?i)) )))
(assert true)
(assert (<= cryptotypes__algorithmt__first (a.select contents field.contentst.mechanism)))
(assert (<= (a.select contents field.contentst.mechanism) cryptotypes__algorithmt__last))
(assert true)
(assert true)
(assert (<= certtypes__serialnumbert__first (a.select (a.select contents field.contentst.id) field.certtypes__idt.serialnumber)))
(assert (<= (a.select (a.select contents field.contentst.id) field.certtypes__idt.serialnumber) certtypes__serialnumbert__last))
(assert (forall ((?i___1 Int)) (let ((?v_0 (a.select (a.select (a.select (a.select contents field.contentst.id) field.certtypes__idt.issuer) field.cryptotypes__issuert.name) ?i___1))) (=> (and (<= cryptotypes__namei__first ?i___1) (<= ?i___1 cryptotypes__namei__last)) (and (<= character__first ?v_0) (<= ?v_0 character__last))))))
(assert (<= cryptotypes__namecountt__first (a.select (a.select (a.select contents field.contentst.id) field.certtypes__idt.issuer) field.cryptotypes__issuert.namelength)))
(assert (<= (a.select (a.select (a.select contents field.contentst.id) field.certtypes__idt.issuer) field.cryptotypes__issuert.namelength) cryptotypes__namecountt__last))
(assert (<= cryptotypes__issueridt__first (a.select (a.select (a.select contents field.contentst.id) field.certtypes__idt.issuer) field.cryptotypes__issuert.id)))
(assert (<= (a.select (a.select (a.select contents field.contentst.id) field.certtypes__idt.issuer) field.cryptotypes__issuert.id) cryptotypes__issueridt__last))
(assert (let ((?v_0 (a.select contents field.contentst.mechanism))) (not (and true (<= cryptotypes__algorithmt__first ?v_0) (<= ?v_0 cryptotypes__algorithmt__last)))))
(check-sat)
(exit)
