(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source | 
  Boogie/Spec# benchmarks.
  This benchmark was translated by Michal Moskal.
|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun n () Int)
(declare-fun InRange (Int Int) Bool)
(declare-fun int_18446744073709551615 () Int)
(declare-fun Smt.false () Int)
(declare-fun join_2_body_correct () Int)
(declare-fun body_correct () Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun select1 (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun i_0 () Int)
(declare-fun start_2_body_correct () Int)
(declare-fun i_1 () Int)
(declare-fun CONCVARSYM (Int) Int)
(declare-fun i_2 () Int)
(declare-fun divides (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun subtypes (Int Int) Bool)
(declare-fun store1 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun BodyCheck_correct () Int)
(declare-fun StartCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun int_2147483647 () Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun ReallyLastGeneratedExit_correct () Int)
(declare-fun int_m9223372036854775808 () Int)
(declare-fun Smt.true () Int)
(declare-fun int_4294967295 () Int)
(declare-fun start_correct () Int)
(declare-fun BodyCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun StartCheck_correct () Int)
(declare-fun boolNot (Int) Int)
(declare-fun GeneratedUnifiedExit_correct () Int)
(declare-fun intLess (Int Int) Int)
(declare-fun JoinCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun f_ (Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun is (Int Int) Int)
(declare-fun join_correct () Int)
(declare-fun int_m2147483648 () Int)
(declare-fun modulo (Int Int) Int)
(declare-fun JoinCheck_correct () Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun int_9223372036854775807 () Int)
(assert true)
(assert true)
(assert (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v)))
(assert (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v)))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolIff ?x ?y) Smt.true) (= (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolImplies ?x ?y) Smt.true) (=> (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolAnd ?x ?y) Smt.true) (and (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolOr ?x ?y) Smt.true) (or (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int)) (! (= (= (boolNot ?x) Smt.true) (not (= ?x Smt.true))) :pattern ((boolNot ?x)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (anyEqual ?x ?y) Smt.true) (= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (! (= (= (anyNeq ?x ?y) Smt.true) (not (= ?x ?y))) :pattern ((anyNeq ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (intLess ?x ?y) Smt.true) (< ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtMost ?x ?y) Smt.true) (<= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtLeast ?x ?y) Smt.true) (>= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intGreater ?x ?y) Smt.true) (> ?x ?y))))
(assert (distinct Smt.false Smt.true))
(assert (forall ((?t Int)) (! (subtypes ?t ?t) :pattern ((subtypes ?t ?t)) )))
(assert (forall ((?t Int) (?u Int) (?v Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?v)) (subtypes ?t ?v)) :pattern ((subtypes ?t ?u) (subtypes ?u ?v)) )))
(assert (forall ((?t Int) (?u Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?t)) (= ?t ?u)) :pattern ((subtypes ?t ?u) (subtypes ?u ?t)) )))
(assert (let ((?v_0 (= 0 0))) (let ((?v_13 (and ?v_0 ?v_0)) (?v_14 (= start_correct Smt.true)) (?v_2 (<= 0 0)) (?v_3 (f_ n))) (let ((?v_1 (<= 0 ?v_3)) (?v_15 (= start_2_body_correct Smt.true)) (?v_5 (<= 0 i_0)) (?v_4 (<= i_0 ?v_3))) (let ((?v_6 (and ?v_4 ?v_5 ?v_0)) (?v_16 (= body_correct Smt.true)) (?v_10 (<= i_1 (+ ?v_3 1)))) (let ((?v_9 (and ?v_10 (<= (+ 0 1) i_1) ?v_0)) (?v_17 (= join_correct Smt.true)) (?v_8 (<= 0 i_1)) (?v_7 (<= i_1 ?v_3)) (?v_18 (= join_2_body_correct Smt.true)) (?v_11 (<= 1 i_1)) (?v_19 (= JoinCheck_correct Smt.true)) (?v_20 (= JoinCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_12 (=> true true)) (?v_21 (= GeneratedUnifiedExit_correct Smt.true)) (?v_22 (= ReallyLastGeneratedExit_correct Smt.true)) (?v_23 (= BodyCheck_correct Smt.true)) (?v_24 (= BodyCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_25 (= StartCheck_correct Smt.true)) (?v_26 (= StartCheck_2_GeneratedUnifiedExit_correct Smt.true))) (not (=> (and (=> (=> true (=> true (=> ?v_13 true))) ?v_14) (=> (=> true (=> (and ?v_2 ?v_0) (=> ?v_1 (=> (and ?v_1 ?v_2 ?v_0) true)))) ?v_15) (=> (=> true (=> (and ?v_5 ?v_0) (=> ?v_4 (=> ?v_6 true)))) ?v_16) (=> (=> true (=> ?v_6 (=> (= i_1 (+ i_0 1)) (=> ?v_9 true)))) ?v_17) (=> (=> true (=> (and ?v_8 ?v_0) (=> ?v_7 (=> (and ?v_7 ?v_8 ?v_0) (=> false true))))) ?v_18) (=> (=> true (=> ?v_9 (and ?v_10 ?v_11 (=> (and ?v_10 ?v_11) (=> (and ?v_11 ?v_10 ?v_0) true))))) ?v_19) (=> (=> true (=> (= i_2 i_1) true)) ?v_20) (=> ?v_12 ?v_21) (=> ?v_12 ?v_22) (=> (=> true (=> ?v_6 (and ?v_4 ?v_5 (=> (and ?v_4 ?v_5) (=> (and ?v_5 ?v_4 ?v_0) true))))) ?v_23) (=> (=> true (=> (= i_2 i_0) true)) ?v_24) (=> (=> true (=> ?v_13 (and ?v_0 (=> ?v_0 (=> (and ?v_0 ?v_0 ?v_0) true))))) ?v_25) (=> (=> true (=> (= i_2 0) true)) ?v_26)) (and ?v_14 ?v_15 ?v_16 ?v_17 ?v_18 ?v_19 ?v_20 ?v_21 ?v_22 ?v_23 ?v_24 ?v_25 ?v_26)))))))))
(check-sat)
(exit)
