(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source | 
  Boogie/Spec# benchmarks.
  This benchmark was translated by Michal Moskal.
|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-fun InRange (Int Int) Bool)
(declare-fun int_18446744073709551615 () Int)
(declare-fun Smt.false () Int)
(declare-fun body_correct () Int)
(declare-fun join_2_body_correct () Int)
(declare-fun then_correct () Int)
(declare-fun anyEqual (Int Int) Int)
(declare-fun end_correct () Int)
(declare-fun select1 (Int Int) Int)
(declare-fun select2 (Int Int Int) Int)
(declare-fun then_2_join_correct () Int)
(declare-fun start_2_body_correct () Int)
(declare-fun i_0 () Int)
(declare-fun i_1 () Int)
(declare-fun CONCVARSYM (Int) Int)
(declare-fun i_2 () Int)
(declare-fun i_3 () Int)
(declare-fun divides (Int Int) Int)
(declare-fun intAtMost (Int Int) Int)
(declare-fun subtypes (Int Int) Bool)
(declare-fun store1 (Int Int Int) Int)
(declare-fun store2 (Int Int Int Int) Int)
(declare-fun intAtLeast (Int Int) Int)
(declare-fun int_2147483647 () Int)
(declare-fun boolOr (Int Int) Int)
(declare-fun ReallyLastGeneratedExit_correct () Int)
(declare-fun m_0 () Int)
(declare-fun realEnd_2_GeneratedUnifiedExit_correct () Int)
(declare-fun m_1 () Int)
(declare-fun realEnd_correct () Int)
(declare-fun m_2 () Int)
(declare-fun m_3 () Int)
(declare-fun int_m9223372036854775808 () Int)
(declare-fun Smt.true () Int)
(declare-fun int_4294967295 () Int)
(declare-fun start_correct () Int)
(declare-fun N () Int)
(declare-fun boolAnd (Int Int) Int)
(declare-fun join_2_end_correct () Int)
(declare-fun boolNot (Int) Int)
(declare-fun GeneratedUnifiedExit_correct () Int)
(declare-fun intLess (Int Int) Int)
(declare-fun JoinCheck_2_GeneratedUnifiedExit_correct () Int)
(declare-fun intGreater (Int Int) Int)
(declare-fun anyNeq (Int Int) Int)
(declare-fun is (Int Int) Int)
(declare-fun join_correct () Int)
(declare-fun int_m2147483648 () Int)
(declare-fun checkIfNgz_correct () Int)
(declare-fun start_2_end_correct () Int)
(declare-fun else_correct () Int)
(declare-fun modulo (Int Int) Int)
(declare-fun else_2_join_correct () Int)
(declare-fun JoinCheck_correct () Int)
(declare-fun boolImplies (Int Int) Int)
(declare-fun boolIff (Int Int) Int)
(declare-fun int_9223372036854775807 () Int)
(assert true)
(assert true)
(assert (forall ((?A Int) (?i Int) (?v Int)) (= (select1 (store1 ?A ?i ?v) ?i) ?v)))
(assert (forall ((?A Int) (?i Int) (?j Int) (?v Int)) (=> (not (= ?i ?j)) (= (select1 (store1 ?A ?i ?v) ?j) (select1 ?A ?j)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?v Int)) (= (select2 (store2 ?A ?o ?f ?v) ?o ?f) ?v)))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?o ?p)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?A Int) (?o Int) (?f Int) (?p Int) (?g Int) (?v Int)) (=> (not (= ?f ?g)) (= (select2 (store2 ?A ?o ?f ?v) ?p ?g) (select2 ?A ?p ?g)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolIff ?x ?y) Smt.true) (= (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolImplies ?x ?y) Smt.true) (=> (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolAnd ?x ?y) Smt.true) (and (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int) (?y Int)) (= (= (boolOr ?x ?y) Smt.true) (or (= ?x Smt.true) (= ?y Smt.true)))))
(assert (forall ((?x Int)) (! (= (= (boolNot ?x) Smt.true) (not (= ?x Smt.true))) :pattern ((boolNot ?x)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (anyEqual ?x ?y) Smt.true) (= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (! (= (= (anyNeq ?x ?y) Smt.true) (not (= ?x ?y))) :pattern ((anyNeq ?x ?y)) )))
(assert (forall ((?x Int) (?y Int)) (= (= (intLess ?x ?y) Smt.true) (< ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtMost ?x ?y) Smt.true) (<= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intAtLeast ?x ?y) Smt.true) (>= ?x ?y))))
(assert (forall ((?x Int) (?y Int)) (= (= (intGreater ?x ?y) Smt.true) (> ?x ?y))))
(assert (distinct Smt.false Smt.true))
(assert (forall ((?t Int)) (! (subtypes ?t ?t) :pattern ((subtypes ?t ?t)) )))
(assert (forall ((?t Int) (?u Int) (?v Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?v)) (subtypes ?t ?v)) :pattern ((subtypes ?t ?u) (subtypes ?u ?v)) )))
(assert (forall ((?t Int) (?u Int)) (! (=> (and (subtypes ?t ?u) (subtypes ?u ?t)) (= ?t ?u)) :pattern ((subtypes ?t ?u) (subtypes ?u ?t)) )))
(assert (let ((?v_0 (<= 0 0)) (?v_2 (<= 0 m_2))) (let ((?v_1 (and (<= 0 i_2) ?v_2)) (?v_3 (< m_2 N)) (?v_5 (= realEnd_correct Smt.true)) (?v_6 (= checkIfNgz_correct Smt.true)) (?v_8 (= GeneratedUnifiedExit_correct Smt.true))) (let ((?v_21 (=> true ?v_8)) (?v_4 (= realEnd_2_GeneratedUnifiedExit_correct Smt.true)) (?v_16 (= end_correct Smt.true)) (?v_15 (=> true true)) (?v_7 (= ReallyLastGeneratedExit_correct Smt.true)) (?v_9 (and ?v_0 ?v_0)) (?v_12 (<= 0 i_0))) (let ((?v_10 (and ?v_12 (<= 0 m_0))) (?v_26 (= join_correct Smt.true))) (let ((?v_27 (=> true ?v_26)) (?v_11 (= else_2_join_correct Smt.true)) (?v_30 (= else_correct Smt.true)) (?v_13 (<= 0 m_1)) (?v_18 (<= 1 i_1))) (let ((?v_17 (and ?v_18 ?v_13)) (?v_14 (and (<= 0 i_1) ?v_13)) (?v_23 (= join_2_body_correct Smt.true)) (?v_32 (=> true ?v_16)) (?v_24 (= join_2_end_correct Smt.true)) (?v_19 (<= i_1 N)) (?v_20 (< m_1 N)) (?v_22 (= JoinCheck_2_GeneratedUnifiedExit_correct Smt.true)) (?v_25 (= JoinCheck_correct Smt.true)) (?v_28 (= then_2_join_correct Smt.true)) (?v_29 (= then_correct Smt.true)) (?v_31 (= body_correct Smt.true)) (?v_33 (= start_2_body_correct Smt.true)) (?v_34 (= start_2_end_correct Smt.true)) (?v_35 (= start_correct Smt.true))) (not (=> (=> (=> true (=> true (=> (and ?v_0 ?v_0 ?v_0 ?v_0) (=> (and (=> (=> true (=> ?v_1 (=> ?v_1 (=> (and (=> (=> true (=> ?v_1 (=> (> N 0) (and ?v_2 ?v_3 (=> (and ?v_2 ?v_3) (=> ?v_1 (=> true ?v_5))))))) ?v_6) (=> (=> true (=> ?v_1 (=> ?v_1 (=> (=> (=> true (=> (= i_3 i_2) (=> (= m_3 m_2) ?v_21))) ?v_4) ?v_4)))) ?v_5)) (and ?v_6 ?v_5))))) ?v_16) (=> (=> true (=> (=> (=> true ?v_15) ?v_7) ?v_7)) ?v_8) (=> (=> true (=> ?v_9 (=> (< 0 N) (=> ?v_9 (=> (=> (=> true (=> ?v_10 (=> (< i_0 N) (=> ?v_10 (=> (and (=> (=> true (=> ?v_10 (=> ?v_10 (=> (=> (=> true (=> (= m_1 m_0) ?v_27)) ?v_11) ?v_11)))) ?v_30) (=> (=> true (=> (and ?v_12 ?v_13) (=> (= i_1 (+ i_0 1)) (=> ?v_17 (=> (and (=> (=> true (=> ?v_14 (=> (< i_1 N) (=> ?v_14 (=> false ?v_15))))) ?v_23) (=> (=> true (=> (= i_2 i_1) (=> (= m_2 m_1) ?v_32))) ?v_24) (=> (=> true (=> ?v_17 (and ?v_19 ?v_13 ?v_18 ?v_20 (=> (and ?v_19 ?v_13 ?v_18 ?v_20) (=> ?v_17 (=> (=> (=> true (=> (= i_3 i_1) (=> (= m_3 m_1) ?v_21))) ?v_22) ?v_22)))))) ?v_25)) (and ?v_23 ?v_24 ?v_25)))))) ?v_26) (=> (=> true (=> ?v_10 (=> (and ?v_12 ?v_12) (=> (=> (=> true (=> (= m_1 i_0) ?v_27)) ?v_28) ?v_28)))) ?v_29)) (and ?v_29 ?v_30)))))) ?v_31) ?v_31))))) ?v_33) (=> (=> true (=> (= i_2 0) (=> (= m_2 0) ?v_32))) ?v_34)) (and ?v_33 ?v_34))))) ?v_35) ?v_35)))))))))
(check-sat)
(exit)
