(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/delete.spl:35:4:An invariant might not hold before entering a loop in procedure delete
  tests/spl/sl_sorted_set/delete.spl:36:16:Related location: This is the loop invariant that might not hold initially
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom$0 () Bool)
(declare-fun Axiom_1$0 () Bool)
(declare-fun Axiom_2$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun c1_2$0 () SetInt)
(declare-fun c2_2$0 () SetInt)
(declare-fun content$0 () SetInt)
(declare-fun curr_2$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev_2$0 () Loc)
(declare-fun sk_?X$0 () SetLoc)
(declare-fun sk_?X_1$0 () SetLoc)
(declare-fun sk_?X_2$0 () SetLoc)
(declare-fun sk_?X_3$0 () SetLoc)
(declare-fun sk_?X_4$0 () SetLoc)
(declare-fun sk_?X_5$0 () SetLoc)
(declare-fun sk_?X_6$0 () SetLoc)
(declare-fun sk_?X_7$0 () SetLoc)
(declare-fun sk_?X_8$0 () SetLoc)
(declare-fun sk_?e$0 () Int)
(declare-fun sk_?e_1$0 () Int)
(declare-fun sk_FP$0 () SetLoc)
(declare-fun sk_FP_1$0 () SetLoc)
(declare-fun sk_l1$0 () Loc)
(declare-fun sk_l1_1$0 () Loc)
(declare-fun sk_l2$0 () Loc)
(declare-fun sk_l2_1$0 () Loc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t$0 () Int)
(declare-fun t_1$0 () Int)
(declare-fun t_2$0 () Int)
(declare-fun t_3$0 () Int)
(declare-fun t_4$0 () Int)
(declare-fun t_5$0 () Int)
(declare-fun t_6$0 () Int)
(declare-fun t_7$0 () Int)
(declare-fun t_8$0 () Int)
(declare-fun t_9$0 () Int)
(declare-fun t_10$0 () Int)
(declare-fun t_11$0 () Int)
(declare-fun t_12$0 () Int)
(declare-fun t_13$0 () Int)
(declare-fun t_14$0 () Int)
(declare-fun t_15$0 () Int)
(declare-fun t_16$0 () Int)
(declare-fun t_17$0 () Int)
(declare-fun t_18$0 () Int)
(declare-fun t_19$0 () Int)
(declare-fun t_20$0 () Int)
(declare-fun t_21$0 () Int)
(declare-fun t_22$0 () Int)
(declare-fun t_23$0 () Int)
(declare-fun t_24$0 () Int)
(declare-fun t_25$0 () Int)
(declare-fun t_26$0 () Int)
(declare-fun t_27$0 () Loc)
(declare-fun t_28$0 () Loc)
(declare-fun t_29$0 () Loc)
(declare-fun t_30$0 () Loc)
(declare-fun t_31$0 () Loc)
(declare-fun t_32$0 () Loc)
(declare-fun t_33$0 () Loc)
(declare-fun t_34$0 () Loc)
(declare-fun t_35$0 () Loc)
(declare-fun t_36$0 () Loc)
(declare-fun t_37$0 () Loc)
(declare-fun t_38$0 () Loc)
(declare-fun t_39$0 () Loc)
(declare-fun t_40$0 () Loc)
(declare-fun t_41$0 () Loc)
(declare-fun t_42$0 () Loc)
(declare-fun t_43$0 () Loc)
(declare-fun t_44$0 () Loc)
(declare-fun t_45$0 () Loc)
(declare-fun t_46$0 () Loc)
(declare-fun t_47$0 () Loc)
(declare-fun t_48$0 () Loc)
(declare-fun t_49$0 () Loc)
(declare-fun t_50$0 () Loc)
(declare-fun t_51$0 () Loc)
(declare-fun t_52$0 () Loc)
(declare-fun t_53$0 () Loc)
(declare-fun val$0 () Int)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_53$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_52$0))

(assert (= (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_51$0))

(assert (= (witness$0 data$0 sk_?e_1$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_50$0))

(assert (= (witness$0 data$0 sk_?e_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_49$0))

(assert (=
  (witness$0 data$0 sk_?e_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_48$0))

(assert (= (witness$0 data$0 sk_?e$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_47$0))

(assert (= (witness$0 data$0 sk_?e$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_46$0))

(assert (= (witness$0 data$0 sk_?e$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_45$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_1$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_44$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_1$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_43$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_1$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_42$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_41$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_40$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_39$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_1$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_38$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_1$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_37$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_1$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_36$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_35$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_34$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_33$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_32$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_31$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_30$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
  t_29$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 lst$0 null$0))
  t_28$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_2$0)
    (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
  t_27$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_26$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_25$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_24$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_1$0
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_23$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_1$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_22$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_1$0
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_21$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_20$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_19$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_18$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_1$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_17$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_1$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_16$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_1$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_15$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_14$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_13$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_12$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_1$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_11$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_1$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_10$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_1$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_9$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_8$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_7$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_6$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_5$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_4$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t_3$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
  t_2$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
  t_1$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_2$0)
      (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
  t$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (and (Btwn$0 next$0 curr_2$0 null$0 null$0) Axiom$0)
    (not
         (sorted_set_struct$0 sk_?X_6$0 data$0 next$0 curr_2$0 null$0 c1_2$0))))

(assert (or (not Axiom_1$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X$0))
                (not (in$1 l2 sk_?X$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 curr_2$0 curr_2$0) Axiom_2$0)
    (not (sorted_set_struct$0 sk_?X_8$0 data$0 next$0 lst$0 curr_2$0 c2_2$0))))

(assert (= c1_2$0 content$0))

(assert (= curr_2$0 lst$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X$0 FP$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (= sk_?X_1$0 sk_?X_3$0))

(assert (= sk_?X_3$0 sk_?X_5$0))

(assert (= sk_?X_5$0 sk_?X_6$0))

(assert (= sk_?X_7$0 sk_?X_8$0))

(assert (= sk_FP$0 sk_?X_2$0))

(assert (or (= prev_2$0 curr_2$0) (in$1 sk_l1$0 (intersection$1 sk_?X_7$0 sk_?X_5$0))
    (and (in$0 sk_?e$0 (union$0 c1_2$0 c2_2$0))
         (not (in$0 sk_?e$0 content$0)))
    (and (in$0 sk_?e$0 c1_2$0)
         (not (in$0 sk_?e$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))
    (and (in$0 sk_?e$0 c2_2$0)
         (not (in$0 sk_?e$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))
    (and (in$0 sk_?e$0 content$0)
         (not (in$0 sk_?e$0 (union$0 c1_2$0 c2_2$0))))
    (and (in$0 sk_?e$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (not (in$0 sk_?e$0 c1_2$0)))
    (and (in$0 sk_?e$0 (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
         (not (in$0 sk_?e$0 c2_2$0)))
    (and (in$1 sk_l1$0 sk_FP$0) (not (in$1 sk_l1$0 FP$0)))
    (and (not (= curr_2$0 null$0)) (not (= prev_2$0 null$0))
         (not (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0))))
    (not (= (read$0 next$0 prev_2$0) curr_2$0))
    (not (> val$0 (read$1 data$0 prev_2$0)))
    (not (Btwn$0 next$0 curr_2$0 null$0 null$0))
    (not (Btwn$0 next$0 lst$0 curr_2$0 curr_2$0))
    (not (Btwn$0 next$0 lst$0 prev_2$0 curr_2$0))
    (and (Btwn$0 next$0 sk_l1$0 sk_l2$0 null$0) (in$1 sk_l1$0 sk_?X_6$0)
         (in$1 sk_l2$0 sk_?X_6$0) (not (= sk_l1$0 sk_l2$0))
         (not (< (read$1 data$0 sk_l1$0) (read$1 data$0 sk_l2$0))))
    (and (Btwn$0 next$0 sk_l1$0 sk_l2$0 curr_2$0) (in$1 sk_l1$0 sk_?X_8$0)
         (in$1 sk_l2$0 sk_?X_8$0) (not (= sk_l1$0 sk_l2$0))
         (not (< (read$1 data$0 sk_l1$0) (read$1 data$0 sk_l2$0))))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (not Axiom$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_6$0))
                (not (in$1 l2 sk_?X_6$0))))))

(assert (or (and (Btwn$0 next$0 lst$0 null$0 null$0) Axiom_1$0)
    (not (sorted_set_struct$0 sk_?X$0 data$0 next$0 lst$0 null$0 content$0))))

(assert (or (not Axiom_2$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_2$0))
                (not (in$1 l1 sk_?X_8$0)) (not (in$1 l2 sk_?X_8$0))))))

(assert (= FP_Caller_1$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c2_2$0 emptyset$0))

(assert (= prev_2$0 null$0))

(assert (= content$0 (sorted_set_c$0 data$0 next$0 lst$0 null$0)))

(assert (= sk_?X$0 (sorted_set_domain$0 data$0 next$0 lst$0 null$0)))

(assert (sorted_set_struct$0 sk_?X$0 data$0 next$0 lst$0 null$0 content$0))

(assert (= sk_?X_2$0 sk_?X_4$0))

(assert (= sk_?X_4$0 (union$1 sk_?X_7$0 sk_?X_5$0)))

(assert (= sk_?X_6$0 (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))

(assert (= sk_?X_8$0 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))

(assert (= sk_FP_1$0 sk_?X_1$0))

(assert (or (in$0 sk_?e_1$0 c2_2$0)
    (and (in$0 sk_?e_1$0 (union$0 c1_2$0 c2_2$0))
         (not (in$0 sk_?e_1$0 content$0)))
    (and (in$0 sk_?e_1$0 c1_2$0)
         (not
              (in$0 sk_?e_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))))
    (and (in$0 sk_?e_1$0 content$0)
         (not (in$0 sk_?e_1$0 (union$0 c1_2$0 c2_2$0))))
    (and (in$0 sk_?e_1$0 (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
         (not (in$0 sk_?e_1$0 c1_2$0)))
    (and (in$1 sk_l2_1$0 sk_FP_1$0) (not (in$1 sk_l2_1$0 FP$0)))
    (and (not (= curr_2$0 null$0)) (not (= prev_2$0 null$0))
         (not (< (read$1 data$0 prev_2$0) (read$1 data$0 curr_2$0))))
    (not (= curr_2$0 lst$0)) (not (= prev_2$0 null$0))
    (not (Btwn$0 next$0 curr_2$0 null$0 null$0))
    (and (Btwn$0 next$0 sk_l1_1$0 sk_l2_1$0 null$0)
         (in$1 sk_l1_1$0 sk_?X_6$0) (in$1 sk_l2_1$0 sk_?X_6$0)
         (not (= sk_l1_1$0 sk_l2_1$0))
         (not (< (read$1 data$0 sk_l1_1$0) (read$1 data$0 sk_l2_1$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))
            (not
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_2$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst$0 l1 curr_2$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0))
                 (not (= l1 curr_2$0)))
            (and (or (= l1 curr_2$0) (not (Btwn$0 next$0 lst$0 l1 curr_2$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst$0 curr_2$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 curr_2$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst$0 null$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
