(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/delete.spl:42:8-35:Possible heap access through null or dangling reference
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_36$0 () Bool)
(declare-fun Axiom_37$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_2$0 () SetLoc)
(declare-fun c1_4$0 () SetInt)
(declare-fun c1_init$0 () SetInt)
(declare-fun c2_4$0 () SetInt)
(declare-fun c2_init$0 () SetInt)
(declare-fun content_2$0 () SetInt)
(declare-fun content_init$0 () SetInt)
(declare-fun curr_5$0 () Loc)
(declare-fun curr_init$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst_2$0 () Loc)
(declare-fun lst_init$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev_4$0 () Loc)
(declare-fun prev_init$0 () Loc)
(declare-fun sk_?X_132$0 () SetLoc)
(declare-fun sk_?X_133$0 () SetLoc)
(declare-fun sk_?X_134$0 () SetLoc)
(declare-fun sk_?X_135$0 () SetLoc)
(declare-fun sk_?X_136$0 () SetLoc)
(declare-fun sk_?X_137$0 () SetLoc)
(declare-fun sk_?X_138$0 () SetLoc)
(declare-fun sk_?X_139$0 () SetLoc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_854$0 () Int)
(declare-fun t_855$0 () Int)
(declare-fun t_856$0 () Int)
(declare-fun t_857$0 () Int)
(declare-fun t_858$0 () Int)
(declare-fun t_859$0 () Int)
(declare-fun t_860$0 () Int)
(declare-fun t_861$0 () Int)
(declare-fun t_862$0 () Int)
(declare-fun t_863$0 () Int)
(declare-fun t_864$0 () Loc)
(declare-fun t_865$0 () Loc)
(declare-fun t_866$0 () Loc)
(declare-fun t_867$0 () Loc)
(declare-fun t_868$0 () Loc)
(declare-fun t_869$0 () Loc)
(declare-fun t_870$0 () Loc)
(declare-fun t_871$0 () Loc)
(declare-fun t_872$0 () Loc)
(declare-fun t_873$0 () Loc)
(declare-fun val_2$0 () Int)
(declare-fun val_init$0 () Int)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_873$0))

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_872$0))

(assert (=
  (witness$0 data$0 val_2$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_871$0))

(assert (=
  (witness$0 data$0 val_2$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_870$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_869$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_868$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_867$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_866$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_865$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_864$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_863$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_862$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_861$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_860$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_859$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_858$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_857$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_856$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_855$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_854$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (and (Btwn$0 next$0 curr_init$0 null$0 null$0) Axiom_36$0)
    (not
         (sorted_set_struct$0 sk_?X_137$0 data$0 next$0 curr_init$0 null$0
           c1_init$0))))

(assert (or (not Axiom_37$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_init$0))
                (not (in$1 l1 sk_?X_139$0)) (not (in$1 l2 sk_?X_139$0))))))

(assert (= FP_Caller_2$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c2_4$0 c2_init$0))

(assert (= curr_5$0 curr_init$0))

(assert (= prev_4$0 prev_init$0))

(assert (< (read$1 data$0 curr_5$0) val_2$0))

(assert (= sk_?X_132$0 sk_?X_134$0))

(assert (= sk_?X_134$0 sk_?X_136$0))

(assert (= sk_?X_136$0 sk_?X_137$0))

(assert (= sk_?X_138$0 sk_?X_139$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (not (= curr_5$0 null$0)))

(assert (not (in$1 curr_5$0 FP$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 curr_init$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))
                 (not (= l1 curr_init$0)))
            (and
                 (or (= l1 curr_init$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 curr_init$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_init$0
                          curr_init$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
              (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (not Axiom_36$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_137$0)) (not (in$1 l2 sk_?X_137$0))))))

(assert (or (and (Btwn$0 next$0 lst_init$0 curr_init$0 curr_init$0) Axiom_37$0)
    (not
         (sorted_set_struct$0 sk_?X_139$0 data$0 next$0 lst_init$0
           curr_init$0 c2_init$0))))

(assert (= c1_4$0 c1_init$0))

(assert (= content_2$0 content_init$0))

(assert (= lst_2$0 lst_init$0))

(assert (= val_2$0 val_init$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_133$0 sk_?X_135$0))

(assert (= sk_?X_135$0 (union$1 sk_?X_138$0 sk_?X_136$0)))

(assert (= sk_?X_137$0 (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0)))

(assert (= sk_?X_139$0 (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0)))

(assert (or
    (and (= (read$0 next$0 prev_init$0) curr_init$0)
         (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_138$0 sk_?X_136$0))
         (= c1_init$0 (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
         (= c2_init$0 (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
         (= content_init$0 (union$0 c1_init$0 c2_init$0))
         (= sk_?X_133$0 FP$0) (> val_init$0 (read$1 data$0 prev_init$0))
         (Btwn$0 next$0 lst_init$0 prev_init$0 curr_init$0)
         (sorted_set_struct$0 sk_?X_137$0 data$0 next$0 curr_init$0 null$0
           c1_init$0)
         (sorted_set_struct$0 sk_?X_139$0 data$0 next$0 lst_init$0
           curr_init$0 c2_init$0)
         (or (= curr_init$0 null$0) (= prev_init$0 null$0)
             (< (read$1 data$0 prev_init$0) (read$1 data$0 curr_init$0)))
         (not (= prev_init$0 curr_init$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_init$0 (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
         (= c2_init$0 emptyset$0)
         (= content_init$0 (union$0 c1_init$0 c2_init$0))
         (= curr_init$0 lst_init$0) (= prev_init$0 null$0)
         (= sk_?X_132$0 FP$0)
         (sorted_set_struct$0 sk_?X_137$0 data$0 next$0 curr_init$0 null$0
           c1_init$0)
         (or (= curr_init$0 null$0) (= prev_init$0 null$0)
             (< (read$1 data$0 prev_init$0) (read$1 data$0 curr_init$0))))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_init$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 curr_init$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_init$0
                          null$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
