(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/delete.spl:46:5-6:An invariant might not be maintained by a loop in procedure delete
  tests/spl/sl_sorted_set/delete.spl:36:16:Related location: This is the loop invariant that might not be maintained
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_42$0 () Bool)
(declare-fun Axiom_43$0 () Bool)
(declare-fun Axiom_44$0 () Bool)
(declare-fun Axiom_45$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_2$0 () SetLoc)
(declare-fun c1_4$0 () SetInt)
(declare-fun c1_5$0 () SetInt)
(declare-fun c1_init$0 () SetInt)
(declare-fun c2_4$0 () SetInt)
(declare-fun c2_5$0 () SetInt)
(declare-fun c2_init$0 () SetInt)
(declare-fun content_2$0 () SetInt)
(declare-fun content_init$0 () SetInt)
(declare-fun curr_5$0 () Loc)
(declare-fun curr_6$0 () Loc)
(declare-fun curr_init$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun lst_2$0 () Loc)
(declare-fun lst_init$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun prev_4$0 () Loc)
(declare-fun prev_5$0 () Loc)
(declare-fun prev_init$0 () Loc)
(declare-fun sk_?X_156$0 () SetLoc)
(declare-fun sk_?X_157$0 () SetLoc)
(declare-fun sk_?X_158$0 () SetLoc)
(declare-fun sk_?X_159$0 () SetLoc)
(declare-fun sk_?X_160$0 () SetLoc)
(declare-fun sk_?X_161$0 () SetLoc)
(declare-fun sk_?X_162$0 () SetLoc)
(declare-fun sk_?X_163$0 () SetLoc)
(declare-fun sk_?X_164$0 () SetLoc)
(declare-fun sk_?X_165$0 () SetLoc)
(declare-fun sk_?X_166$0 () SetLoc)
(declare-fun sk_?X_167$0 () SetLoc)
(declare-fun sk_?X_168$0 () SetLoc)
(declare-fun sk_?X_169$0 () SetLoc)
(declare-fun sk_?X_170$0 () SetLoc)
(declare-fun sk_?X_171$0 () SetLoc)
(declare-fun sk_?e_5$0 () Int)
(declare-fun sk_?e_6$0 () Int)
(declare-fun sk_FP_2$0 () SetLoc)
(declare-fun sk_FP_3$0 () SetLoc)
(declare-fun sk_l1_5$0 () Loc)
(declare-fun sk_l1_6$0 () Loc)
(declare-fun sk_l2_5$0 () Loc)
(declare-fun sk_l2_6$0 () Loc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_914$0 () Int)
(declare-fun t_915$0 () Int)
(declare-fun t_916$0 () Int)
(declare-fun t_917$0 () Int)
(declare-fun t_918$0 () Int)
(declare-fun t_919$0 () Int)
(declare-fun t_920$0 () Int)
(declare-fun t_921$0 () Int)
(declare-fun t_922$0 () Int)
(declare-fun t_923$0 () Int)
(declare-fun t_924$0 () Int)
(declare-fun t_925$0 () Int)
(declare-fun t_926$0 () Int)
(declare-fun t_927$0 () Int)
(declare-fun t_928$0 () Int)
(declare-fun t_929$0 () Int)
(declare-fun t_930$0 () Int)
(declare-fun t_931$0 () Int)
(declare-fun t_932$0 () Int)
(declare-fun t_933$0 () Int)
(declare-fun t_934$0 () Int)
(declare-fun t_935$0 () Int)
(declare-fun t_936$0 () Int)
(declare-fun t_937$0 () Int)
(declare-fun t_938$0 () Int)
(declare-fun t_939$0 () Int)
(declare-fun t_940$0 () Int)
(declare-fun t_941$0 () Int)
(declare-fun t_942$0 () Int)
(declare-fun t_943$0 () Int)
(declare-fun t_944$0 () Int)
(declare-fun t_945$0 () Int)
(declare-fun t_946$0 () Int)
(declare-fun t_947$0 () Int)
(declare-fun t_948$0 () Int)
(declare-fun t_949$0 () Int)
(declare-fun t_950$0 () Int)
(declare-fun t_951$0 () Int)
(declare-fun t_952$0 () Int)
(declare-fun t_953$0 () Int)
(declare-fun t_954$0 () Int)
(declare-fun t_955$0 () Int)
(declare-fun t_956$0 () Int)
(declare-fun t_957$0 () Int)
(declare-fun t_958$0 () Int)
(declare-fun t_959$0 () Int)
(declare-fun t_960$0 () Int)
(declare-fun t_961$0 () Int)
(declare-fun t_962$0 () Int)
(declare-fun t_963$0 () Int)
(declare-fun t_964$0 () Int)
(declare-fun t_965$0 () Int)
(declare-fun t_966$0 () Loc)
(declare-fun t_967$0 () Loc)
(declare-fun t_968$0 () Loc)
(declare-fun t_969$0 () Loc)
(declare-fun t_970$0 () Loc)
(declare-fun t_971$0 () Loc)
(declare-fun t_972$0 () Loc)
(declare-fun t_973$0 () Loc)
(declare-fun t_974$0 () Loc)
(declare-fun t_975$0 () Loc)
(declare-fun t_976$0 () Loc)
(declare-fun t_977$0 () Loc)
(declare-fun t_978$0 () Loc)
(declare-fun t_979$0 () Loc)
(declare-fun t_980$0 () Loc)
(declare-fun t_981$0 () Loc)
(declare-fun t_982$0 () Loc)
(declare-fun t_983$0 () Loc)
(declare-fun t_984$0 () Loc)
(declare-fun t_985$0 () Loc)
(declare-fun t_986$0 () Loc)
(declare-fun t_987$0 () Loc)
(declare-fun t_988$0 () Loc)
(declare-fun t_989$0 () Loc)
(declare-fun t_990$0 () Loc)
(declare-fun t_991$0 () Loc)
(declare-fun t_992$0 () Loc)
(declare-fun t_993$0 () Loc)
(declare-fun t_994$0 () Loc)
(declare-fun t_995$0 () Loc)
(declare-fun t_996$0 () Loc)
(declare-fun t_997$0 () Loc)
(declare-fun t_998$0 () Loc)
(declare-fun t_999$0 () Loc)
(declare-fun t_1000$0 () Loc)
(declare-fun t_1001$0 () Loc)
(declare-fun t_1002$0 () Loc)
(declare-fun t_1003$0 () Loc)
(declare-fun t_1004$0 () Loc)
(declare-fun t_1005$0 () Loc)
(declare-fun t_1006$0 () Loc)
(declare-fun t_1007$0 () Loc)
(declare-fun t_1008$0 () Loc)
(declare-fun t_1009$0 () Loc)
(declare-fun t_1010$0 () Loc)
(declare-fun t_1011$0 () Loc)
(declare-fun t_1012$0 () Loc)
(declare-fun t_1013$0 () Loc)
(declare-fun t_1014$0 () Loc)
(declare-fun t_1015$0 () Loc)
(declare-fun t_1016$0 () Loc)
(declare-fun t_1017$0 () Loc)
(declare-fun val_2$0 () Int)
(declare-fun val_init$0 () Int)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1017$0))

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_1016$0))

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1015$0))

(assert (=
  (witness$0 data$0 val_init$0
    (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_1014$0))

(assert (=
  (witness$0 data$0 val_2$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1013$0))

(assert (= (witness$0 data$0 val_2$0 (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_1012$0))

(assert (=
  (witness$0 data$0 val_2$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1011$0))

(assert (= (witness$0 data$0 val_2$0 (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_1010$0))

(assert (=
  (witness$0 data$0 sk_?e_6$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1009$0))

(assert (=
  (witness$0 data$0 sk_?e_6$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_1008$0))

(assert (=
  (witness$0 data$0 sk_?e_6$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1007$0))

(assert (=
  (witness$0 data$0 sk_?e_6$0 (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_1006$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1005$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_1004$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_1003$0))

(assert (=
  (witness$0 data$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_1002$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_1001$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_1000$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_999$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
    (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_998$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_997$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_996$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_995$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
    (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_994$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_993$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_992$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_991$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
    (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_990$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_989$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_988$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_987$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
    (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_986$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_985$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_984$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_983$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_init$0)
    (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_982$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_981$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_980$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_979$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 prev_5$0)
    (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_978$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_977$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_976$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_975$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_init$0)
    (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_974$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_6$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_973$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_6$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_972$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_6$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_971$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_6$0)
    (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_970$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
  t_969$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
  t_968$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
  t_967$0))

(assert (=
  (witness$0 data$0 (read$1 data$0 curr_5$0)
    (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
  t_966$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_965$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_964$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_963$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_init$0
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_962$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_961$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_960$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_959$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 val_2$0 (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_958$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_6$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_957$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_6$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_956$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_6$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_955$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_6$0
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_954$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_953$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_952$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_951$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 sk_?e_5$0
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_950$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_949$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_948$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_947$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_6$0)
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_946$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_945$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_944$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_943$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l2_5$0)
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_942$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_941$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_940$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_939$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_6$0)
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_938$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_937$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_936$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_935$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 sk_l1_5$0)
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_934$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_933$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_932$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_931$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_init$0)
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_930$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_929$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_928$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_927$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 prev_5$0)
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_926$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_925$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_924$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_923$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_init$0)
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_922$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_6$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_921$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_6$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_920$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_6$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_919$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_6$0)
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_918$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
  t_917$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
  t_916$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
  t_915$0))

(assert (=
  (read$1 data$0
    (witness$0 data$0 (read$1 data$0 curr_5$0)
      (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
  t_914$0))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (not Axiom_42$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_169$0)) (not (in$1 l2 sk_?X_169$0))))))

(assert (or (and (Btwn$0 next$0 curr_init$0 null$0 null$0) Axiom_43$0)
    (not
         (sorted_set_struct$0 sk_?X_161$0 data$0 next$0 curr_init$0 null$0
           c1_init$0))))

(assert (or (not Axiom_44$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_6$0))
                (not (in$1 l1 sk_?X_171$0)) (not (in$1 l2 sk_?X_171$0))))))

(assert (or (and (Btwn$0 next$0 lst_init$0 curr_init$0 curr_init$0) Axiom_45$0)
    (not
         (sorted_set_struct$0 sk_?X_163$0 data$0 next$0 lst_init$0
           curr_init$0 c2_init$0))))

(assert (= c1_4$0 c1_init$0))

(assert (= c2_4$0 c2_init$0))

(assert (= content_2$0 content_init$0))

(assert (= curr_6$0 (read$0 next$0 curr_5$0)))

(assert (= prev_4$0 prev_init$0))

(assert (= val_2$0 val_init$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= sk_?X_157$0 sk_?X_159$0))

(assert (= sk_?X_159$0 (union$1 sk_?X_162$0 sk_?X_160$0)))

(assert (= sk_?X_161$0 (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0)))

(assert (= sk_?X_163$0 (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0)))

(assert (or
    (and (= (read$0 next$0 prev_init$0) curr_init$0)
         (= emptyset$1 emptyset$1)
         (= emptyset$1 (intersection$1 sk_?X_162$0 sk_?X_160$0))
         (= c1_init$0 (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
         (= c2_init$0 (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
         (= content_init$0 (union$0 c1_init$0 c2_init$0))
         (= sk_?X_157$0 FP$0) (> val_init$0 (read$1 data$0 prev_init$0))
         (Btwn$0 next$0 lst_init$0 prev_init$0 curr_init$0)
         (sorted_set_struct$0 sk_?X_161$0 data$0 next$0 curr_init$0 null$0
           c1_init$0)
         (sorted_set_struct$0 sk_?X_163$0 data$0 next$0 lst_init$0
           curr_init$0 c2_init$0)
         (or (= curr_init$0 null$0) (= prev_init$0 null$0)
             (< (read$1 data$0 prev_init$0) (read$1 data$0 curr_init$0)))
         (not (= prev_init$0 curr_init$0)))
    (and (= emptyset$1 emptyset$1)
         (= c1_init$0 (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
         (= c2_init$0 emptyset$0)
         (= content_init$0 (union$0 c1_init$0 c2_init$0))
         (= curr_init$0 lst_init$0) (= prev_init$0 null$0)
         (= sk_?X_156$0 FP$0)
         (sorted_set_struct$0 sk_?X_161$0 data$0 next$0 curr_init$0 null$0
           c1_init$0)
         (or (= curr_init$0 null$0) (= prev_init$0 null$0)
             (< (read$1 data$0 prev_init$0) (read$1 data$0 curr_init$0))))))

(assert (= sk_?X_165$0 sk_?X_167$0))

(assert (= sk_?X_167$0 (union$1 sk_?X_170$0 sk_?X_168$0)))

(assert (= sk_?X_169$0 (sorted_set_domain$0 data$0 next$0 curr_6$0 null$0)))

(assert (= sk_?X_171$0 (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_6$0)))

(assert (= sk_FP_3$0 sk_?X_164$0))

(assert (or (in$0 sk_?e_6$0 c2_5$0)
    (and (in$0 sk_?e_6$0 (union$0 c1_5$0 c2_5$0))
         (not (in$0 sk_?e_6$0 content_2$0)))
    (and (in$0 sk_?e_6$0 c1_5$0)
         (not
              (in$0 sk_?e_6$0 (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))))
    (and (in$0 sk_?e_6$0 content_2$0)
         (not (in$0 sk_?e_6$0 (union$0 c1_5$0 c2_5$0))))
    (and (in$0 sk_?e_6$0 (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
         (not (in$0 sk_?e_6$0 c1_5$0)))
    (and (in$1 sk_l2_6$0 sk_FP_3$0) (not (in$1 sk_l2_6$0 FP$0)))
    (and (not (= curr_6$0 null$0)) (not (= prev_5$0 null$0))
         (not (< (read$1 data$0 prev_5$0) (read$1 data$0 curr_6$0))))
    (not (= curr_6$0 lst_2$0)) (not (= prev_5$0 null$0))
    (not (Btwn$0 next$0 curr_6$0 null$0 null$0))
    (and (Btwn$0 next$0 sk_l1_6$0 sk_l2_6$0 null$0)
         (in$1 sk_l1_6$0 sk_?X_169$0) (in$1 sk_l2_6$0 sk_?X_169$0)
         (not (= sk_l1_6$0 sk_l2_6$0))
         (not (< (read$1 data$0 sk_l1_6$0) (read$1 data$0 sk_l2_6$0))))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_init$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 curr_init$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_init$0
                          null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_init$0 l1 curr_init$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))
                 (not (= l1 curr_init$0)))
            (and
                 (or (= l1 curr_init$0)
                     (not (Btwn$0 next$0 lst_init$0 l1 curr_init$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_init$0
                          curr_init$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_init$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_init$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))
              (sorted_set_domain$0 data$0 next$0 lst_init$0 curr_init$0))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 lst_init$0 curr_init$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (and (Btwn$0 next$0 curr_6$0 null$0 null$0) Axiom_42$0)
    (not
         (sorted_set_struct$0 sk_?X_169$0 data$0 next$0 curr_6$0 null$0
           c1_5$0))))

(assert (or (not Axiom_43$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_161$0)) (not (in$1 l2 sk_?X_161$0))))))

(assert (or (and (Btwn$0 next$0 lst_2$0 curr_6$0 curr_6$0) Axiom_44$0)
    (not
         (sorted_set_struct$0 sk_?X_171$0 data$0 next$0 lst_2$0 curr_6$0
           c2_5$0))))

(assert (or (not Axiom_45$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$1 data$0 l1) (read$1 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 curr_init$0))
                (not (in$1 l1 sk_?X_163$0)) (not (in$1 l2 sk_?X_163$0))))))

(assert (= FP_Caller_2$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= c1_5$0 (setminus$0 c1_4$0 (setenum$0 (read$1 data$0 curr_5$0)))))

(assert (= c2_5$0 (union$0 c2_4$0 (setenum$0 (read$1 data$0 curr_5$0)))))

(assert (= curr_5$0 curr_init$0))

(assert (= lst_2$0 lst_init$0))

(assert (= prev_5$0 curr_5$0))

(assert (< (read$1 data$0 curr_5$0) val_2$0))

(assert (= sk_?X_156$0 sk_?X_158$0))

(assert (= sk_?X_158$0 sk_?X_160$0))

(assert (= sk_?X_160$0 sk_?X_161$0))

(assert (= sk_?X_162$0 sk_?X_163$0))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (= sk_?X_164$0 sk_?X_166$0))

(assert (= sk_?X_166$0 sk_?X_168$0))

(assert (= sk_?X_168$0 sk_?X_169$0))

(assert (= sk_?X_170$0 sk_?X_171$0))

(assert (= sk_FP_2$0 sk_?X_165$0))

(assert (or (= prev_5$0 curr_6$0)
    (in$1 sk_l1_5$0 (intersection$1 sk_?X_170$0 sk_?X_168$0))
    (and (in$0 sk_?e_5$0 (union$0 c1_5$0 c2_5$0))
         (not (in$0 sk_?e_5$0 content_2$0)))
    (and (in$0 sk_?e_5$0 c1_5$0)
         (not
              (in$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))))
    (and (in$0 sk_?e_5$0 c2_5$0)
         (not
              (in$0 sk_?e_5$0
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))))
    (and (in$0 sk_?e_5$0 content_2$0)
         (not (in$0 sk_?e_5$0 (union$0 c1_5$0 c2_5$0))))
    (and (in$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
         (not (in$0 sk_?e_5$0 c1_5$0)))
    (and (in$0 sk_?e_5$0 (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
         (not (in$0 sk_?e_5$0 c2_5$0)))
    (and (in$1 sk_l1_5$0 sk_FP_2$0) (not (in$1 sk_l1_5$0 FP$0)))
    (and (not (= curr_6$0 null$0)) (not (= prev_5$0 null$0))
         (not (< (read$1 data$0 prev_5$0) (read$1 data$0 curr_6$0))))
    (not (= (read$0 next$0 prev_5$0) curr_6$0))
    (not (> val_2$0 (read$1 data$0 prev_5$0)))
    (not (Btwn$0 next$0 curr_6$0 null$0 null$0))
    (not (Btwn$0 next$0 lst_2$0 curr_6$0 curr_6$0))
    (not (Btwn$0 next$0 lst_2$0 prev_5$0 curr_6$0))
    (and (Btwn$0 next$0 sk_l1_5$0 sk_l2_5$0 null$0)
         (in$1 sk_l1_5$0 sk_?X_169$0) (in$1 sk_l2_5$0 sk_?X_169$0)
         (not (= sk_l1_5$0 sk_l2_5$0))
         (not (< (read$1 data$0 sk_l1_5$0) (read$1 data$0 sk_l2_5$0))))
    (and (Btwn$0 next$0 sk_l1_5$0 sk_l2_5$0 curr_6$0)
         (in$1 sk_l1_5$0 sk_?X_171$0) (in$1 sk_l2_5$0 sk_?X_171$0)
         (not (= sk_l1_5$0 sk_l2_5$0))
         (not (< (read$1 data$0 sk_l1_5$0) (read$1 data$0 sk_l2_5$0))))))

(assert (not (= curr_5$0 null$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_6$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$1 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_6$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_6$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$1 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_6$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_6$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 curr_6$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 curr_6$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 curr_6$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst_2$0 l1 curr_6$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_6$0))
                 (not (= l1 curr_6$0)))
            (and
                 (or (= l1 curr_6$0)
                     (not (Btwn$0 next$0 lst_2$0 l1 curr_6$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_6$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$1 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 curr_6$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))
              (sorted_set_domain$0 data$0 next$0 curr_6$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 curr_6$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))
              (sorted_set_domain$0 data$0 next$0 lst_2$0 curr_6$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst_2$0 curr_6$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
