(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sl_sorted_set/difference.spl:43:8-40:A postcondition of procedure difference might not hold at this return point
  tests/spl/sl_sorted_set/difference.spl:28:10-90:Related location: This is the postcondition that might not hold
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldInt Loc) Int)
(declare-fun read$1 (FldLoc Loc) Loc)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetInt)
(declare-fun emptyset$1 () SetLoc)
(declare-fun setenum$0 (Int) SetInt)
(declare-fun setenum$1 (Loc) SetLoc)
(declare-fun union$0 (SetInt SetInt) SetInt)
(declare-fun union$1 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetInt SetInt) SetInt)
(declare-fun intersection$1 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetInt SetInt) SetInt)
(declare-fun setminus$1 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun Frame$0 (SetLoc SetLoc FldInt FldInt) Bool)
(declare-fun Frame$1 (SetLoc SetLoc FldLoc FldLoc) Bool)
(declare-fun in$0 (Int SetInt) Bool)
(declare-fun in$1 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Alloc_1$0 () SetLoc)
(declare-fun Alloc_2$0 () SetLoc)
(declare-fun Axiom_61$0 () Bool)
(declare-fun Axiom_62$0 () Bool)
(declare-fun Axiom_63$0 () Bool)
(declare-fun Axiom_64$0 () Bool)
(declare-fun Axiom_65$0 () Bool)
(declare-fun Axiom_66$0 () Bool)
(declare-fun Axiom_67$0 () Bool)
(declare-fun Axiom_68$0 () Bool)
(declare-fun Axiom_69$0 () Bool)
(declare-fun Axiom_70$0 () Bool)
(declare-fun Axiom_71$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_1$0 () SetLoc)
(declare-fun FP_2$0 () SetLoc)
(declare-fun FP_3$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_1$0 () SetLoc)
(declare-fun FP_Caller_final_1$0 () SetLoc)
(declare-fun content1$0 () SetInt)
(declare-fun content1_1$0 () SetInt)
(declare-fun content2$0 () SetInt)
(declare-fun content2_1$0 () SetInt)
(declare-fun data$0 () FldInt)
(declare-fun lst1$0 () Loc)
(declare-fun lst2$0 () Loc)
(declare-fun n_2$0 () Loc)
(declare-fun next$0 () FldLoc)
(declare-fun next_1$0 () FldLoc)
(declare-fun res_1$0 () Loc)
(declare-fun res_2$0 () Loc)
(declare-fun sk_?X_78$0 () SetLoc)
(declare-fun sk_?X_79$0 () SetLoc)
(declare-fun sk_?X_80$0 () SetLoc)
(declare-fun sk_?X_81$0 () SetLoc)
(declare-fun sk_?X_82$0 () SetLoc)
(declare-fun sk_?X_83$0 () SetLoc)
(declare-fun sk_?X_84$0 () SetLoc)
(declare-fun sk_?X_85$0 () SetLoc)
(declare-fun sk_?X_86$0 () SetLoc)
(declare-fun sk_?X_87$0 () SetLoc)
(declare-fun sk_?X_88$0 () SetLoc)
(declare-fun sk_?X_89$0 () SetLoc)
(declare-fun sk_?e_4$0 () Int)
(declare-fun sk_l1_7$0 () Loc)
(declare-fun sk_l2_7$0 () Loc)
(declare-fun sorted_set_c$0 (FldInt FldLoc Loc Loc) SetInt)
(declare-fun sorted_set_domain$0 (FldInt FldLoc Loc Loc) SetLoc)
(declare-fun sorted_set_struct$0 (SetLoc FldInt FldLoc Loc Loc SetInt) Bool)
(declare-fun t_421$0 () Int)
(declare-fun t_422$0 () Int)
(declare-fun t_423$0 () Int)
(declare-fun t_424$0 () Int)
(declare-fun t_425$0 () Int)
(declare-fun t_426$0 () Int)
(declare-fun t_427$0 () Int)
(declare-fun t_428$0 () Int)
(declare-fun t_429$0 () Int)
(declare-fun t_430$0 () Int)
(declare-fun t_431$0 () Int)
(declare-fun t_432$0 () Int)
(declare-fun t_433$0 () Int)
(declare-fun t_434$0 () Int)
(declare-fun t_435$0 () Int)
(declare-fun t_436$0 () Int)
(declare-fun t_437$0 () Int)
(declare-fun t_438$0 () Int)
(declare-fun t_439$0 () Int)
(declare-fun t_440$0 () Int)
(declare-fun t_441$0 () Int)
(declare-fun t_442$0 () Int)
(declare-fun t_443$0 () Int)
(declare-fun t_444$0 () Int)
(declare-fun t_445$0 () Int)
(declare-fun t_446$0 () Int)
(declare-fun t_447$0 () Int)
(declare-fun t_448$0 () Int)
(declare-fun t_449$0 () Int)
(declare-fun t_450$0 () Int)
(declare-fun t_451$0 () Int)
(declare-fun t_452$0 () Int)
(declare-fun t_453$0 () Int)
(declare-fun t_454$0 () Int)
(declare-fun t_455$0 () Int)
(declare-fun t_456$0 () Int)
(declare-fun t_457$0 () Int)
(declare-fun t_458$0 () Int)
(declare-fun t_459$0 () Int)
(declare-fun t_460$0 () Int)
(declare-fun t_461$0 () Loc)
(declare-fun t_462$0 () Loc)
(declare-fun t_463$0 () Loc)
(declare-fun t_464$0 () Loc)
(declare-fun t_465$0 () Loc)
(declare-fun t_466$0 () Loc)
(declare-fun t_467$0 () Loc)
(declare-fun t_468$0 () Loc)
(declare-fun t_469$0 () Loc)
(declare-fun t_470$0 () Loc)
(declare-fun t_471$0 () Loc)
(declare-fun t_472$0 () Loc)
(declare-fun t_473$0 () Loc)
(declare-fun t_474$0 () Loc)
(declare-fun t_475$0 () Loc)
(declare-fun t_476$0 () Loc)
(declare-fun t_477$0 () Loc)
(declare-fun t_478$0 () Loc)
(declare-fun t_479$0 () Loc)
(declare-fun t_480$0 () Loc)
(declare-fun t_481$0 () Loc)
(declare-fun t_482$0 () Loc)
(declare-fun t_483$0 () Loc)
(declare-fun t_484$0 () Loc)
(declare-fun t_485$0 () Loc)
(declare-fun t_486$0 () Loc)
(declare-fun t_487$0 () Loc)
(declare-fun t_488$0 () Loc)
(declare-fun t_489$0 () Loc)
(declare-fun t_490$0 () Loc)
(declare-fun t_491$0 () Loc)
(declare-fun t_492$0 () Loc)
(declare-fun t_493$0 () Loc)
(declare-fun t_494$0 () Loc)
(declare-fun t_495$0 () Loc)
(declare-fun t_496$0 () Loc)
(declare-fun t_497$0 () Loc)
(declare-fun t_498$0 () Loc)
(declare-fun t_499$0 () Loc)
(declare-fun t_500$0 () Loc)
(declare-fun t_501$0 () Loc)
(declare-fun t_502$0 () Loc)
(declare-fun t_503$0 () Loc)
(declare-fun t_504$0 () Loc)
(declare-fun t_505$0 () Loc)
(declare-fun t_506$0 () Loc)
(declare-fun t_507$0 () Loc)
(declare-fun t_508$0 () Loc)
(declare-fun t_509$0 () Loc)
(declare-fun t_510$0 () Loc)
(declare-fun t_511$0 () Loc)
(declare-fun t_512$0 () Loc)
(declare-fun t_513$0 () Loc)
(declare-fun t_514$0 () Loc)
(declare-fun t_515$0 () Loc)
(declare-fun t_516$0 () Loc)
(declare-fun t_517$0 () Loc)
(declare-fun t_518$0 () Loc)
(declare-fun t_519$0 () Loc)
(declare-fun t_520$0 () Loc)
(declare-fun t_521$0 () Loc)
(declare-fun t_522$0 () Loc)
(declare-fun t_523$0 () Loc)
(declare-fun t_524$0 () Loc)
(declare-fun t_525$0 () Loc)
(declare-fun t_526$0 () Loc)
(declare-fun t_527$0 () Loc)
(declare-fun t_528$0 () Loc)
(declare-fun t_529$0 () Loc)
(declare-fun t_530$0 () Loc)
(declare-fun t_531$0 () Loc)
(declare-fun t_532$0 () Loc)
(declare-fun t_533$0 () Loc)
(declare-fun t_534$0 () Loc)
(declare-fun t_535$0 () Loc)
(declare-fun t_536$0 () Loc)
(declare-fun t_537$0 () Loc)
(declare-fun t_538$0 () Loc)
(declare-fun t_539$0 () Loc)
(declare-fun t_540$0 () Loc)
(declare-fun t_541$0 () Loc)
(declare-fun t_542$0 () Loc)
(declare-fun t_543$0 () Loc)
(declare-fun t_544$0 () Loc)
(declare-fun t_545$0 () Loc)
(declare-fun t_546$0 () Loc)
(declare-fun t_547$0 () Loc)
(declare-fun t_548$0 () Loc)
(declare-fun t_549$0 () Loc)
(declare-fun t_550$0 () Loc)
(declare-fun t_551$0 () Loc)
(declare-fun witness$0 (FldInt Int SetInt) Loc)

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
  t_551$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
  t_550$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))
  t_549$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0))
  t_548$0))

(assert (= (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
  t_547$0))

(assert (= (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_546$0))

(assert (= (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_545$0))

(assert (=
  (witness$0 data$0 sk_?e_4$0
    (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0))
  t_544$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
  t_543$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
  t_542$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))
  t_541$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0))
  t_540$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
  t_539$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_538$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_537$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
    (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0))
  t_536$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
  t_535$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
  t_534$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))
  t_533$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0))
  t_532$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
  t_531$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_530$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_529$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
    (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0))
  t_528$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst2$0)
    (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
  t_527$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst2$0)
    (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
  t_526$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst2$0)
    (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))
  t_525$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst2$0)
    (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0))
  t_524$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst2$0)
    (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
  t_523$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst2$0)
    (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_522$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst2$0)
    (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_521$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst2$0)
    (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0))
  t_520$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst1$0)
    (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
  t_519$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst1$0)
    (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
  t_518$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst1$0)
    (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))
  t_517$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst1$0)
    (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0))
  t_516$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst1$0)
    (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
  t_515$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst1$0)
    (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
  t_514$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst1$0)
    (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
  t_513$0))

(assert (=
  (witness$0 data$0 (read$0 data$0 lst1$0)
    (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0))
  t_512$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_511$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_510$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
  t_509$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))
  t_508$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_507$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_506$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_505$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
  t_504$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_503$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_502$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
  t_501$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))
  t_500$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_499$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_498$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_497$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
  t_496$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_495$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_494$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
  t_493$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))
  t_492$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_491$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_490$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_489$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
  t_488$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_487$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_486$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
  t_485$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))
  t_484$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_483$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_482$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_481$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
  t_480$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_479$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_478$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
  t_477$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))
  t_476$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_475$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_474$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_473$0))

(assert (=
  (ep$0 next$0 FP_2$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
  t_472$0))

(assert (= (ep$0 next$0 FP_2$0 sk_l2_7$0) t_471$0))

(assert (= (ep$0 next$0 FP_2$0 sk_l1_7$0) t_470$0))

(assert (= (ep$0 next$0 FP_2$0 res_2$0) t_469$0))

(assert (= (ep$0 next$0 FP_2$0 res_1$0) t_468$0))

(assert (= (ep$0 next$0 FP_2$0 n_2$0) t_467$0))

(assert (= (ep$0 next$0 FP_2$0 lst2$0) t_466$0))

(assert (= (ep$0 next$0 FP_2$0 lst1$0) t_465$0))

(assert (= (ep$0 next$0 FP_2$0 (read$1 next$0 lst2$0)) t_464$0))

(assert (= (ep$0 next$0 FP_2$0 null$0) t_463$0))

(assert (= (read$1 next_1$0 lst2$0) t_462$0))

(assert (= (read$1 next_1$0 lst1$0) t_461$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_460$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_459$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
  t_458$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))
  t_457$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_456$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_455$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 sk_?e_4$0 (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_454$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 sk_?e_4$0
      (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
  t_453$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_452$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_451$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
  t_450$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))
  t_449$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_448$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_447$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_446$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l2_7$0)
      (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
  t_445$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_444$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_443$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
  t_442$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))
  t_441$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_440$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_439$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_438$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 sk_l1_7$0)
      (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
  t_437$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_436$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_435$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
  t_434$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))
  t_433$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_432$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_431$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_430$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst2$0)
      (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
  t_429$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
  t_428$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
  t_427$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
  t_426$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))
  t_425$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
  t_424$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
  t_423$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
  t_422$0))

(assert (=
  (read$0 data$0
    (witness$0 data$0 (read$0 data$0 lst1$0)
      (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
  t_421$0))

(assert (forall ((?f FldLoc)) (= (read$1 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$1 x (setenum$1 y)))
            (and (not (= x y)) (not (in$1 x (setenum$1 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x (setminus$1 X Y)) (not (in$1 x Y)))
            (and (or (in$1 x Y) (not (in$1 x X)))
                 (not (in$1 x (setminus$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x X) (in$1 x Y) (in$1 x (intersection$1 X Y)))
            (and (or (not (in$1 x X)) (not (in$1 x Y)))
                 (not (in$1 x (intersection$1 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$1 x (union$1 X Y)) (or (in$1 x X) (in$1 x Y)))
            (and (not (in$1 x X)) (not (in$1 x Y))
                 (not (in$1 x (union$1 X Y)))))))

(assert (forall ((x Loc)) (not (in$1 x emptyset$1))))

(assert (forall ((x Int) (y Int))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetInt) (Y SetInt) (x Int))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Int)) (not (in$0 x emptyset$0))))

(assert (or (and (Btwn$0 next$0 (read$1 next$0 lst2$0) null$0 null$0) Axiom_61$0)
    (not
         (sorted_set_struct$0 sk_?X_82$0 data$0 next$0 (read$1 next$0 lst2$0)
           null$0 content2_1$0))))

(assert (or (not Axiom_62$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_86$0))
                (not (in$1 l2 sk_?X_86$0))))))

(assert (or (and (Btwn$0 next$0 lst2$0 null$0 null$0) Axiom_63$0)
    (not
         (sorted_set_struct$0 sk_?X_85$0 data$0 next$0 lst2$0 null$0
           content2$0))))

(assert (or (not Axiom_64$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_83$0))
                (not (in$1 l2 sk_?X_83$0))))))

(assert (or (and (Btwn$0 next_1$0 (read$1 next$0 lst2$0) null$0 null$0) Axiom_65$0)
    (not
         (sorted_set_struct$0 sk_?X_78$0 data$0 next_1$0
           (read$1 next$0 lst2$0) null$0 content2_1$0))))

(assert (or (not Axiom_66$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next_1$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_87$0)) (not (in$1 l2 sk_?X_87$0))))))

(assert (or (and (Btwn$0 next_1$0 res_1$0 null$0 null$0) Axiom_67$0)
    (not
         (sorted_set_struct$0 sk_?X_79$0 data$0 next_1$0 res_1$0 null$0
           (setminus$0 content1_1$0 content2_1$0)))))

(assert (or (not Axiom_68$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next_1$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_88$0)) (not (in$1 l2 sk_?X_88$0))))))

(assert (= Alloc_1$0 (setminus$1 Alloc$0 (setenum$1 lst1$0))))

(assert (= FP_3$0
  (union$1 (setminus$1 FP_1$0 FP_2$0)
    (union$1 (intersection$1 Alloc_2$0 FP_2$0)
      (setminus$1 Alloc_2$0 Alloc_1$0)))))

(assert (= FP_Caller_final_1$0 (union$1 FP_Caller_1$0 FP_3$0)))

(assert (= res_2$0 res_1$0))

(assert (Frame$1 FP_2$0 Alloc_1$0 next$0 next_1$0))

(assert (= Alloc$0 (union$1 FP_Caller$0 Alloc$0)))

(assert (= (setminus$0 content1_1$0 content2_1$0)
  (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))

(assert (= sk_?X_78$0
  (sorted_set_domain$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))

(assert (= sk_?X_80$0
  (union$1 (intersection$1 Alloc_2$0 FP_2$0)
    (setminus$1 Alloc_2$0 Alloc_1$0))))

(assert (sorted_set_struct$0 sk_?X_78$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0
  content2_1$0))

(assert (= emptyset$1 (intersection$1 sk_?X_83$0 sk_?X_82$0)))

(assert (= content2_1$0 (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))

(assert (= sk_?X_81$0 FP_2$0))

(assert (= sk_?X_83$0 (sorted_set_domain$0 data$0 next$0 n_2$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_82$0 data$0 next$0 (read$1 next$0 lst2$0) null$0
  content2_1$0))

(assert (= emptyset$1 (intersection$1 sk_?X_86$0 sk_?X_85$0)))

(assert (= content2$0 (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))

(assert (= sk_?X_84$0 FP$0))

(assert (= sk_?X_86$0 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0)))

(assert (sorted_set_struct$0 sk_?X_85$0 data$0 next$0 lst2$0 null$0 content2$0))

(assert (= sk_?X_87$0 (sorted_set_domain$0 data$0 next_1$0 lst2$0 null$0)))

(assert (= sk_?X_89$0 (union$1 sk_?X_87$0 sk_?X_88$0)))

(assert (not (= lst1$0 null$0)))

(assert (not (< (read$0 data$0 lst1$0) (read$0 data$0 lst2$0))))

(assert (not (in$1 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$0 data$0 l1)
                (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 (read$1 next$0 lst2$0)
                     null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$0 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$0 data$0 l1)
                (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0)
                  null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0
                     (read$1 next$0 lst2$0) null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$0 data$0 l1)
                (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$0 data$0 l1)
              (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 (read$1 next$0 lst2$0)
                     null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$0 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$0 data$0 l1)
              (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0
                     (read$1 next$0 lst2$0) null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$0 data$0 l1)
              (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 (read$1 next$0 lst2$0) l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next$0 (read$1 next$0 lst2$0)
                     null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next$0 (read$1 next$0 lst2$0) l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0
                          (read$1 next$0 lst2$0) null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst2$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_1$0 (read$1 next$0 lst2$0) l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0
                     (read$1 next$0 lst2$0) null$0))
                 (not (= l1 null$0)))
            (and
                 (or (= l1 null$0)
                     (not (Btwn$0 next_1$0 (read$1 next$0 lst2$0) l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next_1$0
                          (read$1 next$0 lst2$0) null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_1$0 res_1$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next_1$0 res_1$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$0 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0)
                    null$0))))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0)
                     null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$0 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$0 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0)
                    null$0))))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0)
                     null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$0 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0))
              null$0)
            (in$0 v
              (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0)
                  null$0))
              null$0)
            (in$0 v
              (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0) null$0))
              (sorted_set_domain$0 data$0 next$0 (read$1 next$0 lst2$0)
                null$0))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next$0 (read$1 next$0 lst2$0)
                     null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0)
                  null$0))
              (sorted_set_domain$0 data$0 next_1$0 (read$1 next$0 lst2$0)
                null$0))
            (not
                 (in$0 v
                   (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0)
                     null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))
              (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next_1$0 res_1$0 null$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$1 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$1 ?y ?X))
            (in$1 (ep$0 ?f ?X ?x) ?X))))

(assert (or (and Axiom_71$0 Axiom_70$0 Axiom_69$0)
    (not (Frame$1 FP_2$0 Alloc_1$0 next$0 next_1$0))))

(assert (or (not Axiom_61$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_82$0))
                (not (in$1 l2 sk_?X_82$0))))))

(assert (or (and (Btwn$0 next$0 lst1$0 null$0 null$0) Axiom_62$0)
    (not
         (sorted_set_struct$0 sk_?X_86$0 data$0 next$0 lst1$0 null$0
           content1$0))))

(assert (or (not Axiom_63$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next$0 l1 l2 null$0)) (not (in$1 l1 sk_?X_85$0))
                (not (in$1 l2 sk_?X_85$0))))))

(assert (or (and (Btwn$0 next$0 n_2$0 null$0 null$0) Axiom_64$0)
    (not
         (sorted_set_struct$0 sk_?X_83$0 data$0 next$0 n_2$0 null$0
           content1_1$0))))

(assert (or (not Axiom_65$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next_1$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_78$0)) (not (in$1 l2 sk_?X_78$0))))))

(assert (or (and (Btwn$0 next_1$0 lst2$0 null$0 null$0) Axiom_66$0)
    (not
         (sorted_set_struct$0 sk_?X_87$0 data$0 next_1$0 lst2$0 null$0
           content2$0))))

(assert (or (not Axiom_67$0)
    (forall ((l1 Loc) (l2 Loc))
            (or (= l1 l2) (< (read$0 data$0 l1) (read$0 data$0 l2))
                (not (Btwn$0 next_1$0 l1 l2 null$0))
                (not (in$1 l1 sk_?X_79$0)) (not (in$1 l2 sk_?X_79$0))))))

(assert (or (and (Btwn$0 next_1$0 res_2$0 null$0 null$0) Axiom_68$0)
    (not
         (sorted_set_struct$0 sk_?X_88$0 data$0 next_1$0 res_2$0 null$0
           (setminus$0 content1$0 content2$0)))))

(assert (= FP_1$0 (setminus$1 FP$0 (setenum$1 lst1$0))))

(assert (= FP_Caller_1$0 (setminus$1 FP_Caller$0 FP$0)))

(assert (= n_2$0 (read$1 next$0 lst1$0)))

(assert (Frame$0 FP_2$0 Alloc_1$0 data$0 data$0))

(assert (= Alloc_2$0 (union$1 FP_3$0 Alloc_2$0)))

(assert (= emptyset$1 (intersection$1 sk_?X_78$0 sk_?X_79$0)))

(assert (= content2_1$0
  (sorted_set_c$0 data$0 next_1$0 (read$1 next$0 lst2$0) null$0)))

(assert (= sk_?X_79$0 (sorted_set_domain$0 data$0 next_1$0 res_1$0 null$0)))

(assert (= sk_?X_80$0 (union$1 sk_?X_78$0 sk_?X_79$0)))

(assert (sorted_set_struct$0 sk_?X_79$0 data$0 next_1$0 res_1$0 null$0
  (setminus$0 content1_1$0 content2_1$0)))

(assert (= content1_1$0 (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))

(assert (= sk_?X_81$0 (union$1 sk_?X_83$0 sk_?X_82$0)))

(assert (= sk_?X_82$0
  (sorted_set_domain$0 data$0 next$0 (read$1 next$0 lst2$0) null$0)))

(assert (= FP_1$0 (union$1 FP_2$0 FP_1$0)))

(assert (sorted_set_struct$0 sk_?X_83$0 data$0 next$0 n_2$0 null$0 content1_1$0))

(assert (= content1$0 (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))

(assert (= sk_?X_84$0 (union$1 sk_?X_86$0 sk_?X_85$0)))

(assert (= sk_?X_85$0 (sorted_set_domain$0 data$0 next$0 lst2$0 null$0)))

(assert (= FP_Caller$0 (union$1 FP$0 FP_Caller$0)))

(assert (sorted_set_struct$0 sk_?X_86$0 data$0 next$0 lst1$0 null$0 content1$0))

(assert (= sk_?X_88$0 (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0)))

(assert (or (in$1 sk_l2_7$0 (intersection$1 sk_?X_87$0 sk_?X_88$0))
    (and (in$0 sk_?e_4$0 (setminus$0 content1$0 content2$0))
         (not
              (in$0 sk_?e_4$0
                (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))))
    (and (in$0 sk_?e_4$0 content2$0)
         (not
              (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))))
    (and (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))
         (not (in$0 sk_?e_4$0 content2$0)))
    (and (in$0 sk_?e_4$0 (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
         (not (in$0 sk_?e_4$0 (setminus$0 content1$0 content2$0))))
    (and
         (in$1 sk_l1_7$0
           (union$1 (intersection$1 Alloc_2$0 FP$0)
             (setminus$1 Alloc_2$0 Alloc$0)))
         (not (in$1 sk_l1_7$0 sk_?X_89$0)))
    (and (in$1 sk_l1_7$0 sk_?X_89$0)
         (not
              (in$1 sk_l1_7$0
                (union$1 (intersection$1 Alloc_2$0 FP$0)
                  (setminus$1 Alloc_2$0 Alloc$0)))))
    (not (Btwn$0 next_1$0 lst2$0 null$0 null$0))
    (not (Btwn$0 next_1$0 res_2$0 null$0 null$0))
    (and (Btwn$0 next_1$0 sk_l1_7$0 sk_l2_7$0 null$0)
         (in$1 sk_l1_7$0 sk_?X_87$0) (in$1 sk_l2_7$0 sk_?X_87$0)
         (not (= sk_l1_7$0 sk_l2_7$0))
         (not (< (read$0 data$0 sk_l1_7$0) (read$0 data$0 sk_l2_7$0))))
    (and (Btwn$0 next_1$0 sk_l1_7$0 sk_l2_7$0 null$0)
         (in$1 sk_l1_7$0 sk_?X_88$0) (in$1 sk_l2_7$0 sk_?X_88$0)
         (not (= sk_l1_7$0 sk_l2_7$0))
         (not (< (read$0 data$0 sk_l1_7$0) (read$0 data$0 sk_l2_7$0))))))

(assert (not (= lst2$0 null$0)))

(assert (not (> (read$0 data$0 lst1$0) (read$0 data$0 lst2$0))))

(assert (not (in$1 null$0 Alloc_2$0)))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$0 data$0 l1)
                (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$0 data$0 l1)
                (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 n_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$0 data$0 l1)
                (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 lst2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (= l1
              (witness$0 data$0 (read$0 data$0 l1)
                (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$0 data$0 l1)
              (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$0 data$0 l1)
              (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
            (not (in$1 l1 (sorted_set_domain$0 data$0 next$0 n_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$0 data$0 l1)
              (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 lst2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (in$0 (read$0 data$0 l1)
              (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
            (not
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 lst1$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 lst1$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 lst1$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 n_2$0 l1 null$0)
                 (in$1 l1 (sorted_set_domain$0 data$0 next$0 n_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next$0 n_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next$0 n_2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_1$0 lst2$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 lst2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next_1$0 lst2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next_1$0 lst2$0 null$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next_1$0 res_2$0 l1 null$0)
                 (in$1 l1
                   (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0))
                 (not (= l1 null$0)))
            (and (or (= l1 null$0) (not (Btwn$0 next_1$0 res_2$0 l1 null$0)))
                 (not
                      (in$1 l1
                        (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0)))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$0 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 lst1$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$0 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next$0 n_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 n_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$0 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (= v
              (read$0 data$0
                (witness$0 data$0 v
                  (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))))
            (not (in$0 v (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 lst1$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next$0 n_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (=
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
              null$0)
            (in$0 v (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0)))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 lst1$0 null$0))
              (sorted_set_domain$0 data$0 next$0 lst1$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 lst1$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next$0 n_2$0 null$0))
              (sorted_set_domain$0 data$0 next$0 n_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next$0 n_2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))
              (sorted_set_domain$0 data$0 next_1$0 lst2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next_1$0 lst2$0 null$0))))))

(assert (forall ((v Int))
        (or
            (in$1
              (witness$0 data$0 v
                (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))
              (sorted_set_domain$0 data$0 next_1$0 res_2$0 null$0))
            (not (in$0 v (sorted_set_c$0 data$0 next_1$0 res_2$0 null$0))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$1 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (not Axiom_69$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (in$1 ?x FP_2$0)
                (and (Btwn$0 next$0 ?x ?z ?y) (Btwn$0 next_1$0 ?x ?z ?y))
                (and (not (Btwn$0 next$0 ?x ?z ?y))
                     (not (Btwn$0 next_1$0 ?x ?z ?y)))
                (not (= ?x (ep$0 next$0 FP_2$0 ?x)))))))

(assert (or (not Axiom_70$0)
    (forall ((?x Loc) (?y Loc) (?z Loc))
            (or (and (Btwn$0 next$0 ?x ?z ?y) (Btwn$0 next_1$0 ?x ?z ?y))
                (and (not (Btwn$0 next$0 ?x ?z ?y))
                     (not (Btwn$0 next_1$0 ?x ?z ?y)))
                (not
                     (or (Btwn$0 next$0 ?x ?y (ep$0 next$0 FP_2$0 ?x))
                         (and (Btwn$0 next$0 ?x ?y ?y)
                              (not
                                   (Btwn$0 next$0 ?x (ep$0 next$0 FP_2$0 ?x)
                                     (ep$0 next$0 FP_2$0 ?x))))))))))

(assert (or (not Axiom_71$0)
    (forall ((?x Loc))
            (or (= (read$1 next$0 ?x) (read$1 next_1$0 ?x))
                (not (in$1 ?x (setminus$1 Alloc_1$0 FP_2$0)))))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$1 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$1 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$1 ?f ?x) (read$1 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
