(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |
  GRASShopper benchmarks.
  Authors: Ruzica Piskac, Thomas Wies, and Damien Zufferey
  URL: http://cs.nyu.edu/wies/software/grasshopper
  See also: GRASShopper - Complete Heap Verification with Mixed Specifications. In TACAS 2014, pages 124-139.

  If this benchmark is satisfiable, GRASShopper reports the following error message:
  tests/spl/sls/sls_quicksort.spl:44:3-4:An invariant might not be maintained by a loop in procedure split
  tests/spl/sls/sls_quicksort.spl:28:14:Related location: This is the loop invariant that might not be maintained
  |)
(set-info :category "crafted")
(set-info :status unsat)

(declare-sort Loc 0)
(declare-sort SetLoc 0)
(declare-sort SetInt 0)
(declare-sort FldBool 0)
(declare-sort FldLoc 0)
(declare-sort FldInt 0)
(declare-fun null$0 () Loc)
(declare-fun read$0 (FldLoc Loc) Loc)
(declare-fun read$1 (FldInt Loc) Int)
(declare-fun write$0 (FldInt Loc Int) FldInt)
(declare-fun ep$0 (FldLoc SetLoc Loc) Loc)
(declare-fun emptyset$0 () SetLoc)
(declare-fun setenum$0 (Loc) SetLoc)
(declare-fun union$0 (SetLoc SetLoc) SetLoc)
(declare-fun intersection$0 (SetLoc SetLoc) SetLoc)
(declare-fun setminus$0 (SetLoc SetLoc) SetLoc)
(declare-fun Btwn$0 (FldLoc Loc Loc Loc) Bool)
(declare-fun in$0 (Loc SetLoc) Bool)
(declare-fun Alloc$0 () SetLoc)
(declare-fun Axiom_98$0 () Bool)
(declare-fun Axiom_99$0 () Bool)
(declare-fun Axiom_100$0 () Bool)
(declare-fun Axiom_101$0 () Bool)
(declare-fun Axiom_102$0 () Bool)
(declare-fun Axiom_103$0 () Bool)
(declare-fun FP$0 () SetLoc)
(declare-fun FP_Caller$0 () SetLoc)
(declare-fun FP_Caller_3$0 () SetLoc)
(declare-fun blseg_domain$0 (FldInt FldLoc Loc Loc Int Int) SetLoc)
(declare-fun blseg_struct$0 (SetLoc FldInt FldLoc Loc Loc Int Int) Bool)
(declare-fun curr_4$0 () Loc)
(declare-fun curr_5$0 () Loc)
(declare-fun curr_init$0 () Loc)
(declare-fun data$0 () FldInt)
(declare-fun data_5$0 () FldInt)
(declare-fun data_6$0 () FldInt)
(declare-fun data_7$0 () FldInt)
(declare-fun lb_5$0 () Int)
(declare-fun lb_init$0 () Int)
(declare-fun next$0 () FldLoc)
(declare-fun pivot_6$0 () Loc)
(declare-fun pivot_7$0 () Loc)
(declare-fun pivot_init$0 () Loc)
(declare-fun sk_?X_209$0 () SetLoc)
(declare-fun sk_?X_210$0 () SetLoc)
(declare-fun sk_?X_211$0 () SetLoc)
(declare-fun sk_?X_212$0 () SetLoc)
(declare-fun sk_?X_213$0 () SetLoc)
(declare-fun sk_?X_214$0 () SetLoc)
(declare-fun sk_?X_215$0 () SetLoc)
(declare-fun sk_?X_216$0 () SetLoc)
(declare-fun sk_?X_217$0 () SetLoc)
(declare-fun sk_?X_218$0 () SetLoc)
(declare-fun sk_?X_219$0 () SetLoc)
(declare-fun sk_?X_220$0 () SetLoc)
(declare-fun sk_?X_221$0 () SetLoc)
(declare-fun sk_?X_222$0 () SetLoc)
(declare-fun sk_?X_223$0 () SetLoc)
(declare-fun sk_?X_224$0 () SetLoc)
(declare-fun sk_?X_225$0 () SetLoc)
(declare-fun sk_?X_226$0 () SetLoc)
(declare-fun sk_?X_227$0 () SetLoc)
(declare-fun sk_?X_228$0 () SetLoc)
(declare-fun sk_FP_4$0 () SetLoc)
(declare-fun sk_l1_6$0 () Loc)
(declare-fun t_109$0 () Int)
(declare-fun t_110$0 () Int)
(declare-fun t_111$0 () Int)
(declare-fun t_112$0 () Int)
(declare-fun t_113$0 () Int)
(declare-fun t_114$0 () Int)
(declare-fun t_115$0 () Int)
(declare-fun t_116$0 () Int)
(declare-fun t_117$0 () Int)
(declare-fun t_118$0 () Int)
(declare-fun t_119$0 () Int)
(declare-fun t_120$0 () Int)
(declare-fun t_121$0 () Int)
(declare-fun t_122$0 () Int)
(declare-fun t_123$0 () Int)
(declare-fun t_124$0 () Int)
(declare-fun t_125$0 () Int)
(declare-fun t_126$0 () Int)
(declare-fun t_127$0 () Int)
(declare-fun t_128$0 () Int)
(declare-fun t_129$0 () Int)
(declare-fun tmp_2$0 () Int)
(declare-fun tmp_4$0 () Int)
(declare-fun tmp_init$0 () Int)
(declare-fun ub_5$0 () Int)
(declare-fun ub_init$0 () Int)
(declare-fun x_5$0 () Loc)
(declare-fun x_init$0 () Loc)
(declare-fun y_5$0 () Loc)
(declare-fun y_init$0 () Loc)

(assert (= (read$1 data_6$0 sk_l1_6$0) t_129$0))

(assert (= (read$1 data_6$0 pivot_7$0) t_128$0))

(assert (= (read$1 data_6$0 pivot_6$0) t_127$0))

(assert (= (read$1 data_5$0 sk_l1_6$0) t_126$0))

(assert (= (read$1 data_5$0 pivot_7$0) t_125$0))

(assert (= (read$1 data_5$0 (read$0 next$0 pivot_6$0)) t_124$0))

(assert (= (read$1 data$0 sk_l1_6$0) t_123$0))

(assert (= (read$1 data$0 pivot_7$0) t_122$0))

(assert (= (read$1 (write$0 data_6$0 pivot_6$0 tmp_4$0) sk_l1_6$0) t_121$0))

(assert (= (read$1 (write$0 data_6$0 pivot_6$0 tmp_4$0) pivot_7$0) t_120$0))

(assert (= (read$1 (write$0 data_6$0 pivot_6$0 tmp_4$0) pivot_6$0) t_119$0))

(assert (=
  (read$1
    (write$0 data_5$0 (read$0 next$0 pivot_6$0) (read$1 data_5$0 pivot_6$0))
    sk_l1_6$0)
  t_118$0))

(assert (=
  (read$1
    (write$0 data_5$0 (read$0 next$0 pivot_6$0) (read$1 data_5$0 pivot_6$0))
    pivot_7$0)
  t_117$0))

(assert (=
  (read$1
    (write$0 data_5$0 (read$0 next$0 pivot_6$0) (read$1 data_5$0 pivot_6$0))
    pivot_6$0)
  t_116$0))

(assert (=
  (read$1
    (write$0 data_5$0 (read$0 next$0 pivot_6$0) (read$1 data_5$0 pivot_6$0))
    (read$0 next$0 pivot_6$0))
  t_115$0))

(assert (=
  (read$1 (write$0 data$0 curr_4$0 (read$1 data$0 (read$0 next$0 pivot_6$0)))
    sk_l1_6$0)
  t_114$0))

(assert (=
  (read$1 (write$0 data$0 curr_4$0 (read$1 data$0 (read$0 next$0 pivot_6$0)))
    pivot_init$0)
  t_113$0))

(assert (=
  (read$1 (write$0 data$0 curr_4$0 (read$1 data$0 (read$0 next$0 pivot_6$0)))
    pivot_7$0)
  t_112$0))

(assert (=
  (read$1 (write$0 data$0 curr_4$0 (read$1 data$0 (read$0 next$0 pivot_6$0)))
    pivot_6$0)
  t_111$0))

(assert (=
  (read$1 (write$0 data$0 curr_4$0 (read$1 data$0 (read$0 next$0 pivot_6$0)))
    curr_4$0)
  t_110$0))

(assert (=
  (read$1 (write$0 data$0 curr_4$0 (read$1 data$0 (read$0 next$0 pivot_6$0)))
    (read$0 next$0 pivot_6$0))
  t_109$0))

(assert (forall ((?d_52 Int) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$1 data_6$0 ?y) (read$1 (write$0 data_6$0 ?x ?d_52) ?y)))))

(assert (forall ((?d_52 Int) (?x Loc))
        (= (read$1 (write$0 data_6$0 ?x ?d_52) ?x) ?d_52)))

(assert (forall ((?d_51 Int) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$1 data_5$0 ?y) (read$1 (write$0 data_5$0 ?x ?d_51) ?y)))))

(assert (forall ((?d_51 Int) (?x Loc))
        (= (read$1 (write$0 data_5$0 ?x ?d_51) ?x) ?d_51)))

(assert (forall ((?d_50 Int) (?x Loc) (?y Loc))
        (or (= ?y ?x)
            (= (read$1 data$0 ?y) (read$1 (write$0 data$0 ?x ?d_50) ?y)))))

(assert (forall ((?d_50 Int) (?x Loc))
        (= (read$1 (write$0 data$0 ?x ?d_50) ?x) ?d_50)))

(assert (forall ((?f FldLoc)) (= (read$0 ?f null$0) null$0)))

(assert (forall ((x Loc) (y Loc))
        (or (and (= x y) (in$0 x (setenum$0 y)))
            (and (not (= x y)) (not (in$0 x (setenum$0 y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x (setminus$0 X Y)) (not (in$0 x Y)))
            (and (or (in$0 x Y) (not (in$0 x X)))
                 (not (in$0 x (setminus$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x X) (in$0 x Y) (in$0 x (intersection$0 X Y)))
            (and (or (not (in$0 x X)) (not (in$0 x Y)))
                 (not (in$0 x (intersection$0 X Y)))))))

(assert (forall ((X SetLoc) (Y SetLoc) (x Loc))
        (or (and (in$0 x (union$0 X Y)) (or (in$0 x X) (in$0 x Y)))
            (and (not (in$0 x X)) (not (in$0 x Y))
                 (not (in$0 x (union$0 X Y)))))))

(assert (forall ((x Loc)) (not (in$0 x emptyset$0))))

(assert (or (and (Btwn$0 next$0 curr_5$0 y_5$0 y_5$0) Axiom_98$0)
    (not
         (blseg_struct$0 sk_?X_224$0 data_7$0 next$0 curr_5$0 y_5$0 lb_5$0
           ub_5$0))))

(assert (or (not Axiom_99$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data$0 l1) ub_init$0)
                     (<= lb_init$0 (read$1 data$0 l1)))
                (not (in$0 l1 sk_?X_214$0))))))

(assert (or (and (Btwn$0 next$0 pivot_7$0 curr_5$0 curr_5$0) Axiom_100$0)
    (not
         (blseg_struct$0 sk_?X_227$0 data_7$0 next$0 pivot_7$0 curr_5$0
           (read$1 data_7$0 pivot_7$0) ub_5$0))))

(assert (or (not Axiom_101$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data$0 l1) ub_init$0)
                     (<= (read$1 data$0 pivot_init$0) (read$1 data$0 l1)))
                (not (in$0 l1 sk_?X_217$0))))))

(assert (or (and (Btwn$0 next$0 x_5$0 pivot_7$0 pivot_7$0) Axiom_102$0)
    (not
         (blseg_struct$0 sk_?X_228$0 data_7$0 next$0 x_5$0 pivot_7$0 lb_5$0
           (read$1 data_7$0 pivot_7$0)))))

(assert (or (not Axiom_103$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data$0 l1) (read$1 data$0 pivot_init$0))
                     (<= lb_init$0 (read$1 data$0 l1)))
                (not (in$0 l1 sk_?X_218$0))))))

(assert (or
    (and
         (= data_5$0
           (write$0 data$0 curr_4$0
             (read$1 data$0 (read$0 next$0 pivot_6$0))))
         (= data_6$0
           (write$0 data_5$0 (read$0 next$0 pivot_6$0)
             (read$1 data_5$0 pivot_6$0)))
         (= data_7$0 (write$0 data_6$0 pivot_6$0 tmp_4$0))
         (= pivot_7$0 (read$0 next$0 pivot_6$0))
         (= tmp_4$0 (read$1 data$0 curr_4$0))
         (< (read$1 data$0 curr_4$0) (read$1 data$0 pivot_6$0)))
    (and (= data_7$0 data$0) (= pivot_7$0 pivot_6$0) (= tmp_4$0 tmp_2$0)
         (not (< (read$1 data$0 curr_4$0) (read$1 data$0 pivot_6$0))))))

(assert (= curr_4$0 curr_init$0))

(assert (= lb_5$0 lb_init$0))

(assert (= tmp_2$0 tmp_init$0))

(assert (= x_5$0 x_init$0))

(assert (= Alloc$0 (union$0 FP_Caller$0 Alloc$0)))

(assert (= emptyset$0 (intersection$0 sk_?X_213$0 sk_?X_212$0)))

(assert (= emptyset$0 (intersection$0 sk_?X_218$0 sk_?X_216$0)))

(assert (= sk_?X_209$0 FP$0))

(assert (= sk_?X_211$0 (union$0 sk_?X_213$0 sk_?X_212$0)))

(assert (= sk_?X_213$0 (union$0 sk_?X_215$0 sk_?X_214$0)))

(assert (= sk_?X_215$0 (union$0 sk_?X_218$0 sk_?X_216$0)))

(assert (= sk_?X_217$0
  (blseg_domain$0 data$0 next$0 pivot_init$0 curr_init$0
    (read$1 data$0 pivot_init$0) ub_init$0)))

(assert (<= (read$1 data$0 pivot_init$0) ub_init$0))

(assert (Btwn$0 next$0 pivot_init$0 curr_init$0 y_init$0))

(assert (= FP_Caller$0 (union$0 FP$0 FP_Caller$0)))

(assert (blseg_struct$0 sk_?X_217$0 data$0 next$0 pivot_init$0 curr_init$0
  (read$1 data$0 pivot_init$0) ub_init$0))

(assert (not (= pivot_init$0 curr_init$0)))

(assert (= sk_?X_220$0 sk_?X_221$0))

(assert (= sk_?X_222$0 emptyset$0))

(assert (= sk_?X_224$0 (blseg_domain$0 data_7$0 next$0 curr_5$0 y_5$0 lb_5$0 ub_5$0)))

(assert (= sk_?X_226$0 sk_?X_227$0))

(assert (= sk_?X_228$0
  (blseg_domain$0 data_7$0 next$0 x_5$0 pivot_7$0 lb_5$0
    (read$1 data_7$0 pivot_7$0))))

(assert (or (= pivot_7$0 curr_5$0)
    (in$0 sk_l1_6$0 (intersection$0 sk_?X_223$0 sk_?X_222$0))
    (in$0 sk_l1_6$0 (intersection$0 sk_?X_225$0 sk_?X_224$0))
    (in$0 sk_l1_6$0 (intersection$0 sk_?X_228$0 sk_?X_226$0))
    (and (in$0 sk_l1_6$0 sk_?X_224$0)
         (or (not (<= (read$1 data_7$0 sk_l1_6$0) ub_5$0))
             (not (<= lb_5$0 (read$1 data_7$0 sk_l1_6$0)))))
    (and (in$0 sk_l1_6$0 sk_?X_227$0)
         (or (not (<= (read$1 data_7$0 sk_l1_6$0) ub_5$0))
             (not
                  (<= (read$1 data_7$0 pivot_7$0)
                    (read$1 data_7$0 sk_l1_6$0)))))
    (and (in$0 sk_l1_6$0 sk_?X_228$0)
         (or
             (not
                  (<= (read$1 data_7$0 sk_l1_6$0)
                    (read$1 data_7$0 pivot_7$0)))
             (not (<= lb_5$0 (read$1 data_7$0 sk_l1_6$0)))))
    (and (in$0 sk_l1_6$0 sk_FP_4$0) (not (in$0 sk_l1_6$0 FP$0)))
    (not (<= (read$1 data_7$0 pivot_7$0) ub_5$0))
    (not (<= lb_5$0 (read$1 data_7$0 pivot_7$0)))
    (not (Btwn$0 next$0 curr_5$0 y_5$0 y_5$0))
    (not (Btwn$0 next$0 pivot_7$0 curr_5$0 curr_5$0))
    (not (Btwn$0 next$0 pivot_7$0 curr_5$0 y_5$0))
    (not (Btwn$0 next$0 x_5$0 pivot_7$0 pivot_7$0))
    (not (Btwn$0 next$0 x_5$0 pivot_7$0 y_5$0))))

(assert (not (in$0 null$0 Alloc$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_init$0 l1 y_init$0)
                 (in$0 l1
                   (blseg_domain$0 data$0 next$0 curr_init$0 y_init$0
                     lb_init$0 ub_init$0))
                 (not (= l1 y_init$0)))
            (and
                 (or (= l1 y_init$0)
                     (not (Btwn$0 next$0 curr_init$0 l1 y_init$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data$0 next$0 curr_init$0 y_init$0
                          lb_init$0 ub_init$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 pivot_init$0 l1 curr_init$0)
                 (in$0 l1
                   (blseg_domain$0 data$0 next$0 pivot_init$0 curr_init$0
                     (read$1 data$0 pivot_init$0) ub_init$0))
                 (not (= l1 curr_init$0)))
            (and
                 (or (= l1 curr_init$0)
                     (not (Btwn$0 next$0 pivot_init$0 l1 curr_init$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data$0 next$0 pivot_init$0
                          curr_init$0 (read$1 data$0 pivot_init$0) ub_init$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 x_init$0 l1 pivot_init$0)
                 (in$0 l1
                   (blseg_domain$0 data$0 next$0 x_init$0 pivot_init$0
                     lb_init$0 (read$1 data$0 pivot_init$0)))
                 (not (= l1 pivot_init$0)))
            (and
                 (or (= l1 pivot_init$0)
                     (not (Btwn$0 next$0 x_init$0 l1 pivot_init$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data$0 next$0 x_init$0 pivot_init$0
                          lb_init$0 (read$1 data$0 pivot_init$0))))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (or (in$0 (ep$0 ?f ?X ?x) ?X) (= ?x (ep$0 ?f ?X ?x)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc))
        (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) (ep$0 ?f ?X ?x))))

(assert (or (not Axiom_98$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data_7$0 l1) ub_5$0)
                     (<= lb_5$0 (read$1 data_7$0 l1)))
                (not (in$0 l1 sk_?X_224$0))))))

(assert (or (and (Btwn$0 next$0 curr_init$0 y_init$0 y_init$0) Axiom_99$0)
    (not
         (blseg_struct$0 sk_?X_214$0 data$0 next$0 curr_init$0 y_init$0
           lb_init$0 ub_init$0))))

(assert (or (not Axiom_100$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data_7$0 l1) ub_5$0)
                     (<= (read$1 data_7$0 pivot_7$0) (read$1 data_7$0 l1)))
                (not (in$0 l1 sk_?X_227$0))))))

(assert (or (and (Btwn$0 next$0 pivot_init$0 curr_init$0 curr_init$0) Axiom_101$0)
    (not
         (blseg_struct$0 sk_?X_217$0 data$0 next$0 pivot_init$0 curr_init$0
           (read$1 data$0 pivot_init$0) ub_init$0))))

(assert (or (not Axiom_102$0)
    (forall ((l1 Loc))
            (or
                (and (<= (read$1 data_7$0 l1) (read$1 data_7$0 pivot_7$0))
                     (<= lb_5$0 (read$1 data_7$0 l1)))
                (not (in$0 l1 sk_?X_228$0))))))

(assert (or (and (Btwn$0 next$0 x_init$0 pivot_init$0 pivot_init$0) Axiom_103$0)
    (not
         (blseg_struct$0 sk_?X_218$0 data$0 next$0 x_init$0 pivot_init$0
           lb_init$0 (read$1 data$0 pivot_init$0)))))

(assert (= FP_Caller_3$0 (setminus$0 FP_Caller$0 FP$0)))

(assert (= curr_5$0 (read$0 next$0 curr_4$0)))

(assert (= pivot_6$0 pivot_init$0))

(assert (= ub_5$0 ub_init$0))

(assert (= y_5$0 y_init$0))

(assert (= emptyset$0 emptyset$0))

(assert (= emptyset$0 (intersection$0 sk_?X_215$0 sk_?X_214$0)))

(assert (= sk_?X_209$0 sk_?X_210$0))

(assert (= sk_?X_210$0 sk_?X_211$0))

(assert (= sk_?X_212$0 emptyset$0))

(assert (= sk_?X_214$0
  (blseg_domain$0 data$0 next$0 curr_init$0 y_init$0 lb_init$0 ub_init$0)))

(assert (= sk_?X_216$0 sk_?X_217$0))

(assert (= sk_?X_218$0
  (blseg_domain$0 data$0 next$0 x_init$0 pivot_init$0 lb_init$0
    (read$1 data$0 pivot_init$0))))

(assert (<= lb_init$0 (read$1 data$0 pivot_init$0)))

(assert (Btwn$0 next$0 x_init$0 pivot_init$0 y_init$0))

(assert (blseg_struct$0 sk_?X_214$0 data$0 next$0 curr_init$0 y_init$0 lb_init$0
  ub_init$0))

(assert (blseg_struct$0 sk_?X_218$0 data$0 next$0 x_init$0 pivot_init$0 lb_init$0
  (read$1 data$0 pivot_init$0)))

(assert (= sk_?X_219$0 sk_?X_220$0))

(assert (= sk_?X_221$0 (union$0 sk_?X_223$0 sk_?X_222$0)))

(assert (= sk_?X_223$0 (union$0 sk_?X_225$0 sk_?X_224$0)))

(assert (= sk_?X_225$0 (union$0 sk_?X_228$0 sk_?X_226$0)))

(assert (= sk_?X_227$0
  (blseg_domain$0 data_7$0 next$0 pivot_7$0 curr_5$0
    (read$1 data_7$0 pivot_7$0) ub_5$0)))

(assert (= sk_FP_4$0 sk_?X_219$0))

(assert (not (= curr_4$0 y_5$0)))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 curr_5$0 l1 y_5$0)
                 (in$0 l1
                   (blseg_domain$0 data_7$0 next$0 curr_5$0 y_5$0 lb_5$0
                     ub_5$0))
                 (not (= l1 y_5$0)))
            (and (or (= l1 y_5$0) (not (Btwn$0 next$0 curr_5$0 l1 y_5$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_7$0 next$0 curr_5$0 y_5$0 lb_5$0
                          ub_5$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 pivot_7$0 l1 curr_5$0)
                 (in$0 l1
                   (blseg_domain$0 data_7$0 next$0 pivot_7$0 curr_5$0
                     (read$1 data_7$0 pivot_7$0) ub_5$0))
                 (not (= l1 curr_5$0)))
            (and
                 (or (= l1 curr_5$0)
                     (not (Btwn$0 next$0 pivot_7$0 l1 curr_5$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_7$0 next$0 pivot_7$0 curr_5$0
                          (read$1 data_7$0 pivot_7$0) ub_5$0)))))))

(assert (forall ((l1 Loc))
        (or
            (and (Btwn$0 next$0 x_5$0 l1 pivot_7$0)
                 (in$0 l1
                   (blseg_domain$0 data_7$0 next$0 x_5$0 pivot_7$0 lb_5$0
                     (read$1 data_7$0 pivot_7$0)))
                 (not (= l1 pivot_7$0)))
            (and
                 (or (= l1 pivot_7$0)
                     (not (Btwn$0 next$0 x_5$0 l1 pivot_7$0)))
                 (not
                      (in$0 l1
                        (blseg_domain$0 data_7$0 next$0 x_5$0 pivot_7$0
                          lb_5$0 (read$1 data_7$0 pivot_7$0))))))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (Btwn$0 ?f ?x (ep$0 ?f ?X ?x) ?y) (not (Btwn$0 ?f ?x ?y ?y))
            (not (in$0 ?y ?X)))))

(assert (forall ((?X SetLoc) (?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (in$0 ?y ?X))
            (in$0 (ep$0 ?f ?X ?x) ?X))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?x ?u ?y))
            (and (Btwn$0 ?f ?x ?u ?z) (Btwn$0 ?f ?u ?y ?z)))))

(assert (forall ((?f FldLoc) (?u Loc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z)) (not (Btwn$0 ?f ?y ?u ?z))
            (and (Btwn$0 ?f ?x ?y ?u) (Btwn$0 ?f ?x ?u ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?y ?z ?z))
            (Btwn$0 ?f ?x ?z ?z))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?z))
            (and (Btwn$0 ?f ?x ?y ?y) (Btwn$0 ?f ?y ?z ?z)))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc) (?z Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (not (Btwn$0 ?f ?x ?z ?z))
            (Btwn$0 ?f ?x ?y ?z) (Btwn$0 ?f ?x ?z ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?x)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y)
            (Btwn$0 ?f ?x (read$0 ?f ?x) ?y))))

(assert (forall ((?f FldLoc) (?x Loc) (?y Loc))
        (or (not (= (read$0 ?f ?x) ?x)) (not (Btwn$0 ?f ?x ?y ?y)) (= ?x ?y))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x (read$0 ?f ?x) (read$0 ?f ?x))))

(assert (forall ((?f FldLoc) (?x Loc)) (Btwn$0 ?f ?x ?x ?x)))

(check-sat)
(exit)
