(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S5)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S8) S5)
(declare-fun f10 () S7)
(declare-fun f11 () S8)
(declare-fun f12 (S9 S10) S5)
(declare-fun f13 (S11 S7) S9)
(declare-fun f14 () S11)
(declare-fun f15 () S7)
(declare-fun f16 (S12 S8) S10)
(declare-fun f17 (S8) S12)
(declare-fun f18 () S8)
(declare-fun f19 (S8) S12)
(declare-fun f20 (S13 S8) Int)
(declare-fun f21 () S13)
(declare-fun f22 (S14 S10) Int)
(declare-fun f23 (S15 S13) S14)
(declare-fun f24 () S15)
(declare-fun f25 (S16 S8) S8)
(declare-fun f26 (S17 S8) S16)
(declare-fun f27 () S17)
(declare-fun f28 (S18 S10) S8)
(declare-fun f29 (S19 S16) S18)
(declare-fun f30 () S19)
(declare-fun f31 (S20 Int) S8)
(declare-fun f32 () S20)
(declare-fun f33 (S10 S8) S1)
(declare-fun f34 (S8 S10) S1)
(declare-fun f35 () S2)
(declare-fun f36 () S3)
(declare-fun f37 () S17)
(declare-fun f38 () S3)
(declare-fun f39 () S17)
(declare-fun f40 (S10) S12)
(declare-fun f41 () S5)
(declare-fun f42 () S8)
(declare-fun f43 (S10) S1)
(declare-fun f44 (S8) S12)
(declare-fun f45 (S12) S12)
(declare-fun f46 (S12) S12)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 (f9 f10 f11)) (f12 (f13 f14 f15) (f16 (f17 f11) f18))) (f12 (f13 f14 f10) (f16 (f19 f11) f18)))))
(assert (< (f20 f21 f11) (f20 f21 f18)))
(assert (forall ((?v0 S8)) (let ((?v_0 (f20 f21 ?v0))) (=> (< (f20 f21 f11) ?v_0) (=> (< ?v_0 (f20 f21 f18)) (= (f9 f15 ?v0) (f9 f10 ?v0)))))))
(assert (< (f20 f21 f11) (f20 f21 f18)))
(assert (forall ((?v0 S8)) (let ((?v_0 (f20 f21 ?v0))) (=> (< (f20 f21 f11) ?v_0) (=> (< ?v_0 (f20 f21 f18)) (= (f9 f15 ?v0) (f9 f10 ?v0)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S13)) (let ((?v_0 (f23 f24 ?v2))) (=> (< (f20 f21 ?v0) (f20 f21 ?v1)) (= (+ (f20 ?v2 ?v0) (f22 ?v_0 (f16 (f17 ?v0) ?v1))) (f22 ?v_0 (f16 (f19 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S7)) (let ((?v_0 (f13 f14 ?v2))) (=> (< (f20 f21 ?v0) (f20 f21 ?v1)) (= (f6 (f7 f8 (f9 ?v2 ?v0)) (f12 ?v_0 (f16 (f17 ?v0) ?v1))) (f12 ?v_0 (f16 (f19 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S16)) (let ((?v_0 (f29 f30 ?v2))) (=> (< (f20 f21 ?v0) (f20 f21 ?v1)) (= (f25 (f26 f27 (f25 ?v2 ?v0)) (f28 ?v_0 (f16 (f17 ?v0) ?v1))) (f28 ?v_0 (f16 (f19 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S13)) (let ((?v_1 (f20 f21 ?v0)) (?v_0 (f23 f24 ?v2))) (=> (< ?v_1 (f20 f21 ?v1)) (= (f22 ?v_0 (f16 (f19 ?v0) ?v1)) (+ (f20 ?v2 ?v0) (f22 ?v_0 (f16 (f19 (f31 f32 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S7)) (let ((?v_1 (f20 f21 ?v0)) (?v_0 (f13 f14 ?v2))) (=> (< ?v_1 (f20 f21 ?v1)) (= (f12 ?v_0 (f16 (f19 ?v0) ?v1)) (f6 (f7 f8 (f9 ?v2 ?v0)) (f12 ?v_0 (f16 (f19 (f31 f32 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S16)) (let ((?v_1 (f20 f21 ?v0)) (?v_0 (f29 f30 ?v2))) (=> (< ?v_1 (f20 f21 ?v1)) (= (f28 ?v_0 (f16 (f19 ?v0) ?v1)) (f25 (f26 f27 (f25 ?v2 ?v0)) (f28 ?v_0 (f16 (f19 (f31 f32 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S13)) (let ((?v_0 (f20 f21 ?v1)) (?v_1 (f23 f24 ?v3)) (?v_2 (f19 ?v0))) (=> (<= (f20 f21 ?v0) ?v_0) (=> (<= ?v_0 (f20 f21 ?v2)) (= (+ (f22 ?v_1 (f16 ?v_2 ?v1)) (f22 ?v_1 (f16 (f19 ?v1) ?v2))) (f22 ?v_1 (f16 ?v_2 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S7)) (let ((?v_0 (f20 f21 ?v1)) (?v_1 (f13 f14 ?v3)) (?v_2 (f19 ?v0))) (=> (<= (f20 f21 ?v0) ?v_0) (=> (<= ?v_0 (f20 f21 ?v2)) (= (f6 (f7 f8 (f12 ?v_1 (f16 ?v_2 ?v1))) (f12 ?v_1 (f16 (f19 ?v1) ?v2))) (f12 ?v_1 (f16 ?v_2 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S16)) (let ((?v_0 (f20 f21 ?v1)) (?v_1 (f29 f30 ?v3)) (?v_2 (f19 ?v0))) (=> (<= (f20 f21 ?v0) ?v_0) (=> (<= ?v_0 (f20 f21 ?v2)) (= (f25 (f26 f27 (f28 ?v_1 (f16 ?v_2 ?v1))) (f28 ?v_1 (f16 (f19 ?v1) ?v2))) (f28 ?v_1 (f16 ?v_2 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f16 (f19 (f31 f32 (+ (f20 f21 ?v0) 1))) ?v1) (f16 (f17 ?v0) ?v1))))
(assert (forall ((?v0 S8) (?v1 S10)) (= (exists ((?v2 S8)) (and (< (f20 f21 ?v2) (f20 f21 ?v0)) (= (f33 ?v1 ?v2) f1))) (exists ((?v2 S8)) (and (= (f34 ?v2 (f16 (f19 (f31 f32 0)) ?v0)) f1) (= (f33 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S8) (?v1 S10)) (= (forall ((?v2 S8)) (=> (< (f20 f21 ?v2) (f20 f21 ?v0)) (= (f33 ?v1 ?v2) f1))) (forall ((?v2 S8)) (=> (= (f34 ?v2 (f16 (f19 (f31 f32 0)) ?v0)) f1) (= (f33 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f3 f35 ?v0) (f3 f35 ?v1)))) (= (f3 f35 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f25 (f26 f27 ?v0) ?v1) (f25 (f26 f27 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f26 f27 ?v0)) (?v_0 (f26 f27 ?v1))) (= (f25 ?v_1 (f25 ?v_0 ?v2)) (f25 ?v_0 (f25 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2)) (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 ?v_0 (f25 (f26 f27 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) ?v2) (f25 (f26 f27 (f25 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (=> (= (f25 (f26 f27 ?v0) ?v1) (f25 (f26 f27 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (=> (= (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (=> (= (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (f25 (f26 f27 (f25 ?v_0 ?v1)) (f25 (f26 f27 ?v2) ?v3)) (f25 (f26 f27 (f25 ?v_0 ?v2)) (f25 (f26 f27 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (= (f25 (f26 f27 ?v0) ?v1) (f25 (f26 f27 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f26 f27 ?v0))) (= (= (f25 ?v_0 ?v1) (f25 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f36 ?v0) ?v1) ?v2) (f3 (f4 f36 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f25 (f26 f27 (f25 (f26 f37 ?v0) ?v1)) ?v2) (f25 (f26 f37 (f25 (f26 f27 ?v0) ?v2)) (f25 (f26 f27 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f38 ?v0) ?v1) ?v2) (f3 (f4 f38 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f25 (f26 f27 (f25 (f26 f39 ?v0) ?v1)) ?v2) (f25 (f26 f39 (f25 (f26 f27 ?v0) ?v2)) (f25 (f26 f27 ?v1) ?v2)))))
(assert (forall ((?v0 S10) (?v1 S8) (?v2 S8)) (= (= (f33 (f16 (f40 ?v0) ?v1) ?v2) f1) (forall ((?v3 S8)) (=> (= (f34 ?v3 (f16 (f19 ?v1) ?v2)) f1) (= (f33 ?v0 ?v3) f1))))))
(assert (forall ((?v0 S13) (?v1 S8) (?v2 S8)) (let ((?v_1 (f23 f24 ?v0)) (?v_2 (f19 ?v1)) (?v_0 (f20 f21 ?v2))) (= (f22 ?v_1 (f16 ?v_2 (f31 f32 (+ ?v_0 1)))) (ite (< ?v_0 (f20 f21 ?v1)) 0 (+ (f22 ?v_1 (f16 ?v_2 ?v2)) (f20 ?v0 ?v2)))))))
(assert (forall ((?v0 S7) (?v1 S8) (?v2 S8)) (let ((?v_1 (f13 f14 ?v0)) (?v_2 (f19 ?v1)) (?v_0 (f20 f21 ?v2))) (= (f12 ?v_1 (f16 ?v_2 (f31 f32 (+ ?v_0 1)))) (ite (< ?v_0 (f20 f21 ?v1)) f41 (f6 (f7 f8 (f12 ?v_1 (f16 ?v_2 ?v2))) (f9 ?v0 ?v2)))))))
(assert (forall ((?v0 S16) (?v1 S8) (?v2 S8)) (let ((?v_1 (f29 f30 ?v0)) (?v_2 (f19 ?v1)) (?v_0 (f20 f21 ?v2))) (= (f28 ?v_1 (f16 ?v_2 (f31 f32 (+ ?v_0 1)))) (ite (< ?v_0 (f20 f21 ?v1)) f42 (f25 (f26 f27 (f28 ?v_1 (f16 ?v_2 ?v2))) (f25 ?v0 ?v2)))))))
(assert (forall ((?v0 S13) (?v1 S8)) (let ((?v_1 (f31 f32 0)) (?v_0 (f23 f24 ?v0))) (=> (= (f20 ?v0 ?v_1) 0) (= (f22 ?v_0 (f16 (f19 (f31 f32 (+ 0 1))) ?v1)) (f22 ?v_0 (f16 (f19 ?v_1) ?v1)))))))
(assert (forall ((?v0 S16) (?v1 S8)) (let ((?v_1 (f31 f32 0)) (?v_0 (f29 f30 ?v0))) (=> (= (f25 ?v0 ?v_1) f42) (= (f28 ?v_0 (f16 (f19 (f31 f32 (+ 0 1))) ?v1)) (f28 ?v_0 (f16 (f19 ?v_1) ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S8)) (let ((?v_1 (f31 f32 0)) (?v_0 (f13 f14 ?v0))) (=> (= (f9 ?v0 ?v_1) f41) (= (f12 ?v_0 (f16 (f19 (f31 f32 (+ 0 1))) ?v1)) (f12 ?v_0 (f16 (f19 ?v_1) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f43 (f16 (f17 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S13)) (let ((?v_0 (f20 f21 ?v1)) (?v_1 (f23 f24 ?v3)) (?v_2 (f19 ?v0))) (=> (<= (f20 f21 ?v0) ?v_0) (=> (<= ?v_0 (f20 f21 ?v2)) (= (- (f22 ?v_1 (f16 ?v_2 ?v2)) (f22 ?v_1 (f16 ?v_2 ?v1))) (f22 ?v_1 (f16 (f19 ?v1) ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S13) (?v3 S8)) (let ((?v_0 (f20 f21 ?v1))) (let ((?v_3 (+ ?v_0 1)) (?v_1 (f23 f24 ?v2)) (?v_2 (f44 ?v0)) (?v_4 (f31 f32 (+ ?v_0 (f20 f21 ?v3))))) (=> (<= (f20 f21 ?v0) ?v_3) (= (f22 ?v_1 (f16 ?v_2 ?v_4)) (+ (f22 ?v_1 (f16 ?v_2 ?v1)) (f22 ?v_1 (f16 (f44 (f31 f32 ?v_3)) ?v_4)))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S7) (?v3 S8)) (let ((?v_0 (f20 f21 ?v1))) (let ((?v_3 (+ ?v_0 1)) (?v_1 (f13 f14 ?v2)) (?v_2 (f44 ?v0)) (?v_4 (f31 f32 (+ ?v_0 (f20 f21 ?v3))))) (=> (<= (f20 f21 ?v0) ?v_3) (= (f12 ?v_1 (f16 ?v_2 ?v_4)) (f6 (f7 f8 (f12 ?v_1 (f16 ?v_2 ?v1))) (f12 ?v_1 (f16 (f44 (f31 f32 ?v_3)) ?v_4)))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S16) (?v3 S8)) (let ((?v_0 (f20 f21 ?v1))) (let ((?v_3 (+ ?v_0 1)) (?v_1 (f29 f30 ?v2)) (?v_2 (f44 ?v0)) (?v_4 (f31 f32 (+ ?v_0 (f20 f21 ?v3))))) (=> (<= (f20 f21 ?v0) ?v_3) (= (f28 ?v_1 (f16 ?v_2 ?v_4)) (f25 (f26 f27 (f28 ?v_1 (f16 ?v_2 ?v1))) (f28 ?v_1 (f16 (f44 (f31 f32 ?v_3)) ?v_4)))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S13)) (let ((?v_1 (f20 f21 ?v0)) (?v_0 (f23 f24 ?v2))) (=> (<= ?v_1 (f20 f21 ?v1)) (= (f22 ?v_0 (f16 (f44 ?v0) ?v1)) (+ (f20 ?v2 ?v0) (f22 ?v_0 (f16 (f44 (f31 f32 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S7)) (let ((?v_1 (f20 f21 ?v0)) (?v_0 (f13 f14 ?v2))) (=> (<= ?v_1 (f20 f21 ?v1)) (= (f12 ?v_0 (f16 (f44 ?v0) ?v1)) (f6 (f7 f8 (f9 ?v2 ?v0)) (f12 ?v_0 (f16 (f44 (f31 f32 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S16)) (let ((?v_1 (f20 f21 ?v0)) (?v_0 (f29 f30 ?v2))) (=> (<= ?v_1 (f20 f21 ?v1)) (= (f28 ?v_0 (f16 (f44 ?v0) ?v1)) (f25 (f26 f27 (f25 ?v2 ?v0)) (f28 ?v_0 (f16 (f44 (f31 f32 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S12) (?v2 S8)) (= (= (f34 ?v0 (f16 (f45 ?v1) ?v2)) f1) (= (f33 (f16 ?v1 ?v0) ?v2) f1))))
(assert (forall ((?v0 S8) (?v1 S12) (?v2 S8)) (= (= (f34 ?v0 (f16 (f46 ?v1) ?v2)) f1) (= (f33 (f16 ?v1 ?v2) ?v0) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f43 (f16 (f19 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f43 (f16 (f44 ?v0) ?v1)) f1)))
(assert (= (f3 f35 0) 0))
(assert (forall ((?v0 S10)) (= (= (f43 ?v0) f1) (exists ((?v1 S8)) (forall ((?v2 S8)) (=> (= (f34 ?v2 ?v0) f1) (< (f20 f21 ?v2) (f20 f21 ?v1))))))))
(assert (forall ((?v0 S10)) (= (= (f43 ?v0) f1) (exists ((?v1 S8)) (forall ((?v2 S8)) (=> (= (f34 ?v2 ?v0) f1) (<= (f20 f21 ?v2) (f20 f21 ?v1))))))))
(assert (forall ((?v0 S8) (?v1 S10)) (= (exists ((?v2 S8)) (and (<= (f20 f21 ?v2) (f20 f21 ?v0)) (= (f33 ?v1 ?v2) f1))) (exists ((?v2 S8)) (and (= (f34 ?v2 (f16 (f44 (f31 f32 0)) ?v0)) f1) (= (f33 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S8) (?v1 S10)) (= (forall ((?v2 S8)) (=> (<= (f20 f21 ?v2) (f20 f21 ?v0)) (= (f33 ?v1 ?v2) f1))) (forall ((?v2 S8)) (=> (= (f34 ?v2 (f16 (f44 (f31 f32 0)) ?v0)) f1) (= (f33 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f35 (- ?v0 ?v1)) (f3 f35 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S8)) (= (= f42 ?v0) (= ?v0 f42))))
(assert (forall ((?v0 S5)) (= (= f41 ?v0) (= ?v0 f41))))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 Int)) (= (= (f3 f35 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f38 ?v0) ?v1) ?v2) (f3 (f4 f38 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f36 ?v0) ?v1) ?v2) (f3 (f4 f36 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S16) (?v1 S8)) (let ((?v_0 (f31 f32 0)) (?v_1 (f29 f30 ?v0))) (=> (= (f25 ?v0 ?v_0) ?v_0) (= (f28 ?v_1 (f16 (f44 (f31 f32 (+ 0 1))) ?v1)) (f28 ?v_1 (f16 (f44 ?v_0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S13) (?v1 S8) (?v2 S8)) (let ((?v_1 (f23 f24 ?v0)) (?v_2 (f44 ?v1)) (?v_0 (+ (f20 f21 ?v2) 1))) (let ((?v_3 (f31 f32 ?v_0))) (= (f22 ?v_1 (f16 ?v_2 ?v_3)) (ite (< ?v_0 (f20 f21 ?v1)) 0 (+ (f22 ?v_1 (f16 ?v_2 ?v2)) (f20 ?v0 ?v_3))))))))
(assert (forall ((?v0 S7) (?v1 S8) (?v2 S8)) (let ((?v_1 (f13 f14 ?v0)) (?v_2 (f44 ?v1)) (?v_0 (+ (f20 f21 ?v2) 1))) (let ((?v_3 (f31 f32 ?v_0))) (= (f12 ?v_1 (f16 ?v_2 ?v_3)) (ite (< ?v_0 (f20 f21 ?v1)) f41 (f6 (f7 f8 (f12 ?v_1 (f16 ?v_2 ?v2))) (f9 ?v0 ?v_3))))))))
(assert (forall ((?v0 S16) (?v1 S8) (?v2 S8)) (let ((?v_1 (f29 f30 ?v0)) (?v_2 (f44 ?v1)) (?v_0 (+ (f20 f21 ?v2) 1))) (let ((?v_3 (f31 f32 ?v_0))) (= (f28 ?v_1 (f16 ?v_2 ?v_3)) (ite (< ?v_0 (f20 f21 ?v1)) f42 (f25 (f26 f27 (f28 ?v_1 (f16 ?v_2 ?v2))) (f25 ?v0 ?v_3))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f16 (f19 ?v0) (f31 f32 (+ (f20 f21 ?v1) 1))) (f16 (f44 ?v0) ?v1))))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f41) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 f42) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 f42) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f41) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 f42) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f41) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 ?v0) f42) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 ?v0) f42) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f41) ?v0)))
(assert (forall ((?v0 S8)) (= (f25 (f26 f27 ?v0) f42) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= ?v0 (f25 (f26 f27 ?v0) ?v1)) (= ?v1 f42))))
(assert (forall ((?v0 S8)) (= (f31 f32 (f20 f21 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f20 f21 (f31 f32 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f20 f21 (f31 f32 ?v0)) 0))))
(check-sat)
(exit)
