(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S3)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 S6) S3)
(declare-fun f7 (S7 S8) S5)
(declare-fun f8 () S7)
(declare-fun f9 () S8)
(declare-fun f10 (S9 S10) S6)
(declare-fun f11 (S10) S9)
(declare-fun f12 () S10)
(declare-fun f13 () S10)
(declare-fun f14 () S8)
(declare-fun f15 () S10)
(declare-fun f16 () S8)
(declare-fun f17 (S11 S10) Int)
(declare-fun f18 () S11)
(declare-fun f19 (S8 S10) S3)
(declare-fun f20 (S12 S6) Int)
(declare-fun f21 (S13 S11) S12)
(declare-fun f22 () S13)
(declare-fun f23 (S14 Int) S10)
(declare-fun f24 () S14)
(declare-fun f25 (S10) S9)
(declare-fun f26 (S6 S10) S1)
(declare-fun f27 (S10 S6) S1)
(declare-fun f28 (S15 Int) Int)
(declare-fun f29 () S15)
(declare-fun f30 (S16 Int) S15)
(declare-fun f31 () S16)
(declare-fun f32 () S16)
(declare-fun f33 (S6) S9)
(declare-fun f34 () S3)
(declare-fun f35 (S6) S1)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f11 f12))) (not (= (f3 (f4 f5 (f6 (f7 f8 f9) (f10 ?v_0 f13))) (f6 (f7 f8 f14) (f10 (f11 f13) f15))) (f6 (f7 f8 f16) (f10 ?v_0 f15))))))
(assert (<= (f17 f18 f12) (f17 f18 f13)))
(assert (<= (f17 f18 f13) (f17 f18 f15)))
(assert (forall ((?v0 S10)) (let ((?v_0 (f17 f18 ?v0))) (=> (<= (f17 f18 f12) ?v_0) (=> (< ?v_0 (f17 f18 f13)) (= (f19 f9 ?v0) (f19 f16 ?v0)))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f17 f18 ?v0))) (=> (<= (f17 f18 f13) ?v_0) (=> (< ?v_0 (f17 f18 f15)) (= (f19 f14 ?v0) (f19 f16 ?v0)))))))
(assert (<= (f17 f18 f13) (f17 f18 f15)))
(assert (<= (f17 f18 f12) (f17 f18 f13)))
(assert (forall ((?v0 S10)) (let ((?v_0 (f17 f18 ?v0))) (=> (<= (f17 f18 f13) ?v_0) (=> (< ?v_0 (f17 f18 f15)) (= (f19 f14 ?v0) (f19 f16 ?v0)))))))
(assert (forall ((?v0 S10)) (let ((?v_0 (f17 f18 ?v0))) (=> (<= (f17 f18 f12) ?v_0) (=> (< ?v_0 (f17 f18 f13)) (= (f19 f9 ?v0) (f19 f16 ?v0)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S11)) (let ((?v_1 (f17 f18 ?v0)) (?v_0 (f21 f22 ?v2))) (=> (< ?v_1 (f17 f18 ?v1)) (= (f20 ?v_0 (f10 (f11 ?v0) ?v1)) (+ (f17 ?v2 ?v0) (f20 ?v_0 (f10 (f11 (f23 f24 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S8)) (let ((?v_1 (f17 f18 ?v0)) (?v_0 (f7 f8 ?v2))) (=> (< ?v_1 (f17 f18 ?v1)) (= (f6 ?v_0 (f10 (f11 ?v0) ?v1)) (f3 (f4 f5 (f19 ?v2 ?v0)) (f6 ?v_0 (f10 (f11 (f23 f24 (+ ?v_1 1))) ?v1))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S11)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f21 f22 ?v3)) (?v_2 (f11 ?v0))) (=> (<= (f17 f18 ?v0) ?v_0) (=> (<= ?v_0 (f17 f18 ?v2)) (= (+ (f20 ?v_1 (f10 ?v_2 ?v1)) (f20 ?v_1 (f10 (f11 ?v1) ?v2))) (f20 ?v_1 (f10 ?v_2 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S8)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f7 f8 ?v3)) (?v_2 (f11 ?v0))) (=> (<= (f17 f18 ?v0) ?v_0) (=> (<= ?v_0 (f17 f18 ?v2)) (= (f3 (f4 f5 (f6 ?v_1 (f10 ?v_2 ?v1))) (f6 ?v_1 (f10 (f11 ?v1) ?v2))) (f6 ?v_1 (f10 ?v_2 ?v2))))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S11)) (let ((?v_0 (f21 f22 ?v2))) (=> (< (f17 f18 ?v0) (f17 f18 ?v1)) (= (+ (f17 ?v2 ?v0) (f20 ?v_0 (f10 (f25 ?v0) ?v1))) (f20 ?v_0 (f10 (f11 ?v0) ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S8)) (let ((?v_0 (f7 f8 ?v2))) (=> (< (f17 f18 ?v0) (f17 f18 ?v1)) (= (f3 (f4 f5 (f19 ?v2 ?v0)) (f6 ?v_0 (f10 (f25 ?v0) ?v1))) (f6 ?v_0 (f10 (f11 ?v0) ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S6)) (= (exists ((?v2 S10)) (and (< (f17 f18 ?v2) (f17 f18 ?v0)) (= (f26 ?v1 ?v2) f1))) (exists ((?v2 S10)) (and (= (f27 ?v2 (f10 (f11 (f23 f24 0)) ?v0)) f1) (= (f26 ?v1 ?v2) f1))))))
(assert (forall ((?v0 S10) (?v1 S6)) (= (forall ((?v2 S10)) (=> (< (f17 f18 ?v2) (f17 f18 ?v0)) (= (f26 ?v1 ?v2) f1))) (forall ((?v2 S10)) (=> (= (f27 ?v2 (f10 (f11 (f23 f24 0)) ?v0)) f1) (= (f26 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f28 f29 ?v0) (f28 f29 ?v1)))) (= (f28 f29 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f5 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f10 (f11 (f23 f24 (+ (f17 f18 ?v0) 1))) ?v1) (f10 (f25 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f28 (f30 f31 ?v0) ?v1) ?v2) (f28 (f30 f31 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f28 (f30 f32 ?v0) ?v1) ?v2) (f28 (f30 f32 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S11) (?v3 S11)) (=> (< (f17 f18 ?v0) (f17 f18 ?v1)) (=> (forall ((?v4 S10)) (let ((?v_0 (f17 f18 ?v4))) (=> (< (f17 f18 ?v0) ?v_0) (=> (< ?v_0 (f17 f18 ?v1)) (= (f17 ?v2 ?v4) (f17 ?v3 ?v4)))))) (= (+ (f17 ?v3 ?v0) (f20 (f21 f22 ?v2) (f10 (f25 ?v0) ?v1))) (f20 (f21 f22 ?v3) (f10 (f11 ?v0) ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S8) (?v3 S8)) (=> (< (f17 f18 ?v0) (f17 f18 ?v1)) (=> (forall ((?v4 S10)) (let ((?v_0 (f17 f18 ?v4))) (=> (< (f17 f18 ?v0) ?v_0) (=> (< ?v_0 (f17 f18 ?v1)) (= (f19 ?v2 ?v4) (f19 ?v3 ?v4)))))) (= (f3 (f4 f5 (f19 ?v3 ?v0)) (f6 (f7 f8 ?v2) (f10 (f25 ?v0) ?v1))) (f6 (f7 f8 ?v3) (f10 (f11 ?v0) ?v1)))))))
(assert (forall ((?v0 S6) (?v1 S10) (?v2 S10)) (= (= (f26 (f10 (f33 ?v0) ?v1) ?v2) f1) (forall ((?v3 S10)) (=> (= (f27 ?v3 (f10 (f11 ?v1) ?v2)) f1) (= (f26 ?v0 ?v3) f1))))))
(assert (forall ((?v0 S11) (?v1 S10) (?v2 S10)) (let ((?v_1 (f21 f22 ?v0)) (?v_2 (f11 ?v1)) (?v_0 (f17 f18 ?v2))) (= (f20 ?v_1 (f10 ?v_2 (f23 f24 (+ ?v_0 1)))) (ite (< ?v_0 (f17 f18 ?v1)) 0 (+ (f20 ?v_1 (f10 ?v_2 ?v2)) (f17 ?v0 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S10) (?v2 S10)) (let ((?v_1 (f7 f8 ?v0)) (?v_2 (f11 ?v1)) (?v_0 (f17 f18 ?v2))) (= (f6 ?v_1 (f10 ?v_2 (f23 f24 (+ ?v_0 1)))) (ite (< ?v_0 (f17 f18 ?v1)) f34 (f3 (f4 f5 (f6 ?v_1 (f10 ?v_2 ?v2))) (f19 ?v0 ?v2)))))))
(assert (forall ((?v0 S11) (?v1 S10)) (let ((?v_1 (f23 f24 0)) (?v_0 (f21 f22 ?v0))) (=> (= (f17 ?v0 ?v_1) 0) (= (f20 ?v_0 (f10 (f11 (f23 f24 (+ 0 1))) ?v1)) (f20 ?v_0 (f10 (f11 ?v_1) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S10)) (let ((?v_1 (f23 f24 0)) (?v_0 (f7 f8 ?v0))) (=> (= (f19 ?v0 ?v_1) f34) (= (f6 ?v_0 (f10 (f11 (f23 f24 (+ 0 1))) ?v1)) (f6 ?v_0 (f10 (f11 ?v_1) ?v1)))))))
(assert (forall ((?v0 S10) (?v1 S10)) (= (f35 (f10 (f25 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S11)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f21 f22 ?v3)) (?v_2 (f11 ?v0))) (=> (<= (f17 f18 ?v0) ?v_0) (=> (<= ?v_0 (f17 f18 ?v2)) (= (- (f20 ?v_1 (f10 ?v_2 ?v2)) (f20 ?v_1 (f10 ?v_2 ?v1))) (f20 ?v_1 (f10 (f11 ?v1) ?v2))))))))
(assert (forall ((?v0 S10)) (= (f23 f24 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f23 f24 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f23 f24 ?v0)) 0))))
(check-sat)
(exit)
