(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 () S3)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S2) Int)
(declare-fun f8 () S5)
(declare-fun f9 () S3)
(declare-fun f10 (S6 S2) S3)
(declare-fun f11 () S6)
(declare-fun f12 (S7 Int) Int)
(declare-fun f13 (S8 Int) S7)
(declare-fun f14 () S8)
(declare-fun f15 () S6)
(declare-fun f16 () S6)
(declare-fun f17 () S3)
(declare-fun f18 (S9 S2) S1)
(declare-fun f19 () S9)
(declare-fun f20 (S10 Int) S1)
(declare-fun f21 () S10)
(declare-fun f22 (S3 S9) S1)
(declare-fun f23 () S9)
(declare-fun f24 (S2 S9) S1)
(declare-fun f25 (S5 S9) S1)
(declare-fun f26 () S7)
(declare-fun f27 (Int S10) S1)
(declare-fun f28 (S9) S9)
(declare-fun f29 () S6)
(declare-fun f30 (S5) S1)
(declare-fun f31 (S3) S1)
(declare-fun f32 () S9)
(declare-fun f33 () S10)
(declare-fun f34 (S11 Int) S3)
(declare-fun f35 () S11)
(declare-fun f36 () S6)
(declare-fun f37 (S12 Int) S5)
(declare-fun f38 () S12)
(declare-fun f39 (S3) S1)
(declare-fun f40 (S5) S1)
(declare-fun f41 () S7)
(declare-fun f42 () S3)
(declare-fun f43 () S8)
(declare-fun f44 () S6)
(declare-fun f45 () S8)
(declare-fun f46 () S6)
(declare-fun f47 (S13 S5) S5)
(declare-fun f48 () S13)
(declare-fun f49 () S9)
(declare-fun f50 () S1)
(declare-fun f51 () S10)
(declare-fun f52 (S10) S10)
(declare-fun f53 (S14 S5) S4)
(declare-fun f54 (S15 S9) S14)
(declare-fun f55 () S15)
(declare-fun f56 (S16 S3) S3)
(declare-fun f57 (S17 S9) S16)
(declare-fun f58 () S17)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 f6 (* 2 (f7 f8 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 f9 ?v0) (f5 f6 (+ (f7 f8 ?v0) 1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f10 f11 ?v0) ?v1) (f5 f6 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f10 f15 ?v0) ?v1) (f5 f6 (- (f7 f8 ?v1) (f7 f8 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f10 f16 ?v0) ?v1) (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v0))))))
(assert (forall ((?v0 S2)) (= (f3 f17 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (= (f18 f19 ?v0) f1) true)))
(assert (forall ((?v0 Int)) (= (= (f20 f21 ?v0) f1) true)))
(assert (not (= (f22 f4 f23) f1)))
(assert (forall ((?v0 S2) (?v1 S9)) (= (f22 (f10 f16 ?v0) ?v1) f1)))
(assert (forall ((?v0 S9)) (= (f22 f9 ?v0) f1)))
(assert (forall ((?v0 S9)) (= (f22 f17 ?v0) f1)))
(assert (forall ((?v0 S9) (?v1 S2)) (=> (forall ((?v2 S2)) (=> (= (f24 ?v2 ?v0) f1) (<= (f7 f8 ?v1) (f7 f8 ?v2)))) (= (f22 (f10 f15 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S9)) (= (= (f25 ?v0 ?v1) f1) (forall ((?v2 S2)) (=> (= (f24 ?v2 ?v1) f1) (forall ((?v3 S2)) (=> (= (f24 ?v3 ?v1) f1) (=> (= (f7 ?v0 ?v2) (f7 ?v0 ?v3)) (= ?v2 ?v3)))))))))
(assert (forall ((?v0 S3) (?v1 S9)) (= (= (f22 ?v0 ?v1) f1) (forall ((?v2 S2)) (=> (= (f24 ?v2 ?v1) f1) (forall ((?v3 S2)) (=> (= (f24 ?v3 ?v1) f1) (=> (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)) (= ?v2 ?v3)))))))))
(assert (forall ((?v0 S5) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= (f25 ?v0 ?v1) f1) (=> (not (= ?v2 ?v3)) (=> (= (f24 ?v2 ?v1) f1) (=> (= (f24 ?v3 ?v1) f1) (not (= (f7 ?v0 ?v2) (f7 ?v0 ?v3)))))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= (f22 ?v0 ?v1) f1) (=> (not (= ?v2 ?v3)) (=> (= (f24 ?v2 ?v1) f1) (=> (= (f24 ?v3 ?v1) f1) (not (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)))))))))
(assert (forall ((?v0 S5) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= (f25 ?v0 ?v1) f1) (=> (= (f24 ?v2 ?v1) f1) (=> (= (f24 ?v3 ?v1) f1) (= (= (f7 ?v0 ?v2) (f7 ?v0 ?v3)) (= ?v2 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f24 ?v2 ?v1) f1) (=> (= (f24 ?v3 ?v1) f1) (= (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)) (= ?v2 ?v3)))))))
(assert (forall ((?v0 S5) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= (f25 ?v0 ?v1) f1) (=> (= (f7 ?v0 ?v2) (f7 ?v0 ?v3)) (=> (= (f24 ?v2 ?v1) f1) (=> (= (f24 ?v3 ?v1) f1) (= ?v2 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f3 ?v0 ?v2) (f3 ?v0 ?v3)) (=> (= (f24 ?v2 ?v1) f1) (=> (= (f24 ?v3 ?v1) f1) (= ?v2 ?v3)))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (<= ?v_0 (f12 (f13 f14 ?v_0) ?v_0)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f13 f14 ?v_0))) (<= ?v_0 (f12 ?v_1 (f12 ?v_1 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f5 f6 (* 0 (f7 f8 ?v0))) (f5 f6 0))))
(assert (forall ((?v0 S2)) (= (f5 f6 (* 1 (f7 f8 ?v0))) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_2 (f7 f8 ?v0)) (?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f12 (f13 f14 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f12 (f13 f14 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f12 (f13 f14 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= ?v0 (f5 f6 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) (or (= ?v1 (f5 f6 1)) (= ?v0 (f5 f6 0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_3 (f7 f8 ?v3)) (?v_1 (f7 f8 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f12 (f13 f14 ?v_0) ?v_1) (f12 (f13 f14 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_3 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v2))) (let ((?v_2 (f13 f14 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f12 ?v_2 ?v_1) (f12 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f12 (f13 f14 ?v_0) ?v_1) (f12 (f13 f14 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f13 f14 (f7 f8 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f12 ?v_1 ?v_0) (f12 ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f12 (f13 f14 ?v_0) ?v_2) (f12 (f13 f14 ?v_1) ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 (+ (f7 f8 ?v0) 1))) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (<= (f12 ?v_0 ?v_1) (f12 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 (+ (f7 f8 ?v0) 1))) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (< (f12 ?v_0 ?v_1) (f12 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 (+ (f7 f8 ?v0) 1)))) (= (= (f5 f6 (f12 ?v_0 (f7 f8 ?v1))) (f5 f6 (f12 ?v_0 (f7 f8 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v1))) (= (= (f5 f6 (f12 (f13 f14 (f7 f8 ?v0)) ?v_0)) (f5 f6 (f12 (f13 f14 (f7 f8 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f5 f6 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 (f7 f8 ?v0)))) (= (= (f5 f6 (f12 ?v_0 (f7 f8 ?v1))) (f5 f6 (f12 ?v_0 (f7 f8 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f5 f6 0)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v2)) (?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (<= (f12 (f13 f14 ?v_1) ?v_0) (f12 (f13 f14 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f7 f8 ?v0))) (let ((?v_0 (f13 f14 ?v_1)) (?v_3 (f7 f8 ?v2)) (?v_2 (f7 f8 ?v1))) (= (<= (f12 ?v_0 ?v_2) (f12 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v2)) (?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0))) (= (< (f12 (f13 f14 ?v_1) ?v_0) (f12 (f13 f14 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f7 f8 ?v0))) (let ((?v_0 (f13 f14 ?v_1)) (?v_3 (f7 f8 ?v2)) (?v_2 (f7 f8 ?v1))) (= (< (f12 ?v_0 ?v_2) (f12 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 (+ 0 1)))) (= (= (f5 f6 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_2 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v2))) (= (f5 f6 (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v_0 ?v_2)))) ?v_1)) (f5 f6 (- (f12 (f13 f14 ?v_0) ?v_1) (f12 (f13 f14 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v2))) (= (f5 f6 (f12 (f13 f14 (+ ?v_0 ?v_2)) ?v_1)) (f5 f6 (+ (f12 (f13 f14 ?v_0) ?v_1) (f12 (f13 f14 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 (f7 f8 ?v0))) (?v_1 (f7 f8 ?v1)) (?v_2 (f7 f8 ?v2))) (= (f5 f6 (f12 (f13 f14 (f12 ?v_0 ?v_1)) ?v_2)) (f5 f6 (f12 ?v_0 (f12 (f13 f14 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 0))) (= (= (f5 f6 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 1))) (= (= (f5 f6 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f5 f6 (f12 (f13 f14 (+ ?v_1 1)) ?v_0)) (f5 f6 (+ ?v_0 (f12 (f13 f14 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v1))) (= (<= ?v_0 (f12 (f13 f14 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 (f7 f8 ?v0))) (?v_2 (f7 f8 ?v2)) (?v_1 (f7 f8 ?v1))) (= (f5 f6 (f12 ?v_0 (f7 f8 (f5 f6 (- ?v_1 ?v_2))))) (f5 f6 (- (f12 ?v_0 ?v_1) (f12 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 (f7 f8 ?v0))) (?v_1 (f7 f8 ?v1)) (?v_2 (f7 f8 ?v2))) (= (f5 f6 (f12 ?v_0 (+ ?v_1 ?v_2))) (f5 f6 (+ (f12 ?v_0 ?v_1) (f12 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f13 f14 ?v_0)) (?v_2 (f7 f8 ?v1))) (= (f5 f6 (f12 ?v_1 (+ ?v_2 1))) (f5 f6 (+ ?v_0 (f12 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f5 f6 (f12 (f13 f14 ?v_1) ?v_0)) (f5 f6 (f12 (f13 f14 ?v_0) ?v_1))))))
(assert (forall ((?v0 S2)) (= (f5 f6 (* (f7 f8 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f5 f6 (* (f7 f8 ?v0) 0)) (f5 f6 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 1))) (= (= ?v_0 (f5 f6 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1))) (= (< 0 (f12 (f13 f14 ?v_0) ?v_1)) (and (< 0 ?v_0) (< 0 ?v_1))))))
(assert (forall ((?v0 S9) (?v1 S4) (?v2 S5)) (=> (forall ((?v3 S2)) (=> (= (f24 ?v3 ?v0) f1) (= (f5 ?v1 (f7 ?v2 ?v3)) ?v3))) (= (f25 ?v2 ?v0) f1))))
(assert (forall ((?v0 S9) (?v1 S3) (?v2 S3)) (=> (forall ((?v3 S2)) (=> (= (f24 ?v3 ?v0) f1) (= (f3 ?v1 (f3 ?v2 ?v3)) ?v3))) (= (f22 ?v2 ?v0) f1))))
(assert (forall ((?v0 S9) (?v1 S5) (?v2 S5)) (=> (forall ((?v3 S2)) (=> (= (f24 ?v3 ?v0) f1) (= (f7 ?v1 ?v3) (f7 ?v2 ?v3)))) (= (= (f25 ?v1 ?v0) f1) (= (f25 ?v2 ?v0) f1)))))
(assert (forall ((?v0 S9) (?v1 S3) (?v2 S3)) (=> (forall ((?v3 S2)) (=> (= (f24 ?v3 ?v0) f1) (= (f3 ?v1 ?v3) (f3 ?v2 ?v3)))) (= (= (f22 ?v1 ?v0) f1) (= (f22 ?v2 ?v0) f1)))))
(assert (forall ((?v0 S9) (?v1 S5)) (=> (forall ((?v2 S2) (?v3 S2)) (=> (= (f24 ?v2 ?v0) f1) (=> (= (f24 ?v3 ?v0) f1) (=> (= (f7 ?v1 ?v2) (f7 ?v1 ?v3)) (= ?v2 ?v3))))) (= (f25 ?v1 ?v0) f1))))
(assert (forall ((?v0 S9) (?v1 S3)) (=> (forall ((?v2 S2) (?v3 S2)) (=> (= (f24 ?v2 ?v0) f1) (=> (= (f24 ?v3 ?v0) f1) (=> (= (f3 ?v1 ?v2) (f3 ?v1 ?v3)) (= ?v2 ?v3))))) (= (f22 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_1 ?v_0) (= (<= (+ (f12 (f13 f14 ?v_0) ?v_2) ?v_3) (+ (f12 (f13 f14 ?v_1) ?v_2) ?v_4)) (<= (+ (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_1 ?v_0) (= (< (+ (f12 (f13 f14 ?v_0) ?v_2) ?v_3) (+ (f12 (f13 f14 ?v_1) ?v_2) ?v_4)) (< (+ (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_1 ?v_0) (= (f5 f6 (- (+ (f12 (f13 f14 ?v_0) ?v_2) ?v_3) (+ (f12 (f13 f14 ?v_1) ?v_2) ?v_4))) (f5 f6 (- (+ (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v_0 ?v_1)))) ?v_2) ?v_3) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_1 ?v_0) (= (= (f5 f6 (+ (f12 (f13 f14 ?v_0) ?v_2) ?v_3)) (f5 f6 (+ (f12 (f13 f14 ?v_1) ?v_2) (f7 f8 ?v4)))) (= (f5 f6 (+ (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v_0 ?v_1)))) ?v_2) ?v_3)) ?v4))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_0 ?v_1) (= (<= (+ (f12 (f13 f14 ?v_0) ?v_2) ?v_3) (+ (f12 (f13 f14 ?v_1) ?v_2) ?v_4)) (<= ?v_3 (+ (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v_1 ?v_0)))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_0 ?v_1) (= (< (+ (f12 (f13 f14 ?v_0) ?v_2) ?v_3) (+ (f12 (f13 f14 ?v_1) ?v_2) ?v_4)) (< ?v_3 (+ (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v_1 ?v_0)))) ?v_2) ?v_4)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_4 (f7 f8 ?v4)) (?v_3 (f7 f8 ?v3))) (=> (<= ?v_0 ?v_1) (= (f5 f6 (- (+ (f12 (f13 f14 ?v_0) ?v_2) ?v_3) (+ (f12 (f13 f14 ?v_1) ?v_2) ?v_4))) (f5 f6 (- ?v_3 (+ (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v_1 ?v_0)))) ?v_2) ?v_4))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_1 (f7 f8 ?v1)) (?v_0 (f7 f8 ?v0)) (?v_2 (f7 f8 ?v2)) (?v_3 (f7 f8 ?v4))) (=> (<= ?v_0 ?v_1) (= (= (f5 f6 (+ (f12 (f13 f14 ?v_0) ?v_2) (f7 f8 ?v3))) (f5 f6 (+ (f12 (f13 f14 ?v_1) ?v_2) ?v_3))) (= ?v3 (f5 f6 (+ (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v_1 ?v_0)))) ?v_2) ?v_3))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f13 f14 (f7 f8 ?v0)))) (= (= (f5 f6 (f12 ?v_0 (f7 f8 ?v1))) (f5 f6 (f12 ?v_0 (f7 f8 ?v2)))) (or (= ?v0 (f5 f6 0)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1)) (?v_2 (f7 f8 ?v2)) (?v_3 (f7 f8 ?v3))) (= (f5 f6 (+ (f12 (f13 f14 ?v_1) ?v_0) (+ (f12 (f13 f14 ?v_2) ?v_0) ?v_3))) (f5 f6 (+ (f12 (f13 f14 (+ ?v_1 ?v_2)) ?v_0) ?v_3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f13 f14 ?v_0))) (=> (< 0 ?v_0) (= (= (f5 f6 (f12 ?v_1 (f7 f8 ?v1))) (f5 f6 (f12 ?v_1 (f7 f8 ?v2)))) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f13 f14 ?v_0)) (?v_3 (f7 f8 ?v2)) (?v_2 (f7 f8 ?v1))) (=> (< 0 ?v_0) (= (< (f12 ?v_1 ?v_2) (f12 ?v_1 ?v_3)) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v0))) (let ((?v_1 (f13 f14 ?v_0)) (?v_3 (f7 f8 ?v2)) (?v_2 (f7 f8 ?v1))) (=> (< 0 ?v_0) (= (<= (f12 ?v_1 ?v_2) (f12 ?v_1 ?v_3)) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 0)) (?v_2 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1))) (= (f5 f6 (f12 (f13 f14 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f5 f6 (+ ?v_1 (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (f5 f6 (* ?v_0 2)) (f5 f6 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (f5 f6 (* 2 ?v_0)) (f5 f6 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f7 f8 ?v0)))) (=> (not (= ?v0 (f5 f6 0))) (= (f5 f6 (+ (+ (f7 f8 (f5 f6 (- ?v_0 2))) 1) 1)) (f5 f6 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 4 (f7 f8 ?v0)))) (=> (not (= ?v0 (f5 f6 0))) (= (f5 f6 (+ (+ (f7 f8 (f5 f6 (- ?v_0 2))) 1) 1)) (f5 f6 ?v_0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (* 2 (f7 f8 ?v0)))) (=> (not (= ?v0 (f5 f6 0))) (= (f5 f6 (+ (f7 f8 (f5 f6 (- ?v_0 1))) 1)) (f5 f6 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 f26 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f14 (f12 f26 ?v0)) (f12 f26 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f26 ?v0))) (= (f12 (f13 f14 ?v_0) ?v_0) (f12 (f13 f14 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (= (f5 f6 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f5 f6 (f12 (f13 f14 (f7 f8 (f5 f6 (ite (< ?v0 0) (- ?v0) ?v0)))) (f7 f8 (f5 f6 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f5 f6 (f12 (f13 f14 ?v0) ?v1)) (f5 f6 (f12 (f13 f14 (f7 f8 (f5 f6 ?v0))) (f7 f8 (f5 f6 ?v1))))))))
(assert (forall ((?v0 S2) (?v1 S9)) (= (= (f24 ?v0 ?v1) f1) (= (f18 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (= (f27 ?v0 ?v1) f1) (= (f20 ?v1 ?v0) f1))))
(assert (forall ((?v0 S9)) (= (f28 ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f5 f6 (f12 (f13 f14 (f7 f8 (f5 f6 ?v0))) (f7 f8 (f5 f6 ?v1)))) (f5 f6 (f12 (f13 f14 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 ?v0) ?v1) (f12 (f13 f14 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (+ ?v1 ?v2)) (+ (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (- ?v1 ?v2)) (- (f12 ?v_0 ?v1) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 (- ?v0)) ?v1) (- (f12 (f13 f14 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 (f13 f14 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f14 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f12 (f13 f14 (+ ?v0 ?v1)) ?v2) (+ (f12 (f13 f14 ?v0) ?v2) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f12 (f13 f14 (- ?v0 ?v1)) ?v2) (- (f12 (f13 f14 ?v0) ?v2) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f12 (f13 f14 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f12 (f13 f14 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f12 ?v_0 ?v0) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (let ((?v_0 (f7 f8 ?v2))) (let ((?v_1 (f13 f14 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f12 ?v_1 ?v0) (f12 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f12 (f13 f14 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f5 f6 (f12 (f13 f14 ?v0) ?v1)) (f5 f6 (f12 (f13 f14 (f7 f8 (f5 f6 (- ?v0)))) (f7 f8 (f5 f6 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f12 (f13 f14 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f12 (f13 f14 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f12 (f13 f14 ?v0) ?v2))) (=> (<= 0 ?v1) (<= ?v2 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (= ?v0 (+ ?v1 (f12 (f13 f14 ?v0) ?v2))) (=> (< ?v1 ?v0) (<= 1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 (+ (f12 (f13 f14 ?v0) ?v1) ?v2)) (=> (< ?v2 ?v0) (=> (< 0 ?v0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ (f12 (f13 f14 ?v0) ?v1) ?v2) 0) (=> (<= 0 ?v2) (=> (< 0 ?v0) (<= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f12 (f13 f14 ?v3) ?v4) ?v5))) (=> (= (+ (f12 (f13 f14 ?v0) ?v1) ?v2) ?v_0) (=> (< ?v_0 0) (=> (< ?v2 ?v0) (=> (<= 0 ?v5) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v4 ?v1))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f13 f14 ?v0))) (=> (<= (+ (f12 ?v_0 ?v1) ?v2) (+ (f12 ?v_0 ?v3) ?v4)) (=> (<= ?v4 0) (=> (< ?v0 ?v4) (=> (< ?v0 ?v2) (<= ?v3 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int)) (let ((?v_0 (+ (f12 (f13 f14 ?v3) ?v4) ?v5))) (=> (= (+ (f12 (f13 f14 ?v0) ?v1) ?v2) ?v_0) (=> (<= 0 ?v_0) (=> (< ?v5 ?v3) (=> (<= 0 ?v2) (=> (< 0 ?v3) (=> (<= ?v3 ?v0) (<= ?v1 ?v4))))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f13 f14 ?v0))) (=> (<= (+ (f12 ?v_0 ?v1) ?v2) (+ (f12 ?v_0 ?v3) ?v4)) (=> (<= 0 ?v2) (=> (< ?v2 ?v0) (=> (< ?v4 ?v0) (<= ?v1 ?v3))))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (- ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (- ?v3 (f12 (f13 f14 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (< 0 ?v0) (=> (forall ((?v3 Int)) (=> (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (+ ?v3 ?v0)) f1))) (=> (<= 0 ?v2) (forall ((?v3 Int)) (=> (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (+ ?v3 (f12 (f13 f14 ?v2) ?v0))) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) (f12 (f13 f14 ?v2) ?v3)) (f12 (f13 f14 (f12 ?v_0 ?v2)) (f12 (f13 f14 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f10 f29 ?v0))) (= (f3 (f10 f29 (f3 ?v_0 ?v1)) (f3 (f10 f29 ?v2) ?v3)) (f3 (f10 f29 (f3 ?v_0 ?v2)) (f3 (f10 f29 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f13 f14 (f12 (f13 f14 ?v0) ?v1))) (?v_0 (f13 f14 ?v2))) (= (f12 ?v_1 (f12 ?v_0 ?v3)) (f12 ?v_0 (f12 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f10 f29 (f3 (f10 f29 ?v0) ?v1))) (?v_0 (f10 f29 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f13 f14 ?v0)) (?v_1 (f12 (f13 f14 ?v2) ?v3))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v_1) (f12 ?v_0 (f12 (f13 f14 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f10 f29 ?v0)) (?v_1 (f3 (f10 f29 ?v2) ?v3))) (= (f3 (f10 f29 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f10 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 (f13 f14 ?v0) ?v1) (f12 (f13 f14 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f10 f29 ?v0) ?v1) (f3 (f10 f29 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f13 f14 ?v0)) (?v_0 (f13 f14 ?v1))) (= (f12 ?v_1 (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f10 f29 ?v0)) (?v_0 (f10 f29 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f12 (f13 f14 ?v1) ?v2)) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f29 ?v0))) (= (f3 ?v_0 (f3 (f10 f29 ?v1) ?v2)) (f3 (f10 f29 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f14 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f29 ?v0))) (= (f3 (f10 f29 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f10 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 (f13 f14 (f12 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f29 ?v0))) (= (f3 (f10 f29 (f3 ?v_0 ?v1)) ?v2) (f3 (f10 f29 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2) (f12 ?v_0 (f12 (f13 f14 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f29 ?v0))) (= (f3 (f10 f29 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f10 f29 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S9)) (=> (= (f30 ?v0) f1) (= (f25 ?v0 ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S9)) (=> (= (f31 ?v0) f1) (= (f22 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (=> (< 0 ?v0) (=> (forall ((?v3 Int) (?v4 Int)) (= (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (- ?v3 (f12 (f13 f14 ?v4) ?v0))) f1))) (=> (exists ((?v3 Int)) (forall ((?v4 Int)) (=> (< ?v4 ?v3) (= (= (f20 ?v2 ?v4) f1) (= (f20 ?v1 ?v4) f1))))) (=> (exists ((?v3 Int)) (= (f20 ?v1 ?v3) f1)) (exists ((?v3 Int)) (= (f20 ?v2 ?v3) f1))))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (=> (< 0 ?v0) (=> (forall ((?v3 Int) (?v4 Int)) (= (= (f20 ?v1 ?v3) f1) (= (f20 ?v1 (- ?v3 (f12 (f13 f14 ?v4) ?v0))) f1))) (=> (exists ((?v3 Int)) (forall ((?v4 Int)) (=> (< ?v3 ?v4) (= (= (f20 ?v2 ?v4) f1) (= (f20 ?v1 ?v4) f1))))) (=> (exists ((?v3 Int)) (= (f20 ?v1 ?v3) f1)) (exists ((?v3 Int)) (= (f20 ?v2 ?v3) f1))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f24 ?v0 f32) f1) (=> (= (f24 ?v1 f32) f1) (= (f24 (f3 (f10 f29 ?v0) ?v1) f32) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f27 ?v0 f33) f1) (=> (= (f27 ?v1 f33) f1) (= (f27 (f12 (f13 f14 ?v0) ?v1) f33) f1)))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (=> (= (f31 ?v0) f1) (= (= (f3 ?v0 ?v1) (f3 ?v0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S2)) (=> (= (f30 ?v0) f1) (= (= (f7 ?v0 ?v1) (f7 ?v0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f3 (f34 f35 ?v0) ?v1) (f5 f6 (+ (f7 f8 (f5 f6 ?v0)) (f7 f8 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f36 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f5 f6 (+ (* 2 (f7 f8 ?v1)) 1))) (f3 (f10 f29 ?v0) (f3 (f10 f29 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f37 f38 ?v0))) (let ((?v_1 (f7 ?v_0 ?v1))) (= (f7 ?v_0 (f5 f6 (+ (* 2 (f7 f8 ?v1)) 1))) (f12 (f13 f14 ?v0) (f12 (f13 f14 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2)) (= (f3 (f10 f36 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f7 (f37 f38 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 (f10 f36 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f5 f6 (f12 (f13 f14 (f7 f8 ?v1)) (f7 f8 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f7 (f37 f38 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f5 f6 (f12 (f13 f14 (f7 f8 ?v1)) (f7 f8 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 (f10 f29 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2)) (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f12 (f13 f14 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f10 f36 (f3 (f10 f29 ?v0) ?v1)) ?v2) (f3 (f10 f29 (f3 (f10 f36 ?v0) ?v2)) (f3 (f10 f36 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f7 (f37 f38 (f12 (f13 f14 ?v0) ?v1)) ?v2) (f12 (f13 f14 (f7 (f37 f38 ?v0) ?v2)) (f7 (f37 f38 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 (f10 f29 (f3 ?v_0 ?v1)) ?v0) (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f12 (f13 f14 (f7 ?v_0 ?v1)) ?v0) (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 (f10 f29 ?v0) (f3 ?v_0 ?v1)) (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f12 (f13 f14 ?v0) (f7 ?v_0 ?v1)) (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (f3 (f10 f29 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (f12 (f13 f14 ?v0) (f7 ?v_0 ?v1))))))
(assert (forall ((?v0 S2)) (= (f3 (f10 f29 ?v0) ?v0) (f3 (f10 f36 ?v0) (f5 f6 2)))))
(assert (forall ((?v0 Int)) (= (f12 (f13 f14 ?v0) ?v0) (f7 (f37 f38 ?v0) (f5 f6 2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f5 f6 2))) (= (f7 (f37 f38 (f12 f26 ?v0)) ?v_0) (f7 (f37 f38 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 (f37 f38 ?v0) (f5 f6 2)))) (= (f12 f26 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v2)))) (f12 (f13 f14 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f7 (f37 f38 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f5 f6 (f12 (f13 f14 (f7 f8 ?v1)) (f7 f8 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 ?v_0 ?v1) (ite (= ?v1 (f5 f6 0)) (f5 f6 1) (f5 f6 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 (f3 ?v_0 (f5 f6 (- (f7 f8 ?v1) 1)))))))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 ?v_0 (f5 f6 (* 2 (f7 f8 ?v1)))) (f3 (f10 f36 (f3 ?v_0 ?v1)) (f5 f6 2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f7 ?v_0 (f5 f6 (* 2 (f7 f8 ?v1)))) (f7 (f37 f38 (f7 ?v_0 ?v1)) (f5 f6 2))))))
(assert (forall ((?v0 S2)) (= (f3 (f10 f36 ?v0) (f5 f6 3)) (f3 (f10 f29 (f3 (f10 f29 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f7 (f37 f38 ?v0) (f5 f6 3)) (f12 (f13 f14 (f12 (f13 f14 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S2)) (= (f3 (f10 f36 ?v0) (f5 f6 2)) (f3 (f10 f29 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f7 (f37 f38 ?v0) (f5 f6 2)) (f12 (f13 f14 ?v0) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (* 2 (f7 f8 ?v1)) 1))) (f3 (f10 f29 ?v0) (f3 (f10 f36 (f3 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (* 2 (f7 f8 ?v1)) 1))) (f12 (f13 f14 ?v0) (f7 (f37 f38 (f7 ?v_0 ?v1)) (f5 f6 2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f36 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (f5 f6 (* 2 (f7 f8 ?v1)))) (f3 (f10 f29 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f37 f38 ?v0))) (let ((?v_1 (f7 ?v_0 ?v1))) (= (f7 ?v_0 (f5 f6 (* 2 (f7 f8 ?v1)))) (f12 (f13 f14 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 ?v_0 (f5 f6 (f12 (f13 f14 (f7 f8 ?v1)) (f7 f8 ?v2)))) (f3 (f10 f36 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f7 ?v_0 (f5 f6 (f12 (f13 f14 (f7 f8 ?v1)) (f7 f8 ?v2)))) (f7 (f37 f38 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (f3 (f10 f29 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (f12 (f13 f14 ?v0) (f7 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (f3 (f10 f29 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) 1))) (f12 (f13 f14 (f7 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (= (f3 ?v_0 (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v2)))) (f3 (f10 f29 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 S2)) (let ((?v_0 (f37 f38 ?v0))) (= (f7 ?v_0 (f5 f6 (+ (f7 f8 ?v1) (f7 f8 ?v2)))) (f12 (f13 f14 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f3 (f10 f36 (f5 f6 ?v0)) ?v1) (f5 f6 (f7 (f37 f38 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (= (f5 f6 (f7 (f37 f38 ?v0) ?v1)) (f3 (f10 f36 (f5 f6 ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (=> (<= 0 ?v0) (<= 0 (f7 (f37 f38 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f7 (f37 f38 (f7 f8 ?v0)) ?v1) (f7 f8 (f3 (f10 f36 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f7 (f37 f38 (f7 f8 ?v0)) ?v1) (f7 f8 (f3 (f10 f36 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (< 0 (f7 (f37 f38 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f5 f6 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f7 f8 (f3 (f10 f36 ?v0) ?v1)) (f7 (f37 f38 (f7 f8 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (<= 0 (f7 (f37 f38 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f7 f8 (f3 (f10 f36 ?v0) ?v1))) (or (< 0 (f7 f8 ?v0)) (= ?v1 (f5 f6 0))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f5 f6 (+ 0 1)))) (= (f3 (f10 f36 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f5 f6 (+ 0 1)))) (= (= (f3 (f10 f36 ?v0) ?v1) ?v_0) (or (= ?v1 (f5 f6 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f10 f36 ?v0))) (=> (< 0 (f7 f8 ?v0)) (=> (< (f7 f8 (f3 ?v_0 ?v1)) (f7 f8 (f3 ?v_0 ?v2))) (< (f7 f8 ?v1) (f7 f8 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f7 f8 ?v0)) (<= ?v_0 (f7 f8 (f3 (f10 f36 ?v0) ?v1)))))))
(assert (forall ((?v0 S2)) (= (f3 (f10 f36 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f7 (f37 f38 ?v0) (f5 f6 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f12 f26 (f7 (f37 f38 ?v0) ?v1)) (f7 (f37 f38 (f12 f26 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f3 (f10 f36 (f3 (f10 f29 ?v0) ?v1)) ?v2) (f3 (f10 f29 (f3 (f10 f36 ?v0) ?v2)) (f3 (f10 f36 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f7 (f37 f38 (f12 (f13 f14 ?v0) ?v1)) ?v2) (f12 (f13 f14 (f7 (f37 f38 ?v0) ?v2)) (f7 (f37 f38 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f3 (f10 f36 ?v0) ?v1))) (= (f3 (f10 f29 ?v_0) ?v0) (f3 (f10 f29 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S2)) (let ((?v_0 (f7 (f37 f38 ?v0) ?v1))) (= (f12 (f13 f14 ?v_0) ?v0) (f12 (f13 f14 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f10 f36 ?v2))) (=> (<= ?v_1 ?v_0) (= (f3 ?v_2 (f5 f6 (- (+ ?v_0 1) ?v_1))) (f3 (f10 f29 (f3 ?v_2 (f5 f6 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 Int)) (let ((?v_0 (f7 f8 ?v1)) (?v_1 (f7 f8 ?v0)) (?v_2 (f37 f38 ?v2))) (=> (<= ?v_1 ?v_0) (= (f7 ?v_2 (f5 f6 (- (+ ?v_0 1) ?v_1))) (f12 (f13 f14 (f7 ?v_2 (f5 f6 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f10 f36 ?v1))) (=> (< 0 ?v_0) (= (f3 (f10 f29 (f3 ?v_1 (f5 f6 (- ?v_0 1)))) ?v1) (f3 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 Int)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f37 f38 ?v1))) (=> (< 0 ?v_0) (= (f12 (f13 f14 (f7 ?v_1 (f5 f6 (- ?v_0 1)))) ?v1) (f7 ?v_1 ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (< 0 (f7 f8 (f3 (f10 f36 ?v0) ?v1))) (or (= ?v1 (f5 f6 0)) (< 0 (f7 f8 ?v0))))))
(assert (forall ((?v0 S3)) (=> (= (f31 ?v0) f1) (= (f39 ?v0) f1))))
(assert (forall ((?v0 S5)) (=> (= (f30 ?v0) f1) (= (f40 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f12 f41 (f7 (f37 f38 ?v0) ?v1)) (f7 (f37 f38 (f12 f41 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 f42 (f3 (f10 f36 ?v0) ?v1)) (f3 (f10 f36 (f3 f42 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f7 f8 (f3 (f10 f36 ?v0) ?v1)) (f7 (f37 f38 (f7 f8 ?v0)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) (= (f7 f8 (f5 f6 ?v_0)) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 f42 (f5 f6 (f12 (f13 f14 (f7 f8 ?v0)) (f7 f8 ?v1)))) (f3 (f10 f29 (f3 f42 ?v0)) (f3 f42 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f12 f41 (f12 (f13 f14 ?v0) ?v1)) (f12 (f13 f14 (f12 f41 ?v0)) (f12 f41 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S2)) (=> (= (f40 ?v0) f1) (= (f12 (f13 f43 (f7 ?v0 ?v1)) (f7 ?v0 ?v2)) (f7 ?v0 (f3 (f10 f44 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (=> (= (f39 ?v0) f1) (= (f3 (f10 f44 (f3 ?v0 ?v1)) (f3 ?v0 ?v2)) (f3 ?v0 (f3 (f10 f44 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S2)) (=> (= (f40 ?v0) f1) (= (f12 (f13 f45 (f7 ?v0 ?v1)) (f7 ?v0 ?v2)) (f7 ?v0 (f3 (f10 f46 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (=> (= (f39 ?v0) f1) (= (f3 (f10 f46 (f3 ?v0 ?v1)) (f3 ?v0 ?v2)) (f3 ?v0 (f3 (f10 f46 ?v1) ?v2))))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (f12 f26 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f7 f8 ?v0) (f7 f8 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f42 ?v0) (f3 f42 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f7 f8 ?v0))) (= (f12 f41 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f12 f41 ?v0) (f12 f41 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f5 f6 ?v0)) (f12 f41 ?v0)))))
(assert (forall ((?v0 S2)) (= (f24 (f3 f42 ?v0) f32) f1)))
(assert (forall ((?v0 S2)) (= (f27 (f7 f8 ?v0) f33) f1)))
(assert (forall ((?v0 S2)) (=> (= (f24 ?v0 f32) f1) (=> (forall ((?v1 S2)) (=> (= ?v0 (f3 f42 ?v1)) false)) false))))
(assert (forall ((?v0 Int)) (=> (= (f27 ?v0 f33) f1) (=> (forall ((?v1 S2)) (=> (= ?v0 (f7 f8 ?v1)) false)) false))))
(assert (forall ((?v0 S2) (?v1 S9)) (=> (= (f24 ?v0 f32) f1) (=> (forall ((?v2 S2)) (= (f18 ?v1 (f3 f42 ?v2)) f1)) (= (f18 ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (= (f27 ?v0 f33) f1) (=> (forall ((?v2 S2)) (= (f20 ?v1 (f7 f8 ?v2)) f1)) (= (f20 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S5) (?v1 S2)) (let ((?v_0 (f5 f6 (+ (f7 f8 ?v1) 1)))) (= (f7 (f47 f48 ?v0) ?v1) (f12 (f13 f14 (f7 f8 ?v_0)) (f7 ?v0 ?v_0))))))
(assert (= (f25 f8 f49) f1))
(assert (= (f22 f42 f49) f1))
(assert (forall ((?v0 S2)) (= (= (f18 f49 ?v0) f1) (= f50 f1))))
(assert (forall ((?v0 Int)) (= (= (f20 f51 ?v0) f1) (= f50 f1))))
(assert (= (f25 f8 f49) f1))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S2)) (=> (= (f25 ?v0 f49) f1) (=> (= (f7 ?v0 ?v1) (f7 ?v0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (=> (= (f22 ?v0 f49) f1) (=> (= (f3 ?v0 ?v1) (f3 ?v0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S2)) (=> (= (f25 ?v0 f49) f1) (= (= (f7 ?v0 ?v1) (f7 ?v0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S2)) (=> (= (f22 ?v0 f49) f1) (= (= (f3 ?v0 ?v1) (f3 ?v0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S2)) (= (= (f24 ?v0 f49) f1) true)))
(assert (forall ((?v0 Int)) (= (= (f27 ?v0 f51) f1) true)))
(assert (forall ((?v0 S2)) (= (f24 ?v0 f49) f1)))
(assert (forall ((?v0 Int)) (= (f27 ?v0 f51) f1)))
(assert (= f49 (f28 f19)))
(assert (= f51 (f52 f21)))
(assert (forall ((?v0 S2)) (= (f18 f49 ?v0) f1)))
(assert (forall ((?v0 Int)) (= (f20 f51 ?v0) f1)))
(assert (forall ((?v0 S5)) (=> (forall ((?v1 S2) (?v2 S2)) (=> (= (f7 ?v0 ?v1) (f7 ?v0 ?v2)) (= ?v1 ?v2))) (= (f25 ?v0 f49) f1))))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 S2) (?v2 S2)) (=> (= (f3 ?v0 ?v1) (f3 ?v0 ?v2)) (= ?v1 ?v2))) (= (f22 ?v0 f49) f1))))
(assert (exists ((?v0 S2)) (= (f24 ?v0 f49) f1)))
(assert (exists ((?v0 Int)) (= (f27 ?v0 f51) f1)))
(assert (forall ((?v0 S9)) (=> (forall ((?v1 S2)) (= (f24 ?v1 ?v0) f1)) (= f49 ?v0))))
(assert (forall ((?v0 S10)) (=> (forall ((?v1 Int)) (= (f27 ?v1 ?v0) f1)) (= f51 ?v0))))
(assert (forall ((?v0 S5) (?v1 S2)) (=> (= (f25 ?v0 f49) f1) (= (f5 (f53 (f54 f55 f49) ?v0) (f7 ?v0 ?v1)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= (f22 ?v0 f49) f1) (= (f3 (f56 (f57 f58 f49) ?v0) (f3 ?v0 ?v1)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S9) (?v2 S2) (?v3 Int)) (=> (= (f25 ?v0 ?v1) f1) (=> (= (f7 ?v0 ?v2) ?v3) (=> (= (f24 ?v2 ?v1) f1) (= (f5 (f53 (f54 f55 ?v1) ?v0) ?v3) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S2) (?v3 S2)) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f3 ?v0 ?v2) ?v3) (=> (= (f24 ?v2 ?v1) f1) (= (f3 (f56 (f57 f58 ?v1) ?v0) ?v3) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S9) (?v2 S2)) (=> (= (f25 ?v0 ?v1) f1) (=> (= (f24 ?v2 ?v1) f1) (= (f5 (f53 (f54 f55 ?v1) ?v0) (f7 ?v0 ?v2)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S2)) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f24 ?v2 ?v1) f1) (= (f3 (f56 (f57 f58 ?v1) ?v0) (f3 ?v0 ?v2)) ?v2)))))
(assert (forall ((?v0 S2)) (= (f5 f6 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
