(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 () S5)
(declare-fun f6 (S6 S4) S4)
(declare-fun f7 () S6)
(declare-fun f8 () S2)
(declare-fun f9 () S3)
(declare-fun f10 () S3)
(declare-fun f11 () S4)
(declare-fun f12 (S7 S3) Int)
(declare-fun f13 () S7)
(declare-fun f14 (S8 Int) S7)
(declare-fun f15 () S8)
(declare-fun f16 (S9 S3) S3)
(declare-fun f17 (S10 S3) S9)
(declare-fun f18 () S10)
(declare-fun f19 () S3)
(declare-fun f20 (S11 Int) S3)
(declare-fun f21 () S11)
(declare-fun f22 (S12 Int) Int)
(declare-fun f23 () S12)
(declare-fun f24 (S13 Int) S12)
(declare-fun f25 () S13)
(declare-fun f26 () S4)
(declare-fun f27 () S3)
(declare-fun f28 (S14 S4) S6)
(declare-fun f29 () S14)
(declare-fun f30 (S3 S3) S1)
(declare-fun f31 (S3 S3) S1)
(declare-fun f32 () S10)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (f4 f5 (f6 f7 (f3 f8 f9))) f10) f11))))
(assert (< 0 (f12 f13 f10)))
(assert (< (f12 f13 f10) (f12 f13 f9)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f3 f8 ?v0)) ?v0) f11)))
(assert (forall ((?v0 S4) (?v1 S3)) (= (f6 f7 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f6 f7 ?v0)) ?v1))))
(assert (= (f6 f7 f11) f11))
(assert (forall ((?v0 S4)) (= (= (f6 f7 ?v0) f11) (= ?v0 f11))))
(assert (forall ((?v0 S3)) (= (f12 (f14 f15 1) ?v0) 1)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f11) ?v0) f11)))
(assert (forall ((?v0 S3)) (= (f16 (f17 f18 f19) ?v0) f19)))
(assert (= (f12 (f14 f15 1) (f20 f21 2)) 1))
(assert (= (f3 (f4 f5 f11) (f20 f21 2)) f11))
(assert (= (f16 (f17 f18 f19) (f20 f21 2)) f19))
(assert (forall ((?v0 Int)) (= (f12 (f14 f15 ?v0) (f20 f21 0)) 1)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f20 f21 0)) f11)))
(assert (forall ((?v0 S3)) (= (f16 (f17 f18 ?v0) (f20 f21 0)) f19)))
(assert (forall ((?v0 Int)) (= (f12 (f14 f15 ?v0) (f20 f21 0)) 1)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f20 f21 0)) f11)))
(assert (forall ((?v0 S3)) (= (f16 (f17 f18 ?v0) (f20 f21 0)) f19)))
(assert (forall ((?v0 S4)) (= (f6 f7 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 f7 ?v0) (f6 f7 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f7 ?v0) (f6 f7 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f22 f23 (f12 (f14 f15 ?v0) ?v1)) (f12 (f14 f15 (f22 f23 ?v0)) ?v1))))
(assert (= (f22 f23 1) 1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 2))) (= (f12 (f14 f15 (f22 f23 ?v0)) ?v_0) (f12 (f14 f15 ?v0) ?v_0)))))
(assert (forall ((?v0 S3)) (= (f16 (f17 f18 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f12 (f14 f15 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f16 (f17 f18 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f12 (f14 f15 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 (f14 f15 ?v0) (f20 f21 2)))) (= (f22 f23 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S4)) (= (= f11 ?v0) (= ?v0 f11))))
(assert (forall ((?v0 S3)) (= (= f19 ?v0) (= ?v0 f19))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 ?v0))) (let ((?v_1 (f24 f25 ?v_0))) (=> (< 0 ?v_0) (= (f3 (f4 f5 (f3 f8 (f20 f21 (f22 ?v_1 (f12 f13 ?v1))))) (f20 f21 (f22 ?v_1 (f12 f13 ?v2)))) (f3 (f4 f5 (f3 f8 ?v1)) ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (not (= ?v0 f26)) (= (f6 f7 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S3)) (= (f12 (f14 f15 0) ?v0) (ite (= ?v0 (f20 f21 0)) 1 0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f26) ?v0) (ite (= ?v0 (f20 f21 0)) f11 f26))))
(assert (forall ((?v0 S3)) (= (f16 (f17 f18 f27) ?v0) (ite (= ?v0 (f20 f21 0)) f19 f27))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 (f28 f29 ?v0) ?v1) f11) (= (f6 f7 ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f14 f15 ?v2))) (=> (<= (f12 f13 ?v0) (f12 f13 ?v1)) (=> (<= 1 ?v2) (<= (f12 ?v_0 ?v0) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v2))) (=> (<= (f12 f13 ?v0) (f12 f13 ?v1)) (=> (= (f30 f19 ?v2) f1) (= (f30 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 1 ?v0) (<= 1 (f12 (f14 f15 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f30 f19 ?v0) f1) (= (f30 f19 (f16 (f17 f18 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f14 f15 ?v2))) (=> (< (f12 f13 ?v0) (f12 f13 ?v1)) (=> (< 1 ?v2) (< (f12 ?v_0 ?v0) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v2))) (=> (< (f12 f13 ?v0) (f12 f13 ?v1)) (=> (= (f31 f19 ?v2) f1) (= (f31 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 ?v0))) (=> (< 1 ?v0) (=> (< (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (< (f12 f13 ?v1) (f12 f13 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (=> (= (f31 f19 ?v0) f1) (=> (= (f31 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1) (< (f12 f13 ?v1) (f12 f13 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (< 1 ?v0) (=> (< 0 (f12 f13 ?v1)) (< 1 (f12 (f14 f15 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f31 f19 ?v0) f1) (=> (< 0 (f12 f13 ?v1)) (= (f31 f19 (f16 (f17 f18 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int)) (not (< (f22 (f24 f25 ?v0) ?v0) 0))))
(assert (forall ((?v0 Int)) (<= 0 (f22 (f24 f25 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f12 (f14 f15 ?v0) (f20 f21 (* 2 (f12 f13 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 f23 (f22 (f24 f25 ?v0) ?v1)) (f22 (f24 f25 (f22 f23 ?v0)) (f22 f23 ?v1)))))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f28 f29 f26) ?v0) f26)))
(assert (forall ((?v0 S3)) (= (f16 (f17 f32 f27) ?v0) f27)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f28 f29 f26) ?v0) f26)))
(assert (forall ((?v0 S3)) (= (f16 (f17 f32 f27) ?v0) f27)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (f22 (f24 f25 ?v0) ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f28 f29 ?v0) f26) f26)))
(assert (forall ((?v0 S3)) (= (f16 (f17 f32 ?v0) f27) f27)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S4)) (= (f6 (f28 f29 ?v0) f26) f26)))
(assert (forall ((?v0 S3)) (= (f16 (f17 f32 ?v0) f27) f27)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 (f24 f25 ?v0) ?v1) (f22 (f24 f25 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f16 (f17 f32 ?v0) ?v1) (f16 (f17 f32 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f28 f29 ?v0) ?v1) (f6 (f28 f29 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) (f20 f21 1) (f20 f21 (f22 (f24 f25 (f12 f13 ?v0)) (f12 f13 (f16 ?v_0 (f20 f21 (- (f12 f13 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 0)) (?v_2 (f12 f13 ?v0)) (?v_1 (f12 f13 ?v1))) (= (f20 f21 (f22 (f24 f25 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f20 f21 (+ ?v_1 (f22 (f24 f25 (f12 f13 (f20 f21 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f12 f13 ?v0))) (= (f20 f21 (* ?v_0 2)) (f20 f21 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f24 f25 ?v0)) (?v_0 (f24 f25 ?v1))) (= (f22 ?v_1 (f22 ?v_0 ?v2)) (f22 ?v_0 (f22 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f17 f32 ?v0)) (?v_0 (f17 f32 ?v1))) (= (f16 ?v_1 (f16 ?v_0 ?v2)) (f16 ?v_0 (f16 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f28 f29 ?v0)) (?v_0 (f28 f29 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f22 ?v_0 (f22 (f24 f25 ?v1) ?v2)) (f22 (f24 f25 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v0))) (= (f16 ?v_0 (f16 (f17 f32 ?v1) ?v2)) (f16 (f17 f32 (f16 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f28 f29 ?v0))) (= (f6 ?v_0 (f6 (f28 f29 ?v1) ?v2)) (f6 (f28 f29 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f22 f23 ?v0))) (= (f22 (f24 f25 ?v_0) ?v_0) (f22 (f24 f25 ?v0) ?v0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f12 f13 ?v0))) (= (f20 f21 (* 2 ?v_0)) (f20 f21 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 (f24 f25 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 (f28 f29 ?v0) ?v1) f26) (or (= ?v0 f26) (= ?v1 f26)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f22 (f24 f25 ?v0) ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f22 (f24 f25 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v0))) (= (f16 (f17 f32 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f17 f32 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f28 f29 ?v0))) (= (f6 (f28 f29 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f28 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f22 (f24 f25 (f22 ?v_0 ?v1)) ?v2) (f22 (f24 f25 (f22 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v0))) (= (f16 (f17 f32 (f16 ?v_0 ?v1)) ?v2) (f16 (f17 f32 (f16 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f28 f29 ?v0))) (= (f6 (f28 f29 (f6 ?v_0 ?v1)) ?v2) (f6 (f28 f29 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f24 f25 ?v0)) (?v_1 (f22 (f24 f25 ?v2) ?v3))) (= (f22 (f24 f25 (f22 ?v_0 ?v1)) ?v_1) (f22 ?v_0 (f22 (f24 f25 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f17 f32 ?v0)) (?v_1 (f16 (f17 f32 ?v2) ?v3))) (= (f16 (f17 f32 (f16 ?v_0 ?v1)) ?v_1) (f16 ?v_0 (f16 (f17 f32 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f28 f29 ?v0)) (?v_1 (f6 (f28 f29 ?v2) ?v3))) (= (f6 (f28 f29 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f28 f29 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f24 f25 (f22 (f24 f25 ?v0) ?v1))) (?v_0 (f24 f25 ?v2))) (= (f22 ?v_1 (f22 ?v_0 ?v3)) (f22 ?v_0 (f22 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f17 f32 (f16 (f17 f32 ?v0) ?v1))) (?v_0 (f17 f32 ?v2))) (= (f16 ?v_1 (f16 ?v_0 ?v3)) (f16 ?v_0 (f16 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f28 f29 (f6 (f28 f29 ?v0) ?v1))) (?v_0 (f28 f29 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f22 (f24 f25 (f22 ?v_0 ?v1)) (f22 (f24 f25 ?v2) ?v3)) (f22 (f24 f25 (f22 ?v_0 ?v2)) (f22 (f24 f25 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f17 f32 ?v0))) (= (f16 (f17 f32 (f16 ?v_0 ?v1)) (f16 (f17 f32 ?v2) ?v3)) (f16 (f17 f32 (f16 ?v_0 ?v2)) (f16 (f17 f32 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f28 f29 ?v0))) (= (f6 (f28 f29 (f6 ?v_0 ?v1)) (f6 (f28 f29 ?v2) ?v3)) (f6 (f28 f29 (f6 ?v_0 ?v2)) (f6 (f28 f29 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f22 (f24 f25 ?v0) ?v1) (f22 (f24 f25 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f22 (f24 f25 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f26)) (=> (not (= ?v1 f26)) (not (= (f6 (f28 f29 ?v0) ?v1) f26))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f27)) (=> (not (= ?v1 f27)) (not (= (f16 (f17 f32 ?v0) ?v1) f27))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f22 (f24 f25 (f22 f23 ?v1)) ?v0) (f22 f23 (f22 (f24 f25 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 0 ?v0) (= (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (< ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (=> (< 0 ?v0) (= (<= (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (<= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (f22 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f31 f27 ?v0) f1) (=> (= (f31 f27 ?v1) f1) (= (f31 f27 (f16 (f17 f32 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f22 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f30 f27 ?v0) f1) (=> (= (f30 f27 ?v1) f1) (= (f30 f27 (f16 (f17 f32 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f22 (f24 f25 ?v0) ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f22 (f24 f25 ?v1) ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f22 (f24 f25 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f31 f27 ?v0) f1) (=> (= (f31 ?v1 f27) f1) (= (f31 (f16 (f17 f32 ?v0) ?v1) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f22 (f24 f25 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f31 f27 ?v0) f1) (=> (= (f31 ?v1 f27) f1) (= (f31 (f16 (f17 f32 ?v1) ?v0) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f22 (f24 f25 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f30 f27 ?v0) f1) (=> (= (f30 ?v1 f27) f1) (= (f30 (f16 (f17 f32 ?v0) ?v1) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f22 (f24 f25 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f30 f27 ?v0) f1) (=> (= (f30 ?v1 f27) f1) (= (f30 (f16 (f17 f32 ?v1) ?v0) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f22 (f24 f25 ?v0) ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f31 f27 (f16 (f17 f32 ?v0) ?v1)) f1) (=> (= (f31 f27 ?v0) f1) (= (f31 f27 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f22 (f24 f25 ?v0) ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f31 f27 (f16 (f17 f32 ?v0) ?v1)) f1) (=> (= (f31 f27 ?v1) f1) (= (f31 f27 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 (f12 (f14 f15 ?v0) (f20 f21 (+ (* 2 (f12 f13 ?v1)) 1)))) (<= 0 ?v0))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (< ?v0 0) (< (f12 (f14 f15 ?v0) (f20 f21 (+ (* 2 (f12 f13 ?v1)) 1))) 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (=> (< ?v0 0) (= (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (< ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (=> (< ?v0 0) (= (<= (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (<= ?v2 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f22 (f24 f25 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f31 ?v0 f27) f1) (=> (= (f31 f27 ?v1) f1) (= (f31 (f16 (f17 f32 ?v0) ?v1) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f22 (f24 f25 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f30 ?v0 f27) f1) (=> (= (f30 f27 ?v1) f1) (= (f30 (f16 (f17 f32 ?v0) ?v1) f27) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (f22 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f22 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f22 (f24 f25 ?v0) ?v2) (f22 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f31 ?v0 ?v1) f1) (=> (= (f31 f27 ?v2) f1) (= (f31 (f16 (f17 f32 ?v0) ?v2) (f16 (f17 f32 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f22 ?v_0 ?v0) (f22 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v2))) (=> (= (f31 ?v0 ?v1) f1) (=> (= (f31 f27 ?v2) f1) (= (f31 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f22 ?v_0 ?v0) (f22 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v2))) (=> (= (f31 ?v0 ?v1) f1) (=> (= (f31 f27 ?v2) f1) (= (f31 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f22 (f24 f25 ?v0) ?v2) (f22 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 f27 ?v2) f1) (= (f30 (f16 (f17 f32 ?v0) ?v2) (f16 (f17 f32 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f22 ?v_0 ?v0) (f22 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v2))) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 f27 ?v2) f1) (= (f30 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f22 ?v_0 ?v0) (f22 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v2))) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 f27 ?v2) f1) (= (f30 (f16 ?v_0 ?v0) (f16 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (< ?v0 ?v1) (=> (<= 0 ?v0) (=> (< 0 (f12 f13 ?v2)) (< (f12 (f14 f15 ?v0) ?v2) (f12 (f14 f15 ?v1) ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f31 ?v0 ?v1) f1) (=> (= (f30 f27 ?v0) f1) (=> (< 0 (f12 f13 ?v2)) (= (f31 (f16 (f17 f18 ?v0) ?v2) (f16 (f17 f18 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f22 (f24 f25 ?v1) ?v2) (f22 (f24 f25 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f22 (f24 f25 ?v1) ?v2) (f22 (f24 f25 ?v0) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f22 ?v_0 ?v1) (f22 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (f22 (f24 f25 ?v0) ?v2) (f22 (f24 f25 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f31 ?v0 ?v1) f1) (=> (= (f31 ?v2 ?v3) f1) (=> (= (f31 f27 ?v1) f1) (=> (= (f30 f27 ?v2) f1) (= (f31 (f16 (f17 f32 ?v0) ?v2) (f16 (f17 f32 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (f22 (f24 f25 ?v0) ?v2) (f22 (f24 f25 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f31 ?v0 ?v1) f1) (=> (= (f31 ?v2 ?v3) f1) (=> (= (f30 f27 ?v0) f1) (=> (= (f30 f27 ?v2) f1) (= (f31 (f16 (f17 f32 ?v0) ?v2) (f16 (f17 f32 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (f22 (f24 f25 ?v0) ?v2) (f22 (f24 f25 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f31 ?v0 ?v1) f1) (=> (= (f30 ?v2 ?v3) f1) (=> (= (f30 f27 ?v0) f1) (=> (= (f31 f27 ?v2) f1) (= (f31 (f16 (f17 f32 ?v0) ?v2) (f16 (f17 f32 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (f22 (f24 f25 ?v0) ?v2) (f22 (f24 f25 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f31 ?v2 ?v3) f1) (=> (= (f31 f27 ?v0) f1) (=> (= (f30 f27 ?v2) f1) (= (f31 (f16 (f17 f32 ?v0) ?v2) (f16 (f17 f32 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f22 (f24 f25 ?v0) ?v2) (f22 (f24 f25 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 ?v2 ?v3) f1) (=> (= (f30 f27 ?v0) f1) (=> (= (f30 f27 ?v2) f1) (= (f30 (f16 (f17 f32 ?v0) ?v2) (f16 (f17 f32 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f22 (f24 f25 ?v0) ?v2) (f22 (f24 f25 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f30 ?v0 ?v1) f1) (=> (= (f30 ?v2 ?v3) f1) (=> (= (f30 f27 ?v1) f1) (=> (= (f30 f27 ?v2) f1) (= (f30 (f16 (f17 f32 ?v0) ?v2) (f16 (f17 f32 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f22 f23 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f22 (f24 f25 ?v_0) ?v_1) (f22 (f24 f25 ?v1) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 (f24 f25 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 (f28 f29 ?v0) ?v1) f26) (or (= ?v0 f26) (= ?v1 f26)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f16 (f17 f32 ?v0) ?v1) f27) (or (= ?v0 f27) (= ?v1 f27)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (< (f12 (f14 f15 ?v0) ?v1) (f12 (f14 f15 ?v2) ?v1)) (=> (<= 0 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f31 (f16 (f17 f18 ?v0) ?v1) (f16 (f17 f18 ?v2) ?v1)) f1) (=> (= (f30 f27 ?v2) f1) (= (f31 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f22 (f24 f25 ?v0) ?v1) (f22 (f24 f25 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f31 (f16 (f17 f32 ?v0) ?v1) (f16 (f17 f32 ?v2) ?v1)) f1) (=> (= (f30 f27 ?v1) f1) (= (f31 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f22 (f24 f25 ?v0) ?v1) (f22 (f24 f25 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f31 (f16 (f17 f32 ?v0) ?v1) (f16 (f17 f32 ?v2) ?v1)) f1) (=> (= (f30 f27 ?v1) f1) (= (f31 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (=> (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v0))) (=> (= (f31 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1) (=> (= (f30 f27 ?v0) f1) (= (f31 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (=> (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v0))) (=> (= (f31 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1) (=> (= (f30 f27 ?v0) f1) (= (f31 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f22 (f24 f25 ?v0) ?v1) (f22 (f24 f25 ?v2) ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f30 (f16 (f17 f32 ?v0) ?v1) (f16 (f17 f32 ?v2) ?v1)) f1) (=> (= (f31 f27 ?v1) f1) (= (f30 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (=> (<= (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v0))) (=> (= (f30 (f16 ?v_0 ?v1) (f16 ?v_0 ?v2)) f1) (=> (= (f31 f27 ?v0) f1) (= (f30 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 2))) (=> (< (f12 (f14 f15 ?v0) ?v_0) (f12 (f14 f15 ?v1) ?v_0)) (=> (<= 0 ?v1) (< ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f20 f21 2))) (=> (= (f31 (f16 (f17 f18 ?v0) ?v_0) (f16 (f17 f18 ?v1) ?v_0)) f1) (=> (= (f30 f27 ?v1) f1) (= (f31 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f22 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f22 f23 (f22 (f24 f25 ?v0) ?v1)) (f22 (f24 f25 (f22 f23 ?v0)) (f22 f23 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f22 (f24 f25 ?v0) ?v1) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (or (and (= (f30 f27 ?v0) f1) (= (f30 ?v1 f27) f1)) (and (= (f30 ?v0 f27) f1) (= (f30 f27 ?v1) f1))) (= (f30 (f16 (f17 f32 ?v0) ?v1) f27) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f22 f23 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f22 f23 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f22 f23 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f22 (f24 f25 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f32 ?v0))) (= (f16 (f17 f32 (f16 ?v_0 ?v1)) ?v2) (f16 ?v_0 (f16 (f17 f32 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f28 f29 ?v0))) (= (f6 (f28 f29 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f28 f29 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (= (<= (f22 f23 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f22 f23 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (< 0 (f22 f23 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= f26 ?v0) (= ?v0 f26))))
(assert (forall ((?v0 S3)) (= (= f27 ?v0) (= ?v0 f27))))
(assert (= (f22 f23 0) 0))
(assert (forall ((?v0 S3)) (= (f20 f21 (f12 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f13 (f20 f21 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f13 (f20 f21 ?v0)) 0))))
(check-sat)
(exit)
