(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S4)
(declare-fun f4 (S5 S4) S2)
(declare-fun f5 () S5)
(declare-fun f6 (S6 S4) S4)
(declare-fun f7 () S6)
(declare-fun f8 () S2)
(declare-fun f9 () S3)
(declare-fun f10 () S3)
(declare-fun f11 () S4)
(declare-fun f12 (S7 S3) Int)
(declare-fun f13 () S7)
(declare-fun f14 (S8 Int) S7)
(declare-fun f15 () S8)
(declare-fun f16 (S9 Int) S3)
(declare-fun f17 () S9)
(declare-fun f18 (S10 Int) Int)
(declare-fun f19 () S10)
(declare-fun f20 (S11 Int) S10)
(declare-fun f21 () S11)
(declare-fun f22 () S4)
(declare-fun f23 (S12 S4) S6)
(declare-fun f24 () S12)
(assert (not (= f1 f2)))
(assert (not (not (= (f3 (f4 f5 (f6 f7 (f3 f8 f9))) f10) f11))))
(assert (< 0 (f12 f13 f10)))
(assert (< (f12 f13 f10) (f12 f13 f9)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f3 f8 ?v0)) ?v0) f11)))
(assert (forall ((?v0 S4) (?v1 S3)) (= (f6 f7 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f6 f7 ?v0)) ?v1))))
(assert (= (f6 f7 f11) f11))
(assert (forall ((?v0 S4)) (= (= (f6 f7 ?v0) f11) (= ?v0 f11))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f11) ?v0) f11)))
(assert (forall ((?v0 S3)) (= (f12 (f14 f15 1) ?v0) 1)))
(assert (= (f3 (f4 f5 f11) (f16 f17 2)) f11))
(assert (= (f12 (f14 f15 1) (f16 f17 2)) 1))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f16 f17 0)) f11)))
(assert (forall ((?v0 Int)) (= (f12 (f14 f15 ?v0) (f16 f17 0)) 1)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f16 f17 0)) f11)))
(assert (forall ((?v0 Int)) (= (f12 (f14 f15 ?v0) (f16 f17 0)) 1)))
(assert (forall ((?v0 S4)) (= (f6 f7 (f6 f7 ?v0)) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 f7 ?v0) (f6 f7 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f7 ?v0) (f6 f7 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f18 f19 (f12 (f14 f15 ?v0) ?v1)) (f12 (f14 f15 (f18 f19 ?v0)) ?v1))))
(assert (= (f18 f19 1) 1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f16 f17 2))) (= (f12 (f14 f15 (f18 f19 ?v0)) ?v_0) (f12 (f14 f15 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f12 (f14 f15 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f12 (f14 f15 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f3 (f4 f5 ?v0) (f16 f17 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 (f14 f15 ?v0) (f16 f17 2)))) (= (f18 f19 ?v_0) ?v_0))))
(assert (forall ((?v0 S4)) (= (= f11 ?v0) (= ?v0 f11))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 ?v0))) (let ((?v_1 (f20 f21 ?v_0))) (=> (< 0 ?v_0) (= (f3 (f4 f5 (f3 f8 (f16 f17 (f18 ?v_1 (f12 f13 ?v1))))) (f16 f17 (f18 ?v_1 (f12 f13 ?v2)))) (f3 (f4 f5 (f3 f8 ?v1)) ?v2)))))))
(assert (forall ((?v0 S4) (?v1 S3)) (=> (not (= ?v0 f22)) (= (f6 f7 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f22) ?v0) (ite (= ?v0 (f16 f17 0)) f11 f22))))
(assert (forall ((?v0 S3)) (= (f12 (f14 f15 0) ?v0) (ite (= ?v0 (f16 f17 0)) 1 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 (f23 f24 ?v0) ?v1) f11) (= (f6 f7 ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f14 f15 ?v2))) (=> (<= (f12 f13 ?v0) (f12 f13 ?v1)) (=> (<= 1 ?v2) (<= (f12 ?v_0 ?v0) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 1 ?v0) (<= 1 (f12 (f14 f15 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f14 f15 ?v2))) (=> (< (f12 f13 ?v0) (f12 f13 ?v1)) (=> (< 1 ?v2) (< (f12 ?v_0 ?v0) (f12 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 ?v0))) (=> (< 1 ?v0) (=> (< (f12 ?v_0 ?v1) (f12 ?v_0 ?v2)) (< (f12 f13 ?v1) (f12 f13 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (< 1 ?v0) (=> (< 0 (f12 f13 ?v1)) (< 1 (f12 (f14 f15 ?v0) ?v1))))))
(assert (forall ((?v0 Int)) (not (< (f18 (f20 f21 ?v0) ?v0) 0))))
(assert (forall ((?v0 Int)) (<= 0 (f18 (f20 f21 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f16 f17 (f12 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f13 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f13 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
