(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S2)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S2) S3)
(declare-fun f7 () S4)
(declare-fun f8 () S2)
(declare-fun f9 (S6 S5) Int)
(declare-fun f10 () S6)
(declare-fun f11 (S7 S5) S2)
(declare-fun f12 (S8 S2) S7)
(declare-fun f13 () S8)
(declare-fun f14 (S9 Int) S5)
(declare-fun f15 () S9)
(declare-fun f16 () S2)
(declare-fun f17 () S5)
(declare-fun f18 () S5)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (=> (not (= ?v0 f3)) (= (f4 f5 ?v0) (f4 (f6 f7 f8) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (let ((?v_0 (f9 f10 ?v2)) (?v_1 (f9 f10 ?v1)) (?v_2 (f12 f13 ?v0))) (=> (not (= ?v0 f3)) (=> (<= ?v_1 ?v_0) (= (f11 (f12 f13 (f4 f5 ?v0)) (f14 f15 (- ?v_0 ?v_1))) (f4 (f6 f7 (f11 ?v_2 ?v1)) (f11 ?v_2 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (let ((?v_0 (f9 f10 ?v2)) (?v_1 (f9 f10 ?v1)) (?v_2 (f12 f13 ?v0))) (=> (not (= ?v0 f3)) (=> (<= ?v_1 ?v_0) (= (f11 ?v_2 (f14 f15 (- ?v_0 ?v_1))) (f4 (f6 f7 (f11 ?v_2 ?v2)) (f11 ?v_2 ?v1))))))))
(assert (not (= f16 f3)))
(assert (let ((?v_0 (f12 f13 f16)) (?v_1 (f9 f10 f17)) (?v_2 (f9 f10 f18))) (not (= (f4 (f6 f7 (f11 ?v_0 f17)) (f11 ?v_0 f18)) (ite (<= ?v_2 ?v_1) (f11 ?v_0 (f14 f15 (- ?v_1 ?v_2))) (f11 (f12 f13 (f4 (f6 f7 f8) f16)) (f14 f15 (- ?v_2 ?v_1))))))))
(assert (forall ((?v0 S5)) (= (f14 f15 (f9 f10 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f10 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f9 f10 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
