(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S4)
(declare-fun f4 () S3)
(declare-fun f5 (S2) S4)
(declare-fun f6 (S5 Int) S2)
(declare-fun f7 () S5)
(declare-fun f8 (S6 S2) Int)
(declare-fun f9 () S6)
(declare-fun f10 () S3)
(declare-fun f11 (S4 S4) S4)
(declare-fun f12 (S2 S3 S2) S4)
(declare-fun f13 (S7 S2) S2)
(declare-fun f14 (S8 S2) S7)
(declare-fun f15 () S8)
(declare-fun f16 () S2)
(declare-fun f17 () S2)
(declare-fun f18 (S4 S4) S4)
(declare-fun f19 (S4 S2) S4)
(declare-fun f20 (S4 S4) S4)
(declare-fun f21 () S4)
(declare-fun f22 (S2) S4)
(declare-fun f23 (S2 S3 S2) S4)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (f3 f4 ?v0) (f5 (f6 f7 (+ (* 2 (f8 f9 ?v0)) 1))))))
(assert (forall ((?v0 S2)) (= (f3 f10 ?v0) (f5 (f6 f7 (* 2 (f8 f9 ?v0)))))))
(assert (let ((?v_0 (f13 (f14 f15 (f6 f7 2)) f16))) (let ((?v_1 (f8 f9 ?v_0))) (let ((?v_2 (f6 f7 (- (f8 f9 f17) ?v_1)))) (let ((?v_3 (f19 (f20 f21 (f22 (f6 f7 (* 2 ?v_1)))) ?v_2))) (not (= (f11 (f12 ?v_0 f10 ?v_2) (f18 ?v_3 (f12 ?v_0 f4 ?v_2))) (f11 (f23 f16 f10 ?v_2) (f18 ?v_3 (f23 f16 f4 ?v_2))))))))))
(assert (not (< (f8 f9 f17) (f8 f9 (f13 (f14 f15 (f6 f7 2)) f16)))))
(assert (< (f8 f9 f17) (* 2 (f8 f9 (f13 (f14 f15 (f6 f7 2)) f16)))))
(assert (let ((?v_0 (f8 f9 (f13 (f14 f15 (f6 f7 2)) f16)))) (< (f8 f9 (f6 f7 (- (f8 f9 f17) ?v_0))) ?v_0)))
(assert (forall ((?v0 S2)) (= (f6 f7 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
