(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S2)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 () S2)
(declare-fun f7 () S4)
(declare-fun f8 () S2)
(declare-fun f9 (S5 S6) S2)
(declare-fun f10 (S7 S2) S5)
(declare-fun f11 () S7)
(declare-fun f12 (S8 Int) S6)
(declare-fun f13 () S8)
(declare-fun f14 (S9 S6) Int)
(declare-fun f15 () S9)
(declare-fun f16 () S6)
(declare-fun f17 () S2)
(declare-fun f18 (S10 Int) S9)
(declare-fun f19 () S10)
(declare-fun f20 (S11 Int) Int)
(declare-fun f21 (S12 Int) S11)
(declare-fun f22 () S12)
(assert (not (= f1 f2)))
(assert (not (not (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f4 f5 f6)) (?v_1 (f4 f7 f8)) (?v_2 (f12 f13 (- (f14 f15 f16) 1)))) (= (f3 ?v_0 (f3 (f4 f7 ?v0) (f3 ?v_1 (f9 (f10 f11 ?v0) ?v_2)))) (f3 ?v_0 (f3 (f4 f7 ?v1) (f3 ?v_1 (f9 (f10 f11 ?v1) ?v_2))))))))))
(assert (not (= f8 f17)))
(assert (not (= f16 (f12 f13 0))))
(assert (not (= f8 f17)))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 ?v1) (ite (= ?v1 (f12 f13 0)) f6 (f3 (f4 f7 ?v0) (f9 ?v_0 (f12 f13 (- (f14 f15 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f14 ?v_0 ?v1) (ite (= ?v1 (f12 f13 0)) 1 (f20 (f21 f22 ?v0) (f14 ?v_0 (f12 f13 (- (f14 f15 ?v1) 1)))))))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f5 ?v0) ?v0) (f3 (f4 f7 (f3 (f4 f5 f6) f6)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (f20 (f21 f22 (+ 1 1)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 ?v0) (f3 (f4 f7 ?v1) ?v0)) (f3 (f4 f7 (f3 (f4 f5 ?v1) f6)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (f20 (f21 f22 ?v1) ?v0)) (f20 (f21 f22 (+ ?v1 1)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f3 (f4 f5 (f3 (f4 f7 ?v0) ?v1)) ?v1) (f3 (f4 f7 (f3 (f4 f5 ?v0) f6)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f20 (f21 f22 ?v0) ?v1) ?v1) (f20 (f21 f22 (+ ?v0 1)) ?v1))))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f6) ?v0) f6)))
(assert (forall ((?v0 S6)) (= (f14 (f18 f19 1) ?v0) 1)))
(assert (= (f9 (f10 f11 f6) (f12 f13 2)) f6))
(assert (= (f14 (f18 f19 1) (f12 f13 2)) 1))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f12 f13 0)) f6)))
(assert (forall ((?v0 Int)) (= (f14 (f18 f19 ?v0) (f12 f13 0)) 1)))
(assert (forall ((?v0 S2)) (= (f9 (f10 f11 ?v0) (f12 f13 0)) f6)))
(assert (forall ((?v0 Int)) (= (f14 (f18 f19 ?v0) (f12 f13 0)) 1)))
(assert (forall ((?v0 Int)) (= (f20 (f21 f22 ?v0) ?v0) (f14 (f18 f19 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f7 ?v0) ?v0) (f9 (f10 f11 ?v0) (f12 f13 2)))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f20 (f21 f22 ?v0) (f14 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f3 (f4 f7 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f20 (f21 f22 ?v0) (f14 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f3 (f4 f7 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f14 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f20 (f21 f22 (f14 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (+ (f14 f15 ?v1) 1))) (f3 (f4 f7 (f9 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f14 (f18 f19 (f14 ?v_0 ?v1)) ?v2) (f14 ?v_0 (f12 f13 (f20 (f21 f22 (f14 f15 ?v1)) (f14 f15 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f12 f13 (f20 (f21 f22 (f14 f15 ?v1)) (f14 f15 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f14 ?v_0 (f12 f13 (* 2 (f14 f15 ?v1)))) (f14 (f18 f19 (f14 ?v_0 ?v1)) (f12 f13 2))))))
(assert (forall ((?v0 S2) (?v1 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (* 2 (f14 f15 ?v1)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f12 f13 2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 S6)) (let ((?v_0 (f18 f19 ?v0))) (= (f14 ?v_0 (f12 f13 (f20 (f21 f22 (f14 f15 ?v1)) (f14 f15 ?v2)))) (f14 (f18 f19 (f14 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S6)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f12 f13 (f20 (f21 f22 (f14 f15 ?v1)) (f14 f15 ?v2)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f7 ?v0) f17) f17)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f7 f17) ?v0) f17)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 (f3 (f4 f5 ?v0) ?v1)) (= ?v1 f17))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S2)) (= (f3 (f4 f5 ?v0) f17) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S2)) (= (f3 (f4 f5 f17) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S2) (?v1 S6)) (=> (not (= ?v0 f17)) (not (= (f9 (f10 f11 ?v0) ?v1) f17)))))
(assert (forall ((?v0 Int) (?v1 S6)) (=> (not (= ?v0 0)) (not (= (f14 (f18 f19 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2)) (= (= (f9 (f10 f11 ?v0) (f12 f13 2)) f17) (= ?v0 f17))))
(assert (forall ((?v0 Int)) (= (= (f14 (f18 f19 ?v0) (f12 f13 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S2) (?v1 S6)) (= (= (f9 (f10 f11 ?v0) ?v1) f17) (and (= ?v0 f17) (not (= ?v1 (f12 f13 0)))))))
(assert (forall ((?v0 Int) (?v1 S6)) (= (= (f14 (f18 f19 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f12 f13 0)))))))
(assert (= (f9 (f10 f11 f17) (f12 f13 2)) f17))
(assert (= (f14 (f18 f19 0) (f12 f13 2)) 0))
(assert (forall ((?v0 S6)) (= (f9 (f10 f11 f17) (f12 f13 (+ (f14 f15 ?v0) 1))) f17)))
(assert (forall ((?v0 S6)) (= (f14 (f18 f19 0) (f12 f13 (+ (f14 f15 ?v0) 1))) 0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f7 ?v0))) (= (f3 (f4 f7 (f3 ?v_0 ?v1)) (f3 (f4 f7 ?v2) ?v3)) (f3 (f4 f7 (f3 ?v_0 ?v2)) (f3 (f4 f7 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) (f20 (f21 f22 ?v2) ?v3)) (f20 (f21 f22 (f20 ?v_0 ?v2)) (f20 (f21 f22 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f4 f7 (f3 (f4 f7 ?v0) ?v1))) (?v_0 (f4 f7 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f21 f22 (f20 (f21 f22 ?v0) ?v1))) (?v_0 (f21 f22 ?v2))) (= (f20 ?v_1 (f20 ?v_0 ?v3)) (f20 ?v_0 (f20 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f4 f7 ?v0)) (?v_1 (f3 (f4 f7 ?v2) ?v3))) (= (f3 (f4 f7 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f7 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f21 f22 ?v0)) (?v_1 (f20 (f21 f22 ?v2) ?v3))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v_1) (f20 ?v_0 (f20 (f21 f22 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f7 ?v0))) (= (f3 (f4 f7 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f7 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2) (f20 (f21 f22 (f20 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f4 f7 ?v0))) (= (f3 (f4 f7 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f7 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (f20 (f21 f22 (f20 ?v_0 ?v1)) ?v2) (f20 ?v_0 (f20 (f21 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S6)) (= (f12 f13 (f14 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f14 f15 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f14 f15 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
