(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S2)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 Int) S3)
(declare-fun f7 () S4)
(declare-fun f8 (S5 S2) S2)
(declare-fun f9 (S6 S2) S5)
(declare-fun f10 () S6)
(declare-fun f11 () S2)
(declare-fun f12 () S6)
(declare-fun f13 (S7 S3) S2)
(declare-fun f14 (S8 S2) S7)
(declare-fun f15 () S8)
(declare-fun f16 () S2)
(declare-fun f17 (S9 Int) Int)
(declare-fun f18 () S9)
(declare-fun f19 () S3)
(declare-fun f20 () S3)
(declare-fun f21 (S10 S3) S3)
(declare-fun f22 (S11 S3) S10)
(declare-fun f23 () S11)
(declare-fun f24 (S12 Int) S9)
(declare-fun f25 () S12)
(declare-fun f26 () S11)
(declare-fun f27 (S13 Int) S14)
(declare-fun f28 () S13)
(declare-fun f29 (S14 S3) Int)
(declare-fun f30 () S11)
(declare-fun f31 () S14)
(declare-fun f32 () S12)
(declare-fun f33 () S12)
(declare-fun f34 (Int S15) S1)
(declare-fun f35 (S15 Int) S1)
(declare-fun f36 (S2 S16) S1)
(declare-fun f37 (S16 S2) S1)
(declare-fun f38 (S17 S11) S11)
(declare-fun f39 (S18 S3) S17)
(declare-fun f40 () S18)
(declare-fun f41 (S19 S6) S8)
(declare-fun f42 (S20 S2) S19)
(declare-fun f43 () S20)
(declare-fun f44 (S21 S12) S13)
(declare-fun f45 (S22 Int) S21)
(declare-fun f46 () S22)
(declare-fun f47 () S5)
(declare-fun f48 (S3 S3) S1)
(declare-fun f49 () S15)
(declare-fun f50 () S16)
(assert (not (= f1 f2)))
(assert (not (not (= f3 f4))))
(assert (not (= f5 (f6 f7 0))))
(assert (= (f8 (f9 f10 f11) (f8 (f9 f12 (f13 (f14 f15 f3) f5)) f16)) f4))
(assert (not (= f16 f4)))
(assert (= (f8 (f9 f10 f11) (f8 (f9 f12 (f13 (f14 f15 f3) f5)) f16)) f4))
(assert (= (f17 f18 0) 0))
(assert (forall ((?v0 S3)) (= (= f19 ?v0) (= ?v0 f19))))
(assert (forall ((?v0 S2)) (= (= f4 ?v0) (= ?v0 f4))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f17 f18 ?v0) 0) (= ?v0 0))))
(assert (not (= f20 f19)))
(assert (not (= f11 f4)))
(assert (not (= 1 0)))
(assert (not (= f19 f20)))
(assert (not (= f4 f11)))
(assert (not (= 0 1)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 f19) ?v0) f19)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 f4) ?v0) f4)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 f19) ?v0) f19)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 f4) ?v0) f4)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 f4) ?v0) f4)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 f4) ?v0) f4)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 ?v0) f19) f19)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 ?v0) f4) f4)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 ?v0) f19) f19)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 ?v0) f4) f4)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 ?v0) f4) f4)))
(assert (not (= f5 (f6 f7 0))))
(assert (=> (forall ((?v0 S2)) (=> (= (f8 (f9 f10 f11) (f8 (f9 f12 (f13 (f14 f15 ?v0) f5)) f16)) f4) false)) false))
(assert (= (f17 f18 1) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 f18 (f17 (f24 f25 ?v0) ?v1)) (f17 (f24 f25 (f17 f18 ?v0)) (f17 f18 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f17 f18 ?v0) (f17 f18 ?v1)))) (= (f17 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 f20) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 f11) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 f20) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 f11) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 f20) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 f11) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (= f20 ?v0) (= ?v0 f20))))
(assert (forall ((?v0 S2)) (= (= f11 ?v0) (= ?v0 f11))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f26 ?v0) (f6 f7 0)) f20)))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 ?v0) (f6 f7 0)) f11)))
(assert (forall ((?v0 Int)) (= (f29 (f27 f28 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f26 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f29 (f27 f28 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 ?v0) f20) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 ?v0) f11) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 ?v0) f20) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 ?v0) f11) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 ?v0) f20) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 ?v0) f11) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f21 (f22 f23 ?v0) ?v1) (f21 (f22 f23 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f9 f12 ?v0) ?v1) (f8 (f9 f12 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 (f24 f25 ?v0) ?v1) (f17 (f24 f25 ?v1) ?v0))))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 ?v0) ?v0) (f13 (f14 f15 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f23 ?v0) ?v0) (f21 (f22 f26 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (= (f17 (f24 f25 ?v0) ?v0) (f29 (f27 f28 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f30 ?v0) ?v0) (f21 (f22 f23 (f21 (f22 f30 f20) f20)) ?v0))))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) ?v0) (f8 (f9 f12 (f8 (f9 f10 f11) f11)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (f17 (f24 f25 (+ 1 1)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1))) (f8 (f9 f12 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1))) (f21 (f22 f23 ?v0) (f21 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1))) (f17 (f24 f25 ?v0) (f29 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f6 f7 (+ (* 2 (f29 f31 ?v1)) 1))) (f8 (f9 f12 ?v0) (f8 (f9 f12 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (let ((?v_1 (f21 ?v_0 ?v1))) (= (f21 ?v_0 (f6 f7 (+ (* 2 (f29 f31 ?v1)) 1))) (f21 (f22 f23 ?v0) (f21 (f22 f23 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f29 ?v_0 ?v1))) (= (f29 ?v_0 (f6 f7 (+ (* 2 (f29 f31 ?v1)) 1))) (f17 (f24 f25 ?v0) (f17 (f24 f25 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f8 (f9 f12 ?v0) (f13 ?v_0 ?v1)) (f13 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 (f22 f23 ?v0) (f21 ?v_0 ?v1)) (f21 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f17 (f24 f25 ?v0) (f29 ?v_0 ?v1)) (f29 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f9 f10 ?v0)) (?v_0 (f9 f10 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f22 f23 ?v0)) (?v_0 (f22 f23 ?v1))) (= (f21 ?v_1 (f21 ?v_0 ?v2)) (f21 ?v_0 (f21 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f9 f12 ?v0)) (?v_0 (f9 f12 ?v1))) (= (f8 ?v_1 (f8 ?v_0 ?v2)) (f8 ?v_0 (f8 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f24 f25 ?v0)) (?v_0 (f24 f25 ?v1))) (= (f17 ?v_1 (f17 ?v_0 ?v2)) (f17 ?v_0 (f17 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f21 (f22 f30 ?v0) (f21 (f22 f23 ?v1) ?v0)) (f21 (f22 f23 (f21 (f22 f30 ?v1) f20)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f9 f10 ?v0) (f8 (f9 f12 ?v1) ?v0)) (f8 (f9 f12 (f8 (f9 f10 ?v1) f11)) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (f17 (f24 f25 ?v1) ?v0)) (f17 (f24 f25 (+ ?v1 1)) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f21 (f22 f23 ?v1) ?v2)) (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f12 ?v0))) (= (f8 ?v_0 (f8 (f9 f12 ?v1) ?v2)) (f8 (f9 f12 (f8 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (f17 (f24 f25 ?v1) ?v2)) (f17 (f24 f25 (f17 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f12 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 ?v_0 (f21 (f22 f30 ?v1) ?v2)) (f21 (f22 f30 (f21 ?v_0 ?v1)) (f21 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f12 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (+ ?v1 ?v2)) (+ (f17 ?v_0 ?v1) (f17 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f12 ?v0))) (= (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2)) (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (let ((?v_1 (f13 ?v_0 ?v1))) (= (f13 ?v_0 (f6 f7 (* 2 (f29 f31 ?v1)))) (f8 (f9 f12 ?v_1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (let ((?v_1 (f21 ?v_0 ?v1))) (= (f21 ?v_0 (f6 f7 (* 2 (f29 f31 ?v1)))) (f21 (f22 f23 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f29 ?v_0 ?v1))) (= (f29 ?v_0 (f6 f7 (* 2 (f29 f31 ?v1)))) (f17 (f24 f25 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f17 f18 ?v0))) (= (f17 (f24 f25 ?v_0) ?v_0) (f17 (f24 f25 ?v0) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f22 f23 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f21 (f22 f30 (f21 ?v_0 ?v2)) (f21 ?v_1 ?v3)) (f21 (f22 f30 (f21 ?v_0 ?v3)) (f21 ?v_1 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f9 f12 ?v0)) (?v_1 (f9 f12 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f8 (f9 f10 (f8 ?v_0 ?v2)) (f8 ?v_1 ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v3)) (f8 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f24 f25 ?v0)) (?v_1 (f24 f25 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (f17 ?v_0 ?v2) (f17 ?v_1 ?v3)) (+ (f17 ?v_0 ?v3) (f17 ?v_1 ?v2))))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f8 (f9 f12 (f13 ?v_0 ?v1)) ?v0) (f13 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v0) (f21 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f17 (f24 f25 (f29 ?v_0 ?v1)) ?v0) (f29 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f10 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2) (f13 ?v_0 (f6 f7 (f17 (f24 f25 (f29 f31 ?v1)) (f29 f31 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 (f22 f26 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f6 f7 (f17 (f24 f25 (f29 f31 ?v1)) (f29 f31 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 (f27 f28 (f29 ?v_0 ?v1)) ?v2) (f29 ?v_0 (f6 f7 (f17 (f24 f25 (f29 f31 ?v1)) (f29 f31 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f22 f23 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f12 ?v0))) (= (f8 (f9 f12 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f12 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 (f24 f25 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f22 f23 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f12 ?v0))) (= (f8 (f9 f12 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f8 (f9 f12 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 (f24 f25 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f21 (f22 f30 (f21 (f22 f23 ?v0) ?v1)) ?v1) (f21 (f22 f23 (f21 (f22 f30 ?v0) f20)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f8 (f9 f10 (f8 (f9 f12 ?v0) ?v1)) ?v1) (f8 (f9 f12 (f8 (f9 f10 ?v0) f11)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f17 (f24 f25 ?v0) ?v1) ?v1) (f17 (f24 f25 (+ ?v0 1)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f10 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v2) (f21 (f22 f23 (f21 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f12 ?v0))) (= (f8 (f9 f12 (f8 ?v_0 ?v1)) ?v2) (f8 (f9 f12 (f8 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 (f24 f25 (f17 ?v_0 ?v1)) ?v2) (f17 (f24 f25 (f17 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f17 (f24 f32 ?v0) ?v1) ?v2) (f17 (f24 f32 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f17 (f24 f33 ?v0) ?v1) ?v2) (f17 (f24 f33 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (= (f13 (f14 f15 (f8 (f9 f12 ?v0) ?v1)) ?v2) (f8 (f9 f12 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f21 (f22 f26 (f21 (f22 f23 ?v0) ?v1)) ?v2) (f21 (f22 f23 (f21 (f22 f26 ?v0) ?v2)) (f21 (f22 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f29 (f27 f28 (f17 (f24 f25 ?v0) ?v1)) ?v2) (f17 (f24 f25 (f29 (f27 f28 ?v0) ?v2)) (f29 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f21 (f22 f23 (f21 (f22 f30 ?v0) ?v1)) ?v2) (f21 (f22 f30 (f21 (f22 f23 ?v0) ?v2)) (f21 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f8 (f9 f12 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f8 (f9 f12 ?v0) ?v2)) (f8 (f9 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f17 (f24 f25 (+ ?v0 ?v1)) ?v2) (+ (f17 (f24 f25 ?v0) ?v2) (f17 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f21 (f22 f23 (f21 (f22 f30 ?v0) ?v1)) ?v2) (f21 (f22 f30 (f21 (f22 f23 ?v0) ?v2)) (f21 (f22 f23 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f8 (f9 f12 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f8 (f9 f12 ?v0) ?v2)) (f8 (f9 f12 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f17 (f24 f25 (+ ?v0 ?v1)) ?v2) (+ (f17 (f24 f25 ?v0) ?v2) (f17 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f8 (f9 f12 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f8 (f9 f12 ?v0) ?v2)) (f8 (f9 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f8 (f9 f12 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f8 (f9 f12 ?v0) ?v2)) (f8 (f9 f12 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 ?v0))) (= (= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f8 (f9 f12 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2)) (f13 ?v_0 (f6 f7 (+ (f29 f31 ?v1) (f29 f31 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) (f21 ?v_0 ?v2)) (f21 ?v_0 (f6 f7 (+ (f29 f31 ?v1) (f29 f31 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f17 (f24 f25 (f29 ?v_0 ?v1)) (f29 ?v_0 ?v2)) (f29 ?v_0 (f6 f7 (+ (f29 f31 ?v1) (f29 f31 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f21 (f22 f23 ?v2) ?v3))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v_1) (f21 ?v_0 (f21 (f22 f23 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f9 f12 ?v0)) (?v_1 (f8 (f9 f12 ?v2) ?v3))) (= (f8 (f9 f12 (f8 ?v_0 ?v1)) ?v_1) (f8 ?v_0 (f8 (f9 f12 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f24 f25 ?v0)) (?v_1 (f17 (f24 f25 ?v2) ?v3))) (= (f17 (f24 f25 (f17 ?v_0 ?v1)) ?v_1) (f17 ?v_0 (f17 (f24 f25 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f22 f23 (f21 (f22 f23 ?v0) ?v1))) (?v_0 (f22 f23 ?v2))) (= (f21 ?v_1 (f21 ?v_0 ?v3)) (f21 ?v_0 (f21 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f9 f12 (f8 (f9 f12 ?v0) ?v1))) (?v_0 (f9 f12 ?v2))) (= (f8 ?v_1 (f8 ?v_0 ?v3)) (f8 ?v_0 (f8 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f24 f25 (f17 (f24 f25 ?v0) ?v1))) (?v_0 (f24 f25 ?v2))) (= (f17 ?v_1 (f17 ?v_0 ?v3)) (f17 ?v_0 (f17 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f21 (f22 f30 (f21 (f22 f23 ?v0) ?v1)) (f21 (f22 f23 ?v2) ?v1)) (f21 (f22 f23 (f21 (f22 f30 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f8 (f9 f10 (f8 (f9 f12 ?v0) ?v1)) (f8 (f9 f12 ?v2) ?v1)) (f8 (f9 f12 (f8 (f9 f10 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f17 (f24 f25 ?v0) ?v1) (f17 (f24 f25 ?v2) ?v1)) (f17 (f24 f25 (+ ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f9 f10 ?v0))) (= (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 (f9 f10 ?v2) ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v2)) (f8 (f9 f10 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f22 f23 ?v0))) (= (f21 (f22 f23 (f21 ?v_0 ?v1)) (f21 (f22 f23 ?v2) ?v3)) (f21 (f22 f23 (f21 ?v_0 ?v2)) (f21 (f22 f23 ?v1) ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f9 f12 ?v0))) (= (f8 (f9 f12 (f8 ?v_0 ?v1)) (f8 (f9 f12 ?v2) ?v3)) (f8 (f9 f12 (f8 ?v_0 ?v2)) (f8 (f9 f12 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 (f24 f25 (f17 ?v_0 ?v1)) (f17 (f24 f25 ?v2) ?v3)) (f17 (f24 f25 (f17 ?v_0 ?v2)) (f17 (f24 f25 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f21 (f22 f30 (f21 (f22 f23 ?v0) ?v1)) (f21 (f22 f30 (f21 (f22 f23 ?v2) ?v1)) ?v3)) (f21 (f22 f30 (f21 (f22 f23 (f21 (f22 f30 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (f8 (f9 f10 (f8 (f9 f12 ?v0) ?v1)) (f8 (f9 f10 (f8 (f9 f12 ?v2) ?v1)) ?v3)) (f8 (f9 f10 (f8 (f9 f12 (f8 (f9 f10 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (f17 (f24 f25 ?v0) ?v1) (+ (f17 (f24 f25 ?v2) ?v1) ?v3)) (+ (f17 (f24 f25 (+ ?v0 ?v2)) ?v1) ?v3))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f22 f23 ?v0)) (?v_1 (f22 f23 ?v2))) (= (= (f21 (f22 f30 (f21 ?v_0 ?v1)) (f21 ?v_1 ?v3)) (f21 (f22 f30 (f21 ?v_0 ?v3)) (f21 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f9 f12 ?v0)) (?v_1 (f9 f12 ?v2))) (= (= (f8 (f9 f10 (f8 ?v_0 ?v1)) (f8 ?v_1 ?v3)) (f8 (f9 f10 (f8 ?v_0 ?v3)) (f8 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f24 f25 ?v0)) (?v_1 (f24 f25 ?v2))) (= (= (+ (f17 ?v_0 ?v1) (f17 ?v_1 ?v3)) (+ (f17 ?v_0 ?v3) (f17 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f9 f10 ?v0))) (=> (= (f8 ?v_0 ?v1) (f8 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 S15)) (= (= (f34 ?v0 ?v1) f1) (= (f35 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S16)) (= (= (f36 ?v0 ?v1) f1) (= (f37 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3) (?v4 S3)) (let ((?v_0 (f22 f23 ?v0))) (=> (not (= ?v0 f19)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f21 (f22 f30 ?v1) (f21 ?v_0 ?v3)) (f21 (f22 f30 ?v2) (f21 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (f9 f12 ?v0))) (=> (not (= ?v0 f4)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f8 (f9 f10 ?v1) (f8 ?v_0 ?v3)) (f8 (f9 f10 ?v2) (f8 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f24 f25 ?v0))) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (f17 ?v_0 ?v3)) (+ ?v2 (f17 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 (f21 (f22 f30 ?v0) ?v1)) (= ?v1 f19))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= ?v0 (f8 (f9 f10 ?v0) ?v1)) (= ?v1 f4))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f30 ?v0) f19) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) f4) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f30 ?v0) f19) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) f4) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f30 ?v0) f19) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 ?v0) f4) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f30 f19) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 f4) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f30 f19) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 f4) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f30 f19) ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f8 (f9 f10 f4) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f21 (f22 f23 ?v0) ?v1) f19) (or (= ?v0 f19) (= ?v1 f19)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f8 (f9 f12 ?v0) ?v1) f4) (or (= ?v0 f4) (= ?v1 f4)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 (f24 f25 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f19)) (=> (not (= ?v1 f19)) (not (= (f21 (f22 f23 ?v0) ?v1) f19))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f4)) (=> (not (= ?v1 f4)) (not (= (f8 (f9 f12 ?v0) ?v1) f4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f17 (f24 f25 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f8 (f9 f12 ?v0) ?v1) f4) (or (= ?v0 f4) (= ?v1 f4)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f17 (f24 f25 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2)) (= (f8 (f9 f12 ?v0) f4) f4)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f20 (f21 (f22 f23 ?v0) (f21 ?v_0 (f6 f7 (- (f29 f31 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) f11 (f8 (f9 f12 ?v0) (f13 ?v_0 (f6 f7 (- (f29 f31 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) 1 (f17 (f24 f25 ?v0) (f29 ?v_0 (f6 f7 (- (f29 f31 ?v1) 1)))))))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f26 f19) ?v0) (ite (= ?v0 (f6 f7 0)) f20 f19))))
(assert (forall ((?v0 S3)) (= (f13 (f14 f15 f4) ?v0) (ite (= ?v0 (f6 f7 0)) f11 f4))))
(assert (forall ((?v0 S3)) (= (f29 (f27 f28 0) ?v0) (ite (= ?v0 (f6 f7 0)) 1 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (+ (f29 (f27 f28 ?v0) ?v_0) (f29 (f27 f28 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (f17 (f24 f25 ?v0) ?v0) (f17 (f24 f25 ?v1) ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f26 f20) ?v0) f20)))
(assert (forall ((?v0 S3)) (= (f13 (f14 f15 f11) ?v0) f11)))
(assert (forall ((?v0 S3)) (= (f29 (f27 f28 1) ?v0) 1)))
(assert (= (f21 (f22 f26 f20) (f6 f7 2)) f20))
(assert (= (f13 (f14 f15 f11) (f6 f7 2)) f11))
(assert (= (f29 (f27 f28 1) (f6 f7 2)) 1))
(assert (forall ((?v0 S3)) (= (f21 (f22 f26 ?v0) (f6 f7 0)) f20)))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 ?v0) (f6 f7 0)) f11)))
(assert (forall ((?v0 Int)) (= (f29 (f27 f28 ?v0) (f6 f7 0)) 1)))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1))) (f8 (f9 f12 ?v0) (f13 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1))) (f21 (f22 f23 ?v0) (f21 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1))) (f17 (f24 f25 ?v0) (f29 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1))) (f8 (f9 f12 (f13 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1))) (f21 (f22 f23 (f21 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 ?v_0 (f6 f7 (+ (f29 f31 ?v1) 1))) (f17 (f24 f25 (f29 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 ?v0) (f6 f7 2)) (f8 (f9 f12 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f26 ?v0) (f6 f7 2)) (f21 (f22 f23 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f29 (f27 f28 ?v0) (f6 f7 2)) (f17 (f24 f25 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 ?v0) (f6 f7 3)) (f8 (f9 f12 (f8 (f9 f12 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f26 ?v0) (f6 f7 3)) (f21 (f22 f23 (f21 (f22 f23 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f29 (f27 f28 ?v0) (f6 f7 3)) (f17 (f24 f25 (f17 (f24 f25 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 ?v_0 ?v1) (ite (= ?v1 (f6 f7 0)) (f6 f7 1) (f6 f7 (f17 (f24 f25 (f29 f31 ?v0)) (f29 f31 (f21 ?v_0 (f6 f7 (- (f29 f31 ?v1) 1)))))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 0)) (?v_2 (f29 f31 ?v0)) (?v_1 (f29 f31 ?v1))) (= (f6 f7 (f17 (f24 f25 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f6 f7 (+ ?v_1 (f17 (f24 f25 (f29 f31 (f6 f7 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f29 f31 ?v0))) (= (f6 f7 (* ?v_0 2)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f29 f31 ?v0))) (= (f6 f7 (* 2 ?v_0)) (f6 f7 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f29 (f27 f28 (f17 f18 ?v0)) ?v_0) (f29 (f27 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (* 2 (f29 f31 ?v1)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 ?v_0 (f6 f7 (* 2 (f29 f31 ?v1)))) (f21 (f22 f26 (f21 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 ?v_0 (f6 f7 (* 2 (f29 f31 ?v1)))) (f29 (f27 f28 (f29 ?v_0 ?v1)) (f6 f7 2))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (f17 (f24 f25 (f29 f31 ?v1)) (f29 f31 ?v2)))) (f13 (f14 f15 (f13 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 ?v_0 (f6 f7 (f17 (f24 f25 (f29 f31 ?v1)) (f29 f31 ?v2)))) (f21 (f22 f26 (f21 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 ?v_0 (f6 f7 (f17 (f24 f25 (f29 f31 ?v1)) (f29 f31 ?v2)))) (f29 (f27 f28 (f29 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f21 (f22 f26 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f29 (f27 f28 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f29 (f27 f28 ?v0) (f6 f7 2)))) (= (f17 f18 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f17 f18 (f29 (f27 f28 ?v0) ?v1)) (f29 (f27 f28 (f17 f18 ?v0)) ?v1))))
(assert (forall ((?v0 S3)) (= (f21 (f22 f26 f19) (f6 f7 (+ (f29 f31 ?v0) 1))) f19)))
(assert (forall ((?v0 S3)) (= (f13 (f14 f15 f4) (f6 f7 (+ (f29 f31 ?v0) 1))) f4)))
(assert (forall ((?v0 S3)) (= (f29 (f27 f28 0) (f6 f7 (+ (f29 f31 ?v0) 1))) 0)))
(assert (= (f21 (f22 f26 f19) (f6 f7 2)) f19))
(assert (= (f13 (f14 f15 f4) (f6 f7 2)) f4))
(assert (= (f29 (f27 f28 0) (f6 f7 2)) 0))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f21 (f22 f26 ?v0) ?v1) f19) (and (= ?v0 f19) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (= (f13 (f14 f15 ?v0) ?v1) f4) (and (= ?v0 f4) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f29 (f27 f28 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f6 f7 0)))))))
(assert (forall ((?v0 S2)) (= (= (f13 (f14 f15 ?v0) (f6 f7 2)) f4) (= ?v0 f4))))
(assert (forall ((?v0 Int)) (= (= (f29 (f27 f28 ?v0) (f6 f7 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (not (= ?v0 f4)) (not (= (f13 (f14 f15 ?v0) ?v1) f4)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (not (= ?v0 0)) (not (= (f29 (f27 f28 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S2)) (let ((?v_0 (f29 f31 ?v1)) (?v_1 (f29 f31 ?v0)) (?v_2 (f14 f15 ?v2))) (=> (<= ?v_1 ?v_0) (= (f13 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f8 (f9 f12 (f13 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f29 f31 ?v1)) (?v_1 (f29 f31 ?v0)) (?v_2 (f22 f26 ?v2))) (=> (<= ?v_1 ?v_0) (= (f21 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f21 (f22 f23 (f21 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f29 f31 ?v1)) (?v_1 (f29 f31 ?v0)) (?v_2 (f27 f28 ?v2))) (=> (<= ?v_1 ?v_0) (= (f29 ?v_2 (f6 f7 (- (+ ?v_0 1) ?v_1))) (f17 (f24 f25 (f29 ?v_2 (f6 f7 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (= (f13 (f14 f15 (f8 (f9 f12 ?v0) ?v1)) ?v2) (f8 (f9 f12 (f13 (f14 f15 ?v0) ?v2)) (f13 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f21 (f22 f26 (f21 (f22 f23 ?v0) ?v1)) ?v2) (f21 (f22 f23 (f21 (f22 f26 ?v0) ?v2)) (f21 (f22 f26 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f29 (f27 f28 (f17 (f24 f25 ?v0) ?v1)) ?v2) (f17 (f24 f25 (f29 (f27 f28 ?v0) ?v2)) (f29 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f13 (f14 f15 ?v0) ?v1))) (= (f8 (f9 f12 ?v_0) ?v0) (f8 (f9 f12 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f21 (f22 f26 ?v0) ?v1))) (= (f21 (f22 f23 ?v_0) ?v0) (f21 (f22 f23 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f29 (f27 f28 ?v0) ?v1))) (= (f17 (f24 f25 ?v_0) ?v0) (f17 (f24 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (f29 f31 ?v1) (f29 f31 ?v2)))) (f8 (f9 f12 (f13 ?v_0 ?v1)) (f13 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 ?v_0 (f6 f7 (+ (f29 f31 ?v1) (f29 f31 ?v2)))) (f21 (f22 f23 (f21 ?v_0 ?v1)) (f21 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 ?v_0 (f6 f7 (+ (f29 f31 ?v1) (f29 f31 ?v2)))) (f17 (f24 f25 (f29 ?v_0 ?v1)) (f29 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f13 ?v_0 (f6 f7 (+ (* 2 (f29 f31 ?v1)) 1))) (f8 (f9 f12 ?v0) (f13 (f14 f15 (f13 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f22 f26 ?v0))) (= (f21 ?v_0 (f6 f7 (+ (* 2 (f29 f31 ?v1)) 1))) (f21 (f22 f23 ?v0) (f21 (f22 f26 (f21 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 ?v_0 (f6 f7 (+ (* 2 (f29 f31 ?v1)) 1))) (f17 (f24 f25 ?v0) (f29 (f27 f28 (f29 ?v_0 ?v1)) (f6 f7 2)))))))
(assert (= f26 (f38 (f39 f40 f20) f23)))
(assert (= f15 (f41 (f42 f43 f11) f12)))
(assert (= f28 (f44 (f45 f46 1) f25)))
(assert (forall ((?v0 S3) (?v1 S2)) (let ((?v_0 (f29 f31 ?v0)) (?v_1 (f14 f15 ?v1))) (=> (< 0 ?v_0) (= (f8 (f9 f12 (f13 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f13 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f29 f31 ?v0)) (?v_1 (f22 f26 ?v1))) (=> (< 0 ?v_0) (= (f21 (f22 f23 (f21 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f21 ?v_1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 Int)) (let ((?v_0 (f29 f31 ?v0)) (?v_1 (f27 f28 ?v1))) (=> (< 0 ?v_0) (= (f17 (f24 f25 (f29 ?v_1 (f6 f7 (- ?v_0 1)))) ?v1) (f29 ?v_1 ?v0))))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S2)) (= (f13 (f14 f15 (f8 f47 ?v0)) (f6 f7 2)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (<= (+ (f17 (f24 f25 ?v3) ?v0) (f17 (f24 f25 ?v4) ?v2)) ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f29 f31 (f21 (f22 f26 ?v0) ?v1)) (f29 (f27 f28 (f29 f31 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f29 f31 (f21 (f22 f26 ?v0) ?v1))) (or (< 0 (f29 f31 ?v0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (f21 (f22 f26 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f29 (f27 f28 (f29 f31 ?v0)) ?v1) (f29 f31 (f21 (f22 f26 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 (+ 0 1)))) (= (= (f21 (f22 f26 ?v0) ?v1) ?v_0) (or (= ?v1 (f6 f7 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f6 f7 (f29 (f27 f28 ?v0) ?v1)) (f21 (f22 f26 (f6 f7 ?v0)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f26 ?v0))) (=> (< 0 (f29 f31 ?v0)) (=> (< (f29 f31 (f21 ?v_0 ?v1)) (f29 f31 (f21 ?v_0 ?v2))) (< (f29 f31 ?v1) (f29 f31 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f29 f31 ?v0)) (<= ?v_0 (f29 f31 (f21 (f22 f26 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S12) (?v2 Int) (?v3 S3)) (let ((?v_0 (f27 (f44 (f45 f46 ?v0) ?v1) ?v2))) (= (f29 ?v_0 (f6 f7 (+ (f29 f31 ?v3) 1))) (f17 (f24 ?v1 ?v2) (f29 ?v_0 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2) (?v3 S3)) (let ((?v_0 (f14 (f41 (f42 f43 ?v0) ?v1) ?v2))) (= (f13 ?v_0 (f6 f7 (+ (f29 f31 ?v3) 1))) (f8 (f9 ?v1 ?v2) (f13 ?v_0 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S11) (?v2 S3) (?v3 S3)) (let ((?v_0 (f22 (f38 (f39 f40 ?v0) ?v1) ?v2))) (= (f21 ?v_0 (f6 f7 (+ (f29 f31 ?v3) 1))) (f21 (f22 ?v1 ?v2) (f21 ?v_0 ?v3))))))
(assert (forall ((?v0 Int) (?v1 S12) (?v2 Int)) (= (f29 (f27 (f44 (f45 f46 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S6) (?v2 S2)) (= (f13 (f14 (f41 (f42 f43 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 S3) (?v1 S11) (?v2 S3)) (= (f21 (f22 (f38 (f39 f40 ?v0) ?v1) ?v2) (f6 f7 0)) ?v0)))
(assert (forall ((?v0 Int)) (<= 0 (f17 f18 ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f17 f18 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 ?v0) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f30 ?v0))) (=> (= (f48 (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) f1) (= (f48 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f48 (f21 (f22 f30 ?v0) ?v1) (f21 (f22 f30 ?v2) ?v1)) f1) (= (f48 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f48 ?v0 ?v1) f1) (=> (= (f48 ?v2 ?v3) f1) (= (f48 (f21 (f22 f30 ?v0) ?v2) (f21 (f22 f30 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f30 ?v2))) (=> (= (f48 ?v0 ?v1) f1) (= (f48 (f21 ?v_0 ?v0) (f21 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f48 ?v0 ?v1) f1) (= (f48 (f21 (f22 f30 ?v0) ?v2) (f21 (f22 f30 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f30 ?v0))) (= (= (f48 (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) f1) (= (f48 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f48 (f21 (f22 f30 ?v0) ?v1) (f21 (f22 f30 ?v2) ?v1)) f1) (= (f48 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f17 f18 (+ ?v0 ?v1)) (+ (f17 f18 ?v0) (f17 f18 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f17 f18 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f17 f18 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f48 f19 ?v0) f1) (=> (= (f48 ?v0 f20) f1) (= (f48 (f21 (f22 f26 ?v0) (f6 f7 (+ (f29 f31 ?v1) 1))) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (=> (<= ?v0 1) (<= (f29 (f27 f28 ?v0) (f6 f7 (+ (f29 f31 ?v1) 1))) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (or (and (= (f48 f19 ?v0) f1) (= (f48 ?v1 f19) f1)) (and (= (f48 ?v0 f19) f1) (= (f48 f19 ?v1) f1))) (= (f48 (f21 (f22 f23 ?v0) ?v1) f19) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f17 (f24 f25 ?v0) ?v1) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f17 f18 (f17 (f24 f25 ?v0) ?v1)) (f17 (f24 f25 (f17 f18 ?v0)) (f17 f18 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f17 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f48 ?v0 ?v1) f1) (=> (= (f48 ?v2 ?v3) f1) (=> (= (f48 f19 ?v1) f1) (=> (= (f48 f19 ?v2) f1) (= (f48 (f21 (f22 f23 ?v0) ?v2) (f21 (f22 f23 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f17 (f24 f25 ?v0) ?v2) (f17 (f24 f25 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f48 ?v0 ?v1) f1) (=> (= (f48 ?v2 ?v3) f1) (=> (= (f48 f19 ?v0) f1) (=> (= (f48 f19 ?v2) f1) (= (f48 (f21 (f22 f23 ?v0) ?v2) (f21 (f22 f23 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f17 (f24 f25 ?v0) ?v2) (f17 (f24 f25 ?v1) ?v3))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f17 ?v_0 ?v1) (f17 ?v_0 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f17 (f24 f25 ?v1) ?v2) (f17 (f24 f25 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v2))) (=> (= (f48 ?v0 ?v1) f1) (=> (= (f48 f19 ?v2) f1) (= (f48 (f21 ?v_0 ?v0) (f21 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f17 ?v_0 ?v0) (f17 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f23 ?v2))) (=> (= (f48 ?v0 ?v1) f1) (=> (= (f48 f19 ?v2) f1) (= (f48 (f21 ?v_0 ?v0) (f21 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f17 ?v_0 ?v0) (f17 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f48 ?v0 ?v1) f1) (=> (= (f48 f19 ?v2) f1) (= (f48 (f21 (f22 f23 ?v0) ?v2) (f21 (f22 f23 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f17 (f24 f25 ?v0) ?v2) (f17 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f17 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f48 ?v0 f19) f1) (=> (= (f48 f19 ?v1) f1) (= (f48 (f21 (f22 f23 ?v0) ?v1) f19) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f17 (f24 f25 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f48 f19 ?v0) f1) (=> (= (f48 ?v1 f19) f1) (= (f48 (f21 (f22 f23 ?v1) ?v0) f19) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f17 (f24 f25 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f48 f19 ?v0) f1) (=> (= (f48 ?v1 f19) f1) (= (f48 (f21 (f22 f23 ?v0) ?v1) f19) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f17 (f24 f25 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f48 f19 ?v0) f1) (=> (= (f48 f19 ?v1) f1) (= (f48 f19 (f21 (f22 f23 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f17 (f24 f25 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f17 (f24 f25 (f17 f18 ?v1)) ?v0) (f17 f18 (f17 (f24 f25 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f17 (f24 f25 ?v0) ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (f17 (f24 f25 ?v0) ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 Int)) (<= 0 (f17 (f24 f25 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v2 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (+ ?v0 ?v1) 0) (and (= ?v0 0) (= ?v1 0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 Int)) (= (<= (+ ?v0 ?v0) 0) (<= ?v0 0))))
(assert (forall ((?v0 Int)) (= (<= 0 (+ ?v0 ?v0)) (<= 0 ?v0))))
(assert (<= 0 1))
(assert (not (<= 1 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (=> (= (f29 (f27 f28 ?v0) ?v_0) (f29 (f27 f28 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 2))) (=> (= (f21 (f22 f26 ?v0) ?v_0) (f21 (f22 f26 ?v1) ?v_0)) (=> (= (f48 f19 ?v0) f1) (=> (= (f48 f19 ?v1) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (=> (<= (f29 (f27 f28 ?v0) ?v_0) (f29 (f27 f28 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 2))) (=> (= (f48 (f21 (f22 f26 ?v0) ?v_0) (f21 (f22 f26 ?v1) ?v_0)) f1) (=> (= (f48 f19 ?v1) f1) (= (f48 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (let ((?v_0 (f6 f7 (+ (f29 f31 ?v1) 1)))) (=> (= (f29 (f27 f28 ?v0) ?v_0) (f29 (f27 f28 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 (+ (f29 f31 ?v1) 1)))) (=> (= (f21 (f22 f26 ?v0) ?v_0) (f21 (f22 f26 ?v2) ?v_0)) (=> (= (f48 f19 ?v0) f1) (=> (= (f48 f19 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (let ((?v_0 (f6 f7 (+ (f29 f31 ?v1) 1)))) (=> (<= (f29 (f27 f28 ?v0) ?v_0) (f29 (f27 f28 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 (+ (f29 f31 ?v1) 1)))) (=> (= (f48 (f21 (f22 f26 ?v0) ?v_0) (f21 (f22 f26 ?v2) ?v_0)) f1) (=> (= (f48 f19 ?v2) f1) (= (f48 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f29 (f27 f28 ?v0) ?v1) (f29 (f27 f28 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f29 f31 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f21 (f22 f26 ?v0) ?v1) (f21 (f22 f26 ?v2) ?v1)) (=> (= (f48 f19 ?v0) f1) (=> (= (f48 f19 ?v2) f1) (=> (< 0 (f29 f31 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f29 (f27 f28 ?v0) ?v2) (f29 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f48 ?v0 ?v1) f1) (=> (= (f48 f19 ?v0) f1) (= (f48 (f21 (f22 f26 ?v0) ?v2) (f21 (f22 f26 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f29 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f48 f19 ?v0) f1) (= (f48 f19 (f21 (f22 f26 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f29 (f27 f28 (f17 f18 ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= 0 (f29 (f27 f28 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 1 ?v0) (<= 1 (f29 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f48 f20 ?v0) f1) (= (f48 f20 (f21 (f22 f26 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (<= (f29 f31 ?v0) (f29 f31 ?v1)) (=> (<= 1 ?v2) (<= (f29 ?v_0 ?v0) (f29 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f26 ?v2))) (=> (<= (f29 f31 ?v0) (f29 f31 ?v1)) (=> (= (f48 f20 ?v2) f1) (= (f48 (f21 ?v_0 ?v0) (f21 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (<= 0 (+ (f17 (f24 f25 ?v0) ?v0) (f17 (f24 f25 ?v1) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (+ (f17 (f24 f25 ?v0) ?v0) (f17 (f24 f25 ?v1) ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f17 (f24 f25 ?v0) ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f17 (f24 f25 ?v1) ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (<= 0 (+ (f29 (f27 f28 ?v0) ?v_0) (f29 (f27 f28 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (<= (+ (f29 (f27 f28 ?v0) ?v_0) (f29 (f27 f28 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f27 f28 ?v2))) (=> (<= (f29 f31 ?v0) (f29 f31 ?v1)) (=> (<= 0 ?v2) (=> (<= ?v2 1) (<= (f29 ?v_0 ?v1) (f29 ?v_0 ?v0))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f22 f26 ?v2))) (=> (<= (f29 f31 ?v0) (f29 f31 ?v1)) (=> (= (f48 f19 ?v2) f1) (=> (= (f48 ?v2 f20) f1) (= (f48 (f21 ?v_0 ?v1) (f21 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f29 (f27 f28 ?v0) (f6 f7 (* 2 (f29 f31 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 (f29 (f27 f28 ?v0) (f6 f7 (+ (* 2 (f29 f31 ?v1)) 1)))) (<= 0 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f6 f7 (f17 (f24 f25 ?v0) ?v1)) (f6 f7 (f17 (f24 f25 (f29 f31 (f6 f7 (- ?v0)))) (f29 f31 (f6 f7 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f6 f7 (f17 (f24 f25 ?v0) ?v1)) (f6 f7 (f17 (f24 f25 (f29 f31 (f6 f7 ?v0))) (f29 f31 (f6 f7 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 (f27 f28 (f29 ?v_0 ?v1)) ?v2) (f29 ?v_0 (f6 f7 (f17 (f24 f25 (f29 f31 ?v1)) (f29 f31 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 (f24 f25 (f29 f31 ?v0)) (f29 f31 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f17 (f24 f25 (f29 f31 ?v0)) (f29 f31 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 (f24 f25 ?v0) ?v1))) (= (f6 f7 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f6 f7 (f17 (f24 f25 (f29 f31 (f6 f7 (ite (< ?v0 0) (- ?v0) ?v0)))) (f29 f31 (f6 f7 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= (f29 (f27 f28 ?v0) (f6 f7 (* 2 (f29 f31 ?v1)))) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v1) (=> (<= 0 ?v3) (=> (<= 0 ?v4) (=> (= (+ ?v3 ?v4) 1) (< (+ (f17 (f24 f25 ?v3) ?v0) (f17 (f24 f25 ?v4) ?v2)) ?v1))))))))
(assert (forall ((?v0 Int)) (=> (= (f34 ?v0 f49) f1) (not (= (+ (+ 1 ?v0) ?v0) 0)))))
(assert (forall ((?v0 S2)) (=> (= (f36 ?v0 f50) f1) (not (= (f8 (f9 f10 (f8 (f9 f10 f11) ?v0)) ?v0) f4)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f29 (f27 f28 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f29 (f27 f28 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 (f24 f25 ?v0) ?v1) (f17 (f24 f25 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f27 f28 ?v0))) (= (f29 ?v_0 (f6 f7 (+ (f29 f31 ?v1) (f29 f31 ?v2)))) (f17 (f24 f25 (f29 ?v_0 ?v1)) (f29 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (+ ?v1 ?v2)) (+ (f17 ?v_0 ?v1) (f17 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 ?v_0 (- ?v1 ?v2)) (- (f17 ?v_0 ?v1) (f17 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f17 (f24 f25 (- ?v0)) ?v1) (- (f17 (f24 f25 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f17 (f24 f25 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v0))) (= (f17 (f24 f25 (f17 ?v_0 ?v1)) ?v2) (f17 ?v_0 (f17 (f24 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f17 (f24 f25 (+ ?v0 ?v1)) ?v2) (+ (f17 (f24 f25 ?v0) ?v2) (f17 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f17 (f24 f25 (- ?v0 ?v1)) ?v2) (- (f17 (f24 f25 ?v0) ?v2) (f17 (f24 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f17 (f24 f25 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f24 f25 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f17 ?v_0 ?v0) (f17 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f29 f31 ?v2))) (let ((?v_1 (f24 f25 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f17 ?v_1 ?v0) (f17 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 (f24 f25 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f17 (f24 f25 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3)) (= (f6 f7 (f29 f31 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f29 f31 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f29 f31 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
