(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S5) S5)
(declare-fun f7 (S6 S5) S4)
(declare-fun f8 () S6)
(declare-fun f9 (S7 S8) S5)
(declare-fun f10 (S9 S5) S7)
(declare-fun f11 () S9)
(declare-fun f12 () S5)
(declare-fun f13 () S8)
(declare-fun f14 () S5)
(declare-fun f15 () S4)
(declare-fun f16 () S5)
(declare-fun f17 () S6)
(declare-fun f18 () S6)
(declare-fun f19 () S5)
(declare-fun f20 (S10 Int) S8)
(declare-fun f21 () S10)
(declare-fun f22 (S11 S8) Int)
(declare-fun f23 (S12 Int) S11)
(declare-fun f24 () S12)
(declare-fun f25 () S3)
(declare-fun f26 (S13 S8) S8)
(declare-fun f27 (S14 S8) S13)
(declare-fun f28 () S14)
(declare-fun f29 () S8)
(declare-fun f30 () S14)
(declare-fun f31 () S11)
(declare-fun f32 () S2)
(declare-fun f33 () S14)
(declare-fun f34 () S8)
(declare-fun f35 () S3)
(declare-fun f36 () S3)
(declare-fun f37 (S15 S3) S12)
(declare-fun f38 (S16 Int) S15)
(declare-fun f39 () S16)
(declare-fun f40 (S17 S6) S9)
(declare-fun f41 (S18 S5) S17)
(declare-fun f42 () S18)
(declare-fun f43 (S19 S14) S14)
(declare-fun f44 (S20 S8) S19)
(declare-fun f45 () S20)
(declare-fun f46 () S4)
(declare-fun f47 () S4)
(declare-fun f48 () S5)
(declare-fun f49 (Int S21) S1)
(declare-fun f50 () S21)
(declare-fun f51 (S5 S22) S1)
(declare-fun f52 () S22)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (= (f6 (f7 f8 (f9 (f10 f11 f12) f13)) f14) (f6 f15 f16))))
(assert (= (f6 (f7 f17 (f6 (f7 f18 f16) (f6 (f7 f8 (f9 (f10 f11 f12) f13)) f14))) f16) (f6 (f7 f17 f19) f16)))
(assert (not (= f13 (f20 f21 0))))
(assert (not (= f14 f19)))
(assert (not (= f12 f19)))
(assert (= (f6 (f7 f17 (f6 (f7 f18 f16) (f6 (f7 f8 (f9 (f10 f11 f12) f13)) f14))) f16) (f6 (f7 f17 f19) f16)))
(assert (= (f6 (f7 f18 f16) (f6 (f7 f8 (f9 (f10 f11 f12) f13)) f14)) f19))
(assert (=> (forall ((?v0 S5)) (=> (= (f6 (f7 f18 f16) (f6 (f7 f8 (f9 (f10 f11 ?v0) f13)) f14)) f19) false)) false))
(assert (forall ((?v0 S5) (?v1 S8)) (= (f9 (f10 f11 (f6 f15 ?v0)) ?v1) (f6 (f7 f8 (f9 (f10 f11 (f6 f15 f16)) ?v1)) (f9 (f10 f11 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f22 (f23 f24 (- ?v0)) ?v1) (f3 (f4 f25 (f22 (f23 f24 (- 1)) ?v1)) (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S5)) (= (= (f9 (f10 f11 ?v0) (f20 f21 2)) f16) (or (= ?v0 f16) (= ?v0 (f6 f15 f16))))))
(assert (forall ((?v0 Int)) (= (= (f22 (f23 f24 ?v0) (f20 f21 2)) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) f29 (f26 (f27 f30 ?v0) (f26 ?v_0 (f20 f21 (- (f22 f31 ?v1) 1)))))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) f16 (f6 (f7 f8 ?v0) (f9 ?v_0 (f20 f21 (- (f22 f31 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) 1 (f3 (f4 f25 ?v0) (f22 ?v_0 (f20 f21 (- (f22 f31 ?v1) 1)))))))))
(assert (forall ((?v0 S5)) (= (f6 f15 ?v0) (f6 (f7 f8 (f6 f15 f16)) ?v0))))
(assert (forall ((?v0 Int)) (= (- ?v0) (* (- 1) ?v0))))
(assert (forall ((?v0 S5)) (= (= (f6 (f7 f8 ?v0) ?v0) f16) (or (= ?v0 f16) (= ?v0 (f6 f15 f16))))))
(assert (forall ((?v0 Int)) (= (= (f3 (f4 f25 ?v0) ?v0) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f3 f32 (f22 (f23 f24 (- ?v0)) ?v1)) (f3 f32 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f20 f21 2))) (= (f9 (f10 f11 (f6 f15 ?v0)) ?v_0) (f9 (f10 f11 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 2))) (= (f22 (f23 f24 (- ?v0)) ?v_0) (f22 (f23 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f20 f21 (+ (+ 0 1) 1)))) (= (= (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (f6 f15 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 (+ (+ 0 1) 1)))) (= (= (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (- ?v1)))))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 f29) ?v0) f29)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 f16) ?v0) f16)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 1) ?v0) 1)))
(assert (= (f26 (f27 f28 f29) (f20 f21 2)) f29))
(assert (= (f9 (f10 f11 f16) (f20 f21 2)) f16))
(assert (= (f22 (f23 f24 1) (f20 f21 2)) 1))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f20 f21 0)) f29)))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f20 f21 0)) f16)))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f20 f21 0)) 1)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f33 f34) ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f18 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f33 ?v0) f34) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f18 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f18 ?v0) ?v1) (f6 (f7 f18 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= ?v0 (f26 (f27 f33 ?v0) ?v1)) (= ?v1 f34))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 (f6 (f7 f18 ?v0) ?v1)) (= ?v1 f19))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f7 f18 ?v0)) (?v_0 (f7 f18 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (= (f6 ?v_0 (f6 (f7 f18 ?v1) ?v2)) (f6 (f7 f18 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (= (f6 (f7 f18 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f18 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (= (f6 (f7 f18 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f18 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f18 ?v0))) (= (f6 (f7 f18 (f6 ?v_0 ?v1)) (f6 (f7 f18 ?v2) ?v3)) (f6 (f7 f18 (f6 ?v_0 ?v2)) (f6 (f7 f18 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2) (f9 ?v_0 (f20 f21 (f3 (f4 f25 (f22 f31 ?v1)) (f22 f31 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f20 f21 (f3 (f4 f25 (f22 f31 ?v1)) (f22 f31 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f20 f21 (f3 (f4 f25 (f22 f31 ?v1)) (f22 f31 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f20 f21 (* 2 (f22 f31 ?v1)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f20 f21 2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f20 f21 (* 2 (f22 f31 ?v1)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) (f20 f21 2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f20 f21 (* 2 (f22 f31 ?v1)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f20 f21 2))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f20 f21 (f3 (f4 f25 (f22 f31 ?v1)) (f22 f31 ?v2)))) (f9 (f10 f11 (f9 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f20 f21 (f3 (f4 f25 (f22 f31 ?v1)) (f22 f31 ?v2)))) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f20 f21 (f3 (f4 f25 (f22 f31 ?v1)) (f22 f31 ?v2)))) (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (= (= (f6 (f7 f18 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f18 (f6 (f7 f8 ?v3) ?v1)) ?v4)) (= (f6 (f7 f18 (f6 (f7 f8 (f6 (f7 f17 ?v0) ?v3)) ?v1)) ?v2) ?v4))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (f3 (f4 f25 ?v0) ?v1) ?v2) (+ (f3 (f4 f25 ?v3) ?v1) ?v4)) (= (+ (f3 (f4 f25 (- ?v0 ?v3)) ?v1) ?v2) ?v4))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (= (= (f6 (f7 f18 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f18 (f6 (f7 f8 ?v3) ?v1)) ?v4)) (= ?v2 (f6 (f7 f18 (f6 (f7 f8 (f6 (f7 f17 ?v3) ?v0)) ?v1)) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (= (= (+ (f3 (f4 f25 ?v0) ?v1) ?v2) (+ (f3 (f4 f25 ?v3) ?v1) ?v4)) (= ?v2 (+ (f3 (f4 f25 (- ?v3 ?v0)) ?v1) ?v4)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f17 (f6 ?v_0 ?v1)) (f6 (f7 f8 ?v2) ?v3)) (f6 (f7 f18 (f6 ?v_0 (f6 (f7 f17 ?v1) ?v3))) (f6 (f7 f8 (f6 (f7 f17 ?v0) ?v2)) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (- (f3 ?v_0 ?v1) (f3 (f4 f25 ?v2) ?v3)) (+ (f3 ?v_0 (- ?v1 ?v3)) (f3 (f4 f25 (- ?v0 ?v2)) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f17 ?v0) ?v1) (f6 (f7 f18 ?v0) (f6 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8) (?v4 S8)) (let ((?v_0 (f27 f30 ?v0))) (=> (not (= ?v0 f34)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f26 (f27 f33 ?v1) (f26 ?v_0 ?v3)) (f26 (f27 f33 ?v2) (f26 ?v_0 ?v4)))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (let ((?v_0 (f7 f8 ?v0))) (=> (not (= ?v0 f19)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (f6 (f7 f18 ?v1) (f6 ?v_0 ?v3)) (f6 (f7 f18 ?v2) (f6 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f4 f25 ?v0))) (=> (not (= ?v0 0)) (=> (and (= ?v1 ?v2) (not (= ?v3 ?v4))) (not (= (+ ?v1 (f3 ?v_0 ?v3)) (+ ?v2 (f3 ?v_0 ?v4)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ (f3 (f4 f25 ?v0) ?v0) (f3 (f4 f25 ?v1) ?v1)) 0) (and (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f18 ?v0) ?v1) f19) (= ?v1 (f6 f15 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ ?v0 ?v1) 0) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 2))) (= (= (+ (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f20 f21 (* 2 (f22 f31 ?v1))))) (= (f9 (f10 f11 (f6 f15 ?v0)) ?v_0) (f9 (f10 f11 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f20 f21 (* 2 (f22 f31 ?v1))))) (= (f22 (f23 f24 (- ?v0)) ?v_0) (f22 (f23 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f27 f30 ?v0)) (?v_1 (f27 f30 ?v2))) (= (= (f26 (f27 f33 (f26 ?v_0 ?v1)) (f26 ?v_1 ?v3)) (f26 (f27 f33 (f26 ?v_0 ?v3)) (f26 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v2))) (= (= (f6 (f7 f18 (f6 ?v_0 ?v1)) (f6 ?v_1 ?v3)) (f6 (f7 f18 (f6 ?v_0 ?v3)) (f6 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f25 ?v0)) (?v_1 (f4 f25 ?v2))) (= (= (+ (f3 ?v_0 ?v1) (f3 ?v_1 ?v3)) (+ (f3 ?v_0 ?v3) (f3 ?v_1 ?v1))) (or (= ?v0 ?v2) (= ?v1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (= (f26 (f27 f33 (f26 (f27 f30 ?v0) ?v1)) (f26 (f27 f33 (f26 (f27 f30 ?v2) ?v1)) ?v3)) (f26 (f27 f33 (f26 (f27 f30 (f26 (f27 f33 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f6 (f7 f18 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f18 (f6 (f7 f8 ?v2) ?v1)) ?v3)) (f6 (f7 f18 (f6 (f7 f8 (f6 (f7 f18 ?v0) ?v2)) ?v1)) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (f3 (f4 f25 ?v0) ?v1) (+ (f3 (f4 f25 ?v2) ?v1) ?v3)) (+ (f3 (f4 f25 (+ ?v0 ?v2)) ?v1) ?v3))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f26 (f27 f33 (f26 (f27 f30 ?v0) ?v1)) (f26 (f27 f30 ?v2) ?v1)) (f26 (f27 f30 (f26 (f27 f33 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f18 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 ?v2) ?v1)) (f6 (f7 f8 (f6 (f7 f18 ?v0) ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f25 ?v0) ?v1) (f3 (f4 f25 ?v2) ?v1)) (f3 (f4 f25 (+ ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f26 (f27 f30 (f26 (f27 f33 ?v0) ?v1)) ?v2) (f26 (f27 f33 (f26 (f27 f30 ?v0) ?v2)) (f26 (f27 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f6 (f7 f18 ?v0) ?v1)) ?v2) (f6 (f7 f18 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f25 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f25 ?v0) ?v2) (f3 (f4 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f26 (f27 f30 (f26 (f27 f33 ?v0) ?v1)) ?v2) (f26 (f27 f33 (f26 (f27 f30 ?v0) ?v2)) (f26 (f27 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f6 (f7 f18 ?v0) ?v1)) ?v2) (f6 (f7 f18 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f25 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f25 ?v0) ?v2) (f3 (f4 f25 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f27 f30 ?v0)) (?v_1 (f27 f30 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f26 (f27 f33 (f26 ?v_0 ?v2)) (f26 ?v_1 ?v3)) (f26 (f27 f33 (f26 ?v_0 ?v3)) (f26 ?v_1 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (f6 (f7 f18 (f6 ?v_0 ?v2)) (f6 ?v_1 ?v3)) (f6 (f7 f18 (f6 ?v_0 ?v3)) (f6 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f25 ?v0)) (?v_1 (f4 f25 ?v1))) (= (and (not (= ?v0 ?v1)) (not (= ?v2 ?v3))) (not (= (+ (f3 ?v_0 ?v2) (f3 ?v_1 ?v3)) (+ (f3 ?v_0 ?v3) (f3 ?v_1 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f30 ?v0))) (= (f26 ?v_0 (f26 (f27 f33 ?v1) ?v2)) (f26 (f27 f33 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f18 ?v1) ?v2)) (f6 (f7 f18 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f26 (f27 f30 ?v0) ?v1) f34) (or (= ?v0 f34) (= ?v1 f34)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f8 ?v0) ?v1) f19) (or (= ?v0 f19) (= ?v1 f19)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f25 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f34)) (=> (not (= ?v1 f34)) (not (= (f26 (f27 f30 ?v0) ?v1) f34))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (not (= ?v0 f19)) (=> (not (= ?v1 f19)) (not (= (f6 (f7 f8 ?v0) ?v1) f19))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f3 (f4 f25 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v1) f19) (or (= ?v0 f19) (= ?v1 f19)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f25 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f30 ?v0) f34) f34)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f19) f19)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f30 ?v0) f34) f34)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f19) f19)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f30 f34) ?v0) f34)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f19) ?v0) f19)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f30 f34) ?v0) f34)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f19) ?v0) f19)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (not (= f34 f29)))
(assert (not (= f19 f16)))
(assert (not (= 0 1)))
(assert (not (= f29 f34)))
(assert (not (= f16 f19)))
(assert (not (= 1 0)))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (not (= ?v0 f19)) (not (= (f9 (f10 f11 ?v0) ?v1) f19)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f22 (f23 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S5)) (= (= (f9 (f10 f11 ?v0) (f20 f21 2)) f19) (= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= (f22 (f23 f24 ?v0) (f20 f21 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f26 (f27 f28 ?v0) ?v1) f34) (and (= ?v0 f34) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (= (= (f9 (f10 f11 ?v0) ?v1) f19) (and (= ?v0 f19) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f22 (f23 f24 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f20 f21 0)))))))
(assert (= (f26 (f27 f28 f34) (f20 f21 2)) f34))
(assert (= (f9 (f10 f11 f19) (f20 f21 2)) f19))
(assert (= (f22 (f23 f24 0) (f20 f21 2)) 0))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 f34) (f20 f21 (+ (f22 f31 ?v0) 1))) f34)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 f19) (f20 f21 (+ (f22 f31 ?v0) 1))) f19)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 0) (f20 f21 (+ (f22 f31 ?v0) 1))) 0)))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 (f6 f15 f16)) (f20 f21 (* 2 (f22 f31 ?v0)))) f16)))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 (- 1)) (f20 f21 (* 2 (f22 f31 ?v0)))) 1)))
(assert (forall ((?v0 S8)) (let ((?v_0 (f6 f15 f16))) (= (f9 (f10 f11 ?v_0) (f20 f21 (+ (* 2 (f22 f31 ?v0)) 1))) ?v_0))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 (- 1)) (f20 f21 (+ (* 2 (f22 f31 ?v0)) 1))) (- 1))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f17 (f6 (f7 f8 ?v0) ?v0)) f16) (f6 (f7 f8 (f6 (f7 f18 ?v0) f16)) (f6 (f7 f17 ?v0) f16)))))
(assert (forall ((?v0 Int)) (= (- (f3 (f4 f25 ?v0) ?v0) 1) (f3 (f4 f25 (+ ?v0 1)) (- ?v0 1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f20 f21 (+ (+ 0 1) 1)))) (= (f6 (f7 f17 (f9 (f10 f11 ?v0) ?v_0)) (f9 (f10 f11 ?v1) ?v_0)) (f6 (f7 f8 (f6 (f7 f17 ?v0) ?v1)) (f6 (f7 f18 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 (+ (+ 0 1) 1)))) (= (- (f22 (f23 f24 ?v0) ?v_0) (f22 (f23 f24 ?v1) ?v_0)) (f3 (f4 f25 (- ?v0 ?v1)) (+ ?v0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f27 f30 ?v0))) (= (f26 (f27 f30 (f26 ?v_0 ?v1)) (f26 (f27 f30 ?v2) ?v3)) (f26 (f27 f30 (f26 ?v_0 ?v2)) (f26 (f27 f30 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 (f7 f8 ?v2) ?v3)) (f6 (f7 f8 (f6 ?v_0 ?v2)) (f6 (f7 f8 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) (f3 (f4 f25 ?v2) ?v3)) (f3 (f4 f25 (f3 ?v_0 ?v2)) (f3 (f4 f25 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f4 f25 (f3 (f4 f25 ?v0) ?v1))) (?v_0 (f4 f25 ?v2))) (= (f3 ?v_1 (f3 ?v_0 ?v3)) (f3 ?v_0 (f3 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f7 f8 (f6 (f7 f8 ?v0) ?v1))) (?v_0 (f7 f8 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f25 ?v0)) (?v_1 (f3 (f4 f25 ?v2) ?v3))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v_1) (f3 ?v_0 (f3 (f4 f25 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f6 (f7 f8 ?v2) ?v3))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 (f4 f25 (f3 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f8 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f32 ?v0))) (= (f3 (f4 f25 ?v_0) ?v_0) (f3 (f4 f25 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (f3 (f4 f25 ?v1) ?v2)) (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f4 f25 ?v0)) (?v_0 (f4 f25 ?v1))) (= (f3 ?v_1 (f3 ?v_0 ?v2)) (f3 ?v_0 (f3 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f25 ?v0) ?v1) (f3 (f4 f25 ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f32 (f3 (f4 f25 ?v0) ?v1)) (f3 (f4 f25 (f3 f32 ?v0)) (f3 f32 ?v1)))))
(assert (= (f3 f32 1) 1))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 2))) (= (f22 (f23 f24 (f3 f32 ?v0)) ?v_0) (f22 (f23 f24 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f22 (f23 f24 ?v0) (f20 f21 2)))) (= (f3 f32 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f3 f32 (f22 (f23 f24 ?v0) ?v1)) (f22 (f23 f24 (f3 f32 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (f3 (f4 f25 ?v0) ?v1) ?v1) (f3 (f4 f25 (+ ?v0 1)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f18 (f6 (f7 f8 ?v0) ?v1)) ?v1) (f6 (f7 f8 (f6 (f7 f18 ?v0) f16)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (f3 (f4 f25 ?v1) ?v0)) (f3 (f4 f25 (+ ?v1 1)) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f18 ?v0) (f6 (f7 f8 ?v1) ?v0)) (f6 (f7 f8 (f6 (f7 f18 ?v1) f16)) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 ?v0) (f3 (f4 f25 (+ 1 1)) ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f18 ?v0) ?v0) (f6 (f7 f8 (f6 (f7 f18 f16) f16)) ?v0))))
(assert (forall ((?v0 S8)) (= (f22 (f23 f24 0) ?v0) (ite (= ?v0 (f20 f21 0)) 1 0))))
(assert (forall ((?v0 S8)) (= (f9 (f10 f11 f19) ?v0) (ite (= ?v0 (f20 f21 0)) f16 f19))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 f34) ?v0) (ite (= ?v0 (f20 f21 0)) f29 f34))))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f16) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f25 ?v0) ?v0) (f3 (f4 f25 ?v1) ?v1)) (or (= ?v0 ?v1) (= ?v0 (- ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f8 ?v0) ?v0) (f6 (f7 f8 ?v1) ?v1)) (or (= ?v0 ?v1) (= ?v0 (f6 f15 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f25 (- ?v0)) (- ?v1)) (f3 (f4 f25 ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f6 f15 ?v0)) (f6 f15 ?v1)) (f6 (f7 f8 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f25 (- ?v0)) ?v1) (f3 (f4 f25 ?v0) (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f6 f15 ?v0)) ?v1) (f6 (f7 f8 ?v0) (f6 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 (f4 f25 ?v0) ?v1)) (f3 (f4 f25 (- ?v0)) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f15 (f6 (f7 f8 ?v0) ?v1)) (f6 (f7 f8 (f6 f15 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (- (f3 ?v_0 ?v1)) (f3 ?v_0 (- ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 f15 (f6 ?v_0 ?v1)) (f6 ?v_0 (f6 f15 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f22 f31 ?v1)) (?v_1 (f22 f31 ?v0)) (?v_2 (f23 f24 ?v2))) (=> (<= ?v_1 ?v_0) (= (f22 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (f3 (f4 f25 (f22 ?v_2 (f20 f21 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f31 ?v1)) (?v_1 (f22 f31 ?v0)) (?v_2 (f27 f28 ?v2))) (=> (<= ?v_1 ?v_0) (= (f26 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (f26 (f27 f30 (f26 ?v_2 (f20 f21 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S5)) (let ((?v_0 (f22 f31 ?v1)) (?v_1 (f22 f31 ?v0)) (?v_2 (f10 f11 ?v2))) (=> (<= ?v_1 ?v_0) (= (f9 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f8 (f9 ?v_2 (f20 f21 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 Int)) (let ((?v_0 (f22 f31 ?v0)) (?v_1 (f23 f24 ?v1))) (=> (< 0 ?v_0) (= (f3 (f4 f25 (f22 ?v_1 (f20 f21 (- ?v_0 1)))) ?v1) (f22 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f22 f31 ?v0)) (?v_1 (f27 f28 ?v1))) (=> (< 0 ?v_0) (= (f26 (f27 f30 (f26 ?v_1 (f20 f21 (- ?v_0 1)))) ?v1) (f26 ?v_1 ?v0))))))
(assert (forall ((?v0 S8) (?v1 S5)) (let ((?v_0 (f22 f31 ?v0)) (?v_1 (f10 f11 ?v1))) (=> (< 0 ?v_0) (= (f6 (f7 f8 (f9 ?v_1 (f20 f21 (- ?v_0 1)))) ?v1) (f9 ?v_1 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f3 (f4 f25 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2)) (f22 ?v_0 (f20 f21 (+ (f22 f31 ?v1) (f22 f31 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f30 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2)) (f26 ?v_0 (f20 f21 (+ (f22 f31 ?v1) (f22 f31 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2)) (f9 ?v_0 (f20 f21 (+ (f22 f31 ?v1) (f22 f31 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f22 (f23 f24 (f3 (f4 f25 ?v0) ?v1)) ?v2) (f3 (f4 f25 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f26 (f27 f28 (f26 (f27 f30 ?v0) ?v1)) ?v2) (f26 (f27 f30 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f9 (f10 f11 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f22 (f23 f24 (f3 (f4 f25 ?v0) ?v1)) ?v2) (f3 (f4 f25 (f22 (f23 f24 ?v0) ?v2)) (f22 (f23 f24 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f26 (f27 f28 (f26 (f27 f30 ?v0) ?v1)) ?v2) (f26 (f27 f30 (f26 (f27 f28 ?v0) ?v2)) (f26 (f27 f28 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S8)) (= (f9 (f10 f11 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f9 (f10 f11 ?v0) ?v2)) (f9 (f10 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 (f23 f24 ?v0) ?v1))) (= (f3 (f4 f25 ?v_0) ?v0) (f3 (f4 f25 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f26 (f27 f28 ?v0) ?v1))) (= (f26 (f27 f30 ?v_0) ?v0) (f26 (f27 f30 ?v0) ?v_0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v1))) (= (f6 (f7 f8 ?v_0) ?v0) (f6 (f7 f8 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f3 (f4 f25 (f22 ?v_0 ?v1)) ?v0) (f22 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f30 (f26 ?v_0 ?v1)) ?v0) (f26 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f6 (f7 f8 (f9 ?v_0 ?v1)) ?v0) (f9 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f20 f21 (* 2 (f22 f31 ?v1)))) (f3 (f4 f25 ?v_1) ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f26 ?v_0 ?v1))) (= (f26 ?v_0 (f20 f21 (* 2 (f22 f31 ?v1)))) (f26 (f27 f30 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f20 f21 (* 2 (f22 f31 ?v1)))) (f6 (f7 f8 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f20 f21 (+ (f22 f31 ?v1) (f22 f31 ?v2)))) (f3 (f4 f25 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f20 f21 (+ (f22 f31 ?v1) (f22 f31 ?v2)))) (f26 (f27 f30 (f26 ?v_0 ?v1)) (f26 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S8) (?v2 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f20 f21 (+ (f22 f31 ?v1) (f22 f31 ?v2)))) (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f3 (f4 f25 ?v0) (f22 ?v_0 ?v1)) (f22 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f30 ?v0) (f26 ?v_0 ?v1)) (f26 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f6 (f7 f8 ?v0) (f9 ?v_0 ?v1)) (f9 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f20 f21 (+ (* 2 (f22 f31 ?v1)) 1))) (f3 (f4 f25 ?v0) (f3 (f4 f25 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (let ((?v_1 (f26 ?v_0 ?v1))) (= (f26 ?v_0 (f20 f21 (+ (* 2 (f22 f31 ?v1)) 1))) (f26 (f27 f30 ?v0) (f26 (f27 f30 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (let ((?v_1 (f9 ?v_0 ?v1))) (= (f9 ?v_0 (f20 f21 (+ (* 2 (f22 f31 ?v1)) 1))) (f6 (f7 f8 ?v0) (f6 (f7 f8 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f20 f21 (+ (* 2 (f22 f31 ?v1)) 1))) (f3 (f4 f25 ?v0) (f22 (f23 f24 (f22 ?v_0 ?v1)) (f20 f21 2)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f20 f21 (+ (* 2 (f22 f31 ?v1)) 1))) (f26 (f27 f30 ?v0) (f26 (f27 f28 (f26 ?v_0 ?v1)) (f20 f21 2)))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f20 f21 (+ (* 2 (f22 f31 ?v1)) 1))) (f6 (f7 f8 ?v0) (f9 (f10 f11 (f9 ?v_0 ?v1)) (f20 f21 2)))))))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f20 f21 3)) (f3 (f4 f25 (f3 (f4 f25 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f20 f21 3)) (f26 (f27 f30 (f26 (f27 f30 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f20 f21 3)) (f6 (f7 f8 (f6 (f7 f8 ?v0) ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f20 f21 2)) (f3 (f4 f25 ?v0) ?v0))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f20 f21 2)) (f26 (f27 f30 ?v0) ?v0))))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f20 f21 2)) (f6 (f7 f8 ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1))) (f3 (f4 f25 (f22 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1))) (f26 (f27 f30 (f26 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1))) (f6 (f7 f8 (f9 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1))) (f3 (f4 f25 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1))) (f26 (f27 f30 ?v0) (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1))) (f6 (f7 f8 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1))) (f3 (f4 f25 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1))) (f26 (f27 f30 ?v0) (f26 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S8)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f20 f21 (+ (f22 f31 ?v1) 1))) (f6 (f7 f8 ?v0) (f9 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f25 ?v0) ?v0) (f22 (f23 f24 ?v0) (f20 f21 2)))))
(assert (forall ((?v0 S8)) (= (f26 (f27 f30 ?v0) ?v0) (f26 (f27 f28 ?v0) (f20 f21 2)))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) ?v0) (f9 (f10 f11 ?v0) (f20 f21 2)))))
(assert (forall ((?v0 Int)) (= (f22 (f23 f24 ?v0) (f20 f21 0)) 1)))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 ?v0) (f20 f21 0)) f16)))
(assert (forall ((?v0 S8)) (= (f26 (f27 f28 ?v0) (f20 f21 0)) f29)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f17 ?v0) ?v1) (f6 (f7 f18 ?v0) (f6 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 (- ?v1)) (+ ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f17 ?v0) (f6 f15 ?v1)) (f6 (f7 f18 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f17 ?v0) ?v1) (f6 (f7 f18 ?v0) (f6 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- ?v0 ?v1) (+ ?v0 (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f17 ?v0) ?v1) (f6 (f7 f18 ?v0) (f6 f15 ?v1)))))
(assert (forall ((?v0 Int)) (= (- 0 ?v0) (- ?v0))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f17 f19) ?v0) (f6 f15 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f7 f8 ?v2)) (?v_0 (f7 f8 (f6 (f7 f17 ?v0) ?v2))) (?v_2 (f6 (f7 f17 ?v1) ?v3))) (= (f6 (f7 f17 (f6 (f7 f8 ?v0) ?v1)) (f6 ?v_1 ?v3)) (f6 (f7 f18 (f6 (f7 f18 (f6 ?v_0 ?v_2)) (f6 ?v_0 ?v3))) (f6 ?v_1 ?v_2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (+ ?v0 ?v1) 0) (= (- ?v0) ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) f19) (= (f6 f15 ?v0) ?v1))))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f18 (f6 f15 ?v0)) ?v0) f19)))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f18 (f6 f15 ?v0)) ?v0) f19)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= (+ ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 (f6 f15 ?v1)) (= (f6 (f7 f18 ?v0) ?v1) f19))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) (f20 f21 1) (f20 f21 (f3 (f4 f25 (f22 f31 ?v0)) (f22 f31 (f26 ?v_0 (f20 f21 (- (f22 f31 ?v1) 1)))))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f20 f21 0)) (?v_2 (f22 f31 ?v0)) (?v_1 (f22 f31 ?v1))) (= (f20 f21 (f3 (f4 f25 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f20 f21 (+ ?v_1 (f3 (f4 f25 (f22 f31 (f20 f21 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f22 f31 ?v0))) (= (f20 f21 (* ?v_0 2)) (f20 f21 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f22 f31 ?v0))) (= (f20 f21 (* 2 ?v_0)) (f20 f21 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 Int)) (= (= (f3 f32 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= f19 ?v0) (= ?v0 f19))))
(assert (= (f3 f32 0) 0))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f25 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f6 (f7 f18 ?v0) ?v1) (f6 (f7 f18 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (=> (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (=> (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (= (f6 (f7 f18 ?v0) ?v1) (f6 (f7 f18 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (= (= (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f35 ?v0) ?v1) ?v2) (f3 (f4 f35 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f36 ?v0) ?v1) ?v2) (f3 (f4 f36 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f18 ?v0))) (= (f6 (f7 f18 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f18 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f3 f32 ?v0) (f3 f32 ?v1)))) (= (f3 f32 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S5)) (= (= f16 ?v0) (= ?v0 f16))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (=> (= (f6 (f7 f17 ?v0) ?v1) (f6 (f7 f17 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f35 ?v0) ?v1) ?v2) (f3 (f4 f35 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f36 ?v0) ?v1) ?v2) (f3 (f4 f36 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f32 (- ?v0 ?v1)) (f3 f32 (- ?v1 ?v0)))))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 f15 (f6 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (f3 f32 (- ?v0)) (f3 f32 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 (f4 f36 ?v0) ?v1)) (f3 (f4 f35 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f3 (f4 f35 ?v0) ?v1)) (f3 (f4 f36 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 (f6 f15 ?v1)) (= ?v1 (f6 f15 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 f15 ?v0) ?v1) (= (f6 f15 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 f15 ?v0) (f6 f15 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f19) ?v0) f19)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f19) ?v0) f19)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f19) f19)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f19) f19)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f18 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f18 ?v0) f19) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f18 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f18 f19) ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f6 (f7 f17 ?v0) ?v1) f19) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (= (f6 (f7 f17 ?v0) ?v1) f19))))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f17 ?v0) ?v0) f19)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f17 ?v0) f19) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f18 ?v1) ?v2)) (f6 (f7 f18 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f18 ?v1) ?v2)) (f6 (f7 f18 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f6 (f7 f18 ?v0) ?v1)) ?v2) (f6 (f7 f18 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f6 (f7 f18 ?v0) ?v1)) ?v2) (f6 (f7 f18 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f16) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f8 ?v0) f16) ?v0)))
(assert (= 0 0))
(assert (= (f6 f15 f19) f19))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (forall ((?v0 S5)) (= (= f19 (f6 f15 ?v0)) (= f19 ?v0))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S5)) (= (= (f6 f15 ?v0) f19) (= ?v0 f19))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) ?v0) (= ?v0 0))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f17 ?v1) ?v2)) (f6 (f7 f17 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f17 ?v1) ?v2)) (f6 (f7 f17 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f6 (f7 f17 ?v0) ?v1)) ?v2) (f6 (f7 f17 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f6 (f7 f8 (f6 (f7 f17 ?v0) ?v1)) ?v2) (f6 (f7 f17 (f6 (f7 f8 ?v0) ?v2)) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f17 (f6 (f7 f18 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f18 (f6 (f7 f17 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 f15 ?v1)) (f6 f15 (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 f15 ?v1)) (f6 f15 (f6 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f6 f15 ?v0)) ?v1) (f6 f15 (f6 (f7 f8 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f8 (f6 f15 ?v0)) ?v1) (f6 f15 (f6 (f7 f8 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v0) (- ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f15 (f6 (f7 f18 ?v0) ?v1)) (f6 (f7 f18 (f6 f15 ?v0)) (f6 f15 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f15 (f6 (f7 f18 ?v0) ?v1)) (f6 (f7 f18 (f6 f15 ?v1)) (f6 f15 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (+ (- ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f18 ?v0) (f6 (f7 f18 (f6 f15 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0) (+ ?v0 ?v1)) ?v1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f18 (f6 f15 ?v0)) (f6 (f7 f18 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (- ?v0 ?v1)) (- ?v1 ?v0))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f15 (f6 (f7 f17 ?v0) ?v1)) (f6 (f7 f17 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (+ ?v0 (- ?v0)) 0)))
(assert (forall ((?v0 S5)) (= (f6 (f7 f18 ?v0) (f6 f15 ?v0)) f19)))
(assert (= f24 (f37 (f38 f39 1) f25)))
(assert (= f11 (f40 (f41 f42 f16) f8)))
(assert (= f28 (f43 (f44 f45 f29) f30)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (- ?v0) (- ?v1)) (- (- ?v0 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 (f7 f17 (f6 f15 ?v0)) (f6 f15 ?v1)) (f6 f15 (f6 (f7 f17 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (- ?v0 ?v2) (- ?v1 ?v3)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (f6 (f7 f17 (f6 (f7 f18 ?v0) ?v1)) (f6 (f7 f18 ?v2) ?v3)) (f6 (f7 f18 (f6 (f7 f17 ?v0) ?v2)) (f6 (f7 f17 ?v1) ?v3)))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f22 f31 ?v0)) (<= ?v_0 (f22 f31 (f26 (f27 f28 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f27 f28 ?v0))) (=> (< 0 (f22 f31 ?v0)) (=> (< (f22 f31 (f26 ?v_0 ?v1)) (f22 f31 (f26 ?v_0 ?v2))) (< (f22 f31 ?v1) (f22 f31 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (= (f20 f21 (f22 (f23 f24 ?v0) ?v1)) (f26 (f27 f28 (f20 f21 ?v0)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f20 f21 (+ 0 1)))) (= (= (f26 (f27 f28 ?v0) ?v1) ?v_0) (or (= ?v1 (f20 f21 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f22 (f23 f24 (f22 f31 ?v0)) ?v1) (f22 f31 (f26 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f20 f21 (+ 0 1)))) (= (f26 (f27 f28 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (< 0 (f22 f31 (f26 (f27 f28 ?v0) ?v1))) (or (< 0 (f22 f31 ?v0)) (= ?v1 (f20 f21 0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f22 f31 (f26 (f27 f28 ?v0) ?v1)) (f22 (f23 f24 (f22 f31 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f20 f21 (f3 (f4 f25 ?v0) ?v1)) (f20 f21 (f3 (f4 f25 (f22 f31 (f20 f21 (- ?v0)))) (f22 f31 (f20 f21 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f20 f21 (f3 (f4 f25 ?v0) ?v1)) (f20 f21 (f3 (f4 f25 (f22 f31 (f20 f21 ?v0))) (f22 f31 (f20 f21 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f20 f21 (f3 (f4 f25 (f22 f31 ?v1)) (f22 f31 ?v2))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f3 (f4 f25 (f22 f31 ?v0)) (f22 f31 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f3 (f4 f25 (f22 f31 ?v0)) (f22 f31 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f25 ?v0) ?v1))) (= (f20 f21 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f20 f21 (f3 (f4 f25 (f22 f31 (f20 f21 (ite (< ?v0 0) (- ?v0) ?v0)))) (f22 f31 (f20 f21 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 S5)) (= (f9 (f10 f11 (f6 f46 ?v0)) (f20 f21 2)) ?v0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f6 f47 (f6 (f7 f18 ?v0) ?v1)) (f6 (f7 f8 (f6 f47 ?v0)) (f6 f47 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f25 ?v0) ?v1) (f3 (f4 f25 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 ?v_0 (f20 f21 (+ (f22 f31 ?v1) (f22 f31 ?v2)))) (f3 (f4 f25 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (+ ?v1 ?v2)) (+ (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 ?v_0 (- ?v1 ?v2)) (- (f3 ?v_0 ?v1) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f25 (- ?v0)) ?v1) (- (f3 (f4 f25 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f3 (f4 f25 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f25 ?v0))) (= (f3 (f4 f25 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f3 (f4 f25 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f25 (+ ?v0 ?v1)) ?v2) (+ (f3 (f4 f25 ?v0) ?v2) (f3 (f4 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f25 (- ?v0 ?v1)) ?v2) (- (f3 (f4 f25 ?v0) ?v2) (f3 (f4 f25 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f3 (f4 f25 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f4 f25 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (let ((?v_0 (f22 f31 ?v2))) (let ((?v_1 (f4 f25 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f3 ?v_1 ?v0) (f3 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f25 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 (f4 f25 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (< 0 (f22 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f20 f21 0))))))
(assert (forall ((?v0 Int) (?v1 S8)) (<= 0 (f22 (f23 f24 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (= (f6 f47 f19) f16))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f22 (f23 f24 (f22 f31 ?v0)) ?v1) (f22 f31 (f26 (f27 f28 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (= (f26 (f27 f28 (f20 f21 ?v0)) ?v1) (f20 f21 (f22 (f23 f24 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f3 (f4 f25 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (<= 0 ?v0) (<= 0 (f22 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f20 f21 (f3 (f4 f25 (f22 f31 (f20 f21 ?v0))) (f22 f31 (f20 f21 ?v1)))) (f20 f21 (f3 (f4 f25 ?v0) ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f3 (f4 f25 (f22 f31 ?v0)) (f22 f31 ?v1)))) (= ?v_0 ?v_0))))
(assert (= (f6 (f7 f8 f48) f48) (f6 f15 f16)))
(assert (forall ((?v0 Int)) (=> (= (f49 ?v0 f50) f1) (not (= (+ (+ 1 ?v0) ?v0) 0)))))
(assert (forall ((?v0 S5)) (=> (= (f51 ?v0 f52) f1) (not (= (f6 (f7 f18 (f6 (f7 f18 f16) ?v0)) ?v0) f19)))))
(assert (forall ((?v0 Int)) (=> (= (f49 ?v0 f50) f1) (= (= (+ ?v0 ?v0) 0) (= ?v0 0)))))
(assert (forall ((?v0 S5)) (=> (= (f51 ?v0 f52) f1) (= (= (f6 (f7 f18 ?v0) ?v0) f19) (= ?v0 f19)))))
(assert (= (f49 0 f50) f1))
(assert (= (f51 f19 f52) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f49 ?v0 f50) f1) (=> (= (f49 ?v1 f50) f1) (= (f49 (+ ?v0 ?v1) f50) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f51 ?v0 f52) f1) (=> (= (f51 ?v1 f52) f1) (= (f51 (f6 (f7 f18 ?v0) ?v1) f52) f1)))))
(assert (= (f49 1 f50) f1))
(assert (= (f51 f16 f52) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f49 ?v0 f50) f1) (=> (= (f49 ?v1 f50) f1) (= (f49 (- ?v0 ?v1) f50) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f51 ?v0 f52) f1) (=> (= (f51 ?v1 f52) f1) (= (f51 (f6 (f7 f17 ?v0) ?v1) f52) f1)))))
(assert (forall ((?v0 Int)) (=> (= (f49 ?v0 f50) f1) (= (f49 (- ?v0) f50) f1))))
(assert (forall ((?v0 S5)) (=> (= (f51 ?v0 f52) f1) (= (f51 (f6 f15 ?v0) f52) f1))))
(assert (not (= f48 f19)))
(assert (not (= f48 f16)))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (= (f49 ?v0 f50) f1) (= (f49 (f22 (f23 f24 ?v0) ?v1) f50) f1))))
(assert (forall ((?v0 S5) (?v1 S8)) (=> (= (f51 ?v0 f52) f1) (= (f51 (f9 (f10 f11 ?v0) ?v1) f52) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f49 ?v0 f50) f1) (=> (= (f49 ?v1 f50) f1) (= (f49 (f3 (f4 f25 ?v0) ?v1) f50) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f51 ?v0 f52) f1) (=> (= (f51 ?v1 f52) f1) (= (f51 (f6 (f7 f8 ?v0) ?v1) f52) f1)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f7 f8 f48))) (= (f6 ?v_0 (f6 ?v_0 ?v0)) (f6 f15 ?v0)))))
(assert (forall ((?v0 S8)) (= (f20 f21 (f22 f31 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f22 f31 (f20 f21 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f22 f31 (f20 f21 ?v0)) 0))))
(check-sat)
(exit)
