(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S4 S4) S1)
(declare-fun f7 (S5 S4) S4)
(declare-fun f8 (S6 S4) S5)
(declare-fun f9 () S6)
(declare-fun f10 () S5)
(declare-fun f11 () S6)
(declare-fun f12 () S4)
(declare-fun f13 () S4)
(declare-fun f14 () S4)
(declare-fun f15 (S4 S4) S1)
(declare-fun f16 () S4)
(declare-fun f17 () S4)
(declare-fun f18 () S4)
(declare-fun f19 () S7)
(declare-fun f20 () S7)
(declare-fun f21 () S2)
(declare-fun f22 (S8 S7) S7)
(declare-fun f23 (S9 S7) S8)
(declare-fun f24 () S9)
(declare-fun f25 () S6)
(declare-fun f26 () S3)
(declare-fun f27 () S6)
(declare-fun f28 () S3)
(declare-fun f29 () S7)
(declare-fun f30 () S9)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) ?v1) (- ?v0 ?v1))))
(assert (not (= (f6 (f7 (f8 f9 (f7 f10 (f7 (f8 f11 f12) f13))) f14) f12) f1)))
(assert (= (f15 f16 f14) f1))
(assert (= (f6 f14 f13) f1))
(assert (= (f15 f13 f12) f1))
(assert (= (f6 f16 f17) f1))
(assert (forall ((?v0 S4)) (=> (= (f6 f16 ?v0) f1) (exists ((?v1 S4)) (and (= (f6 f16 ?v1) f1) (and (= (f6 ?v1 f12) f1) (= (f6 ?v1 ?v0) f1)))))))
(assert (forall ((?v0 S4)) (= (f6 f16 (f7 (f8 f9 f12) (f7 f10 ?v0))) f1)))
(assert (= (f6 f18 f12) f1))
(assert (= (f6 f16 f18) f1))
(assert (< 0 (+ 1 1)))
(assert (= (f6 f16 (f7 (f8 f9 f12) f12)) f1))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f16 ?v0) f1) (=> (= (f15 f16 ?v1) f1) (= (f6 f16 (f7 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (<= 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f15 f16 ?v0) f1) (=> (= (f6 f16 ?v1) f1) (= (f6 f16 (f7 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f6 f16 ?v0) f1) (=> (= (f15 ?v1 ?v2) f1) (= (f6 ?v1 (f7 (f8 f9 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (<= ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f15 f16 ?v0) f1) (=> (= (f6 ?v1 ?v2) f1) (= (f6 ?v1 (f7 (f8 f9 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 ?v0 f16) f1) (=> (= (f15 ?v1 f16) f1) (= (f6 (f7 (f8 f9 ?v0) ?v1) f16) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (<= ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f15 ?v0 f16) f1) (=> (= (f6 ?v1 f16) f1) (= (f6 (f7 (f8 f9 ?v0) ?v1) f16) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S4)) (not (= (f6 (f7 (f8 f9 (f7 f10 ?v0)) f12) ?v0) f1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f15 ?v0 ?v1) f1) (= (f15 (f7 (f8 f11 ?v0) ?v1) f16) f1))))
(assert (not (= f19 f20)))
(assert (forall ((?v0 S4)) (= (= (f7 f10 ?v0) f16) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (f3 f21 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S7)) (= (= f20 ?v0) (= ?v0 f20))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= f16 ?v0) (= ?v0 f16))))
(assert (= (f7 f10 f16) f16))
(assert (= (f3 f21 0) 0))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f15 (f7 f10 ?v0) ?v1) f1) (= (f15 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f3 f21 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S4)) (= (f15 ?v0 (f7 f10 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 f21 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f6 ?v0 ?v1) f1) false) (=> (=> (= (f6 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (= (f22 (f23 f24 ?v0) ?v1) (f22 (f23 f24 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (=> (= (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f22 (f23 f24 ?v0) ?v1) (f22 (f23 f24 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (= (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f7 (f8 f9 (f7 (f8 f25 ?v0) ?v1)) ?v2) (f7 (f8 f25 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f26 ?v0) ?v1) ?v2) (f3 (f4 f26 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f7 (f8 f9 (f7 (f8 f27 ?v0) ?v1)) ?v2) (f7 (f8 f27 (f7 (f8 f9 ?v0) ?v2)) (f7 (f8 f9 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f3 (f4 f28 ?v0) ?v1) ?v2) (f3 (f4 f28 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (= (f7 (f8 f9 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f8 f9 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f23 f24 ?v0))) (= (f22 (f23 f24 (f22 ?v_0 ?v1)) ?v2) (f22 ?v_0 (f22 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f7 (f8 f9 (f7 f10 ?v0)) (f7 f10 ?v1)))) (= (f7 f10 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f3 f21 ?v0) (f3 f21 ?v1)))) (= (f3 f21 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S4)) (= (= f12 ?v0) (= ?v0 f12))))
(assert (forall ((?v0 S7)) (= (= f29 ?v0) (= ?v0 f29))))
(assert (= (f7 f10 f12) f12))
(assert (= (f3 f21 1) 1))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f7 (f8 f11 ?v0) ?v1) (f7 (f8 f11 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (= (f22 (f23 f30 ?v0) ?v1) (f22 (f23 f30 ?v2) ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (= ?v0 ?v1) (= ?v2 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f7 (f8 f11 (f7 (f8 f25 ?v0) ?v1)) ?v2) (f7 (f8 f25 (f7 (f8 f11 ?v0) ?v2)) (f7 (f8 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f26 ?v0) ?v1) ?v2) (f3 (f4 f26 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f7 (f8 f11 (f7 (f8 f27 ?v0) ?v1)) ?v2) (f7 (f8 f27 (f7 (f8 f11 ?v0) ?v2)) (f7 (f8 f11 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (- (f3 (f4 f28 ?v0) ?v1) ?v2) (f3 (f4 f28 (- ?v0 ?v2)) (- ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f7 f10 (f7 (f8 f11 ?v0) ?v1)) (f7 f10 (f7 (f8 f11 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 f21 (- ?v0 ?v1)) (f3 f21 (- ?v1 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f15 ?v0 ?v1) f1) (=> (= (f15 ?v1 ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f15 ?v0 ?v1) f1) (=> (= (f15 ?v1 ?v2) f1) (= (f15 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (or (= (f15 ?v0 ?v1) f1) (= (f15 ?v1 ?v0) f1))))
(assert (forall ((?v0 S4)) (= (f15 ?v0 ?v0) f1)))
(assert (forall ((?v0 S4)) (=> (= (f15 f16 ?v0) f1) (= (f7 f10 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f21 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (= (f15 (f7 f10 ?v0) f16) f1) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (<= (f3 f21 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (f15 f16 (f7 f10 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f3 f21 ?v0))))
(assert (forall ((?v0 S4)) (=> (= (f6 f16 ?v0) f1) (= (f7 f10 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 f21 ?v0) ?v0))))
(assert (forall ((?v0 S4)) (= (= (f6 f16 (f7 f10 ?v0)) f1) (not (= ?v0 f16)))))
(assert (forall ((?v0 Int)) (= (< 0 (f3 f21 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S4)) (not (= (f6 (f7 f10 ?v0) f16) f1))))
(assert (forall ((?v0 Int)) (not (< (f3 f21 ?v0) 0))))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 ?v0) f16) ?v0)))
(assert (forall ((?v0 S7)) (= (f22 (f23 f24 ?v0) f20) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 ?v0) f16) ?v0)))
(assert (forall ((?v0 S7)) (= (f22 (f23 f24 ?v0) f20) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S4)) (= (= f16 (f7 (f8 f9 ?v0) ?v0)) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 f16) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f22 (f23 f24 f20) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 f16) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f22 (f23 f24 f20) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f15 (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) f1) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f15 (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) f1) (= (f15 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f15 ?v0 ?v1) f1) (=> (= (f15 ?v2 ?v3) f1) (= (f15 (f7 (f8 f9 ?v0) ?v2) (f7 (f8 f9 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f15 ?v0 ?v1) f1) (= (f15 (f7 ?v_0 ?v0) (f7 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f15 ?v0 ?v1) f1) (= (f15 (f7 (f8 f9 ?v0) ?v2) (f7 (f8 f9 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f15 (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) f1) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f15 (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) f1) (= (f15 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f15 (f7 f10 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 (f7 f10 ?v0)) (f7 f10 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f21 (+ ?v0 ?v1)) (+ (f3 f21 ?v0) (f3 f21 ?v1)))))
(assert (not (= 0 1)))
(assert (not (= f16 f12)))
(assert (not (= f20 f29)))
(assert (not (= 1 0)))
(assert (not (= f12 f16)))
(assert (not (= f29 f20)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (=> (= (f6 (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) f1) (= (f6 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f6 (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) f1) (= (f6 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 ?v2 ?v3) f1) (= (f6 (f7 (f8 f9 ?v0) ?v2) (f7 (f8 f9 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f6 ?v0 ?v1) f1) (= (f6 (f7 ?v_0 ?v0) (f7 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f6 ?v0 ?v1) f1) (= (f6 (f7 (f8 f9 ?v0) ?v2) (f7 (f8 f9 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v0))) (= (= (f6 (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) f1) (= (f6 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f6 (f7 (f8 f9 ?v0) ?v1) (f7 (f8 f9 ?v2) ?v1)) f1) (= (f6 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f22 (f23 f30 ?v0) ?v1) f20) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0 ?v1) 0) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f7 (f8 f11 ?v0) ?v1) f16) (= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 ?v1) (= (f22 (f23 f30 ?v0) ?v1) f20))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 ?v1) (= (f7 (f8 f11 ?v0) ?v1) f16))))
(assert (forall ((?v0 S7)) (= (f22 (f23 f30 ?v0) ?v0) f20)))
(assert (forall ((?v0 Int)) (= (- ?v0 ?v0) 0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 ?v0) ?v0) f16)))
(assert (forall ((?v0 S7)) (= (f22 (f23 f30 ?v0) f20) ?v0)))
(assert (forall ((?v0 Int)) (= (- ?v0 0) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f11 ?v0) f16) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f7 (f8 f11 ?v0) ?v1) (f7 (f8 f11 ?v2) ?v3)) (= (= (f15 ?v0 ?v1) f1) (= (f15 ?v2 ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (<= ?v0 ?v1) (<= ?v2 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f15 (f7 (f8 f11 (f7 f10 ?v0)) (f7 f10 ?v1)) (f7 f10 (f7 (f8 f11 ?v1) ?v0))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f21 ?v0) (f3 f21 ?v1)) (f3 f21 (- ?v1 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f15 (f7 (f8 f11 (f7 f10 ?v0)) (f7 f10 ?v1)) (f7 f10 (f7 (f8 f11 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (- (f3 f21 ?v0) (f3 f21 ?v1)) (f3 f21 (- ?v0 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f15 (f7 f10 (f7 (f8 f11 (f7 f10 ?v0)) (f7 f10 ?v1))) (f7 f10 (f7 (f8 f11 ?v0) ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f21 (- (f3 f21 ?v0) (f3 f21 ?v1))) (f3 f21 (- ?v0 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f7 (f8 f11 ?v0) ?v1) (f7 (f8 f11 ?v2) ?v3)) (= (= (f6 ?v0 ?v1) f1) (= (f6 ?v2 ?v3) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (- ?v0 ?v1) (- ?v2 ?v3)) (= (< ?v0 ?v1) (< ?v2 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f7 (f8 f11 (f7 (f8 f9 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f22 (f23 f30 (f22 (f23 f24 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f7 (f8 f9 (f7 (f8 f11 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0 ?v1) ?v1) ?v0)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f22 (f23 f24 (f22 (f23 f30 ?v0) ?v1)) ?v1) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f15 ?v0 ?v1) f1) (or (= (f6 ?v0 ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 ?v0 ?v1) f1) (and (= (f15 ?v0 ?v1) f1) (not (= ?v0 ?v1))))))
(assert (not (= f16 f12)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f8 f9 ?v2))) (=> (= (f15 ?v0 ?v1) f1) (= (f15 (f7 ?v_0 ?v0) (f7 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f15 ?v0 f16) f1) (=> (= (f15 ?v1 f16) f1) (= (f15 (f7 (f8 f9 ?v0) ?v1) f16) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f15 f16 ?v0) f1) (=> (= (f15 ?v1 ?v2) f1) (= (f15 ?v1 (f7 (f8 f9 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v2 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f15 f16 ?v0) f1) (=> (= (f15 ?v1 ?v2) f1) (= (f15 ?v1 (f7 (f8 f9 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f15 f16 ?v0) f1) (=> (= (f15 f16 ?v1) f1) (= (= (f7 (f8 f9 ?v0) ?v1) f16) (and (= ?v0 f16) (= ?v1 f16)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (+ ?v0 ?v1) 0) (and (= ?v0 0) (= ?v1 0)))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f15 f16 ?v0) f1) (=> (= (f15 f16 ?v1) f1) (= (f15 f16 (f7 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S4)) (= (= (f15 (f7 (f8 f9 ?v0) ?v0) f16) f1) (= (f15 ?v0 f16) f1))))
(assert (forall ((?v0 Int)) (= (<= (+ ?v0 ?v0) 0) (<= ?v0 0))))
(assert (forall ((?v0 S4)) (= (= (f15 f16 (f7 (f8 f9 ?v0) ?v0)) f1) (= (f15 f16 ?v0) f1))))
(assert (forall ((?v0 Int)) (= (<= 0 (+ ?v0 ?v0)) (<= 0 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 ?v0 f16) f1) (=> (= (f6 ?v1 f16) f1) (= (f6 (f7 (f8 f9 ?v0) ?v1) f16) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f6 f16 ?v0) f1) (=> (= (f6 ?v1 ?v2) f1) (= (f6 ?v1 (f7 (f8 f9 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v1 ?v2) (< ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f16 ?v0) f1) (=> (= (f6 f16 ?v1) f1) (= (f6 f16 (f7 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S4)) (= (= (f6 (f7 (f8 f9 ?v0) ?v0) f16) f1) (= (f6 ?v0 f16) f1))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S4)) (= (= (f6 f16 (f7 (f8 f9 ?v0) ?v0)) f1) (= (f6 f16 ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< 0 (+ ?v0 ?v0)) (< 0 ?v0))))
(assert (<= 0 1))
(assert (= (f15 f16 f12) f1))
(assert (not (<= 1 0)))
(assert (not (= (f15 f12 f16) f1)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f15 ?v0 ?v1) f1) (=> (= (f6 ?v2 ?v3) f1) (= (f6 (f7 (f8 f9 ?v0) ?v2) (f7 (f8 f9 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f15 ?v2 ?v3) f1) (= (f6 (f7 (f8 f9 ?v0) ?v2) (f7 (f8 f9 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (<= (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f15 ?v0 ?v1) f1) (= (f15 (f7 (f8 f11 ?v0) ?v1) f16) f1))))
(assert (< 0 1))
(assert (= (f6 f16 f12) f1))
(assert (not (< 1 0)))
(assert (not (= (f6 f12 f16) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (< (- ?v0 ?v1) 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 ?v0 ?v1) f1) (= (f6 (f7 (f8 f11 ?v0) ?v1) f16) f1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f15 (f7 f10 (f7 (f8 f11 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 ?v2) ?v3))) (f7 (f8 f9 (f7 f10 (f7 (f8 f11 ?v0) ?v2))) (f7 f10 (f7 (f8 f11 ?v1) ?v3)))) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (<= (f3 f21 (- (+ ?v0 ?v1) (+ ?v2 ?v3))) (+ (f3 f21 (- ?v0 ?v2)) (f3 f21 (- ?v1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f15 (f7 f10 (f7 (f8 f11 ?v0) ?v1)) (f7 (f8 f9 (f7 f10 ?v0)) (f7 f10 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f3 f21 (- ?v0 ?v1)) (+ (f3 f21 ?v0) (f3 f21 ?v1)))))
(assert (forall ((?v0 Int)) (< ?v0 (+ ?v0 1))))
(assert (forall ((?v0 S4)) (= (f6 ?v0 (f7 (f8 f9 ?v0) f12)) f1)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f6 (f7 f10 (f7 (f8 f11 ?v0) ?v1)) ?v2) f1) (and (= (f6 (f7 (f8 f11 ?v1) ?v2) ?v0) f1) (= (f6 ?v0 (f7 (f8 f9 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f3 f21 (- ?v0 ?v1)) ?v2) (and (< (- ?v1 ?v2) ?v0) (< ?v0 (+ ?v1 ?v2))))))
(assert (forall ((?v0 S4)) (= (= (f6 (f7 (f8 f9 ?v0) ?v0) f16) f1) (= (f6 ?v0 f16) f1))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S4)) (= (f15 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 f16 ?v0) f1) (=> (= (f6 f16 ?v1) f1) (exists ((?v2 S4)) (and (= (f6 f16 ?v2) f1) (and (= (f6 ?v2 ?v0) f1) (= (f6 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (=> (= (f6 ?v0 ?v1) f1) (=> (= (f6 ?v1 ?v2) f1) (exists ((?v3 S4)) (and (= (f6 f16 ?v3) f1) (forall ((?v4 S4)) (=> (= (f6 (f7 f10 (f7 (f8 f11 ?v1) ?v4)) ?v3) f1) (and (= (f15 ?v0 ?v4) f1) (= (f15 ?v4 ?v2) f1))))))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (= (f7 (f8 f11 (f7 (f8 f9 ?v0) ?v1)) (f7 (f8 f9 ?v2) ?v3)) (f7 (f8 f9 (f7 (f8 f11 ?v0) ?v2)) (f7 (f8 f11 ?v1) ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (- (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (- ?v0 ?v2) (- ?v1 ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (= (f22 (f23 f30 (f22 (f23 f24 ?v0) ?v1)) (f22 (f23 f24 ?v2) ?v3)) (f22 (f23 f24 (f22 (f23 f30 ?v0) ?v2)) (f22 (f23 f30 ?v1) ?v3)))))
(assert (forall ((?v0 S4)) (= (= (f7 (f8 f9 ?v0) ?v0) f16) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 (f7 (f8 f9 ?v0) ?v1)) (= ?v1 f16))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 (f22 (f23 f24 ?v0) ?v1)) (= ?v1 f20))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 ?v0) f16) ?v0)))
(assert (forall ((?v0 S7)) (= (f22 (f23 f24 ?v0) f20) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S4)) (= (f7 (f8 f9 f16) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f22 (f23 f24 f20) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (forall ((?v2 S4)) (=> (= (f6 f16 ?v2) f1) (= (f15 ?v0 (f7 (f8 f9 ?v1) ?v2)) f1))) (= (f15 ?v0 ?v1) f1))))
(assert (forall ((?v0 S4) (?v1 S4)) (or (= (f15 ?v0 ?v1) f1) (= (f15 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= ?v0 ?v1) (and (= (f15 ?v0 ?v1) f1) (= (f15 ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f15 ?v0 (f7 (f8 f27 ?v1) ?v2)) f1) (or (= (f15 ?v0 ?v1) f1) (= (f15 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f3 (f4 f28 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (= (f15 (f7 (f8 f25 ?v0) ?v1) ?v2) f1) (or (= (f15 ?v0 ?v2) f1) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f3 (f4 f26 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= ?v0 ?v1) (= (f15 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(check-sat)
(exit)
