(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S3) S2)
(declare-fun f5 (S4 S3) S3)
(declare-fun f6 (S5 S3) S4)
(declare-fun f7 () S5)
(declare-fun f8 () S3)
(declare-fun f9 () S3)
(declare-fun f10 (S6 S7) S3)
(declare-fun f11 () S6)
(declare-fun f12 () S7)
(declare-fun f13 () S5)
(declare-fun f14 () S3)
(declare-fun f15 () S7)
(declare-fun f16 () S3)
(declare-fun f17 () S4)
(declare-fun f18 (S8 S7) S7)
(declare-fun f19 (S9 S7) S8)
(declare-fun f20 () S9)
(declare-fun f21 (S10 Int) Int)
(declare-fun f22 () S10)
(declare-fun f23 (S11 Int) S10)
(declare-fun f24 () S11)
(declare-fun f25 () S4)
(declare-fun f26 () S7)
(declare-fun f27 () S7)
(declare-fun f28 () S12)
(declare-fun f29 () S12)
(declare-fun f30 () S9)
(declare-fun f31 (S13 S12) S12)
(declare-fun f32 (S14 S12) S13)
(declare-fun f33 () S14)
(declare-fun f34 (S15 S3) S7)
(declare-fun f35 () S15)
(declare-fun f36 () S4)
(declare-fun f37 (S3) S2)
(declare-fun f38 (S16 S12) S8)
(declare-fun f39 () S16)
(declare-fun f40 () S12)
(declare-fun f41 () S4)
(declare-fun f42 () S8)
(declare-fun f43 (S18 S7) S13)
(declare-fun f44 () S18)
(declare-fun f45 () S10)
(declare-fun f46 () S12)
(declare-fun f47 () S12)
(declare-fun f48 (S8) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 (f6 f7 f8) f9)) (f10 f11 f12)) f1)))
(assert (= (f3 (f4 f8) (f5 (f6 f13 (f10 f11 f12)) f9)) f1))
(assert (= (f3 (f4 f14) f9) f1))
(assert (= (f3 (f4 f14) f9) f1))
(assert (= (f3 (f4 f14) f8) f1))
(assert (= (f3 (f4 f8) (f5 (f6 f13 (f10 f11 f12)) f9)) f1))
(assert (not (= f12 f15)))
(assert (= (f3 (f4 f8) f16) f1))
(assert (= (f3 (f4 f14) (f5 (f6 f13 (f10 f11 f12)) f9)) f1))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 (f5 f17 ?v0)) ?v1) f1) (=> (= (f3 (f4 (f5 f17 ?v2)) ?v3) f1) (= (f3 (f4 (f5 f17 (f5 (f6 f7 ?v0) ?v2))) (f5 (f6 f7 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S7) (?v1 S3) (?v2 S7) (?v3 S3)) (=> (= (f3 (f4 (f10 f11 ?v0)) ?v1) f1) (=> (= (f3 (f4 (f10 f11 ?v2)) ?v3) f1) (= (f3 (f4 (f10 f11 (f18 (f19 f20 ?v0) ?v2))) (f5 (f6 f7 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f17 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f17 ?v0)) (f5 f17 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f10 f11 (f18 (f19 f20 ?v0) ?v1)) (f5 (f6 f7 (f10 f11 ?v0)) (f10 f11 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f21 f22 ?v0)) (?v_1 (f21 f22 ?v2))) (=> (< ?v_0 ?v1) (=> (< ?v_1 ?v3) (< (f21 (f23 f24 ?v_0) ?v_1) (f21 (f23 f24 ?v1) ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f5 f25 ?v0)) (?v_1 (f5 f25 ?v2))) (=> (= (f3 (f4 ?v_0) ?v1) f1) (=> (= (f3 (f4 ?v_1) ?v3) f1) (= (f3 (f4 (f5 (f6 f7 ?v_0) ?v_1)) (f5 (f6 f7 ?v1) ?v3)) f1))))))
(assert (exists ((?v0 S3)) (let ((?v_0 (f4 ?v0))) (and (= (f3 (f4 f14) ?v0) f1) (and (= (f3 ?v_0 (f5 (f6 f13 (f10 f11 f12)) f9)) f1) (= (f3 ?v_0 f16) f1))))))
(assert (=> (forall ((?v0 S3)) (let ((?v_0 (f4 ?v0))) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 ?v_0 (f5 (f6 f13 (f10 f11 f12)) f9)) f1) (=> (= (f3 ?v_0 f16) f1) false))))) false))
(assert (forall ((?v0 S2)) (=> (exists ((?v1 S3)) (= (f3 ?v0 ?v1) f1)) (=> (exists ((?v1 S3)) (forall ((?v2 S3)) (=> (= (f3 ?v0 ?v2) f1) (= (f3 (f4 ?v2) ?v1) f1)))) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (exists ((?v3 S3)) (and (= (f3 ?v0 ?v3) f1) (= (f3 (f4 ?v2) ?v3) f1))) (= (f3 (f4 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S7)) (not (= (f3 (f4 (f10 f11 ?v0)) f14) f1))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 (f5 f17 ?v0)) f14) f1))))
(assert (forall ((?v0 S3)) (= (not (= (f3 (f4 f14) (f5 (f6 f7 ?v0) ?v0)) f1)) (= ?v0 f14))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f4 (f5 (f6 f7 ?v1) ?v0)) (f5 (f6 f7 ?v2) ?v0)) f1) (= (f3 (f4 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) ?v2) f1) (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 (f5 (f6 f7 ?v0) ?v0)) f14) f1))))
(assert (forall ((?v0 Int)) (not (< (f21 (f23 f24 ?v0) ?v0) 0))))
(assert (not (= f26 f15)))
(assert (not (= f27 f15)))
(assert (not (= f28 f29)))
(assert (not (= f16 f14)))
(assert (not (= 1 0)))
(assert (not (= f15 f27)))
(assert (not (= f29 f28)))
(assert (not (= f14 f16)))
(assert (not (= 0 1)))
(assert (not (= f14 f16)))
(assert (= (f21 f22 1) 1))
(assert (= (f5 f25 f16) f16))
(assert (= (f10 f11 f27) f16))
(assert (= (f5 f17 f16) f16))
(assert (forall ((?v0 S3)) (= (f5 (f6 f13 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f30 f15) ?v0) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f13 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f30 f15) ?v0) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f13 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f30 ?v0) f15) f15)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f30 ?v0) f27) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f13 ?v0) f16) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f30 ?v0) ?v0) (ite (= ?v0 f15) f15 f27))))
(assert (forall ((?v0 S3)) (= (f5 (f6 f13 ?v0) ?v0) (ite (= ?v0 f14) f14 f16))))
(assert (forall ((?v0 S7)) (=> (not (= ?v0 f15)) (= (f18 (f19 f30 ?v0) ?v0) f27))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f14)) (= (f5 (f6 f13 ?v0) ?v0) f16))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 f15)) (= (= (f18 (f19 f30 ?v1) ?v0) f27) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (= (= (f5 (f6 f13 ?v1) ?v0) f16) (= ?v1 ?v0)))))
(assert (= (f3 (f4 f14) f16) f1))
(assert (< 0 1))
(assert (not (= (f3 (f4 f16) f14) f1)))
(assert (not (< 1 0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f16) ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (= (f5 f17 (f5 (f6 f13 ?v1) ?v0)) (f5 (f6 f13 (f5 f17 ?v1)) (f5 f17 ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 f15)) (= (f10 f11 (f18 (f19 f30 ?v1) ?v0)) (f5 (f6 f13 (f10 f11 ?v1)) (f10 f11 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (=> (= (f5 (f6 f7 ?v1) ?v0) ?v2) (= ?v1 (f5 (f6 f13 ?v2) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f15)) (=> (= (f18 (f19 f20 ?v1) ?v0) ?v2) (= ?v1 (f18 (f19 f30 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (=> (= ?v1 (f5 (f6 f7 ?v2) ?v0)) (= (f5 (f6 f13 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f15)) (=> (= ?v1 (f18 (f19 f20 ?v2) ?v0)) (= (f18 (f19 f30 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (= (= (f5 (f6 f13 ?v1) ?v0) ?v2) (= ?v1 (f5 (f6 f7 ?v2) ?v0))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f15)) (= (= (f18 (f19 f30 ?v1) ?v0) ?v2) (= ?v1 (f18 (f19 f20 ?v2) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (= (= ?v1 (f5 (f6 f13 ?v2) ?v0)) (= (f5 (f6 f7 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f15)) (= (= ?v1 (f18 (f19 f30 ?v2) ?v0)) (= (f18 (f19 f20 ?v1) ?v0) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f10 f11 (f18 (f19 f30 ?v0) ?v1)) (f5 (f6 f13 (f10 f11 ?v0)) (f10 f11 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f17 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 (f5 f17 ?v0)) (f5 f17 ?v1)))))
(assert (forall ((?v0 S3)) (= (= (f5 f17 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 S7)) (= (= (f10 f11 ?v0) f14) (= ?v0 f15))))
(assert (= (f5 f17 f14) f14))
(assert (= (f10 f11 f15) f14))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f16))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 1 ?v0) (=> (< 1 ?v1) (< 1 (f21 (f23 f24 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (f5 (f6 f13 ?v1) ?v2)) (f5 (f6 f13 (f5 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f18 (f19 f30 ?v1) ?v2)) (f18 (f19 f30 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f5 (f6 f7 ?v0) ?v1) f14) (or (= ?v0 f14) (= ?v1 f14)))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f18 (f19 f20 ?v0) ?v1) f15) (or (= ?v0 f15) (= ?v1 f15)))))
(assert (forall ((?v0 S12) (?v1 S12)) (=> (= (f31 (f32 f33 ?v0) ?v1) f29) (or (= ?v0 f29) (= ?v1 f29)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 (f23 f24 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (=> (not (= ?v1 f14)) (not (= (f5 (f6 f7 ?v0) ?v1) f14))))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (not (= ?v0 f15)) (=> (not (= ?v1 f15)) (not (= (f18 (f19 f20 ?v0) ?v1) f15))))))
(assert (forall ((?v0 S12) (?v1 S12)) (=> (not (= ?v0 f29)) (=> (not (= ?v1 f29)) (not (= (f31 (f32 f33 ?v0) ?v1) f29))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f21 (f23 f24 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f5 (f6 f7 ?v0) ?v1) f14) (or (= ?v0 f14) (= ?v1 f14)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f18 (f19 f20 ?v0) ?v1) f15) (or (= ?v0 f15) (= ?v1 f15)))))
(assert (forall ((?v0 S12) (?v1 S12)) (= (= (f31 (f32 f33 ?v0) ?v1) f29) (or (= ?v0 f29) (= ?v1 f29)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f21 (f23 f24 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f15) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f15) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f15) f15)))
(assert (forall ((?v0 S12)) (= (f31 (f32 f33 ?v0) f29) f29)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f15) ?v0) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f15) ?v0) f15)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f15) ?v0) f15)))
(assert (forall ((?v0 S12)) (= (f31 (f32 f33 f29) ?v0) f29)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f13 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v0)) (f5 (f6 f13 ?v1) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (not (= ?v0 f14)) (= (= (f5 ?v_0 ?v1) (f5 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (= (= (f5 (f6 f7 ?v1) ?v0) (f5 (f6 f7 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f14) (f5 f17 ?v0)) f1) (not (= ?v0 f14)))))
(assert (forall ((?v0 S7)) (= (= (f3 (f4 f14) (f10 f11 ?v0)) f1) (not (= ?v0 f15)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (f21 (f23 f24 ?v_0) ?v_0) (f21 (f23 f24 ?v0) ?v0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f5 f25 ?v0))) (= (f5 (f6 f7 ?v_0) ?v_0) (f5 (f6 f7 ?v0) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 f22 (f21 (f23 f24 ?v0) ?v1)) (f21 (f23 f24 (f21 f22 ?v0)) (f21 f22 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f25 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f25 ?v0)) (f5 f25 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f10 f11 ?v0))) (= (f5 f25 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f5 f17 ?v0))) (= (f5 f25 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) f14) f1) (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v2))) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f21 ?v_0 ?v1) (f21 ?v_0 ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) f14) f1) (= (f3 (f4 (f5 (f6 f7 ?v1) ?v2)) (f5 (f6 f7 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 0) (< (f21 (f23 f24 ?v1) ?v2) (f21 (f23 f24 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f21 ?v_0 ?v0) (f21 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f21 ?v_0 ?v0) (f21 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f21 (f23 f24 ?v0) ?v2) (f21 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 f14) (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< ?v1 0) (< 0 (f21 (f23 f24 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (=> (< 0 ?v1) (< (f21 (f23 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (= (f3 (f4 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (=> (< ?v0 0) (= (< (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (< ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f21 (f23 f24 ?v0) ?v1)) (=> (< 0 ?v1) (< 0 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 (f21 (f23 f24 ?v0) ?v1)) (=> (< 0 ?v0) (< 0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 (f5 (f6 f7 ?v1) ?v0)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f21 (f23 f24 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v1 0) (< (f21 (f23 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (< 0 (f21 (f23 f24 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (= (f3 (f4 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (=> (< 0 ?v0) (= (< (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (< ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (or (and (= (f3 (f4 f14) ?v0) f1) (= (f3 (f4 ?v1) ?v2) f1)) (and (= (f3 (f4 ?v0) f14) f1) (= (f3 (f4 ?v2) ?v1) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (< (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (or (and (< 0 ?v0) (< ?v1 ?v2)) (and (< ?v0 0) (< ?v2 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 ?v2) ?v1)) f1) (or (and (= (f3 (f4 f14) ?v1) f1) (= (f3 (f4 ?v0) ?v2) f1)) (and (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 ?v2) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f21 (f23 f24 ?v0) ?v1) (f21 (f23 f24 ?v2) ?v1)) (or (and (< 0 ?v1) (< ?v0 ?v2)) (and (< ?v1 0) (< ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f13 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) f14) f1) (=> (= (f3 (f4 f14) (f5 (f6 f7 ?v0) ?v1)) f1) (= (f3 (f4 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f14)) (?v_1 (f6 f13 ?v2))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 ?v_0 (f5 (f6 f7 ?v1) ?v0)) f1) (= (f3 (f4 (f5 ?v_1 ?v1)) (f5 ?v_1 ?v0)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f4 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v2) ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f4 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1) (= (f3 (f4 ?v2) (f5 (f6 f7 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 (f5 (f6 f7 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) (f5 (f6 f7 ?v2) ?v0)) f1) (= (f3 (f4 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f4 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1) (= (f3 (f4 ?v1) (f5 (f6 f7 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f4 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1) (= (f3 (f4 (f5 (f6 f7 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 f14)) (?v_0 (f5 (f6 f7 ?v2) ?v1))) (= (= (f3 (f4 (f5 (f6 f13 ?v0) ?v1)) ?v2) f1) (ite (= (f3 ?v_1 ?v1) f1) (= (f3 (f4 ?v0) ?v_0) f1) (ite (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 ?v_0) ?v0) f1) (= (f3 ?v_1 ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f4 ?v0)) (?v_0 (f5 (f6 f7 ?v0) ?v2))) (= (= (f3 ?v_1 (f5 (f6 f13 ?v1) ?v2)) f1) (ite (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 ?v_0) ?v1) f1) (ite (= (f3 (f4 ?v2) f14) f1) (= (f3 (f4 ?v1) ?v_0) f1) (= (f3 ?v_1 f14) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f25 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 (f5 f25 ?v0)) (f5 f25 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (= (f5 f25 (f5 (f6 f13 ?v1) ?v0)) (f5 (f6 f13 (f5 f25 ?v1)) (f5 f25 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (f5 (f6 f7 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 ?v2) ?v3)) (f5 (f6 f13 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (= (f18 (f19 f20 (f18 (f19 f30 ?v0) ?v1)) (f18 (f19 f30 ?v2) ?v3)) (f18 (f19 f30 (f18 (f19 f20 ?v0) ?v2)) (f18 (f19 f20 ?v1) ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (= (= (f3 ?v_0 (f5 (f6 f13 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 ?v0) f14) f1) (= (f3 (f4 ?v1) f14) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (= (= (f3 (f4 (f5 (f6 f13 ?v0) ?v1)) f14) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 ?v1) f14) f1)) (and (= (f3 (f4 ?v0) f14) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f4 ?v0) ?v2) f1)) (and (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 ?v2) ?v0) f1)) (not (= ?v1 f14)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (f5 (f6 f13 (f5 f25 ?v1)) ?v0) (f5 f25 (f5 (f6 f13 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f13 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 (f5 (f6 f13 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f4 (f5 (f6 f13 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f4 f14) (f5 (f6 f13 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 (f5 (f6 f13 ?v0) ?v2)) (f5 (f6 f13 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) f14) f1) (= (f3 (f4 (f5 (f6 f13 ?v1) ?v2)) (f5 (f6 f13 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= ?v0 (f5 (f6 f13 ?v1) ?v2)) (ite (not (= ?v2 f14)) (= (f5 (f6 f7 ?v0) ?v2) ?v1) (= ?v0 f14)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= ?v0 (f18 (f19 f30 ?v1) ?v2)) (ite (not (= ?v2 f15)) (= (f18 (f19 f20 ?v0) ?v2) ?v1) (= ?v0 f15)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f5 (f6 f13 ?v0) ?v1) ?v2) (ite (not (= ?v1 f14)) (= ?v0 (f5 (f6 f7 ?v2) ?v1)) (= ?v2 f14)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (= (= (f18 (f19 f30 ?v0) ?v1) ?v2) (ite (not (= ?v1 f15)) (= ?v0 (f18 (f19 f20 ?v2) ?v1)) (= ?v2 f15)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 f14)) (= (f5 (f6 f13 (f5 (f6 f7 ?v1) ?v0)) (f5 (f6 f7 ?v2) ?v0)) (f5 (f6 f13 ?v1) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (=> (not (= ?v0 f15)) (= (f18 (f19 f30 (f18 (f19 f20 ?v1) ?v0)) (f18 (f19 f20 ?v2) ?v0)) (f18 (f19 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (not (= ?v0 f14)) (= (f5 (f6 f13 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) (f5 (f6 f13 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (=> (not (= ?v0 f15)) (= (f18 (f19 f30 (f18 ?v_0 ?v1)) (f18 ?v_0 ?v2)) (f18 (f19 f30 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (not (= ?v0 f14)) (=> (not (= ?v1 f14)) (= (= (f5 (f6 f13 ?v2) ?v0) (f5 (f6 f13 ?v3) ?v1)) (= (f5 (f6 f7 ?v2) ?v1) (f5 (f6 f7 ?v3) ?v0)))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (=> (not (= ?v0 f15)) (=> (not (= ?v1 f15)) (= (= (f18 (f19 f30 ?v2) ?v0) (f18 (f19 f30 ?v3) ?v1)) (= (f18 (f19 f20 ?v2) ?v1) (f18 (f19 f20 ?v3) ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (exists ((?v2 S3)) (let ((?v_1 (f4 ?v2))) (and (= (f3 ?v_0 ?v2) f1) (and (= (f3 ?v_1 ?v0) f1) (= (f3 ?v_1 ?v1) f1))))))))))
(assert (not (= (f34 f35 f8) f15)))
(assert (forall ((?v0 S12)) (= (f31 (f32 f33 f28) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f27) ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S12)) (= (f31 (f32 f33 f28) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f27) ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S12)) (= (f31 (f32 f33 f28) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f27) ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f16) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (* 1 ?v0) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f5 f36 ?v0) (f5 f36 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f34 f35 ?v0) (f34 f35 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3)) (= (f5 f17 (f5 f36 ?v0)) (f5 f25 ?v0))))
(assert (forall ((?v0 S3)) (= (f10 f11 (f34 f35 ?v0)) (f5 f25 ?v0))))
(assert (= (f5 f36 f14) f14))
(assert (= (f34 f35 f14) f15))
(assert (= (f5 f36 f14) f14))
(assert (= (f34 f35 f14) f15))
(assert (forall ((?v0 S3)) (= (= (f5 f36 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 S3)) (= (= (f34 f35 ?v0) f15) (= ?v0 f14))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f36 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f36 ?v0)) (f5 f36 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f34 f35 (f5 (f6 f7 ?v0) ?v1)) (f18 (f19 f20 (f34 f35 ?v0)) (f34 f35 ?v1)))))
(assert (= (f5 f36 f16) f16))
(assert (= (f34 f35 f16) f27))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f36 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 (f5 f36 ?v0)) (f5 f36 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f34 f35 (f5 (f6 f13 ?v0) ?v1)) (f18 (f19 f30 (f34 f35 ?v0)) (f34 f35 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (= (f5 f36 (f5 (f6 f13 ?v1) ?v0)) (f5 (f6 f13 (f5 f36 ?v1)) (f5 f36 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f14)) (= (f34 f35 (f5 (f6 f13 ?v1) ?v0)) (f18 (f19 f30 (f34 f35 ?v1)) (f34 f35 ?v0))))))
(assert (= (f21 f22 0) 0))
(assert (= (f5 f25 f14) f14))
(assert (forall ((?v0 S3)) (= (= f14 ?v0) (= ?v0 f14))))
(assert (forall ((?v0 S7)) (= (= f15 ?v0) (= ?v0 f15))))
(assert (forall ((?v0 S12)) (= (= f29 ?v0) (= ?v0 f29))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= (f21 f22 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f5 f25 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (f21 (f23 f24 (f21 ?v_0 ?v1)) (f21 (f23 f24 ?v2) ?v3)) (f21 (f23 f24 (f21 ?v_0 ?v2)) (f21 (f23 f24 ?v1) ?v3))))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12) (?v3 S12)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) (f31 (f32 f33 ?v2) ?v3)) (f31 (f32 f33 (f31 ?v_0 ?v2)) (f31 (f32 f33 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) (f5 (f6 f7 ?v2) ?v3)) (f5 (f6 f7 (f5 ?v_0 ?v2)) (f5 (f6 f7 ?v1) ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) (f18 (f19 f20 ?v2) ?v3)) (f18 (f19 f20 (f18 ?v_0 ?v2)) (f18 (f19 f20 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f23 f24 (f21 (f23 f24 ?v0) ?v1))) (?v_0 (f23 f24 ?v2))) (= (f21 ?v_1 (f21 ?v_0 ?v3)) (f21 ?v_0 (f21 ?v_1 ?v3))))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12) (?v3 S12)) (let ((?v_1 (f32 f33 (f31 (f32 f33 ?v0) ?v1))) (?v_0 (f32 f33 ?v2))) (= (f31 ?v_1 (f31 ?v_0 ?v3)) (f31 ?v_0 (f31 ?v_1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_1 (f6 f7 (f5 (f6 f7 ?v0) ?v1))) (?v_0 (f6 f7 ?v2))) (= (f5 ?v_1 (f5 ?v_0 ?v3)) (f5 ?v_0 (f5 ?v_1 ?v3))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_1 (f19 f20 (f18 (f19 f20 ?v0) ?v1))) (?v_0 (f19 f20 ?v2))) (= (f18 ?v_1 (f18 ?v_0 ?v3)) (f18 ?v_0 (f18 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f23 f24 ?v0)) (?v_1 (f21 (f23 f24 ?v2) ?v3))) (= (f21 (f23 f24 (f21 ?v_0 ?v1)) ?v_1) (f21 ?v_0 (f21 (f23 f24 ?v1) ?v_1))))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12) (?v3 S12)) (let ((?v_0 (f32 f33 ?v0)) (?v_1 (f31 (f32 f33 ?v2) ?v3))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v_1) (f31 ?v_0 (f31 (f32 f33 ?v1) ?v_1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f6 f7 ?v0)) (?v_1 (f5 (f6 f7 ?v2) ?v3))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v_1) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v_1))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7) (?v3 S7)) (let ((?v_0 (f19 f20 ?v0)) (?v_1 (f18 (f19 f20 ?v2) ?v3))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v_1) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (f21 (f23 f24 (f21 ?v_0 ?v1)) ?v2) (f21 (f23 f24 (f21 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2) (f31 (f32 f33 (f31 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 (f6 f7 (f5 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 (f19 f20 (f18 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (f21 (f23 f24 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2) (f31 ?v_0 (f31 (f32 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (f21 (f23 f24 (f21 ?v_0 ?v1)) ?v2) (f21 ?v_0 (f21 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2) (f31 ?v_0 (f31 (f32 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2) (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2) (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (= (f21 ?v_0 (f21 (f23 f24 ?v1) ?v2)) (f21 (f23 f24 (f21 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f31 (f32 f33 ?v1) ?v2)) (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (= (f5 ?v_0 (f5 (f6 f7 ?v1) ?v2)) (f5 (f6 f7 (f5 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_0 (f19 f20 ?v0))) (= (f18 ?v_0 (f18 (f19 f20 ?v1) ?v2)) (f18 (f19 f20 (f18 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f23 f24 ?v0)) (?v_0 (f23 f24 ?v1))) (= (f21 ?v_1 (f21 ?v_0 ?v2)) (f21 ?v_0 (f21 ?v_1 ?v2))))))
(assert (forall ((?v0 S12) (?v1 S12) (?v2 S12)) (let ((?v_1 (f32 f33 ?v0)) (?v_0 (f32 f33 ?v1))) (= (f31 ?v_1 (f31 ?v_0 ?v2)) (f31 ?v_0 (f31 ?v_1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f6 f7 ?v0)) (?v_0 (f6 f7 ?v1))) (= (f5 ?v_1 (f5 ?v_0 ?v2)) (f5 ?v_0 (f5 ?v_1 ?v2))))))
(assert (forall ((?v0 S7) (?v1 S7) (?v2 S7)) (let ((?v_1 (f19 f20 ?v0)) (?v_0 (f19 f20 ?v1))) (= (f18 ?v_1 (f18 ?v_0 ?v2)) (f18 ?v_0 (f18 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f21 (f23 f24 ?v0) ?v1) (f21 (f23 f24 ?v1) ?v0))))
(assert (forall ((?v0 S12) (?v1 S12)) (= (f31 (f32 f33 ?v0) ?v1) (f31 (f32 f33 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 (f6 f7 ?v0) ?v1) (f5 (f6 f7 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f18 (f19 f20 ?v0) ?v1) (f18 (f19 f20 ?v1) ?v0))))
(assert (forall ((?v0 S7)) (= (= f27 ?v0) (= ?v0 f27))))
(assert (forall ((?v0 S12)) (= (= f28 ?v0) (= ?v0 f28))))
(assert (forall ((?v0 S3)) (= (= f16 ?v0) (= ?v0 f16))))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f21 f22 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (f5 f25 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (f21 f22 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f14) (f5 f25 ?v0)) f1) (not (= ?v0 f14)))))
(assert (forall ((?v0 Int)) (not (< (f21 f22 ?v0) 0))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 (f5 f25 ?v0)) f14) f1))))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f14) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f15) f15)))
(assert (forall ((?v0 S12)) (= (f31 (f32 f33 ?v0) f29) f29)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 f14) ?v0) f14)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 f15) ?v0) f15)))
(assert (forall ((?v0 S12)) (= (f31 (f32 f33 f29) ?v0) f29)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S12)) (= (f31 (f32 f33 ?v0) f28) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f27) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f16) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S12)) (= (f31 (f32 f33 ?v0) f28) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f27) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f16) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 Int)) (= (* ?v0 1) ?v0)))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 ?v0) f16) ?v0)))
(assert (forall ((?v0 S7)) (= (f18 (f19 f20 ?v0) f27) ?v0)))
(assert (= (f3 (f37 (f10 f11 (f34 f35 f8))) f16) f1))
(assert (let ((?v_0 (f34 f35 f8))) (= (f10 f11 (f18 (f19 f20 ?v_0) (f18 (f38 f39 f40) ?v_0))) (f10 f11 f12))))
(assert (forall ((?v0 S3)) (= (f5 f17 (f5 f41 ?v0)) (ite (= ?v0 f14) f14 f16))))
(assert (forall ((?v0 S7)) (= (f10 f11 (f18 f42 ?v0)) (ite (= ?v0 f15) f14 f16))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (= (f3 (f4 ?v0) ?v1) f1))))
(assert (=> (forall ((?v0 S7)) (=> (not (= ?v0 f15)) (= (f18 (f38 f39 f40) ?v0) f15))) (= f40 f29)))
(assert (forall ((?v0 S17) (?v1 S7)) (=> (= (f3 (f37 (f10 f11 ?v1)) f16) f1) (= (f3 (f37 (f10 f11 (f18 (f38 f39 f40) ?v1))) f9) f1))))
(assert (= (f3 (f37 (f10 f11 (f18 (f38 f39 f40) (f34 f35 f8)))) f9) f1))
(assert (let ((?v_0 (f34 f35 f8))) (= (f3 (f37 (f10 f11 (f18 (f19 f20 ?v_0) (f18 (f38 f39 f40) ?v_0)))) (f5 (f6 f7 f8) f9)) f1)))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f14) ?v0) f1) (forall ((?v1 S7)) (=> (= (f3 (f37 (f10 f11 ?v1)) f16) f1) (= (f3 (f37 (f10 f11 (f18 (f38 f39 f40) ?v1))) ?v0) f1))))))
(assert (forall ((?v0 S7)) (=> (not (= ?v0 f15)) (= (f18 (f38 f39 (f31 (f43 f44 f12) f40)) ?v0) f15))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f37 f14) ?v0) f1) (= (f5 f25 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f21 f22 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f37 (f5 f25 ?v0)) f14) f1) (= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (<= (f21 f22 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (f3 (f37 f14) (f5 f25 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= 0 (f21 f22 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f37 ?v0) (f5 f25 ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f37 (f5 f25 ?v0)) ?v1) f1) (= (f3 (f37 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3)) (= (f18 f42 (f34 f35 ?v0)) (f34 f35 (f5 f41 ?v0)))))
(assert (forall ((?v0 S3)) (= (f5 f41 (f5 f36 ?v0)) (f5 f36 (f5 f41 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f37 ?v0) ?v1) f1) (or (= (f3 (f4 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 ?v0) ?v1) f1) (and (= (f3 (f37 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3)) (= (f3 (f37 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f5 f41 ?v0))) (= (f5 f41 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f37 ?v0) ?v1) f1) (= (f3 (f37 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f37 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3)) (= (= (f5 f41 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 S7)) (= (= (f18 f42 ?v0) f15) (= ?v0 f15))))
(assert (forall ((?v0 S3)) (= (= (f5 f41 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= (f21 f45 ?v0) 0) (= ?v0 0))))
(assert (= (f5 f41 f14) f14))
(assert (= (f18 f42 f15) f15))
(assert (= (f5 f41 f14) f14))
(assert (= (f21 f45 0) 0))
(assert (forall ((?v0 S3)) (= (f5 f41 ?v0) (f5 (f6 f13 ?v0) (f5 f25 ?v0)))))
(assert (forall ((?v0 S3)) (= (f5 f25 ?v0) (f5 (f6 f7 ?v0) (f5 f41 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f41 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f41 ?v0)) (f5 f41 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f5 f41 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f41 ?v0)) (f5 f41 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f18 f42 (f18 (f19 f20 ?v0) ?v1)) (f18 (f19 f20 (f18 f42 ?v0)) (f18 f42 ?v1)))))
(assert (forall ((?v0 S3)) (= (f5 (f6 f7 (f5 f41 ?v0)) (f5 f25 ?v0)) ?v0)))
(assert (= (f5 f41 f16) f16))
(assert (forall ((?v0 Int)) (<= 0 (f21 (f23 f24 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f37 f14) (f5 (f6 f7 ?v0) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= 0 (f21 (f23 f24 ?v0) ?v1)) (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (= (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f37 ?v0) f14) f1) (= (f3 (f37 ?v1) f14) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f21 (f23 f24 ?v0) ?v1) 0) (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (= (= (f3 (f37 (f5 (f6 f7 ?v0) ?v1)) f14) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f37 ?v1) f14) f1)) (and (= (f3 (f37 ?v0) f14) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f37 f14) ?v0) f1) (= (f5 (f6 f7 (f5 f25 ?v1)) ?v0) (f5 f25 (f5 (f6 f7 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f21 (f23 f24 (f21 f22 ?v1)) ?v0) (f21 f22 (f21 (f23 f24 ?v1) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f21 (f23 f24 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f21 (f23 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f37 f14) ?v0) f1) (=> (= (f3 (f37 ?v1) f14) f1) (= (f3 (f37 (f5 (f6 f7 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 0) (<= (f21 (f23 f24 ?v1) ?v0) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f37 f14) ?v0) f1) (=> (= (f3 (f37 ?v1) f14) f1) (= (f3 (f37 (f5 (f6 f7 ?v1) ?v0)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= 0 ?v1) (<= (f21 (f23 f24 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f37 ?v0) f14) f1) (=> (= (f3 (f37 f14) ?v1) f1) (= (f3 (f37 (f5 (f6 f7 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= 0 (f21 (f23 f24 ?v0) ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f37 ?v0) f14) f1) (=> (= (f3 (f37 ?v1) f14) f1) (= (f3 (f37 f14) (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f21 (f23 f24 ?v0) ?v2) (f21 (f23 f24 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 f14) ?v2) f1) (= (f3 (f37 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f21 ?v_0 ?v0) (f21 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 f14) ?v2) f1) (= (f3 (f37 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v2))) (=> (<= ?v0 ?v1) (=> (<= 0 ?v2) (<= (f21 ?v_0 ?v0) (f21 ?v_0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 f14) ?v2) f1) (= (f3 (f37 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f21 (f23 f24 ?v1) ?v2) (f21 (f23 f24 ?v0) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 ?v2) f14) f1) (= (f3 (f37 (f5 (f6 f7 ?v1) ?v2)) (f5 (f6 f7 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v2))) (=> (<= ?v0 ?v1) (=> (<= ?v2 0) (<= (f21 ?v_0 ?v1) (f21 ?v_0 ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v2))) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 ?v2) f14) f1) (= (f3 (f37 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (<= (f21 (f23 f24 ?v0) ?v2) (f21 (f23 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f37 f14))) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f37 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v1) (=> (<= 0 ?v2) (<= (f21 (f23 f24 ?v0) ?v2) (f21 (f23 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f37 f14))) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f37 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= 0 ?v1)) (and (<= ?v0 0) (<= ?v1 0))) (<= 0 (f21 (f23 f24 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f37 ?v0) f14) f1) (= (f3 (f37 ?v1) f14) f1))) (= (f3 ?v_0 (f5 (f6 f7 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (=> (and (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f37 ?v0) f14) f1)) (or (= (f3 ?v_0 ?v1) f1) (= (f3 (f37 ?v1) f14) f1))) (= (f5 f25 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 (f5 f25 ?v0)) (f5 f25 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (and (or (<= 0 ?v0) (<= ?v0 0)) (or (<= 0 ?v1) (<= ?v1 0))) (= (f21 f22 (f21 (f23 f24 ?v0) ?v1)) (f21 (f23 f24 (f21 f22 ?v0)) (f21 f22 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (or (and (<= 0 ?v0) (<= ?v1 0)) (and (<= ?v0 0) (<= 0 ?v1))) (<= (f21 (f23 f24 ?v0) ?v1) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (=> (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f37 ?v1) f14) f1)) (and (= (f3 (f37 ?v0) f14) f1) (= (f3 ?v_0 ?v1) f1))) (= (f3 (f37 (f5 (f6 f7 ?v0) ?v1)) f14) f1)))))
(assert (<= 0 1))
(assert (= (f3 (f37 f14) f16) f1))
(assert (not (<= 1 0)))
(assert (not (= (f3 (f37 f16) f14) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 ?v2) f14) f1) (= (f3 (f37 (f5 (f6 f13 ?v1) ?v2)) (f5 (f6 f13 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 f14) ?v2) f1) (= (f3 (f37 (f5 (f6 f13 ?v0) ?v2)) (f5 (f6 f13 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (= (= (f3 (f37 (f5 (f6 f13 ?v0) ?v1)) f14) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f37 ?v1) f14) f1)) (and (= (f3 (f37 ?v0) f14) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (= (= (f3 ?v_0 (f5 (f6 f13 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f37 ?v0) f14) f1) (= (f3 (f37 ?v1) f14) f1)))))))
(assert (forall ((?v0 S3)) (= (f3 (f37 f14) (f5 f17 ?v0)) f1)))
(assert (forall ((?v0 S7)) (= (f3 (f37 f14) (f10 f11 ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (= (= (f3 ?v_0 (f5 (f6 f13 ?v0) ?v1)) f1) (and (or (= (f3 (f37 ?v0) f14) f1) (= (f3 ?v_0 ?v1) f1)) (or (= (f3 ?v_0 ?v0) f1) (= (f3 (f37 ?v1) f14) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f14))) (= (= (f3 ?v_0 (f5 f41 ?v0)) f1) (= (f3 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f21 f45 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 (f5 f41 ?v0)) f14) f1) (= (f3 (f4 ?v0) f14) f1))))
(assert (forall ((?v0 Int)) (= (< (f21 f45 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (=> (< 0 ?v0) (= (<= (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (<= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f37 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (= (f3 (f37 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (=> (< ?v0 0) (= (<= (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (<= ?v2 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f37 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (= (f3 (f37 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v1) (=> (<= 0 ?v2) (< (f21 (f23 f24 ?v0) ?v2) (f21 (f23 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) ?v3) f1) (=> (= (f3 (f4 f14) ?v1) f1) (=> (= (f3 (f37 f14) ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (< (f21 (f23 f24 ?v0) ?v2) (f21 (f23 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f37 f14))) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) ?v3) f1) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (=> (<= 0 ?v0) (=> (< 0 ?v2) (< (f21 (f23 f24 ?v0) ?v2) (f21 (f23 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f37 ?v2) ?v3) f1) (=> (= (f3 (f37 f14) ?v0) f1) (=> (= (f3 (f4 f14) ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (=> (< 0 ?v0) (=> (<= 0 ?v2) (< (f21 (f23 f24 ?v0) ?v2) (f21 (f23 f24 ?v1) ?v3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f4 ?v2) ?v3) f1) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f37 f14) ?v2) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) ?v2)) (f5 (f6 f7 ?v1) ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f21 (f23 f24 ?v0) ?v1) (f21 (f23 f24 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 ?v2) ?v1)) f1) (=> (= (f3 (f37 f14) ?v1) f1) (= (f3 (f4 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (f21 (f23 f24 ?v0) ?v1) (f21 (f23 f24 ?v2) ?v1)) (=> (<= 0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 ?v2) ?v1)) f1) (=> (= (f3 (f37 f14) ?v1) f1) (= (f3 (f4 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (=> (< (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (=> (= (f3 (f37 f14) ?v0) f1) (= (f3 (f4 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (=> (< (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (=> (<= 0 ?v0) (< ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (=> (= (f3 (f37 f14) ?v0) f1) (= (f3 (f4 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f21 (f23 f24 ?v0) ?v1) (f21 (f23 f24 ?v2) ?v1)) (=> (< 0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f37 (f5 (f6 f7 ?v0) ?v1)) (f5 (f6 f7 ?v2) ?v1)) f1) (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f37 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f23 f24 ?v0))) (=> (<= (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (=> (< 0 ?v0) (<= ?v1 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f37 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (=> (= (f3 (f4 f14) ?v0) f1) (= (f3 (f37 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f21 (f23 f24 ?v1) ?v0) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f37 ?v1) f16) f1) (= (f3 (f37 (f5 (f6 f7 ?v1) ?v0)) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (<= ?v1 1) (<= (f21 (f23 f24 ?v0) ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f37 ?v1) f16) f1) (= (f3 (f37 (f5 (f6 f7 ?v0) ?v1)) ?v0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f37 ?v0) f14) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f37 f14) (f5 (f6 f13 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f37 ?v0) f14) f1) (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f37 (f5 (f6 f13 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f37 f14) ?v0) f1) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (=> (= (f3 (f37 ?v2) ?v3) f1) (= (f3 (f37 (f5 (f6 f13 ?v0) ?v3)) (f5 (f6 f13 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f37 f14) ?v0) f1) (=> (= (f3 (f4 ?v0) ?v1) f1) (=> (= (f3 (f4 f14) ?v2) f1) (=> (= (f3 (f37 ?v2) ?v3) f1) (= (f3 (f4 (f5 (f6 f13 ?v0) ?v3)) (f5 (f6 f13 ?v1) ?v2)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 (f4 ?v2) ?v3) f1) (= (f3 (f4 (f5 (f6 f13 ?v0) ?v3)) (f5 (f6 f13 ?v1) ?v2)) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f37 f14) ?v0) f1) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f37 (f5 (f6 f13 ?v0) ?v1)) f14) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f14))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 ?v_0 (f5 (f6 f13 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f37 (f5 (f6 f13 ?v0) ?v1)) (f5 (f6 f13 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f14) ?v1) f1) (= (f3 (f37 ?v0) ?v2) f1)) (=> (= (f3 (f4 ?v1) f14) f1) (= (f3 (f37 ?v2) ?v0) f1))))))
(assert (forall ((?v0 S7)) (= (= (f3 (f37 (f10 f11 ?v0)) f14) f1) (= ?v0 f15))))
(assert (forall ((?v0 S3)) (= (= (f3 (f37 (f5 f17 ?v0)) f14) f1) (= ?v0 f14))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f3 (f37 (f10 f11 (f18 (f19 f20 ?v0) ?v1))) (f5 (f6 f7 (f10 f11 ?v0)) (f10 f11 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f37 (f5 f17 (f5 (f6 f7 ?v0) ?v1))) (f5 (f6 f7 (f5 f17 ?v0)) (f5 f17 ?v1))) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f37 (f5 (f6 f7 ?v1) ?v0)) (f5 (f6 f7 ?v2) ?v0)) f1) (= (f3 (f37 ?v1) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f7 ?v0))) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f37 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v2)) f1) (= (f3 (f37 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (f5 f41 ?v0) f16))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f21 f45 ?v0) 1))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (f5 f41 ?v0) f16))))
(assert (forall ((?v0 Int)) (= (= (f21 f45 ?v0) 1) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f5 f41 ?v0) f16) (= (f3 (f4 f14) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f37 ?v0)) (?v_0 (f5 (f6 f7 ?v0) ?v2))) (= (= (f3 ?v_1 (f5 (f6 f13 ?v1) ?v2)) f1) (ite (= (f3 (f4 f14) ?v2) f1) (= (f3 (f37 ?v_0) ?v1) f1) (ite (= (f3 (f4 ?v2) f14) f1) (= (f3 (f37 ?v1) ?v_0) f1) (= (f3 ?v_1 f14) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f5 (f6 f7 ?v2) ?v1))) (= (= (f3 (f37 (f5 (f6 f13 ?v0) ?v1)) ?v2) f1) (ite (= (f3 (f4 f14) ?v1) f1) (= (f3 (f37 ?v0) ?v_0) f1) (ite (= (f3 (f4 ?v1) f14) f1) (= (f3 (f37 ?v_0) ?v0) f1) (= (f3 (f37 f14) ?v2) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f37 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1) (= (f3 (f37 (f5 (f6 f7 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (= (= (f3 (f37 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1) (= (f3 (f37 ?v1) (f5 (f6 f7 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f37 ?v1) (f5 (f6 f7 ?v2) ?v0)) f1) (= (f3 (f37 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f14) ?v0) f1) (=> (= (f3 (f37 (f5 (f6 f7 ?v1) ?v0)) ?v2) f1) (= (f3 (f37 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f37 ?v1) (f5 (f6 f13 ?v2) ?v0)) f1) (= (f3 (f37 ?v2) (f5 (f6 f7 ?v1) ?v0)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 ?v0) f14) f1) (= (= (f3 (f37 (f5 (f6 f13 ?v1) ?v0)) ?v2) f1) (= (f3 (f37 (f5 (f6 f7 ?v2) ?v0)) ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f13 ?v2))) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 f14) ?v2) f1) (=> (= (f3 (f4 f14) (f5 (f6 f7 ?v1) ?v0)) f1) (= (f3 (f37 (f5 ?v_0 ?v1)) (f5 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f6 f13 ?v2))) (=> (= (f3 (f37 ?v0) ?v1) f1) (=> (= (f3 (f37 ?v2) f14) f1) (=> (= (f3 (f4 f14) (f5 (f6 f7 ?v0) ?v1)) f1) (= (f3 (f37 (f5 ?v_0 ?v0)) (f5 ?v_0 ?v1)) f1)))))))
(assert (forall ((?v0 S7)) (=> (not (= ?v0 f15)) (= (f18 (f38 f39 f46) ?v0) f15))))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f14) ?v0) f1) (forall ((?v1 S3)) (= (f3 (f37 (f10 f11 (f34 f35 ?v1))) (f5 (f6 f7 (f5 f17 ?v1)) ?v0)) f1)))))
(assert (exists ((?v0 S3)) (and (= (f3 (f4 f14) ?v0) f1) (forall ((?v1 S3)) (= (f3 (f37 (f5 f17 (f5 f36 ?v1))) (f5 (f6 f7 (f5 f17 ?v1)) ?v0)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (and (= (f3 (f4 f14) ?v1) f1) (forall ((?v2 S3)) (= (f3 (f37 (f5 f17 (f5 (f6 f13 ?v2) ?v0))) (f5 (f6 f7 (f5 f17 ?v2)) ?v1)) f1))))))
(assert (forall ((?v0 S7)) (exists ((?v1 S3)) (and (= (f3 (f4 f14) ?v1) f1) (forall ((?v2 S7)) (= (f3 (f37 (f10 f11 (f18 (f19 f30 ?v2) ?v0))) (f5 (f6 f7 (f10 f11 ?v2)) ?v1)) f1))))))
(assert (not (exists ((?v0 S7) (?v1 S12)) (and (not (= ?v0 f15)) (and (= ?v1 f29) (= f47 (f31 (f43 f44 ?v0) ?v1)))))))
(assert (= (f48 (f38 f39 (f31 (f43 f44 f26) f46))) f1))
(check-sat)
(exit)
