(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-sort S25 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S3)
(declare-fun f7 (S5 S3) S3)
(declare-fun f8 () S5)
(declare-fun f9 () S3)
(declare-fun f10 () S3)
(declare-fun f11 (S6 Int) Int)
(declare-fun f12 () S6)
(declare-fun f13 () S5)
(declare-fun f14 () S7)
(declare-fun f15 (S8 Int) S6)
(declare-fun f16 () S8)
(declare-fun f17 (S9 S3) S5)
(declare-fun f18 () S9)
(declare-fun f19 () S8)
(declare-fun f20 () S9)
(declare-fun f21 (S10 S7) S7)
(declare-fun f22 () S10)
(declare-fun f23 () S7)
(declare-fun f24 (S11 S3) S7)
(declare-fun f25 (S12 S3) S11)
(declare-fun f26 () S12)
(declare-fun f27 (S13 Int) S3)
(declare-fun f28 (S14 S3) Int)
(declare-fun f29 (S15 S16) S7)
(declare-fun f30 (S17 S7) S15)
(declare-fun f31 () S17)
(declare-fun f32 () S10)
(declare-fun f33 (S18 Int) S16)
(declare-fun f34 () S18)
(declare-fun f35 (S19 S16) Int)
(declare-fun f36 (S20 Int) S19)
(declare-fun f37 () S20)
(declare-fun f38 (S21 S16) S3)
(declare-fun f39 (S22 S3) S21)
(declare-fun f40 () S22)
(declare-fun f41 () S19)
(declare-fun f42 (S23 S7) S16)
(declare-fun f43 () S23)
(declare-fun f44 () S23)
(declare-fun f45 (S24 S4) S9)
(declare-fun f46 () S24)
(declare-fun f47 () S24)
(declare-fun f48 (S3) S1)
(declare-fun f49 () S12)
(declare-fun f50 () S9)
(declare-fun f51 (S25 S7) S10)
(declare-fun f52 () S25)
(declare-fun f53 (S3 S3) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 f6) (f7 f8 f9)) f1)))
(assert (not (= (f3 (f4 f5 f6) f9) f1)))
(assert (= f10 f6))
(assert (not (= (f3 (f4 f5 f6) f9) f1)))
(assert (forall ((?v0 Int)) (<= (- (f11 f12 ?v0)) 0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f7 f8 (f7 f13 ?v0))) f6) f1)))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 f6) (f7 f8 ?v0)) f1) (= (f3 (f4 f5 ?v0) f6) f1))))
(assert (forall ((?v0 Int)) (= (<= 0 (- ?v0)) (<= ?v0 0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f7 f8 ?v0)) f1) (= (f3 ?v_0 f6) f1)))))
(assert (forall ((?v0 Int)) (= (<= ?v0 (- ?v0)) (<= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f7 f8 ?v0)) f6) f1) (= (f3 (f4 f5 f6) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (<= (- ?v0) 0) (<= 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f7 f8 ?v0)) ?v0) f1) (= (f3 (f4 f5 f6) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (<= (- ?v0) ?v0) (<= 0 ?v0))))
(assert (forall ((?v0 Int)) (=> (<= ?v0 0) (= (f11 f12 ?v0) (- ?v0)))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (f7 f13 ?v0) (f7 f8 ?v0)))))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f7 f13 ?v0)) ?v1) f1) (and (= (f3 (f4 f5 (f7 f8 ?v1)) ?v0) f1) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int)) (<= (- ?v0) (f11 f12 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 (f7 f8 ?v0)) (f7 f13 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 (- ?v1)) (<= ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) (f7 f8 ?v1)) f1) (= (f3 (f4 f5 ?v1) (f7 f8 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) ?v1) (<= (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f7 f8 ?v0)) ?v1) f1) (= (f3 (f4 f5 (f7 f8 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f11 f12 ?v0) ?v1) (and (<= ?v0 ?v1) (<= (- ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f7 f13 ?v0)) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f7 f8 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int)) (= (= (f11 f12 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f7 f13 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 S3)) (= (= f6 ?v0) (= ?v0 f6))))
(assert (forall ((?v0 S7)) (= (= f14 ?v0) (= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (= (f11 f12 0) 0))
(assert (= (f7 f13 f6) f6))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (<= ?v0 ?v1) false) (=> (=> (<= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f11 f12 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 (f7 f13 ?v0)) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v0) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v0 ?v2) (<= ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (<= ?v1 ?v2) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (<= ?v1 ?v0) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 ?v1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f11 (f15 f16 ?v0) ?v1) ?v2) (or (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f7 (f17 f18 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f11 (f15 f19 ?v1) ?v2)) (or (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f7 (f17 f20 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 ?v1) (and (<= ?v0 ?v1) (<= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 ?v1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f11 f12 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) (f7 f13 ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f7 f8 ?v0) (f7 f8 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f21 f22 ?v0) (f21 f22 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f7 f8 ?v0) ?v1) (= (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f21 f22 ?v0) ?v1) (= (f21 f22 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 (f7 f8 ?v1)) (= ?v1 (f7 f8 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 (f21 f22 ?v1)) (= ?v1 (f21 f22 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f11 (f15 f16 ?v0) ?v1)) (f11 (f15 f19 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 f8 (f7 (f17 f18 ?v0) ?v1)) (f7 (f17 f20 (f7 f8 ?v0)) (f7 f8 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f11 (f15 f19 ?v0) ?v1)) (f11 (f15 f16 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 f8 (f7 (f17 f20 ?v0) ?v1)) (f7 (f17 f18 (f7 f8 ?v0)) (f7 f8 ?v1)))))
(assert (forall ((?v0 Int)) (= (f11 f12 (- ?v0)) (f11 f12 ?v0))))
(assert (forall ((?v0 S3)) (= (f7 f13 (f7 f8 ?v0)) (f7 f13 ?v0))))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 f8 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 S7)) (= (f21 f22 (f21 f22 ?v0)) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f11 f12 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f7 f13 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (<= (f11 f12 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f7 f13 ?v0)) f6) f1) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (<= 0 (f11 f12 ?v0))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f6) (f7 f13 ?v0)) f1)))
(assert (forall ((?v0 S3)) (= (= (f7 f8 ?v0) ?v0) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) ?v0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f7 f8 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 S7)) (= (= (f21 f22 ?v0) f14) (= ?v0 f14))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= ?v0 (f7 f8 ?v0)) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= f6 (f7 f8 ?v0)) (= f6 ?v0))))
(assert (forall ((?v0 S7)) (= (= f14 (f21 f22 ?v0)) (= f14 ?v0))))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (= (f7 f8 f6) f6))
(assert (= (f21 f22 f14) f14))
(assert (= 0 0))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f11 f12 ?v0) ?v1) (<= (- ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 (f7 f13 ?v0)) ?v1) f1) (= (f3 (f4 f5 (f7 f8 ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= (- ?v0) ?v1) (<= (f11 f12 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 (f7 f8 ?v0)) ?v1) f1) (= (f3 (f4 f5 (f7 f13 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (<= (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f7 f8 ?v1)) (f7 f8 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) (- ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f7 f8 ?v0)) (f7 f8 ?v1)) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (= f23 (f24 (f25 f26 f9) f10)))
(assert (forall ((?v0 S13) (?v1 Int) (?v2 S3) (?v3 Int)) (=> (= (f3 (f4 f5 (f27 ?v0 ?v1)) ?v2) f1) (=> (<= ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (= (f3 (f4 f5 (f27 ?v0 ?v5)) (f27 ?v0 ?v4)) f1))) (= (f3 (f4 f5 (f27 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S14) (?v1 S3) (?v2 Int) (?v3 S3)) (=> (<= (f28 ?v0 ?v1) ?v2) (=> (= (f3 (f4 f5 ?v3) ?v1) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (<= (f28 ?v0 ?v5) (f28 ?v0 ?v4)))) (<= (f28 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f11 ?v1 ?v2)) (=> (<= ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v5 ?v4) (<= (f11 ?v1 ?v5) (f11 ?v1 ?v4)))) (<= (f11 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S5) (?v2 S3) (?v3 S3)) (=> (= ?v0 (f7 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v3) ?v2) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (= (f3 (f4 f5 (f7 ?v1 ?v5)) (f7 ?v1 ?v4)) f1))) (= (f3 (f4 f5 (f7 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 S3) (?v1 S13) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 (f27 ?v1 ?v2)) f1) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f3 (f4 f5 (f27 ?v1 ?v4)) (f27 ?v1 ?v5)) f1))) (= (f3 ?v_0 (f27 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S3) (?v3 S3)) (=> (<= ?v0 (f28 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (<= (f28 ?v1 ?v4) (f28 ?v1 ?v5)))) (<= ?v0 (f28 ?v1 ?v3)))))))
(assert (forall ((?v0 Int) (?v1 S14) (?v2 S3) (?v3 S3)) (=> (= ?v0 (f28 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (<= (f28 ?v1 ?v4) (f28 ?v1 ?v5)))) (<= ?v0 (f28 ?v1 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S13) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f27 ?v1 ?v2)) (=> (<= ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f3 (f4 f5 (f27 ?v1 ?v4)) (f27 ?v1 ?v5)) f1))) (= (f3 (f4 f5 ?v0) (f27 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S14) (?v3 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (<= (f28 ?v2 ?v1) ?v3) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (<= (f28 ?v2 ?v4) (f28 ?v2 ?v5)))) (<= (f28 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 S3)) (=> (<= ?v0 ?v1) (=> (= (f3 (f4 f5 (f27 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f3 (f4 f5 (f27 ?v2 ?v4)) (f27 ?v2 ?v5)) f1))) (= (f3 (f4 f5 (f27 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S14) (?v3 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f28 ?v2 ?v1) ?v3) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (<= (f28 ?v2 ?v4) (f28 ?v2 ?v5)))) (<= (f28 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 S3)) (=> (<= ?v0 ?v1) (=> (= (f27 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (<= ?v4 ?v5) (= (f3 (f4 f5 (f27 ?v2 ?v4)) (f27 ?v2 ?v5)) f1))) (= (f3 (f4 f5 (f27 ?v2 ?v0)) ?v3) f1))))))
(assert (=> (forall ((?v0 S3) (?v1 S3)) (=> (= f23 (f24 (f25 f26 ?v0) ?v1)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f11 (f15 f19 ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 ?v0) (f7 (f17 f20 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f11 (f15 f19 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 ?v0) (f7 (f17 f20 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f11 (f15 f16 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f7 (f17 f18 ?v0) ?v1)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f11 (f15 f16 ?v0) ?v1) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f7 (f17 f18 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f11 (f15 f19 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f7 (f17 f20 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f11 (f15 f16 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f7 (f17 f18 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f11 (f15 f16 ?v1) ?v2)) (and (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f7 (f17 f18 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f19 ?v0))) (<= (f11 ?v_0 (f11 (f15 f16 ?v1) ?v2)) (f11 (f15 f16 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f20 ?v0))) (= (f3 (f4 f5 (f7 ?v_0 (f7 (f17 f18 ?v1) ?v2))) (f7 (f17 f18 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f11 (f15 f19 ?v0) ?v1) ?v2) (and (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f7 (f17 f20 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f15 f16 ?v0))) (<= (f11 (f15 f19 (f11 ?v_0 ?v1)) (f11 ?v_0 ?v2)) (f11 ?v_0 (f11 (f15 f19 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f18 ?v0))) (= (f3 (f4 f5 (f7 (f17 f20 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))) (f7 ?v_0 (f7 (f17 f20 ?v1) ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f11 (f15 f19 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f7 (f17 f20 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f11 (f15 f19 ?v2) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f7 (f17 f20 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f11 (f15 f16 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f7 (f17 f18 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f11 (f15 f16 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f7 (f17 f18 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f11 (f15 f19 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f7 (f17 f20 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f11 (f15 f16 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f7 (f17 f18 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f11 (f15 f19 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f7 (f17 f20 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f11 (f15 f16 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f7 (f17 f18 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f11 (f15 f16 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f7 (f17 f18 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f11 (f15 f16 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f7 (f17 f18 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f11 (f15 f19 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v1) f1) (= (f3 (f4 f5 (f7 (f17 f20 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f11 (f15 f19 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v1) f1) (= (f3 (f4 f5 (f7 (f17 f20 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f11 (f15 f19 ?v0) ?v2) (f11 (f15 f19 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f7 (f17 f20 ?v0) ?v2)) (f7 (f17 f20 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f11 (f15 f16 ?v0) ?v2) (f11 (f15 f16 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f7 (f17 f18 ?v0) ?v2)) (f7 (f17 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f11 (f15 f16 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 (f7 (f17 f18 ?v1) ?v2)) f1) (=> (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) false)) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f11 (f15 f19 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 (f7 (f17 f20 ?v0) ?v1)) ?v2) f1) (=> (=> (= (f3 (f4 f5 ?v0) ?v2) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) false)) false))))
(assert (=> (= (f3 (f4 f5 f6) f9) f1) (= (f29 (f30 f31 (f21 f32 f23)) (f33 f34 2)) f23)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f21 f22 (f24 (f25 f26 ?v0) ?v1)) (f24 (f25 f26 (f7 f8 ?v0)) (f7 f8 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f24 (f25 f26 ?v0) ?v1) f14) (and (= ?v0 f6) (= ?v1 f6)))))
(assert (= f14 (f24 (f25 f26 f6) f6)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (forall ((?v2 Int)) (<= ?v0 ?v2)) (= (f11 (f15 f19 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (forall ((?v2 S3)) (= (f3 (f4 f5 ?v0) ?v2) f1)) (= (f7 (f17 f20 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f33 f34 (+ (+ 0 1) 1)))) (= (= (f35 (f36 f37 ?v0) ?v_0) (f35 (f36 f37 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (- ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S7)) (let ((?v_0 (f33 f34 (+ (+ 0 1) 1)))) (= (= (f29 (f30 f31 ?v0) ?v_0) (f29 (f30 f31 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (f21 f22 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f33 f34 (+ (+ 0 1) 1)))) (= (= (f38 (f39 f40 ?v0) ?v_0) (f38 (f39 f40 ?v1) ?v_0)) (or (= ?v0 ?v1) (= ?v0 (f7 f8 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (= (= (f24 (f25 f26 ?v0) ?v1) (f24 (f25 f26 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f33 f34 2))) (=> (= (f35 (f36 f37 ?v0) ?v_0) (f35 (f36 f37 ?v1) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (f4 f5 f6)) (?v_0 (f33 f34 2))) (=> (= (f38 (f39 f40 ?v0) ?v_0) (f38 (f39 f40 ?v1) ?v_0)) (=> (= (f3 ?v_1 ?v0) f1) (=> (= (f3 ?v_1 ?v1) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f33 f34 2))) (=> (<= (f35 (f36 f37 ?v0) ?v_0) (f35 (f36 f37 ?v1) ?v_0)) (=> (<= 0 ?v1) (<= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f33 f34 2))) (=> (= (f3 (f4 f5 (f38 (f39 f40 ?v0) ?v_0)) (f38 (f39 f40 ?v1) ?v_0)) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 S16) (?v2 Int)) (let ((?v_0 (f33 f34 (+ (f35 f41 ?v1) 1)))) (=> (= (f35 (f36 f37 ?v0) ?v_0) (f35 (f36 f37 ?v2) ?v_0)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S16) (?v2 S3)) (let ((?v_1 (f4 f5 f6)) (?v_0 (f33 f34 (+ (f35 f41 ?v1) 1)))) (=> (= (f38 (f39 f40 ?v0) ?v_0) (f38 (f39 f40 ?v2) ?v_0)) (=> (= (f3 ?v_1 ?v0) f1) (=> (= (f3 ?v_1 ?v2) f1) (= ?v0 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S16) (?v2 Int)) (let ((?v_0 (f33 f34 (+ (f35 f41 ?v1) 1)))) (=> (<= (f35 (f36 f37 ?v0) ?v_0) (f35 (f36 f37 ?v2) ?v_0)) (=> (<= 0 ?v2) (<= ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S16) (?v2 S3)) (let ((?v_0 (f33 f34 (+ (f35 f41 ?v1) 1)))) (=> (= (f3 (f4 f5 (f38 (f39 f40 ?v0) ?v_0)) (f38 (f39 f40 ?v2) ?v_0)) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S16) (?v2 Int)) (=> (= (f35 (f36 f37 ?v0) ?v1) (f35 (f36 f37 ?v2) ?v1)) (=> (<= 0 ?v0) (=> (<= 0 ?v2) (=> (< 0 (f35 f41 ?v1)) (= ?v0 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S16) (?v2 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f38 (f39 f40 ?v0) ?v1) (f38 (f39 f40 ?v2) ?v1)) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (=> (< 0 (f35 f41 ?v1)) (= ?v0 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f33 f34 2))) (= (f3 (f4 f5 (f7 f8 (f38 (f39 f40 ?v0) ?v_0))) (f38 (f39 f40 ?v1) ?v_0)) f1))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f33 f34 2))) (= (f38 (f39 f40 (f7 f13 ?v0)) ?v_0) (f38 (f39 f40 ?v0) ?v_0)))))
(assert (forall ((?v0 S3)) (= (f38 (f39 f40 ?v0) (f33 f34 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f29 (f30 f31 ?v0) (f33 f34 1)) ?v0)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f38 (f39 f40 ?v0) (f33 f34 2)))) (= (f7 f13 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S16)) (= (f7 f13 (f38 (f39 f40 ?v0) ?v1)) (f38 (f39 f40 (f7 f13 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S16)) (=> (not (= ?v0 0)) (not (= (f35 (f36 f37 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S7) (?v1 S16)) (=> (not (= ?v0 f14)) (not (= (f29 (f30 f31 ?v0) ?v1) f14)))))
(assert (forall ((?v0 S3) (?v1 S16)) (=> (not (= ?v0 f6)) (not (= (f38 (f39 f40 ?v0) ?v1) f6)))))
(assert (forall ((?v0 Int)) (= (= (f35 (f36 f37 ?v0) (f33 f34 2)) 0) (= ?v0 0))))
(assert (forall ((?v0 S7)) (= (= (f29 (f30 f31 ?v0) (f33 f34 2)) f14) (= ?v0 f14))))
(assert (forall ((?v0 S3)) (= (= (f38 (f39 f40 ?v0) (f33 f34 2)) f6) (= ?v0 f6))))
(assert (forall ((?v0 Int) (?v1 S16)) (= (= (f35 (f36 f37 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f33 f34 0)))))))
(assert (forall ((?v0 S7) (?v1 S16)) (= (= (f29 (f30 f31 ?v0) ?v1) f14) (and (= ?v0 f14) (not (= ?v1 (f33 f34 0)))))))
(assert (forall ((?v0 S3) (?v1 S16)) (= (= (f38 (f39 f40 ?v0) ?v1) f6) (and (= ?v0 f6) (not (= ?v1 (f33 f34 0)))))))
(assert (= (f35 (f36 f37 0) (f33 f34 2)) 0))
(assert (= (f29 (f30 f31 f14) (f33 f34 2)) f14))
(assert (= (f38 (f39 f40 f6) (f33 f34 2)) f6))
(assert (forall ((?v0 S16)) (= (f35 (f36 f37 0) (f33 f34 (+ (f35 f41 ?v0) 1))) 0)))
(assert (forall ((?v0 S16)) (= (f29 (f30 f31 f14) (f33 f34 (+ (f35 f41 ?v0) 1))) f14)))
(assert (forall ((?v0 S16)) (= (f38 (f39 f40 f6) (f33 f34 (+ (f35 f41 ?v0) 1))) f6)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f33 f34 2))) (= (f38 (f39 f40 (f7 f8 ?v0)) ?v_0) (f38 (f39 f40 ?v0) ?v_0)))))
(assert (forall ((?v0 S7)) (let ((?v_0 (f33 f34 2))) (= (f29 (f30 f31 (f21 f22 ?v0)) ?v_0) (f29 (f30 f31 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S16)) (= (f7 f13 (f38 (f39 f40 (f7 f8 ?v0)) ?v1)) (f7 f13 (f38 (f39 f40 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (<= 0 (f35 (f36 f37 ?v0) (f33 f34 2)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f5 f6) (f38 (f39 f40 ?v0) (f33 f34 2))) f1)))
(assert (forall ((?v0 S3) (?v1 S16)) (= (f3 (f4 f5 f6) (f38 (f39 f40 (f7 f13 ?v0)) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S16)) (<= 0 (f35 (f36 f37 (f11 f12 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S16)) (=> (<= 0 ?v0) (<= 0 (f35 (f36 f37 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S16)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 (f38 (f39 f40 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S16)) (=> (<= ?v0 ?v1) (=> (<= 0 ?v0) (<= (f35 (f36 f37 ?v0) ?v2) (f35 (f36 f37 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S16)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f3 (f4 f5 (f38 (f39 f40 ?v0) ?v2)) (f38 (f39 f40 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f42 f43 (f24 (f25 f26 ?v0) ?v1)) (f33 f34 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f42 f44 (f24 (f25 f26 ?v0) ?v1)) (f33 f34 0))))
(assert (forall ((?v0 S7)) (=> (forall ((?v1 S3) (?v2 S3)) (=> (= ?v0 (f24 (f25 f26 ?v1) ?v2)) false)) false)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S5) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f7 ?v2 ?v0) ?v3) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (= (f3 (f4 f5 (f7 ?v2 ?v5)) (f7 ?v2 ?v4)) f1))) (= (f3 (f4 f5 ?v3) (f7 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (forall ((?v2 S3)) (= (f3 (f4 f5 ?v0) ?v2) f1)) (= (f7 (f17 f18 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (forall ((?v2 S3)) (= (f3 (f4 f5 ?v0) ?v2) f1)) (= (f7 (f17 f20 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (forall ((?v2 S3)) (= (f3 (f4 f5 ?v0) ?v2) f1)) (= (f7 (f17 f18 ?v1) ?v0) ?v0))))
(assert (= f20 (f45 f46 f5)))
(assert (= f18 (f45 f47 f5)))
(assert (forall ((?v0 S3)) (=> (not (= (f48 ?v0) f1)) (=> (not (= ?v0 f6)) (= (f48 (f7 f8 ?v0)) f1)))))
(assert (forall ((?v0 S3)) (= (f24 (f25 f49 f6) ?v0) f14)))
(assert (not (= (f48 f6) f1)))
(assert (forall ((?v0 S3)) (= (f38 (f39 f40 ?v0) (f33 f34 1)) ?v0)))
(assert (forall ((?v0 S7)) (= (f29 (f30 f31 ?v0) (f33 f34 1)) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 f6) (f7 (f17 f50 ?v0) ?v1)) f1) (= (f3 (f4 f5 (f7 f8 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f7 (f17 f50 ?v0) ?v1)) f6) f1) (= (f3 (f4 f5 ?v1) (f7 f8 ?v0)) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f48 ?v0) f1) (=> (= (f48 ?v1) f1) (= (f48 (f7 (f17 f50 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 (f17 f50 ?v0) ?v1) (f7 (f17 f50 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f17 f50 ?v0)) (?v_0 (f17 f50 ?v1))) (= (f7 ?v_1 (f7 ?v_0 ?v2)) (f7 ?v_0 (f7 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (= (f7 ?v_0 (f7 (f17 f50 ?v1) ?v2)) (f7 (f17 f50 (f7 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (= (f7 (f17 f50 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f17 f50 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (= (f7 (f17 f50 (f7 ?v_0 ?v1)) ?v2) (f7 (f17 f50 (f7 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f17 f50 ?v0))) (= (f7 (f17 f50 (f7 ?v_0 ?v1)) (f7 (f17 f50 ?v2) ?v3)) (f7 (f17 f50 (f7 ?v_0 ?v2)) (f7 (f17 f50 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f7 (f17 f50 ?v0) ?v1) (f7 (f17 f50 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (=> (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f7 (f17 f50 ?v0) ?v1) (f7 (f17 f50 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (= (= (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f11 (f15 f16 ?v0) ?v1) ?v2) (f11 (f15 f16 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f7 (f17 f50 (f7 (f17 f18 ?v0) ?v1)) ?v2) (f7 (f17 f18 (f7 (f17 f50 ?v0) ?v2)) (f7 (f17 f50 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f11 (f15 f19 ?v0) ?v1) ?v2) (f11 (f15 f19 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f7 (f17 f50 (f7 (f17 f20 ?v0) ?v1)) ?v2) (f7 (f17 f20 (f7 (f17 f50 ?v0) ?v2)) (f7 (f17 f50 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (= (f7 (f17 f50 (f7 ?v_0 ?v1)) ?v2) (f7 ?v_0 (f7 (f17 f50 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 (f17 f50 (f7 f13 ?v0)) (f7 f13 ?v1)))) (= (f7 f13 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f11 f12 ?v0) (f11 f12 ?v1)))) (= (f11 f12 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 f13 (f7 (f17 f50 ?v0) (f7 f8 ?v1))) (f7 f13 (f7 (f17 f50 ?v1) (f7 f8 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f7 ?v_0 ?v0)) (f7 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v0) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 f8 (f7 (f17 f50 ?v0) ?v1)) (f7 (f17 f50 (f7 f8 ?v0)) (f7 f8 ?v1)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f21 f22 (f21 (f51 f52 ?v0) ?v1)) (f21 (f51 f52 (f21 f22 ?v0)) (f21 f22 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 f8 (f7 (f17 f50 ?v0) ?v1)) (f7 (f17 f50 (f7 f8 ?v1)) (f7 f8 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f21 f22 (f21 (f51 f52 ?v0) ?v1)) (f21 (f51 f52 (f21 f22 ?v1)) (f21 f22 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (+ (- ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 (f17 f50 ?v0) (f7 (f17 f50 (f7 f8 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f21 (f51 f52 ?v0) (f21 (f51 f52 (f21 f22 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0) (+ ?v0 ?v1)) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f7 (f17 f50 (f7 f8 ?v0)) (f7 (f17 f50 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S7) (?v1 S7)) (= (f21 (f51 f52 (f21 f22 ?v0)) (f21 (f51 f52 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f5 (f7 f13 (f7 (f17 f50 ?v0) ?v1))) (f7 (f17 f50 (f7 f13 ?v0)) (f7 f13 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f11 f12 (+ ?v0 ?v1)) (+ (f11 f12 ?v0) (f11 f12 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f7 (f17 f50 ?v0) ?v1)) (f7 (f17 f50 ?v2) ?v1)) f1) (= (f3 (f4 f5 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (= (= (f3 (f4 f5 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f7 (f17 f50 ?v0) ?v2)) (f7 (f17 f50 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f7 ?v_0 ?v0)) (f7 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f7 (f17 f50 ?v0) ?v2)) (f7 (f17 f50 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 (f7 (f17 f50 ?v0) ?v1)) (f7 (f17 f50 ?v2) ?v1)) f1) (= (f3 (f4 f5 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (=> (= (f3 (f4 f5 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2)) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f17 f50 f6) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f21 (f51 f52 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f17 f50 f6) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f21 (f51 f52 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (= 0 (+ ?v0 ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= f6 (f7 (f17 f50 ?v0) ?v0)) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f17 f50 ?v0) f6) ?v0)))
(assert (forall ((?v0 S7)) (= (f21 (f51 f52 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f17 f50 ?v0) f6) ?v0)))
(assert (forall ((?v0 S7)) (= (f21 (f51 f52 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (+ ?v0 ?v1)) (= ?v1 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 (f7 (f17 f50 ?v0) ?v1)) (= ?v1 f6))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 (f21 (f51 f52 ?v0) ?v1)) (= ?v1 f14))))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f17 f50 ?v0) f6) ?v0)))
(assert (forall ((?v0 S7)) (= (f21 (f51 f52 ?v0) f14) ?v0)))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 (f17 f50 f6) ?v0) ?v0)))
(assert (forall ((?v0 S7)) (= (f21 (f51 f52 f14) ?v0) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (<= ?v1 0) (<= (+ ?v0 ?v1) 0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 (f7 (f17 f50 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v2 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v1))) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f7 (f17 f50 ?v2) ?v0)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (<= ?v1 ?v2) (<= ?v1 (+ ?v0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v1))) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f7 (f17 f50 ?v0) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (= (+ ?v0 ?v1) 0) (and (= ?v0 0) (= ?v1 0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (= (f7 (f17 f50 ?v0) ?v1) f6) (and (= ?v0 f6) (= ?v1 f6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (+ ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f7 (f17 f50 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 Int)) (= (<= (+ ?v0 ?v0) 0) (<= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f7 (f17 f50 ?v0) ?v0)) f6) f1) (= (f3 (f4 f5 ?v0) f6) f1))))
(assert (forall ((?v0 Int)) (= (<= 0 (+ ?v0 ?v0)) (<= 0 ?v0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 ?v_0 (f7 (f17 f50 ?v0) ?v0)) f1) (= (f3 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (+ ?v0 ?v1) 0) (= (- ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f7 (f17 f50 ?v0) ?v1) f6) (= (f7 f8 ?v0) ?v1))))
(assert (forall ((?v0 S7) (?v1 S7)) (=> (= (f21 (f51 f52 ?v0) ?v1) f14) (= (f21 f22 ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (+ ?v0 ?v1) 0) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f7 (f17 f50 ?v0) ?v1) f6) (= ?v1 (f7 f8 ?v0)))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= (f21 (f51 f52 ?v0) ?v1) f14) (= ?v1 (f21 f22 ?v0)))))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f7 (f17 f50 (f7 f8 ?v0)) ?v0) f6)))
(assert (forall ((?v0 S7)) (= (f21 (f51 f52 (f21 f22 ?v0)) ?v0) f14)))
(assert (forall ((?v0 Int)) (= (+ (- ?v0) ?v0) 0)))
(assert (forall ((?v0 S3)) (= (f7 (f17 f50 (f7 f8 ?v0)) ?v0) f6)))
(assert (forall ((?v0 S7)) (= (f21 (f51 f52 (f21 f22 ?v0)) ?v0) f14)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= (+ ?v0 ?v1) 0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 (f7 f8 ?v1)) (= (f7 (f17 f50 ?v0) ?v1) f6))))
(assert (forall ((?v0 S7) (?v1 S7)) (= (= ?v0 (f21 f22 ?v1)) (= (f21 (f51 f52 ?v0) ?v1) f14))))
(assert (forall ((?v0 Int)) (= (+ ?v0 (- ?v0)) 0)))
(assert (forall ((?v0 S3)) (= (f7 (f17 f50 ?v0) (f7 f8 ?v0)) f6)))
(assert (forall ((?v0 S7)) (= (f21 (f51 f52 ?v0) (f21 f22 ?v0)) f14)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f33 f34 2))) (= (= (+ (f35 (f36 f37 ?v0) ?v_0) (f35 (f36 f37 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f33 f34 2))) (= (= (f7 (f17 f50 (f38 (f39 f40 ?v0) ?v_0)) (f38 (f39 f40 ?v1) ?v_0)) f6) (and (= ?v0 f6) (= ?v1 f6))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f33 f34 2))) (= (= (f7 (f17 f50 (f38 (f39 f40 ?v0) ?v_0)) (f38 (f39 f40 ?v1) ?v_0)) f6) (and (= ?v0 f6) (= ?v1 f6))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f17 f50 ?v0)) (?v_1 (f7 f8 ?v2)) (?v_2 (f7 f8 ?v3))) (= (f3 (f4 f5 (f7 f13 (f7 (f17 f50 (f7 ?v_0 ?v1)) (f7 (f17 f50 ?v_1) ?v_2)))) (f7 (f17 f50 (f7 f13 (f7 ?v_0 ?v_1))) (f7 f13 (f7 (f17 f50 ?v1) ?v_2)))) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f7 (f17 f50 ?v0) (f7 f8 ?v1)) f6) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f7 (f17 f50 ?v0) ?v1) f6) (= ?v1 (f7 f8 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f33 f34 2))) (<= 0 (+ (f35 (f36 f37 ?v0) ?v_0) (f35 (f36 f37 ?v1) ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f33 f34 2))) (= (f3 (f4 f5 f6) (f7 (f17 f50 (f38 (f39 f40 ?v0) ?v_0)) (f38 (f39 f40 ?v1) ?v_0))) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f33 f34 2))) (= (<= (+ (f35 (f36 f37 ?v0) ?v_0) (f35 (f36 f37 ?v1) ?v_0)) 0) (and (= ?v0 0) (= ?v1 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f33 f34 2))) (= (= (f3 (f4 f5 (f7 (f17 f50 (f38 (f39 f40 ?v0) ?v_0)) (f38 (f39 f40 ?v1) ?v_0))) f6) f1) (and (= ?v0 f6) (= ?v1 f6))))))
(assert (forall ((?v0 Int)) (= (= (+ ?v0 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f7 (f17 f50 ?v0) ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f53 f6 (f7 (f17 f50 ?v0) ?v1)) f1) (= (f53 (f7 f8 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f53 (f7 (f17 f50 ?v0) ?v1) f6) f1) (= (f53 ?v1 (f7 f8 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (=> (= (f53 (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) f1) (= (f53 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f53 (f7 (f17 f50 ?v0) ?v1) (f7 (f17 f50 ?v2) ?v1)) f1) (= (f53 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f53 ?v0 ?v1) f1) (=> (= (f53 ?v2 ?v3) f1) (= (f53 (f7 (f17 f50 ?v0) ?v2) (f7 (f17 f50 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v2))) (=> (= (f53 ?v0 ?v1) f1) (= (f53 (f7 ?v_0 ?v0) (f7 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f53 ?v0 ?v1) f1) (= (f53 (f7 (f17 f50 ?v0) ?v2) (f7 (f17 f50 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v0 ?v2)) (< ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f17 f50 ?v0))) (= (= (f53 (f7 ?v_0 ?v1) (f7 ?v_0 ?v2)) f1) (= (f53 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (+ ?v0 ?v1) (+ ?v2 ?v1)) (< ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f53 (f7 (f17 f50 ?v0) ?v1) (f7 (f17 f50 ?v2) ?v1)) f1) (= (f53 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (< (+ ?v0 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f53 (f7 (f17 f50 ?v0) ?v0) f6) f1) (= (f53 ?v0 f6) f1))))
(assert (forall ((?v0 S3)) (=> (= (f53 f6 ?v0) f1) (= (f7 f13 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f11 f12 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (= (f53 f6 (f7 f13 ?v0)) f1) (not (= ?v0 f6)))))
(assert (forall ((?v0 Int)) (= (< 0 (f11 f12 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S3)) (not (= (f53 (f7 f13 ?v0) f6) f1))))
(assert (forall ((?v0 Int)) (not (< (f11 f12 ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f53 ?v2 ?v0) f1) (= (f53 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f53 ?v1 ?v2) f1) (= (f53 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f53 ?v0 ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v0) f1) (= (f53 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f53 ?v0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f53 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f53 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f53 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f53 ?v0 ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f53 ?v0 ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f53 ?v0 ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f53 ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= (f53 ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f53 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f53 ?v0 ?v1) f1)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f53 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f53 ?v0 ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f53 ?v0 ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f53 ?v0 ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f53 ?v0 ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f53 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f53 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f53 ?v0 ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) (- ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f53 (f7 f8 ?v0) (f7 f8 ?v1)) f1) (= (f53 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) ?v1) (< (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f53 (f7 f8 ?v0) ?v1) f1) (= (f53 (f7 f8 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 (- ?v1)) (< ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f53 ?v0 (f7 f8 ?v1)) f1) (= (f53 ?v1 (f7 f8 ?v0)) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= (f53 ?v0 ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S16)) (= (f33 f34 (f35 f41 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f35 f41 (f33 f34 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f35 f41 (f33 f34 ?v0)) 0))))
(check-sat)
(exit)
