(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 () S2)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 (S4 S2) Int)
(declare-fun f8 () S4)
(declare-fun f9 () S2)
(assert (not (= f1 f2)))
(assert (= (f3 f4) f1))
(assert (forall ((?v0 S2)) (= (= (f3 ?v0) f1) (exists ((?v1 S2)) (= ?v0 (f5 f6 (* 2 (f7 f8 ?v1))))))))
(assert (let ((?v_0 (f5 f6 0))) (not (=> (not (= f4 ?v_0)) (=> (= f4 (f5 f6 (* 2 (f7 f8 f9)))) (not (= f9 ?v_0)))))))
(assert (forall ((?v0 S2)) (= (f5 f6 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f5 f6 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f5 f6 ?v0)) 0))))
(check-sat)
(exit)
