(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S2) S1)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 () S3)
(declare-fun f6 (S5 S4) S4)
(declare-fun f7 (S6 S4) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S4)
(declare-fun f10 () S6)
(declare-fun f11 () S4)
(declare-fun f12 (S7 S8) S4)
(declare-fun f13 (S9 S4) S7)
(declare-fun f14 () S9)
(declare-fun f15 () S5)
(declare-fun f16 () S4)
(declare-fun f17 () S8)
(declare-fun f18 () S2)
(declare-fun f19 () S8)
(declare-fun f20 (S10 Int) S8)
(declare-fun f21 () S10)
(declare-fun f22 (S11 S8) Int)
(declare-fun f23 () S11)
(declare-fun f24 () S4)
(declare-fun f25 (S8) S1)
(declare-fun f26 (S12 Int) Int)
(declare-fun f27 (S13 Int) S12)
(declare-fun f28 () S13)
(declare-fun f29 (S14 Int) S11)
(declare-fun f30 () S14)
(declare-fun f31 (S15 S2) S2)
(declare-fun f32 (S16 S2) S15)
(declare-fun f33 () S16)
(declare-fun f34 (S17 S8) S2)
(declare-fun f35 (S18 S2) S17)
(declare-fun f36 () S18)
(declare-fun f37 (S8 S8) S1)
(declare-fun f38 () S8)
(declare-fun f39 (S19 S8) S8)
(declare-fun f40 (S20 S8) S19)
(declare-fun f41 () S20)
(declare-fun f42 () S20)
(declare-fun f43 () S15)
(declare-fun f44 () S16)
(declare-fun f45 () S2)
(declare-fun f46 () S8)
(declare-fun f47 () S15)
(declare-fun f48 () S12)
(declare-fun f49 () S20)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 (f6 f15 f16)) f17)))) f18) f1)))
(assert (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 f16) f19)))) f18) f1))
(assert (not (= f19 (f20 f21 0))))
(assert (not (= f17 (f20 f21 0))))
(assert (< (f22 f23 f19) (f22 f23 f17)))
(assert (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 f16) f19)))) f18) f1))
(assert (not (= f11 f24)))
(assert (forall ((?v0 S8)) (=> (< (f22 f23 ?v0) (f22 f23 f17)) (=> (not (= ?v0 (f20 f21 0))) (exists ((?v1 S4)) (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 ?v1) ?v0)))) f18) f1))))))
(assert (= (f25 f17) f1))
(assert (=> (forall ((?v0 S4)) (=> (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 ?v0) f19)))) f18) f1) false)) false))
(assert (=> (< (f22 f23 f19) (f22 f23 f17)) (=> (not (= f19 (f20 f21 0))) (exists ((?v0 S4)) (= (f3 (f4 f5 (f6 (f7 f8 f9) (f6 (f7 f10 f11) (f12 (f13 f14 ?v0) f19)))) f18) f1)))))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 (f6 f15 ?v0)) (f20 f21 2)) ?v0)))
(assert (= f17 (f20 f21 (* 2 (f22 f23 f19)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (f26 (f27 f28 ?v0) (f22 (f29 f30 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (= (f3 f18 ?v0) f1) (= (f3 f18 (f31 (f32 f33 ?v0) (f34 (f35 f36 ?v0) ?v1))) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f37 f38 ?v0) f1) (= (f37 f38 (f39 (f40 f41 ?v0) (f39 (f40 f42 ?v0) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 (f29 f30 ?v0) ?v1))) (=> (< 1 ?v0) (< ?v_0 (f26 (f27 f28 ?v0) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f34 (f35 f36 ?v0) ?v1))) (=> (= (f3 f18 ?v0) f1) (= (f3 ?v_0 (f31 (f32 f33 ?v0) ?v_0)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f39 (f40 f42 ?v0) ?v1))) (=> (= (f37 f38 ?v0) f1) (= (f37 ?v_0 (f39 (f40 f41 ?v0) ?v_0)) f1)))))
(assert (= (f31 f43 f18) f18))
(assert (= (f4 f5 f9) f18))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f31 f43 ?v0) ?v1) f1) (=> (= (f3 (f31 f43 ?v2) ?v3) f1) (= (f3 (f31 f43 (f31 (f32 f44 ?v0) ?v2)) (f31 (f32 f44 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4) (?v3 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f8 ?v0) ?v2)) (f31 (f32 f44 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (=> (= (f3 (f31 f43 ?v0) ?v1) f1) (=> (= (f3 (f31 f43 ?v2) ?v3) f1) (= (f3 (f31 f43 (f31 (f32 f33 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4) (?v3 S2)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f6 (f7 f10 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f29 f30 ?v0))) (= (f22 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) 1 (f26 (f27 f28 ?v0) (f22 ?v_0 (f20 f21 (- (f22 f23 ?v1) 1)))))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) f18 (f31 (f32 f33 ?v0) (f34 ?v_0 (f20 f21 (- (f22 f23 ?v1) 1)))))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) f9 (f6 (f7 f10 ?v0) (f12 ?v_0 (f20 f21 (- (f22 f23 ?v1) 1)))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) f38 (f39 (f40 f41 ?v0) (f39 ?v_0 (f20 f21 (- (f22 f23 ?v1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (< 1 (f22 (f29 f30 ?v0) (f20 f21 (+ (f22 f23 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (= (f3 f18 ?v0) f1) (= (f3 f18 (f34 (f35 f36 ?v0) (f20 f21 (+ (f22 f23 ?v1) 1)))) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f37 f38 ?v0) f1) (= (f37 f38 (f39 (f40 f42 ?v0) (f20 f21 (+ (f22 f23 ?v1) 1)))) f1))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f29 f30 ?v0))) (=> (< 1 ?v0) (= (= (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f35 f36 ?v0))) (=> (= (f3 f18 ?v0) f1) (= (= (f34 ?v_0 ?v1) (f34 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f42 ?v0))) (=> (= (f37 f38 ?v0) f1) (= (= (f39 ?v_0 ?v1) (f39 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f29 f30 ?v0))) (=> (< 1 ?v0) (= (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (< (f22 f23 ?v1) (f22 f23 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f35 f36 ?v0))) (=> (= (f3 f18 ?v0) f1) (= (= (f3 (f34 ?v_0 ?v1) (f34 ?v_0 ?v2)) f1) (< (f22 f23 ?v1) (f22 f23 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f42 ?v0))) (=> (= (f37 f38 ?v0) f1) (= (= (f37 (f39 ?v_0 ?v1) (f39 ?v_0 ?v2)) f1) (< (f22 f23 ?v1) (f22 f23 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 1 ?v0) (=> (< 0 (f22 f23 ?v1)) (< 1 (f22 (f29 f30 ?v0) ?v1))))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (= (f3 f18 ?v0) f1) (=> (< 0 (f22 f23 ?v1)) (= (f3 f18 (f34 (f35 f36 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f37 f38 ?v0) f1) (=> (< 0 (f22 f23 ?v1)) (= (f37 f38 (f39 (f40 f42 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f29 f30 ?v0))) (=> (< 1 ?v0) (=> (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v2)) (< (f22 f23 ?v1) (f22 f23 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f35 f36 ?v0))) (=> (= (f3 f18 ?v0) f1) (=> (= (f3 (f34 ?v_0 ?v1) (f34 ?v_0 ?v2)) f1) (< (f22 f23 ?v1) (f22 f23 ?v2)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f42 ?v0))) (=> (= (f37 f38 ?v0) f1) (=> (= (f37 (f39 ?v_0 ?v1) (f39 ?v_0 ?v2)) f1) (< (f22 f23 ?v1) (f22 f23 ?v2)))))))
(assert (=> (forall ((?v0 S8)) (=> (= f17 (f20 f21 (* 2 (f22 f23 ?v0)))) false)) false))
(assert (exists ((?v0 S8)) (= f17 (f20 f21 (* 2 (f22 f23 ?v0))))))
(assert (= (f31 f43 f45) f45))
(assert (= (f4 f5 f24) f45))
(assert (forall ((?v0 S2)) (= (= (f31 f43 ?v0) f45) (= ?v0 f45))))
(assert (forall ((?v0 S4)) (= (= (f4 f5 ?v0) f45) (= ?v0 f24))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 (f20 f21 (f26 (f27 f28 (f22 f23 ?v1)) (f22 f23 ?v2)))) (f39 (f40 f42 (f39 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f20 f21 (f26 (f27 f28 (f22 f23 ?v1)) (f22 f23 ?v2)))) (f34 (f35 f36 (f34 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f20 f21 (f26 (f27 f28 (f22 f23 ?v1)) (f22 f23 ?v2)))) (f12 (f13 f14 (f12 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f29 f30 ?v0))) (= (f22 ?v_0 (f20 f21 (f26 (f27 f28 (f22 f23 ?v1)) (f22 f23 ?v2)))) (f22 (f29 f30 (f22 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2)) (= (f31 (f32 f33 ?v0) f45) f45)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 ?v0) f24) f24)))
(assert (forall ((?v0 S2)) (= (f31 (f32 f33 ?v0) f45) f45)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 ?v0) f24) f24)))
(assert (forall ((?v0 S2)) (= (f31 (f32 f33 f45) ?v0) f45)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 f24) ?v0) f24)))
(assert (forall ((?v0 S2)) (= (f31 (f32 f33 f45) ?v0) f45)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 f24) ?v0) f24)))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (not (= ?v0 f45)) (not (= (f34 (f35 f36 ?v0) ?v1) f45)))))
(assert (forall ((?v0 S4) (?v1 S8)) (=> (not (= ?v0 f24)) (not (= (f12 (f13 f14 ?v0) ?v1) f24)))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (not (= ?v0 0)) (not (= (f22 (f29 f30 ?v0) ?v1) 0)))))
(assert (forall ((?v0 S2) (?v1 S8)) (= (= (f34 (f35 f36 ?v0) ?v1) f45) (and (= ?v0 f45) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 S4) (?v1 S8)) (= (= (f12 (f13 f14 ?v0) ?v1) f24) (and (= ?v0 f24) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (= (f22 (f29 f30 ?v0) ?v1) 0) (and (= ?v0 0) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f39 (f40 f42 ?v0) ?v1) f46) (and (= ?v0 f46) (not (= ?v1 (f20 f21 0)))))))
(assert (forall ((?v0 S8)) (= (f34 (f35 f36 f45) (f20 f21 (+ (f22 f23 ?v0) 1))) f45)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f24) (f20 f21 (+ (f22 f23 ?v0) 1))) f24)))
(assert (forall ((?v0 S8)) (= (f22 (f29 f30 0) (f20 f21 (+ (f22 f23 ?v0) 1))) 0)))
(assert (forall ((?v0 S8)) (= (f39 (f40 f42 f46) (f20 f21 (+ (f22 f23 ?v0) 1))) f46)))
(assert (forall ((?v0 S2)) (= (= (f3 f45 (f31 f43 ?v0)) f1) (not (= ?v0 f45)))))
(assert (forall ((?v0 S4)) (= (= (f3 f45 (f4 f5 ?v0)) f1) (not (= ?v0 f24)))))
(assert (forall ((?v0 S2)) (=> (= (f3 (f31 f47 ?v0) f18) f1) (= (f3 (f34 (f35 f36 ?v0) (f20 f21 2)) f18) f1))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (= (f3 f45 ?v0) f1) (= (f3 f45 (f34 (f35 f36 ?v0) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (< 0 (f22 (f29 f30 ?v0) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f37 f46 ?v0) f1) (= (f37 f46 (f39 (f40 f42 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S8)) (= (f22 (f29 f30 0) ?v0) (ite (= ?v0 (f20 f21 0)) 1 0))))
(assert (forall ((?v0 S8)) (= (f34 (f35 f36 f45) ?v0) (ite (= ?v0 (f20 f21 0)) f18 f45))))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f24) ?v0) (ite (= ?v0 (f20 f21 0)) f9 f24))))
(assert (forall ((?v0 S8)) (= (f39 (f40 f42 f46) ?v0) (ite (= ?v0 (f20 f21 0)) f38 f46))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f29 f30 ?v2))) (=> (< (f22 f23 ?v0) (f22 f23 ?v1)) (=> (< 0 ?v2) (=> (< ?v2 1) (< (f22 ?v_0 ?v1) (f22 ?v_0 ?v0))))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S2)) (let ((?v_0 (f35 f36 ?v2))) (=> (< (f22 f23 ?v0) (f22 f23 ?v1)) (=> (= (f3 f45 ?v2) f1) (=> (= (f3 ?v2 f18) f1) (= (f3 (f34 ?v_0 ?v1) (f34 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f42 ?v2))) (=> (< (f22 f23 ?v0) (f22 f23 ?v1)) (=> (= (f37 f46 ?v2) f1) (=> (= (f37 ?v2 f38) f1) (= (f37 (f39 ?v_0 ?v1) (f39 ?v_0 ?v0)) f1)))))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f22 (f29 f30 ?v0) (f20 f21 (+ (f22 f23 ?v1) 1))) 1)))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (= (f3 f45 ?v0) f1) (=> (= (f3 ?v0 f18) f1) (= (f3 (f34 (f35 f36 ?v0) (f20 f21 (+ (f22 f23 ?v1) 1))) f18) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f37 f46 ?v0) f1) (=> (= (f37 ?v0 f38) f1) (= (f37 (f39 (f40 f42 ?v0) (f20 f21 (+ (f22 f23 ?v1) 1))) f38) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 (f29 f30 ?v0) ?v1))) (=> (< 0 ?v0) (=> (< ?v0 1) (< (f26 (f27 f28 ?v0) ?v_0) ?v_0))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f34 (f35 f36 ?v0) ?v1))) (=> (= (f3 f45 ?v0) f1) (=> (= (f3 ?v0 f18) f1) (= (f3 (f31 (f32 f33 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f39 (f40 f42 ?v0) ?v1))) (=> (= (f37 f46 ?v0) f1) (=> (= (f37 ?v0 f38) f1) (= (f37 (f39 (f40 f41 ?v0) ?v_0) ?v_0) f1))))))
(assert (forall ((?v0 S8)) (= (f39 (f40 f42 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f34 (f35 f36 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f22 (f29 f30 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S8)) (= (f31 f47 (f34 (f35 f36 ?v0) ?v1)) (f34 (f35 f36 (f31 f47 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (f26 f48 (f22 (f29 f30 ?v0) ?v1)) (f22 (f29 f30 (f26 f48 ?v0)) ?v1))))
(assert (forall ((?v0 S4)) (let ((?v_0 (f4 f5 ?v0))) (= (f31 f47 ?v_0) ?v_0))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f31 f43 ?v0))) (= (f31 f47 ?v_0) ?v_0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f31 (f32 f33 (f31 (f32 f44 ?v0) ?v1)) ?v2) (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f10 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f10 ?v0) ?v2)) (f6 (f7 f10 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (= (f31 (f32 f33 (f31 (f32 f44 ?v0) ?v1)) ?v2) (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v2)) (f31 (f32 f33 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (= (f6 (f7 f10 (f6 (f7 f8 ?v0) ?v1)) ?v2) (f6 (f7 f8 (f6 (f7 f10 ?v0) ?v2)) (f6 (f7 f10 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f31 (f32 f44 ?v1) ?v2)) (f31 (f32 f44 (f31 ?v_0 ?v1)) (f31 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f31 (f32 f44 ?v1) ?v2)) (f31 (f32 f44 (f31 ?v_0 ?v1)) (f31 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f22 f23 ?v1)) (?v_1 (f22 f23 ?v0)) (?v_2 (f40 f42 ?v2))) (=> (<= ?v_1 ?v_0) (= (f39 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (f39 (f40 f41 (f39 ?v_2 (f20 f21 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S2)) (let ((?v_0 (f22 f23 ?v1)) (?v_1 (f22 f23 ?v0)) (?v_2 (f35 f36 ?v2))) (=> (<= ?v_1 ?v_0) (= (f34 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (f31 (f32 f33 (f34 ?v_2 (f20 f21 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S4)) (let ((?v_0 (f22 f23 ?v1)) (?v_1 (f22 f23 ?v0)) (?v_2 (f13 f14 ?v2))) (=> (<= ?v_1 ?v_0) (= (f12 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (f6 (f7 f10 (f12 ?v_2 (f20 f21 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f22 f23 ?v1)) (?v_1 (f22 f23 ?v0)) (?v_2 (f29 f30 ?v2))) (=> (<= ?v_1 ?v_0) (= (f22 ?v_2 (f20 f21 (- (+ ?v_0 1) ?v_1))) (f26 (f27 f28 (f22 ?v_2 (f20 f21 (- ?v_0 ?v_1)))) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (= (f39 (f40 f42 (f39 (f40 f41 ?v0) ?v1)) ?v2) (f39 (f40 f41 (f39 (f40 f42 ?v0) ?v2)) (f39 (f40 f42 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S8)) (= (f34 (f35 f36 (f31 (f32 f33 ?v0) ?v1)) ?v2) (f31 (f32 f33 (f34 (f35 f36 ?v0) ?v2)) (f34 (f35 f36 ?v1) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S8)) (= (f12 (f13 f14 (f6 (f7 f10 ?v0) ?v1)) ?v2) (f6 (f7 f10 (f12 (f13 f14 ?v0) ?v2)) (f12 (f13 f14 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S8)) (= (f22 (f29 f30 (f26 (f27 f28 ?v0) ?v1)) ?v2) (f26 (f27 f28 (f22 (f29 f30 ?v0) ?v2)) (f22 (f29 f30 ?v1) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f39 (f40 f42 ?v0) ?v1))) (= (f39 (f40 f41 ?v_0) ?v0) (f39 (f40 f41 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f34 (f35 f36 ?v0) ?v1))) (= (f31 (f32 f33 ?v_0) ?v0) (f31 (f32 f33 ?v0) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f12 (f13 f14 ?v0) ?v1))) (= (f6 (f7 f10 ?v_0) ?v0) (f6 (f7 f10 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f22 (f29 f30 ?v0) ?v1))) (= (f26 (f27 f28 ?v_0) ?v0) (f26 (f27 f28 ?v0) ?v_0)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 (f20 f21 (+ (f22 f23 ?v1) (f22 f23 ?v2)))) (f39 (f40 f41 (f39 ?v_0 ?v1)) (f39 ?v_0 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S8) (?v2 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f20 f21 (+ (f22 f23 ?v1) (f22 f23 ?v2)))) (f31 (f32 f33 (f34 ?v_0 ?v1)) (f34 ?v_0 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S8) (?v2 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f20 f21 (+ (f22 f23 ?v1) (f22 f23 ?v2)))) (f6 (f7 f10 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S8) (?v2 S8)) (let ((?v_0 (f29 f30 ?v0))) (= (f22 ?v_0 (f20 f21 (+ (f22 f23 ?v1) (f22 f23 ?v2)))) (f26 (f27 f28 (f22 ?v_0 ?v1)) (f22 ?v_0 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 (f20 f21 (+ (f22 f23 ?v1) 1))) (f39 (f40 f41 (f39 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f20 f21 (+ (f22 f23 ?v1) 1))) (f31 (f32 f33 (f34 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f20 f21 (+ (f22 f23 ?v1) 1))) (f6 (f7 f10 (f12 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f29 f30 ?v0))) (= (f22 ?v_0 (f20 f21 (+ (f22 f23 ?v1) 1))) (f26 (f27 f28 (f22 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 (f20 f21 (+ (f22 f23 ?v1) 1))) (f39 (f40 f41 ?v0) (f39 ?v_0 ?v1))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f35 f36 ?v0))) (= (f34 ?v_0 (f20 f21 (+ (f22 f23 ?v1) 1))) (f31 (f32 f33 ?v0) (f34 ?v_0 ?v1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (= (f12 ?v_0 (f20 f21 (+ (f22 f23 ?v1) 1))) (f6 (f7 f10 ?v0) (f12 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f29 f30 ?v0))) (= (f22 ?v_0 (f20 f21 (+ (f22 f23 ?v1) 1))) (f26 (f27 f28 ?v0) (f22 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (f22 (f29 f30 ?v0) (f20 f21 0)) 1)))
(assert (forall ((?v0 S2)) (= (f34 (f35 f36 ?v0) (f20 f21 0)) f18)))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f20 f21 0)) f9)))
(assert (forall ((?v0 S8)) (= (f39 (f40 f42 ?v0) (f20 f21 0)) f38)))
(assert (forall ((?v0 S8)) (= (f22 (f29 f30 1) ?v0) 1)))
(assert (forall ((?v0 S8)) (= (f34 (f35 f36 f18) ?v0) f18)))
(assert (forall ((?v0 S8)) (= (f12 (f13 f14 f9) ?v0) f9)))
(assert (forall ((?v0 S8)) (= (f39 (f40 f42 f38) ?v0) f38)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f31 f43 (f31 (f32 f33 ?v0) ?v1)) (f31 (f32 f33 (f31 f43 ?v0)) (f31 f43 ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f4 f5 (f6 (f7 f10 ?v0) ?v1)) (f31 (f32 f33 (f4 f5 ?v0)) (f4 f5 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S8)) (= (f31 f43 (f34 (f35 f36 ?v0) ?v1)) (f34 (f35 f36 (f31 f43 ?v0)) ?v1))))
(assert (forall ((?v0 S4) (?v1 S8)) (= (f4 f5 (f12 (f13 f14 ?v0) ?v1)) (f34 (f35 f36 (f4 f5 ?v0)) ?v1))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 Int)) (let ((?v_0 (f29 f30 ?v2))) (=> (< (f22 f23 ?v0) (f22 f23 ?v1)) (=> (< 1 ?v2) (< (f22 ?v_0 ?v0) (f22 ?v_0 ?v1)))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S2)) (let ((?v_0 (f35 f36 ?v2))) (=> (< (f22 f23 ?v0) (f22 f23 ?v1)) (=> (= (f3 f18 ?v2) f1) (= (f3 (f34 ?v_0 ?v0) (f34 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f42 ?v2))) (=> (< (f22 f23 ?v0) (f22 f23 ?v1)) (=> (= (f37 f38 ?v2) f1) (= (f37 (f39 ?v_0 ?v0) (f39 ?v_0 ?v1)) f1))))))
(assert (forall ((?v0 S2) (?v1 S8)) (= (= (f3 (f34 (f35 f36 ?v0) ?v1) f45) f1) (and (not (= (f25 ?v1) f1)) (= (f3 ?v0 f45) f1)))))
(assert (forall ((?v0 Int) (?v1 S8)) (= (< (f22 (f29 f30 ?v0) ?v1) 0) (and (not (= (f25 ?v1) f1)) (< ?v0 0)))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (= (f25 ?v1) f1))) (= (= (f3 f45 (f34 (f35 f36 ?v0) ?v1)) f1) (or (= ?v1 (f20 f21 0)) (or (and ?v_0 (not (= ?v0 f45))) (and (not ?v_0) (= (f3 f45 ?v0) f1))))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (= (f25 ?v1) f1))) (= (< 0 (f22 (f29 f30 ?v0) ?v1)) (or (= ?v1 (f20 f21 0)) (or (and ?v_0 (not (= ?v0 0))) (and (not ?v_0) (< 0 ?v0))))))))
(assert (forall ((?v0 S2) (?v1 S8)) (=> (= (f3 ?v0 f45) f1) (= (f3 (f34 (f35 f36 ?v0) (f20 f21 (+ (* 2 (f22 f23 ?v1)) 1))) f45) f1))))
(assert (forall ((?v0 Int) (?v1 S8)) (=> (< ?v0 0) (< (f22 (f29 f30 ?v0) (f20 f21 (+ (* 2 (f22 f23 ?v1)) 1))) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 2))) (= (< 0 (+ (f22 (f29 f30 ?v0) ?v_0) (f22 (f29 f30 ?v1) ?v_0))) (or (not (= ?v0 0)) (not (= ?v1 0)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f20 f21 2))) (= (= (f3 f45 (f31 (f32 f44 (f34 (f35 f36 ?v0) ?v_0)) (f34 (f35 f36 ?v1) ?v_0))) f1) (or (not (= ?v0 f45)) (not (= ?v1 f45)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f20 f21 2))) (not (< (+ (f22 (f29 f30 ?v0) ?v_0) (f22 (f29 f30 ?v1) ?v_0)) 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f20 f21 2))) (not (= (f3 (f31 (f32 f44 (f34 (f35 f36 ?v0) ?v_0)) (f34 (f35 f36 ?v1) ?v_0)) f45) f1)))))
(assert (< 0 (+ 1 1)))
(assert (= (f3 f45 (f31 (f32 f44 f18) f18)) f1))
(assert (= (f37 f46 (f39 (f40 f49 f38) f38)) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< 0 (+ (f26 (f27 f28 ?v0) ?v0) (f26 (f27 f28 ?v1) ?v1))) (or (not (= ?v0 0)) (not (= ?v1 0))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 f45 (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v0)) (f31 (f32 f33 ?v1) ?v1))) f1) (or (not (= ?v0 f45)) (not (= ?v1 f45))))))
(assert (forall ((?v0 Int) (?v1 Int)) (not (< (+ (f26 (f27 f28 ?v0) ?v0) (f26 (f27 f28 ?v1) ?v1)) 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= (f3 (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v0)) (f31 (f32 f33 ?v1) ?v1)) f45) f1))))
(assert (forall ((?v0 S2)) (not (= (f3 (f31 (f32 f44 (f31 f47 ?v0)) f18) ?v0) f1))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f40 f42 ?v0))) (let ((?v_1 (f39 ?v_0 ?v1))) (= (f39 ?v_0 (f20 f21 (* 2 (f22 f23 ?v1)))) (f39 (f40 f41 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S8)) (let ((?v_0 (f35 f36 ?v0))) (let ((?v_1 (f34 ?v_0 ?v1))) (= (f34 ?v_0 (f20 f21 (* 2 (f22 f23 ?v1)))) (f31 (f32 f33 ?v_1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S8)) (let ((?v_0 (f13 f14 ?v0))) (let ((?v_1 (f12 ?v_0 ?v1))) (= (f12 ?v_0 (f20 f21 (* 2 (f22 f23 ?v1)))) (f6 (f7 f10 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S8)) (let ((?v_0 (f29 f30 ?v0))) (let ((?v_1 (f22 ?v_0 ?v1))) (= (f22 ?v_0 (f20 f21 (* 2 (f22 f23 ?v1)))) (f26 (f27 f28 ?v_1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (=> (not (= ?v0 f45)) (= (= (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (not (= ?v0 f45)) (= (= (f31 (f32 f33 ?v1) ?v0) (f31 (f32 f33 ?v2) ?v0)) (= ?v1 ?v2)))))
(assert (not (= f45 f18)))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f20 f21 2))) (= (= (f31 (f32 f44 (f34 (f35 f36 ?v0) ?v_0)) (f34 (f35 f36 ?v1) ?v_0)) f45) (and (= ?v0 f45) (= ?v1 f45))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (=> (= (f3 f45 ?v0) f1) (=> (= (f3 ?v1 ?v2) f1) (= (f3 (f31 ?v_0 ?v1) (f31 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 f45 ?v0) f1) (=> (= (f3 f45 ?v1) f1) (= (f3 f45 (f31 (f32 f33 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (=> (= (f3 f45 ?v0) f1) (= (= (f3 (f31 (f32 f33 ?v1) ?v0) (f31 (f32 f33 ?v2) ?v0)) f1) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f31 (f32 f44 (f31 (f32 f33 ?v0) ?v0)) (f31 (f32 f33 ?v1) ?v1)) f45) (and (= ?v0 f45) (= ?v1 f45)))))
(assert (forall ((?v0 S2)) (= (f3 f45 (f31 (f32 f44 f18) (f31 f47 ?v0))) f1)))
(assert (forall ((?v0 S4)) (not (= (f3 (f4 f5 ?v0) f45) f1))))
(assert (forall ((?v0 S2)) (not (= (f3 (f31 f43 ?v0) f45) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 ?v0 ?v1) f1) false) (=> (=> (= (f3 ?v1 ?v0) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f31 f47 (f31 (f32 f33 ?v0) ?v1)) (f31 (f32 f33 (f31 f47 ?v0)) (f31 f47 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 f48 (f26 (f27 f28 ?v0) ?v1)) (f26 (f27 f28 (f26 f48 ?v0)) (f26 f48 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f31 (f32 f33 ?v0) ?v1) (f31 (f32 f33 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f26 (f27 f28 ?v0) ?v1) (f26 (f27 f28 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f10 ?v0) ?v1) (f6 (f7 f10 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f39 (f40 f41 ?v0) ?v1) (f39 (f40 f41 ?v1) ?v0))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f32 f33 ?v0)) (?v_0 (f32 f33 ?v1))) (= (f31 ?v_1 (f31 ?v_0 ?v2)) (f31 ?v_0 (f31 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f27 f28 ?v0)) (?v_0 (f27 f28 ?v1))) (= (f26 ?v_1 (f26 ?v_0 ?v2)) (f26 ?v_0 (f26 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f7 f10 ?v0)) (?v_0 (f7 f10 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f40 f41 ?v0)) (?v_0 (f40 f41 ?v1))) (= (f39 ?v_1 (f39 ?v_0 ?v2)) (f39 ?v_0 (f39 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 ?v_0 (f31 (f32 f33 ?v1) ?v2)) (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2)) (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 ?v_0 (f6 (f7 f10 ?v1) ?v2)) (f6 (f7 f10 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f41 ?v0))) (= (f39 ?v_0 (f39 (f40 f41 ?v1) ?v2)) (f39 (f40 f41 (f39 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f31 f47 ?v0))) (= (f31 (f32 f33 ?v_0) ?v_0) (f31 (f32 f33 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f26 f48 ?v0))) (= (f26 (f27 f28 ?v_0) ?v_0) (f26 (f27 f28 ?v0) ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2) (f31 ?v_0 (f31 (f32 f33 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 (f7 f10 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f10 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f41 ?v0))) (= (f39 (f40 f41 (f39 ?v_0 ?v1)) ?v2) (f39 ?v_0 (f39 (f40 f41 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2) (f31 (f32 f33 (f31 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v2) (f26 (f27 f28 (f26 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 (f7 f10 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f10 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f41 ?v0))) (= (f39 (f40 f41 (f39 ?v_0 ?v1)) ?v2) (f39 (f40 f41 (f39 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f32 f33 ?v0)) (?v_1 (f31 (f32 f33 ?v2) ?v3))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v_1) (f31 ?v_0 (f31 (f32 f33 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f27 f28 ?v0)) (?v_1 (f26 (f27 f28 ?v2) ?v3))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) ?v_1) (f26 ?v_0 (f26 (f27 f28 ?v1) ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f10 ?v0)) (?v_1 (f6 (f7 f10 ?v2) ?v3))) (= (f6 (f7 f10 (f6 ?v_0 ?v1)) ?v_1) (f6 ?v_0 (f6 (f7 f10 ?v1) ?v_1))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f40 f41 ?v0)) (?v_1 (f39 (f40 f41 ?v2) ?v3))) (= (f39 (f40 f41 (f39 ?v_0 ?v1)) ?v_1) (f39 ?v_0 (f39 (f40 f41 ?v1) ?v_1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_1 (f32 f33 (f31 (f32 f33 ?v0) ?v1))) (?v_0 (f32 f33 ?v2))) (= (f31 ?v_1 (f31 ?v_0 ?v3)) (f31 ?v_0 (f31 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f27 f28 (f26 (f27 f28 ?v0) ?v1))) (?v_0 (f27 f28 ?v2))) (= (f26 ?v_1 (f26 ?v_0 ?v3)) (f26 ?v_0 (f26 ?v_1 ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_1 (f7 f10 (f6 (f7 f10 ?v0) ?v1))) (?v_0 (f7 f10 ?v2))) (= (f6 ?v_1 (f6 ?v_0 ?v3)) (f6 ?v_0 (f6 ?v_1 ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_1 (f40 f41 (f39 (f40 f41 ?v0) ?v1))) (?v_0 (f40 f41 ?v2))) (= (f39 ?v_1 (f39 ?v_0 ?v3)) (f39 ?v_0 (f39 ?v_1 ?v3))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) (f31 (f32 f33 ?v2) ?v3)) (f31 (f32 f33 (f31 ?v_0 ?v2)) (f31 (f32 f33 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f27 f28 ?v0))) (= (f26 (f27 f28 (f26 ?v_0 ?v1)) (f26 (f27 f28 ?v2) ?v3)) (f26 (f27 f28 (f26 ?v_0 ?v2)) (f26 (f27 f28 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f10 ?v0))) (= (f6 (f7 f10 (f6 ?v_0 ?v1)) (f6 (f7 f10 ?v2) ?v3)) (f6 (f7 f10 (f6 ?v_0 ?v2)) (f6 (f7 f10 ?v1) ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f40 f41 ?v0))) (= (f39 (f40 f41 (f39 ?v_0 ?v1)) (f39 (f40 f41 ?v2) ?v3)) (f39 (f40 f41 (f39 ?v_0 ?v2)) (f39 (f40 f41 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 ?v1) (+ ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f31 (f32 f44 ?v0) ?v1) (f31 (f32 f44 ?v1) ?v0))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (f39 (f40 f49 ?v0) ?v1) (f39 (f40 f49 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ ?v1 (+ ?v0 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_1 (f32 f44 ?v0)) (?v_0 (f32 f44 ?v1))) (= (f31 ?v_1 (f31 ?v_0 ?v2)) (f31 ?v_0 (f31 ?v_1 ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_1 (f7 f8 ?v0)) (?v_0 (f7 f8 ?v1))) (= (f6 ?v_1 (f6 ?v_0 ?v2)) (f6 ?v_0 (f6 ?v_1 ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_1 (f40 f49 ?v0)) (?v_0 (f40 f49 ?v1))) (= (f39 ?v_1 (f39 ?v_0 ?v2)) (f39 ?v_0 (f39 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ ?v0 (+ ?v1 ?v2)) (+ (+ ?v0 ?v1) ?v2))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f44 ?v0))) (= (f31 ?v_0 (f31 (f32 f44 ?v1) ?v2)) (f31 (f32 f44 (f31 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2)) (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f49 ?v0))) (= (f39 ?v_0 (f39 (f40 f49 ?v1) ?v2)) (f39 (f40 f49 (f39 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f44 ?v0))) (= (f31 (f32 f44 (f31 ?v_0 ?v1)) ?v2) (f31 ?v_0 (f31 (f32 f44 ?v1) ?v2))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f49 ?v0))) (= (f39 (f40 f49 (f39 ?v_0 ?v1)) ?v2) (f39 ?v_0 (f39 (f40 f49 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ (+ ?v0 ?v2) ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f44 ?v0))) (= (f31 (f32 f44 (f31 ?v_0 ?v1)) ?v2) (f31 (f32 f44 (f31 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 (f7 f8 (f6 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8)) (let ((?v_0 (f40 f49 ?v0))) (= (f39 (f40 f49 (f39 ?v_0 ?v1)) ?v2) (f39 (f40 f49 (f39 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (= (+ (+ ?v0 ?v1) (+ ?v2 ?v3)) (+ (+ ?v0 ?v2) (+ ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (let ((?v_0 (f32 f44 ?v0))) (= (f31 (f32 f44 (f31 ?v_0 ?v1)) (f31 (f32 f44 ?v2) ?v3)) (f31 (f32 f44 (f31 ?v_0 ?v2)) (f31 (f32 f44 ?v1) ?v3))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4) (?v3 S4)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) (f6 (f7 f8 ?v2) ?v3)) (f6 (f7 f8 (f6 ?v_0 ?v2)) (f6 (f7 f8 ?v1) ?v3))))))
(assert (forall ((?v0 S8) (?v1 S8) (?v2 S8) (?v3 S8)) (let ((?v_0 (f40 f49 ?v0))) (= (f39 (f40 f49 (f39 ?v_0 ?v1)) (f39 (f40 f49 ?v2) ?v3)) (f39 (f40 f49 (f39 ?v_0 ?v2)) (f39 (f40 f49 ?v1) ?v3))))))
(assert (= (f31 f47 f18) f18))
(assert (= (f26 f48 1) 1))
(assert (forall ((?v0 S2)) (let ((?v_0 (f34 (f35 f36 ?v0) (f20 f21 2)))) (= (f31 f47 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f22 (f29 f30 ?v0) (f20 f21 2)))) (= (f26 f48 ?v_0) ?v_0))))
(assert (forall ((?v0 S8)) (= (f39 (f40 f42 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S2)) (= (f34 (f35 f36 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S4)) (= (f12 (f13 f14 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f22 (f29 f30 ?v0) (f20 f21 1)) ?v0)))
(assert (forall ((?v0 S2)) (let ((?v_0 (f20 f21 2))) (= (f34 (f35 f36 (f31 f47 ?v0)) ?v_0) (f34 (f35 f36 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f20 f21 2))) (= (f22 (f29 f30 (f26 f48 ?v0)) ?v_0) (f22 (f29 f30 ?v0) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (let ((?v_0 (f32 f33 ?v0))) (= (f31 (f32 f33 (f31 ?v_0 ?v1)) ?v2) (f31 ?v_0 (f31 (f32 f33 ?v1) ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f31 (f32 f33 ?v0) ?v1) (f31 (f32 f33 ?v1) ?v0))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f20 f21 (* 2 ?v_0)) (f20 f21 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f22 f23 ?v0))) (= (f20 f21 (* ?v_0 2)) (f20 f21 (+ ?v_0 ?v_0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f20 f21 0)) (?v_2 (f22 f23 ?v0)) (?v_1 (f22 f23 ?v1))) (= (f20 f21 (f26 (f27 f28 ?v_2) ?v_1)) (ite (= ?v0 ?v_0) ?v_0 (f20 f21 (+ ?v_1 (f26 (f27 f28 (f22 f23 (f20 f21 (- ?v_2 1)))) ?v_1))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (f40 f42 ?v0))) (= (f39 ?v_0 ?v1) (ite (= ?v1 (f20 f21 0)) (f20 f21 1) (f20 f21 (f26 (f27 f28 (f22 f23 ?v0)) (f22 f23 (f39 ?v_0 (f20 f21 (- (f22 f23 ?v1) 1)))))))))))
(assert (forall ((?v0 S8)) (let ((?v_0 (f22 f23 ?v0))) (=> (< 0 ?v_0) (= (= (f25 ?v0) f1) (not (= (f25 (f20 f21 (- ?v_0 1))) f1)))))))
(assert (forall ((?v0 S8)) (=> (not (= (f25 ?v0) f1)) (< 0 (f22 f23 ?v0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_0 (= (f25 ?v0) f1)) (?v_1 (= (f25 ?v1) f1))) (= (= (f25 (f20 f21 (+ (f22 f23 ?v0) (f22 f23 ?v1)))) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 S8) (?v1 S8)) (let ((?v_1 (f22 f23 ?v1)) (?v_0 (f22 f23 ?v0)) (?v_2 (= (f25 ?v0) f1)) (?v_3 (= (f25 ?v1) f1))) (= (= (f25 (f20 f21 (- ?v_0 ?v_1))) f1) (or (< ?v_0 ?v_1) (or (and ?v_2 ?v_3) (and (not ?v_2) (not ?v_3))))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f25 (f39 (f40 f42 ?v0) ?v1)) f1) (and (= (f25 ?v0) f1) (< 0 (f22 f23 ?v1))))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (= (f25 (f20 f21 (+ (f22 f23 ?v0) (f22 f23 ?v1)))) f1) (= (= (f25 ?v0) f1) (= (f25 ?v1) f1)))))
(assert (forall ((?v0 S8) (?v1 S8)) (= (not (= (f25 (f20 f21 (+ (f22 f23 ?v0) (f22 f23 ?v1)))) f1)) (not (= (not (= (f25 ?v0) f1)) (not (= (f25 ?v1) f1)))))))
(assert (forall ((?v0 S8)) (= (= (f25 (f20 f21 (+ (f22 f23 ?v0) 1))) f1) (not (= (f25 ?v0) f1)))))
(assert (not (= (f25 (f20 f21 1)) f1)))
(assert (= (f25 (f20 f21 0)) f1))
(assert (forall ((?v0 S2)) (= (f31 (f32 f33 f45) ?v0) f45)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 f24) ?v0) f24)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S8)) (= (f39 (f40 f41 f46) ?v0) f46)))
(assert (forall ((?v0 S2)) (= (f31 (f32 f33 f45) ?v0) f45)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 f24) ?v0) f24)))
(assert (forall ((?v0 Int)) (= (* 0 ?v0) 0)))
(assert (forall ((?v0 S8)) (= (f39 (f40 f41 f46) ?v0) f46)))
(assert (forall ((?v0 S2)) (= (f31 (f32 f33 ?v0) f45) f45)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 ?v0) f24) f24)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f39 (f40 f41 ?v0) f46) f46)))
(assert (forall ((?v0 S2)) (= (f31 (f32 f33 ?v0) f45) f45)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f10 ?v0) f24) f24)))
(assert (forall ((?v0 Int)) (= (* ?v0 0) 0)))
(assert (forall ((?v0 S8)) (= (f39 (f40 f41 ?v0) f46) f46)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f31 (f32 f33 ?v0) ?v1) f45) (or (= ?v0 f45) (= ?v1 f45)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f6 (f7 f10 ?v0) ?v1) f24) (or (= ?v0 f24) (= ?v1 f24)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f26 (f27 f28 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (not (= ?v0 f45)) (=> (not (= ?v1 f45)) (not (= (f31 (f32 f33 ?v0) ?v1) f45))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (not (= ?v0 f24)) (=> (not (= ?v1 f24)) (not (= (f6 (f7 f10 ?v0) ?v1) f24))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (not (= ?v1 0)) (not (= (f26 (f27 f28 ?v0) ?v1) 0))))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (not (= ?v0 f46)) (=> (not (= ?v1 f46)) (not (= (f39 (f40 f41 ?v0) ?v1) f46))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f31 (f32 f33 ?v0) ?v1) f45) (or (= ?v0 f45) (= ?v1 f45)))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f6 (f7 f10 ?v0) ?v1) f24) (or (= ?v0 f24) (= ?v1 f24)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f26 (f27 f28 ?v0) ?v1) 0) (or (= ?v0 0) (= ?v1 0)))))
(assert (forall ((?v0 S8) (?v1 S8)) (=> (= (f39 (f40 f41 ?v0) ?v1) f46) (or (= ?v0 f46) (= ?v1 f46)))))
(assert (forall ((?v0 Int)) (= (+ 0 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (f31 (f32 f44 f45) ?v0) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 f24) ?v0) ?v0)))
(assert (forall ((?v0 S8)) (= (f39 (f40 f49 f46) ?v0) ?v0)))
(assert (forall ((?v0 Int)) (= (+ ?v0 0) ?v0)))
(assert (forall ((?v0 S2)) (= (f31 (f32 f44 ?v0) f45) ?v0)))
(assert (forall ((?v0 S4)) (= (f6 (f7 f8 ?v0) f24) ?v0)))
(assert (forall ((?v0 S8)) (= (f39 (f40 f49 ?v0) f46) ?v0)))
(assert (forall ((?v0 S8)) (= (f20 f21 (f22 f23 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f22 f23 (f20 f21 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f22 f23 (f20 f21 ?v0)) 0))))
(check-sat)
(exit)
