(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 () S4)
(declare-fun f6 () S3)
(declare-fun f7 () S3)
(declare-fun f8 () S3)
(declare-fun f9 () S3)
(declare-fun f10 (S5 S3) S3)
(declare-fun f11 () S5)
(declare-fun f12 (S6 Int) Int)
(declare-fun f13 () S6)
(declare-fun f14 (S7 S3) S5)
(declare-fun f15 () S7)
(declare-fun f16 () S6)
(declare-fun f17 () S5)
(declare-fun f18 () S7)
(declare-fun f19 (S8 Int) S6)
(declare-fun f20 () S8)
(declare-fun f21 () S7)
(declare-fun f22 () S8)
(declare-fun f23 (S9 S3) Int)
(declare-fun f24 (S10 Int) S3)
(declare-fun f25 () S5)
(declare-fun f26 () S5)
(declare-fun f27 () S2)
(declare-fun f28 () S7)
(declare-fun f29 () S4)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 f6) f7) f1)))
(assert (= (f3 (f4 f5 f6) f8) f1))
(assert (= (f3 (f4 f5 f6) f9) f1))
(assert (not (< 1 0)))
(assert (not (= (f3 (f4 f5 f7) f6) f1)))
(assert (< 0 1))
(assert (= (f3 (f4 f5 f6) f7) f1))
(assert (not (= f6 f7)))
(assert (not (= 1 0)))
(assert (not (= f7 f6)))
(assert (not (= 0 1)))
(assert (not (= f6 f7)))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f5 (f10 f11 ?v0)) f6) f1))))
(assert (forall ((?v0 Int)) (not (< (f12 f13 ?v0) 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 f6) (f10 f11 ?v0)) f1) (not (= ?v0 f6)))))
(assert (forall ((?v0 Int)) (= (< 0 (f12 f13 ?v0)) (not (= ?v0 0)))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f10 f11 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f12 f13 ?v0) ?v0))))
(assert (forall ((?v0 S2)) (=> (exists ((?v1 S3)) (= (f3 ?v0 ?v1) f1)) (=> (exists ((?v1 S3)) (forall ((?v2 S3)) (=> (= (f3 ?v0 ?v2) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))) (exists ((?v1 S3)) (forall ((?v2 S3)) (= (exists ((?v3 S3)) (and (= (f3 ?v0 ?v3) f1) (= (f3 (f4 f5 ?v2) ?v3) f1))) (= (f3 (f4 f5 ?v2) ?v1) f1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (exists ((?v2 S3)) (let ((?v_1 (f4 f5 ?v2))) (and (= (f3 ?v_0 ?v2) f1) (and (= (f3 ?v_1 ?v0) f1) (= (f3 ?v_1 ?v1) f1))))))))))
(assert (= (f10 f11 f7) f7))
(assert (= (f12 f13 1) 1))
(assert (forall ((?v0 Int)) (= (= 1 ?v0) (= ?v0 1))))
(assert (forall ((?v0 S3)) (= (= f7 ?v0) (= ?v0 f7))))
(assert (forall ((?v0 S3)) (= (= (f10 f11 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= (f12 f13 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 Int)) (= (= 0 ?v0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= f6 ?v0) (= ?v0 f6))))
(assert (= (f10 f11 f6) f6))
(assert (= (f12 f13 0) 0))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (= (f3 (f4 f5 f6) (f10 (f14 f15 f8) f9)) f1))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f12 f16 ?v0) 1))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f10 f17 ?v0) f7))))
(assert (forall ((?v0 Int)) (= (= (f12 f16 ?v0) 1) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f10 f17 ?v0) f7) (= (f3 (f4 f5 f6) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (=> (< ?v0 ?v1) false) (=> (=> (= ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (=> (not false) (= (f3 (f4 f5 ?v1) ?v0) f1)) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (=> (not false) (< ?v1 ?v0)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v0 ?v2) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v2 ?v1) (< ?v2 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 ?v1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f10 f17 ?v0))) (= (f10 f17 ?v_0) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f12 f16 ?v0))) (= (f12 f16 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (= (f10 (f14 f15 f6) ?v0) f6)))
(assert (forall ((?v0 S3)) (= (f10 (f14 f15 ?v0) f6) f6)))
(assert (forall ((?v0 S3)) (= (f10 (f14 f15 ?v0) f7) ?v0)))
(assert (= (f10 f17 f6) f6))
(assert (= (f12 f16 0) 0))
(assert (forall ((?v0 S3)) (= (= (f10 f17 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= (f12 f16 ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (f10 (f14 f15 ?v0) ?v0) (ite (= ?v0 f6) f6 f7))))
(assert (forall ((?v0 S3)) (=> (not (= ?v0 f6)) (= (f10 (f14 f15 ?v0) ?v0) f7))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (= (f10 (f14 f15 ?v1) ?v0) f7) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 ?v_0 (f10 f17 ?v0)) f1) (= (f3 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (< 0 (f12 f16 ?v0)) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f10 f17 ?v0)) f6) f1) (= (f3 (f4 f5 ?v0) f6) f1))))
(assert (forall ((?v0 Int)) (= (< (f12 f16 ?v0) 0) (< ?v0 0))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f5 ?v0) ?v0) f1))))
(assert (forall ((?v0 Int)) (not (< ?v0 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= ?v0 ?v1)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (= ?v0 ?v1)) (or (< ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (or (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (or (< ?v1 ?v0) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (or (= ?v0 ?v1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (< ?v0 ?v1) (or (= ?v0 ?v1) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f10 (f14 f18 ?v1) ?v2)) f1) (or (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f12 (f19 f20 ?v1) ?v2)) (or (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f10 (f14 f21 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< ?v0 (f12 (f19 f22 ?v1) ?v2)) (and (< ?v0 ?v1) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f10 (f14 f18 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f12 (f19 f20 ?v0) ?v1) ?v2) (and (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f10 (f14 f21 ?v0) ?v1)) ?v2) f1) (or (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (< (f12 (f19 f22 ?v0) ?v1) ?v2) (or (< ?v0 ?v2) (< ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (not (= (f3 (f4 f5 ?v1) ?v0) f1)) (= ?v1 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (not (< ?v1 ?v0)) (= ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (=> (= (f3 (f4 f5 ?v0) ?v1) f1) false) (=> (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (=> (< ?v0 ?v1) false) (=> (=> (< ?v1 ?v0) false) false)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (not (= (f3 (f4 f5 ?v1) ?v0) f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (not (< ?v1 ?v0)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v0 ?v1) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (= (= ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S1)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (=> (= (f3 (f4 f5 ?v1) ?v0) f1) (= ?v2 f1)) true))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S1)) (=> (< ?v0 ?v1) (= (=> (< ?v1 ?v0) (= ?v2 f1)) true))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v0) f1) false))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (=> (< ?v1 ?v0) false))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f10 f17 ?v0) f7))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 ?v_0 (f10 (f14 f15 ?v0) ?v1)) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 (f4 f5 ?v1) f6) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (= (= (f3 (f4 f5 (f10 (f14 f15 ?v0) ?v1)) f6) f1) (or (and (= (f3 ?v_0 ?v0) f1) (= (f3 (f4 f5 ?v1) f6) f1)) (and (= (f3 (f4 f5 ?v0) f6) f1) (= (f3 ?v_0 ?v1) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f5 (f10 (f14 f15 ?v0) ?v1)) (f10 (f14 f15 ?v2) ?v1)) f1) (and (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)) (and (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 ?v2) ?v0) f1)) (not (= ?v1 f6)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (= (f10 (f14 f15 (f10 f11 ?v1)) ?v0) (f10 f11 (f10 (f14 f15 ?v1) ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f4 f5 f6))) (=> (= (f3 ?v_0 ?v0) f1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f10 (f14 f15 ?v0) ?v1)) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 f6) ?v0) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 (f10 (f14 f15 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 f6) ?v1) f1) (= (f3 (f4 f5 (f10 (f14 f15 ?v0) ?v1)) f6) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f3 (f4 f5 f6) (f10 (f14 f15 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 f11 (f10 (f14 f15 ?v0) ?v1)) (f10 (f14 f15 (f10 f11 ?v0)) (f10 f11 ?v1)))))
(assert (forall ((?v0 S3)) (= (f10 f17 ?v0) (f10 (f14 f15 ?v0) (f10 f11 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f10 f11 (f10 (f14 f15 ?v1) ?v0)) (f10 (f14 f15 (f10 f11 ?v1)) (f10 f11 ?v0))))))
(assert (forall ((?v0 S3)) (= (f10 (f14 f15 f6) ?v0) f6)))
(assert (forall ((?v0 S3)) (= (= (f10 f17 ?v0) f6) (= ?v0 f6))))
(assert (= (f10 f17 f6) f6))
(assert (= (f10 f17 f7) f7))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) f6) f1) (= (f3 (f4 f5 (f10 (f14 f15 ?v1) ?v2)) (f10 (f14 f15 ?v0) ?v2)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 f6) ?v2) f1) (= (f3 (f4 f5 (f10 (f14 f15 ?v0) ?v2)) (f10 (f14 f15 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S9) (?v1 S3) (?v2 Int) (?v3 S3)) (=> (< (f23 ?v0 ?v1) ?v2) (=> (= (f3 (f4 f5 ?v3) ?v1) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (< (f23 ?v0 ?v5) (f23 ?v0 ?v4)))) (< (f23 ?v0 ?v3) ?v2))))))
(assert (forall ((?v0 S10) (?v1 Int) (?v2 S3) (?v3 Int)) (=> (= (f3 (f4 f5 (f24 ?v0 ?v1)) ?v2) f1) (=> (< ?v3 ?v1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f3 (f4 f5 (f24 ?v0 ?v5)) (f24 ?v0 ?v4)) f1))) (= (f3 (f4 f5 (f24 ?v0 ?v3)) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S5) (?v2 S3) (?v3 S3)) (=> (= ?v0 (f10 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v3) ?v2) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (= (f3 (f4 f5 (f10 ?v1 ?v5)) (f10 ?v1 ?v4)) f1))) (= (f3 (f4 f5 (f10 ?v1 ?v3)) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 S6) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f12 ?v1 ?v2)) (=> (< ?v3 ?v2) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f12 ?v1 ?v5) (f12 ?v1 ?v4)))) (< (f12 ?v1 ?v3) ?v0))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S3) (?v3 S3)) (=> (< ?v0 (f23 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (< (f23 ?v1 ?v4) (f23 ?v1 ?v5)))) (< ?v0 (f23 ?v1 ?v3)))))))
(assert (forall ((?v0 S3) (?v1 S10) (?v2 Int) (?v3 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 (f24 ?v1 ?v2)) f1) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f5 (f24 ?v1 ?v4)) (f24 ?v1 ?v5)) f1))) (= (f3 ?v_0 (f24 ?v1 ?v3)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S10) (?v2 Int) (?v3 Int)) (=> (= ?v0 (f24 ?v1 ?v2)) (=> (< ?v2 ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f5 (f24 ?v1 ?v4)) (f24 ?v1 ?v5)) f1))) (= (f3 (f4 f5 ?v0) (f24 ?v1 ?v3)) f1))))))
(assert (forall ((?v0 Int) (?v1 S9) (?v2 S3) (?v3 S3)) (=> (= ?v0 (f23 ?v1 ?v2)) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (< (f23 ?v1 ?v4) (f23 ?v1 ?v5)))) (< ?v0 (f23 ?v1 ?v3)))))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (= (f3 (f4 f5 ?v0) ?v1) f1))))
(assert (forall ((?v0 S3)) (exists ((?v1 S3)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (exists ((?v2 S3)) (and (= (f3 (f4 f5 ?v0) ?v2) f1) (= (f3 (f4 f5 ?v2) ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S10)) (let ((?v_0 (f4 f5 ?v2))) (=> (< ?v0 ?v1) (=> (= (f3 ?v_0 (f24 ?v3 ?v0)) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (= (f3 (f4 f5 (f24 ?v3 ?v5)) (f24 ?v3 ?v4)) f1))) (= (f3 ?v_0 (f24 ?v3 ?v1)) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int) (?v3 S9)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (< ?v2 (f23 ?v3 ?v0)) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (< (f23 ?v3 ?v5) (f23 ?v3 ?v4)))) (< ?v2 (f23 ?v3 ?v1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S5) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f10 ?v2 ?v0) ?v3) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v5) ?v4) f1) (= (f3 (f4 f5 (f10 ?v2 ?v5)) (f10 ?v2 ?v4)) f1))) (= (f3 (f4 f5 ?v3) (f10 ?v2 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S6) (?v3 Int)) (=> (< ?v0 ?v1) (=> (= (f12 ?v2 ?v0) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v5 ?v4) (< (f12 ?v2 ?v5) (f12 ?v2 ?v4)))) (< ?v3 (f12 ?v2 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10) (?v3 S3)) (=> (< ?v0 ?v1) (=> (= (f24 ?v2 ?v1) ?v3) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f5 (f24 ?v2 ?v4)) (f24 ?v2 ?v5)) f1))) (= (f3 (f4 f5 (f24 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S9) (?v3 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f23 ?v2 ?v1) ?v3) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (< (f23 ?v2 ?v4) (f23 ?v2 ?v5)))) (< (f23 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10) (?v3 S3)) (=> (< ?v0 ?v1) (=> (= (f3 (f4 f5 (f24 ?v2 ?v1)) ?v3) f1) (=> (forall ((?v4 Int) (?v5 Int)) (=> (< ?v4 ?v5) (= (f3 (f4 f5 (f24 ?v2 ?v4)) (f24 ?v2 ?v5)) f1))) (= (f3 (f4 f5 (f24 ?v2 ?v0)) ?v3) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S9) (?v3 Int)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (< (f23 ?v2 ?v1) ?v3) (=> (forall ((?v4 S3) (?v5 S3)) (=> (= (f3 (f4 f5 ?v4) ?v5) f1) (< (f23 ?v2 ?v4) (f23 ?v2 ?v5)))) (< (f23 ?v2 ?v0) ?v3))))))
(assert (forall ((?v0 S3)) (= (f10 f17 ?v0) (ite (= ?v0 f6) f6 (ite (= (f3 (f4 f5 f6) ?v0) f1) f7 (f10 f25 f7))))))
(assert (forall ((?v0 S3)) (= (f10 f17 ?v0) (ite (= ?v0 f6) f6 (ite (= (f3 (f4 f5 f6) ?v0) f1) f7 (f10 f25 f7))))))
(assert (forall ((?v0 S3)) (= (f10 f26 (f10 f17 ?v0)) (ite (= ?v0 f6) f6 f7))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f16 ?v0) (- 1)))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (f10 f17 ?v0) (f10 f25 f7)))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) ?v0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f10 f25 ?v0) ?v0) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= (- ?v0) 0) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f10 f25 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= ?v0 (- ?v0)) (= ?v0 0))))
(assert (forall ((?v0 S3)) (= (= ?v0 (f10 f25 ?v0)) (= ?v0 f6))))
(assert (forall ((?v0 Int)) (= (= 0 (- ?v0)) (= 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= f6 (f10 f25 ?v0)) (= f6 ?v0))))
(assert (= 0 0))
(assert (= (f10 f25 f6) f6))
(assert (forall ((?v0 S3)) (let ((?v_0 (f10 f26 ?v0))) (= (f10 f11 ?v_0) ?v_0))))
(assert (forall ((?v0 S3)) (= (f10 f26 (f10 f25 ?v0)) (f10 f26 ?v0))))
(assert (forall ((?v0 S3)) (= (f10 f25 (f10 f25 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (= (- (- ?v0)) ?v0)))
(assert (forall ((?v0 S3)) (= (f10 f11 (f10 f25 ?v0)) (f10 f11 ?v0))))
(assert (forall ((?v0 Int)) (= (f12 f13 (- ?v0)) (f12 f13 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 f25 (f10 (f14 f18 ?v0) ?v1)) (f10 (f14 f21 (f10 f25 ?v0)) (f10 f25 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f12 (f19 f20 ?v0) ?v1)) (f12 (f19 f22 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 f25 (f10 (f14 f21 ?v0) ?v1)) (f10 (f14 f18 (f10 f25 ?v0)) (f10 f25 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (f12 (f19 f22 ?v0) ?v1)) (f12 (f19 f20 (- ?v0)) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= ?v0 (f10 f25 ?v1)) (= ?v1 (f10 f25 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= ?v0 (- ?v1)) (= ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f10 f25 ?v0) ?v1) (= (f10 f25 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) ?v1) (= (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f10 f25 ?v0) (f10 f25 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (- ?v0) (- ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) (f10 f25 ?v1)) f1) (= (f3 (f4 f5 ?v1) (f10 f25 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 (- ?v1)) (< ?v1 (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f10 f25 ?v0)) ?v1) f1) (= (f3 (f4 f5 (f10 f25 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) ?v1) (< (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f10 f11 ?v0)) ?v1) f1) (and (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f10 f25 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (f12 f13 ?v0) ?v1) (and (< ?v0 ?v1) (< (- ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f10 f25 ?v0)) (f10 f25 ?v1)) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< (- ?v0) (- ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 f25 (f10 (f14 f15 ?v0) ?v1)) (f10 (f14 f15 (f10 f25 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 (f14 f15 (f10 f25 ?v0)) (f10 f25 ?v1)) (f10 (f14 f15 ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 (f14 f15 (f10 f25 ?v0)) ?v1) (f10 f25 (f10 (f14 f15 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f14 f15 ?v0))) (= (f10 f25 (f10 ?v_0 ?v1)) (f10 ?v_0 (f10 f25 ?v1))))))
(assert (forall ((?v0 S3)) (= (f10 f17 (f10 f25 ?v0)) (f10 f25 (f10 f17 ?v0)))))
(assert (forall ((?v0 S3)) (= (f10 f11 ?v0) (ite (= (f3 (f4 f5 ?v0) f6) f1) (f10 f25 ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (f12 f13 ?v0) (ite (< ?v0 0) (- ?v0) ?v0))))
(assert (forall ((?v0 Int)) (= (< 0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 f6) (f10 f25 ?v0)) f1) (= (f3 (f4 f5 ?v0) f6) f1))))
(assert (forall ((?v0 Int)) (= (< ?v0 (- ?v0)) (< ?v0 0))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (= (f3 ?v_0 (f10 f25 ?v0)) f1) (= (f3 ?v_0 f6) f1)))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) 0) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f10 f25 ?v0)) f6) f1) (= (f3 (f4 f5 f6) ?v0) f1))))
(assert (forall ((?v0 Int)) (= (< (- ?v0) ?v0) (< 0 ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 (f10 f25 ?v0)) ?v0) f1) (= (f3 (f4 f5 f6) ?v0) f1))))
(assert (forall ((?v0 S3)) (=> (= (f3 (f4 f5 ?v0) f6) f1) (= (f10 f11 ?v0) (f10 f25 ?v0)))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f13 ?v0) (- ?v0)))))
(assert (= (f10 f26 f6) f6))
(assert (forall ((?v0 S3)) (= (= (f10 f26 ?v0) f6) (= ?v0 f6))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f14 f15 ?v1))) (=> (not (= ?v0 f6)) (= (f10 f25 (f10 ?v_0 ?v0)) (f10 ?v_0 (f10 f25 ?v0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f10 (f14 f15 (f10 f25 ?v1)) (f10 f25 ?v0)) (f10 (f14 f15 ?v1) ?v0)))))
(assert (forall ((?v0 S3)) (not (= (f3 (f4 f5 (f10 f26 ?v0)) f6) f1))))
(assert (= (f10 f26 f7) f7))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 f26 (f10 (f14 f15 ?v0) ?v1)) (f10 (f14 f15 (f10 f26 ?v0)) (f10 f26 ?v1)))))
(assert (forall ((?v0 S3)) (= (f10 f11 ?v0) (ite (= (f3 (f4 f5 ?v0) f6) f1) (f10 f25 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (f10 f11 ?v0) (ite (= (f3 (f4 f5 ?v0) f6) f1) (f10 f25 ?v0) ?v0))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f5 f6) (f10 f26 ?v0)) f1) (not (= ?v0 f6)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 f6)) (= (f10 f26 (f10 (f14 f15 ?v1) ?v0)) (f10 (f14 f15 (f10 f26 ?v1)) (f10 f26 ?v0))))))
(assert (forall ((?v0 Int)) (= (f12 f16 ?v0) (ite (= ?v0 0) 0 (ite (< 0 ?v0) 1 (- 1))))))
(assert (forall ((?v0 S3)) (= (f10 f17 ?v0) (ite (= ?v0 f6) f6 (ite (= (f3 (f4 f5 f6) ?v0) f1) f7 (f10 f25 f7))))))
(assert (forall ((?v0 Int)) (= (= (f12 f16 ?v0) (- 1)) (< ?v0 0))))
(assert (forall ((?v0 S3)) (= (= (f10 f17 ?v0) (f10 f25 f7)) (= (f3 (f4 f5 ?v0) f6) f1))))
(assert (forall ((?v0 S3)) (=> (not (= (f3 f27 ?v0) f1)) (=> (not (= ?v0 f6)) (= (f3 f27 (f10 f25 ?v0)) f1)))))
(assert (not (= (f3 f27 f6) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f10 (f14 f21 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f12 (f19 f22 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f5 (f10 (f14 f21 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< (f12 (f19 f22 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f10 (f14 f18 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f12 (f19 f20 ?v2) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f10 (f14 f18 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (< ?v0 (f12 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 f6) (f10 (f14 f28 ?v0) ?v1)) f1) (= (f3 (f4 f5 (f10 f25 ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 (f10 (f14 f28 ?v0) ?v1)) f6) f1) (= (f3 (f4 f5 ?v1) (f10 f25 ?v0)) f1))))
(assert (forall ((?v0 S3)) (= (= (f3 (f4 f29 (f10 f26 ?v0)) f6) f1) (= ?v0 f6))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f29 ?v0) ?v0) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f29 ?v0) (f10 (f14 f18 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f12 (f19 f20 ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f29 ?v0) (f10 (f14 f18 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= ?v0 (f12 (f19 f20 ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f29 (f10 (f14 f21 ?v0) ?v1)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f12 (f19 f22 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f29 (f10 (f14 f21 ?v0) ?v1)) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f12 (f19 f22 ?v0) ?v1) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f10 (f14 f18 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f12 (f19 f20 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f10 (f14 f21 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (= (f12 (f19 f22 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f29 ?v0))) (= (= (f3 ?v_0 (f10 (f14 f21 ?v1) ?v2)) f1) (and (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= ?v0 (f12 (f19 f22 ?v1) ?v2)) (and (<= ?v0 ?v1) (<= ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f18 ?v0))) (= (f3 (f4 f29 (f10 ?v_0 (f10 (f14 f21 ?v1) ?v2))) (f10 (f14 f21 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f19 f20 ?v0))) (<= (f12 ?v_0 (f12 (f19 f22 ?v1) ?v2)) (f12 (f19 f22 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f29 (f10 (f14 f18 ?v0) ?v1)) ?v2) f1) (and (= (f3 (f4 f29 ?v0) ?v2) f1) (= (f3 (f4 f29 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (f12 (f19 f20 ?v0) ?v1) ?v2) (and (<= ?v0 ?v2) (<= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f21 ?v0))) (= (f3 (f4 f29 (f10 (f14 f18 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2))) (f10 ?v_0 (f10 (f14 f18 ?v1) ?v2))) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f19 f22 ?v0))) (<= (f12 (f19 f20 (f12 ?v_0 ?v1)) (f12 ?v_0 ?v2)) (f12 ?v_0 (f12 (f19 f20 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f29 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f10 (f14 f18 ?v1) ?v2)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f12 (f19 f20 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f29 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 (f10 (f14 f18 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= ?v0 (f12 (f19 f20 ?v2) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f3 (f4 f29 (f10 (f14 f21 ?v0) ?v2)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f12 (f19 f22 ?v0) ?v2) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f3 (f4 f29 (f10 (f14 f21 ?v2) ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (f12 (f19 f22 ?v2) ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f10 (f14 f18 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f12 (f19 f20 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f10 (f14 f21 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f12 (f19 f22 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f10 (f14 f18 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f12 (f19 f20 ?v1) ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f10 (f14 f21 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (f12 (f19 f22 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f29 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f10 (f14 f21 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f12 (f19 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f29 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) (= (f3 ?v_0 (f10 (f14 f21 ?v1) ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) (<= ?v0 (f12 (f19 f22 ?v1) ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 ?v2) ?v1) f1) (= (f3 (f4 f29 (f10 (f14 f18 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f12 (f19 f20 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 ?v2) ?v1) f1) (= (f3 (f4 f29 (f10 (f14 f18 ?v0) ?v2)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v1) (<= (f12 (f19 f20 ?v0) ?v2) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 ?v2) ?v3) f1) (= (f3 (f4 f29 (f10 (f14 f18 ?v0) ?v2)) (f10 (f14 f18 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f12 (f19 f20 ?v0) ?v2) (f12 (f19 f20 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 ?v2) ?v3) f1) (= (f3 (f4 f29 (f10 (f14 f21 ?v0) ?v2)) (f10 (f14 f21 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (f12 (f19 f22 ?v0) ?v2) (f12 (f19 f22 ?v1) ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f29 ?v0))) (=> (= (f3 ?v_0 (f10 (f14 f21 ?v1) ?v2)) f1) (=> (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 ?v_0 ?v2) f1) false)) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 (f12 (f19 f22 ?v1) ?v2)) (=> (=> (<= ?v0 ?v1) (=> (<= ?v0 ?v2) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f29 (f10 (f14 f18 ?v0) ?v1)) ?v2) f1) (=> (=> (= (f3 (f4 f29 ?v0) ?v2) f1) (=> (= (f3 (f4 f29 ?v1) ?v2) f1) false)) false))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (f12 (f19 f20 ?v0) ?v1) ?v2) (=> (=> (<= ?v0 ?v2) (=> (<= ?v1 ?v2) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 f27 ?v0) f1) (=> (= (f3 f27 ?v1) f1) (= (f3 f27 (f10 (f14 f28 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v1) ?v2) f1) (= (f3 (f4 f5 ?v0) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (=> (< ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 ?v2) ?v0) f1) (= (f3 (f4 f5 ?v2) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v0) (< ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f29 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< ?v0 ?v1) (=> (<= ?v1 ?v2) (< ?v0 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (not (= ?v1 ?v0)) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v1 ?v0)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (not (= ?v0 ?v1)) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (not (= ?v0 ?v1)) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (= (not (< ?v0 ?v1)) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (= (f3 (f4 f29 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (not (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (not (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f29 ?v1) ?v0) f1) (= (f3 (f4 f5 ?v1) ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v1 ?v0) (< ?v1 ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= ?v0 ?v1)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v0) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 ?v1)) (=> (<= ?v0 ?v1) (< ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (= (f3 (f4 f29 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (= (<= ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f29 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f29 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 ?v1) (or (< ?v0 ?v1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f29 ?v0) ?v1) f1) (not (= (f3 (f4 f29 ?v1) ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (<= ?v1 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f29 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (< ?v0 ?v1) (and (<= ?v0 ?v1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (or (<= ?v0 ?v1) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f29 ?v0) ?v1) f1)) (= (f3 (f4 f5 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (<= ?v0 ?v1)) (< ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (not (= (f3 (f4 f5 ?v0) ?v1) f1)) (= (f3 (f4 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (not (< ?v0 ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 (f14 f28 (f10 f25 ?v0)) (f10 (f14 f28 ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ (- ?v0) (+ ?v0 ?v1)) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 (f14 f28 ?v0) (f10 (f14 f28 (f10 f25 ?v0)) ?v1)) ?v1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (+ ?v0 (+ (- ?v0) ?v1)) ?v1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 f25 (f10 (f14 f28 ?v0) ?v1)) (f10 (f14 f28 (f10 f25 ?v1)) (f10 f25 ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 f25 (f10 (f14 f28 ?v0) ?v1)) (f10 (f14 f28 (f10 f25 ?v0)) (f10 f25 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (- (+ ?v0 ?v1)) (+ (- ?v0) (- ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f10 (f14 f15 (f10 (f14 f28 ?v0) ?v1)) ?v2) (f10 (f14 f28 (f10 (f14 f15 ?v0) ?v2)) (f10 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f10 (f14 f15 (f10 (f14 f28 ?v0) ?v1)) ?v2) (f10 (f14 f28 (f10 (f14 f15 ?v0) ?v2)) (f10 (f14 f15 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 (f10 f11 ?v0)) ?v1) f1) (= (f3 (f4 f29 (f10 f25 ?v0)) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f12 f13 ?v0) ?v1) (<= (- ?v0) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 (f10 f25 ?v0)) ?v1) f1) (= (f3 (f4 f29 (f10 f11 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (=> (<= (- ?v0) ?v1) (<= (f12 f13 ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f3 (f4 f29 (f10 f25 ?v1)) (f10 f25 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 ?v1) (<= (- ?v1) (- ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f29 (f10 f25 ?v0)) (f10 f25 ?v1)) f1) (= (f3 (f4 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) (- ?v1)) (<= ?v1 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f29 (f10 f11 ?v0)) ?v1) f1) (and (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f3 (f4 f29 (f10 f25 ?v0)) ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (f12 f13 ?v0) ?v1) (and (<= ?v0 ?v1) (<= (- ?v0) ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f29 (f10 f25 ?v0)) ?v1) f1) (= (f3 (f4 f29 (f10 f25 ?v1)) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= (- ?v0) ?v1) (<= (- ?v1) ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f29 ?v0) (f10 f25 ?v1)) f1) (= (f3 (f4 f29 ?v1) (f10 f25 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (<= ?v0 (- ?v1)) (<= ?v1 (- ?v0)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f29 (f10 f25 ?v0)) (f10 f11 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= (- ?v0) (f12 f13 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f29 ?v0) ?v1) f1) (or (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (and (= (f3 (f4 f29 ?v0) ?v1) f1) (not (= ?v0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f10 f11 (f10 (f14 f28 ?v0) (f10 f25 ?v1))) (f10 f11 (f10 (f14 f28 ?v1) (f10 f25 ?v0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f3 (f4 f29 (f10 f11 ?v0)) ?v1) f1) (and (= (f3 (f4 f29 (f10 f25 ?v1)) ?v0) f1) (= (f3 (f4 f29 ?v0) ?v1) f1)))))
(assert (forall ((?v0 S3)) (= (f3 (f4 f29 ?v0) ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f3 (f4 f29 ?v0) (f10 f11 ?v0)) f1)))
(assert (forall ((?v0 Int)) (<= ?v0 (f12 f13 ?v0))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f4 f29 (f10 f11 (f10 (f14 f28 ?v0) ?v1))) (f10 (f14 f28 (f10 f11 ?v0)) (f10 f11 ?v1))) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (<= (f12 f13 (+ ?v0 ?v1)) (+ (f12 f13 ?v0) (f12 f13 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f10 (f14 f28 (f10 f11 ?v0)) (f10 f11 ?v1)))) (= (f10 f11 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ (f12 f13 ?v0) (f12 f13 ?v1)))) (= (f12 f13 ?v_0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (or (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f3 (f4 f29 ?v1) ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f28 ?v0))) (= (f10 (f14 f28 (f10 ?v_0 ?v1)) ?v2) (f10 ?v_0 (f10 (f14 f28 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (+ ?v0 ?v1) ?v2) (+ ?v0 (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f10 (f14 f28 (f10 (f14 f18 ?v0) ?v1)) ?v2) (f10 (f14 f18 (f10 (f14 f28 ?v0) ?v2)) (f10 (f14 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f12 (f19 f20 ?v0) ?v1) ?v2) (f12 (f19 f20 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f10 (f14 f28 (f10 (f14 f21 ?v0) ?v1)) ?v2) (f10 (f14 f21 (f10 (f14 f28 ?v0) ?v2)) (f10 (f14 f28 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (+ (f12 (f19 f22 ?v0) ?v1) ?v2) (f12 (f19 f22 (+ ?v0 ?v2)) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f28 ?v0))) (= (= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f10 (f14 f28 ?v0) ?v1) (f10 (f14 f28 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (= (f3 (f4 f29 (f10 (f14 f28 ?v0) ?v1)) (f10 (f14 f28 ?v2) ?v1)) f1) (= (f3 (f4 f29 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f28 ?v0))) (= (= (f3 (f4 f29 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) f1) (= (f3 (f4 f29 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f3 (f4 f29 (f10 (f14 f28 ?v0) ?v2)) (f10 (f14 f28 ?v1) ?v2)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v0 ?v2) (+ ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f28 ?v2))) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f3 (f4 f29 (f10 ?v_0 ?v0)) (f10 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= ?v0 ?v1) (<= (+ ?v2 ?v0) (+ ?v2 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f28 ?v2))) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (= (f3 (f4 f29 (f10 ?v_0 ?v0)) (f10 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f29 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f4 f29 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 ?v2) ?v3) f1) (= (f3 (f4 f29 (f10 (f14 f28 ?v0) ?v2)) (f10 (f14 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (<= ?v2 ?v3) (<= (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 f29 (f10 f11 ?v0)) ?v1) f1) (= (f3 (f4 f29 ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= (f12 f13 ?v0) ?v1) (<= ?v0 ?v1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f28 ?v0))) (=> (= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f28 ?v0))) (=> (= (f10 ?v_0 ?v1) (f10 ?v_0 ?v2)) (= ?v1 ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v0 ?v2)) (= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f10 (f14 f28 ?v0) ?v1) (f10 (f14 f28 ?v2) ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (+ ?v0 ?v1) (+ ?v2 ?v1)) (= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f3 (f4 f29 (f10 (f14 f28 ?v0) ?v1)) (f10 (f14 f28 ?v2) ?v1)) f1) (= (f3 (f4 f29 ?v0) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v2 ?v1)) (<= ?v0 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f14 f28 ?v0))) (=> (= (f3 (f4 f29 (f10 ?v_0 ?v1)) (f10 ?v_0 ?v2)) f1) (= (f3 (f4 f29 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= (+ ?v0 ?v1) (+ ?v0 ?v2)) (<= ?v1 ?v2))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f5 ?v0) ?v1) f1) (=> (= (f3 (f4 f29 ?v2) ?v3) f1) (= (f3 (f4 f5 (f10 (f14 f28 ?v0) ?v2)) (f10 (f14 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (< ?v0 ?v1) (=> (<= ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 f29 ?v0) ?v1) f1) (=> (= (f3 (f4 f5 ?v2) ?v3) f1) (= (f3 (f4 f5 (f10 (f14 f28 ?v0) ?v2)) (f10 (f14 f28 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (<= ?v0 ?v1) (=> (< ?v2 ?v3) (< (+ ?v0 ?v2) (+ ?v1 ?v3))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f4 f29 f6))) (= (= (f3 ?v_0 (f10 (f14 f28 ?v0) ?v0)) f1) (= (f3 ?v_0 ?v0) f1)))))
(assert (forall ((?v0 Int)) (= (<= 0 (+ ?v0 ?v0)) (<= 0 ?v0))))
(check-sat)
(exit)
