(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-sort S25 0)
(declare-sort S26 0)
(declare-sort S27 0)
(declare-sort S28 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 S2) S3)
(declare-fun f5 () S4)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S3) S3)
(declare-fun f8 (S6 S2) S5)
(declare-fun f9 () S6)
(declare-fun f10 () S6)
(declare-fun f11 (S9 S7) S1)
(declare-fun f12 (S10 S8) S9)
(declare-fun f13 (S11 S7) S10)
(declare-fun f14 () S11)
(declare-fun f15 (S12 S8) S10)
(declare-fun f16 (S13 S10) S12)
(declare-fun f17 () S13)
(declare-fun f18 (S14 S10) S10)
(declare-fun f19 (S15 S1) S14)
(declare-fun f20 () S15)
(declare-fun f21 () S10)
(declare-fun f22 () S10)
(declare-fun f23 () S3)
(declare-fun f24 (S16 S3) S1)
(declare-fun f25 (S17 S3) S16)
(declare-fun f26 () S17)
(declare-fun f27 () S3)
(declare-fun f28 () S6)
(declare-fun f29 (S18 S10) S2)
(declare-fun f30 (S19 S20) S18)
(declare-fun f31 (S21 S10) S19)
(declare-fun f32 () S21)
(declare-fun f33 () S10)
(declare-fun f34 () S20)
(declare-fun f35 () S3)
(declare-fun f36 (S22 S2) S16)
(declare-fun f37 () S22)
(declare-fun f38 (S24 S2) S25)
(declare-fun f39 (S26 S23) S24)
(declare-fun f40 () S26)
(declare-fun f41 (S27 Int) S25)
(declare-fun f42 () S27)
(declare-fun f43 () S5)
(declare-fun f44 (S28 S25) Int)
(declare-fun f45 () S28)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f5 ?v0) ?v1) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 f6 ?v0) ?v1) f1) (= ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f7 (f8 f9 ?v0) ?v1) ?v2) f1) (and (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f7 (f8 f10 ?v0) ?v1) ?v2) f1) (and (= ?v2 ?v0) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S7) (?v1 S8) (?v2 S7)) (= (= (f11 (f12 (f13 f14 ?v0) ?v1) ?v2) f1) (= ?v2 ?v0))))
(assert (forall ((?v0 S10) (?v1 S8) (?v2 S8)) (= (f12 (f15 (f16 f17 ?v0) ?v1) ?v2) (f12 ?v0 ?v1))))
(assert (forall ((?v0 S1) (?v1 S10) (?v2 S8) (?v3 S7)) (= (= (f11 (f12 (f18 (f19 f20 ?v0) ?v1) ?v2) ?v3) f1) (and (= (f11 (f12 ?v1 ?v2) ?v3) f1) (= ?v0 f1)))))
(assert (forall ((?v0 S8) (?v1 S7)) (= (= (f11 (f12 f21 ?v0) ?v1) f1) false)))
(assert (forall ((?v0 S8) (?v1 S7)) (= (= (f11 (f12 f22 ?v0) ?v1) f1) true)))
(assert (forall ((?v0 S2)) (= (= (f3 f23 ?v0) f1) false)))
(assert (not (= (f24 (f25 f26 f27) (f7 (f8 f28 (f29 (f30 (f31 f32 f33) f34) f22)) f35)) f1)))
(assert (forall ((?v0 S3)) (= (f24 (f25 f26 ?v0) f35) f1)))
(assert (forall ((?v0 S3) (?v1 S20) (?v2 S10)) (= (f24 (f25 f26 ?v0) (f7 (f8 f28 (f29 (f30 (f31 f32 f21) ?v1) ?v2)) f35)) f1)))
(assert (forall ((?v0 S10) (?v1 S20) (?v2 S10) (?v3 S10) (?v4 S20) (?v5 S10)) (= (= (f29 (f30 (f31 f32 ?v0) ?v1) ?v2) (f29 (f30 (f31 f32 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 ?v2))) (=> (= (f24 (f25 f26 ?v0) ?v1) f1) (=> (= (f24 ?v_0 ?v0) f1) (= (f24 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f8 f28 ?v1))) (=> (= (f24 ?v_0 (f7 ?v_1 f35)) f1) (=> (= (f24 ?v_0 ?v2) f1) (= (f24 ?v_0 (f7 ?v_1 ?v2)) f1))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f8 f28 ?v1))) (=> (= (f24 ?v_0 (f7 ?v_1 ?v2)) f1) (and (= (f24 ?v_0 (f7 ?v_1 f35)) f1) (= (f24 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S1) (?v1 S3) (?v2 S10) (?v3 S20) (?v4 S10)) (let ((?v_0 (f25 f26 ?v1))) (=> (=> (= ?v0 f1) (= (f24 ?v_0 (f7 (f8 f28 (f29 (f30 (f31 f32 ?v2) ?v3) ?v4)) f35)) f1)) (= (f24 ?v_0 (f7 (f8 f28 (f29 (f30 (f31 f32 (f18 (f19 f20 ?v0) ?v2)) ?v3) ?v4)) f35)) f1)))))
(assert (forall ((?v0 S10) (?v1 S3) (?v2 S20) (?v3 S10)) (=> (forall ((?v4 S8) (?v5 S7)) (=> (= (f11 (f12 ?v0 ?v4) ?v5) f1) (= (f24 (f25 f26 ?v1) (f7 (f8 f28 (f29 (f30 (f31 f32 (f13 f14 ?v5)) ?v2) (f15 (f16 f17 ?v3) ?v4))) f35)) f1))) (= (f24 (f25 f26 ?v1) (f7 (f8 f28 (f29 (f30 (f31 f32 ?v0) ?v2) ?v3)) f35)) f1))))
(assert (forall ((?v0 S3) (?v1 S10) (?v2 S20) (?v3 S10) (?v4 S10)) (let ((?v_0 (f25 f26 ?v0)) (?v_1 (f30 (f31 f32 ?v1) ?v2))) (=> (= (f24 ?v_0 (f7 (f8 f28 (f29 ?v_1 ?v3)) f35)) f1) (=> (forall ((?v5 S8) (?v6 S7)) (=> (= (f11 (f12 ?v3 ?v5) ?v6) f1) (= (f11 (f12 ?v4 ?v5) ?v6) f1))) (= (f24 ?v_0 (f7 (f8 f28 (f29 ?v_1 ?v4)) f35)) f1))))))
(assert (forall ((?v0 S3) (?v1 S10) (?v2 S20) (?v3 S10) (?v4 S10)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f24 ?v_0 (f7 (f8 f28 (f29 (f30 (f31 f32 ?v1) ?v2) ?v3)) f35)) f1) (=> (forall ((?v5 S8) (?v6 S7)) (=> (= (f11 (f12 ?v4 ?v5) ?v6) f1) (= (f11 (f12 ?v1 ?v5) ?v6) f1))) (= (f24 ?v_0 (f7 (f8 f28 (f29 (f30 (f31 f32 ?v4) ?v2) ?v3)) f35)) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f24 ?v_0 (f7 (f8 f28 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f24 ?v_0 ?v2) f1) false) false))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (let ((?v_0 (f36 f37 ?v0))) (=> (=> (not (= (f24 ?v_0 ?v1) f1)) (= ?v0 ?v2)) (= (f24 ?v_0 (f7 (f8 f28 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f24 (f36 f37 ?v0) f35) f1) false)))
(assert (forall ((?v0 S3) (?v1 S10) (?v2 S20) (?v3 S10) (?v4 S10) (?v5 S10)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f24 ?v_0 (f7 (f8 f28 (f29 (f30 (f31 f32 ?v1) ?v2) ?v3)) f35)) f1) (=> (forall ((?v6 S8) (?v7 S7)) (=> (= (f11 (f12 ?v4 ?v6) ?v7) f1) (forall ((?v8 S7)) (=> (forall ((?v9 S8)) (=> (= (f11 (f12 ?v1 ?v9) ?v7) f1) (= (f11 (f12 ?v3 ?v9) ?v8) f1))) (= (f11 (f12 ?v5 ?v6) ?v8) f1))))) (= (f24 ?v_0 (f7 (f8 f28 (f29 (f30 (f31 f32 ?v4) ?v2) ?v5)) f35)) f1))))))
(assert (forall ((?v0 S23) (?v1 S10) (?v2 S20) (?v3 S10)) (= (f38 (f39 f40 ?v0) (f29 (f30 (f31 f32 ?v1) ?v2) ?v3)) (f41 f42 0))))
(assert (forall ((?v0 S2)) (= (f7 f43 (f4 f5 ?v0)) (f7 (f8 f28 ?v0) f35))))
(assert (forall ((?v0 S2)) (= (f7 f43 (f4 f6 ?v0)) (f7 (f8 f28 ?v0) f35))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f7 f43 (f7 (f8 f9 ?v0) ?v1)) (ite (= (f3 ?v1 ?v0) f1) (f7 (f8 f28 ?v0) f35) f35))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f7 f43 (f7 (f8 f10 ?v0) ?v1)) (ite (= (f3 ?v1 ?v0) f1) (f7 (f8 f28 ?v0) f35) f35))))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= ?v0 f35) (not (= (f24 (f36 f37 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S3)) (= (= (f7 f43 ?v0) f35) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2)) (= (= (f24 (f36 f37 ?v0) f35) f1) false)))
(assert (forall ((?v0 S3)) (= (= f35 (f7 f43 ?v0)) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (=> (= (f24 (f36 f37 ?v1) f35) f1) (= (f3 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (and (= (f24 (f36 f37 ?v1) f35) f1) (= (f3 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (= (f24 (f36 f37 ?v1) ?v0) f1)) (not (= ?v0 f35)))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (not (= (f24 (f36 f37 ?v1) ?v0) f1))) (= ?v0 f35))))
(assert (= f35 (f7 f43 f23)))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f24 (f36 f37 ?v0) ?v1) f1) (= (f7 (f8 f28 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (let ((?v_0 (f36 f37 ?v0))) (=> (= (f24 ?v_0 ?v1) f1) (= (f24 ?v_0 (f7 (f8 f28 ?v2) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f36 f37 ?v0)) (?v_1 (f8 f28 ?v0))) (=> (not (= (f24 ?v_0 ?v1) f1)) (=> (not (= (f24 ?v_0 ?v2) f1)) (= (= (f7 ?v_1 ?v1) (f7 ?v_1 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f7 (f8 f28 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S25)) (= (f41 f42 (f44 f45 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f44 f45 (f41 f42 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f44 f45 (f41 f42 ?v0)) 0))))
(check-sat)
(exit)
