(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S4 S2) S1)
(declare-fun f4 (S5 S3) S4)
(declare-fun f5 (S6 S2) S5)
(declare-fun f6 () S6)
(declare-fun f7 (S9 S8) S1)
(declare-fun f8 (S2 S7) S9)
(declare-fun f9 (S3 S8 S10 S8) S1)
(declare-fun f10 (S11 Int) S10)
(declare-fun f11 () S11)
(declare-fun f12 (S12 S10) Int)
(declare-fun f13 () S12)
(declare-fun f14 () S10)
(declare-fun f15 () S6)
(declare-fun f16 (S13 S14) S15)
(declare-fun f17 (S2 S3 S2) S14)
(declare-fun f18 (S16 S2) S15)
(declare-fun f19 (S17 S3) S16)
(declare-fun f20 (S13 S2) S17)
(declare-fun f21 (S6 S14) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f5 f6 ?v0) ?v1) ?v2) f1) (forall ((?v3 S7) (?v4 S8)) (=> (= (f7 (f8 ?v0 ?v3) ?v4) f1) (forall ((?v5 S8)) (=> (= (f9 ?v1 ?v4 (f10 f11 (+ (f12 f13 f14) 1)) ?v5) f1) (= (f7 (f8 ?v2 ?v3) ?v5) f1))))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f5 f15 ?v0) ?v1) ?v2) f1) (forall ((?v3 S7) (?v4 S8)) (=> (= (f7 (f8 ?v0 ?v3) ?v4) f1) (forall ((?v5 S8)) (=> (= (f9 ?v1 ?v4 f14 ?v5) f1) (= (f7 (f8 ?v2 ?v3) ?v5) f1))))))))
(assert (forall ((?v0 S3) (?v1 S8) (?v2 S10) (?v3 S8)) (=> (= (f9 ?v0 ?v1 ?v2 ?v3) f1) (= (f9 ?v0 ?v1 (f10 f11 (+ (f12 f13 ?v2) 1)) ?v3) f1))))
(assert (forall ((?v0 S13) (?v1 S2) (?v2 S3) (?v3 S2)) (= (f16 ?v0 (f17 ?v1 ?v2 ?v3)) (f18 (f19 (f20 ?v0 ?v1) ?v2) ?v3))))
(assert (forall ((?v0 S6) (?v1 S2) (?v2 S3) (?v3 S2)) (= (= (f21 ?v0 (f17 ?v1 ?v2 ?v3)) f1) (= (f3 (f4 (f5 ?v0 ?v1) ?v2) ?v3) f1))))
(assert (not (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (let ((?v_0 (f17 ?v0 ?v1 ?v2))) (=> (= (f21 f6 ?v_0) f1) (= (f21 f15 ?v_0) f1))))))
(assert (forall ((?v0 S10)) (= (f10 f11 (f12 f13 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f12 f13 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f12 f13 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
