(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 S3) S3)
(declare-fun f5 (S2) S4)
(declare-fun f6 (S2 S3) S1)
(declare-fun f7 (S2) S4)
(declare-fun f8 () S3)
(declare-fun f9 () S3)
(declare-fun f10 (S5) S3)
(declare-fun f11 (S2) S4)
(declare-fun f12 () S2)
(declare-fun f13 () S3)
(declare-fun f14 (S3 S3) S1)
(declare-fun f15 () S3)
(declare-fun f16 (S6 Int) S5)
(declare-fun f17 () S6)
(declare-fun f18 (S7 S5) Int)
(declare-fun f19 () S7)
(declare-fun f20 () S1)
(declare-fun f21 (S3 S3) S1)
(declare-fun f22 (S3) S3)
(declare-fun f23 (S8 S3) S2)
(declare-fun f24 () S8)
(declare-fun f25 (S11 S9) S2)
(declare-fun f26 (S12 S10) S11)
(declare-fun f27 (S13 S9) S12)
(declare-fun f28 () S13)
(declare-fun f29 (S16 S15) S1)
(declare-fun f30 (S9 S14) S16)
(declare-fun f31 (S17) S4)
(declare-fun f32 (S19 S2) S5)
(declare-fun f33 (S20 S18) S19)
(declare-fun f34 () S20)
(declare-fun f35 () S10)
(declare-fun f36 (S21 S10) S10)
(declare-fun f37 (S22 S10) S21)
(declare-fun f38 () S22)
(declare-fun f39 () S19)
(declare-fun f40 (S23 S2) S4)
(declare-fun f41 (S17) S23)
(declare-fun f42 (S17 S8) S1)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f6 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f7 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 f8 ?v0) f1) false)))
(assert (not (forall ((?v0 S5)) (=> (forall ((?v1 S2)) (=> (= (f6 ?v1 f9) f1) (= (f3 (f10 ?v0) ?v1) f1))) (forall ((?v1 S2)) (=> (= (f6 ?v1 (f4 (f11 f12) f13)) f1) (= (f3 (f10 ?v0) ?v1) f1)))))))
(assert (= (f14 f9 (f4 (f11 f12) f15)) f1))
(assert (forall ((?v0 S5)) (=> (forall ((?v1 S2)) (=> (= (f6 ?v1 f9) f1) (= (f3 (f10 ?v0) ?v1) f1))) (forall ((?v1 S2)) (=> (= (f6 ?v1 (f4 (f11 f12) f15)) f1) (= (f3 (f10 ?v0) ?v1) f1))))))
(assert (= (f14 f9 f13) f1))
(assert (forall ((?v0 S5)) (=> (forall ((?v1 S2)) (=> (= (f6 ?v1 f9) f1) (= (f3 (f10 ?v0) ?v1) f1))) (forall ((?v1 S2)) (=> (= (f6 ?v1 f13) f1) (= (f3 (f10 ?v0) ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (f14 ?v0 f15) f1)))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f14 ?v0 ?v1) f1) (=> (= (f14 ?v2 ?v0) f1) (= (f14 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S3) (?v1 S5)) (=> (forall ((?v2 S2)) (=> (= (f6 ?v2 ?v0) f1) (= (f3 (f10 (f16 f17 (+ (f18 f19 ?v1) 1))) ?v2) f1))) (forall ((?v2 S2)) (=> (= (f6 ?v2 ?v0) f1) (= (f3 (f10 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_0 (f11 ?v1))) (=> (= (f14 ?v0 (f4 ?v_0 f15)) f1) (=> (= (f14 ?v0 ?v2) f1) (= (f14 ?v0 (f4 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 S3) (?v1 S2) (?v2 S3)) (let ((?v_0 (f11 ?v1))) (=> (= (f14 ?v0 (f4 ?v_0 ?v2)) f1) (and (= (f14 ?v0 (f4 ?v_0 f15)) f1) (= (f14 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S2)) (=> (= (f3 (f10 (f16 f17 (+ (f18 f19 ?v0) 1))) ?v1) f1) (= (f3 (f10 ?v0) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (=> (= (f6 ?v0 (f4 (f11 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f6 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (=> (not (= (f6 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f6 ?v0 (f4 (f11 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2)) (=> (= (f6 ?v0 f15) f1) false)))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= f15 (f4 (f11 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= (f4 (f11 ?v0) ?v1) f15))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f6 ?v0 (f4 (f11 ?v1) f15)) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f4 (f11 ?v0) (f4 (f11 ?v1) f15)) (f4 (f11 ?v2) (f4 (f11 ?v3) f15))) (or (and (= ?v0 ?v2) (= ?v1 ?v3)) (and (= ?v0 ?v3) (= ?v1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f6 ?v0 (f4 (f11 ?v1) f15)) f1) (=> (=> (= ?v0 ?v1) false) false))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f4 (f11 ?v0) f15) (f4 (f11 ?v1) f15)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2)) (= (= (f3 f15 ?v0) f1) (= f20 f1))))
(assert (forall ((?v0 S2)) (= (= (f3 f15 ?v0) f1) (= f20 f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f21 ?v0 ?v1) f1) (forall ((?v2 S5)) (=> (forall ((?v3 S2)) (=> (= (f6 ?v3 ?v0) f1) (= (f3 (f10 ?v2) ?v3) f1))) (forall ((?v3 S2)) (=> (= (f6 ?v3 ?v1) f1) (= (f3 (f10 ?v2) ?v3) f1))))))))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= ?v0 f15) (not (= (f6 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S3)) (= (= (f22 ?v0) f15) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2)) (= (= (f6 ?v0 f15) f1) false)))
(assert (forall ((?v0 S3)) (= (= f15 (f22 ?v0)) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (=> (= (f6 ?v1 f15) f1) (= (f3 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (and (= (f6 ?v1 f15) f1) (= (f3 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (= (f6 ?v1 ?v0) f1)) (not (= ?v0 f15)))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (not (= (f6 ?v1 ?v0) f1))) (= ?v0 f15))))
(assert (= f15 (f22 f8)))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f6 ?v0 ?v1) f1) (= (f4 (f11 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (= (f6 ?v0 ?v1) f1) (= (f6 ?v0 (f4 (f11 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f11 ?v0))) (=> (not (= (f6 ?v0 ?v1) f1)) (=> (not (= (f6 ?v0 ?v2) f1)) (= (= (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f4 (f11 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (= (= (f6 ?v0 (f4 (f11 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f6 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (let ((?v_1 (f11 ?v0)) (?v_0 (f11 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f11 ?v0))) (let ((?v_1 (f4 ?v_0 ?v1))) (= (f4 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f4 (f11 ?v0) (f22 ?v1)) (f22 (f4 (f7 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f4 (f11 ?v0) ?v1) (f22 (f4 (f5 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f6 ?v0 (f4 (f11 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S2)) (= (f23 f24 (f4 (f11 ?v0) f15)) ?v0)))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f6 ?v0 ?v1) f1) (=> (forall ((?v2 S3)) (=> (= ?v1 (f4 (f11 ?v0) ?v2)) (=> (not (= (f6 ?v0 ?v2) f1)) false))) false))))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f6 ?v0 ?v1) f1) (exists ((?v2 S3)) (and (= ?v1 (f4 (f11 ?v0) ?v2)) (not (= (f6 ?v0 ?v2) f1)))))))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 S2)) (=> (= (f6 ?v1 ?v0) f1) false)) (= ?v0 f15))))
(assert (forall ((?v0 S3)) (= (not (= ?v0 f15)) (exists ((?v1 S2) (?v2 S3)) (and (= ?v0 (f4 (f11 ?v1) ?v2)) (not (= (f6 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 S2)) (= (= (f3 f15 ?v0) f1) (= (f6 ?v0 f15) f1))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S10) (?v3 S9) (?v4 S9)) (=> (= (f14 ?v0 (f4 (f11 (f25 (f26 (f27 f28 ?v1) ?v2) ?v3)) f15)) f1) (=> (forall ((?v5 S14) (?v6 S15)) (=> (= (f29 (f30 ?v4 ?v5) ?v6) f1) (= (f29 (f30 ?v1 ?v5) ?v6) f1))) (= (f14 ?v0 (f4 (f11 (f25 (f26 (f27 f28 ?v4) ?v2) ?v3)) f15)) f1)))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S10) (?v3 S9) (?v4 S9)) (let ((?v_0 (f26 (f27 f28 ?v1) ?v2))) (=> (= (f14 ?v0 (f4 (f11 (f25 ?v_0 ?v3)) f15)) f1) (=> (forall ((?v5 S14) (?v6 S15)) (=> (= (f29 (f30 ?v3 ?v5) ?v6) f1) (= (f29 (f30 ?v4 ?v5) ?v6) f1))) (= (f14 ?v0 (f4 (f11 (f25 ?v_0 ?v4)) f15)) f1))))))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S10) (?v3 S9) (?v4 S9) (?v5 S9)) (=> (= (f14 ?v0 (f4 (f11 (f25 (f26 (f27 f28 ?v1) ?v2) ?v3)) f15)) f1) (=> (forall ((?v6 S14) (?v7 S15)) (=> (= (f29 (f30 ?v4 ?v6) ?v7) f1) (forall ((?v8 S15)) (=> (forall ((?v9 S14)) (=> (= (f29 (f30 ?v1 ?v9) ?v7) f1) (= (f29 (f30 ?v3 ?v9) ?v8) f1))) (= (f29 (f30 ?v5 ?v6) ?v8) f1))))) (= (f14 ?v0 (f4 (f11 (f25 (f26 (f27 f28 ?v4) ?v2) ?v5)) f15)) f1)))))
(assert (forall ((?v0 S17) (?v1 S2) (?v2 S2)) (= (= (f3 (f4 (f31 ?v0) (f4 (f11 ?v1) f15)) ?v2) f1) (= ?v1 ?v2))))
(assert (forall ((?v0 S9) (?v1 S10) (?v2 S9) (?v3 S9) (?v4 S10) (?v5 S9)) (= (= (f25 (f26 (f27 f28 ?v0) ?v1) ?v2) (f25 (f26 (f27 f28 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 S17) (?v1 S2)) (=> (= (f3 (f4 (f31 ?v0) f15) ?v1) f1) false)))
(assert (forall ((?v0 S17) (?v1 S3) (?v2 S2)) (=> (= (f3 (f4 (f31 ?v0) ?v1) ?v2) f1) (not (= ?v1 f15)))))
(assert (forall ((?v0 S18) (?v1 S9) (?v2 S10) (?v3 S9)) (= (f32 (f33 f34 ?v0) (f25 (f26 (f27 f28 ?v1) ?v2) ?v3)) (f16 f17 0))))
(assert (forall ((?v0 S3) (?v1 S9)) (= (f14 ?v0 (f4 (f11 (f25 (f26 (f27 f28 ?v1) f35) ?v1)) f15)) f1)))
(assert (forall ((?v0 S3) (?v1 S9) (?v2 S10) (?v3 S9) (?v4 S10) (?v5 S9)) (let ((?v_0 (f27 f28 ?v1))) (=> (= (f14 ?v0 (f4 (f11 (f25 (f26 ?v_0 ?v2) ?v3)) f15)) f1) (=> (= (f14 ?v0 (f4 (f11 (f25 (f26 (f27 f28 ?v3) ?v4) ?v5)) f15)) f1) (= (f14 ?v0 (f4 (f11 (f25 (f26 ?v_0 (f36 (f37 f38 ?v2) ?v4)) ?v5)) f15)) f1))))))
(assert (forall ((?v0 S9) (?v1 S10) (?v2 S9)) (= (f32 f39 (f25 (f26 (f27 f28 ?v0) ?v1) ?v2)) (f16 f17 0))))
(assert (forall ((?v0 S2)) (=> (forall ((?v1 S9) (?v2 S10) (?v3 S9)) (=> (= ?v0 (f25 (f26 (f27 f28 ?v1) ?v2) ?v3)) false)) false)))
(assert (forall ((?v0 S9) (?v1 S3) (?v2 S10) (?v3 S9)) (=> (forall ((?v4 S14) (?v5 S15)) (=> (= (f29 (f30 ?v0 ?v4) ?v5) f1) (exists ((?v6 S9) (?v7 S9)) (and (= (f14 ?v1 (f4 (f11 (f25 (f26 (f27 f28 ?v6) ?v2) ?v7)) f15)) f1) (forall ((?v8 S15)) (=> (forall ((?v9 S14)) (=> (= (f29 (f30 ?v6 ?v9) ?v5) f1) (= (f29 (f30 ?v7 ?v9) ?v8) f1))) (= (f29 (f30 ?v3 ?v4) ?v8) f1))))))) (= (f14 ?v1 (f4 (f11 (f25 (f26 (f27 f28 ?v0) ?v2) ?v3)) f15)) f1))))
(assert (forall ((?v0 S10) (?v1 S10)) (not (= f35 (f36 (f37 f38 ?v0) ?v1)))))
(assert (forall ((?v0 S10) (?v1 S10)) (not (= (f36 (f37 f38 ?v0) ?v1) f35))))
(assert (forall ((?v0 S17) (?v1 S2) (?v2 S3) (?v3 S2)) (=> (= (f3 (f4 (f40 (f41 ?v0) ?v1) ?v2) ?v3) f1) (=> (not (= (f6 ?v1 ?v2) f1)) (= (f3 (f4 (f31 ?v0) (f4 (f11 ?v1) ?v2)) ?v3) f1)))))
(assert (forall ((?v0 S10) (?v1 S10) (?v2 S10) (?v3 S10)) (= (= (f36 (f37 f38 ?v0) ?v1) (f36 (f37 f38 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S17) (?v1 S8) (?v2 S2)) (=> (= (f42 ?v0 ?v1) f1) (= (f23 ?v1 (f4 (f11 ?v2) f15)) ?v2))))
(assert (forall ((?v0 S5)) (= (f16 f17 (f18 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f18 f19 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f18 f19 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
