(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S4 S5) S1)
(declare-fun f4 (S6 S3) S4)
(declare-fun f5 () S6)
(declare-fun f6 () S5)
(declare-fun f7 (S5 S3) S1)
(declare-fun f8 (S7 S2) S5)
(declare-fun f9 () S7)
(declare-fun f10 () S5)
(declare-fun f11 (S8 S5) S4)
(declare-fun f12 () S8)
(declare-fun f13 () S5)
(declare-fun f14 () S8)
(declare-fun f15 (S9 Int) S2)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S2) Int)
(declare-fun f18 () S10)
(declare-fun f19 (S11 S1) S1)
(declare-fun f20 (S12 S1) S11)
(declare-fun f21 () S12)
(declare-fun f22 () S8)
(assert (not (= f1 f2)))
(assert (not (forall ((?v0 S2)) (=> (forall ((?v1 S3)) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f7 (f8 f9 ?v0) ?v1) f1))) (forall ((?v1 S3)) (=> (= (f3 (f4 f5 ?v1) f10) f1) (= (f7 (f8 f9 ?v0) ?v1) f1)))))))
(assert (= (f3 (f11 f12 f6) f13) f1))
(assert (forall ((?v0 S2)) (=> (forall ((?v1 S3)) (=> (= (f3 (f4 f5 ?v1) f6) f1) (= (f7 (f8 f9 ?v0) ?v1) f1))) (forall ((?v1 S3)) (=> (= (f3 (f4 f5 ?v1) f13) f1) (= (f7 (f8 f9 ?v0) ?v1) f1))))))
(assert (= (f3 (f11 f14 f10) f13) f1))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f3 (f11 f14 ?v0) ?v1) f1) (= (f3 (f11 f12 ?v1) ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f12 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f11 f14 ?v2) ?v1) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f3 (f11 f12 ?v0) ?v1) f1) (=> (= (f3 (f11 f14 ?v0) ?v2) f1) (= (f3 (f11 f12 ?v2) ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f12 ?v2))) (=> (= (f3 (f11 f12 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S2)) (=> (forall ((?v2 S3)) (=> (= (f3 (f4 f5 ?v2) ?v0) f1) (= (f7 (f8 f9 (f15 f16 (+ (f17 f18 ?v1) 1))) ?v2) f1))) (forall ((?v2 S3)) (=> (= (f3 (f4 f5 ?v2) ?v0) f1) (= (f7 (f8 f9 ?v1) ?v2) f1))))))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f7 (f8 f9 (f15 f16 (+ (f17 f18 ?v0) 1))) ?v1) f1) (= (f7 (f8 f9 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3)) (let ((?v_0 (f4 f5 ?v2))) (=> (= (f3 (f11 f14 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f3 (f11 f14 ?v0) ?v1) f1) (=> (= (f3 (f11 f14 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S1)) (= (f19 (f20 f21 ?v0) ?v0) f1)))
(assert (forall ((?v0 S5)) (= (f3 (f11 f14 ?v0) ?v0) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f3 (f11 f14 ?v0) ?v1) f1) (forall ((?v2 S3)) (= (f19 (f20 f21 (f7 ?v0 ?v2)) (f7 ?v1 ?v2)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3)) (=> (= (f3 (f11 f14 ?v0) ?v1) f1) (= (f19 (f20 f21 (f7 ?v0 ?v2)) (f7 ?v1 ?v2)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3)) (=> (= (f3 (f11 f14 ?v0) ?v1) f1) (=> (=> (= (f19 (f20 f21 (f7 ?v0 ?v2)) (f7 ?v1 ?v2)) f1) false) false))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f3 (f11 f22 ?v0) ?v1) f1) (forall ((?v2 S2)) (=> (forall ((?v3 S3)) (=> (= (f3 (f4 f5 ?v3) ?v0) f1) (= (f7 (f8 f9 ?v2) ?v3) f1))) (forall ((?v3 S3)) (=> (= (f3 (f4 f5 ?v3) ?v1) f1) (= (f7 (f8 f9 ?v2) ?v3) f1))))))))
(assert (forall ((?v0 S5)) (= (f3 (f11 f14 ?v0) ?v0) f1)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (and (= (f3 (f11 f14 ?v0) ?v1) f1) (= (f3 (f11 f14 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S5) (?v1 S3) (?v2 S5)) (=> (= (f7 ?v0 ?v1) f1) (=> (= (f3 (f11 f14 ?v0) ?v2) f1) (= (f7 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 ?v1) (= (f3 (f11 f14 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 ?v1) (= (f3 (f11 f14 ?v1) ?v0) f1))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f20 f21 ?v2))) (=> (= (f19 (f20 f21 ?v0) ?v1) f1) (=> (= (f19 ?v_0 ?v0) f1) (= (f19 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v2))) (=> (= (f3 (f11 f14 ?v0) ?v1) f1) (=> (= (f3 ?v_0 ?v0) f1) (= (f3 ?v_0 ?v1) f1))))))
(assert (forall ((?v0 S1) (?v1 S1)) (=> (= (f19 (f20 f21 ?v0) ?v1) f1) (=> (= (f19 (f20 f21 ?v1) ?v0) f1) (= (= ?v1 f1) (= ?v0 f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f3 (f11 f14 ?v0) ?v1) f1) (=> (= (f3 (f11 f14 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f19 ?v_0 ?v1) f1) (=> (= (f19 (f20 f21 ?v1) ?v2) f1) (= (f19 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= (f3 (f11 f14 ?v1) ?v2) f1) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S1) (?v1 S1)) (=> (= (f19 (f20 f21 ?v0) ?v1) f1) (=> (= (f19 (f20 f21 ?v1) ?v0) f1) (= (= ?v0 f1) (= ?v1 f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f3 (f11 f14 ?v0) ?v1) f1) (=> (= (f3 (f11 f14 ?v1) ?v0) f1) (= ?v0 ?v1)))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (=> (= (f19 (f20 f21 ?v0) ?v1) f1) (=> (= (= ?v0 f1) (= ?v2 f1)) (= (f19 (f20 f21 ?v2) ?v1) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= (f3 (f11 f14 ?v0) ?v1) f1) (=> (= ?v0 ?v2) (= (f3 (f11 f14 ?v2) ?v1) f1)))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f20 f21 ?v0))) (=> (= (f19 ?v_0 ?v1) f1) (=> (= (= ?v1 f1) (= ?v2 f1)) (= (f19 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v0))) (=> (= (f3 ?v_0 ?v1) f1) (=> (= ?v1 ?v2) (= (f3 ?v_0 ?v2) f1))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (let ((?v_0 (f20 f21 ?v2))) (=> (= (= ?v0 f1) (= ?v1 f1)) (=> (= (f19 ?v_0 ?v1) f1) (= (f19 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f11 f14 ?v2))) (=> (= ?v0 ?v1) (=> (= (f3 ?v_0 ?v1) f1) (= (f3 ?v_0 ?v0) f1))))))
(assert (forall ((?v0 S1) (?v1 S1) (?v2 S1)) (=> (= (= ?v0 f1) (= ?v1 f1)) (=> (= (f19 (f20 f21 ?v1) ?v2) f1) (= (f19 (f20 f21 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (=> (= ?v0 ?v1) (=> (= (f3 (f11 f14 ?v1) ?v2) f1) (= (f3 (f11 f14 ?v0) ?v2) f1)))))
(assert (forall ((?v0 S1) (?v1 S1)) (=> (= (f19 (f20 f21 ?v0) ?v1) f1) (= (= (f19 (f20 f21 ?v1) ?v0) f1) (= (= ?v1 f1) (= ?v0 f1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f3 (f11 f14 ?v0) ?v1) f1) (= (= (f3 (f11 f14 ?v1) ?v0) f1) (= ?v1 ?v0)))))
(assert (forall ((?v0 S1) (?v1 S1)) (=> (= (= ?v0 f1) (= ?v1 f1)) (= (f19 (f20 f21 ?v0) ?v1) f1))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= ?v0 ?v1) (= (f3 (f11 f14 ?v0) ?v1) f1))))
(assert (forall ((?v0 S1) (?v1 S1)) (= (= (= ?v0 f1) (= ?v1 f1)) (and (= (f19 (f20 f21 ?v0) ?v1) f1) (= (f19 (f20 f21 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= ?v0 ?v1) (and (= (f3 (f11 f14 ?v0) ?v1) f1) (= (f3 (f11 f14 ?v1) ?v0) f1)))))
(assert (forall ((?v0 S2)) (= (f15 f16 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
