(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) S1)
(declare-fun f4 (S4 S3) S2)
(declare-fun f5 (S5) S4)
(declare-fun f6 () S5)
(declare-fun f7 () S3)
(declare-fun f8 () S3)
(declare-fun f9 () S1)
(declare-fun f10 (S6 S3) S3)
(declare-fun f11 (S7 S3) S6)
(declare-fun f12 () S7)
(declare-fun f13 () S5)
(declare-fun f14 (S8 S5) S5)
(declare-fun f15 (S9 S5) S8)
(declare-fun f16 () S9)
(declare-fun f17 (S10 S2) S9)
(declare-fun f18 () S10)
(declare-fun f19 (S11 S2) S8)
(declare-fun f20 () S11)
(declare-fun f21 (S12 S5) S13)
(declare-fun f22 () S12)
(declare-fun f23 (S14 Int) S13)
(declare-fun f24 () S14)
(declare-fun f25 (S15 S13) Int)
(declare-fun f26 () S15)
(declare-fun f27 () S12)
(declare-fun f28 (S5) S1)
(declare-fun f29 (S18 S17) S5)
(declare-fun f30 (S19 S16) S18)
(declare-fun f31 () S19)
(declare-fun f32 (S21 S17) S8)
(declare-fun f33 (S22 S20) S21)
(declare-fun f34 () S22)
(declare-fun f35 (S23 S13) S2)
(declare-fun f36 (S24 S3) S23)
(declare-fun f37 (S5) S24)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6) f7) f8) f1)))
(assert (= f9 f1))
(assert (forall ((?v0 S3)) (=> (forall ((?v1 S3)) (=> (= (f3 (f4 (f5 f6) f7) ?v1) f1) (= ?v0 ?v1))) (= ?v0 f8))))
(assert (exists ((?v0 S3)) (= (f3 (f4 (f5 f6) (f10 (f11 f12 f7) f8)) ?v0) f1)))
(assert (= (= f9 f1) (exists ((?v0 S3) (?v1 S3)) (not (= ?v0 ?v1)))))
(assert (=> (= f9 f1) (forall ((?v0 S3)) (=> (forall ((?v1 S3)) (= ?v1 ?v0)) false))))
(assert (forall ((?v0 S5) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f4 (f5 ?v0) ?v1))) (=> (= (f3 ?v_0 ?v2) f1) (=> (= (f3 ?v_0 ?v3) f1) (= ?v3 ?v2))))))
(assert (forall ((?v0 S3)) (= (f3 (f4 (f5 f13) ?v0) ?v0) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f3 (f4 (f5 f13) ?v0) ?v1) f1) (=> (=> (= ?v1 ?v0) false) false))))
(assert (forall ((?v0 S5) (?v1 S3) (?v2 S3) (?v3 S5) (?v4 S3)) (=> (= (f3 (f4 (f5 ?v0) ?v1) ?v2) f1) (=> (= (f3 (f4 (f5 ?v3) ?v2) ?v4) f1) (= (f3 (f4 (f5 (f14 (f15 f16 ?v0) ?v3)) ?v1) ?v4) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S3) (?v4 S5)) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 (f4 (f5 ?v2) ?v1) ?v3) f1) (= (f3 (f4 (f5 (f14 (f15 (f17 f18 ?v0) ?v4) ?v2)) ?v1) ?v3) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S3) (?v4 S5)) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 (f4 (f5 ?v2) ?v1) ?v3) f1) (= (f3 (f4 (f5 (f14 (f15 (f17 f18 ?v0) ?v2) ?v4)) ?v1) ?v3) f1)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5) (?v3 S3) (?v4 S3)) (let ((?v_0 (= (f3 ?v0 ?v3) f1))) (=> (= (f3 (f4 (f5 (f14 (f15 (f17 f18 ?v0) ?v1) ?v2)) ?v3) ?v4) f1) (=> (=> ?v_0 (=> (= (f3 (f4 (f5 ?v1) ?v3) ?v4) f1) false)) (=> (=> (not ?v_0) (=> (= (f3 (f4 (f5 ?v2) ?v3) ?v4) f1) false)) false))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5)) (=> (not (= (f3 ?v0 ?v1) f1)) (= (f3 (f4 (f5 (f14 (f19 f20 ?v0) ?v2)) ?v1) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S3) (?v4 S3)) (let ((?v_0 (f5 (f14 (f19 f20 ?v0) ?v2)))) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 (f4 (f5 ?v2) ?v1) ?v3) f1) (=> (= (f3 (f4 ?v_0 ?v3) ?v4) f1) (= (f3 (f4 ?v_0 ?v1) ?v4) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 (f5 (f14 (f15 f16 ?v0) ?v1)) ?v2) ?v3) f1) (=> (forall ((?v4 S3)) (=> (= (f3 (f4 (f5 ?v0) ?v2) ?v4) f1) (=> (= (f3 (f4 (f5 ?v1) ?v4) ?v3) f1) false))) false))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S3) (?v3 S3)) (=> (= (f3 (f4 (f5 (f14 (f19 f20 ?v0) ?v1)) ?v2) ?v3) f1) (=> (=> (= ?v3 ?v2) (=> (not (= (f3 ?v0 ?v2) f1)) false)) (=> (forall ((?v4 S3)) (=> (= (f3 ?v0 ?v2) f1) (=> (= (f3 (f4 (f5 ?v1) ?v2) ?v4) f1) (=> (= (f3 (f4 (f5 (f14 (f19 f20 ?v0) ?v1)) ?v4) ?v3) f1) false)))) false)))))
(assert (forall ((?v0 S5) (?v1 S5)) (not (= f13 (f14 (f15 f16 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (not (= (f14 (f15 f16 ?v0) ?v1) f13))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (not (= f13 (f14 (f15 (f17 f18 ?v0) ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (not (= (f14 (f15 (f17 f18 ?v0) ?v1) ?v2) f13))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2) (?v3 S5) (?v4 S5)) (not (= (f14 (f15 f16 ?v0) ?v1) (f14 (f15 (f17 f18 ?v2) ?v3) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5) (?v3 S5) (?v4 S5)) (not (= (f14 (f15 (f17 f18 ?v0) ?v1) ?v2) (f14 (f15 f16 ?v3) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S5)) (not (= f13 (f14 (f19 f20 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S5)) (not (= (f14 (f19 f20 ?v0) ?v1) f13))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2) (?v3 S5)) (not (= (f14 (f15 f16 ?v0) ?v1) (f14 (f19 f20 ?v2) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5) (?v3 S5)) (not (= (f14 (f19 f20 ?v0) ?v1) (f14 (f15 f16 ?v2) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S2) (?v3 S5)) (= (= (f14 (f19 f20 ?v0) ?v1) (f14 (f19 f20 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5) (?v3 S2) (?v4 S5) (?v5 S5)) (= (= (f14 (f15 (f17 f18 ?v0) ?v1) ?v2) (f14 (f15 (f17 f18 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (= (= (f14 (f15 f16 ?v0) ?v1) (f14 (f15 f16 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5) (?v3 S2) (?v4 S5)) (not (= (f14 (f15 (f17 f18 ?v0) ?v1) ?v2) (f14 (f19 f20 ?v3) ?v4)))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S2) (?v3 S5) (?v4 S5)) (not (= (f14 (f19 f20 ?v0) ?v1) (f14 (f15 (f17 f18 ?v2) ?v3) ?v4)))))
(assert (= (f21 f22 f13) (f23 f24 0)))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f21 f22 (f14 (f15 f16 ?v0) ?v1)) (f23 f24 (+ (+ (f25 f26 (f21 f22 ?v0)) (f25 f26 (f21 f22 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (= (f21 f22 (f14 (f15 (f17 f18 ?v0) ?v1) ?v2)) (f23 f24 (+ (+ (f25 f26 (f21 f22 ?v1)) (f25 f26 (f21 f22 ?v2))) (+ 0 1))))))
(assert (= (f21 f27 f13) (f23 f24 0)))
(assert (forall ((?v0 S2) (?v1 S5)) (= (f21 f22 (f14 (f19 f20 ?v0) ?v1)) (f23 f24 (+ (f25 f26 (f21 f22 ?v1)) (+ 0 1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f21 f27 (f14 (f15 f16 ?v0) ?v1)) (f23 f24 (+ (+ (f25 f26 (f21 f27 ?v0)) (f25 f26 (f21 f27 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S5)) (= (f21 f27 (f14 (f19 f20 ?v0) ?v1)) (f23 f24 (+ (f25 f26 (f21 f27 ?v1)) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (= (f21 f27 (f14 (f15 (f17 f18 ?v0) ?v1) ?v2)) (f23 f24 (+ (+ (f25 f26 (f21 f27 ?v1)) (f25 f26 (f21 f27 ?v2))) (+ 0 1))))))
(assert (=> (= (f28 f13) f1) (=> false false)))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f28 (f14 (f15 f16 ?v0) ?v1)) f1) (=> (=> (= (f28 ?v0) f1) (=> (= (f28 ?v1) f1) false)) false))))
(assert (forall ((?v0 S2) (?v1 S5) (?v2 S5)) (=> (= (f28 (f14 (f15 (f17 f18 ?v0) ?v1) ?v2)) f1) (=> (=> (= (f28 ?v1) f1) (=> (= (f28 ?v2) f1) false)) false))))
(assert (forall ((?v0 S2) (?v1 S5)) (=> (= (f28 (f14 (f19 f20 ?v0) ?v1)) f1) (=> (=> (= (f28 ?v1) f1) false) false))))
(assert (forall ((?v0 S5) (?v1 S2)) (=> (= (f28 ?v0) f1) (= (f28 (f14 (f19 f20 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S2)) (=> (= (f28 ?v0) f1) (=> (= (f28 ?v1) f1) (= (f28 (f14 (f15 (f17 f18 ?v2) ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (=> (= (f28 ?v0) f1) (=> (= (f28 ?v1) f1) (= (f28 (f14 (f15 f16 ?v0) ?v1)) f1)))))
(assert (= (f28 f13) f1))
(assert (forall ((?v0 S16) (?v1 S17)) (=> (= (f28 (f29 (f30 f31 ?v0) ?v1)) f1) (=> false false))))
(assert (forall ((?v0 S20) (?v1 S17) (?v2 S5)) (=> (= (f28 (f14 (f32 (f33 f34 ?v0) ?v1) ?v2)) f1) (=> (=> (= (f28 ?v2) f1) false) false))))
(assert (forall ((?v0 S3) (?v1 S13) (?v2 S3)) (=> (= (f3 (f35 (f36 (f37 f13) ?v0) ?v1) ?v2) f1) (=> (=> (= ?v2 ?v0) false) false))))
(assert (forall ((?v0 S3) (?v1 S13)) (= (f3 (f35 (f36 (f37 f13) ?v0) ?v1) ?v0) f1)))
(assert (forall ((?v0 S5) (?v1 S3) (?v2 S13) (?v3 S3) (?v4 S5) (?v5 S3)) (=> (= (f3 (f35 (f36 (f37 ?v0) ?v1) ?v2) ?v3) f1) (=> (= (f3 (f35 (f36 (f37 ?v4) ?v3) ?v2) ?v5) f1) (= (f3 (f35 (f36 (f37 (f14 (f15 f16 ?v0) ?v4)) ?v1) ?v2) ?v5) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S13)) (=> (not (= (f3 ?v0 ?v1) f1)) (= (f3 (f35 (f36 (f37 (f14 (f19 f20 ?v0) ?v2)) ?v1) ?v3) ?v1) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S13) (?v4 S3) (?v5 S3)) (let ((?v_0 (f37 (f14 (f19 f20 ?v0) ?v2)))) (=> (= (f3 ?v0 ?v1) f1) (=> (= (f3 (f35 (f36 (f37 ?v2) ?v1) ?v3) ?v4) f1) (=> (= (f3 (f35 (f36 ?v_0 ?v4) ?v3) ?v5) f1) (= (f3 (f35 (f36 ?v_0 ?v1) ?v3) ?v5) f1)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S5) (?v3 S13) (?v4 S3) (?v5 S5)) (=> (not (= (f3 ?v0 ?v1) f1)) (=> (= (f3 (f35 (f36 (f37 ?v2) ?v1) ?v3) ?v4) f1) (= (f3 (f35 (f36 (f37 (f14 (f15 (f17 f18 ?v0) ?v5) ?v2)) ?v1) ?v3) ?v4) f1)))))
(assert (forall ((?v0 S13)) (= (f23 f24 (f25 f26 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f25 f26 (f23 f24 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f25 f26 (f23 f24 ?v0)) 0))))
(check-sat)
(exit)
