(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () S2)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 (S5) S3)
(declare-fun f6 () S5)
(declare-fun f7 () S4)
(declare-fun f8 (S4) S1)
(declare-fun f9 (S2 S2) S1)
(declare-fun f10 (S6 S2) S7)
(declare-fun f11 () S6)
(declare-fun f12 (S8) S1)
(declare-fun f13 () S8)
(declare-fun f14 (S2) S1)
(declare-fun f15 (S10 S2) S4)
(declare-fun f16 (S9) S10)
(declare-fun f17 (S11 S7) Int)
(declare-fun f18 () S11)
(declare-fun f19 (S4 S4) S1)
(declare-fun f20 (S12 S4) S7)
(declare-fun f21 () S12)
(declare-fun f22 (S13 Int) S7)
(declare-fun f23 () S13)
(assert (not (= f1 f2)))
(assert (not (= f3 (f4 (f5 f6) f7))))
(assert (= (f8 f7) f1))
(assert (= (f9 f3 (f4 (f5 f6) f7)) f1))
(assert (= (f10 f11 f3) (f10 f11 (f4 (f5 f6) f7))))
(assert (= (f12 f13) f1))
(assert (forall ((?v0 S4) (?v1 S5)) (=> (= (f8 ?v0) f1) (= (f14 (f4 (f5 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S9)) (=> (= (f14 ?v0) f1) (= (f8 (f15 (f16 ?v1) ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f14 ?v0) f1) (=> (= (f9 ?v1 ?v0) f1) (=> (<= (f17 f18 (f10 f11 ?v0)) (f17 f18 (f10 f11 ?v1))) (= ?v1 ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4)) (=> (= (f8 ?v0) f1) (=> (= (f19 ?v1 ?v0) f1) (=> (<= (f17 f18 (f20 f21 ?v0)) (f17 f18 (f20 f21 ?v1))) (= ?v1 ?v0))))))
(assert (forall ((?v0 S7)) (= (f22 f23 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f22 f23 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f22 f23 ?v0)) 0))))
(check-sat)
(exit)
