(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S3 S2) S2)
(declare-fun f5 () S3)
(declare-fun f6 () S2)
(declare-fun f7 () S3)
(declare-fun f8 (S4 S2) S3)
(declare-fun f9 () S4)
(declare-fun f10 () S4)
(declare-fun f11 (S2) S1)
(declare-fun f12 () S3)
(declare-fun f13 (S6 S5) S2)
(declare-fun f14 () S6)
(declare-fun f15 () S2)
(declare-fun f16 () S2)
(declare-fun f17 () S4)
(declare-fun f18 () S4)
(declare-fun f19 () S3)
(declare-fun f20 (S2 S7) S1)
(declare-fun f21 (S7 S2) S1)
(declare-fun f22 (S9 S8) S2)
(declare-fun f23 () S9)
(declare-fun f24 (S10 S8) S3)
(declare-fun f25 (S11 S4) S10)
(declare-fun f26 () S11)
(declare-fun f27 (S12 S2) S13)
(declare-fun f28 () S12)
(declare-fun f29 (S14 Int) S13)
(declare-fun f30 () S14)
(declare-fun f31 (S15 S13) Int)
(declare-fun f32 () S15)
(declare-fun f33 () S9)
(declare-fun f34 (S8) S7)
(declare-fun f35 (S17 S16) S12)
(declare-fun f36 () S17)
(declare-fun f37 (S16 S5) S13)
(declare-fun f38 (S2) S18)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 f6)) f1)))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f7 ?v0)) f1) (= (f3 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (f4 (f8 f9 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (f4 (f8 f10 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f11 ?v0) f1) (= (f3 ?v0) f1))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f12 ?v0)) f1) false)))
(assert (forall ((?v0 S5)) (= (= (f3 (f13 f14 ?v0)) f1) true)))
(assert (= (= (f3 f15) f1) true))
(assert (= (= (f3 f16) f1) true))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 (f8 f17 ?v0) ?v1)) f1) (and (= (f3 ?v0) f1) (= (f3 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f4 (f8 f18 ?v0) ?v1)) f1) (and (= (f3 ?v0) f1) (= (f3 ?v1) f1)))))
(assert (forall ((?v0 S2)) (= (= (f3 (f4 f19 ?v0)) f1) (= (f3 ?v0) f1))))
(assert (not (= f15 f16)))
(assert (not (= f16 f15)))
(assert (forall ((?v0 S2)) (not (= f15 (f4 f12 ?v0)))))
(assert (forall ((?v0 S2)) (not (= f15 (f4 f19 ?v0)))))
(assert (forall ((?v0 S5)) (not (= f15 (f13 f14 ?v0)))))
(assert (forall ((?v0 S2)) (not (= f16 (f4 f12 ?v0)))))
(assert (forall ((?v0 S2)) (not (= f16 (f4 f19 ?v0)))))
(assert (forall ((?v0 S5)) (not (= f16 (f13 f14 ?v0)))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= f15 (f4 (f8 f18 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= f15 (f4 (f8 f17 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= f16 (f4 (f8 f18 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= f16 (f4 (f8 f17 ?v0) ?v1)))))
(assert (forall ((?v0 S2)) (not (= (f4 f12 ?v0) f15))))
(assert (forall ((?v0 S2)) (not (= (f4 f12 ?v0) f16))))
(assert (forall ((?v0 S2)) (not (= (f4 f19 ?v0) f15))))
(assert (forall ((?v0 S2)) (not (= (f4 f19 ?v0) f16))))
(assert (forall ((?v0 S5)) (not (= (f13 f14 ?v0) f15))))
(assert (forall ((?v0 S5)) (not (= (f13 f14 ?v0) f16))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= (f4 f12 ?v0) (f4 f19 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S5)) (not (= (f4 f12 ?v0) (f13 f14 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= (f4 f19 ?v0) (f4 f12 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S5)) (not (= (f4 f19 ?v0) (f13 f14 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S2)) (not (= (f13 f14 ?v0) (f4 f12 ?v1)))))
(assert (forall ((?v0 S5) (?v1 S2)) (not (= (f13 f14 ?v0) (f4 f19 ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f4 f12 ?v0) (f4 (f8 f18 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f4 f12 ?v0) (f4 (f8 f17 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f4 f19 ?v0) (f4 (f8 f18 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f4 f19 ?v0) (f4 (f8 f17 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S2)) (not (= (f13 f14 ?v0) (f4 (f8 f18 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S2) (?v2 S2)) (not (= (f13 f14 ?v0) (f4 (f8 f17 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= (f4 (f8 f18 ?v0) ?v1) f15))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= (f4 (f8 f18 ?v0) ?v1) f16))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= (f4 (f8 f17 ?v0) ?v1) f15))))
(assert (forall ((?v0 S2) (?v1 S2)) (not (= (f4 (f8 f17 ?v0) ?v1) f16))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f4 (f8 f18 ?v0) ?v1) (f4 f12 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f4 (f8 f18 ?v0) ?v1) (f4 f19 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5)) (not (= (f4 (f8 f18 ?v0) ?v1) (f13 f14 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f4 (f8 f17 ?v0) ?v1) (f4 f12 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2)) (not (= (f4 (f8 f17 ?v0) ?v1) (f4 f19 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S5)) (not (= (f4 (f8 f17 ?v0) ?v1) (f13 f14 ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (not (= (f4 (f8 f18 ?v0) ?v1) (f4 (f8 f17 ?v2) ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (not (= (f4 (f8 f17 ?v0) ?v1) (f4 (f8 f18 ?v2) ?v3)))))
(assert (= (= (f11 f15) f1) true))
(assert (= (= (f11 f16) f1) true))
(assert (forall ((?v0 S2)) (= (f4 f7 ?v0) (ite (= ?v0 f15) f16 (ite (= ?v0 f16) f15 (f4 f19 ?v0))))))
(assert (forall ((?v0 S2)) (= (= (f11 (f4 f12 ?v0)) f1) false)))
(assert (forall ((?v0 S2)) (= (= (f11 (f4 f19 ?v0)) f1) false)))
(assert (forall ((?v0 S5)) (= (= (f11 (f13 f14 ?v0)) f1) true)))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f11 (f4 (f8 f18 ?v0) ?v1)) f1) (and (= (f11 ?v0) f1) (= (f11 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f11 (f4 (f8 f17 ?v0) ?v1)) f1) (and (= (f11 ?v0) f1) (= (f11 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f8 f9 ?v0) ?v1) (ite (= ?v0 f16) ?v1 (ite (= ?v1 f16) ?v0 (ite (or (= ?v0 f15) (= ?v1 f15)) f15 (f4 (f8 f18 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f4 (f8 f10 ?v0) ?v1) (ite (= ?v0 f15) ?v1 (ite (= ?v1 f15) ?v0 (ite (or (= ?v0 f16) (= ?v1 f16)) f16 (f4 (f8 f17 ?v0) ?v1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 f12 ?v0) (f4 f12 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f4 f19 ?v0) (f4 f19 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (= (f13 f14 ?v0) (f13 f14 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S7)) (= (= (f20 ?v0 ?v1) f1) (= (f21 ?v1 ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f4 (f8 f18 ?v0) ?v1) (f4 (f8 f18 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f4 (f8 f17 ?v0) ?v1) (f4 (f8 f17 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S2)) (=> (=> (= ?v0 f15) false) (=> (=> (= ?v0 f16) false) (=> (forall ((?v1 S5)) (=> (= ?v0 (f13 f14 ?v1)) false)) (=> (forall ((?v1 S2) (?v2 S2)) (=> (= ?v0 (f4 (f8 f17 ?v1) ?v2)) false)) (=> (forall ((?v1 S2) (?v2 S2)) (=> (= ?v0 (f4 (f8 f18 ?v1) ?v2)) false)) (=> (forall ((?v1 S2)) (=> (= ?v0 (f4 f19 ?v1)) false)) (=> (forall ((?v1 S2)) (=> (= ?v0 (f4 f12 ?v1)) false)) false)))))))))
(assert (forall ((?v0 S8)) (= (f22 f23 ?v0) (f4 (f24 (f25 f26 f10) ?v0) f15))))
(assert (forall ((?v0 S2)) (= (f27 f28 (f4 f12 ?v0)) (f29 f30 (+ (f31 f32 (f27 f28 ?v0)) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f27 f28 (f4 (f8 f17 ?v0) ?v1)) (f29 f30 (+ (+ (f31 f32 (f27 f28 ?v0)) (f31 f32 (f27 f28 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f27 f28 (f4 (f8 f18 ?v0) ?v1)) (f29 f30 (+ (+ (f31 f32 (f27 f28 ?v0)) (f31 f32 (f27 f28 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S5)) (= (f27 f28 (f13 f14 ?v0)) (f29 f30 0))))
(assert (forall ((?v0 S2)) (= (f27 f28 (f4 f19 ?v0)) (f29 f30 (+ (f31 f32 (f27 f28 ?v0)) (+ 0 1))))))
(assert (= (f27 f28 f15) (f29 f30 0)))
(assert (= (f27 f28 f16) (f29 f30 0)))
(assert (forall ((?v0 S8)) (= (f22 f33 ?v0) (f4 (f24 (f25 f26 f9) ?v0) f16))))
(assert (forall ((?v0 S8) (?v1 S2)) (= (= (f3 (f4 (f24 (f25 f26 f18) ?v0) ?v1)) f1) (and (= (f3 ?v1) f1) (forall ((?v2 S2)) (=> (= (f20 ?v2 (f34 ?v0)) f1) (= (f3 ?v2) f1)))))))
(assert (forall ((?v0 S8)) (=> (forall ((?v1 S2)) (=> (= (f20 ?v1 (f34 ?v0)) f1) (= (f3 ?v1) f1))) (= (f3 (f22 f23 ?v0)) f1))))
(assert (forall ((?v0 S16) (?v1 S2)) (let ((?v_0 (f35 f36 ?v0))) (= (f27 ?v_0 (f4 f12 ?v1)) (f29 f30 (+ (f31 f32 (f27 ?v_0 ?v1)) (+ 0 1)))))))
(assert (forall ((?v0 S16) (?v1 S2)) (let ((?v_0 (f35 f36 ?v0))) (= (f27 ?v_0 (f4 f19 ?v1)) (f29 f30 (+ (f31 f32 (f27 ?v_0 ?v1)) (+ 0 1)))))))
(assert (forall ((?v0 S16)) (= (f27 (f35 f36 ?v0) f16) (f29 f30 0))))
(assert (forall ((?v0 S16)) (= (f27 (f35 f36 ?v0) f15) (f29 f30 0))))
(assert (forall ((?v0 S16) (?v1 S5)) (= (f27 (f35 f36 ?v0) (f13 f14 ?v1)) (f29 f30 (+ (f31 f32 (f37 ?v0 ?v1)) (+ 0 1))))))
(assert (forall ((?v0 S16) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f36 ?v0))) (= (f27 ?v_0 (f4 (f8 f18 ?v1) ?v2)) (f29 f30 (+ (+ (f31 f32 (f27 ?v_0 ?v1)) (f31 f32 (f27 ?v_0 ?v2))) (+ 0 1)))))))
(assert (forall ((?v0 S16) (?v1 S2) (?v2 S2)) (let ((?v_0 (f35 f36 ?v0))) (= (f27 ?v_0 (f4 (f8 f17 ?v1) ?v2)) (f29 f30 (+ (+ (f31 f32 (f27 ?v_0 ?v1)) (f31 f32 (f27 ?v_0 ?v2))) (+ 0 1)))))))
(assert (forall ((?v0 S8)) (=> (forall ((?v1 S2)) (=> (= (f20 ?v1 (f34 ?v0)) f1) (= (f3 ?v1) f1))) (= (f3 (f22 f33 ?v0)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S8) (?v3 S8) (?v4 S4) (?v5 S4)) (=> (= ?v0 ?v1) (=> (= ?v2 ?v3) (=> (forall ((?v6 S2) (?v7 S2)) (=> (= (f20 ?v7 (f34 ?v2)) f1) (= (f4 (f8 ?v4 ?v7) ?v6) (f4 (f8 ?v5 ?v7) ?v6)))) (= (f4 (f24 (f25 f26 ?v4) ?v2) ?v0) (f4 (f24 (f25 f26 ?v5) ?v3) ?v1)))))))
(assert (forall ((?v0 S7) (?v1 S2) (?v2 S8) (?v3 S7) (?v4 S4)) (=> (= (f21 ?v0 ?v1) f1) (=> (forall ((?v5 S2)) (=> (= (f20 ?v5 (f34 ?v2)) f1) (= (f21 ?v3 ?v5) f1))) (=> (forall ((?v5 S2) (?v6 S2)) (=> (and (= (f21 ?v3 ?v5) f1) (= (f21 ?v0 ?v6) f1)) (= (f21 ?v0 (f4 (f8 ?v4 ?v5) ?v6)) f1))) (= (f21 ?v0 (f4 (f24 (f25 f26 ?v4) ?v2) ?v1)) f1))))))
(assert (forall ((?v0 S2)) (= (f38 (f4 f12 ?v0)) (f38 ?v0))))
(assert (forall ((?v0 S13)) (= (f29 f30 (f31 f32 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f31 f32 (f29 f30 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f31 f32 (f29 f30 ?v0)) 0))))
(check-sat)
(exit)
