(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-sort S24 0)
(declare-sort S25 0)
(declare-sort S26 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 (S4 Int) S3)
(declare-fun f5 (S5 Int) S4)
(declare-fun f6 () S5)
(declare-fun f7 (S6 S2) Int)
(declare-fun f8 (S7 Int) S6)
(declare-fun f9 () S7)
(declare-fun f10 () S4)
(declare-fun f11 (S8 Int) Int)
(declare-fun f12 (S9 Int) S8)
(declare-fun f13 () S9)
(declare-fun f14 () Int)
(declare-fun f15 (S10 S2) S6)
(declare-fun f16 () S10)
(declare-fun f17 () S2)
(declare-fun f18 () S2)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () S2)
(declare-fun f22 (S11 S2) S2)
(declare-fun f23 (S12 Int) S11)
(declare-fun f24 () S12)
(declare-fun f25 (S13 S14) Int)
(declare-fun f26 () S13)
(declare-fun f27 () S14)
(declare-fun f28 () Int)
(declare-fun f29 () S13)
(declare-fun f30 (Int Int S2) S14)
(declare-fun f31 (S17 S15) S15)
(declare-fun f32 (S18 S16) S17)
(declare-fun f33 () S18)
(declare-fun f34 (S20 S19) S19)
(declare-fun f35 (S21 S15) S20)
(declare-fun f36 () S21)
(declare-fun f37 () S9)
(declare-fun f38 (S4 S5 S5 S14) S1)
(declare-fun f39 (S22 S7) S6)
(declare-fun f40 (S23 Int) S22)
(declare-fun f41 () S23)
(declare-fun f42 (Int) S1)
(declare-fun f43 (Int) S1)
(declare-fun f44 (S25 S24) Int)
(declare-fun f45 () S25)
(declare-fun f46 (S26 Int) S24)
(declare-fun f47 () S26)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (= (f3 (f4 (f5 f6 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (f7 (f8 f9 ?v0) ?v1) ?v0)))
(assert (forall ((?v0 Int) (?v1 S2)) (= (= (f3 (f4 f10 ?v0) ?v1) f1) false)))
(assert (let ((?v_0 (f7 (f15 f16 f17) f18))) (not (= (f11 (f12 f13 (+ f14 ?v_0)) f19) (f11 (f12 f13 (+ (f11 (f12 f13 f14) f19) (f11 (f12 f13 ?v_0) f19))) f19)))))
(assert (let ((?v_0 (+ f14 (f7 (f15 f16 f17) f18)))) (= (f11 (f12 f13 (+ f20 ?v_0)) f19) (f11 (f12 f13 (+ (f11 (f12 f13 f20) f19) (f11 (f12 f13 ?v_0) f19))) f19))))
(assert (= f21 (f22 (f23 f24 1) f17)))
(assert (let ((?v_0 (f25 f26 f27))) (= (f11 (f12 f13 f14) ?v_0) (f11 (f12 f13 f28) ?v_0))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) 2))) (= (not (= ?v_0 0)) (= ?v_0 1)))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) (- 1)) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 ?v0) (- ?v1)) (- (f11 (f12 f13 (- ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 ?v0))) (let ((?v_1 (f11 ?v_0 ?v1))) (= (f11 ?v_0 (- ?v1)) (ite (= ?v_1 0) 0 (- ?v_1 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v1))) (= (f11 (f12 f13 (- ?v0)) ?v1) (ite (= ?v_0 0) 0 (- ?v1 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 (- ?v0)) (- ?v1)) (- (f11 (f12 f13 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 (- (f11 (f12 f13 ?v0) ?v1))) ?v1) (f11 (f12 f13 (- ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f13 (- ?v0 (f11 (f12 f13 ?v1) ?v2))) ?v2) (f11 (f12 f13 (- ?v0 ?v1)) ?v2))))
(assert (= (f25 f29 f27) 1))
(assert (=> (forall ((?v0 S2)) (=> (= f21 (f22 (f23 f24 1) ?v0)) false)) false))
(assert (= f27 (f30 f19 f20 f21)))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v1))) (= (f11 (f12 f13 ?v_0) ?v1) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f11 (f12 f13 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f13 ?v1) ?v0))) (=> (< ?v0 0) (and (<= ?v_0 0) (< ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f11 (f12 f13 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (- (* 2 (f11 (f12 f13 (+ ?v1 1)) ?v0)) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (<= (f11 (f12 f13 ?v1) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (< ?v0 (f11 (f12 f13 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ ?v0 ?v1))) (=> (< 0 ?v0) (=> (<= ?v_0 0) (= (f11 (f12 f13 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f11 (f12 f13 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f11 (f12 f13 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f11 (f12 f13 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (+ 1 (* 2 (f11 (f12 f13 ?v1) ?v0)))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f11 (f12 f13 (- 1)) ?v0) (- ?v0 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (<= (f11 (f12 f13 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (< (f11 (f12 f13 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f13 ?v1) ?v0))) (=> (< 0 ?v0) (and (<= 0 ?v_0) (< ?v_0 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= 0 (f11 (f12 f13 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= (f11 (f12 f13 (- ?v0)) ?v1) 0)) (not (= (f11 (f12 f13 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 ?v0))) (=> (not (= (f11 ?v_0 (- ?v1)) 0)) (not (= (f11 ?v_0 ?v1) 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f13 (- (f11 (f12 f13 ?v0) ?v1) ?v2)) ?v1) (f11 (f12 f13 (- ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 S15) (?v1 S16)) (not (= ?v0 (f31 (f32 f33 ?v1) ?v0)))))
(assert (forall ((?v0 S19) (?v1 S15)) (not (= ?v0 (f34 (f35 f36 ?v1) ?v0)))))
(assert (forall ((?v0 S2) (?v1 Int)) (not (= ?v0 (f22 (f23 f24 ?v1) ?v0)))))
(assert (forall ((?v0 S16) (?v1 S15)) (not (= (f31 (f32 f33 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S15) (?v1 S19)) (not (= (f34 (f35 f36 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S2)) (not (= (f22 (f23 f24 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S16) (?v1 S15) (?v2 S16) (?v3 S15)) (= (= (f31 (f32 f33 ?v0) ?v1) (f31 (f32 f33 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S15) (?v1 S19) (?v2 S15) (?v3 S19)) (= (= (f34 (f35 f36 ?v0) ?v1) (f34 (f35 f36 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 S2) (?v2 Int) (?v3 S2)) (= (= (f22 (f23 f24 ?v0) ?v1) (f22 (f23 f24 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 (f12 f37 ?v0) ?v1) (ite (<= 0 ?v1) (f11 ?v_0 ?v1) (f11 ?v_0 (- ?v1)))))))
(assert (= (f38 f10 f6 f6 f27) f1))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 Int) (?v3 S2)) (= (f7 (f39 (f40 f41 ?v0) ?v1) (f22 (f23 f24 ?v2) ?v3)) (f7 (f8 ?v1 ?v2) ?v3))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f42 ?v0) f1) (=> (= (f42 ?v1) f1) (= (f42 (f11 (f12 f13 ?v0) ?v1)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f43 ?v0) f1) (= (f11 (f12 f13 ?v0) 2) 0))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) 0) ?v0)))
(assert (= (f43 0) f1))
(assert (not (= (f43 1) f1)))
(assert (forall ((?v0 Int)) (= (= (f43 ?v0) f1) (exists ((?v1 Int)) (= ?v0 (* 2 ?v1))))))
(assert (forall ((?v0 Int)) (= (= (f43 (- ?v0)) f1) (= (f43 ?v0) f1))))
(assert (forall ((?v0 Int)) (= (not (= (f43 ?v0) f1)) (exists ((?v1 Int)) (= ?v0 (+ (* 2 ?v1) 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (= (f43 ?v0) f1)) (?v_1 (= (f43 ?v1) f1))) (= (= (f43 (+ ?v0 ?v1)) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (= (f43 ?v0) f1)) (?v_1 (= (f43 ?v1) f1))) (= (= (f43 (- ?v0 ?v1)) f1) (or (and ?v_0 ?v_1) (and (not ?v_0) (not ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f43 ?v0) f1) (=> (= (f43 ?v1) f1) (= (f43 (+ ?v0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f43 ?v0) f1) (=> (not (= (f43 ?v1) f1)) (not (= (f43 (+ ?v0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= (f43 ?v0) f1)) (=> (= (f43 ?v1) f1) (not (= (f43 (+ ?v0 ?v1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= (f43 ?v0) f1)) (=> (not (= (f43 ?v1) f1)) (= (f43 (+ ?v0 ?v1)) f1)))))
(assert (forall ((?v0 S24) (?v1 S24)) (let ((?v_0 (f11 (f12 f13 (f44 f45 ?v0)) (f44 f45 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S24) (?v1 S24)) (let ((?v_0 (f11 (f12 f13 (f44 f45 ?v0)) (f44 f45 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f46 f47 (f11 (f12 f13 ?v0) ?v1)) (f46 f47 (f11 (f12 f13 (f44 f45 (f46 f47 ?v0))) (f44 f45 (f46 f47 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (= (f46 f47 (f11 (f12 f13 (f44 f45 (f46 f47 ?v0))) (f44 f45 (f46 f47 ?v1)))) (f46 f47 (f11 (f12 f13 ?v0) ?v1)))))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 0) ?v0) 0)))
(assert (forall ((?v0 S4) (?v1 S5) (?v2 S5) (?v3 Int) (?v4 Int) (?v5 S2)) (= (= (f38 ?v0 ?v1 ?v2 (f30 ?v3 ?v4 ?v5)) f1) (= (f3 (f4 (f5 ?v1 ?v3) ?v4) ?v5) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S2)) (= (f25 f29 (f30 ?v0 ?v1 ?v2)) (f7 (f39 (f40 f41 0) f9) ?v2))))
(assert (forall ((?v0 S24)) (= (f46 f47 (f44 f45 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f44 f45 (f46 f47 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f44 f45 (f46 f47 ?v0)) 0))))
(check-sat)
(exit)
