(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 () Int)
(declare-fun f8 (S4 S5) Int)
(declare-fun f9 (S6 S5) S4)
(declare-fun f10 () S6)
(declare-fun f11 () S5)
(declare-fun f12 () S5)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () S5)
(declare-fun f16 (S7 S5) S5)
(declare-fun f17 (S8 Int) S7)
(declare-fun f18 () S8)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f8 (f9 f10 f11) f12))) (not (= (f3 (f4 f5 (+ (f3 (f4 f5 f6) f7) (f3 (f4 f5 ?v_0) f7))) f7) (f3 (f4 f5 (+ f6 ?v_0)) f7)))))
(assert (let ((?v_0 (f8 (f9 f10 f11) f12))) (= (f3 (f4 f5 (+ f13 ?v_0)) f7) (f3 (f4 f5 (+ (f3 (f4 f5 f13) f7) (f3 (f4 f5 ?v_0) f7))) f7))))
(assert (= (f3 (f4 f5 f13) f7) (f3 (f4 f5 f6) f7)))
(assert (let ((?v_0 (f8 (f9 f10 f11) f12))) (= (f3 (f4 f5 (+ f14 (+ f13 ?v_0))) f7) (f3 (f4 f5 (+ (f3 (f4 f5 f14) f7) (f3 (f4 f5 (+ (f3 (f4 f5 f6) f7) (f3 (f4 f5 ?v_0) f7))) f7))) f7))))
(assert (let ((?v_0 (+ f13 (f8 (f9 f10 f11) f12)))) (= (f3 (f4 f5 (+ f14 ?v_0)) f7) (f3 (f4 f5 (+ (f3 (f4 f5 f14) f7) (f3 (f4 f5 ?v_0) f7))) f7))))
(assert (= f15 (f16 (f17 f18 1) f11)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) 2))) (= (not (= ?v_0 0)) (= ?v_0 1)))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) ?v0) 0)))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (- 1)) 0)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 (f4 f5 ?v0) (- ?v1)) (- (f3 (f4 f5 (- ?v0)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v0))) (let ((?v_1 (f3 ?v_0 ?v1))) (= (f3 ?v_0 (- ?v1)) (ite (= ?v_1 0) 0 (- ?v_1 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f3 (f4 f5 (- ?v0)) ?v1) (ite (= ?v_0 0) 0 (- ?v1 ?v_0))))))
(assert (=> (forall ((?v0 S5)) (=> (= f15 (f16 (f17 f18 1) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) ?v1))) (= (f3 (f4 f5 ?v_0) ?v1) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (=> (< ?v1 ?v0) (= (f3 (f4 f5 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v1) ?v0))) (=> (< ?v0 0) (and (<= ?v_0 0) (< ?v0 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f3 (f4 f5 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (- (* 2 (f3 (f4 f5 (+ ?v1 1)) ?v0)) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (<= (f3 (f4 f5 ?v1) ?v0) 0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< ?v0 0) (< ?v0 (f3 (f4 f5 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ ?v0 ?v1))) (=> (< 0 ?v0) (=> (<= ?v_0 0) (= (f3 (f4 f5 ?v0) ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (= (f3 (f4 f5 ?v0) ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (<= 0 (f3 (f4 f5 ?v0) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f3 (f4 f5 (+ 1 (* 2 ?v1))) (* 2 ?v0)) (+ 1 (* 2 (f3 (f4 f5 ?v1) ?v0)))))))
(assert (forall ((?v0 Int)) (=> (< 0 ?v0) (= (f3 (f4 f5 (- 1)) ?v0) (- ?v0 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (<= (f3 (f4 f5 ?v0) ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (< (f3 (f4 f5 ?v1) ?v0) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f3 (f4 f5 ?v1) ?v0))) (=> (< 0 ?v0) (and (<= 0 ?v_0) (< ?v_0 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (<= 0 (f3 (f4 f5 ?v1) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= (f3 (f4 f5 (- ?v0)) ?v1) 0)) (not (= (f3 (f4 f5 ?v0) ?v1) 0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v0))) (=> (not (= (f3 ?v_0 (- ?v1)) 0)) (not (= (f3 ?v_0 ?v1) 0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (- (f3 (f4 f5 ?v0) ?v1) ?v2)) ?v1) (f3 (f4 f5 (- ?v0 ?v2)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f3 (f4 f5 (- ?v0 (f3 (f4 f5 ?v1) ?v2))) ?v2) (f3 (f4 f5 (- ?v0 ?v1)) ?v2))))
(check-sat)
(exit)
