(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-sort S14 0)
(declare-sort S15 0)
(declare-sort S16 0)
(declare-sort S17 0)
(declare-sort S18 0)
(declare-sort S19 0)
(declare-sort S20 0)
(declare-sort S21 0)
(declare-sort S22 0)
(declare-sort S23 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S3 S2) S1)
(declare-fun f4 () S3)
(declare-fun f5 (S2 S3) S1)
(declare-fun f6 (S4 S5) S3)
(declare-fun f7 () S4)
(declare-fun f8 () S5)
(declare-fun f9 (S6 S7) S3)
(declare-fun f10 (S8 S7) S6)
(declare-fun f11 (S9) S8)
(declare-fun f12 () S9)
(declare-fun f13 () S7)
(declare-fun f14 (S2) S3)
(declare-fun f15 (S10 Int) S1)
(declare-fun f16 (Int) S10)
(declare-fun f17 (S2) S3)
(declare-fun f18 (Int) S10)
(declare-fun f19 (S11 S3) S3)
(declare-fun f20 (S2) S11)
(declare-fun f21 (S12 S10) S10)
(declare-fun f22 (Int) S12)
(declare-fun f23 (Int S10) S1)
(declare-fun f24 (S2) S11)
(declare-fun f25 (Int) S12)
(declare-fun f26 (S2) S11)
(declare-fun f27 (Int) S12)
(declare-fun f28 (S2) S11)
(declare-fun f29 (Int) S12)
(declare-fun f30 (S14 S13) S1)
(declare-fun f31 (S9 Int) S14)
(declare-fun f32 (S2) S9)
(declare-fun f33 (S15 S2) Int)
(declare-fun f34 () S15)
(declare-fun f35 (Int) S12)
(declare-fun f36 () S10)
(declare-fun f37 (S7 Int) S9)
(declare-fun f38 (S2) S7)
(declare-fun f39 (S16 Int) Int)
(declare-fun f40 () S16)
(declare-fun f41 () S3)
(declare-fun f42 () S10)
(declare-fun f43 (S3) S3)
(declare-fun f44 () S15)
(declare-fun f45 (S10 S13) S1)
(declare-fun f46 (S17 S13) S10)
(declare-fun f47 () S17)
(declare-fun f48 (S3 S5) S1)
(declare-fun f49 (S18 S13) S13)
(declare-fun f50 (S19 Int) S18)
(declare-fun f51 (S20 S16) S19)
(declare-fun f52 () S20)
(declare-fun f53 (S10 S13) S1)
(declare-fun f54 (S3 S5) S1)
(declare-fun f55 (S21 S13) S2)
(declare-fun f56 (S22 Int) S21)
(declare-fun f57 () S22)
(declare-fun f58 (S23 Int) S22)
(declare-fun f59 () S23)
(declare-fun f60 () S23)
(declare-fun f61 (S10 S13) S1)
(declare-fun f62 (S3 S5) S1)
(declare-fun f63 () S17)
(declare-fun f64 () S4)
(declare-fun f65 (Int S13) S1)
(declare-fun f66 (S2 S5) S1)
(declare-fun f67 (S2) S11)
(declare-fun f68 () S3)
(declare-fun f69 (S10) S10)
(assert (not (= f1 f2)))
(assert (forall ((?v0 S2)) (= (= (f3 f4 ?v0) f1) (and (= (f5 ?v0 (f6 f7 f8)) f1) (= (f3 (f9 (f10 (f11 f12) f13) f13) ?v0) f1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f14 ?v0) ?v1) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f16 ?v0) ?v1) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f3 (f17 ?v0) ?v1) f1) (= ?v1 ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f15 (f18 ?v0) ?v1) f1) (= ?v1 ?v0))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f19 (f20 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f5 ?v2 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f15 (f21 (f22 ?v0) ?v1) ?v2) f1) (or (= ?v2 ?v0) (= (f23 ?v2 ?v1) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f19 (f24 ?v0) ?v1) ?v2) f1) (and (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f15 (f21 (f25 ?v0) ?v1) ?v2) f1) (and (= ?v0 ?v2) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f19 (f26 ?v0) ?v1) ?v2) f1) (and (= ?v2 ?v0) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f15 (f21 (f27 ?v0) ?v1) ?v2) f1) (and (= ?v2 ?v0) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f19 (f28 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f15 (f21 (f29 ?v0) ?v1) ?v2) f1) (=> (not (= ?v2 ?v0)) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 S13)) (= (= (f30 (f31 (f32 ?v0) ?v1) ?v2) f1) (= (f23 (f33 f34 ?v0) (f21 (f35 1) (f21 (f35 (- 1)) f36))) f1))))
(assert (forall ((?v0 S2) (?v1 Int) (?v2 Int) (?v3 S13)) (= (= (f30 (f31 (f37 (f38 ?v0) ?v1) ?v2) ?v3) f1) (= (f33 f34 ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13)) (= (= (f30 (f31 (f37 f13 ?v0) ?v1) ?v2) f1) true)))
(assert (forall ((?v0 Int) (?v1 S13)) (= (= (f30 (f31 f12 ?v0) ?v1) f1) false)))
(assert (forall ((?v0 Int)) (= (f39 f40 ?v0) ?v0)))
(assert (forall ((?v0 S2)) (= (= (f3 f41 ?v0) f1) false)))
(assert (forall ((?v0 Int)) (= (= (f15 f42 ?v0) f1) false)))
(assert (not (forall ((?v0 S2)) (=> (= (f5 ?v0 (f43 f4)) f1) (= (f33 f34 ?v0) 1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f38 ?v0))) (=> (= (f5 ?v0 (f6 f7 f8)) f1) (= (f3 (f9 (f10 (f11 (f32 ?v0)) ?v_0) ?v_0) ?v0) f1)))))
(assert (forall ((?v0 S2)) (let ((?v_0 (f38 ?v0))) (=> (= (f5 ?v0 (f6 f7 f8)) f1) (= (f3 (f9 (f10 (f11 (f32 ?v0)) ?v_0) ?v_0) ?v0) f1)))))
(assert (forall ((?v0 S2)) (=> (= (f5 ?v0 (f6 f7 f8)) f1) (not (= (f33 f44 ?v0) 0)))))
(assert (forall ((?v0 S10) (?v1 S13)) (= (= (f45 ?v0 ?v1) f1) (exists ((?v2 Int)) (and (and (= (f23 ?v2 (f46 f47 ?v1)) f1) (= (f15 ?v0 ?v2) f1)) (forall ((?v3 Int)) (=> (and (= (f23 ?v3 (f46 f47 ?v1)) f1) (= (f15 ?v0 ?v3) f1)) (= ?v3 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f48 ?v0 ?v1) f1) (exists ((?v2 S2)) (and (and (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1)) (forall ((?v3 S2)) (=> (and (= (f5 ?v3 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v3) f1)) (= ?v3 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 S13)) (=> (= (f23 ?v0 (f46 f47 ?v1)) f1) (= (f49 (f50 (f51 f52 f40) ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S10) (?v1 S13)) (= (= (f53 ?v0 ?v1) f1) (exists ((?v2 Int)) (and (= (f23 ?v2 (f46 f47 ?v1)) f1) (= (f15 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f54 ?v0 ?v1) f1) (exists ((?v2 S2)) (and (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S9) (?v1 S7) (?v2 S7) (?v3 Int) (?v4 S13)) (= (= (f3 (f9 (f10 (f11 ?v0) ?v1) ?v2) (f55 (f56 f57 ?v3) ?v4)) f1) (= (f30 (f31 ?v0 ?v3) ?v4) f1))))
(assert (forall ((?v0 S9) (?v1 S7) (?v2 S7) (?v3 Int) (?v4 Int) (?v5 S13)) (= (= (f3 (f9 (f10 (f11 ?v0) ?v1) ?v2) (f55 (f56 (f58 f59 ?v3) ?v4) ?v5)) f1) (= (f30 (f31 (f37 ?v2 ?v3) ?v4) ?v5) f1))))
(assert (forall ((?v0 S9) (?v1 S7) (?v2 S7) (?v3 Int) (?v4 Int) (?v5 S13)) (= (= (f3 (f9 (f10 (f11 ?v0) ?v1) ?v2) (f55 (f56 (f58 f60 ?v3) ?v4) ?v5)) f1) (= (f30 (f31 (f37 ?v1 ?v3) ?v4) ?v5) f1))))
(assert (forall ((?v0 S10) (?v1 S13)) (= (= (f61 ?v0 ?v1) f1) (forall ((?v2 Int)) (=> (= (f23 ?v2 (f46 f47 ?v1)) f1) (= (f15 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f62 ?v0 ?v1) f1) (forall ((?v2 S2)) (=> (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (= f63 f47))
(assert (= f64 f7))
(assert (forall ((?v0 S10) (?v1 S13)) (= (= (f45 ?v0 ?v1) f1) (exists ((?v2 Int)) (and (and (= (f23 ?v2 (f46 f47 ?v1)) f1) (= (f15 ?v0 ?v2) f1)) (forall ((?v3 Int)) (=> (and (= (f23 ?v3 (f46 f47 ?v1)) f1) (= (f15 ?v0 ?v3) f1)) (= ?v3 ?v2))))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f48 ?v0 ?v1) f1) (exists ((?v2 S2)) (and (and (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1)) (forall ((?v3 S2)) (=> (and (= (f5 ?v3 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v3) f1)) (= ?v3 ?v2))))))))
(assert (forall ((?v0 S13) (?v1 Int)) (= (= (f15 (f46 f63 ?v0) ?v1) f1) (= (f23 ?v1 (f46 f47 ?v0)) f1))))
(assert (forall ((?v0 S5) (?v1 S2)) (= (= (f3 (f6 f64 ?v0) ?v1) f1) (= (f5 ?v1 (f6 f7 ?v0)) f1))))
(assert (forall ((?v0 Int) (?v1 S13)) (= (= (f65 ?v0 ?v1) f1) (= (f23 ?v0 (f46 f47 ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S5)) (= (= (f66 ?v0 ?v1) f1) (= (f5 ?v0 (f6 f7 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S13)) (= (= (f23 ?v0 (f46 f47 ?v1)) f1) (= (f15 (f46 f63 ?v1) ?v0) f1))))
(assert (forall ((?v0 S2) (?v1 S5)) (= (= (f5 ?v0 (f6 f7 ?v1)) f1) (= (f3 (f6 f64 ?v1) ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 S13) (?v2 Int) (?v3 Int) (?v4 S13)) (not (= (f55 (f56 f57 ?v0) ?v1) (f55 (f56 (f58 f60 ?v2) ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 S13) (?v2 Int) (?v3 Int) (?v4 S13)) (not (= (f55 (f56 f57 ?v0) ?v1) (f55 (f56 (f58 f59 ?v2) ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 Int) (?v4 S13)) (not (= (f55 (f56 (f58 f60 ?v0) ?v1) ?v2) (f55 (f56 f57 ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 Int) (?v4 S13)) (not (= (f55 (f56 (f58 f59 ?v0) ?v1) ?v2) (f55 (f56 f57 ?v3) ?v4)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 Int) (?v4 Int) (?v5 S13)) (not (= (f55 (f56 (f58 f60 ?v0) ?v1) ?v2) (f55 (f56 (f58 f59 ?v3) ?v4) ?v5)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 Int) (?v4 Int) (?v5 S13)) (not (= (f55 (f56 (f58 f59 ?v0) ?v1) ?v2) (f55 (f56 (f58 f60 ?v3) ?v4) ?v5)))))
(assert (forall ((?v0 Int) (?v1 S13)) (= (f33 f44 (f55 (f56 f57 ?v0) ?v1)) 1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13)) (= (f33 f44 (f55 (f56 (f58 f60 ?v0) ?v1) ?v2)) ?v0)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13)) (= (f33 f44 (f55 (f56 (f58 f59 ?v0) ?v1) ?v2)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S13) (?v2 Int) (?v3 S13)) (= (= (f55 (f56 f57 ?v0) ?v1) (f55 (f56 f57 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 Int) (?v4 Int) (?v5 S13)) (= (= (f55 (f56 (f58 f60 ?v0) ?v1) ?v2) (f55 (f56 (f58 f60 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S13) (?v3 Int) (?v4 Int) (?v5 S13)) (= (= (f55 (f56 (f58 f59 ?v0) ?v1) ?v2) (f55 (f56 (f58 f59 ?v3) ?v4) ?v5)) (and (= ?v0 ?v3) (and (= ?v1 ?v4) (= ?v2 ?v5))))))
(assert (forall ((?v0 S13) (?v1 S10)) (= (forall ((?v2 Int)) (=> (= (f23 ?v2 (f46 f47 ?v0)) f1) (= (f15 ?v1 ?v2) f1))) (= (f61 ?v1 ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S3)) (= (forall ((?v2 S2)) (=> (= (f5 ?v2 (f6 f7 ?v0)) f1) (= (f3 ?v1 ?v2) f1))) (= (f62 ?v1 ?v0) f1))))
(assert (forall ((?v0 S10) (?v1 S13)) (= (= (f61 ?v0 ?v1) f1) (forall ((?v2 Int)) (=> (= (f23 ?v2 (f46 f47 ?v1)) f1) (= (f15 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f62 ?v0 ?v1) f1) (forall ((?v2 S2)) (=> (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S13) (?v1 S10)) (= (exists ((?v2 Int)) (and (= (f23 ?v2 (f46 f47 ?v0)) f1) (= (f15 ?v1 ?v2) f1))) (= (f53 ?v1 ?v0) f1))))
(assert (forall ((?v0 S5) (?v1 S3)) (= (exists ((?v2 S2)) (and (= (f5 ?v2 (f6 f7 ?v0)) f1) (= (f3 ?v1 ?v2) f1))) (= (f54 ?v1 ?v0) f1))))
(assert (forall ((?v0 S10) (?v1 S13)) (= (= (f53 ?v0 ?v1) f1) (exists ((?v2 Int)) (and (= (f23 ?v2 (f46 f47 ?v1)) f1) (= (f15 ?v0 ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S5)) (= (= (f54 ?v0 ?v1) f1) (exists ((?v2 S2)) (and (= (f5 ?v2 (f6 f7 ?v1)) f1) (= (f3 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S13)) (= (f46 f47 (f49 (f50 (f51 f52 f40) ?v0) ?v1)) (f21 (f35 ?v0) (f46 f47 ?v1)))))
(assert (forall ((?v0 S13) (?v1 S13) (?v2 S10) (?v3 S10)) (=> (= ?v0 ?v1) (=> (forall ((?v4 Int)) (=> (= (f23 ?v4 (f46 f47 ?v1)) f1) (= (= (f15 ?v2 ?v4) f1) (= (f15 ?v3 ?v4) f1)))) (= (= (f53 ?v2 ?v0) f1) (= (f53 ?v3 ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3) (?v3 S3)) (=> (= ?v0 ?v1) (=> (forall ((?v4 S2)) (=> (= (f5 ?v4 (f6 f7 ?v1)) f1) (= (= (f3 ?v2 ?v4) f1) (= (f3 ?v3 ?v4) f1)))) (= (= (f54 ?v2 ?v0) f1) (= (f54 ?v3 ?v1) f1))))))
(assert (forall ((?v0 S13) (?v1 S13) (?v2 S10) (?v3 S10)) (=> (= ?v0 ?v1) (=> (forall ((?v4 Int)) (=> (= (f23 ?v4 (f46 f47 ?v1)) f1) (= (= (f15 ?v2 ?v4) f1) (= (f15 ?v3 ?v4) f1)))) (= (= (f61 ?v2 ?v0) f1) (= (f61 ?v3 ?v1) f1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S3) (?v3 S3)) (=> (= ?v0 ?v1) (=> (forall ((?v4 S2)) (=> (= (f5 ?v4 (f6 f7 ?v1)) f1) (= (= (f3 ?v2 ?v4) f1) (= (f3 ?v3 ?v4) f1)))) (= (= (f62 ?v2 ?v0) f1) (= (f62 ?v3 ?v1) f1))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (=> (= (f5 ?v0 (f19 (f67 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f5 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (=> (= (f23 ?v0 (f21 (f35 ?v1) ?v2)) f1) (=> (=> (= ?v0 ?v1) false) (=> (=> (= (f23 ?v0 ?v2) f1) false) false)))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (=> (not (= (f5 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f5 ?v0 (f19 (f67 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (=> (not (= (f23 ?v0 ?v1) f1)) (= ?v0 ?v2)) (= (f23 ?v0 (f21 (f35 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2)) (=> (= (f5 ?v0 f68) f1) false)))
(assert (forall ((?v0 Int)) (=> (= (f23 ?v0 f36) f1) false)))
(assert (forall ((?v0 S2)) (= (f43 (f14 ?v0)) (f19 (f67 ?v0) f68))))
(assert (forall ((?v0 Int)) (= (f69 (f16 ?v0)) (f21 (f35 ?v0) f36))))
(assert (forall ((?v0 S2)) (= (f43 (f17 ?v0)) (f19 (f67 ?v0) f68))))
(assert (forall ((?v0 Int)) (= (f69 (f18 ?v0)) (f21 (f35 ?v0) f36))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f43 (f19 (f24 ?v0) ?v1)) (ite (= (f3 ?v1 ?v0) f1) (f19 (f67 ?v0) f68) f68))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f69 (f21 (f25 ?v0) ?v1)) (ite (= (f15 ?v1 ?v0) f1) (f21 (f35 ?v0) f36) f36))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f43 (f19 (f26 ?v0) ?v1)) (ite (= (f3 ?v1 ?v0) f1) (f19 (f67 ?v0) f68) f68))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f69 (f21 (f27 ?v0) ?v1)) (ite (= (f15 ?v1 ?v0) f1) (f21 (f35 ?v0) f36) f36))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= f68 (f19 (f67 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (not (= f36 (f21 (f35 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (not (= (f19 (f67 ?v0) ?v1) f68))))
(assert (forall ((?v0 Int) (?v1 S10)) (not (= (f21 (f35 ?v0) ?v1) f36))))
(assert (forall ((?v0 S3) (?v1 S2)) (=> (= ?v0 f68) (not (= (f5 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S10) (?v1 Int)) (=> (= ?v0 f36) (not (= (f23 ?v1 ?v0) f1)))))
(assert (forall ((?v0 S10)) (= (= (f69 ?v0) f36) (forall ((?v1 Int)) (not (= (f15 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (= (f43 ?v0) f68) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S2)) (= (= (f5 ?v0 f68) f1) false)))
(assert (forall ((?v0 Int)) (= (= (f23 ?v0 f36) f1) false)))
(assert (forall ((?v0 S10)) (= (= f36 (f69 ?v0)) (forall ((?v1 Int)) (not (= (f15 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (= f68 (f43 ?v0)) (forall ((?v1 S2)) (not (= (f3 ?v0 ?v1) f1))))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (=> (= (f5 ?v1 f68) f1) (= (f3 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S10)) (= (forall ((?v1 Int)) (=> (= (f23 ?v1 f36) f1) (= (f15 ?v0 ?v1) f1))) true)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (and (= (f5 ?v1 f68) f1) (= (f3 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S10)) (= (exists ((?v1 Int)) (and (= (f23 ?v1 f36) f1) (= (f15 ?v0 ?v1) f1))) false)))
(assert (forall ((?v0 S3)) (= (exists ((?v1 S2)) (= (f5 ?v1 ?v0) f1)) (not (= ?v0 f68)))))
(assert (forall ((?v0 S10)) (= (exists ((?v1 Int)) (= (f23 ?v1 ?v0) f1)) (not (= ?v0 f36)))))
(assert (forall ((?v0 S3)) (= (forall ((?v1 S2)) (not (= (f5 ?v1 ?v0) f1))) (= ?v0 f68))))
(assert (forall ((?v0 S10)) (= (forall ((?v1 Int)) (not (= (f23 ?v1 ?v0) f1))) (= ?v0 f36))))
(assert (= f36 (f69 f42)))
(assert (= f68 (f43 f41)))
(assert (forall ((?v0 S2) (?v1 S3)) (=> (= (f5 ?v0 ?v1) f1) (= (f19 (f67 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 Int) (?v1 S10)) (=> (= (f23 ?v0 ?v1) f1) (= (f21 (f35 ?v0) ?v1) ?v1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (=> (= (f5 ?v0 ?v1) f1) (= (f5 ?v0 (f19 (f67 ?v2) ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (=> (= (f23 ?v0 ?v1) f1) (= (f23 ?v0 (f21 (f35 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S3)) (let ((?v_0 (f67 ?v0))) (=> (not (= (f5 ?v0 ?v1) f1)) (=> (not (= (f5 ?v0 ?v2) f1)) (= (= (f19 ?v_0 ?v1) (f19 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 S10)) (let ((?v_0 (f35 ?v0))) (=> (not (= (f23 ?v0 ?v1) f1)) (=> (not (= (f23 ?v0 ?v2) f1)) (= (= (f21 ?v_0 ?v1) (f21 ?v_0 ?v2)) (= ?v1 ?v2)))))))
(assert (forall ((?v0 S2) (?v1 S3) (?v2 S2)) (= (= (f3 (f19 (f67 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f3 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S10) (?v2 Int)) (= (= (f15 (f21 (f35 ?v0) ?v1) ?v2) f1) (or (= ?v0 ?v2) (= (f15 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (= (= (f5 ?v0 (f19 (f67 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f5 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (= (= (f23 ?v0 (f21 (f35 ?v1) ?v2)) f1) (or (= ?v0 ?v1) (= (f23 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S3)) (let ((?v_1 (f67 ?v0)) (?v_0 (f67 ?v1))) (= (f19 ?v_1 (f19 ?v_0 ?v2)) (f19 ?v_0 (f19 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S10)) (let ((?v_1 (f35 ?v0)) (?v_0 (f35 ?v1))) (= (f21 ?v_1 (f21 ?v_0 ?v2)) (f21 ?v_0 (f21 ?v_1 ?v2))))))
(assert (forall ((?v0 S2) (?v1 S3)) (let ((?v_0 (f67 ?v0))) (let ((?v_1 (f19 ?v_0 ?v1))) (= (f19 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (let ((?v_0 (f35 ?v0))) (let ((?v_1 (f21 ?v_0 ?v1))) (= (f21 ?v_0 ?v_1) ?v_1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f19 (f67 ?v0) (f43 ?v1)) (f43 (f19 (f28 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f21 (f35 ?v0) (f69 ?v1)) (f69 (f21 (f29 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f19 (f67 ?v0) ?v1) (f43 (f19 (f20 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f21 (f35 ?v0) ?v1) (f69 (f21 (f22 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f5 ?v0 (f19 (f67 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f23 ?v0 (f21 (f35 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S2) (?v1 S3)) (= (f19 (f67 ?v0) ?v1) (f43 (f19 (f20 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S10)) (= (f21 (f35 ?v0) ?v1) (f69 (f21 (f22 ?v0) ?v1)))))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f19 (f67 ?v0) f68) (f19 (f67 ?v1) f68)) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 (f35 ?v0) f36) (f21 (f35 ?v1) f36)) (= ?v0 ?v1))))
(check-sat)
(exit)
