(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 () S3)
(declare-fun f6 () S4)
(declare-fun f7 (S5 S2) S3)
(declare-fun f8 (S6 S2) S5)
(declare-fun f9 () S6)
(declare-fun f10 () S5)
(declare-fun f11 (S7 S2) S4)
(declare-fun f12 () S7)
(declare-fun f13 (S8 Int) S4)
(declare-fun f14 () S8)
(declare-fun f15 () S7)
(declare-fun f16 (S9 S4) S5)
(declare-fun f17 () S9)
(declare-fun f18 (S10 S4) Int)
(declare-fun f19 () S10)
(declare-fun f20 (S11 S2) S2)
(declare-fun f21 () S11)
(declare-fun f22 (S12 S4) S13)
(declare-fun f23 (S12 S2 S13) S1)
(declare-fun f24 (S2 S2) S1)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 f5 f6)) f1)))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f4 f5 ?v0) (f4 f5 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f7 (f8 f9 ?v0) (f4 f5 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f7 f10 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S4)) (= (f11 f12 (f4 f5 ?v0)) (f13 f14 0))))
(assert (forall ((?v0 S4)) (= (f11 f15 (f4 f5 ?v0)) (f13 f14 0))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S4)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f18 f19 ?v1))) (= (f4 (f7 (f16 f17 ?v0) ?v_0) ?v2) (ite (< ?v_1 (f18 f19 ?v2)) ?v_0 (f4 f5 (f13 f14 (+ ?v_1 (f18 f19 ?v0)))))))))
(assert (forall ((?v0 S2)) (=> (= (f3 ?v0) f1) (= (f3 (f20 f21 ?v0)) f1))))
(assert (forall ((?v0 S12) (?v1 S4) (?v2 S13)) (=> (= (f22 ?v0 ?v1) ?v2) (= (f23 ?v0 (f4 f5 ?v1) ?v2) f1))))
(assert (forall ((?v0 S12) (?v1 S4) (?v2 S13)) (=> (= (f23 ?v0 (f4 f5 ?v1) ?v2) f1) (=> (=> (= (f22 ?v0 ?v1) ?v2) false) false))))
(assert (forall ((?v0 S4) (?v1 S2)) (=> (= (f24 (f4 f5 ?v0) ?v1) f1) false)))
(assert (forall ((?v0 S2) (?v1 S2)) (=> (= (f24 ?v0 ?v1) f1) (= (f24 (f20 f21 ?v0) (f20 f21 ?v1)) f1))))
(assert (forall ((?v0 S2)) (= (f11 f12 (f20 f21 ?v0)) (f13 f14 (+ (f18 f19 (f11 f12 ?v0)) (+ 0 1))))))
(assert (forall ((?v0 S2)) (= (f11 f15 (f20 f21 ?v0)) (f13 f14 (+ (f18 f19 (f11 f15 ?v0)) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f4 (f7 f10 (f20 f21 ?v0)) ?v1) (f20 f21 (f4 (f7 f10 ?v0) (f13 f14 (+ (f18 f19 ?v1) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (= (f20 f21 ?v0) (f20 f21 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S2) (?v1 S4)) (= (f4 (f7 (f16 f17 (f13 f14 0)) ?v0) ?v1) ?v0)))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_0 (f16 f17 ?v0))) (= (f4 (f7 ?v_0 (f20 f21 ?v1)) ?v2) (f20 f21 (f4 (f7 ?v_0 ?v1) (f13 f14 (+ (f18 f19 ?v2) 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f7 (f8 f9 (f20 f21 ?v0)) ?v1) ?v2) (f20 f21 (f4 (f7 (f8 f9 ?v0) (f4 (f7 f10 ?v1) (f13 f14 0))) (f13 f14 (+ (f18 f19 ?v2) 1)))))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (= (f4 (f7 (f16 f17 (f13 f14 (+ (f18 f19 ?v0) 1))) ?v1) ?v2) (f4 (f7 f10 (f4 (f7 (f16 f17 ?v0) ?v1) ?v2)) ?v2))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f4 (f7 (f8 f9 (f4 (f7 f10 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (=> (= (f24 ?v0 ?v1) f1) (= (f24 (f4 (f7 f10 ?v0) ?v2) (f4 (f7 f10 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S4)) (=> (= (f24 ?v0 ?v1) f1) (= (f24 (f4 (f7 (f8 f9 ?v0) ?v2) ?v3) (f4 (f7 (f8 f9 ?v1) ?v2) ?v3)) f1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (+ (f18 f19 ?v1) 1)) (?v_1 (f7 f10 ?v2))) (=> (< (f18 f19 ?v0) ?v_0) (= (f4 (f7 f10 (f4 ?v_1 ?v0)) (f13 f14 ?v_0)) (f4 (f7 f10 (f4 ?v_1 ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f18 f19 ?v1) 1))) (=> (< (f18 f19 ?v0) ?v_0) (= (f4 (f7 f10 (f4 (f7 (f8 f9 ?v2) ?v3) ?v1)) ?v0) (f4 (f7 (f8 f9 (f4 (f7 f10 ?v2) ?v0)) (f4 (f7 f10 ?v3) ?v0)) (f13 f14 ?v_0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f18 f19 ?v1) 1))) (=> (< (f18 f19 ?v0) ?v_0) (= (f4 (f7 f10 (f4 (f7 (f8 f9 ?v2) ?v3) ?v0)) ?v1) (f4 (f7 (f8 f9 (f4 (f7 f10 ?v2) (f13 f14 ?v_0))) (f4 (f7 f10 ?v3) ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (+ (f18 f19 ?v1) 1)) (?v_1 (f8 f9 ?v2))) (=> (< (f18 f19 ?v0) ?v_0) (= (f4 (f7 (f8 f9 (f4 (f7 ?v_1 (f4 (f7 f10 ?v3) ?v0)) (f13 f14 ?v_0))) (f4 (f7 (f8 f9 ?v4) ?v3) ?v1)) ?v0) (f4 (f7 (f8 f9 (f4 (f7 ?v_1 ?v4) ?v0)) ?v3) ?v1))))))
(assert (forall ((?v0 S12) (?v1 S2) (?v2 S13) (?v3 S2)) (=> (= (f23 ?v0 ?v1 ?v2) f1) (=> (= (f24 ?v1 ?v3) f1) (= (f23 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 S4) (?v1 S2)) (not (= (f4 f5 ?v0) (f20 f21 ?v1)))))
(assert (forall ((?v0 S4)) (= (f13 f14 (f18 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f18 f19 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f18 f19 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
