(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-sort S12 0)
(declare-sort S13 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2) S1)
(declare-fun f4 (S3 S4) S2)
(declare-fun f5 (S5 S2) S3)
(declare-fun f6 (S6 S2) S5)
(declare-fun f7 () S6)
(declare-fun f8 (S7 S2) S2)
(declare-fun f9 (S8 S2) S7)
(declare-fun f10 () S8)
(declare-fun f11 () S3)
(declare-fun f12 (S9 Int) S4)
(declare-fun f13 () S9)
(declare-fun f14 () S5)
(declare-fun f15 () S2)
(declare-fun f16 () S2)
(declare-fun f17 (S10 S4) Int)
(declare-fun f18 () S10)
(declare-fun f19 (S11 S2 S12) S1)
(declare-fun f20 () S11)
(declare-fun f21 () S12)
(declare-fun f22 (S13 S2) S4)
(declare-fun f23 () S13)
(declare-fun f24 () S6)
(declare-fun f25 () S7)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f12 f13 0))) (not (= (f3 (f4 (f5 (f6 f7 (f8 (f9 f10 (f4 f11 ?v_0)) (f4 (f5 f14 f15) ?v_0))) f16) ?v_0)) f1))))
(assert (= (f3 f16) f1))
(assert (= (f3 f15) f1))
(assert (forall ((?v0 S2) (?v1 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f5 f14 ?v0) ?v1)) f1))))
(assert (forall ((?v0 S4)) (= (f3 (f4 f11 ?v0)) f1)))
(assert (forall ((?v0 S2) (?v1 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f8 (f9 f10 ?v0) (f4 f11 ?v1))) f1))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S4)) (=> (= (f3 ?v0) f1) (= (f3 (f4 (f5 (f6 f7 ?v0) (f4 f11 ?v1)) ?v2)) f1))))
(assert (forall ((?v0 S2) (?v1 S4) (?v2 S2)) (= (f4 (f5 (f6 f7 (f4 (f5 f14 ?v0) ?v1)) ?v2) ?v1) ?v0)))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f17 f18 ?v1) 1))) (=> (< (f17 f18 ?v0) ?v_0) (= (f4 (f5 f14 (f4 (f5 (f6 f7 ?v2) ?v3) ?v1)) ?v0) (f4 (f5 (f6 f7 (f4 (f5 f14 ?v2) ?v0)) (f4 (f5 f14 ?v3) ?v0)) (f12 f13 ?v_0)))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2)) (let ((?v_0 (+ (f17 f18 ?v1) 1))) (=> (< (f17 f18 ?v0) ?v_0) (= (f4 (f5 f14 (f4 (f5 (f6 f7 ?v2) ?v3) ?v0)) ?v1) (f4 (f5 (f6 f7 (f4 (f5 f14 ?v2) (f12 f13 ?v_0))) (f4 (f5 f14 ?v3) ?v1)) ?v0))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2) (?v3 S2) (?v4 S2)) (let ((?v_0 (+ (f17 f18 ?v1) 1)) (?v_1 (f6 f7 ?v2))) (=> (< (f17 f18 ?v0) ?v_0) (= (f4 (f5 (f6 f7 (f4 (f5 ?v_1 (f4 (f5 f14 ?v3) ?v0)) (f12 f13 ?v_0))) (f4 (f5 (f6 f7 ?v4) ?v3) ?v1)) ?v0) (f4 (f5 (f6 f7 (f4 (f5 ?v_1 ?v4) ?v0)) ?v3) ?v1))))))
(assert (forall ((?v0 S4) (?v1 S4)) (let ((?v_0 (f4 f11 ?v0)) (?v_1 (f17 f18 ?v0))) (= (f4 (f5 f14 ?v_0) ?v1) (ite (< ?v_1 (f17 f18 ?v1)) ?v_0 (f4 f11 (f12 f13 (+ ?v_1 1))))))))
(assert (forall ((?v0 S4) (?v1 S2)) (= (f4 (f5 (f6 f7 (f4 f11 ?v0)) ?v1) ?v0) ?v1)))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S4)) (let ((?v_1 (f4 f11 ?v0)) (?v_0 (f17 f18 ?v0))) (= (f4 (f5 (f6 f7 ?v_1) ?v1) ?v2) (ite (< (f17 f18 ?v2) ?v_0) (f4 f11 (f12 f13 (- ?v_0 1))) (ite (= ?v0 ?v2) ?v1 ?v_1))))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (f4 f11 ?v0))) (=> (< (f17 f18 ?v0) (f17 f18 ?v1)) (= (f4 (f5 (f6 f7 ?v_0) ?v2) ?v1) ?v_0)))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (f17 f18 ?v1))) (=> (< (f17 f18 ?v0) ?v_0) (= (f4 (f5 (f6 f7 (f4 f11 ?v1)) ?v2) ?v0) (f4 f11 (f12 f13 (- ?v_0 1))))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f5 f14 (f8 (f9 f10 ?v0) ?v1)) ?v2) (f8 (f9 f10 (f4 (f5 f14 ?v0) ?v2)) (f4 (f5 f14 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S4)) (= (f4 (f5 (f6 f7 (f8 (f9 f10 ?v0) ?v1)) ?v2) ?v3) (f8 (f9 f10 (f4 (f5 (f6 f7 ?v0) ?v2) ?v3)) (f4 (f5 (f6 f7 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S4) (?v1 S2) (?v2 S2)) (not (= (f4 f11 ?v0) (f8 (f9 f10 ?v1) ?v2)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S2)) (= (= (f8 (f9 f10 ?v0) ?v1) (f8 (f9 f10 ?v2) ?v3)) (and (= ?v0 ?v2) (= ?v1 ?v3)))))
(assert (forall ((?v0 S4) (?v1 S4)) (= (= (f4 f11 ?v0) (f4 f11 ?v1)) (= ?v0 ?v1))))
(assert (forall ((?v0 S4) (?v1 S4) (?v2 S2)) (let ((?v_0 (+ (f17 f18 ?v1) 1)) (?v_1 (f5 f14 ?v2))) (=> (< (f17 f18 ?v0) ?v_0) (= (f4 (f5 f14 (f4 ?v_1 ?v0)) (f12 f13 ?v_0)) (f4 (f5 f14 (f4 ?v_1 ?v1)) ?v0))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (not (= (f8 (f9 f10 ?v0) ?v1) (f4 f11 ?v2)))))
(assert (= (f19 f20 f15 f21) f1))
(assert (forall ((?v0 S4)) (= (f22 f23 (f4 f11 ?v0)) (f12 f13 0))))
(assert (forall ((?v0 S2) (?v1 S2)) (= (f22 f23 (f8 (f9 f10 ?v0) ?v1)) (f12 f13 (+ (+ (f17 f18 (f22 f23 ?v0)) (f17 f18 (f22 f23 ?v1))) (+ 0 1))))))
(assert (forall ((?v0 S2) (?v1 S2)) (let ((?v_0 (f12 f13 0))) (= (f4 (f5 (f6 f24 ?v0) ?v1) ?v_0) (f4 (f5 (f6 f7 ?v0) ?v1) ?v_0)))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S4)) (= (f4 (f5 (f6 f7 (f8 f25 ?v0)) ?v1) ?v2) (f8 f25 (f4 (f5 (f6 f7 ?v0) (f4 (f5 f14 ?v1) (f12 f13 0))) (f12 f13 (+ (f17 f18 ?v2) 1)))))))
(assert (forall ((?v0 S2) (?v1 S2) (?v2 S2) (?v3 S4)) (= (f4 (f5 (f6 f24 (f8 (f9 f10 ?v0) ?v1)) ?v2) ?v3) (f8 (f9 f10 (f4 (f5 (f6 f24 ?v0) ?v2) ?v3)) (f4 (f5 (f6 f24 ?v1) ?v2) ?v3)))))
(assert (forall ((?v0 S4)) (= (f12 f13 (f17 f18 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f17 f18 (f12 f13 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f17 f18 (f12 f13 ?v0)) 0))))
(check-sat)
(exit)
