(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) S3)
(declare-fun f7 () S5)
(declare-fun f8 () Int)
(declare-fun f9 (Int) S1)
(declare-fun f10 (S6 Int) Int)
(declare-fun f11 (S7 Int) S6)
(declare-fun f12 () S7)
(declare-fun f13 () S6)
(declare-fun f14 (Int Int) S1)
(declare-fun f15 () S7)
(declare-fun f16 () S2)
(assert (not (= f1 f2)))
(assert (not (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f8) 1))))))
(assert (= (f9 (+ (* 4 f8) 1)) f1))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f9 ?v_0) f1) (= (f10 (f11 f12 (- 1)) ?v_0) 1)))))
(assert (= (f9 2) f1))
(assert (forall ((?v0 Int)) (=> (= (f9 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f4 f5 ?v0) (f6 f7 2)))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 2))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f6 f7 3))) (let ((?v_0 (f3 (f4 f5 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f4 f5 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f6 f7 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 3))) (= (f3 (f4 f5 (- ?v0)) ?v_0) (- (f3 (f4 f5 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f6 f7 4))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 f7 2))) (= (= (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f4 f5 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f4 f5 ?v0) (f6 f7 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (<= 0 (f3 (f4 f5 ?v0) ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f6 f7 2))) (= (f3 (f4 f5 (f10 f13 ?v0)) ?v_0) (f3 (f4 f5 ?v0) ?v_0)))))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (= (f3 (f4 f5 ?v0) (f6 f7 1)) ?v0)))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 (f4 f5 ?v0) (f6 f7 2)))) (= (f10 f13 ?v_0) ?v_0))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f10 f13 (f3 (f4 f5 ?v0) ?v1)) (f3 (f4 f5 (f10 f13 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f9 ?v0) f1) (=> (= (f14 ?v0 (f3 (f4 f5 ?v1) ?v2)) f1) (= (f14 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 f15 ?v0))) (=> (= (f9 ?v0) f1) (=> (<= 5 ?v0) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (= (f10 ?v_0 (f10 ?v_0 ?v1)) ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (< (f10 (f11 f15 ?v0) ?v1) ?v_0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 (- ?v0 1)) (< 1 (f10 (f11 f15 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v0 1))) (=> (= (f9 ?v0) f1) (=> (< 1 ?v1) (=> (< ?v1 ?v_0) (not (= (f10 (f11 f15 ?v0) ?v1) ?v_0))))))))
(assert (forall ((?v0 Int)) (= (= (f14 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f14 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f14 ?v0 ?v1) f1) (=> (= (f14 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f14 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f14 ?v0 ?v1) f1) (=> (= (f14 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f14 ?v0 (- ?v1 ?v2)) f1) (=> (= (f14 ?v0 ?v2) f1) (= (f14 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f14 ?v0 ?v1) f1) (= (f14 (f3 (f4 f5 ?v0) ?v2) (f3 (f4 f5 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3)) (= (f6 f7 (f3 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f16 (f6 f7 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f16 (f6 f7 ?v0)) 0))))
(check-sat)
(exit)
