(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 (S2 Int) Int)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 () Int)
(declare-fun f9 (S4 S5) Int)
(declare-fun f10 () S4)
(declare-fun f11 (Int Int) S5)
(declare-fun f12 () Int)
(declare-fun f13 (Int) S1)
(declare-fun f14 () S3)
(declare-fun f15 (Int Int) S1)
(declare-fun f16 (S6 S7) Int)
(declare-fun f17 (S8 Int) S6)
(declare-fun f18 () S8)
(declare-fun f19 (S9 Int) S7)
(declare-fun f20 () S9)
(declare-fun f21 () S6)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 (Int Int Int) S1)
(declare-fun f24 () Int)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) f8)) f1)))
(assert (= (f9 f10 (f11 f12 1)) (f4 (f5 f6 (+ (* 4 f7) 1)) f8)))
(assert (< 0 (+ (* 4 f7) 1)))
(assert (= (f9 f10 (f11 f12 1)) (f4 (f5 f6 (+ (* 4 f7) 1)) f8)))
(assert (= (f13 (+ (* 4 f7) 1)) f1))
(assert (= (f4 (f5 f14 (- 1)) (+ (* 4 f7) 1)) 1))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (= (f15 (+ (* 4 f7) 1) (- 1)) f1))
(assert (= (+ (f16 (f17 f18 f12) (f19 f20 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) f8)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (=> (not (= (f15 ?v_0 (- 1)) f1)) (not (= (f4 (f5 f14 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 f6 ?v0)) (?v_1 (f5 f6 ?v1))) (= (f4 (f5 f6 (f9 f10 (f11 ?v0 ?v1))) (f9 f10 (f11 ?v2 ?v3))) (f9 f10 (f11 (+ (f4 ?v_0 ?v2) (f4 ?v_1 ?v3)) (- (f4 ?v_0 ?v3) (f4 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (+ ?v1 ?v2)) (+ (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (- ?v1 ?v2)) (- (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 (- ?v0)) ?v1) (- (f4 (f5 f6 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v2) (+ (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v2) (- (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (let ((?v_0 (f16 (f17 f18 f12) (f19 f20 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f16 (f17 f18 f12) (f19 f20 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S7)) (<= 0 (f16 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S7)) (= (< 0 (f16 (f17 f18 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f19 f20 0))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f13 ?v_0) f1) (= (f4 (f5 f14 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 S7) (?v2 S7)) (let ((?v_0 (f17 f18 ?v0))) (= (f16 ?v_0 (f19 f20 (+ (f16 f21 ?v1) (f16 f21 ?v2)))) (f4 (f5 f6 (f16 ?v_0 ?v1)) (f16 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f4 (f5 f6 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (let ((?v_0 (f16 f21 ?v2))) (let ((?v_1 (f5 f6 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f4 ?v_1 ?v0) (f4 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int)) (= (= (f3 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f9 f10 (f11 ?v1 ?v2)) ?v0)))))
(assert (= (f22 (+ (* 4 f7) 1) (- (f16 (f17 f18 f12) (f19 f20 2)) (- 1))) f1))
(assert (= (f22 (+ (* 4 f7) 1) (+ (f16 (f17 f18 f12) (f19 f20 2)) 1)) f1))
(assert (= (f23 (f16 (f17 f18 f12) (f19 f20 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (and (<= 0 f12) (and (< f12 ?v_0) (= (f23 f24 f12 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f17 f18 ?v1)) (?v_1 (f19 f20 ?v0))) (=> (< 0 ?v0) (= (f16 ?v_0 ?v_1) (f4 (f5 f6 ?v1) (f16 ?v_0 (f19 f20 (- (f16 f21 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f4 (f5 f6 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f16 (f17 f18 ?v0) ?v_0) (f16 (f17 f18 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f19 f20 2)) (?v_0 (f19 f20 3)) (?v_3 (f17 f18 ?v1)) (?v_1 (f17 f18 ?v0))) (= (f16 (f17 f18 (- ?v0 ?v1)) ?v_0) (- (+ (- (f16 ?v_1 ?v_0) (f4 (f5 f6 (* 3 (f16 ?v_1 ?v_2))) ?v1)) (f4 (f5 f6 (* 3 ?v0)) (f16 ?v_3 ?v_2))) (f16 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f19 f20 2)) (?v_0 (f19 f20 3)) (?v_1 (f17 f18 ?v0)) (?v_3 (f17 f18 ?v1))) (= (f16 (f17 f18 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f16 ?v_1 ?v_0) (f4 (f5 f6 (* 3 (f16 ?v_1 ?v_2))) ?v1)) (f4 (f5 f6 (* 3 ?v0)) (f16 ?v_3 ?v_2))) (f16 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (f16 (f17 f18 (- ?v0 ?v1)) ?v_0) (+ (- (f16 (f17 f18 ?v0) ?v_0) (f4 (f5 f6 (* 2 ?v0)) ?v1)) (f16 (f17 f18 ?v1) ?v_0))))))
(assert (= (f23 (f16 (f17 f18 f24) (f19 f20 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f23 (f16 (f17 f18 ?v0) (f19 f20 2)) (- 1) (+ (* 4 f7) 1)) f1) false)) false))
(assert (let ((?v_0 (f19 f20 2))) (= (f23 (f16 (f17 f18 f12) ?v_0) (f16 (f17 f18 f24) ?v_0) (+ (* 4 f7) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f24 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f23 f24 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f23 f24 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int)) (= (= (f22 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f22 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f23 ?v0 0 ?v1) f1)) (=> (= (f23 (f16 (f17 f18 ?v2) (f19 f20 2)) ?v0 ?v1) f1) (not (= (f22 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f22 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f22 ?v0 ?v1) f1) (=> (= (f22 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f22 ?v0 (- ?v1 ?v2)) f1) (=> (= (f22 ?v0 ?v2) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) f1) (= (f22 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f22 (f4 (f5 f6 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1) f1) (= (= (f22 ?v0 (+ ?v2 ?v3)) f1) (= (f22 ?v0 (+ (+ ?v2 (f4 (f5 f6 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f22 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f22 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7)) (=> (= (f13 ?v0) f1) (=> (= (f22 ?v0 (f16 (f17 f18 ?v1) ?v2)) f1) (= (f22 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int)) (let ((?v_0 (f16 (f17 f18 ?v0) ?v2))) (=> (= (f13 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (f4 (f5 f6 ?v3) ?v1)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S7) (?v3 Int)) (let ((?v_0 (f16 (f17 f18 ?v0) ?v2))) (=> (= (f13 ?v0) f1) (=> (not (= (f22 ?v0 ?v1) f1)) (=> (= (f22 ?v_0 (f4 (f5 f6 ?v1) ?v3)) f1) (= (f22 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f4 (f5 f6 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int)) (=> (= (f16 (f17 f18 ?v0) (f19 f20 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f19 f20 2))) (= (= (f16 (f17 f18 ?v0) ?v_0) (f16 (f17 f18 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 2)) (?v_1 (f17 f18 ?v0))) (= (f16 (f17 f18 (f16 ?v_1 ?v_0)) ?v_0) (f16 ?v_1 (f19 f20 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f19 f20 3))) (= (f16 (f17 f18 (- ?v0)) ?v_0) (- (f16 (f17 f18 ?v0) ?v_0))))))
(assert (forall ((?v0 S7)) (= (f19 f20 (f16 f21 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f16 f21 (f19 f20 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f16 f21 (f19 f20 ?v0)) 0))))
(check-sat)
(exit)
