(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 () Int)
(declare-fun f5 (Int) S1)
(declare-fun f6 (S2 Int) Int)
(declare-fun f7 (S3 Int) S2)
(declare-fun f8 () S3)
(declare-fun f9 (S4 S5) Int)
(declare-fun f10 (S6 Int) S4)
(declare-fun f11 () S6)
(declare-fun f12 () Int)
(declare-fun f13 (S7 Int) S5)
(declare-fun f14 () S7)
(declare-fun f15 (S8 S9) Int)
(declare-fun f16 () S8)
(declare-fun f17 (Int Int) S9)
(declare-fun f18 (Int) S1)
(declare-fun f19 () S3)
(declare-fun f20 (Int Int) S1)
(declare-fun f21 (Int Int) S1)
(declare-fun f22 (Int Int Int) S1)
(declare-fun f23 () Int)
(declare-fun f24 () S4)
(assert (not (= f1 f2)))
(assert (not (<= 1 f3)))
(assert (< f3 (+ (* 4 f4) 1)))
(assert (= (f5 (f6 (f7 f8 (+ (* 4 f4) 1)) f3)) f1))
(assert (= (+ (f9 (f10 f11 f12) (f13 f14 2)) 1) (f6 (f7 f8 (+ (* 4 f4) 1)) f3)))
(assert (< 0 (+ (* 4 f4) 1)))
(assert (= (f15 f16 (f17 f12 1)) (f6 (f7 f8 (+ (* 4 f4) 1)) f3)))
(assert (let ((?v_0 (f9 (f10 f11 f12) (f13 f14 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f18 (+ (* 4 f4) 1)) f1))
(assert (= (f6 (f7 f19 (- 1)) (+ (* 4 f4) 1)) 1))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f9 (f10 f11 f12) (f13 f14 2)) 1) (f6 (f7 f8 (+ (* 4 f4) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f8 ?v0)) (?v_1 (f7 f8 ?v1))) (= (f6 (f7 f8 (f15 f16 (f17 ?v0 ?v1))) (f15 f16 (f17 ?v2 ?v3))) (f15 f16 (f17 (+ (f6 ?v_0 ?v2) (f6 ?v_1 ?v3)) (- (f6 ?v_0 ?v3) (f6 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f5 ?v0) f1) (=> (= (f5 ?v1) f1) (= (f5 (f6 (f7 f8 ?v0) ?v1)) f1)))))
(assert (= (f20 (+ (* 4 f4) 1) (- 1)) f1))
(assert (forall ((?v0 Int)) (= (= (f5 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f15 f16 (f17 ?v1 ?v2)) ?v0)))))
(assert (= (f21 (+ (* 4 f4) 1) (+ (f9 (f10 f11 f12) (f13 f14 2)) 1)) f1))
(assert (= (f21 (+ (* 4 f4) 1) (- (f9 (f10 f11 f12) (f13 f14 2)) (- 1))) f1))
(assert (= (f22 (f9 (f10 f11 f12) (f13 f14 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (and (<= 0 f12) (and (< f12 ?v_0) (= (f22 f23 f12 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f10 f11 ?v0))) (= (f9 ?v_0 (f13 f14 (+ (f9 f24 ?v1) (f9 f24 ?v2)))) (f6 (f7 f8 (f9 ?v_0 ?v1)) (f9 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f6 (f7 f8 ?v0) (f9 ?v_0 (f13 f14 2))) (f9 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f9 (f10 f11 (+ ?v0 ?v1)) ?v_0) (+ (+ (f9 (f10 f11 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f9 (f10 f11 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f9 (f10 f11 (- ?v0 ?v1)) ?v_0) (+ (- (f9 (f10 f11 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f9 (f10 f11 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_1 (f10 f11 ?v0)) (?v_3 (f10 f11 ?v1))) (= (f9 (f10 f11 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f9 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f9 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f9 ?v_3 ?v_2))) (f9 ?v_3 ?v_0))))))
(assert (= (f22 (f9 (f10 f11 f23) (f13 f14 2)) (- 1) (+ (* 4 f4) 1)) f1))
(assert (let ((?v_0 (+ (* 4 f4) 1))) (=> (not (= (f20 ?v_0 (- 1)) f1)) (not (= (f6 (f7 f19 (- 1)) ?v_0) 1)))))
(assert (=> (forall ((?v0 Int)) (=> (= (f22 (f9 (f10 f11 ?v0) (f13 f14 2)) (- 1) (+ (* 4 f4) 1)) f1) false)) false))
(assert (let ((?v_0 (f13 f14 2))) (= (f22 (f9 (f10 f11 f12) ?v_0) (f9 (f10 f11 f23) ?v_0) (+ (* 4 f4) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f22 f23 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f4) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f22 f23 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f22 f23 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f18 ?v0) f1) (=> (= (f21 ?v0 (f9 (f10 f11 ?v1) ?v2)) f1) (= (f21 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f21 ?v0 (- ?v1 ?v2)) f1) (=> (= (f21 ?v0 ?v2) f1) (= (f21 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (= (f21 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f21 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f21 ?v0 ?v1) f1) (=> (= (f21 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f18 ?v_0) f1) (= (f6 (f7 f19 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f21 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f21 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (= (f18 2) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f21 (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f21 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f21 ?v0 ?v1) f1) (= (= (f21 ?v0 (+ ?v2 ?v3)) f1) (= (f21 ?v0 (+ (+ ?v2 (f6 (f7 f8 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f21 (f6 (f7 f8 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f21 ?v0 (+ ?v1 (f6 (f7 f8 ?v0) ?v2))) f1) (= (f21 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v2))) (=> (= (f18 ?v0) f1) (=> (not (= (f21 ?v0 ?v1) f1)) (=> (= (f21 ?v_0 (f6 (f7 f8 ?v3) ?v1)) f1) (= (f21 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f9 (f10 f11 ?v0) ?v2))) (=> (= (f18 ?v0) f1) (=> (not (= (f21 ?v0 ?v1) f1)) (=> (= (f21 ?v_0 (f6 (f7 f8 ?v1) ?v3)) f1) (= (f21 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f9 f24 ?v2))) (let ((?v_1 (f7 f8 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f6 ?v_1 ?v0) (f6 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f6 (f7 f8 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v2) (- (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v2) (+ (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 (- ?v0)) ?v1) (- (f6 (f7 f8 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (- ?v1 ?v2)) (- (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (+ ?v1 ?v2)) (+ (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f9 (f10 f11 ?v0) (f13 f14 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (= (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2)) (?v_1 (f10 f11 ?v0))) (= (f9 (f10 f11 (f9 ?v_1 ?v_0)) ?v_0) (f9 ?v_1 (f13 f14 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f13 f14 3))) (= (f9 (f10 f11 (- ?v0)) ?v_0) (- (f9 (f10 f11 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f9 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f13 f14 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 3))) (let ((?v_0 (f9 (f10 f11 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f9 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f13 f14 2))) (let ((?v_0 (f9 (f10 f11 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f9 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f9 (f10 f11 ?v0) (f13 f14 2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f9 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f13 f14 2)) (?v_0 (f13 f14 3)) (?v_3 (f10 f11 ?v1)) (?v_1 (f10 f11 ?v0))) (= (f9 (f10 f11 (- ?v0 ?v1)) ?v_0) (- (+ (- (f9 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f9 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f9 ?v_3 ?v_2))) (f9 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 ?v0) f1) (=> (not (= (f21 ?v0 ?v1) f1)) (= (f22 (f9 (f10 f11 ?v1) (f13 f14 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f19 ?v0) ?v1) (ite (= (f22 ?v0 0 ?v1) f1) 0 (ite (= (f20 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f20 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f22 (f9 (f10 f11 ?v2) (f13 f14 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f18 ?v0) f1) (=> (= (f21 ?v0 (f9 (f10 f11 ?v1) ?v2)) f1) (=> (< 0 (f9 f24 ?v2)) (= (f21 ?v0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (= (f21 ?v0 (f6 (f7 f8 ?v1) ?v2)) f1) (or (= (f21 ?v0 ?v1) f1) (= (f21 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f18 ?v1) f1) (=> (= (f21 ?v1 (f6 (f7 f8 ?v0) ?v2)) f1) (or (= (f21 ?v1 ?v0) f1) (= (f21 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (not (= (f22 ?v1 0 ?v0) f1)) (=> (not (= (f22 ?v2 0 ?v0) f1)) (not (= (f22 (f6 (f7 f8 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f22 (f6 (f7 f8 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f22 ?v1 0 ?v0) f1)) (not (= (f22 ?v2 0 ?v0) f1))) (not (= (f22 (f6 (f7 f8 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f18 ?v0) f1) (=> (< 0 ?v1) (=> (= (f22 (f6 (f7 f8 ?v1) ?v2) 0 ?v0) f1) (or (= (f22 ?v1 0 ?v0) f1) (= (f22 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f7 f8 ?v1))) (= (+ (f6 (f7 f8 (- ?v0 (f6 ?v_0 ?v2))) ?v3) (f6 (f7 f8 (- ?v4 (f6 ?v_0 ?v5))) ?v6)) (- (+ (f6 (f7 f8 ?v0) ?v3) (f6 (f7 f8 ?v4) ?v6)) (f6 ?v_0 (+ (f6 (f7 f8 ?v2) ?v3) (f6 (f7 f8 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 ?v1 ?v2) f1) (= (f22 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 ?v1 (- ?v2)) f1) (= (f22 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f22 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f22 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f22 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f22 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f22 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f22 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f22 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f22 ?v1 (- 1) ?v0) f1) (not (= (f22 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (f22 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f22 ?v3 ?v4 ?v2) f1) (= (f22 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (= (f22 ?v1 ?v3 ?v2) f1) (= (f22 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (= (f22 ?v3 ?v4 ?v2) f1) (= (f22 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (= (f22 ?v3 ?v4 ?v2) f1) (= (f22 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f21 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f6 (f7 f8 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f22 (f6 (f7 f8 ?v0) ?v1) (f6 (f7 f8 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (= (f22 ?v3 (f6 (f7 f8 ?v0) ?v4) ?v2) f1) (= (f22 ?v3 (f6 (f7 f8 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f7 f8 ?v4))) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (= (f22 ?v3 (f6 ?v_0 ?v0) ?v2) f1) (= (f22 ?v3 (f6 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (f22 (f6 (f7 f8 ?v0) ?v3) (f6 (f7 f8 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f7 f8 ?v3))) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (f22 (f6 ?v_0 ?v0) (f6 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (=> (= (f22 ?v3 ?v4 ?v2) f1) (= (f22 (f6 (f7 f8 ?v0) ?v3) (f6 (f7 f8 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 ?v0 0 ?v1) f1) (= (f21 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f22 ?v0 0 ?v1) f1) (= (f21 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f22 ?v0 ?v1 ?v2) f1) (= (f21 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S5)) (=> (= (f22 ?v0 ?v1 ?v2) f1) (= (f22 (f9 (f10 f11 ?v0) ?v3) (f9 (f10 f11 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (=> (< 0 (f9 f24 ?v0)) (=> (= (f21 ?v1 ?v2) f1) (= (f21 ?v1 (f9 (f10 f11 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f18 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f21 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f18 ?v0) f1) (=> (< 0 ?v1) (=> (= (f22 (f6 (f7 f8 ?v1) ?v1) 1 ?v0) f1) (or (= (f22 ?v1 1 ?v0) f1) (= (f22 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f22 ?v0 0 ?v1) f1)) (=> (= (f22 (f9 (f10 f11 ?v2) (f13 f14 2)) ?v0 ?v1) f1) (not (= (f21 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f18 ?v1) f1) (= (f21 ?v1 ?v0) f1))))))
(assert (forall ((?v0 S5) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f13 f14 0))) (= (= (f21 (f9 (f10 f11 ?v1) ?v0) (f9 (f10 f11 ?v2) ?v0)) f1) (= (f21 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int)) (=> (= (f21 (f9 (f10 f11 ?v0) ?v1) (f9 (f10 f11 ?v2) ?v1)) f1) (=> (not (= ?v1 (f13 f14 0))) (= (f21 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f10 f11 (- 1)))) (let ((?v_1 (f9 ?v_0 ?v1)) (?v_2 (f9 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f22 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 ?v1)) (?v_1 (f13 f14 ?v0))) (=> (< 0 ?v0) (= (f9 ?v_0 ?v_1) (f6 (f7 f8 ?v1) (f9 ?v_0 (f13 f14 (- (f9 f24 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f22 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S5)) (let ((?v_0 (f9 (f10 f11 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (=> (not (= ?v0 0)) (= (= (f21 ?v1 ?v2) f1) (= (f21 (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f22 (f6 (f7 f8 ?v0) ?v_0) 1 ?v1) f1) (= (f22 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 Int) (?v3 S5)) (let ((?v_0 (f10 f11 ?v0))) (=> (= (f21 (f9 ?v_0 ?v1) ?v2) f1) (=> (<= (f9 f24 ?v3) (f9 f24 ?v1)) (= (f21 (f9 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 S5)) (=> (= (f21 ?v0 ?v1) f1) (=> (<= (f9 f24 ?v2) (f9 f24 ?v3)) (= (f21 (f9 (f10 f11 ?v0) ?v2) (f9 (f10 f11 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S5)) (= (f13 f14 (f9 f24 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f24 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f9 f24 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
