(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 () Int)
(declare-fun f8 (Int Int Int) S1)
(declare-fun f9 () Int)
(declare-fun f10 (S5 S4) Int)
(declare-fun f11 (S6 Int) S5)
(declare-fun f12 () S6)
(declare-fun f13 (S7 Int) S4)
(declare-fun f14 () S7)
(declare-fun f15 () Int)
(declare-fun f16 () S5)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f3 (f4 f5 ?v0) ?v1)) (< 0 ?v1)))))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f3 (f4 f5 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (let ((?v_0 (+ (* 4 f6) 1))) (and (<= 0 f7) (and (< f7 ?v_0) (= (f8 f9 f7 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 S4)) (<= 0 (f10 (f11 f12 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f10 (f11 f12 f7) (f13 f14 2)) 1) (f3 (f4 f5 (+ (* 4 f6) 1)) ?v0)) false)) false))
(assert (let ((?v_0 (+ (f10 (f11 f12 f7) (f13 f14 2)) 1))) (not (=> (= ?v_0 (f3 (f4 f5 (+ (* 4 f6) 1)) f15)) (=> (= f15 0) (= ?v_0 0))))))
(assert (forall ((?v0 S4)) (= (f13 f14 (f10 f16 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f10 f16 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f10 f16 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
