(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 () Int)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () Int)
(declare-fun f11 (S6 Int) Int)
(declare-fun f12 (S7 Int) S6)
(declare-fun f13 () S7)
(declare-fun f14 () Int)
(declare-fun f15 () S2)
(declare-fun f16 () S3)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () S3)
(declare-fun f22 (Int) S1)
(declare-fun f23 (Int) S1)
(declare-fun f24 () S7)
(declare-fun f25 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 2)) (?v_1 (+ 1 (f3 f15 f16)))) (not (= (+ (f3 (f4 f5 f6) ?v_0) (f3 (f4 f5 f9) ?v_0)) (+ (f3 (f4 f5 (- f10 (f11 (f12 f13 f14) ?v_1))) ?v_0) (f3 (f4 f5 (- f17 (f11 (f12 f13 f18) ?v_1))) ?v_0))))))
(assert (let ((?v_0 (+ 1 (f3 f15 f16)))) (and (= f6 (- f10 (f11 (f12 f13 f14) ?v_0))) (<= (ite (< f6 0) (* (- 2) f6) (* 2 f6)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f15 f16)))) (and (= f9 (- f17 (f11 (f12 f13 f18) ?v_0))) (<= (ite (< f9 0) (* (- 2) f9) (* 2 f9)) ?v_0))))
(assert (< 1 f19))
(assert (< 0 (f3 f15 f16)))
(assert (< 0 (+ 1 (f3 f15 f16))))
(assert (let ((?v_0 (+ 1 (f3 f15 f16)))) (and (= f6 (- f10 (f11 (f12 f13 f14) ?v_0))) (<= (ite (< f6 0) (* (- 2) f6) (* 2 f6)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f15 f16)))) (and (= f9 (- f17 (f11 (f12 f13 f18) ?v_0))) (<= (ite (< f9 0) (* (- 2) f9) (* 2 f9)) ?v_0))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f15 f16)))) (=> (and (= ?v1 (- f10 (f11 (f12 f13 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f15 f16)))) (=> (and (= ?v1 (- f17 (f11 (f12 f13 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f4 f5 f10) ?v_0) (f3 (f4 f5 f17) ?v_0)) (f11 (f12 f13 (+ (* 4 f20) 1)) (+ 1 (f3 f15 f16))))))
(assert (= f21 (f7 f8 (- (f3 f15 (f7 f8 f19)) 1))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f15 ?v1) (f3 f15 ?v2)))) (f11 (f12 f13 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f11 (f12 f13 ?v0) (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f11 (f12 f13 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f11 (f12 f13 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f11 (f12 f13 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f11 (f12 f13 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f11 (f12 f13 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f11 (f12 f13 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f11 (f12 f13 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f11 (f12 f13 ?v1) (f3 ?v_0 (f7 f8 (- (f3 f15 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (= (f11 (f12 f13 ?v0) ?v0) (f3 (f4 f5 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f15 ?v1) 1))) (f11 (f12 f13 ?v0) (f3 ?v_0 ?v1))))))
(assert (< 0 (f3 f15 f21)))
(assert (< 0 (+ (* 4 f20) 1)))
(assert (<= 1 f19))
(assert (not (= (f22 (f11 (f12 f13 (+ (* 4 f20) 1)) (+ 1 0))) f1)))
(assert (< f19 (+ (* 4 f20) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f15 (f7 f8 f19)) 1))) (=> (< 0 (f3 f15 ?v0)) false))) false))
(assert (let ((?v_1 (+ 1 (f3 f15 f16))) (?v_0 (+ (* 4 f20) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f22 (f11 (f12 f13 ?v_0) ?v_1)) f1))))))
(assert (= (f23 (+ (* 4 f20) 1)) f1))
(assert (= (f11 (f12 f24 (- 1)) (+ (* 4 f20) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f11 (f12 f13 (+ (* 4 f20) 1)) (+ 1 (f3 f15 f16)))) false))) false))
(assert (= (+ (f3 (f4 f5 f25) (f7 f8 2)) 1) (f11 (f12 f13 (+ (* 4 f20) 1)) f19)))
(assert (let ((?v_1 (+ 1 (f3 f15 f16))) (?v_0 (+ (* 4 f20) 1))) (and (< ?v_1 ?v_0) (= (f22 (f11 (f12 f13 ?v_0) ?v_1)) f1))))
(assert (= (f22 (f11 (f12 f13 (+ (* 4 f20) 1)) f19)) f1))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f15 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f15 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f15 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
