(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 (S4 Int) S2)
(declare-fun f5 () S4)
(declare-fun f6 (S5 Int) Int)
(declare-fun f7 (S6 Int) S5)
(declare-fun f8 () S6)
(declare-fun f9 () S2)
(declare-fun f10 () S3)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 (S7 Int) S3)
(declare-fun f16 () S7)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () S3)
(declare-fun f22 () Int)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 (Int) S1)
(declare-fun f25 (Int) S1)
(declare-fun f26 () S6)
(declare-fun f27 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (f7 f8 (+ 1 (f3 f9 f10)))) (?v_2 (f7 f8 f11)) (?v_3 (f7 f8 f13))) (let ((?v_4 (+ (f6 ?v_0 (f6 ?v_2 f12)) (f6 ?v_0 (f6 ?v_3 f14)))) (?v_1 (f15 f16 2))) (let ((?v_5 (f3 (f4 f5 (- (f6 ?v_0 (f6 ?v_2 f14)) (f6 ?v_0 (f6 ?v_3 f12)))) ?v_1))) (not (= (+ (f3 (f4 f5 (+ ?v_4 (+ (f3 (f4 f5 f12) ?v_1) (f3 (f4 f5 f14) ?v_1)))) ?v_1) ?v_5) (+ (f3 (f4 f5 (+ ?v_4 (f6 ?v_0 f17))) ?v_1) ?v_5)))))))
(assert (let ((?v_0 (f15 f16 2))) (= (+ (f3 (f4 f5 f12) ?v_0) (f3 (f4 f5 f14) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f9 f10))) f17))))
(assert (< 1 f18))
(assert (< 0 (f3 f9 f10)))
(assert (< 0 (+ 1 (f3 f9 f10))))
(assert (let ((?v_0 (f15 f16 2))) (= (+ (f3 (f4 f5 f12) ?v_0) (f3 (f4 f5 f14) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f9 f10))) f17))))
(assert (< f17 (+ 1 (f3 f9 f10))))
(assert (let ((?v_0 (+ 1 (f3 f9 f10)))) (and (= f12 (- f19 (f6 (f7 f8 f11) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f9 f10)))) (and (= f14 (- f20 (f6 (f7 f8 f13) ?v_0))) (<= (ite (< f14 0) (* (- 2) f14) (* 2 f14)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f9 f10)))) (let ((?v_5 (f7 f8 ?v_0)) (?v_4 (f7 f8 f11)) (?v_6 (f7 f8 f13)) (?v_3 (f15 f16 2))) (let ((?v_1 (f7 f8 (+ (f6 ?v_4 ?v_0) f12))) (?v_2 (f7 f8 (+ (f6 ?v_6 ?v_0) f14)))) (= (+ (f3 (f4 f5 (+ (f6 ?v_1 f12) (f6 ?v_2 f14))) ?v_3) (f3 (f4 f5 (- (f6 ?v_1 f14) (f6 ?v_2 f12))) ?v_3)) (+ (f3 (f4 f5 (+ (+ (f6 ?v_5 (f6 ?v_4 f12)) (f6 ?v_5 (f6 ?v_6 f14))) (+ (f3 (f4 f5 f12) ?v_3) (f3 (f4 f5 f14) ?v_3)))) ?v_3) (f3 (f4 f5 (- (f6 ?v_5 (f6 ?v_4 f14)) (f6 ?v_5 (f6 ?v_6 f12)))) ?v_3)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f15 f16 2))) (=> (= (+ (f3 (f4 f5 f12) ?v_0) (f3 (f4 f5 f14) ?v_0)) (f6 (f7 f8 (+ 1 (f3 f9 f10))) ?v0)) false))) false))
(assert (= f21 (f15 f16 (- (f3 f9 (f15 f16 f18)) 1))))
(assert (let ((?v_1 (+ 1 (f3 f9 f10)))) (let ((?v_2 (f7 f8 ?v_1)) (?v_4 (f7 f8 f11)) (?v_5 (f7 f8 f13)) (?v_0 (f15 f16 2))) (let ((?v_3 (+ (f3 (f4 f5 f12) ?v_0) (f3 (f4 f5 f14) ?v_0)))) (= (f6 (f7 f8 (f6 (f7 f8 (+ (* 4 f22) 1)) ?v_1)) ?v_3) (+ (f3 (f4 f5 (+ (+ (f6 ?v_2 (f6 ?v_4 f12)) (f6 ?v_2 (f6 ?v_5 f14))) ?v_3)) ?v_0) (f3 (f4 f5 (- (f6 ?v_2 (f6 ?v_4 f14)) (f6 ?v_2 (f6 ?v_5 f12)))) ?v_0)))))))
(assert (let ((?v_0 (f15 f16 2))) (= (f23 (+ 1 (f3 f9 f10)) (+ (f3 (f4 f5 f12) ?v_0) (f3 (f4 f5 f14) ?v_0))) f1)))
(assert (let ((?v_3 (+ 1 (f3 f9 f10))) (?v_2 (f15 f16 2))) (let ((?v_4 (f7 f8 (+ (f6 (f7 f8 f11) ?v_3) f12))) (?v_5 (f7 f8 (+ (f6 (f7 f8 f13) ?v_3) f14))) (?v_0 (f7 f8 f19)) (?v_1 (f7 f8 f20))) (= (+ (f3 (f4 f5 (+ (f6 ?v_0 f12) (f6 ?v_1 f14))) ?v_2) (f3 (f4 f5 (- (f6 ?v_0 f14) (f6 ?v_1 f12))) ?v_2)) (+ (f3 (f4 f5 (+ (f6 ?v_4 f12) (f6 ?v_5 f14))) ?v_2) (f3 (f4 f5 (- (f6 ?v_4 f14) (f6 ?v_5 f12))) ?v_2))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f4 f5 ?v0))) (= (f3 ?v_0 (f15 f16 (+ (f3 f9 ?v1) (f3 f9 ?v2)))) (f6 (f7 f8 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f4 f5 ?v0))) (= (f6 (f7 f8 ?v0) (f3 ?v_0 (f15 f16 2))) (f3 ?v_0 (f15 f16 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f4 f5 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f4 f5 ?v0) ?v_0) (f6 (f7 f8 (* 2 ?v0)) ?v1)) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f15 f16 2)) (?v_0 (f15 f16 3)) (?v_1 (f4 f5 ?v0)) (?v_3 (f4 f5 ?v1))) (= (f3 (f4 f5 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f15 f16 2)) (?v_0 (f15 f16 3)) (?v_3 (f4 f5 ?v1)) (?v_1 (f4 f5 ?v0))) (= (f3 (f4 f5 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f6 (f7 f8 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f6 (f7 f8 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (f6 (f7 f8 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 f5 ?v1)) (?v_1 (f15 f16 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f6 (f7 f8 ?v1) (f3 ?v_0 (f15 f16 (- (f3 f9 ?v_1) 1)))))))))
(assert (< 0 (f3 f9 f21)))
(assert (< 0 (+ (* 4 f22) 1)))
(assert (<= 1 f18))
(assert (not (= (f24 (f6 (f7 f8 (+ (* 4 f22) 1)) (+ 1 0))) f1)))
(assert (< f18 (+ (* 4 f22) 1)))
(assert (let ((?v_1 (+ 1 (f3 f9 f10))) (?v_0 (+ (* 4 f22) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f24 (f6 (f7 f8 ?v_0) ?v_1)) f1))))))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f15 f16 (- (f3 f9 (f15 f16 f18)) 1))) (=> (< 0 (f3 f9 ?v0)) false))) false))
(assert (let ((?v_0 (f15 f16 2))) (= (+ (f3 (f4 f5 f19) ?v_0) (f3 (f4 f5 f20) ?v_0)) (f6 (f7 f8 (+ (* 4 f22) 1)) (+ 1 (f3 f9 f10))))))
(assert (= (f25 (+ (* 4 f22) 1)) f1))
(assert (= (f6 (f7 f26 (- 1)) (+ (* 4 f22) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f9 f10)))) (=> (and (= ?v1 (- f20 (f6 (f7 f8 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f9 f10)))) (=> (and (= ?v1 (- f19 (f6 (f7 f8 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (f15 f16 2)) (?v_1 (f7 f8 f19)) (?v_2 (f7 f8 f20))) (= (f6 (f7 f8 (+ (f3 (f4 f5 f19) ?v_0) (f3 (f4 f5 f20) ?v_0))) (+ (f3 (f4 f5 f12) ?v_0) (f3 (f4 f5 f14) ?v_0))) (+ (f3 (f4 f5 (+ (f6 ?v_1 f12) (f6 ?v_2 f14))) ?v_0) (f3 (f4 f5 (- (f6 ?v_1 f14) (f6 ?v_2 f12))) ?v_0)))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (=> (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (f6 (f7 f8 (+ (* 4 f22) 1)) (+ 1 (f3 f9 f10)))) false))) false))
(assert (= (+ (f3 (f4 f5 f27) (f15 f16 2)) 1) (f6 (f7 f8 (+ (* 4 f22) 1)) f18)))
(assert (let ((?v_0 (f15 f16 2))) (let ((?v_1 (+ (f3 (f4 f5 f12) ?v_0) (f3 (f4 f5 f14) ?v_0)))) (= (f6 (f7 f8 (f6 (f7 f8 (+ (* 4 f22) 1)) (+ 1 (f3 f9 f10)))) ?v_1) (f6 (f7 f8 (+ (f3 (f4 f5 f19) ?v_0) (f3 (f4 f5 f20) ?v_0))) ?v_1)))))
(assert (let ((?v_1 (+ 1 (f3 f9 f10))) (?v_0 (+ (* 4 f22) 1))) (and (< ?v_1 ?v_0) (= (f24 (f6 (f7 f8 ?v_0) ?v_1)) f1))))
(assert (= (f24 (f6 (f7 f8 (+ (* 4 f22) 1)) f18)) f1))
(assert (=> (= f18 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f15 f16 2))) (= (+ (f3 (f4 f5 ?v0) ?v_0) (f3 (f4 f5 ?v1) ?v_0)) (+ (* 4 f22) 1))))))
(assert (forall ((?v0 Int)) (= (= (f23 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f23 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f23 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0 ?v1) f1) (=> (= (f23 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f23 ?v0 (- ?v1 ?v2)) f1) (=> (= (f23 ?v0 ?v2) f1) (= (f23 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (=> (= (f23 (f6 ?v_0 ?v1) (f6 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f23 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f23 ?v0 ?v1) f1) (= (= (f23 ?v0 (+ ?v2 ?v3)) f1) (= (f23 ?v0 (+ (+ ?v2 (f6 (f7 f8 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f23 (f6 (f7 f8 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f23 ?v0 (+ ?v1 (f6 (f7 f8 ?v0) ?v2))) f1) (= (f23 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f6 (f7 f8 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f6 (f7 f8 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f9 ?v2))) (let ((?v_1 (f7 f8 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f6 ?v_1 ?v0) (f6 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f6 ?v_0 ?v0) (f6 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f6 (f7 f8 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (- ?v0 ?v1)) ?v2) (- (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f6 (f7 f8 (+ ?v0 ?v1)) ?v2) (+ (f6 (f7 f8 ?v0) ?v2) (f6 (f7 f8 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 (f7 f8 (f6 ?v_0 ?v1)) ?v2) (f6 ?v_0 (f6 (f7 f8 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f6 (f7 f8 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f6 (f7 f8 (- ?v0)) ?v1) (- (f6 (f7 f8 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f7 f8 ?v0))) (= (f6 ?v_0 (- ?v1 ?v2)) (- (f6 ?v_0 ?v1) (f6 ?v_0 ?v2))))))
(assert (forall ((?v0 S3)) (= (f15 f16 (f3 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f9 (f15 f16 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f9 (f15 f16 ?v0)) 0))))
(check-sat)
(exit)
