(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 Int) Int)
(declare-fun f4 (S3 Int) S2)
(declare-fun f5 () S3)
(declare-fun f6 () Int)
(declare-fun f7 (S4 S5) Int)
(declare-fun f8 () S4)
(declare-fun f9 () S5)
(declare-fun f10 (S6 Int) S4)
(declare-fun f11 () S6)
(declare-fun f12 () Int)
(declare-fun f13 (S7 Int) S5)
(declare-fun f14 () S7)
(declare-fun f15 () Int)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 (Int) S1)
(declare-fun f21 (Int) S1)
(declare-fun f22 () S3)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 (Int Int) S1)
(declare-fun f26 () S5)
(declare-fun f27 (Int Int) S1)
(declare-fun f28 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_1 (+ 1 (f7 f8 f9))) (?v_0 (f13 f14 2))) (let ((?v_2 (f4 f5 (f7 (f10 f11 ?v_1) ?v_0))) (?v_3 (f4 f5 f16)) (?v_4 (f4 f5 f17))) (not (= (f3 (f4 f5 (f3 (f4 f5 (+ (* 4 f6) 1)) ?v_1)) (+ (f7 (f10 f11 f12) ?v_0) (f7 (f10 f11 f15) ?v_0))) (+ (f3 ?v_2 (f7 (f10 f11 (+ (+ (f3 ?v_3 f12) (f3 ?v_4 f15)) f18)) ?v_0)) (f3 ?v_2 (f7 (f10 f11 (- (f3 ?v_3 f15) (f3 ?v_4 f12))) ?v_0))))))))
(assert (let ((?v_1 (+ 1 (f7 f8 f9))) (?v_0 (f13 f14 2)) (?v_3 (f4 f5 f16)) (?v_4 (f4 f5 f17))) (let ((?v_2 (f4 f5 ?v_1))) (= (f3 (f4 f5 (f3 (f4 f5 (+ (* 4 f6) 1)) ?v_1)) (+ (f7 (f10 f11 f12) ?v_0) (f7 (f10 f11 f15) ?v_0))) (+ (f7 (f10 f11 (+ (+ (f3 ?v_2 (f3 ?v_3 f12)) (f3 ?v_2 (f3 ?v_4 f15))) (f3 ?v_2 f18))) ?v_0) (f7 (f10 f11 (- (f3 ?v_2 (f3 ?v_3 f15)) (f3 ?v_2 (f3 ?v_4 f12)))) ?v_0))))))
(assert (< 1 f19))
(assert (< 0 (f7 f8 f9)))
(assert (< 0 (+ 1 (f7 f8 f9))))
(assert (< 0 (+ (* 4 f6) 1)))
(assert (not (= (f20 (f3 (f4 f5 (+ (* 4 f6) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f7 f8 f9)))) (not (=> (< ?v_1 ?v_0) (not (= (f20 (f3 (f4 f5 ?v_0) ?v_1)) f1))))))
(assert (< f18 (+ 1 (f7 f8 f9))))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f7 (f10 f11 f12) ?v_0) (f7 (f10 f11 f15) ?v_0)) (f3 (f4 f5 (+ 1 (f7 f8 f9))) f18))))
(assert (let ((?v_1 (+ 1 (f7 f8 f9))) (?v_0 (f13 f14 2)) (?v_3 (f4 f5 f16)) (?v_4 (f4 f5 f17))) (let ((?v_2 (f4 f5 ?v_1))) (= (f3 (f4 f5 (f3 (f4 f5 (+ (* 4 f6) 1)) ?v_1)) (+ (f7 (f10 f11 f12) ?v_0) (f7 (f10 f11 f15) ?v_0))) (+ (f7 (f10 f11 (+ (+ (f3 ?v_2 (f3 ?v_3 f12)) (f3 ?v_2 (f3 ?v_4 f15))) (f3 ?v_2 f18))) ?v_0) (f7 (f10 f11 (- (f3 ?v_2 (f3 ?v_3 f15)) (f3 ?v_2 (f3 ?v_4 f12)))) ?v_0))))))
(assert (= (f21 (+ (* 4 f6) 1)) f1))
(assert (= (f3 (f4 f22 (- 1)) (+ (* 4 f6) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f7 (f10 f11 ?v0) ?v_0) (f7 (f10 f11 ?v1) ?v_0)) (f3 (f4 f5 (+ (* 4 f6) 1)) (+ 1 (f7 f8 f9)))) false))) false))
(assert (let ((?v_0 (+ 1 (f7 f8 f9)))) (and (= f12 (- f23 (f3 (f4 f5 f16) ?v_0))) (<= (ite (< f12 0) (* (- 2) f12) (* 2 f12)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f7 f8 f9)))) (and (= f15 (- f24 (f3 (f4 f5 f17) ?v_0))) (<= (ite (< f15 0) (* (- 2) f15) (* 2 f15)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f7 f8 f9))) (?v_3 (f13 f14 2)) (?v_4 (f4 f5 f16)) (?v_6 (f4 f5 f17))) (let ((?v_5 (f4 f5 ?v_0)) (?v_1 (f4 f5 (+ (f3 ?v_4 ?v_0) f12))) (?v_2 (f4 f5 (+ (f3 ?v_6 ?v_0) f15)))) (= (+ (f7 (f10 f11 (+ (f3 ?v_1 f12) (f3 ?v_2 f15))) ?v_3) (f7 (f10 f11 (- (f3 ?v_1 f15) (f3 ?v_2 f12))) ?v_3)) (+ (f7 (f10 f11 (+ (+ (f3 ?v_5 (f3 ?v_4 f12)) (f3 ?v_5 (f3 ?v_6 f15))) (+ (f7 (f10 f11 f12) ?v_3) (f7 (f10 f11 f15) ?v_3)))) ?v_3) (f7 (f10 f11 (- (f3 ?v_5 (f3 ?v_4 f15)) (f3 ?v_5 (f3 ?v_6 f12)))) ?v_3))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f13 f14 2))) (=> (= (+ (f7 (f10 f11 f12) ?v_0) (f7 (f10 f11 f15) ?v_0)) (f3 (f4 f5 (+ 1 (f7 f8 f9))) ?v0)) false))) false))
(assert (let ((?v_1 (f13 f14 2)) (?v_2 (f4 f5 f16)) (?v_3 (f4 f5 f17)) (?v_0 (f4 f5 (+ 1 (f7 f8 f9))))) (let ((?v_4 (+ (f3 ?v_0 (f3 ?v_2 f12)) (f3 ?v_0 (f3 ?v_3 f15)))) (?v_5 (f7 (f10 f11 (- (f3 ?v_0 (f3 ?v_2 f15)) (f3 ?v_0 (f3 ?v_3 f12)))) ?v_1))) (= (+ (f7 (f10 f11 (+ ?v_4 (+ (f7 (f10 f11 f12) ?v_1) (f7 (f10 f11 f15) ?v_1)))) ?v_1) ?v_5) (+ (f7 (f10 f11 (+ ?v_4 (f3 ?v_0 f18))) ?v_1) ?v_5)))))
(assert (let ((?v_0 (+ (* 4 f6) 1)) (?v_1 (+ 1 (f7 f8 f9)))) (and (< ?v_1 ?v_0) (= (f20 (f3 (f4 f5 ?v_0) ?v_1)) f1))))
(assert (= (f25 (+ (* 4 f6) 1) (- 1)) f1))
(assert (= f26 (f13 f14 (- (f7 f8 (f13 f14 f19)) 1))))
(assert (let ((?v_0 (f13 f14 2))) (= (f27 (+ 1 (f7 f8 f9)) (+ (f7 (f10 f11 f12) ?v_0) (f7 (f10 f11 f15) ?v_0))) f1)))
(assert (let ((?v_0 (f13 f14 2))) (= (+ (f7 (f10 f11 f23) ?v_0) (f7 (f10 f11 f24) ?v_0)) (f3 (f4 f5 (+ (* 4 f6) 1)) (+ 1 (f7 f8 f9))))))
(assert (let ((?v_3 (+ 1 (f7 f8 f9))) (?v_2 (f13 f14 2))) (let ((?v_4 (f4 f5 (+ (f3 (f4 f5 f16) ?v_3) f12))) (?v_5 (f4 f5 (+ (f3 (f4 f5 f17) ?v_3) f15))) (?v_0 (f4 f5 f23)) (?v_1 (f4 f5 f24))) (= (+ (f7 (f10 f11 (+ (f3 ?v_0 f12) (f3 ?v_1 f15))) ?v_2) (f7 (f10 f11 (- (f3 ?v_0 f15) (f3 ?v_1 f12))) ?v_2)) (+ (f7 (f10 f11 (+ (f3 ?v_4 f12) (f3 ?v_5 f15))) ?v_2) (f7 (f10 f11 (- (f3 ?v_4 f15) (f3 ?v_5 f12))) ?v_2))))))
(assert (< f19 (+ (* 4 f6) 1)))
(assert (let ((?v_0 (f13 f14 2))) (let ((?v_1 (+ (f7 (f10 f11 f12) ?v_0) (f7 (f10 f11 f15) ?v_0)))) (= (f3 (f4 f5 (f3 (f4 f5 (+ (* 4 f6) 1)) (+ 1 (f7 f8 f9)))) ?v_1) (f3 (f4 f5 (+ (f7 (f10 f11 f23) ?v_0) (f7 (f10 f11 f24) ?v_0))) ?v_1)))))
(assert (= (+ (f7 (f10 f11 f28) (f13 f14 2)) 1) (f3 (f4 f5 (+ (* 4 f6) 1)) f19)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f7 (f10 f11 f28) (f13 f14 2)) 1) (f3 (f4 f5 (+ (* 4 f6) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f10 f11 ?v0))) (= (f7 ?v_0 (f13 f14 (+ (f7 f8 ?v1) (f7 f8 ?v2)))) (f3 (f4 f5 (f7 ?v_0 ?v1)) (f7 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 ?v0))) (= (f3 (f4 f5 ?v0) (f7 ?v_0 (f13 f14 2))) (f7 ?v_0 (f13 f14 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f13 f14 2))) (= (f7 (f10 f11 (+ ?v0 ?v1)) ?v_0) (+ (+ (f7 (f10 f11 ?v0) ?v_0) (f3 (f4 f5 (* 2 ?v0)) ?v1)) (f7 (f10 f11 ?v1) ?v_0))))))
(assert (< 0 (f7 f8 f26)))
(assert (<= 1 f19))
(assert (forall ((?v0 S5)) (= (f13 f14 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f13 f14 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f13 f14 ?v0)) 0))))
(check-sat)
(exit)
