(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 (S2 Int) Int)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 () Int)
(declare-fun f9 (S4 S5) Int)
(declare-fun f10 (S6 Int) S4)
(declare-fun f11 () S6)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 (S7 Int) S5)
(declare-fun f17 () S7)
(declare-fun f18 () Int)
(declare-fun f19 () S4)
(declare-fun f20 () S5)
(declare-fun f21 (Int) S1)
(declare-fun f22 () S3)
(declare-fun f23 (Int Int) S1)
(declare-fun f24 () S5)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) f8)) f1)))
(assert (let ((?v_0 (f5 f6 f12)) (?v_1 (f5 f6 f14)) (?v_2 (f16 f17 2))) (= (+ (f9 (f10 f11 (+ (+ (f4 ?v_0 f13) (f4 ?v_1 f15)) f8)) ?v_2) (f9 (f10 f11 (- (f4 ?v_0 f15) (f4 ?v_1 f13))) ?v_2)) (f4 (f5 f6 (+ (* 4 f7) 1)) f8))))
(assert (< 1 f18))
(assert (< 0 (f9 f19 f20)))
(assert (< 0 (+ (* 4 f7) 1)))
(assert (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 0))) f1)))
(assert (let ((?v_0 (f5 f6 f12)) (?v_1 (f5 f6 f14)) (?v_2 (f16 f17 2))) (= (+ (f9 (f10 f11 (+ (+ (f4 ?v_0 f13) (f4 ?v_1 f15)) f8)) ?v_2) (f9 (f10 f11 (- (f4 ?v_0 f15) (f4 ?v_1 f13))) ?v_2)) (f4 (f5 f6 (+ (* 4 f7) 1)) f8))))
(assert (= (f21 (+ (* 4 f7) 1)) f1))
(assert (= (f4 (f5 f22 (- 1)) (+ (* 4 f7) 1)) 1))
(assert (let ((?v_0 (+ (* 4 f7) 1)) (?v_1 (+ 1 (f9 f19 f20)))) (not (=> (< ?v_1 ?v_0) (not (= (f3 (f4 (f5 f6 ?v_0) ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (= (f23 (+ (* 4 f7) 1) (- 1)) f1))
(assert (= f24 (f16 f17 (- (f9 f19 (f16 f17 f18)) 1))))
(assert (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) f18)) f1))
(assert (< f18 (+ (* 4 f7) 1)))
(assert (let ((?v_0 (+ (* 4 f7) 1)) (?v_1 (+ 1 (f9 f19 f20)))) (and (< ?v_1 ?v_0) (= (f3 (f4 (f5 f6 ?v_0) ?v_1)) f1))))
(assert (let ((?v_0 (f16 f17 2))) (= (+ (f9 (f10 f11 f13) ?v_0) (f9 (f10 f11 f15) ?v_0)) (f4 (f5 f6 (+ 1 (f9 f19 f20))) f8))))
(assert (< f8 (+ 1 (f9 f19 f20))))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (=> (not (= (f23 ?v_0 (- 1)) f1)) (not (= (f4 (f5 f22 (- 1)) ?v_0) 1)))))
(assert (= (+ (f9 (f10 f11 f25) (f16 f17 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) f18)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f9 (f10 f11 f25) (f16 f17 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (+ ?v1 ?v2)) (+ (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (< 0 (f9 f19 f24)))
(assert (< 0 (+ 1 (f9 f19 f20))))
(assert (<= 1 f18))
(assert (let ((?v_0 (f9 (f10 f11 f25) (f16 f17 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f16 f17 (- (f9 f19 (f16 f17 f18)) 1))) (=> (< 0 (f9 f19 ?v0)) false))) false))
(assert (let ((?v_0 (+ 1 (f9 f19 f20)))) (and (= f15 (- f26 (f4 (f5 f6 f14) ?v_0))) (<= (ite (< f15 0) (* (- 2) f15) (* 2 f15)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f9 f19 f20)))) (and (= f13 (- f27 (f4 (f5 f6 f12) ?v_0))) (<= (ite (< f13 0) (* (- 2) f13) (* 2 f13)) ?v_0))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (=> (= (+ (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v1) ?v_0)) (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 (f9 f19 f20)))) false))) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f16 f17 2))) (=> (= (+ (f9 (f10 f11 f13) ?v_0) (f9 (f10 f11 f15) ?v_0)) (f4 (f5 f6 (+ 1 (f9 f19 f20))) ?v0)) false))) false))
(assert (let ((?v_0 (f16 f17 2))) (= (+ (f9 (f10 f11 f27) ?v_0) (f9 (f10 f11 f26) ?v_0)) (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 (f9 f19 f20))))))
(assert (=> (= f18 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f16 f17 2))) (= (+ (f9 (f10 f11 ?v0) ?v_0) (f9 (f10 f11 ?v1) ?v_0)) (+ (* 4 f7) 1))))))
(assert (forall ((?v0 S5)) (= (f16 f17 (f9 f19 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f9 f19 (f16 f17 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f9 f19 (f16 f17 ?v0)) 0))))
(check-sat)
(exit)
