(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unknown)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int Int) S1)
(declare-fun f4 (S2 Int) Int)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 (S4 S5) Int)
(declare-fun f8 () S4)
(declare-fun f9 () S5)
(declare-fun f10 () Int)
(declare-fun f11 (S6 Int) S4)
(declare-fun f12 () S6)
(declare-fun f13 () Int)
(declare-fun f14 (S7 Int) S5)
(declare-fun f15 () S7)
(declare-fun f16 () Int)
(declare-fun f17 () Int)
(declare-fun f18 (Int) S1)
(declare-fun f19 (Int) S1)
(declare-fun f20 () S3)
(declare-fun f21 () Int)
(declare-fun f22 (Int Int) S1)
(declare-fun f23 () S5)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (+ 1 (f7 f8 f9)))) (let ((?v_1 (f5 f6 ?v_0))) (not (= (f3 (f4 ?v_1 ?v_0) (f4 ?v_1 (+ (* 4 f10) 1))) f1)))))
(assert (let ((?v_0 (f14 f15 2))) (= (+ (f7 (f11 f12 f13) ?v_0) (f7 (f11 f12 f16) ?v_0)) (f4 (f5 f6 (+ (* 4 f10) 1)) (+ 1 (f7 f8 f9))))))
(assert (let ((?v_0 (f14 f15 2))) (= (f3 (f7 (f11 f12 (+ 1 (f7 f8 f9))) ?v_0) (+ (f7 (f11 f12 f13) ?v_0) (f7 (f11 f12 f16) ?v_0))) f1)))
(assert (< 1 f17))
(assert (< 0 (f7 f8 f9)))
(assert (let ((?v_0 (f14 f15 2))) (= (f3 (f7 (f11 f12 (+ 1 (f7 f8 f9))) ?v_0) (+ (f7 (f11 f12 f13) ?v_0) (f7 (f11 f12 f16) ?v_0))) f1)))
(assert (< 0 (+ (* 4 f10) 1)))
(assert (< 0 (+ 1 (f7 f8 f9))))
(assert (let ((?v_0 (f14 f15 2))) (= (+ (f7 (f11 f12 f13) ?v_0) (f7 (f11 f12 f16) ?v_0)) (f4 (f5 f6 (+ (* 4 f10) 1)) (+ 1 (f7 f8 f9))))))
(assert (not (= (f18 (f4 (f5 f6 (+ (* 4 f10) 1)) (+ 1 0))) f1)))
(assert (let ((?v_1 (+ 1 (f7 f8 f9))) (?v_0 (+ (* 4 f10) 1))) (not (=> (< ?v_1 ?v_0) (not (= (f18 (f4 (f5 f6 ?v_0) ?v_1)) f1))))))
(assert (let ((?v_0 (+ 1 (f7 f8 f9)))) (and (= (f3 ?v_0 f13) f1) (= (f3 ?v_0 f16) f1))))
(assert (= (f19 (+ (* 4 f10) 1)) f1))
(assert (= (f4 (f5 f20 (- 1)) (+ (* 4 f10) 1)) 1))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f7 f8 f9)))) (=> (and (= ?v1 (- f13 (f4 (f5 f6 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f7 f8 f9)))) (=> (and (= ?v1 (- f16 (f4 (f5 f6 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_1 (+ 1 (f7 f8 f9))) (?v_0 (+ (* 4 f10) 1))) (and (< ?v_1 ?v_0) (= (f18 (f4 (f5 f6 ?v_0) ?v_1)) f1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f14 f15 2))) (=> (= (+ (f7 (f11 f12 ?v0) ?v_0) (f7 (f11 f12 ?v1) ?v_0)) (f4 (f5 f6 (+ (* 4 f10) 1)) (+ 1 (f7 f8 f9)))) false))) false))
(assert (let ((?v_0 (f14 f15 2))) (let ((?v_1 (f7 (f11 f12 (+ 1 (f7 f8 f9))) ?v_0))) (and (= (f3 ?v_1 (f7 (f11 f12 f13) ?v_0)) f1) (= (f3 ?v_1 (f7 (f11 f12 f16) ?v_0)) f1)))))
(assert (< f21 (+ 1 (f7 f8 f9))))
(assert (= (f22 (+ (* 4 f10) 1) (- 1)) f1))
(assert (= f23 (f14 f15 (- (f7 f8 (f14 f15 f17)) 1))))
(assert (< f17 (+ (* 4 f10) 1)))
(assert (let ((?v_0 (+ 1 (f7 f8 f9)))) (and (= f24 (- f13 (f4 (f5 f6 f25) ?v_0))) (<= (ite (< f24 0) (* (- 2) f24) (* 2 f24)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f7 f8 f9)))) (and (= f26 (- f16 (f4 (f5 f6 f27) ?v_0))) (<= (ite (< f26 0) (* (- 2) f26) (* 2 f26)) ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f3 ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) f1) (= (f3 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f3 (f4 (f5 f6 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (not (= ?v0 0)) (= (= (f3 ?v1 ?v2) f1) (= (f3 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f3 ?v0 ?v1) f1) (= (= (f3 ?v0 (+ ?v2 ?v3)) f1) (= (f3 ?v0 (+ (+ ?v2 (f4 (f5 f6 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f3 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f3 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f3 ?v0 (f4 (f5 f6 ?v0) ?v1)) f1)))
(assert (< 0 (f7 f8 f23)))
(assert (<= 1 f17))
(assert (let ((?v_0 (f14 f15 2))) (= (+ (f7 (f11 f12 f24) ?v_0) (f7 (f11 f12 f26) ?v_0)) 0)))
(assert (and (= f24 0) (= f26 0)))
(assert (forall ((?v0 S5)) (= (f14 f15 (f7 f8 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f14 f15 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f7 f8 (f14 f15 ?v0)) 0))))
(check-sat)
(exit)
