(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int) S1)
(declare-fun f4 (S2 Int) Int)
(declare-fun f5 (S3 Int) S2)
(declare-fun f6 () S3)
(declare-fun f7 () Int)
(declare-fun f8 (S4 S5) Int)
(declare-fun f9 () S4)
(declare-fun f10 (S6 Int) S5)
(declare-fun f11 () S6)
(declare-fun f12 () Int)
(declare-fun f13 () Int)
(declare-fun f14 () S5)
(declare-fun f15 (Int) S1)
(declare-fun f16 () S3)
(declare-fun f17 (Int Int) S1)
(declare-fun f18 () S5)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 (S7 Int) S4)
(declare-fun f22 () S7)
(declare-fun f23 () Int)
(declare-fun f24 () Int)
(declare-fun f25 () Int)
(declare-fun f26 () Int)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (Int Int Int) S1)
(declare-fun f30 (S8 S9) Int)
(declare-fun f31 () S8)
(declare-fun f32 (Int Int) S9)
(declare-fun f33 () Int)
(declare-fun f34 (S10 S5) S11)
(declare-fun f35 () S10)
(declare-fun f36 (S11 S5) S5)
(declare-fun f37 () S10)
(assert (not (= f1 f2)))
(assert (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 (f8 f9 (f10 f11 (- (f8 f9 (f10 f11 f12)) 1)))))) f1)))
(assert (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) f12)) f1))
(assert (= (+ 1 (f8 f9 (f10 f11 (- (f8 f9 (f10 f11 f12)) 1)))) f12))
(assert (< 1 f13))
(assert (= (+ 1 (f8 f9 (f10 f11 (- (f8 f9 (f10 f11 f12)) 1)))) f12))
(assert (< 0 (f8 f9 f14)))
(assert (< 0 (+ (* 4 f7) 1)))
(assert (not (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 0))) f1)))
(assert (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) f12)) f1))
(assert (< 0 f12))
(assert (= (f15 (+ (* 4 f7) 1)) f1))
(assert (= (f4 (f5 f16 (- 1)) (+ (* 4 f7) 1)) 1))
(assert (let ((?v_0 (+ (* 4 f7) 1)) (?v_1 (+ 1 (f8 f9 f14)))) (not (=> (< ?v_1 ?v_0) (not (= (f3 (f4 (f5 f6 ?v_0) ?v_1)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f3 ?v0) f1) (=> (= (f3 ?v1) f1) (= (f3 (f4 (f5 f6 ?v0) ?v1)) f1)))))
(assert (= (f17 (+ (* 4 f7) 1) (- 1)) f1))
(assert (= f18 (f10 f11 (- (f8 f9 (f10 f11 f13)) 1))))
(assert (= (f3 (f4 (f5 f6 (+ (* 4 f7) 1)) f13)) f1))
(assert (< f13 (+ (* 4 f7) 1)))
(assert (let ((?v_0 (+ (* 4 f7) 1)) (?v_1 (+ 1 (f8 f9 f14)))) (and (< ?v_1 ?v_0) (= (f3 (f4 (f5 f6 ?v_0) ?v_1)) f1))))
(assert (< f12 (+ 1 (f8 f9 f14))))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (=> (not (= (f17 ?v_0 (- 1)) f1)) (not (= (f4 (f5 f16 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (+ ?v1 ?v2)) (+ (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (- ?v1 ?v2)) (- (f4 ?v_0 ?v1) (f4 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 (- ?v0)) ?v1) (- (f4 (f5 f6 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (< 0 (f8 f9 f18)))
(assert (< 0 (+ 1 (f8 f9 f14))))
(assert (<= 1 f13))
(assert (=> (forall ((?v0 S5)) (=> (= ?v0 (f10 f11 (- (f8 f9 (f10 f11 f13)) 1))) (=> (< 0 (f8 f9 ?v0)) false))) false))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f15 ?v_0) f1) (= (f4 (f5 f16 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f4 (f5 f6 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (let ((?v_0 (f8 f9 ?v2))) (let ((?v_1 (f5 f6 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f4 ?v_1 ?v0) (f4 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f4 ?v_0 ?v0) (f4 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f4 (f5 f6 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (- ?v0 ?v1)) ?v2) (- (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f4 (f5 f6 (+ ?v0 ?v1)) ?v2) (+ (f4 (f5 f6 ?v0) ?v2) (f4 (f5 f6 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f8 f9 f14)))) (=> (and (= ?v1 (- f19 (f4 (f5 f6 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f8 f9 f14)))) (=> (and (= ?v1 (- f20 (f4 (f5 f6 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (=> (= (+ (f8 (f21 f22 ?v0) ?v_0) (f8 (f21 f22 ?v1) ?v_0)) (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 (f8 f9 f14)))) false))) false))
(assert (= (+ (f8 (f21 f22 f23) (f10 f11 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) f13)))
(assert (let ((?v_0 (+ 1 (f8 f9 f14)))) (and (= f24 (- f19 (f4 (f5 f6 f25) ?v_0))) (<= (ite (< f24 0) (* (- 2) f24) (* 2 f24)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f8 f9 f14)))) (and (= f26 (- f20 (f4 (f5 f6 f27) ?v_0))) (<= (ite (< f26 0) (* (- 2) f26) (* 2 f26)) ?v_0))))
(assert (let ((?v_0 (f10 f11 2))) (= (+ (f8 (f21 f22 f20) ?v_0) (f8 (f21 f22 f19) ?v_0)) (f4 (f5 f6 (+ (* 4 f7) 1)) (+ 1 (f8 f9 f14))))))
(assert (=> (= f13 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (+ (f8 (f21 f22 ?v0) ?v_0) (f8 (f21 f22 ?v1) ?v_0)) (+ (* 4 f7) 1))))))
(assert (let ((?v_0 (f10 f11 2))) (= (+ (f8 (f21 f22 f26) ?v_0) (f8 (f21 f22 f24) ?v_0)) (f4 (f5 f6 (+ 1 (f8 f9 f14))) f12))))
(assert (= (f15 2) f1))
(assert (let ((?v_0 (f8 (f21 f22 f23) (f10 f11 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f8 (f21 f22 f23) (f10 f11 2)) 1) (f4 (f5 f6 (+ (* 4 f7) 1)) ?v0)) false)) false))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2))) (=> (= (+ (f8 (f21 f22 f26) ?v_0) (f8 (f21 f22 f24) ?v_0)) (f4 (f5 f6 (+ 1 (f8 f9 f14))) ?v0)) false))) false))
(assert (let ((?v_2 (f10 f11 2)) (?v_1 (f5 f6 f25)) (?v_0 (f5 f6 f27))) (= (+ (f8 (f21 f22 (+ (+ (f4 ?v_0 f26) (f4 ?v_1 f24)) f12)) ?v_2) (f8 (f21 f22 (- (f4 ?v_0 f24) (f4 ?v_1 f26))) ?v_2)) (f4 (f5 f6 (+ (* 4 f7) 1)) f12))))
(assert (forall ((?v0 Int) (?v1 S5)) (<= 0 (f8 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 S5)) (= (< 0 (f8 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f10 f11 0))))))
(assert (forall ((?v0 Int)) (=> (= (f8 (f21 f22 ?v0) (f10 f11 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (= (f8 (f21 f22 ?v0) ?v_0) (f8 (f21 f22 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 2)) (?v_1 (f21 f22 ?v0))) (= (f8 (f21 f22 (f8 ?v_1 ?v_0)) ?v_0) (f8 ?v_1 (f10 f11 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f10 f11 3))) (= (f8 (f21 f22 (- ?v0)) ?v_0) (- (f8 (f21 f22 ?v0) ?v_0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 3))) (let ((?v_0 (f8 (f21 f22 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f10 f11 2))) (let ((?v_0 (f8 (f21 f22 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f8 (f21 f22 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f8 (f21 f22 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f21 f22 ?v0))) (= (f4 (f5 f6 ?v0) (f8 ?v_0 (f10 f11 2))) (f8 ?v_0 (f10 f11 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f8 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (+ (f8 (f21 f22 ?v0) ?v_0) (f4 (f5 f6 (* 2 ?v0)) ?v1)) (f8 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f8 (f21 f22 (- ?v0 ?v1)) ?v_0) (+ (- (f8 (f21 f22 ?v0) ?v_0) (f4 (f5 f6 (* 2 ?v0)) ?v1)) (f8 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f10 f11 2)) (?v_0 (f10 f11 3)) (?v_1 (f21 f22 ?v0)) (?v_3 (f21 f22 ?v1))) (= (f8 (f21 f22 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f8 ?v_1 ?v_0) (f4 (f5 f6 (* 3 (f8 ?v_1 ?v_2))) ?v1)) (f4 (f5 f6 (* 3 ?v0)) (f8 ?v_3 ?v_2))) (f8 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f10 f11 2)) (?v_0 (f10 f11 3)) (?v_3 (f21 f22 ?v1)) (?v_1 (f21 f22 ?v0))) (= (f8 (f21 f22 (- ?v0 ?v1)) ?v_0) (- (+ (- (f8 ?v_1 ?v_0) (f4 (f5 f6 (* 3 (f8 ?v_1 ?v_2))) ?v1)) (f4 (f5 f6 (* 3 ?v0)) (f8 ?v_3 ?v_2))) (f8 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f10 f11 2))) (= (f4 (f5 f6 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f8 (f21 f22 ?v0) ?v_0) (f8 (f21 f22 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f8 ?v_0 (f10 f11 (+ (f8 f9 ?v1) (f8 f9 ?v2)))) (f4 (f5 f6 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f4 (f5 f6 ?v0) ?v1)) (< 0 ?v1)))))
(assert (let ((?v_0 (f10 f11 2))) (= (f28 (+ 1 (f8 f9 f14)) (+ (f8 (f21 f22 f26) ?v_0) (f8 (f21 f22 f24) ?v_0))) f1)))
(assert (= (f28 (+ (* 4 f7) 1) (+ (f8 (f21 f22 f23) (f10 f11 2)) 1)) f1))
(assert (= (f28 (+ (* 4 f7) 1) (- (f8 (f21 f22 f23) (f10 f11 2)) (- 1))) f1))
(assert (= (f29 (f8 (f21 f22 f23) (f10 f11 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (= (f30 f31 (f32 f23 1)) (f4 (f5 f6 (+ (* 4 f7) 1)) f13)))
(assert (let ((?v_0 (+ (* 4 f7) 1))) (and (<= 0 f23) (and (< f23 ?v_0) (= (f29 f33 f23 ?v_0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f21 f22 ?v1)) (?v_1 (f10 f11 ?v0))) (=> (< 0 ?v0) (= (f8 ?v_0 ?v_1) (f4 (f5 f6 ?v1) (f8 ?v_0 (f10 f11 (- (f8 f9 ?v_1) 1)))))))))
(assert (forall ((?v0 Int)) (= (f4 (f5 f6 ?v0) ?v0) (f8 (f21 f22 ?v0) (f10 f11 2)))))
(assert (forall ((?v0 S5)) (= (f36 (f34 f35 ?v0) ?v0) (f36 (f34 f37 ?v0) (f10 f11 2)))))
(assert (= (f29 (f8 (f21 f22 f33) (f10 f11 2)) (- 1) (+ (* 4 f7) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f29 (f8 (f21 f22 ?v0) (f10 f11 2)) (- 1) (+ (* 4 f7) 1)) f1) false)) false))
(assert (let ((?v_0 (f10 f11 2))) (= (f29 (f8 (f21 f22 f23) ?v_0) (f8 (f21 f22 f33) ?v_0) (+ (* 4 f7) 1)) f1)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) false))) false))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f7) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f29 f33 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f29 f33 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f29 ?v0 0 ?v1) f1)) (=> (= (f29 (f8 (f21 f22 ?v2) (f10 f11 2)) ?v0 ?v1) f1) (not (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f8 (f21 f22 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f10 f11 (f4 (f5 f6 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f34 f37 ?v0))) (= (f36 (f34 f37 (f36 ?v_0 ?v1)) ?v2) (f36 ?v_0 (f10 f11 (f4 (f5 f6 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f28 ?v0 (- ?v1 ?v2)) f1) (=> (= (f28 ?v0 ?v2) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f28 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f28 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f28 ?v0 ?v1) f1) (=> (= (f28 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f28 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f28 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 f6 ?v0)) (?v_1 (f5 f6 ?v1))) (= (f4 (f5 f6 (f30 f31 (f32 ?v0 ?v1))) (f30 f31 (f32 ?v2 ?v3))) (f30 f31 (f32 (+ (f4 ?v_0 ?v2) (f4 ?v_1 ?v3)) (- (f4 ?v_0 ?v3) (f4 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (=> (= (f28 (f4 ?v_0 ?v1) (f4 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f28 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f28 ?v0 ?v1) f1) (= (= (f28 ?v0 (+ ?v2 ?v3)) f1) (= (f28 ?v0 (+ (+ ?v2 (f4 (f5 f6 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f28 (f4 (f5 f6 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f28 ?v0 (+ ?v1 (f4 (f5 f6 ?v0) ?v2))) f1) (= (f28 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 S5)) (=> (<= 0 ?v0) (= (f10 f11 (f8 (f21 f22 ?v0) ?v1)) (f36 (f34 f37 (f10 f11 ?v0)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 (f21 f22 (f8 f9 ?v0)) ?v1) (f8 f9 (f36 (f34 f37 ?v0) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f8 f9 (f36 (f34 f37 ?v0) ?v1)) (f8 (f21 f22 (f8 f9 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f10 f11 (f4 (f5 f6 ?v0) ?v1)) (f10 f11 (f4 (f5 f6 (f8 f9 (f10 f11 (- ?v0)))) (f8 f9 (f10 f11 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f10 f11 (f4 (f5 f6 ?v0) ?v1)) (f10 f11 (f4 (f5 f6 (f8 f9 (f10 f11 ?v0))) (f8 f9 (f10 f11 ?v1))))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f4 (f5 f6 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f4 (f5 f6 (f8 f9 ?v0)) (f8 f9 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f4 (f5 f6 ?v0) ?v1))) (= (f10 f11 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f10 f11 (f4 (f5 f6 (f8 f9 (f10 f11 (ite (< ?v0 0) (- ?v0) ?v0)))) (f8 f9 (f10 f11 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f8 (f21 f22 (f8 ?v_0 ?v1)) ?v2) (f8 ?v_0 (f10 f11 (f4 (f5 f6 (f8 f9 ?v1)) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (=> (= (f15 ?v0) f1) (=> (= (f28 ?v0 (f8 (f21 f22 ?v1) ?v2)) f1) (= (f28 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f8 (f21 f22 ?v0) ?v2))) (=> (= (f15 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (f4 (f5 f6 ?v1) ?v3)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5) (?v3 Int)) (let ((?v_0 (f8 (f21 f22 ?v0) ?v2))) (=> (= (f15 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (=> (= (f28 ?v_0 (f4 (f5 f6 ?v3) ?v1)) f1) (= (f28 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f34 f35 ?v0))) (= (f36 (f34 f35 (f36 ?v_0 ?v1)) (f36 (f34 f35 ?v2) ?v3)) (f36 (f34 f35 (f36 ?v_0 ?v2)) (f36 (f34 f35 ?v1) ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) (f4 (f5 f6 ?v2) ?v3)) (f4 (f5 f6 (f4 ?v_0 ?v2)) (f4 (f5 f6 ?v1) ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_1 (f34 f35 (f36 (f34 f35 ?v0) ?v1))) (?v_0 (f34 f35 ?v2))) (= (f36 ?v_1 (f36 ?v_0 ?v3)) (f36 ?v_0 (f36 ?v_1 ?v3))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_1 (f5 f6 (f4 (f5 f6 ?v0) ?v1))) (?v_0 (f5 f6 ?v2))) (= (f4 ?v_1 (f4 ?v_0 ?v3)) (f4 ?v_0 (f4 ?v_1 ?v3))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5) (?v3 S5)) (let ((?v_0 (f34 f35 ?v0)) (?v_1 (f36 (f34 f35 ?v2) ?v3))) (= (f36 (f34 f35 (f36 ?v_0 ?v1)) ?v_1) (f36 ?v_0 (f36 (f34 f35 ?v1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f5 f6 ?v0)) (?v_1 (f4 (f5 f6 ?v2) ?v3))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v_1) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f34 f35 ?v0))) (= (f36 (f34 f35 (f36 ?v_0 ?v1)) ?v2) (f36 (f34 f35 (f36 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 (f5 f6 (f4 ?v_0 ?v2)) ?v1)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f34 f35 ?v0))) (= (f36 (f34 f35 (f36 ?v_0 ?v1)) ?v2) (f36 ?v_0 (f36 (f34 f35 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2) (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f34 f35 ?v0))) (= (f36 ?v_0 (f36 (f34 f35 ?v1) ?v2)) (f36 (f34 f35 (f36 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f5 f6 ?v0))) (= (f4 ?v_0 (f4 (f5 f6 ?v1) ?v2)) (f4 (f5 f6 (f4 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_1 (f34 f35 ?v0)) (?v_0 (f34 f35 ?v1))) (= (f36 ?v_1 (f36 ?v_0 ?v2)) (f36 ?v_0 (f36 ?v_1 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_1 (f5 f6 ?v0)) (?v_0 (f5 f6 ?v1))) (= (f4 ?v_1 (f4 ?v_0 ?v2)) (f4 ?v_0 (f4 ?v_1 ?v2))))))
(assert (forall ((?v0 S5) (?v1 S5)) (= (f36 (f34 f35 ?v0) ?v1) (f36 (f34 f35 ?v1) ?v0))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f6 ?v0) ?v1) (f4 (f5 f6 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (= (f8 (f21 f22 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 S5)) (= (f36 (f34 f37 ?v0) (f10 f11 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S5) (?v2 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f4 (f5 f6 (f8 ?v_0 ?v1)) (f8 ?v_0 ?v2)) (f8 ?v_0 (f10 f11 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (let ((?v_0 (f34 f37 ?v0))) (= (f36 (f34 f35 (f36 ?v_0 ?v1)) (f36 ?v_0 ?v2)) (f36 ?v_0 (f10 f11 (+ (f8 f9 ?v1) (f8 f9 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S5)) (= (f8 (f21 f22 (f4 (f5 f6 ?v0) ?v1)) ?v2) (f4 (f5 f6 (f8 (f21 f22 ?v0) ?v2)) (f8 (f21 f22 ?v1) ?v2)))))
(assert (forall ((?v0 S5) (?v1 S5) (?v2 S5)) (= (f36 (f34 f37 (f36 (f34 f35 ?v0) ?v1)) ?v2) (f36 (f34 f35 (f36 (f34 f37 ?v0) ?v2)) (f36 (f34 f37 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f4 (f5 f6 (f8 ?v_0 ?v1)) ?v0) (f8 ?v_0 (f10 f11 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f34 f37 ?v0))) (= (f36 (f34 f35 (f36 ?v_0 ?v1)) ?v0) (f36 ?v_0 (f10 f11 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f10 f11 (* 2 (f8 f9 ?v1)))) (f4 (f5 f6 ?v_1) ?v_1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f34 f37 ?v0))) (let ((?v_1 (f36 ?v_0 ?v1))) (= (f36 ?v_0 (f10 f11 (* 2 (f8 f9 ?v1)))) (f36 (f34 f35 ?v_1) ?v_1))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f4 (f5 f6 ?v0) (f8 ?v_0 ?v1)) (f8 ?v_0 (f10 f11 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f34 f37 ?v0))) (= (f36 (f34 f35 ?v0) (f36 ?v_0 ?v1)) (f36 ?v_0 (f10 f11 (+ (f8 f9 ?v1) 1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (let ((?v_1 (f8 ?v_0 ?v1))) (= (f8 ?v_0 (f10 f11 (+ (* 2 (f8 f9 ?v1)) 1))) (f4 (f5 f6 ?v0) (f4 (f5 f6 ?v_1) ?v_1)))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f34 f37 ?v0))) (let ((?v_1 (f36 ?v_0 ?v1))) (= (f36 ?v_0 (f10 f11 (+ (* 2 (f8 f9 ?v1)) 1))) (f36 (f34 f35 ?v0) (f36 (f34 f35 ?v_1) ?v_1)))))))
(assert (forall ((?v0 Int) (?v1 S5)) (let ((?v_0 (f21 f22 ?v0))) (= (f8 ?v_0 (f10 f11 (+ (f8 f9 ?v1) 1))) (f4 (f5 f6 ?v0) (f8 ?v_0 ?v1))))))
(assert (forall ((?v0 S5) (?v1 S5)) (let ((?v_0 (f34 f37 ?v0))) (= (f36 ?v_0 (f10 f11 (+ (f8 f9 ?v1) 1))) (f36 (f34 f35 ?v0) (f36 ?v_0 ?v1))))))
(assert (forall ((?v0 Int)) (= (= (f3 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f30 f31 (f32 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f15 ?v0) f1) (=> (not (= (f28 ?v0 ?v1) f1)) (= (f29 (f8 (f21 f22 ?v1) (f10 f11 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f4 (f5 f16 ?v0) ?v1) (ite (= (f29 ?v0 0 ?v1) f1) 0 (ite (= (f17 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 S5)) (= (f10 f11 (f8 f9 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f8 f9 (f10 f11 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f8 f9 (f10 f11 ?v0)) 0))))
(check-sat)
(exit)
