(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-sort S6 0)
(declare-sort S7 0)
(declare-sort S8 0)
(declare-sort S9 0)
(declare-sort S10 0)
(declare-sort S11 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (S2 S3) Int)
(declare-fun f4 () S2)
(declare-fun f5 () S3)
(declare-fun f6 () S3)
(declare-fun f7 (S4 Int) S3)
(declare-fun f8 () S4)
(declare-fun f9 () Int)
(declare-fun f10 (Int) S1)
(declare-fun f11 (S5 Int) Int)
(declare-fun f12 (S6 Int) S5)
(declare-fun f13 () S6)
(declare-fun f14 () Int)
(declare-fun f15 () Int)
(declare-fun f16 () S3)
(declare-fun f17 () Int)
(declare-fun f18 () Int)
(declare-fun f19 () Int)
(declare-fun f20 () Int)
(declare-fun f21 () Int)
(declare-fun f22 () Int)
(declare-fun f23 (Int) S1)
(declare-fun f24 () S6)
(declare-fun f25 (S7 Int) S2)
(declare-fun f26 () S7)
(declare-fun f27 () Int)
(declare-fun f28 (Int Int) S1)
(declare-fun f29 (Int Int) S1)
(declare-fun f30 (Int Int Int) S1)
(declare-fun f31 (S8 S9) Int)
(declare-fun f32 () S8)
(declare-fun f33 (Int Int) S9)
(declare-fun f34 () Int)
(declare-fun f35 (S3 S3) S1)
(declare-fun f36 (S10 S3) S3)
(declare-fun f37 (S11 S3) S10)
(declare-fun f38 () S11)
(declare-fun f39 () S5)
(declare-fun f40 () S11)
(assert (not (= f1 f2)))
(assert (not (< (f3 f4 f5) (f3 f4 f6))))
(assert (and (= f5 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1))) (= (f10 (f11 (f12 f13 (+ (* 4 f14) 1)) (+ 1 (f3 f4 f5)))) f1)))
(assert (< f9 (+ 1 (f3 f4 f6))))
(assert (< 0 f9))
(assert (not (= (f10 (f11 (f12 f13 (+ (* 4 f14) 1)) (+ 1 0))) f1)))
(assert (= (+ 1 (f3 f4 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1)))) f9))
(assert (< 1 f15))
(assert (< 0 (+ (* 4 f14) 1)))
(assert (< f9 (+ 1 (f3 f4 f6))))
(assert (< 0 (f3 f4 f6)))
(assert (< 0 (+ 1 (f3 f4 f6))))
(assert (and (= f5 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1))) (= (f10 (f11 (f12 f13 (+ (* 4 f14) 1)) (+ 1 (f3 f4 f5)))) f1)))
(assert (let ((?v_0 (+ (* 4 f14) 1)) (?v_1 (+ 1 (f3 f4 f6)))) (not (=> (< ?v_1 ?v_0) (not (= (f10 (f11 (f12 f13 ?v_0) ?v_1)) f1))))))
(assert (= f16 (f7 f8 (- (f3 f4 (f7 f8 f15)) 1))))
(assert (let ((?v_0 (+ (* 4 f14) 1)) (?v_1 (+ 1 (f3 f4 f6)))) (and (< ?v_1 ?v_0) (= (f10 (f11 (f12 f13 ?v_0) ?v_1)) f1))))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f6)))) (=> (and (= ?v1 (- f17 (f11 (f12 f13 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (+ 1 (f3 f4 f6)))) (=> (and (= ?v1 (- f18 (f11 (f12 f13 ?v0) ?v_0))) (<= (ite (< ?v1 0) (* (- 2) ?v1) (* 2 ?v1)) ?v_0)) false))) false))
(assert (let ((?v_0 (+ 1 (f3 f4 f6)))) (and (= f19 (- f17 (f11 (f12 f13 f20) ?v_0))) (<= (ite (< f19 0) (* (- 2) f19) (* 2 f19)) ?v_0))))
(assert (let ((?v_0 (+ 1 (f3 f4 f6)))) (and (= f21 (- f18 (f11 (f12 f13 f22) ?v_0))) (<= (ite (< f21 0) (* (- 2) f21) (* 2 f21)) ?v_0))))
(assert (= (f23 (+ (* 4 f14) 1)) f1))
(assert (= (f11 (f12 f24 (- 1)) (+ (* 4 f14) 1)) 1))
(assert (<= 1 f15))
(assert (=> (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f25 f26 ?v0) ?v_0) (f3 (f25 f26 ?v1) ?v_0)) (f11 (f12 f13 (+ (* 4 f14) 1)) (+ 1 (f3 f4 f6)))) false))) false))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f25 f26 f17) ?v_0) (f3 (f25 f26 f18) ?v_0)) (f11 (f12 f13 (+ (* 4 f14) 1)) (+ 1 (f3 f4 f6))))))
(assert (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f25 f26 f19) ?v_0) (f3 (f25 f26 f21) ?v_0)) (f11 (f12 f13 (+ 1 (f3 f4 f6))) f9))))
(assert (< 0 f9))
(assert (< 0 (f3 f4 f16)))
(assert (< f15 (+ (* 4 f14) 1)))
(assert (=> (forall ((?v0 S3)) (=> (= ?v0 (f7 f8 (- (f3 f4 (f7 f8 f15)) 1))) (=> (< 0 (f3 f4 ?v0)) false))) false))
(assert (= (f10 (f11 (f12 f13 (+ (* 4 f14) 1)) (+ 1 (f3 f4 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1)))))) f1))
(assert (= (f10 (f11 (f12 f13 (+ (* 4 f14) 1)) f9)) f1))
(assert (= (f10 (f11 (f12 f13 (+ (* 4 f14) 1)) f15)) f1))
(assert (=> (forall ((?v0 S3)) (=> (and (= ?v0 (f7 f8 (- (f3 f4 (f7 f8 f9)) 1))) (= (f10 (f11 (f12 f13 (+ (* 4 f14) 1)) (+ 1 (f3 f4 ?v0)))) f1)) false)) false))
(assert (= (+ (f3 (f25 f26 f27) (f7 f8 2)) 1) (f11 (f12 f13 (+ (* 4 f14) 1)) f15)))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2))) (=> (= (+ (f3 (f25 f26 f19) ?v_0) (f3 (f25 f26 f21) ?v_0)) (f11 (f12 f13 (+ 1 (f3 f4 f6))) ?v0)) false))) false))
(assert (let ((?v_0 (f12 f13 f20)) (?v_1 (f12 f13 f22)) (?v_2 (f7 f8 2))) (= (+ (f3 (f25 f26 (+ (+ (f11 ?v_0 f19) (f11 ?v_1 f21)) f9)) ?v_2) (f3 (f25 f26 (- (f11 ?v_0 f21) (f11 ?v_1 f19))) ?v_2)) (f11 (f12 f13 (+ (* 4 f14) 1)) f9))))
(assert (=> (= f15 1) (exists ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (+ (f3 (f25 f26 ?v0) ?v_0) (f3 (f25 f26 ?v1) ?v_0)) (+ (* 4 f14) 1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 ?v0) 1))) (=> (= (f23 ?v_0) f1) (= (f11 (f12 f24 (- 1)) ?v_0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f10 ?v0) f1) (=> (= (f10 ?v1) f1) (= (f10 (f11 (f12 f13 ?v0) ?v1)) f1)))))
(assert (let ((?v_0 (+ (* 4 f14) 1))) (=> (not (= (f28 ?v_0 (- 1)) f1)) (not (= (f11 (f12 f24 (- 1)) ?v_0) 1)))))
(assert (= (f28 (+ (* 4 f14) 1) (- 1)) f1))
(assert (let ((?v_0 (f7 f8 2))) (= (f29 (+ 1 (f3 f4 f6)) (+ (f3 (f25 f26 f19) ?v_0) (f3 (f25 f26 f21) ?v_0))) f1)))
(assert (=> (forall ((?v0 Int)) (=> (= (+ (f3 (f25 f26 f27) (f7 f8 2)) 1) (f11 (f12 f13 (+ (* 4 f14) 1)) ?v0)) false)) false))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f11 (f12 f13 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f25 f26 ?v0))) (= (f11 (f12 f13 ?v0) (f3 ?v_0 (f7 f8 2))) (f3 ?v_0 (f7 f8 3))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f25 f26 (+ ?v0 ?v1)) ?v_0) (+ (+ (f3 (f25 f26 ?v0) ?v_0) (f11 (f12 f13 (* 2 ?v0)) ?v1)) (f3 (f25 f26 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f3 (f25 f26 (- ?v0 ?v1)) ?v_0) (+ (- (f3 (f25 f26 ?v0) ?v_0) (f11 (f12 f13 (* 2 ?v0)) ?v1)) (f3 (f25 f26 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_1 (f25 f26 ?v0)) (?v_3 (f25 f26 ?v1))) (= (f3 (f25 f26 (+ ?v0 ?v1)) ?v_0) (+ (+ (+ (f3 ?v_1 ?v_0) (f11 (f12 f13 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f11 (f12 f13 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_2 (f7 f8 2)) (?v_0 (f7 f8 3)) (?v_3 (f25 f26 ?v1)) (?v_1 (f25 f26 ?v0))) (= (f3 (f25 f26 (- ?v0 ?v1)) ?v_0) (- (+ (- (f3 ?v_1 ?v_0) (f11 (f12 f13 (* 3 (f3 ?v_1 ?v_2))) ?v1)) (f11 (f12 f13 (* 3 ?v0)) (f3 ?v_3 ?v_2))) (f3 ?v_3 ?v_0))))))
(assert (let ((?v_0 (f3 (f25 f26 f27) (f7 f8 2)))) (= (- ?v_0 (- 1)) (+ ?v_0 1))))
(assert (= (f29 (+ (* 4 f14) 1) (- (f3 (f25 f26 f27) (f7 f8 2)) (- 1))) f1))
(assert (= (f29 (+ (* 4 f14) 1) (+ (f3 (f25 f26 f27) (f7 f8 2)) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0 (- ?v1 ?v2)) f1) (=> (= (f29 ?v0 ?v2) f1) (= (f29 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v1 ?v0) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (< 0 ?v1) (<= ?v0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f29 ?v1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (<= 0 ?v1) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v1 ?v0) f1) (= ?v0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (=> (= (f29 ?v1 ?v0) f1) (<= (ite (< ?v1 0) (- ?v1) ?v1) (ite (< ?v0 0) (- ?v0) ?v0))))))
(assert (forall ((?v0 Int)) (= (= (f29 ?v0 1) f1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (=> (= (f29 (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) f1) (=> (not (= ?v0 0)) (= (f29 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f29 ?v0 ?v1) f1) (= (= (f29 ?v0 (+ ?v2 ?v3)) f1) (= (f29 ?v0 (+ (+ ?v2 (f11 (f12 f13 ?v4) ?v1)) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (not (= ?v0 0)) (= (= (f29 (f11 (f12 f13 ?v0) ?v1) ?v0) f1) (= (ite (< ?v1 0) (- ?v1) ?v1) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f29 ?v0 (+ ?v1 (f11 (f12 f13 ?v0) ?v2))) f1) (= (f29 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f23 ?v0) f1) (=> (= (f29 ?v0 (f3 (f25 f26 ?v1) ?v2)) f1) (= (f29 ?v0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f25 f26 ?v0) ?v2))) (=> (= (f23 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (=> (= (f29 ?v_0 (f11 (f12 f13 ?v3) ?v1)) f1) (= (f29 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 Int)) (let ((?v_0 (f3 (f25 f26 ?v0) ?v2))) (=> (= (f23 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (=> (= (f29 ?v_0 (f11 (f12 f13 ?v1) ?v3)) f1) (= (f29 ?v_0 ?v3) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 (f12 f13 ?v0) ?v1) 1) (or (= ?v0 1) (= ?v0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v1))) (=> (= (ite (< ?v_0 0) (- ?v_0) ?v_0) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (let ((?v_0 (f3 f4 ?v2))) (let ((?v_1 (f12 f13 ?v_0))) (=> (< ?v0 ?v1) (=> (< 0 ?v_0) (< (f11 ?v_1 ?v0) (f11 ?v_1 ?v1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v2))) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (< (f11 ?v_0 ?v0) (f11 ?v_0 ?v1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< 0 (f11 (f12 f13 ?v0) ?v1)) (< 0 ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (= (= (f11 (f12 f13 ?v0) ?v1) 1) (and (= ?v0 1) (= ?v1 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f13 (- ?v0 ?v1)) ?v2) (- (f11 (f12 f13 ?v0) ?v2) (f11 (f12 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f11 (f12 f13 (+ ?v0 ?v1)) ?v2) (+ (f11 (f12 f13 ?v0) ?v2) (f11 (f12 f13 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 (f12 f13 (f11 ?v_0 ?v1)) ?v2) (f11 ?v_0 (f11 (f12 f13 ?v1) ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f11 (f12 f13 ?v0) ?v1) 1) (or (and (= ?v0 1) (= ?v1 1)) (and (= ?v0 (- 1)) (= ?v1 (- 1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 (- ?v0)) ?v1) (- (f11 (f12 f13 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 ?v_0 (- ?v1 ?v2)) (- (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (= (f11 ?v_0 (+ ?v1 ?v2)) (+ (f11 ?v_0 ?v1) (f11 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f13 ?v0) ?v1) (f11 (f12 f13 ?v1) ?v0))))
(assert (forall ((?v0 Int)) (=> (= (f3 (f25 f26 ?v0) (f7 f8 2)) 1) (= (ite (< ?v0 0) (- ?v0) ?v0) 1))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (= (f3 (f25 f26 ?v0) ?v_0) (f3 (f25 f26 ?v1) ?v_0)) (= (ite (< ?v0 0) (- ?v0) ?v0) (ite (< ?v1 0) (- ?v1) ?v1))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 2)) (?v_1 (f25 f26 ?v0))) (= (f3 (f25 f26 (f3 ?v_1 ?v_0)) ?v_0) (f3 ?v_1 (f7 f8 4))))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f7 f8 3))) (= (f3 (f25 f26 (- ?v0)) ?v_0) (- (f3 (f25 f26 ?v0) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (< 0 (f3 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1)) (or (not (= ?v0 0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 3))) (let ((?v_0 (f3 (f25 f26 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (let ((?v_1 (f7 f8 2))) (let ((?v_0 (f3 (f25 f26 ?v0) ?v_1))) (= (ite (< ?v_0 0) (- ?v_0) ?v_0) (f3 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v_1))))))
(assert (forall ((?v0 Int)) (<= ?v0 (f3 (f25 f26 ?v0) (f7 f8 2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (<= 0 (f3 (f25 f26 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1))))
(assert (= (f23 2) f1))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f7 f8 2))) (= (f11 (f12 f13 (+ ?v0 ?v1)) (- ?v0 ?v1)) (- (f3 (f25 f26 ?v0) ?v_0) (f3 (f25 f26 ?v1) ?v_0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f23 ?v0) f1) (=> (= (f29 ?v0 (f3 (f25 f26 ?v1) ?v2)) f1) (=> (< 0 (f3 f4 ?v2)) (= (f29 ?v0 ?v1) f1))))))
(assert (= (f30 (f3 (f25 f26 f27) (f7 f8 2)) (- 1) (+ (* 4 f14) 1)) f1))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (= (f23 ?v1) f1) (=> (= (f29 ?v1 (f11 (f12 f13 ?v0) ?v2)) f1) (or (= (f29 ?v1 ?v0) f1) (= (f29 ?v1 ?v2) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f23 ?v0) f1) (=> (= (f29 ?v0 (f11 (f12 f13 ?v1) ?v2)) f1) (or (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 ?v2) f1))))))
(assert (forall ((?v0 Int)) (=> (< 1 ?v0) (exists ((?v1 Int)) (and (= (f23 ?v1) f1) (= (f29 ?v1 ?v0) f1))))))
(assert (= (f31 f32 (f33 f27 1)) (f11 (f12 f13 (+ (* 4 f14) 1)) f15)))
(assert (let ((?v_0 (+ (* 4 f14) 1))) (and (<= 0 f27) (and (< f27 ?v_0) (= (f30 f34 f27 ?v_0) f1)))))
(assert (forall ((?v0 Int)) (= (= (f23 ?v0) f1) (and (< 1 ?v0) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (= (f29 ?v1 ?v0) f1)) (or (= ?v1 1) (= ?v1 ?v0))))))))
(assert (= (f30 (f3 (f25 f26 f34) (f7 f8 2)) (- 1) (+ (* 4 f14) 1)) f1))
(assert (=> (forall ((?v0 Int)) (=> (= (f30 (f3 (f25 f26 ?v0) (f7 f8 2)) (- 1) (+ (* 4 f14) 1)) f1) false)) false))
(assert (let ((?v_0 (f7 f8 2))) (= (f30 (f3 (f25 f26 f27) ?v_0) (f3 (f25 f26 f34) ?v_0) (+ (* 4 f14) 1)) f1)))
(assert (exists ((?v0 Int)) (let ((?v_0 (+ (* 4 f14) 1))) (and (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f30 f34 ?v0 ?v_0) f1))) (forall ((?v1 Int)) (=> (and (<= 0 ?v1) (and (< ?v1 ?v_0) (= (f30 f34 ?v1 ?v_0) f1))) (= ?v1 ?v0)))))))
(assert (=> (forall ((?v0 Int)) (let ((?v_0 (+ (* 4 f14) 1))) (=> (and (<= 0 ?v0) (and (< ?v0 ?v_0) (= (f30 f34 ?v0 ?v_0) f1))) false))) false))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (= (f29 ?v2 (- ?v0 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 0 ?v1) f1) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (f11 (f12 f13 ?v0) ?v3) (f11 (f12 f13 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f13 ?v3))) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f11 ?v_0 ?v0) (f11 ?v_0 ?v1) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f11 (f12 f13 ?v0) ?v3) (f11 (f12 f13 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (let ((?v_0 (f12 f13 ?v4))) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (= (f30 ?v3 (f11 ?v_0 ?v0) ?v2) f1) (= (f30 ?v3 (f11 ?v_0 ?v1) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (= (f30 ?v3 (f11 (f12 f13 ?v0) ?v4) ?v2) f1) (= (f30 ?v3 (f11 (f12 f13 ?v1) ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (f30 (f11 (f12 f13 ?v0) ?v1) (f11 (f12 f13 ?v2) ?v1) ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (exists ((?v3 Int)) (= ?v1 (+ ?v0 (f11 (f12 f13 ?v2) ?v3)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 S3)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (f3 (f25 f26 ?v0) ?v3) (f3 (f25 f26 ?v1) ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f30 ?v0 ?v1 0) f1) (= ?v0 ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 ?v1 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (= (= (f30 ?v0 ?v1 (- ?v2)) f1) (= (f30 ?v0 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int)) (= (f30 ?v0 0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 ?v1 1) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f30 ?v0 ?v0 ?v1) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< 0 ?v1) (=> (< 0 ?v2) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (< ?v0 ?v2) (=> (< ?v1 ?v2) (= ?v0 ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (not (= (f30 ?v0 0 ?v1) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (< 0 ?v0) (=> (< ?v0 ?v1) (=> (< 0 ?v2) (=> (< ?v2 ?v0) (not (= (f30 ?v0 ?v2 ?v1) f1))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (<= 0 ?v2) (=> (< ?v2 ?v1) (=> (= (f30 ?v0 ?v2 ?v1) f1) (= ?v0 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f30 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (=> (< ?v0 ?v1) (=> (= (f30 ?v0 0 ?v1) f1) (= ?v0 0))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (< 2 ?v0) (=> (= (f30 ?v1 (- 1) ?v0) f1) (not (= (f30 ?v1 1 ?v0) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (= (f30 (+ ?v0 ?v3) (+ ?v1 ?v3) ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= ?v1 ?v3) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 ?v0 ?v4 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v1 ?v3 ?v2) f1) (= (f30 ?v0 ?v3 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (+ ?v0 ?v3) (+ ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int)) (=> (= (f30 ?v0 ?v1 ?v2) f1) (=> (= (f30 ?v3 ?v4 ?v2) f1) (= (f30 (- ?v0 ?v3) (- ?v1 ?v4) ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (let ((?v_0 (f12 f13 ?v0)) (?v_1 (f12 f13 ?v1))) (= (f11 (f12 f13 (f31 f32 (f33 ?v0 ?v1))) (f31 f32 (f33 ?v2 ?v3))) (f31 f32 (f33 (+ (f11 ?v_0 ?v2) (f11 ?v_1 ?v3)) (- (f11 ?v_0 ?v3) (f11 ?v_1 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f23 ?v0) f1) (=> (not (= (f30 ?v1 0 ?v0) f1)) (=> (not (= (f30 ?v2 0 ?v0) f1)) (not (= (f30 (f11 (f12 f13 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0) f1) (=> (< 0 ?v1) (=> (< ?v1 ?v0) (=> (= (f30 (f11 (f12 f13 ?v1) ?v1) 1 ?v0) f1) (or (= ?v1 1) (= ?v1 (- ?v0 1)))))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f23 ?v0) f1) (=> (< 0 ?v1) (=> (and (not (= (f30 ?v1 0 ?v0) f1)) (not (= (f30 ?v2 0 ?v0) f1))) (not (= (f30 (f11 (f12 f13 ?v1) ?v2) 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f23 ?v0) f1) (=> (< 0 ?v1) (=> (= (f30 (f11 (f12 f13 ?v1) ?v2) 0 ?v0) f1) (or (= (f30 ?v1 0 ?v0) f1) (= (f30 ?v2 0 ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0) f1) (=> (< 0 ?v1) (=> (= (f30 (f11 (f12 f13 ?v1) ?v1) 1 ?v0) f1) (or (= (f30 ?v1 1 ?v0) f1) (= (f30 ?v1 (- ?v0 1) ?v0) f1)))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int) (?v4 Int) (?v5 Int) (?v6 Int)) (let ((?v_0 (f12 f13 ?v1))) (= (+ (f11 (f12 f13 (- ?v0 (f11 ?v_0 ?v2))) ?v3) (f11 (f12 f13 (- ?v4 (f11 ?v_0 ?v5))) ?v6)) (- (+ (f11 (f12 f13 ?v0) ?v3) (f11 (f12 f13 ?v4) ?v6)) (f11 ?v_0 (+ (f11 (f12 f13 ?v2) ?v3) (f11 (f12 f13 ?v5) ?v6))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (or (<= ?v1 0) (<= ?v0 ?v1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f29 ?v1 ?v2) f1) (= (f29 ?v1 (f3 (f25 f26 ?v2) ?v0)) f1)))))
(assert (forall ((?v0 Int)) (= (= (f10 ?v0) f1) (exists ((?v1 Int) (?v2 Int)) (= (f31 f32 (f33 ?v1 ?v2)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f23 ?v0) f1) (=> (not (= (f29 ?v0 ?v1) f1)) (= (f30 (f3 (f25 f26 ?v1) (f7 f8 (- ?v0 1))) 1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 (f12 f24 ?v0) ?v1) (ite (= (f30 ?v0 0 ?v1) f1) 0 (ite (= (f28 ?v1 ?v0) f1) 1 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f28 ?v0 ?v1) f1) (exists ((?v2 Int)) (= (f30 (f3 (f25 f26 ?v2) (f7 f8 2)) ?v1 ?v0) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (not (= (f30 ?v0 0 ?v1) f1)) (=> (= (f30 (f3 (f25 f26 ?v2) (f7 f8 2)) ?v0 ?v1) f1) (not (= (f29 ?v1 ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f25 f26 ?v1)) (?v_1 (f7 f8 ?v0))) (=> (< 0 ?v0) (= (f3 ?v_0 ?v_1) (f11 (f12 f13 ?v1) (f3 ?v_0 (f7 f8 (- (f3 f4 ?v_1) 1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int)) (=> (= (f29 (f3 (f25 f26 ?v0) ?v1) (f3 (f25 f26 ?v2) ?v1)) f1) (=> (not (= ?v1 (f7 f8 0))) (= (f29 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 Int) (?v2 Int)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f29 (f3 (f25 f26 ?v1) ?v0) (f3 (f25 f26 ?v2) ?v0)) f1) (= (f29 ?v1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 (- 1)))) (let ((?v_1 (f3 ?v_0 ?v1)) (?v_2 (f3 ?v_0 ?v2))) (=> (< 2 ?v0) (=> (= (f30 ?v_1 ?v_2 ?v0) f1) (= ?v_1 ?v_2)))))))
(assert (forall ((?v0 Int)) (=> (< 2 ?v0) (not (= (f30 1 (- 1) ?v0) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f3 (f25 f26 (- 1)) ?v0))) (or (= ?v_0 1) (= ?v_0 (- 1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (f12 f13 ?v0))) (=> (not (= ?v0 0)) (= (= (f29 ?v1 ?v2) f1) (= (f29 (f11 ?v_0 ?v1) (f11 ?v_0 ?v2)) f1))))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (- ?v1 1))) (= (= (f30 (f11 (f12 f13 ?v0) ?v_0) 1 ?v1) f1) (= (f30 ?v0 ?v_0 ?v1) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (=> (= (f29 ?v0 ?v1) f1) (= (f29 (f3 (f25 f26 ?v0) ?v2) (f3 (f25 f26 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f35 ?v0 ?v1) f1) (= (f35 (f36 (f37 f38 ?v0) ?v2) (f36 (f37 f38 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (= (f35 ?v0 ?v1) f1) (= (f29 (f3 f4 ?v0) (f3 f4 ?v1)) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f29 ?v0 (f3 f4 ?v1)) f1) (= (f35 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)) ?v1) f1))))
(assert (forall ((?v0 S3) (?v1 Int)) (= (= (f29 (f3 f4 ?v0) ?v1) f1) (= (f35 ?v0 (f7 f8 (ite (< ?v1 0) (- ?v1) ?v1))) f1))))
(assert (forall ((?v0 Int) (?v1 S3)) (= (= (f35 (f7 f8 ?v0) ?v1) f1) (ite (<= 0 ?v0) (= (f29 ?v0 (f3 f4 ?v1)) f1) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 f4 (f36 (f37 f38 ?v0) ?v1)) (f3 (f25 f26 (f3 f4 ?v0)) ?v1))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f3 (f25 f26 (f3 f4 ?v0)) ?v1) (f3 f4 (f36 (f37 f38 ?v0) ?v1)))))
(assert (forall ((?v0 Int) (?v1 S3)) (=> (<= 0 ?v0) (= (f7 f8 (f3 (f25 f26 ?v0) ?v1)) (f36 (f37 f38 (f7 f8 ?v0)) ?v1)))))
(assert (forall ((?v0 Int)) (= (f3 (f25 f26 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f36 (f37 f38 ?v0) (f7 f8 1)) ?v0)))
(assert (forall ((?v0 Int) (?v1 S3)) (= (f11 f39 (f3 (f25 f26 ?v0) ?v1)) (f3 (f25 f26 (f11 f39 ?v0)) ?v1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v1 ?v2))) (=> (< 0 ?v0) (< (- ?v1 (f11 (f12 f13 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)) ?v2)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (let ((?v_0 (- ?v2 ?v1))) (=> (< 0 ?v0) (< ?v1 (+ ?v2 (f11 (f12 f13 (+ (ite (< ?v_0 0) (- ?v_0) ?v_0) 1)) ?v0)))))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1) f1) (= (f29 (- ?v0) ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 (- ?v1)) f1))))
(assert (forall ((?v0 Int)) (=> (= (f23 ?v0) f1) (=> (not (= ?v0 2)) (=> (not (= ?v0 3)) (<= 5 ?v0))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3)) (= (f3 (f25 f26 (f11 (f12 f13 ?v0) ?v1)) ?v2) (f11 (f12 f13 (f3 (f25 f26 ?v0) ?v2)) (f3 (f25 f26 ?v1) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (= (f36 (f37 f38 (f36 (f37 f40 ?v0) ?v1)) ?v2) (f36 (f37 f40 (f36 (f37 f38 ?v0) ?v2)) (f36 (f37 f38 ?v1) ?v2)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f3 (f25 f26 ?v0) ?v1))) (= (f11 (f12 f13 ?v_0) ?v0) (f11 (f12 f13 ?v0) ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f36 (f37 f38 ?v0) ?v1))) (= (f36 (f37 f40 ?v_0) ?v0) (f36 (f37 f40 ?v0) ?v_0)))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f11 (f12 f13 (f3 ?v_0 ?v1)) (f3 ?v_0 ?v2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (= (f36 ?v_0 (f7 f8 (+ (f3 f4 ?v1) (f3 f4 ?v2)))) (f36 (f37 f40 (f36 ?v_0 ?v1)) (f36 ?v_0 ?v2))))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f4 ?v1) 1))) (f11 (f12 f13 (f3 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f38 ?v0))) (= (f36 ?v_0 (f7 f8 (+ (f3 f4 ?v1) 1))) (f36 (f37 f40 (f36 ?v_0 ?v1)) ?v0)))))
(assert (forall ((?v0 Int) (?v1 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f3 ?v_0 (f7 f8 (+ (f3 f4 ?v1) 1))) (f11 (f12 f13 ?v0) (f3 ?v_0 ?v1))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f37 f38 ?v0))) (= (f36 ?v_0 (f7 f8 (+ (f3 f4 ?v1) 1))) (f36 (f37 f40 ?v0) (f36 ?v_0 ?v1))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f29 (f3 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f29 (f3 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f35 (f36 ?v_0 ?v1) ?v2) f1) (=> (<= (f3 f4 ?v3) (f3 f4 ?v1)) (= (f35 (f36 ?v_0 ?v3) ?v2) f1))))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 S3) (?v3 S3)) (=> (= (f29 ?v0 ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f29 (f3 (f25 f26 ?v0) ?v2) (f3 (f25 f26 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f35 ?v0 ?v1) f1) (=> (<= (f3 f4 ?v2) (f3 f4 ?v3)) (= (f35 (f36 (f37 f38 ?v0) ?v2) (f36 (f37 f38 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 Int)) (let ((?v_0 (f25 f26 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f29 (f3 ?v_0 ?v0) (f3 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v2))) (=> (<= (f3 f4 ?v0) (f3 f4 ?v1)) (= (f35 (f36 ?v_0 ?v0) (f36 ?v_0 ?v1)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 (f11 (f12 f13 ?v0) ?v1)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f35 ?v0 (f36 (f37 f40 ?v0) ?v1)) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f29 ?v0 (f11 (f12 f13 ?v1) ?v0)) f1)))
(assert (forall ((?v0 S3) (?v1 S3)) (= (f35 ?v0 (f36 (f37 f40 ?v1) ?v0)) f1)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 (f11 (f12 f13 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f35 ?v0 ?v1) f1) (= (f35 ?v0 (f36 (f37 f40 ?v1) ?v2)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (not (= ?v0 (f7 f8 0))) (= (= (f35 (f36 (f37 f38 ?v1) ?v0) (f36 (f37 f38 ?v2) ?v0)) f1) (= (f35 ?v1 ?v2) f1)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (=> (= (f35 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (< 0 (f3 f4 ?v0)) (=> (= (f35 ?v1 ?v0) f1) (< 0 (f3 f4 ?v1))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (=> (= (f35 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (= (= (f35 ?v0 ?v_0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (= (= (f35 ?v_0 ?v0) f1) (= ?v0 ?v_0)))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (= (not (= ?v0 ?v_0)) (and (= (f35 ?v0 ?v_0) f1) (not (= (f35 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (= (not (= ?v0 ?v_0)) (and (= (f35 ?v_0 ?v0) f1) (not (= (f35 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S3)) (= (f35 ?v0 (f7 f8 0)) f1)))
(assert (forall ((?v0 S3)) (= (f35 (f7 f8 1) ?v0) f1)))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 1))) (not (and (= (f35 ?v0 ?v_0) f1) (not (= (f35 ?v_0 ?v0) f1)))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 0))) (not (and (= (f35 ?v_0 ?v0) f1) (not (= (f35 ?v0 ?v_0) f1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (= (< 0 (f3 f4 (f36 (f37 f38 ?v0) ?v1))) (or (< 0 (f3 f4 ?v0)) (= ?v1 (f7 f8 0))))))
(assert (forall ((?v0 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (f36 (f37 f38 ?v_0) ?v0) ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (= (f36 (f37 f38 ?v0) ?v1) ?v_0) (or (= ?v1 (f7 f8 0)) (= ?v0 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (< 0 (f3 f4 ?v0)) (=> (< (f3 f4 (f36 ?v_0 ?v1)) (f3 f4 (f36 ?v_0 ?v2))) (< (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1))) (=> (<= ?v_0 (f3 f4 ?v0)) (<= ?v_0 (f3 f4 (f36 (f37 f38 ?v0) ?v1)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f3 ?v_0 (f7 f8 (f11 (f12 f13 (f3 f4 ?v1)) (f3 f4 ?v2)))) (f3 (f25 f26 (f3 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (= (f36 ?v_0 (f7 f8 (f11 (f12 f13 (f3 f4 ?v1)) (f3 f4 ?v2)))) (f36 (f37 f38 (f36 ?v_0 ?v1)) ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f37 f38 ?v0))) (=> (= (f35 (f36 ?v_0 ?v1) (f36 ?v_0 ?v2)) f1) (=> (< 1 (f3 f4 ?v0)) (<= (f3 f4 ?v1) (f3 f4 ?v2)))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 S3)) (let ((?v_0 (f25 f26 ?v0))) (= (f3 (f25 f26 (f3 ?v_0 ?v1)) ?v2) (f3 ?v_0 (f7 f8 (f11 (f12 f13 (f3 f4 ?v1)) (f3 f4 ?v2))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= ?v0 0) (= (f7 f8 (f11 (f12 f13 ?v0) ?v1)) (f7 f8 (f11 (f12 f13 (f3 f4 (f7 f8 (- ?v0)))) (f3 f4 (f7 f8 (- ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (<= 0 ?v0) (= (f7 f8 (f11 (f12 f13 ?v0) ?v1)) (f7 f8 (f11 (f12 f13 (f3 f4 (f7 f8 ?v0))) (f3 f4 (f7 f8 ?v1))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f11 (f12 f13 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f11 (f12 f13 (f3 f4 ?v0)) (f3 f4 ?v1)))) (= ?v_0 ?v_0))))
(assert (forall ((?v0 Int) (?v1 Int)) (let ((?v_0 (f11 (f12 f13 ?v0) ?v1))) (= (f7 f8 (ite (< ?v_0 0) (- ?v_0) ?v_0)) (f7 f8 (f11 (f12 f13 (f3 f4 (f7 f8 (ite (< ?v0 0) (- ?v0) ?v0)))) (f3 f4 (f7 f8 (ite (< ?v1 0) (- ?v1) ?v1)))))))))
(assert (forall ((?v0 Int) (?v1 S3) (?v2 Int) (?v3 S3)) (let ((?v_0 (f25 f26 ?v0))) (=> (= (f30 (f3 ?v_0 ?v1) 1 ?v2) f1) (= (f30 (f3 ?v_0 (f7 f8 (f11 (f12 f13 (f3 f4 ?v1)) (f3 f4 ?v3)))) 1 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (f11 f39 (f11 (f12 f13 ?v0) ?v1)) (f11 (f12 f13 (f11 f39 ?v0)) (f11 f39 ?v1)))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f11 f39 ?v0))) (= (f11 (f12 f13 ?v_0) ?v_0) (f11 (f12 f13 ?v0) ?v0)))))
(assert (forall ((?v0 Int)) (= (f29 ?v0 ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f35 ?v0 ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 ?v0 (f11 f39 ?v1)) f1) (= (f29 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int)) (= (= (f29 (f11 f39 ?v0) ?v1) f1) (= (f29 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v1 ?v2) f1) (= (f29 ?v0 ?v2) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f35 ?v0 ?v1) f1) (=> (= (f35 ?v1 ?v2) f1) (= (f35 ?v0 ?v2) f1)))))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f11 f39 ?v0) (f11 f39 ?v1)) (= (f29 ?v0 ?v1) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 (f11 (f12 f13 ?v0) ?v1) ?v2) f1) (= (f29 ?v1 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f35 (f36 (f37 f40 ?v0) ?v1) ?v2) f1) (= (f35 ?v1 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 (f11 (f12 f13 ?v0) ?v1) ?v2) f1) (= (f29 ?v0 ?v2) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f35 (f36 (f37 f40 ?v0) ?v1) ?v2) f1) (= (f35 ?v0 ?v2) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= ?v0 (f11 (f12 f13 ?v1) ?v2)) (= (f29 ?v1 ?v0) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= ?v0 (f36 (f37 f40 ?v1) ?v2)) (= (f35 ?v1 ?v0) f1))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int) (?v3 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (= (f29 ?v2 ?v3) f1) (= (f29 (f11 (f12 f13 ?v0) ?v2) (f11 (f12 f13 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (=> (= (f35 ?v0 ?v1) f1) (=> (= (f35 ?v2 ?v3) f1) (= (f35 (f36 (f37 f40 ?v0) ?v2) (f36 (f37 f40 ?v1) ?v3)) f1)))))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f29 ?v0 ?v1) f1) (= (f29 ?v0 (f11 (f12 f13 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (=> (= (f35 ?v0 ?v1) f1) (= (f35 ?v0 (f36 (f37 f40 ?v2) ?v1)) f1))))
(assert (forall ((?v0 S3)) (= (f35 ?v0 ?v0) f1)))
(assert (forall ((?v0 S3)) (= (f35 (f7 f8 (+ 0 1)) ?v0) f1)))
(assert (forall ((?v0 Int) (?v1 Int)) (=> (= (f29 ?v0 ?v1) f1) (=> (forall ((?v2 Int)) (=> (= ?v1 (f11 (f12 f13 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= (f35 ?v0 ?v1) f1) (=> (forall ((?v2 S3)) (=> (= ?v1 (f36 (f37 f40 ?v0) ?v2)) false)) false))))
(assert (forall ((?v0 Int)) (let ((?v_0 (f3 f4 (f7 f8 (- ?v0 2))))) (=> (<= 5 ?v0) (= (f7 f8 (f11 (f12 f13 ?v_0) ?v_0)) (f7 f8 (+ (f11 (f12 f13 (f3 f4 (f7 f8 (- ?v0 1)))) (f3 f4 (f7 f8 (- ?v0 3)))) 1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_2 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v1))) (=> (< ?v_0 ?v_2) (=> (< ?v_0 ?v_1) (< ?v_0 (f11 (f12 f13 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f11 (f12 f13 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (=> (< ?v_0 ?v_1) (=> (< ?v_0 ?v_2) (< ?v_1 (f11 (f12 f13 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (=> (= ?v0 (f7 f8 (f11 (f12 f13 (f3 f4 ?v0)) (f3 f4 ?v1)))) (or (= ?v1 (f7 f8 1)) (= ?v0 (f7 f8 0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3) (?v3 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_3 (f3 f4 ?v3)) (?v_1 (f3 f4 ?v2))) (=> (<= ?v_0 ?v_2) (=> (<= ?v_1 ?v_3) (<= (f11 (f12 f13 ?v_0) ?v_1) (f11 (f12 f13 ?v_2) ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_3 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0)) (?v_0 (f3 f4 ?v2))) (let ((?v_2 (f12 f13 ?v_0))) (=> (< ?v_1 ?v_3) (=> (< 0 ?v_0) (< (f11 ?v_2 ?v_1) (f11 ?v_2 ?v_3))))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v2))) (=> (< ?v_0 ?v_2) (=> (< 0 ?v_1) (< (f11 (f12 f13 ?v_0) ?v_1) (f11 (f12 f13 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_1 (f12 f13 (f3 f4 ?v2)))) (=> (<= ?v_0 ?v_2) (<= (f11 ?v_1 ?v_0) (f11 ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v2))) (=> (<= ?v_0 ?v_1) (<= (f11 (f12 f13 ?v_0) ?v_2) (f11 (f12 f13 ?v_1) ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 (+ (f3 f4 ?v0) 1))) (?v_2 (f3 f4 ?v2)) (?v_1 (f3 f4 ?v1))) (= (<= (f11 ?v_0 ?v_1) (f11 ?v_0 ?v_2)) (<= ?v_1 ?v_2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 (+ (f3 f4 ?v0) 1))) (?v_2 (f3 f4 ?v2)) (?v_1 (f3 f4 ?v1))) (= (< (f11 ?v_0 ?v_1) (f11 ?v_0 ?v_2)) (< ?v_1 ?v_2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 (+ (f3 f4 ?v0) 1)))) (= (= (f7 f8 (f11 ?v_0 (f3 f4 ?v1))) (f7 f8 (f11 ?v_0 (f3 f4 ?v2)))) (= ?v1 ?v2)))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v1))) (= (= (f7 f8 (f11 (f12 f13 (f3 f4 ?v0)) ?v_0)) (f7 f8 (f11 (f12 f13 (f3 f4 ?v2)) ?v_0))) (or (= ?v0 ?v2) (= ?v1 (f7 f8 0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 (f3 f4 ?v0)))) (= (= (f7 f8 (f11 ?v_0 (f3 f4 ?v1))) (f7 f8 (f11 ?v_0 (f3 f4 ?v2)))) (or (= ?v1 ?v2) (= ?v0 (f7 f8 0)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v2)) (?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0))) (= (<= (f11 (f12 f13 ?v_1) ?v_0) (f11 (f12 f13 ?v_2) ?v_0)) (=> (< 0 ?v_0) (<= ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f3 f4 ?v0))) (let ((?v_0 (f12 f13 ?v_1)) (?v_3 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (= (<= (f11 ?v_0 ?v_2) (f11 ?v_0 ?v_3)) (=> (< 0 ?v_1) (<= ?v_2 ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v2)) (?v_0 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v0))) (= (< (f11 (f12 f13 ?v_1) ?v_0) (f11 (f12 f13 ?v_2) ?v_0)) (and (< 0 ?v_0) (< ?v_1 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_1 (f3 f4 ?v0))) (let ((?v_0 (f12 f13 ?v_1)) (?v_3 (f3 f4 ?v2)) (?v_2 (f3 f4 ?v1))) (= (< (f11 ?v_0 ?v_2) (f11 ?v_0 ?v_3)) (and (< 0 ?v_1) (< ?v_2 ?v_3)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f8 (+ 0 1)))) (= (= (f7 f8 (f11 (f12 f13 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_2 (f3 f4 ?v1)) (?v_0 (f3 f4 ?v0)) (?v_1 (f3 f4 ?v2))) (= (f7 f8 (f11 (f12 f13 (f3 f4 (f7 f8 (- ?v_0 ?v_2)))) ?v_1)) (f7 f8 (- (f11 (f12 f13 ?v_0) ?v_1) (f11 (f12 f13 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1)) (?v_1 (f3 f4 ?v2))) (= (f7 f8 (f11 (f12 f13 (+ ?v_0 ?v_2)) ?v_1)) (f7 f8 (+ (f11 (f12 f13 ?v_0) ?v_1) (f11 (f12 f13 ?v_2) ?v_1)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 (f3 f4 ?v0))) (?v_1 (f3 f4 ?v1)) (?v_2 (f3 f4 ?v2))) (= (f7 f8 (f11 (f12 f13 (f11 ?v_0 ?v_1)) ?v_2)) (f7 f8 (f11 ?v_0 (f11 (f12 f13 ?v_1) ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f8 0))) (= (= (f7 f8 (f11 (f12 f13 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (or (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f7 f8 1))) (= (= (f7 f8 (f11 (f12 f13 (f3 f4 ?v0)) (f3 f4 ?v1))) ?v_0) (and (= ?v0 ?v_0) (= ?v1 ?v_0))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (f3 f4 ?v0)) (?v_0 (f3 f4 ?v1))) (= (f7 f8 (f11 (f12 f13 (+ ?v_1 1)) ?v_0)) (f7 f8 (+ ?v_0 (f11 (f12 f13 ?v_1) ?v_0)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (+ 0 1)) (?v_1 (f3 f4 ?v0)) (?v_2 (f3 f4 ?v1))) (= (<= ?v_0 (f11 (f12 f13 ?v_1) ?v_2)) (and (<= ?v_0 ?v_1) (<= ?v_0 ?v_2))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 (f3 f4 ?v0))) (?v_2 (f3 f4 ?v2)) (?v_1 (f3 f4 ?v1))) (= (f7 f8 (f11 ?v_0 (f3 f4 (f7 f8 (- ?v_1 ?v_2))))) (f7 f8 (- (f11 ?v_0 ?v_1) (f11 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3) (?v2 S3)) (let ((?v_0 (f12 f13 (f3 f4 ?v0))) (?v_1 (f3 f4 ?v1)) (?v_2 (f3 f4 ?v2))) (= (f7 f8 (f11 ?v_0 (+ ?v_1 ?v_2))) (f7 f8 (+ (f11 ?v_0 ?v_1) (f11 ?v_0 ?v_2)))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_0 (f3 f4 ?v0))) (let ((?v_1 (f12 f13 ?v_0)) (?v_2 (f3 f4 ?v1))) (= (f7 f8 (f11 ?v_1 (+ ?v_2 1))) (f7 f8 (+ ?v_0 (f11 ?v_1 ?v_2))))))))
(assert (forall ((?v0 S3) (?v1 S3)) (let ((?v_1 (f3 f4 ?v0)) (?v_0 (f3 f4 ?v1))) (= (f7 f8 (f11 (f12 f13 ?v_1) ?v_0)) (f7 f8 (f11 (f12 f13 ?v_0) ?v_1))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (* (f3 f4 ?v0) 1)) ?v0)))
(assert (forall ((?v0 S3)) (= (f7 f8 (f3 f4 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f3 f4 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f3 f4 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
