(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 () Int)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 (S5 Int) S3)
(declare-fun f8 () S5)
(declare-fun f9 () Int)
(declare-fun f10 () S2)
(assert (not (= f1 f2)))
(assert (let ((?v_0 (exists ((?v0 Int) (?v1 Int)) (let ((?v_1 (f7 f8 2))) (= (+ (f4 (f5 f6 ?v0) ?v_1) (f4 (f5 f6 ?v1) ?v_1)) (+ (* 4 f9) 1)))))) (not (=> (<= 1 f3) (=> (=> (= f3 1) ?v_0) (=> (=> (< 1 f3) ?v_0) ?v_0))))))
(assert (forall ((?v0 S3)) (= (f7 f8 (f4 f10 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f10 (f7 f8 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f10 (f7 f8 ?v0)) 0))))
(check-sat)
(exit)
