(set-info :smt-lib-version 2.6)
(set-logic UFLIA)
(set-info :source |Benchmarks from the paper: "Extending Sledgehammer with SMT Solvers" by Jasmin Blanchette, Sascha Bohme, and Lawrence C. Paulson, CADE 2011.  Translated to SMT2 by Andrew Reynolds and Morgan Deters.|)
(set-info :category "industrial")
(set-info :status unsat)
(declare-sort S1 0)
(declare-sort S2 0)
(declare-sort S3 0)
(declare-sort S4 0)
(declare-sort S5 0)
(declare-fun f1 () S1)
(declare-fun f2 () S1)
(declare-fun f3 (Int Int) S1)
(declare-fun f4 (S2 S3) Int)
(declare-fun f5 (S4 Int) S2)
(declare-fun f6 () S4)
(declare-fun f7 () S2)
(declare-fun f8 () S3)
(declare-fun f9 (S5 Int) S3)
(declare-fun f10 () S5)
(declare-fun f11 () Int)
(declare-fun f12 () Int)
(assert (not (= f1 f2)))
(assert (forall ((?v0 Int) (?v1 Int) (?v2 Int)) (=> (= (f3 ?v0 (- ?v1 ?v2)) f1) (=> (= (f3 ?v0 ?v2) f1) (= (f3 ?v0 ?v1) f1)))))
(assert (let ((?v_0 (f9 f10 2))) (let ((?v_1 (f4 (f5 f6 (+ 1 (f4 f7 f8))) ?v_0)) (?v_2 (f4 (f5 f6 f11) ?v_0)) (?v_3 (f4 (f5 f6 f12) ?v_0))) (not (=> (and (= (f3 ?v_1 ?v_2) f1) (= (f3 ?v_1 ?v_3) f1)) (= (f3 ?v_1 (+ ?v_2 ?v_3)) f1))))))
(assert (forall ((?v0 S3)) (= (f9 f10 (f4 f7 ?v0)) ?v0)))
(assert (forall ((?v0 Int)) (=> (<= 0 ?v0) (= (f4 f7 (f9 f10 ?v0)) ?v0))))
(assert (forall ((?v0 Int)) (=> (< ?v0 0) (= (f4 f7 (f9 f10 ?v0)) 0))))
(check-sat)
(exit)
